#!/bin/sh
# This material contains unpublished, proprietary software of 
# Entropic Research Laboratory, Inc. Any reproduction, distribution, 
# or publication of this work must be authorized in writing by Entropic 
# Research Laboratory, Inc., and must bear the notice: 
#
#    "Copyright (c) 1997  Entropic Research Laboratory, Inc. 
#                   All rights reserved"
#
# The copyright notice above does not evidence any actual or intended 
# publication of this source code.     
#
# @(#)cepanal.tst	1.1	29 Apr 1997	ERL
# 
# Written by:  Rod Johnson
# Checked by:
# Revised by:
# 
# Brief description:  Test script for functions cepanal and cepsyn.
#  This is a minimal check that cepsyn inverts the transformation
#  performed by cepanal in one simple case.  (They really ought to
#  be tested separately, against independently computed results.)
#

echo "Testing the pair of functions cepanal and cepsyn."

# Make a speech sampled-data file.
# (This is speech.sd:  "There's usually a valve.", truncated to
#  a whole number of frames.)

echo "Making test data file (sp.sd)."

testsd -tSHORT -a- sp.sd <<EOF
     -2     -5     -4      2     -4     -4     -2     -2     -2      0
      2     -4      0      7     -1      1      6      5      7      3
      0      4      3      4      4      3      4      3      3      5
      3     -1     -1     -3      3      2      1      0      1      0
     -4     -5     -8     -8    -11    -10    -12     -7     -3    -10
     -8     -6     -5      7      2      0      4      4      6      2
      5      9     14     12     15     21     16     16     19     16
     13      1     -6     -4    -13     -6     17     32    -51    -23
     80    -77     -4     29    -56    -12     -3    -23     -6     -9
     -8     -6      1     12      4      9      6      5      8      1
      1      5      1     -1     -6     -9    -10     -5     -9    -11
    -10    -17    -11     -8     -8     -9     -5     -2      4      5
      2      3      5     13     14     11     15     15     16     21
     14     14     11     14     10      6      6      2      1     -2
     -6    -12     -5     -7    -14     -9    -11    -13    -12     -7
     -9     -8     -7     -5     -3     -4     -4     -3     -3     -4
     -3     -3     -5     -1      1      0     -3      2      5      1
      3     -1      4      4     -1     -2     -2      2     -1      0
      4     11      9      6     11     10     10     10      7      5
      3     -2     -1      1     -1     -5    -13    -12    -16    -17
    -13    -13    -14    -13    -10    -13     -5     -5     -9     -3
      3      0      0      1      2      8     10      9     13     10
     10     14      9     12     11      7     11      9      6      7
      7      3     10      7     -1      0     -3     -4     -8     -7
    -11    -12    -13    -17    -12    -12    -15    -13    -13    -12
     -9     -9     -9     -6     -7     -4     -5     -4     -1      5
      7     11     11     12     14     13     13     12     11      8
      4      3      5      2      0     -3      3      0      1      3
     -2      1      1      1      2     -1      1      1      1      1
      2      0      2     -1     -4     -3     -6     -2     -5     -4
     -3     -3     -6     -1     -1     -3     -3      0     -5     -8
     -5     -7     -7      0      2      2     -2      5      2      5
      8      1      6      5      6      6      1      6      2      1
      5      1     -1      1      3      0      2      2     -2     -1
     -3      0     -1      1      1      0      1      2      6      6
      1      1      1      1      0      4      1      0      0     -5
     -6     -7     -9     -9     -6     -9     -9     -9    -10     -8
     -8     -8    -10     -9     -5     -5      3      7      5     11
     12     12     13     14     13     12      9      9      9      7
      7      7      4      4      4      2      2     -2     -5     -2
     -2     -5     -9     -9     -7    -12    -15    -16    -16    -18
    -18    -13    -15    -17    -11    -10    -10     -5      1      1
     -1      7      8      6     11     13     13     17     13     14
     16     14     12      9      9      7      8      7      0     -2
     -2     -2     -7     -7     -3    -10     -6     -2     -4     -8
    -11     -7     -3     -6     -5     -3     -4     -5     -5     -4
     -4     -3     -4     -1     -4     -3     -2     -6      0     -3
     -2     -4      1      3      0      2      6      5      9      9
      6      9      6      8     10      4      4      9      5      2
      0      1      0     -2     -2     -9     -7    -10    -10     -9
    -12    -15    -12    -13    -17    -13    -12    -10    -10     -5
     -1     -1      3      7      9      6      5     11     10     12
     15     11     14     12     12     12     12     13     10      6
      7      7      2     -3     -4     -7    -11    -12    -13    -15
    -13    -17    -11    -10    -14    -12    -11     -6     -6      0
      0      0      5     -2      5      8      7      9      8      7
      5      5      8      5      6      5      3      0      1      1
     -4     -4     -6     -5     -9     -5     -5     -2      1     -2
      2     -2     -1      2     -2     -1      3      2      2      3
      4      6     10     12     29     51    107    255    -31   -234
     12   -147   -126     -2    -62    -35     -4    -11     69    116
     88    139    -42    -92     88     69     40   -145    -12    -42
   -136    -53    -30    -40     44     14     18    102    202    -88
    -38     17   -116    -52     13    -98     35    -28    -48     20
     59    -23     75     75     56     68    103     26     42     -8
    -75    -69    -57    -91    -59    -14    -30    -46     10     19
     17     69     32     29     45     30     -8     17    -10    -12
    -15     -7    -34     -3    -26    -24    -28     -3    -18     17
     16     37     29     63     16     34     23     15      1     28
     -8     25     26    -10    -26     -2    -44    -26    -30    -40
    -40    -22    -54    -46    -62    -76    -61    -52    -63    -85
     14    120   -313    167   -171    -56   -148    -22   -120   -109
    -32     -8    -20     96    145    148    444    637    734    536
    721    654    580    360    157   -146   -157   -470   -733   -869
   -831   -917   -749   -629   -414   -268    -22    101    266    373
    430    359    346    244    124    -26   -191   -337   -419   -499
   -591   -632   -650   -569   -459   -387   -292    -65    121    403
    589   1139   2313   1884   1238   2470   1939   1459   1317    434
   -350     39  -1148  -2183  -1887  -2147  -2466  -1967  -1983  -1859
   -493   -237   -239    700   1210   1119   1571   1227    795   1100
    732   -254   -245   -460   -845   -709   -738   -664      1     69
    410    736    930   1084   1059    738    615    432    -43   -445
   -782  -1028  -1184  -1264  -1495  -1285  -1051   -917   -707   -387
   -299      7    257    396    774   1954   2939   1598   1924   3081
   1867   1890   1224    -31   -145    -80  -2051  -2441  -2011  -2673
  -2382  -1986  -2145  -1304    227   -166    325   1326   1380   1454
   1591    706    568    875   -213   -880   -704  -1019   -909   -333
   -966   -441    920    551    749   1302   1082   1196   1284    202
     36    239   -732  -1211  -1151  -1531  -1532  -1275  -1716  -1258
   -552   -777   -693    -17    304    626   1520   3340   2977   1392
   4098   2911   1804   2480    308   -247   -204  -1237  -3630  -2323
  -2944  -3524  -2313  -2424  -1988   -327    652   -152   1507   2003
   1497   1837   1318    394    498    288  -1337  -1231  -1014  -1499
   -983   -382   -409    398   1599   1257   1598   2180   1627   1339
   1018    181   -364   -498  -1427  -1918  -1618  -1888  -1950  -1638
  -1515  -1072   -499   -579   -504    232    405    460   1872   4103
   2404   1157   4758   2424   1775   2500   -163   -230   -152  -1335
  -3822  -2285  -2387  -3518  -1890  -2029  -1663    165    945     86
   1133   2301   1218   1102    961   -135   -134   -237  -1443  -1870
   -972  -1038  -1171   -220    356    855   1783   2165   1745   2140
   2100   1128    528     32   -620  -1174  -1516  -2045  -2024  -1645
  -1732  -1684  -1196   -754   -482   -381   -374   -113    114    341
   1185   4072   3348    183   4504   3737   1557   2721    361    -49
   -485   -666  -3189  -3737  -2037  -3120  -2730  -2033  -1634   -267
    701   1030    693   1525   2254   1014    571    137   -350   -566
  -1094  -1614  -1825   -948   -558   -612    121   1132   1693   2008
   2400   2121   1662   1647    874   -314   -676   -885  -1532  -1948
  -1793  -1793  -1586  -1311  -1324  -1005   -462   -334   -647   -505
   -206   -189    310   3381   4667    -34   2945   5549   2029   2643
   1178    731   -640   -699  -1398  -4837  -3021  -2170  -3139  -2834
  -2026   -260     85    982   1547    690   2071   2142    802    -97
   -345    -79  -1199  -1561  -1634  -1653   -685   -291   -167    365
   1650   2285   2010   2409   2053   1454   1210    320   -686  -1214
  -1142  -1713  -2215  -1820  -1523  -1442  -1389  -1038   -654   -417
   -367   -656   -607   -126   -104   1899   5461   1797    605   5551
   3791   2660   1242   1007    438  -1529   -583  -3530  -4578  -2625
  -2538  -2653  -3086  -1091    628    441   1509   1153   1481   2134
   1449    666   -847   -501   -369  -1513  -1918  -1931  -1051   -478
   -280    254    919   2130   2440   2649   2443   1426   1502    989
   -306  -1261  -1381  -1348  -2070  -2150  -1831  -1647  -1397  -1200
   -837   -579   -410   -438   -528   -263   -272   1922   5696   2126
    247   4987   4362   3006    865    867    834  -1399   -691  -3027
  -4549  -3116  -2457  -2129  -3357  -1906    702    695   1174    914
   1557   2156   1409   1031   -540   -753   -273   -969  -1747  -2280
  -1168   -288   -460     -2    785   1890   2251   2636   2628   1444
   1501   1290     17  -1204  -1465  -1152  -1960  -2400  -2068  -1778
  -1584  -1437   -964   -694   -600   -478   -286     11     69   2705
   5804   1596    997   4912   4269   2872    222   1074    645  -1519
  -1076  -3153  -4158  -3299  -2472  -1944  -3444  -1782    740    795
   1075    716   1856   2192   1216   1002   -306   -566   -408   -883
  -1536  -2324  -1202   -261   -536   -218    731   2036   2296   2415
   2203   1434   1709   1158   -140  -1185  -1245   -898  -1933  -2478
  -2154  -1773  -1562  -1602  -1156   -936   -813   -274    -99   -132
   1705   5540   3394    308   3946   4993   3472    823    645   1380
  -1069  -1268  -2082  -4011  -3786  -2885  -1802  -3157  -3248     78
    998    668    576   1525   2497   1513   1348    706   -416   -198
   -400  -1072  -2139  -1922   -550   -664   -860   -149   1112   1953
   2105   2446   1897   1600   1814    882   -320  -1101   -873  -1024
  -2219  -2481  -2063  -1753  -1855  -1818  -1246  -1018   -773   -252
     26    981   4170   4572   1174   2683   4880   4236   2000    431
   1545    232  -1379  -1697  -3273  -3714  -3437  -2722  -2561  -3701
  -1746    466    617    502    828   2403   2425   1399   1407    735
    216    -36   -619  -1279  -2065  -1409   -749  -1236  -1004     51
   1197   1779   1943   1869   1901   2136   1576    430   -268   -382
   -682  -1534  -2250  -2311  -2050  -1976  -2082  -1946  -1427  -1007
   -613   -177    292   2625   5016   2462   1649   4248   4687   3471
    897   1170   1504   -587  -1320  -2365  -3427  -3405  -3420  -2682
  -3482  -3427   -875     61    144    299   1309   2705   2058   1611
   1653   1085    869    161   -524  -1117  -1640  -1116  -1191  -1608
   -963    -78    882   1400   1142   1519   2105   1927   1165    335
    336    142   -822  -1507  -1982  -2034  -1934  -2129  -2238  -2064
  -1412   -873   -706   -347   1388   4397   3109   1205   3762   4643
   4098   2102   1156   2172    598   -596  -1419  -3070  -2916  -3264
  -3377  -3420  -4125  -2360   -980   -971   -329    289   1775   2408
   1747   2052   1965   1842   1622    436    -58   -443   -803   -923
  -1630  -1396   -752   -436    -36   -132    517   1287   1078    945
    715    832    870    -69   -660  -1016  -1206  -1186  -1716  -1918
  -1722  -1398  -1012  -1066   -745   1217   3241   1580   1144   3363
   3676   3488   2007   1484   2561   1274     95   -708  -2029  -1622
  -2269  -3240  -3255  -3673  -2671  -1938  -2206  -1403   -630    379
   1241    948   1418   2127   2110   2081   1442   1025   1209    649
     78   -287   -524   -276   -562   -952   -704   -488   -281   -314
   -439    -83    127     45   -165   -350   -241   -123   -194   -443
   -727   -676   -246   -203   -911   -497   1619   1199   -363   1238
   1957   1525   1843   1162   1494   2114   1036    805    352   -466
   -127   -849  -1828  -1848  -2222  -2005  -1911  -2467  -1854  -1315
  -1103   -437   -506    -72   1063    952    938   1244   1208   1505
   1297    932   1146    875    616    470      4     83   -163   -747
   -700   -771   -554   -183   -447   -460   -338   -408    -79   -489
   -582    297   -403   -751    117   -380   -845    -48    633    316
   -201    704    944   1097   1852    908   1157   2486   1189    783
   1246     68    191    154  -1298  -1207  -1219  -1958  -1782  -2026
  -2078  -1452  -1475  -1208   -719   -575    137    420    260    798
    949    933   1182    950   1080   1268    745    734    698    233
    236     28   -166     94    -22   -142   -211   -573   -276   -295
   -822   -454   -376   -683   -747   -135   -630   -835   -153   -842
   -495    659     66   -457    839    967    570   1759   1298    850
   2419   1621    688   1610    663    115    551   -820  -1163   -759
  -1794  -1920  -1754  -2160  -1565  -1291  -1500   -870   -480   -298
     94    191    443    751    716    772    834    951    998    723
    724    691    561    577    330    306    410    140    105   -219
   -280    -50   -554   -709   -264   -848   -597   -273  -1044   -527
   -269   -902   -397   -325   -730    347    297   -231    667    871
    655   1357   1219    996   1715   1451    941   1195    735    291
    272   -464   -899   -887  -1536  -1786  -1502  -1568  -1323   -981
  -1015   -901   -398   -225   -296    217    154    223    559    476
    687    566    566    846    456    660    747    440    642    324
    453    328    -91    112     56   -441   -261   -236   -593   -368
   -388   -753   -246   -554   -481   -405   -483   -409   -431    -26
   -129    222    339    277    827    713    931   1003   1053   1035
    921    920    477    369    110   -389   -344   -625   -837   -746
  -1031   -991   -915   -850   -790   -801   -315   -664   -267   -118
   -309    206     38    240    240    359    451    511    450    409
    694    386    424    464    277    358    217    181    -37    207
      2   -258    -37   -180   -341   -161   -404   -370   -395   -435
   -276   -510   -173   -360   -143    236   -189    542    357    260
    905    349    726    551    552    475    272    381   -114    181
   -207   -367   -149   -591   -343   -599   -485   -516   -513   -441
   -578   -228   -367   -369    -95   -165   -133    209   -139    215
    354    -20    465    264    218    368    436    206    283    329
    219    225    174    192     31    -65    366   -616    356   -385
   -294    143   -650     83   -395   -244    122   -485    202     31
   -181    481   -127    344    182    192    315     51    311    153
    -23    313    -79    -21    170   -226    -75    -10   -421    130
   -417   -191   -229   -229   -232   -322     22   -535    184   -246
   -108    -18    111   -118     68    138    -21    164    145     90
    -33    441   -178    329    174     42    194    243    -12    159
    212   -158    196    -83    169   -383    245   -154   -282    262
   -251   -141    309   -395    187      0   -175    303   -285    253
   -159     92     86   -250    322   -271    137     96   -150     45
     61     35   -242    223   -213    -54    -29    -88   -217    144
   -160   -218    217   -290    105    -84    -58     19    -86    108
   -166    -46    126   -153     -6     62     42     -3    208    152
   -106    501   -138    229    102    177    153   -388    693   -539
    251     89   -389    339   -107   -201    180    -73    -61    -10
     66   -115    -55    159   -405    168     16   -360    201   -170
    -98     20    -51   -110     15    -13    -20    -66    148   -158
    113    227   -441    532    -46   -202    407    -69    -50     44
    252   -463    168    162   -531    230   -158     52   -496    714
   -815    393    354   -791    851   -418    370    -20     -7    328
   -252    189    265   -667    966   -744    151    509   -717    645
   -471    407   -232    -25    320   -603    546   -406   -113    158
   -266    -62   -126     51   -292     46    123   -360     39    533
   -769    615    104   -562    966   -447    184    328     73   -258
    489    119   -537    588    -81   -672    569   -259   -494    167
      7   -553    130    127   -666    676   -621    364     76   -229
    516   -496    911  -1021   1187   -652     22    970  -1319   1103
   -104   -626    830   -147   -461    502    276   -839    515    276
   -828    237    560  -1024    180    546  -1174    646   -116   -524
    537   -615    589   -506    417    -70   -187    784   -764    910
   -463    372    228   -393    664   -447    171    273   -632    393
   -122   -390    -25    218   -510   -162    394   -518    -55    444
   -645    487   -142     27    -69    401   -317    173    203   -269
    507   -478    481    -72    -11    239   -150    324   -305    547
   -625    526     -1   -747    939   -528   -448    653   -375   -502
    659   -507   -327    657   -587   -187    751   -665     61    494
   -298    -96    716   -743    575    171   -485    476     51   -351
    226    290   -930    881   -286   -834   1242  -1047    145    220
   -175   -147    143    224   -645    627   -129   -318    469   -135
   -121    118    221   -221    228     56    -25    171    -91    463
   -700    873   -320   -401    870   -699    207   -221    417   -629
     31    485   -965    510   -220    -24   -374    386   -178   -365
    550   -333    -65    296     19   -282    479   -132    -38    209
    -33    196   -385    641   -416     68    164   -215    118    -79
    207   -644    872   -561    -51    481   -521    162     98   -150
   -104    345   -450     46    430   -535    193    320   -474    340
     20    -36    151   -249    424   -197   -108    214    -22   -163
     -1     22    -39    -23    -96    -85    168   -315    182    -49
   -199    269    -44   -298    470   -282     38    255   -255    160
    174   -415    412    -10   -366    375   -103   -261    450   -347
    -33    381   -339    -78    647   -703    212    681   -988    602
    126   -489    312     16   -158   -227    496   -474     65     38
    -25    -36    -39    133   -128    -92    340   -129   -317    510
   -193   -221    345   -158   -104    249   -375    309     25   -467
    596    -86   -662    928   -254   -431    482    179   -749    598
     67   -606    491   -247     25    166   -425    520   -305    -91
    352   -353    250    137   -470    604    -34   -596    814    -35
   -831    913     -9  -1079   1100   -305   -499    127    552   -794
     80    422   -445      1    351   -270   -182    596   -484     77
    179   -165    222   -209    -70    549   -561     11    555   -510
   -105    677   -701    332    489   -805    405    545   -792    123
    715   -756     19    331   -263   -190    250   -176   -226    218
   -123   -121    300   -308    -78    765   -682    180    538   -415
     74    530   -375   -157    747   -350   -513    971   -554   -539
   1087   -765   -358   1014  -1054    -86    866  -1434    573    752
  -1756   1068    544  -1945   1456    441  -1798   1152    420  -1363
   1258   -188   -686   1099   -681     75    981   -912    306   1199
  -1024    368    979   -802    327    742   -666    167    663   -684
    -24    629   -544   -242    398   -383   -450    159   -303   -253
     15   -885    127     15  -1286    397   -331   -871    381   -490
   -565    412   -294   -311    160   -104    671    177    140   1257
    491    542   1322    904    740   1125    850    586    884    208
    -55    242   -513   -733   -573  -1046  -1184  -1065  -1250  -1196
   -873  -1084   -527   -334   -773    356    308   -161    646    655
    348    481    742    357    250    193     -5      3   -326   -507
   -416   -622   -748   -309     35   -490    -86    907    415    613
   1328   1330   1414   1203   1549   1543   1065    602    759    471
   -556   -546   -624  -1266  -1739  -1545  -1626  -1955  -1845  -1498
  -1333  -1113   -679   -293    172    297    646   1105   1116   1128
   1227   1341    855    700    561     57   -316   -425   -701  -1282
  -1125  -1086   -634   -588  -1187    604    572     34   1226   1961
   1536   1261   2606   1925   1342   1484   1295    613    -66   -256
   -770  -1153  -2034  -1914  -1885  -2498  -2571  -1955  -1805  -2016
  -1008   -451   -264    262    884   1402   1429   1626   1872   1878
   1367   1168   1073    244   -185   -409  -1044  -1577  -1576  -1366
   -929  -1633   -967    733   -280    138   1839   2027   1089   2226
   3078   1734   1700   1960   1515    361     93   -217   -851  -1702
  -2193  -1879  -2487  -2978  -2606  -2012  -2293  -2019   -935   -146
   -292    159   1766   1551   1104   2128   2494   1310   1163   1648
    678   -278   -372   -637  -1580  -1465   -730  -1695  -1536    205
   -525   -372   1298   1528    942   2017   2764   1740   1967   2065
   1539    821    548     11   -687  -1164  -1827  -1978  -2279  -2630
  -2749  -2250  -2163  -2047  -1309   -585    -51     59    967   1676
   1432   1424   2188   1914    895   1078   1085    -59   -858   -659
  -1017  -1208  -1054  -1611   -489     43   -787    342   1814   1203
    764   2762   2602   1167   1841   2328    997     57    639   -148
  -1308  -1616  -1580  -2136  -2681  -2591  -2353  -2177  -2183  -1553
   -872   -166    -12    495   1638   1516   1257   1932   2196   1090
    885   1226    325   -719   -848   -830  -1222  -1026  -1497   -978
    196   -531   -188   1477   1809    690   1941   3177   1630   1260
   2288   1750    -45    232    286  -1055  -1849  -1660  -1914  -2646
  -2649  -2522  -2142  -2030  -1686  -1115   -162    377    161   1238
   2087   1390   1196   2343   1768    308    797    922   -677  -1458
   -773   -930  -1243  -1604   -922    386   -391   -249   1509   2238
    943   1633   3381   2198   1079   1899   2175    142   -395    116
   -780  -2149  -2248  -1873  -2626  -3003  -2695  -2021  -1865  -1761
  -1027    244    602    168   1435   2364   1364   1149   2359   1692
    124    525    700   -907  -1768   -883   -621  -1460  -1892   -107
    563   -604    335   2265   2137    927   2479   3334   1846   1220
   1987   1577   -213   -443   -506  -1274  -2409  -2586  -2357  -2730
  -3086  -2849  -1777  -1582  -1578   -521    852    755    591   2095
   2381   1335   1600   2268   1101     95    375   -110  -1399  -1794
   -990   -733  -1977  -1418    642    121   -368   1457   2759   1571
   1733   3368   2765   1610   1682   1859    569   -319   -672  -1290
  -1930  -2679  -2974  -2916  -2834  -3225  -2625  -1524  -1389  -1076
    339   1129    808   1614   2313   1904   1763   1895   1359    547
    278   -399  -1209  -1492  -1007   -915  -2038   -868    592   -285
    -12   1942   2469   1285   2371   3439   2303   1654   2014   1576
    188   -165   -775  -1629  -2096  -2687  -3162  -3070  -2850  -3171
  -2517  -1530  -1243   -746    431   1016   1105   1782   2032   1903
   1916   1618    916    499    120   -931  -1461   -746   -434  -2002
  -1292    951     -1   -506   1638   2826   1308   1748   3485   2530
   1477   1787   1601    350   -268   -783  -1726  -1902  -2557  -3362
  -3088  -2591  -3030  -2889  -1409   -998   -918    156   1118   1193
   1392   1923   1943   1778   1426    866    440      7   -892  -1447
   -509   -329  -1924   -832   1112    245   -123   1968   2896   1552
   2128   3287   2444   1601   1599   1047    135   -388  -1360  -2263
  -2098  -2744  -3781  -3246  -2414  -2912  -2757  -1193   -665   -490
    337   1194   1414   1540   1787   1753   1614   1228    408    -15
   -251  -1100  -1215    -49   -929  -1509    623    934    113   1172
   2909   2221   1892   3153   2817   1790   1834   1280    112   -238
   -809  -2329  -2625  -2315  -3543  -3891  -2767  -2459  -2948  -1953
   -664   -418    -93    895   1319   1364   1729   1634   1314   1257
    680   -198   -414   -694   -891   -112   -686  -1031    831   1126
    428   1380   3013   2415   1918   2991   2880   1759   1496   1056
     63   -496  -1161  -2408  -2733  -2483  -3570  -3710  -2693  -2316
  -2707  -1852   -414   -359    -75    922   1169   1154   1578   1364
    861    859    445   -559   -747   -719   -310    -11  -1033     91
   1598   1106    934   2372   3349   2305   2413   3108   2474   1643
   1133    343   -330   -915  -1946  -3013  -2737  -2986  -3769  -3364
  -2442  -2173  -2361  -1077   -182    -61    494   1018   1093   1374
   1415    799    497    500   -311   -986  -1069   -776    408   -636
   -938   1559   1948   1023   1749   3660   3244   2338   3121   2893
   2080   1493    482   -448   -698  -1487  -3268  -3310  -2740  -3682
  -3933  -2784  -2057  -2560  -1405   -178   -279    477   1272   1010
   1097   1735   1052    147    480    -26  -1116  -1272  -1052    220
   -167  -1339   1077   2284   1319   1570   3401   3847   2577   3180
   3117   2351   1853    738   -363   -774  -1104  -3095  -3725  -2892
  -3449  -4088  -3345  -2366  -2496  -1703   -759   -357    460   1046
    985   1100   1791   1245    310    529    199   -752  -1260  -1162
    198    268  -1584    627   2568   1245   1307   3208   4068   2453
   3095   3432   2358   1992   1036   -129   -760   -829  -2769  -3801
  -2782  -3229  -4129  -3558  -2593  -2590  -1997  -1225   -714    216
    705    670   1012   1752   1202    410    780    481   -366   -796
  -1014      0   1030  -1299   -271   2920   1448    704   2630   4260
   2347   2275   3707   2433   1849   1240    263   -555   -602  -2083
  -3714  -2491  -2598  -4220  -3824  -2343  -2521  -2841  -1537   -733
   -422     72    424    829   1342   1097    355    837    899   -213
   -489   -341    353   1249   -864      2   3090   1300    606   2548
   3915   1992   1708   3488   2237   1475   1003    284   -135   -678
  -1981  -3040  -1908  -2377  -4152  -3174  -2057  -2700  -2974  -1570
   -762  -1013   -455    212    657    845    558    551   1003    743
   -167     99    262    -21   1466    175   -489   2969   1519    228
   2430   3416   1739   1151   3494   2117    726   1494    504   -101
   -435  -1468  -2241  -1748  -1915  -3784  -2797  -1707  -3172  -2901
  -1478  -1232  -1493   -729    180    169    451    462    632   1134
    583     39    691    901   -398    369   2201   -312     14   3110
    814    472   2720   2295   1063   1915   2585    871   1092   1494
   -444   -164     51  -1866  -1913  -1176  -2249  -3243  -2058  -1895
  -3037  -1897  -1231  -1639   -923   -531   -143    206    312    290
    646   1282    174    363   1357    349    -14    565    890   1133
   -182    574   2281    505    601   1993   1655   1241   1268   1533
   1341    953    341   -138    469   -523  -1923  -1013  -1114  -2407
  -2350  -1548  -1765  -2235  -1634  -1244  -1037   -706   -797    -77
    385   -132    182    775    604    358    457    827    530    424
    388    404    668    646    715    168   1306   1335     54   1562
   1559    670   1269   1112    873    713    364      9   -242   -268
  -1239  -1495   -760  -1615  -2104  -1250  -1377  -1797  -1241  -1028
   -836   -699   -727    217   -249    -97    359    102    759    167
    441    727    437    744    163    858    751     62    664    947
    777    102    927   1238    198    762    959    591    590    381
    369    199    -97   -426   -573   -430  -1027  -1177   -679  -1260
  -1314   -798  -1100   -946   -866   -549   -635   -376   -152   -384
    170     82   -179    577    327    134    733    420    635    490
    698    580    493    774    251    484    745     54    740    152
    270    568    -81    353    205      9    187   -171     -1   -130
   -411   -225   -440   -362   -576   -798   -330   -738   -941   -245
   -727   -748   -105   -642   -384     44   -372   -234    370    -78
    -31    657    154    315    683    506    402    549    903   -161
    889    651   -389    897     32   -106    510   -177     12    -54
     -6    104   -421    227     25   -429    374   -175   -267    130
   -328   -244   -254   -252   -397   -555   -153   -415   -661    -31
   -413   -441   -118   -197     48   -361    381    100    -49    354
    515     84    374    644    127    349    495    402   -169    412
    524   -529    296    408   -592    249    160   -446    177    -93
    -65   -126      1    134   -504    276    -18   -635    494   -434
   -311    213   -459    -81    -65   -312    -23    -86   -167    -33
   -114     87   -203     22    200   -260    211     74   -149    426
   -121    133    313     47    163    162    343     -7    228    167
    114    161   -138    221     45   -343    372   -340   -175    228
   -485     21      2   -230    -34    -95     73   -106   -100    297
   -267     75    230   -413    290    -94   -287    102   -112   -219
    -27   -190   -149    176   -485    243     80   -110     98    267
     34     68    518   -140    167    577   -278     27    502   -151
   -320    320    -23   -592    480   -194   -659    760   -464   -308
    605   -293     -7    170    251   -339    244    573   -874    596
    145   -728    478   -244   -312     -3    -93   -316    -69    171
   -597    236    117   -400    336     77   -117    429    -41   -140
    626   -258     33    417   -389    303    -32    -92   -150    297
   -111   -531    623   -198   -518    756   -374   -181    585   -304
    -26    310     -7    -82    -59    485   -563     87    610  -1203
    777     34  -1018    876   -447    -84   -150    252     19   -675
    979   -525   -227    905   -789    217    529   -427     51    232
     45   -301     95    444   -864    586    150   -868    742   -267
   -137    120    -62    167   -325    466   -187    -83    521   -520
    316    113   -190    182    -50     20   -162    287   -254   -147
    451   -359   -217    646   -542   -168    728   -517   -252    651
   -300   -392    498      8   -714    408    327   -987    450    367
   -741    134    369   -175   -348    567    110   -720   1078   -391
   -418   1099   -722    -59    565   -283   -185    340    -61   -334
    344    130   -433    342     97   -114     25    174    -94     72
    -61    275   -309    -43    250   -435    -97    167   -357   -256
    149   -129   -511    436    -40   -751    845     35   -655    659
    220   -362    134    602   -373    112    373    -42   -175    193
    265   -436    102    283    -83   -350    330    185   -472    278
    176   -447    179    440   -788    276    593   -856    -59    695
   -567   -749    866   -143   -960    512    217   -618   -106    702
   -287   -612   1093   -348   -652   1096   -105   -355    392    260
    -80   -237    608   -189   -412    749   -395   -444    762   -459
   -140    381   -224     41     64     15     16    177   -186   -103
    187   -110   -225    319   -264   -173    432   -689   -167    817
   -653   -698   1110   -290  -1021    808    743  -1154   -312   1959
  -1093   -827   1932   -662   -517    549    504   -534   -428   1090
   -457   -674    931   -438   -141    210   -261    118    -36   -190
    188    -61   -238    -55    413   -240   -341    519    -21   -337
     62    286   -148    -85    -74    254     29   -316    406   -282
    115     99   -268    297   -224    166     88   -224    -24     57
    432   -582     21    701   -528   -225    607   -221   -421    360
    351   -684      8    736   -525   -461    819    -27   -815    316
    526   -438   -174    263    136   -376    109    530   -556    -28
    650   -259   -241    206    172    -47   -452    299    351   -535
   -333    323    237   -729    151    525   -560    115    405   -287
   -196     69    728   -615   -510   1175   -180   -559     18    389
    286   -912    444    628   -811    -43    549     14   -714    185
   1029   -968   -431   1125   -139   -767    196    651   -334   -576
    836    -88   -454    345     66     -1   -266    254    199   -462
    138    190    -54   -159   -353    360    268   -475   -364    442
     66   -435    120    126   -226     12    353   -133   -502    251
    414   -276   -240    405    308   -349   -171    211    106    190
   -366    -65    658    -40   -398    -69    382     20   -182    -37
    -67    285    240   -202   -336    188    357   -255   -453    126
    157    129   -322   -536    390    459   -419   -683    224    616
     13   -513   -346    624    445   -474   -264    159    165     85
     21   -323   -277    439    375   -244   -313    106    415     71
     -4    131    160    101     14    390    -35   -342    157    288
     49   -473   -212    282    -20   -145   -192   -174    -32     76
     83   -226   -198    -57    -49    -71   -304   -243     95    -28
   -414   -367    -60    -18   -143   -201   -114    103     41    -72
     71    215    315    330    307    495    722    711    696    597
    579    705    539    381    159    -61    -69   -128   -231   -600
   -860   -743   -692   -732   -922   -993   -823   -553   -379   -482
   -433   -242   -138     65     48    -58     11    116    193    163
     98     87     44    211    688    994    740    720   1022   1300
   1244   1050   1065    886    609    455    237   -123   -619   -899
   -927  -1072  -1381  -1526  -1426  -1345  -1234   -955   -682   -528
   -199    166    401    613    718    767    709    665    688    604
    436    194    -27   -106   -220   -402   -467   -557   -667   -657
   -509   -448   -543   -396     -9    576    840    832    929   1139
   1406   1412   1478   1311    907    597    444    236   -315   -831
  -1132  -1310  -1467  -1584  -1518  -1535  -1506  -1228   -799   -442
   -320    -89    347    763    975   1098   1202   1100    971    867
    717    446    164     28   -149   -411   -585   -622   -699   -816
   -902   -842   -768   -778   -664   -522    -96    514    741    990
   1107   1226   1388   1457   1700   1585   1224    777    426    121
   -366   -716  -1030  -1380  -1699  -1815  -1679  -1596  -1379  -1107
   -820   -545   -256    207    521    752    990   1212   1323   1297
   1257   1054    746    422    188    -38   -272   -454   -650   -790
   -928  -1008  -1016  -1014   -953   -941   -862   -742   -621   -206
    505    894   1161   1410   1483   1510   1531   1851   1885   1613
   1211    730    198   -387   -668   -939  -1270  -1580  -1828  -1903
  -1880  -1633  -1239   -878   -594   -325     23    285    541    801
   1027   1166   1214   1201   1040    827    542    257      7   -211
   -367   -493   -631   -775   -797   -791   -767   -696   -713   -704
   -670   -587   -511   -339    289    793   1102   1455   1507   1492
   1374   1518   1629   1566   1424    996    430   -301   -799  -1146
  -1359  -1518  -1667  -1758  -1917  -1857  -1610  -1198   -666   -206
    226    463    659    790    899   1077   1186   1269   1209   1011
    686    289    -91   -353   -449   -433   -484   -613   -711   -791
   -748   -616   -520   -471   -466   -524   -621   -618   -383    224
    714   1151   1577   1581   1512   1347   1406   1462   1469   1408
   1048    532   -229   -877  -1395  -1691  -1788  -1822  -1732  -1762
  -1737  -1585  -1300   -862   -341    305    740   1018   1166   1177
   1127   1081   1168   1142   1118    945    557    115   -396   -678
   -751   -647   -558   -501   -567   -756   -812   -801   -699   -595
   -521   -557   -664   -616   -173    374    893   1607   1889   1922
   1754   1575   1487   1328   1326   1124    766    122   -603  -1253
  -1897  -2238  -2297  -2096  -1850  -1563  -1236  -1086   -837   -443
     66    612   1115   1552   1641   1515   1295   1077    836    639
    647    498    230   -101   -554   -976  -1204  -1076   -835   -587
   -414   -393   -482   -666   -740   -692   -619   -567   -532   -124
    418    832   1562   2000   2078   2062   1856   1711   1397   1234
   1014    591     49   -687  -1344  -2050  -2500  -2546  -2434  -2088
  -1658  -1224   -879   -572   -123    269    767   1253   1614   1799
   1729   1508   1109    759    441    208    127    -63   -262   -556
   -905  -1133  -1216  -1070   -812   -459   -159    -57   -153   -405
   -598   -721   -757   -738   -476    314    920   1521   2283   2355
   2310   2055   1761   1520   1146   1021    576    -68   -832  -1628
  -2325  -2923  -2914  -2691  -2317  -1589  -1019   -534   -178    206
    591    922   1446   1748   1905   1797   1426    946    326    -75
   -375   -450   -312   -296   -238   -371   -560   -705   -826   -641
   -420   -176     20     12   -178   -558   -853  -1155  -1330  -1269
   -773    448   1270   2205   3166   2974   2833   2286   1796   1467
    908    796    163   -699  -1586  -2541  -3275  -3699  -3284  -2699
  -1933   -773   -150    397    737    947   1227   1383   1808   1909
   1722   1378    637   -154   -848  -1148  -1112   -855   -282    102
    233    226     52   -137   -203    -89     51    105     13   -261
   -659  -1103  -1429  -1586  -1652  -1550  -1133    151   1543   2446
   3966   4221   3561   3295   2197   1350    727    172   -526  -1547
  -2291  -3480  -4167  -4075  -3884  -2671  -1373   -174    969   1447
   1800   1775   1742   1850   1665   1632   1138    353   -425  -1384
  -1882  -1989  -1515   -780    153   1103   1330   1463   1243    649
    352     64   -190   -381   -578   -944  -1390  -1601  -1891  -1990
  -1759  -1601  -1304   -681    959   2799   3609   5429   5346   3799
   3370   1549    259   -351   -859  -1886  -2742  -3281  -4535  -4754
  -3737  -3023  -1293    801   1636   2377   2605   2247   1588   1552
   1343    598    493   -355  -1654  -2042  -2490  -2492  -1527   -206
    872   1919   2847   2348   1931   1531    348   -123   -368   -999
  -1305  -1360  -1772  -1896  -1552  -1601  -1406   -865   -846   -776
   -428    -20   1866   3507   4078   5717   4298   2797   1858    -84
   -633  -1014  -1164  -2288  -2689  -3584  -4484  -3612  -2505  -1184
    946   2035   2292   2183   1808    994    703    979    153     46
   -748  -1887  -2379  -2371  -1896   -867    622   1436   2099   2507
   2242   1928   1608    944    139   -485  -1272  -1902  -1832  -1755
  -1423   -851   -771   -778   -780   -832   -838   -620   -603   -597
    883   2700   2782   4813   4508   2357   2638    501   -157   -338
   -631  -1869  -2278  -2990  -4301  -3250  -2361  -1439    703   1585
   1655   1977   1572   1023    857   1098    -57    -81  -1091  -2136
  -2260  -2141  -1592   -538    642    884   1603   1908   1855   2222
   2183   1406    830   -288  -1374  -1722  -1731  -1520   -834   -541
   -650   -623   -976  -1075   -849   -597   -712   -782  -1206   -490
   1856   2124   4546   5183   3053   3285    988     93   -160   -207
  -1424  -1501  -2843  -4155  -3649  -3219  -1935    176   1397   1708
   2313   1411   1092    927    873    243    416   -978  -1643  -2283
  -2569  -2035   -977    -23    734   1579   1334   1874   1828   2041
   2182   1892   1041    149   -959  -1706  -1700  -1563  -1141   -774
   -831  -1066  -1155  -1291  -1041   -792   -638   -718   -860   -807
    963   1728   2975   4922   3259   3706   2079   1085    346    446
   -728   -679  -1488  -2993  -2895  -3522  -2934  -2054   -417   -299
   1462    764   1202    756    989    449   1145    504    234   -138
  -1088  -1318  -1445  -1072   -800    291    151    847    791   1059
   1048   1739   1441   1670   1232    457   -161   -735  -1249  -1283
  -1279  -1453  -1201  -1451  -1408  -1295  -1069   -986   -570   -716
   -579     85   1351   1630   3438   3418   2924   2940   1637   1180
    992    831     39    488  -1321  -1627  -2650  -3029  -3272  -2236
  -2176  -1057   -499   -403     37    241    362    896   1485   1346
   1859   1288    818    296    -74   -677   -351   -622   -549   -430
   -601   -546   -246    -89    567   1008   1305   1414   1139    606
    177   -245   -603   -578   -809   -931  -1145  -1388  -1581  -1515
  -1521  -1331  -1202  -1038   -159   1011   1535   3145   3200   3223
   3128   2447   1866   1725   1141    421    214  -1298  -1938  -2888
  -3438  -3652  -2875  -2725  -1402   -848   -197    243    755    753
   1432   1599   1791   1948   1635   1041    588   -222   -751   -914
  -1193  -1086   -906   -859   -684   -226    -90    618   1109   1397
   1715   1640   1131    854    145   -425   -684  -1106  -1294  -1291
  -1548  -1602  -1497  -1621  -1416  -1226  -1121   -659    573   1161
   2386   3437   3142   3434   2651   2046   1444   1276    278    356
   -629  -1414  -2090  -2736  -3361  -2893  -2696  -1930   -912   -342
    227    687    763    812   1205   1018   1342   1264   1078    617
    340   -564   -709  -1131  -1099   -894   -445   -313    197    352
    442    865   1000   1224   1409   1259    802    501   -319   -705
  -1047  -1240  -1238  -1126  -1252  -1171  -1211  -1350  -1174  -1189
  -1093   -773    303   1018   2121   3228   3065   3280   2586   2068
   1313   1248    326    355   -444  -1042  -1786  -2253  -2971  -2691
  -2586  -2047  -1121   -611     82    364    665    443    897    601
   1047    988   1152    776    719    -40   -296   -702   -879   -795
   -564   -332    -68    284    257    634    787    945   1176   1200
    968    703    195   -392   -676  -1093  -1168  -1238  -1266  -1364
  -1288  -1421  -1324  -1247  -1200   -927   -219    901   1573   3074
   3159   3376   2938   2339   1522   1192    611    128     -2   -935
  -1315  -2170  -2508  -3113  -2465  -2587  -1342   -912     58    307
    874    648    862    813    805    977    961    799    570    124
   -443   -777  -1070  -1067   -732   -368     41    501    700    875
   1135   1148   1238   1266    964    614    136   -534   -941  -1247
  -1420  -1386  -1282  -1298  -1179  -1161  -1158  -1049  -1022   -900
   -542    573   1219   2474   3283   3154   3202   2410   1865    963
    976   -123    221   -772  -1044  -1877  -2188  -2923  -2526  -2371
  -1697   -745   -187    335    640    574    481    595    495    667
    822    680    511    272   -329   -528   -788   -806   -540   -168
    110    526    780    792   1107   1099   1136   1211    959    601
    178   -412   -928  -1143  -1416  -1397  -1314  -1351  -1252  -1210
  -1215  -1071   -996   -932   -712    181   1217   1990   3429   3179
   3298   2478   1924   1018    930    342    -13   -176  -1238  -1592
  -2337  -2716  -2724  -2129  -1768   -644    -62    283    399    684
    228    498    491    587    861    684    266    -64   -714  -1037
   -808   -669    -81    478    643    768    982    821   1117   1562
   1465   1491    954    -94   -793  -1410  -1792  -1454  -1316  -1249
  -1027  -1299  -1375  -1079   -972   -575   -305   -596   -813   -280
   1583   2308   4320   4732   3214   2663   1009     69    270    242
   -880   -860  -2945  -3638  -3429  -2670  -1376    765    778   1169
    954    272    587   1155    809    741   -203  -1821  -2131  -2254
  -1746   -388    281    299    710    376    748   1714   2105   2224
   2062    802    -92   -197   -510   -150    122   -599   -911  -1189
  -1430   -675   -257   -295   -213   -783  -1166   -856   -845   -703
   -798  -1653  -2196  -1430   1816   3315   4754   5574   2447   2217
   1687   1347   1693   1115  -2393  -2972  -4665  -4252  -2178   -884
   -948     76   -606     89   2117   2448   2492   1801   -662  -1677
  -1489  -1887  -1016  -1120  -2079  -1742   -862     79   2065   2464
   1915   1764   1185   1074   1760   1165    107   -445  -1295  -1169
   -203   -224   -264   -477  -1032   -597    -79    -95    -79   -673
  -1232  -1080  -1020   -996  -1237  -2071  -2350  -1373   2504   4442
   3763   5056   1955   2479   3636   2751    931   -555  -4230  -3378
  -2749  -2665  -2179  -2662  -2875   -316   1531   2301   2975   1144
    584   1183    684     -8   -920  -3218  -2847  -1924  -1410   -465
   -402   -686   1068   2168   2569   2868   1569    740   1166    739
    281   -410  -1402   -970   -267   -155    -85   -503   -710     60
    190   -118   -466  -1041   -925   -503   -911  -1252  -1639  -2037
  -1698  -1320   -336   3496   3506   2350   4829   2274   3810   4002
    984   -463   -487  -3334  -1409  -2775  -4548  -3059  -2004  -1579
   1003    377    257   2612   1996   1900   1790   -590   -891   -155
  -2146  -1893  -2131  -2667   -975   -106   -648   1026   1420   1818
   3047   2075   1234   1790    943    402     90  -1079   -744   -466
  -1088   -834   -673   -723     28   -305   -693   -164   -288   -357
   -343  -1139  -1081  -1002  -1792  -1823  -1594   -612   3692   2502
    558   5055   2884   4319   3947    454    356   1863  -2520  -1777
  -3109  -4368  -2248  -2266  -3783   -714    124     84   2221    998
   1246   2974   1080    -64    750  -1451  -1020  -1325  -2723  -1771
   -541  -1635    -66    545    732   2288   2118   1396   2510   2061
   1060    918    205     45   -354  -1343  -1331   -929  -1420  -1272
  -1083   -871   -322   -466   -679   -193   -196   -450   -556  -1037
  -1199  -1181  -1103   2238   2637  -1114   4727   3392   2016   3836
   1923   1495   2648  -1288  -1986   -108  -3697  -2978  -2816  -3208
  -2170   -840  -2743    849   1216    503   1623   1873    903   1935
    203   -425    638  -1193  -1806  -1059  -1431  -1251   -368   -892
    689   1172    668   1459   2415   1822   1650   1283   1421    858
   -125   -664   -535  -1251  -1850  -1662  -1396  -1248  -1280  -1094
   -648   -464   -610   -197   -159   -554   -941   -843   -403   2411
   1999  -1734   5221   3217    544   3929   2769   1726   1602   -603
   -412    739  -4153  -2373  -1772  -3043  -3432  -1619  -2202   -123
   -997   -548   1912   1236    256   1699   1627    521    688    -74
    485   -324  -1322   -706     81  -1123   -637     10    171    302
    451   1237   1489   1050   1573   1322   1011    754     39     -5
   -494  -1341  -1293  -1244  -1746  -1634  -1519  -1318  -1196  -1175
   -868   -740   -780   -443   -236    633   3496    247   1018   6903
    245   2524   4373   1649   1163   1201   -627    617  -2058  -3598
   -575  -3206  -3857  -2112  -1756  -2704   -864  -1161    641    374
    -63   1598   2034    565   1470   1804    604    477    194    340
   -224   -909   -669   -227  -1209   -830    -42    105    224    318
   1485   1692    514   1643   1804     25    331    380   -715  -1037
  -1408  -1376  -1575  -2363  -1737  -1302  -1859  -1319   -723   -845
   -445   -242    934   3682    261   1449   6834     90   2576   4675
   1542   1422   1153    217    368  -2152  -2545   -486  -3906  -3658
  -1911  -2711  -3207  -1621  -1286   -503   -433    288   1961   1281
   1099   2582   2091   1170   1531   1293    431   -217   -482   -355
  -1176  -1624   -846   -870   -951    -96    174    755   1179   1004
   1810   1613    910   1180    553   -323   -472   -896  -1507  -1783
  -2007  -1881  -2077  -1858  -1279  -1314  -1138   -483   -236    240
   2594   1741    268   5825   2085   1306   5286   1976   1828   1790
   1026    360  -1054  -2076   -933  -3237  -4069  -2288  -3444  -3562
  -2431  -1666  -1486   -737    114   1376   1337   1417   2825   2224
   1756   2028   1818    851    332     96   -309  -1036  -1290   -867
  -1319  -1294   -508   -212   -211    817    955    871   1596   1166
   1120    907    283     85   -473  -1141  -1177  -1572  -1968  -1729
  -1849  -1684  -1565  -1322   -800   -626   -435    900   2882    239
   2147   5879    393   3375   4653   1486   2247   1607   1128     43
  -1843  -1431  -1589  -4119  -3461  -2346  -4256  -3292  -2247  -1747
  -1500   -605    681   1279   1126   2040   3014   1947   2051   2464
   1619    823    561    334   -564  -1148   -970  -1068  -1642  -1247
   -407   -570   -233    907    866    784   1548   1213    855    831
    223    -34   -624  -1066  -1184  -1712  -1852  -1656  -1728  -1671
  -1359  -1153   -819   -514   -188   1309   2741      5   3289   5150
    159   4271   4321   1234   2339   1517    950   -445  -2024  -1151
  -2506  -4279  -3367  -2622  -4582  -3118  -2032  -1941  -1259   -273
    985   1334   1326   2652   2903   1998   2240   2577   1231    758
    598     71   -752  -1264   -882  -1308  -1664  -1001   -335   -655
   -261   1174    916    572   1608   1598    530    649    680   -315
   -868   -879  -1090  -1890  -1960  -1413  -1853  -1913  -1160  -1129
  -1057   -454   -234    668   2991    964   1472   6368   1152   2366
   5736   1740   1376   2435    474     18  -2273  -1625  -2197  -4183
  -4209  -2577  -3942  -4055  -1769  -1568  -1426    -33    921   1824
   1485   2345   3244   2199   1925   2342   1616    342    313    117
   -898  -1378  -1148  -1113  -1571  -1322   -418   -297    -32    443
   1421   1380    696   1869   1495     39    632    303   -912  -1087
  -1179  -1579  -2026  -1973  -1568  -1610  -1661   -891   -684   -710
    -14    324    610   2983   2280    417   5852   2902    662   5063
   2695   -126   2104    169   -679  -1957  -2607  -2132  -3656  -4333
  -2675  -2663  -3637  -1857   -272   -963    125   1627   1720   1896
   1956   2763   2303   1198   1529   1301    -48   -461   -238   -805
  -1632  -1163   -874  -1139   -958   -274    214    182    812   1255
   1388   1652   1120   1154   1172   -136   -249   -226  -1430  -1670
  -1417  -1844  -1990  -1681  -1391  -1180   -982   -446   -117    -44
    190    626    800   1967   3269    202   3396   4612    -75   2649
   3795   -408    406   1014  -1433  -1341  -2613  -2353  -2426  -3500
  -3091  -1441  -2340  -1993   -110    338   -146   1373   1723   1671
   1655   1595   1827   1184    189    650    101   -839   -791   -646
   -997  -1175   -703   -291   -346    -86    494    799    911   1249
   1239   1331   1184    440    504    280   -937   -861   -825  -1748
  -1539  -1313  -1554  -1220   -989   -772   -285   -126    -29    307
    213     93    286    379   2195   2231   -887   3941   3250   -729
   2536   3326   -909    604    606  -1084  -1133  -2299  -2221  -1456
  -3111  -2789   -835  -1641  -1688     40    682    283   1022   1450
   1608   1360    845   1043   1032   -312   -426    -26   -788  -1249
   -708   -527   -543   -499    152    617    550    649   1139   1419
    921    562   1158    936   -122   -476     66   -723  -1607  -1084
   -755  -1540  -1254   -627   -541   -586   -380     50    220   -177
   -165     32   -357   -645   -465    665   2819   -433    995   5151
   1016    754   3829   1880   -254   1063   -816   -605  -1823  -3154
  -2408  -1506  -3555  -2256   -856   -625   -913    648   1235   1480
   1110   1269   1431   1173   -261    -72     17  -1036  -1375   -819
   -799   -709   -418    165    772    939   1025   1453   1505   1045
    769    895    486   -364   -310   -282   -786  -1145   -684   -717
   -776   -537   -328   -213    -30   -236   -120     -8   -336   -590
   -420   -716  -1128  -1178  -1218  -1140   -695   1480   3403     -6
   3093   5636   1992   1792   3822   1088     56   -306  -2316  -1961
  -2413  -4233  -3295  -1501  -2272  -1839     77   1005    764   1725
   1682   1472   1431    460   -559   -169  -1080  -1738  -1536  -1205
   -993   -352    132    856   1545   1846   1788   1877   1550    915
    439   -159   -953  -1160  -1094  -1371  -1193   -302    434    480
    599   1178   1030    511    308   -207   -663   -826  -1353  -1571
  -1506  -1513  -1425  -1126   -966   -834   -655   -285    169    626
   2995   4718   1310   3206   4901   1998   1267   1751  -1059  -1032
  -1120  -3297  -3099  -2154  -2600  -2012   -704   -540    373   1342
   1177    724   1318    566   -243   -671  -1264  -1586  -1182  -1383
  -1081   -297    612    924   1455   1890   1922   1709   1430    574
     18   -511  -1074  -1398  -1505  -1448   -896   -245    843   1361
   1420   1996   2038   1078    542   -101  -1097  -1345  -1523  -2000
  -1815  -1356  -1313   -901   -513   -323    126    231   -108     40
   -154   -450   -263     96   1449   3574   2230   2186   3594   2223
   1953   1708   -735  -1582   -979  -2489  -2681  -2728  -2546  -1617
   -286   -325    327   1038   1247   1060    999   -247   -635   -712
  -1275  -1528  -1244  -1213   -264    498    828   1195   1663   1670
   1595   1167    339   -264   -490   -917  -1173  -1185   -974   -264
    751   1195   1351   1600   1683   1208    457   -317  -1136  -1476
  -1410  -1450  -1563  -1278   -859   -464   -265   -139   -149    -59
    -72   -176   -507   -818   -984   -802    213   3086   4406   2435
   3263   2864   1827   2138    922  -2226  -2444  -2418  -2545  -2253
  -1928  -2457   -824    997   1284   1329   1288    223    395    542
   -848  -1895  -1959  -2164  -1387   -291   -113    139   1077   1861
   2218   2091   1353    548     82   -194   -686  -1218  -1465  -1266
   -663     90    568    747   1149   1780   1785   1389    758   -108
   -631   -848  -1057  -1303  -1354  -1068   -714   -281    -86   -366
   -460   -359   -391   -419   -547   -912  -1068  -1004   -880   -713
   -289    908   3823   5036   3784   3878   2352    870   1358    564
  -1861  -2845  -3314  -3682  -2231   -770  -1139   -666    511   1029
   1528   2256    864   -635   -939  -1448  -1857  -1485  -1688  -2056
  -1047    287   1020   2087   2514   1845   1557   1718    966    298
   -279  -1433  -2030  -1550  -1184   -812    -61    283    793   1728
   2064   2001   1723    993     66   -434   -930  -1398  -1431  -1468
  -1570  -1245   -761   -701   -533   -320   -367   -382   -197   -296
   -407   -400   -619   -747   -186    900   2885   4027   3630   3546
   2231   1192   1258    912   -378  -1464  -2498  -3548  -3090  -2019
  -1476  -1056   -405   -412    114   1112   1376   1122    666   -150
  -1069   -998   -831   -857   -670   -583   -611   -102    773   1205
   1511   1550   1079    598    542    261    -93   -258   -651  -1059
   -944   -617   -269    520   1026    987   1080   1073    719    526
    334   -337   -846  -1008  -1244  -1229   -940   -949   -987   -745
   -650   -506   -135     10    -77     63    158     89     46      6
     30    953   2036   2014   2298   1905    957    833   1114    870
    484    119  -1042  -1810  -1724  -1649  -1492   -959  -1003  -1251
  -1062   -698   -486    111    494    308    156    185    134    252
    626    536    280    150     -7   -121    118    245     50     24
    -33   -182    -38    251    257    305    396    258    182    293
    305    273    320    241    -14    -47   -115   -196   -156   -148
   -282   -280   -208   -289   -253   -188   -256   -298   -275   -339
   -408   -391   -396   -387   -332   -269   -278   -204   -143   -146
    108    646    891   1099   1090    772    658    774    848    857
    854    586    233     42   -129   -336   -429   -512   -802   -930
   -897   -881   -750   -510   -481   -517   -425   -415   -392   -190
    -97    -91    -21    -51   -119     23    195    350    524    628
    563    519    535    514    486    444    287     75     56     57
     31    141    156     66     81     98     57     99     64    -89
   -229   -334   -440   -530   -559   -593   -616   -573   -464   -365
   -264   -202   -155   -129   -103    -94   -118   -149   -130    132
    311    537    737    685    644    771    979   1056   1127    993
    677    305     26   -172   -205   -253   -476   -629   -698   -751
   -718   -570   -565   -634   -655   -701   -697   -576   -419   -376
   -237   -137    -39    138    346    454    557    641    573    493
    447    382    272    255    241    189    149    133    120    102
    146    179    218    166     65      5    -80    -97    -96    -83
   -111   -124   -131   -129   -118   -151   -245   -302   -395   -489
   -516   -526   -520   -513   -429   -329   -232   -108     19     84
    156    227    258    308    435    499    556    624    557    515
    592    704    739    770    629    372    231    142     -7   -146
   -295   -517   -638   -716   -761   -743   -658   -620   -567   -484
   -439   -394   -311   -236   -212   -134    -98    -93    -46     22
     79    186    292    338    359    385    410    443    498    513
    457    396    388    360    361    383    301    194    108     19
    -52    -94   -195   -291   -382   -436   -476   -475   -473   -496
   -460   -446   -428   -392   -327   -295   -252   -205   -164   -102
    -25     55    104    161    203    302    490    543    587    623
    555    509    573    623    584    568    413    250    151     95
     -6    -67   -211   -378   -478   -546   -591   -606   -590   -613
   -594   -556   -496   -452   -358   -271   -232   -165   -125   -104
    -44     64    140    249    315    340    379    462    508    542
    569    512    409    315    240    134     81     20    -31    -64
    -59    -33    -21     12     28     29     18    -39    -82   -136
   -206   -291   -381   -426   -455   -444   -391   -341   -298   -230
   -163    -94    -31    -14    -25    -30    -31      0     27     59
     98    151    217    304    421    549    548    547    517    423
    363    351    297    211    156     60     -2    -26    -48    -75
   -100   -176   -256   -330   -398   -474   -505   -521   -555   -546
   -516   -469   -389   -266   -171    -84    -20     37     68    109
    146    172    181    202    222    266    318    364    415    451
    474    462    450    409    338    258    165     80      8    -37
    -78   -111   -152   -202   -225   -244   -261   -286   -348   -428
   -488   -508   -513   -488   -430   -391   -319   -194    -75     34
    145    227    272    284    289    297    295    282    261    259
    300    301    321    365    349    346    353    348    312    264
    165     51    -46   -120   -197   -245   -294   -348   -375   -369
   -363   -357   -336   -358   -379   -379   -368   -353   -303   -252
   -215   -146    -70     21    122    228    274    299    320    323
    327    343    316    285    263    253    240    260    282    239
    215    199    145     81     31    -29    -99   -163   -213   -256
   -270   -278   -276   -257   -256   -235   -226   -228   -222   -225
   -214   -215   -187   -158   -129    -65    -11     58    109    169
    240    253    270    276    248    241    243    208    170    149
    127    114    122    116     85     71     40      8    -10    -28
    -65   -109   -118   -130   -157   -138   -131   -127   -129   -109
    -91    -94   -101    -99   -101   -121   -114    -98    -77    -52
    -32     21     34     61     97    105    138    146    120     94
     85     63     65     31     20     35      1    -45     28    -19
    -33      0    -94    -91    -83   -151    -56    -74    -67     96
    306    -86   -241   -108   -166    101    167    112    114     80
    166    382    331    286    228    222    200    346    250   -136
   -346   -364   -477   -384   -337   -463   -402   -321   -290   -187
    -38    -81    -23    108    126    143    230    174    176    256
    213    167    200    151    107    182    143     74     58    -16
   -102    -82   -120   -191   -196   -195   -270   -254   -234   -239
   -178   -141   -150    -75    -73   -201   -228   -274   -345   -181
   -176   -103    680   1428   1427   1561   1182    576    458    640
    189   -178   -532  -1076  -1044   -556   -434   -514   -370   -580
   -473    -52     81   -219   -228   -457   -556   -210     22   -157
    -89     26     11    348    591    448    302    304    126    266
    620    669    453    582    268     98    218    -25   -393   -376
   -466   -534   -209   -250   -541   -598   -610   -800   -535   -549
   -821   -770   -591   -617   -460   -617  -1252  -1337    821   4936
   5016   4336   3550    481     93   1375    289  -2155  -2463  -3964
  -3077   -308    768   -269    386    253    228   1792   1365  -1021
  -2037  -2169  -2579  -1000   -272  -1073   -738    693   1200   2320
   2676    958    -79     74   -355   -405   -171  -1158  -1369    -91
    715   1456   2371   1732   1185   1220    388   -589  -1065  -1836
  -2001  -1080   -650   -607   -328   -501   -819   -432   -491   -830
   -798   -881  -1292  -1289  -1687  -2272   1000   8201   7859   5085
   4264   -752  -1778   1196   -688  -4659  -3354  -3594  -1694   2888
   3162   -324    449    603   -450    551  -1090  -4975  -4124  -1608
  -1097    852   1393   -346    838   3070   1962   1007      8  -2241
  -1729    464     24   -190    589    331   1198   2809   1499   -225
   -243   -377    -84   1135    550   -795   -326    -58   -429   -342
  -1018  -1883   -942   -219   -517   -446   -624  -1000   -353   -324
  -1320  -1591  -1599  -2002  -1379   1591   8529   8485   4015   3517
  -1133  -2278     84  -1879  -5299  -2219   -850   1342   3872   2388
  -1356     33   -114  -1710  -2074  -3588  -4515  -1184   1179    786
   1234    836    409   1433   1127  -1431  -1523  -1114   -412    971
   1344    338   1256   1875   1295    595   -490  -1565   -620    889
    928    367    918    919    219   -286  -1733  -2342   -952    -71
   -100     81   -406   -610   -323   -982  -1795  -1422  -1005   -650
   -759  -1473  -1643    873   9400  10744   1849   1554  -1327  -2901
    253  -2356  -6298   -483   2492   2772   3519    -79  -2690    356
   -687  -3859  -3310  -3094  -1141   2207   1290   -432    877    722
    -68   -521  -1959  -1688    878   1201    658   1117   1199   1378
   1383   -418  -1305   -482     20    211    649   1209   1923   1912
    636   -815  -1917  -1811  -1280  -1007   -306    510    691     60
  -1036  -1908  -1794  -1234   -965   -878   -376   -221  -1112  -1842
   -622   7809  11980   1530    920    -33  -2901     37  -2394  -5750
    693   3775   2035   1958   -350  -1664    -38  -1998  -4858  -2574
   -879    397   1364    317     36   1543   -127  -1845  -1879  -1059
    103   1264    559    794   1814   1577    289   -529   -832   -196
    248    -97    120   1697   2950   1537   -152   -493  -1341  -1406
  -1149  -1434     73    986     -8   -686  -1329  -1464  -1206  -1530
  -1226   -667   -391   -499  -1963  -2489   1265  11426   9075  -1279
   2674   -612  -1739   -811  -5293  -2549   4023   2210   1809    147
   -699    342  -2137  -4508  -2609  -1452    256    714   -488   1252
   1736   -712  -1598  -2129  -1496    567     40    169   1754   1899
   1474    553   -759   -250     -2   -492   -173    475   1517   2749
   1772    656   -110  -1601  -1569  -1386  -1126    197    483     80
   -215  -1323  -1845  -1812  -1733   -811   -603  -1008  -1391  -1917
  -1210   3212  12347   5667  -1759   3653  -1683  -2110  -1935  -4462
    956   4206   1176   1869    252     99  -1213  -4149  -3418  -1240
  -1019    342     -6    326   1795   -101  -2062  -1582  -1614   -542
    435     31   1525   1919    740    435    -28   -375    -11   -380
    -75    905   1425   2346   1911    270    225   -589  -1854  -1304
   -590     69    630   -131   -570  -1059  -1768  -1822  -1624  -1258
   -922  -1075  -1633  -1782   -942   4350  12731   2902  -1159   3633
  -2723  -1888  -2676  -3419   2981   3735   1028   1807    220     16
  -2778  -4217  -1677   -607   -635    381    -39   1205    740  -2031
  -2133  -1621  -1451     17    -12   1074   2746   1441    263   -264
   -923   -536   -390    -84   1052   1472   1993   2129   1333    729
  -1189  -2014   -934   -726    -16    594    313    173  -1026  -2000
  -1893  -1827  -1302  -1035  -1292  -1631  -1958   -941   6623  12039
   -269    199   3038  -3549  -1908  -3468  -1757   4377   2952   1054
   1839    422   -800  -3793  -3360  -1001     53     50    121    921
   1596   -950  -2581  -2241  -1854   -965   -230    311   2119   2200
    730    138   -581   -681   -724   -871    329   1556   1682   2239
   1861    614    -58  -1143  -1668   -768    -81    363    562    144
   -471  -1377  -1721  -1630  -1553  -1260  -1350  -1459  -2146  -1395
   7237  11641  -1108    224   2191  -3958  -1955  -3344  -1187   4493
   2809    980   1652    414  -1374  -3756  -2687   -717    653    615
    476   1515   1067  -1613  -2406  -2238  -1424   -547   -423    819
   2092   1344    255   -496   -856   -673   -902   -361   1076   1596
   2268   1800   1049    716  -1285  -1758   -924   -534    422    790
    241    -71   -972  -1757  -1738  -1451  -1336  -1353  -1659  -2485
    417   9617   8779  -2359   1344    803  -3899  -2899  -3026   1006
   4374   2034   1007   1518   -159  -3006  -3887  -1734     51   1113
    545    922   1633    -56  -1911  -2155  -1978   -728   -196    477
   1653   1831    749   -401  -1002   -962  -1018   -814     72   1160
   2421   2122   1055    254  -1430  -1305   -630   -523    572    919
    234   -464  -1254  -1763  -1646  -1146  -1162  -1032  -1313  -1900
   3390  11594   3120  -2972   2589  -2035  -3470  -2385  -1500   3008
   4011    818    673    734  -1802  -3732  -2718  -1093   1217    983
    150   1813    914  -1512  -2104  -2373  -1314   -247    263   1609
   2019   1321    373   -790   -977   -705   -768   -105   1299   2194
   1507    885   -228  -1877  -1523  -1009   -487    934    987    317
   -218  -1200  -1598  -1730  -1753  -1420  -1049  -1472     76   9310
   9481  -2989    438    480  -4423  -2216  -2300    600   4937   2179
    272   1320   -842  -3173  -3352  -2056    517   1503    -26    915
   1254   -651  -1814  -2300  -1386    400    112    680   1557   1110
    409   -595  -1018   -448    -44    236   1223   2262   1557    530
   -378  -1524  -1474  -1053   -410    574    893    149   -754  -1505
  -1754  -1742  -1622  -1242   -933  -1242   1226   9930   7976  -3057
    415   -492  -4327  -1855  -1779   1393   5227   1877    -92    391
  -1861  -2889  -2667  -1477   1591   2070    223    671     52  -1295
  -2144  -2708  -1118    621    686   1291   1598   1160    134  -1298
  -1435   -466     73    495   2010   3052   1327   -814  -1858  -1484
   -805   -568    330   1062    755   -246  -1429  -1816  -1768  -1997
  -1683  -1332   -971   2042  10126   6935  -3111    548  -1307  -4271
  -1136  -1496   1495   5405   1703   -365   -124  -2516  -3031  -2367
  -1108   1962   2331    531    627   -361  -1698  -1856  -2151  -1192
   1106   1396    962   1019    540   -320  -1160  -1398   -302    609
   1339   2713   1995     13  -1277  -2236  -1576   -542    258   1197
    928    -30   -920  -1853  -2091  -1684  -1537  -1334   -945   1425
   9594   7970  -2808   -653  -1236  -3881   -744  -1225   1083   5817
   2305   -850   -710  -2921  -2958  -2198  -1706   1610   3073   1007
    352   -720  -1916  -1642  -1829  -1274    894   1498   1345    899
     66   -106   -486  -1183   -501    696   1675   2204   1233    662
   -905  -2500  -1234   -355     25   1094    345   -629   -838  -1806
  -2083  -1736  -1652  -1195   -879   3067  11062   5212  -3362   -547
  -2961  -3015    650   -921   1983   5736   1674  -1070  -1962  -3580
  -1864   -898  -1081   1845   2967    826   -469  -2134  -2562  -1176
   -990   -588   1192   1871   1380    169  -1008  -1090   -493   -448
    101   1799   2465   1840    805  -1789  -2377   -729   -412    223
   1161    738    244   -879  -2397  -1971  -1460  -1661  -1328  -1172
   2101  10356   6622  -3271  -2008  -2997  -3073   1300   -252    948
   5739   2997  -1093  -2420  -4207  -2518    151   -225   1033   2700
   1319    -39  -1950  -3479  -1759    129    172    871   1574   1333
    704   -766  -1968  -1186     24    958   1450   1485   2009    624
  -2139  -2322  -1451   -223   1347    999    118     31   -775  -1831
  -2121  -2099  -1435   -985      9   6609  10769   1682  -3097  -3153
  -5020   -383   2028   -331   2698   4493   1117  -1129  -3799  -4943
   -937   1237    783   1635   1209     94   -168  -2500  -3468  -1027
    649   1398   1718    695    442    404   -889  -1303   -604    693
   1797   1381   1143    702  -1202  -1783  -1408   -954    499    744
   -116   -243   -699  -1109   -965  -1582  -2000  -1584   -752   4041
  10057   4557  -2246  -3101  -4778  -1254   2968    817   1270   3455
   1544   -161  -2255  -4977  -2264   1406   1646   1414    401  -1169
   -631   -968  -2280  -1769   -370    806   1777    959   -382   -306
   -134   -424   -182    568   1083   1373   1671    672   -828  -1069
   -992   -687    118    146   -286   -309   -625   -959  -1085  -1499
  -1812  -1671  -1141   2523   9006   6744   -420  -3339  -5742  -3032
   2759   2631   1455   2115    871    176   -356  -3456  -3649   -316
   1843   2409   1386  -1443  -2024   -912   -913  -1088   -934   -625
    777   1644    642   -324   -543   -667    -21    943    915    544
   1560   1105   -725   -934  -1116   -691    846    437   -655   -551
   -843   -830   -498  -1398  -1931  -1707  -1527   1221   7612   7829
   1521  -2271  -5655  -4586   1753   3823   2249   1732    -16   -807
    129  -1582  -3299  -1619    529   2056   2576    245  -2162  -2151
  -1433   -600    -67   -565   -555    732   1222    675    -62   -915
   -963    562   1400   1044   1423    868   -493   -530   -844  -1093
     20    380    -44    -50   -722  -1172   -776  -1154  -1636  -1559
  -1741   -590   4496   8579   5053    127  -4372  -6662  -2095   3424
   4336   3373    771  -1874  -1279   -183  -1399  -1938  -1300    -99
   1711   2239    257  -1737  -2475  -2051   -756    326    183    -11
    254    462    602    436   -425   -543    223    685   1870   1969
     59   -963  -1270  -1116    187    663    -89   -348   -504   -878
   -649   -846  -1543  -1636  -1514  -1409    910   6258   7611   3629
   -490  -5543  -6298  -1118   3437   4872   3876     88  -2571  -1822
   -803   -711   -620   -955   -860    619   1615    878   -523  -1916
  -2606  -1834   -283    765   1136    730     70   -167    -43    -53
    229    573    491   1181   1398    425   -303  -1056  -1373   -383
    392    342     87   -464   -943   -897  -1006  -1215  -1258  -1471
  -1643   -693   3445   7792   6188   2552  -2719  -6794  -4764    338
   4238   5579   3155  -1047  -2911  -2513  -1425    -92    207   -621
   -943   -110    562    808    174  -1303  -2640  -2365   -936    772
   1874   1687    525   -450   -824   -533    573   1343   1381   1466
    550   -401   -729   -976   -753   -132    155    121     22   -300
   -737   -929  -1165  -1347  -1196  -1151  -1453  -1100   1925   6325
   6466   4372    132  -5129  -5774  -2596   1567   4963   5255   1882
  -1637  -3377  -3389  -1476    629    961    -45   -704  -1085   -646
    254    399   -514  -1488  -2019  -1459    130   1549   1986   1351
    -20  -1065   -966    218   1497   2145   1913    441   -870  -1406
  -1319   -494    481    776    325   -353   -957  -1116   -916   -750
   -729   -715   -922  -1400  -1706   -413   3658   6325   5800   3640
  -1477  -5314  -5078  -1915   2126   4960   4287   1125  -1838  -3493
  -3018   -981    770    925    164   -968  -1763  -1264    140    979
    650   -414  -1749  -2085  -1042    664   1957   2175   1093   -314
  -1121   -739    592   1713   2098   1050   -543  -1417  -1419   -592
    444    867    509   -209   -871  -1146   -866   -340   -191   -379
   -726  -1534  -2103  -1906    -69   4015   6473   6063   3875  -1061
  -4993  -5491  -3053    799   4142   4549   2267   -766  -3132  -3488
  -1874    163   1021    819   -267  -1409  -1469   -476    481    942
    551   -785  -1814  -1692   -578    918   2054   2038    931   -501
  -1349   -877    561   1693   2132   1151   -447  -1502  -1579   -686
    477   1113    867    -22   -885  -1318  -1119   -555   -179   -200
   -555  -1216  -1810  -1948   -880   2177   5350   6072   5116   1551
  -2934  -5230  -4704  -2001   1713   4034   3691   1631  -1094  -2958
  -2842  -1234    351   1148    848   -504  -1610  -1663   -840    234
   1072    927    -34  -1148  -1730  -1294    -56   1254   1984   1703
    611   -590  -1123   -489    652   1572   1941   1029   -257  -1168
  -1410   -728    364    953    747    -75  -1120  -1586  -1315   -598
     13    211   -165  -1004  -1813  -2190  -1698    561   3791   5580
   5597   3667   -206  -3499  -4734  -3641   -740   2377   3786   3125
   1021  -1374  -2663  -2321  -1066    248    931    398   -770  -1648
  -1714  -1016    152   1009    963    183   -762  -1351  -1122   -137
    996   1724   1688    886   -158   -853   -843     65   1156   1760
   1805    905   -315  -1151  -1435  -1065   -273    383    522    205
   -440   -999  -1123   -910   -655   -424   -407   -661  -1050  -1398
  -1535   -899   1107   3475   5007   5260   3647    604  -2231  -3714
  -3394  -1417    947   2389   2473   1304   -496  -1774  -1955  -1322
   -369    279    129   -611  -1331  -1635  -1290   -307    764   1341
   1237    446   -616  -1261  -1206   -414    678   1427   1481    878
     37   -518   -488    182    932   1274   1297    661   -206   -818
  -1107   -912   -394     73    269    224   -151   -672  -1010  -1073
   -919   -594   -325   -273   -494   -864  -1153  -1022    -85   1733
   3636   4685   4457   2717    120  -2258  -3430  -2991  -1328    705
   2084   2210   1211   -342  -1548  -1807  -1254   -368    244    162
   -519  -1330  -1724  -1413   -513    523   1187   1178    513   -400
  -1078  -1112   -524    368   1175   1545   1364    715    -41   -538
   -560     52    843   1222   1331    848    -26   -600   -928   -996
   -688   -302    -50    141     13   -414   -815  -1100  -1150   -855
   -465   -230   -214   -466   -875  -1029   -649    458   2180   3733
   4452   4051   2462    148  -1888  -2890  -2699  -1373    309   1503
   1748   1006   -297  -1377  -1781  -1499   -785   -142    -63   -507
  -1107  -1466  -1270   -510    448   1140   1324    873     45   -682
   -957   -647    129    964   1479   1480    968    257   -308   -475
   -100    496    870    955    628     34   -490   -709   -781   -688
   -460   -304   -187   -145   -317   -584   -783   -932   -886   -642
   -377   -203   -174   -375   -605   -534     66   1390   2958   3981
   4108   3062   1066  -1130  -2544  -2923  -2118   -605    723   1413
   1229    306   -743  -1365  -1501  -1090   -511   -185   -275   -625
  -1046  -1188   -834   -126    687   1318   1471   1036    243   -593
  -1059   -900   -189    706   1384   1531   1092    329   -402   -773
   -644    -66    606    941    949    487    -78   -494   -694   -551
   -402   -312   -306   -372   -451   -445   -442   -441   -447   -496
   -523   -514   -453   -415   -431   -507   -454    -71    868   2262
   3498   4008   3652   2116   -151  -1971  -3074  -2998  -1780   -303
    894   1398    968     42   -733  -1168  -1071   -628   -260   -221
   -432   -837  -1095   -992   -554    214    986   1414   1324    800
     28   -631   -920   -710   -108    570   1028   1110    833    318
   -169   -437   -471   -194    295    557    681    511    161    -69
   -373   -506   -493   -503   -434   -296   -275   -215   -251   -422
   -509   -591   -626   -538   -451   -451   -464   -558   -552    -61
    934   2324   3463   3853   3443   1840   -145  -1803  -2910  -2875
  -1929   -630    689   1425   1278    694   -195   -985  -1220  -1115
   -792   -420   -362   -564   -772   -927   -709   -113    605   1287
   1590   1302    665   -118   -827  -1018   -730   -129    602   1059
   1083    742    165   -379   -624   -543   -130    450    759    817
    546    -55   -366   -601   -613   -271   -151    -86    -68   -286
   -361   -311   -361   -293   -373   -636   -754   -872   -918   -782
   -708   -520    -58    619   1953   3259   3916   4121   3025    985
   -916  -2727  -3549  -2993  -1946   -403   1008   1483   1408    807
   -221   -794  -1031  -1044   -635   -453   -571   -681   -963   -986
   -479    173   1012   1701   1735   1359    582   -434  -1087  -1337
  -1151   -444    298    824   1078    839    392    -14   -345   -375
   -165     19    222    496    514    465    556    184    109    -72
   -460   -431   -513   -459   -116     24     -1    -43   -621  -1084
  -1400  -1587  -1228   -705   -217    191    206     33    214    707
   1830   2984   3646   3688   2572    751  -1114  -2686  -3306  -2802
  -1698   -174   1103   1607   1543    834   -143   -849  -1244  -1256
   -904   -670   -555   -597   -853   -880   -575     14    860   1585
   1851   1644    819   -282  -1180  -1679  -1524   -805    126   1001
   1494   1419    998    375   -204   -480   -491   -257    228    551
    621    607    200    -23   -177   -330   -253   -321   -440   -534
   -666   -760   -671   -739   -681   -666   -734   -683   -650   -594
   -504   -405   -177    506   1659   3016   3857   4455   3578   1922
      2  -2257  -3330  -3590  -2889  -1437    137   1087   1764   1419
    714     59   -739  -1009  -1069  -1030   -932   -880  -1121  -1015
   -864   -384    530   1300   1987   2187   1728    810   -272  -1371
  -1821  -1768  -1186   -158    739   1401   1612   1317    748    178
   -403   -616   -643   -530   -252     63    451    587    826    700
    507    328   -212   -510   -881  -1124  -1036   -792   -517   -107
    -80   -218   -452   -878   -984   -994   -812   -461   -150    203
    853   1656   2582   3293   3616   3152   2012    507  -1294  -2556
  -3279  -3118  -2210   -926    354   1351   1672   1439    825    -54
   -695  -1197  -1404  -1339  -1172   -957   -640   -369     -6    484
    919   1371   1563   1430    955    188   -672  -1344  -1683  -1504
   -893    -87    787   1385   1623   1474    982    323   -257   -672
   -674   -312    -48    476    579    455    392    -41   -235   -411
   -611   -638   -636   -747   -656   -711   -714   -586   -629   -547
   -541   -630   -673   -574   -341    411   1780   2838   3904   4380
   3389   2269    142  -1803  -3034  -3734  -3329  -2132   -856    543
   1514   1596   1495    705     -3   -494   -905   -969   -891   -947
   -932   -954  -1010   -642   -212    526   1338   1828   2014   1680
    829   -162  -1124  -1815  -1867  -1507   -685    298   1106   1650
   1750   1411    835    142   -456   -757   -859   -655   -186    208
    499    722    471    288     99   -193   -242   -371   -569   -672
   -856   -925   -790   -711   -472   -314   -308   -311   -450   -618
   -667   -605   -280    461   1533   2606   3521   3982   3440   2459
    729  -1071  -2464  -3399  -3402  -2717  -1591   -305    791   1359
   1555   1197    644     47   -482   -777   -950  -1003  -1000   -997
   -978   -803   -497      0    615   1189   1636   1747   1460    849
     41   -738  -1291  -1481  -1254   -699      6    674   1136   1295
   1146    772    354     86     11    -21     79     76    -92   -259
   -504   -617   -607   -508   -322   -184   -213   -337   -589   -818
   -907   -892   -718   -517   -390   -336   -240    -12    488   1372
   2298   3051   3578   3266   2460   1151   -491  -1866  -2862  -3234
  -2887  -2059   -984    145    904   1302   1274    917    423    -55
   -460   -690   -809   -881   -888   -888   -836   -678   -381     53
    600   1111   1502   1625   1420    929    237   -483  -1051  -1348
  -1303   -940   -391    216    725   1031   1159   1227   1098    892
    681    222   -196   -630  -1062  -1235  -1220  -1021   -620   -275
    -37     56    -84   -290   -511   -696   -771   -787   -761   -645
   -397     48    735   1661   2445   3081   3349   2956   2256   1070
   -254  -1460  -2415  -2913  -2829  -2369  -1583   -662    136    760
   1109   1153   1012    717    317    -72   -456   -778   -989  -1121
  -1111   -938   -645   -222    273    750   1149   1394   1408   1199
    798    261   -286   -733   -997  -1036   -850   -495    -85    311
    758   1017   1150   1231    966    650    209   -353   -759  -1084
  -1243  -1145   -985   -730   -431   -267   -165   -124   -202   -256
   -318   -413   -446   -492   -423   -150    365   1109   1799   2542
   2921   2825   2473   1564    473   -634  -1691  -2293  -2489  -2371
  -1900  -1314   -756   -197    211    460    659    694    642    547
    321     77   -183   -488   -706   -826   -833   -627   -317     47
    452    735    906    950    827    630    368     56   -188   -348
   -421   -375   -296   -171    -20    155    348    469    618    614
    519    390    105   -128   -351   -552   -614   -638   -627   -601
   -604   -624   -611   -588   -507   -358   -234   -100    -48    -63
    -53     23    289    728   1194   1714   2086   2164   2009   1543
    837     24   -723  -1228  -1442  -1466  -1353  -1121   -910   -710
   -509   -369   -240   -141    -76     19    105    154    195    182
    128     77      1    -38    -35    -20     37     93    118    130
    113     77     42     21     22     85    171    260    345    380
    403    410    319    266    169    -21    -88   -196   -251   -198
   -195   -148   -132   -194   -253   -316   -415   -434   -440   -446
   -366   -336   -315   -251   -243   -213   -143    -71     78    287
    501    737    975   1097   1171   1134    960    730    375     45
   -186   -305   -310   -289   -306   -372   -465   -587   -656   -681
   -667   -578   -485   -366   -241   -148    -59      5     52     77
    105    105     90     75     41     28     -7      6     53    104
    203    274    357    422    433    401    358    285    222    160
     72     32    -60   -125   -136   -168   -113    -58    -26     24
     30    -28    -90   -167   -291   -359   -415   -454   -445   -423
   -341   -305   -244   -134    -87    -34      9     61    106    172
    244    327    437    522    595    630    648    596    532    460
    352    262    161     86     28    -64   -180   -305   -412   -501
   -532   -552   -533   -486   -467   -429   -407   -403   -374   -347
   -307   -214   -109    -21     80    168    256    360    404    434
    445    423    386    338    291    233    181    144    126     96
     84     74     85    107    104    101     97     50    -32   -102
   -177   -272   -332   -360   -411   -446   -409   -381   -389   -351
   -242   -214   -213   -105    -71    -20     67    129    185    222
    245    277    331    369    436    481    489    495    461    401
    353    297    245    191    106     12    -81   -201   -299   -376
   -458   -504   -532   -551   -551   -512   -448   -388   -322   -240
   -172   -139    -70      3     58    130    185    232    284    299
    276    285    272    234    203    179    176    169    173    203
    213    213    210    180    153    127     76     33    -20    -82
   -135   -199   -271   -326   -362   -353   -341   -326   -247   -209
   -168   -157   -153   -130    -80    -89   -113    -41     20     40
     44    114    140    206    236    296    337    326    326    298
    268    231    126    133     40      1     19    -75    -69    -64
   -109    -56    -25    -51    -96    -96   -153   -169   -158   -142
   -160   -121   -108   -100     -8     -2     -5      5    -17    -24
    -34    -59    -79   -107    -63     -1     14     39    128    123
     93    203    148     93    169     53      0    -28    -54   -177
   -172   -114   -102    -56     62     58     55    109    124     65
     -8     46   -106    -83    -55    -90     -4    -45    -32     75
     57    110    106     35     79    114     66     -3     -4   -123
    -92    -55    -64    -22    -12     43     57     98     94    132
     55    -48      8    -56    -37    -10    -60     29      0     26
     76     83     26     58     21   -101   -184   -177    -90   -213
   -216   -101   -111   -162   -101     45     30      3     86     40
     12     77    -38      8     15    -92      9     70     -9    133
    185    246    201    283    201    160     48    109     -2    -38
    -98     -9    -91   -105    -43    -24     40    -60    -89    -40
    -81     -4   -130   -189   -140   -178   -140    -41   -131    -69
    -19     59    153    129     52    154     89     13     33     44
     93     10     69     77    -22     63    -19     -8    154    115
    -52     21    -50   -118    -76    -48   -157   -111     22    -18
    -40    -14    -41     22      5     30      1    -59     -1    -80
    -80    -22     16    -51      9     33     12     93     69    138
      5     14    151      8    -78    -17     41    -50     99     93
     57     65     39    119     63     39      2    -43   -103   -120
    -41   -137    -99   -104   -109    -48    -79    -36     32    -17
     11    -62     19    -78    -49     19    -34     96     25     73
     72     83     60    117     50    140     38     41     -1    -21
     -6    -31      0    -30      8     13      3     -4     53   -109
    -59    -59    -69    -74     27    -61    -66    -47     10     -5
     33    -52    110     10     -9     95      2     33    -45    -82
     -2    -35     42     17    -14     54     45     46    118     48
      9     38     -1      3     20      7    -85     40    -48    -54
    -24    -92    -28     40     -3    -89    -39    -71    -91    -88
    -29     22     29     18     48     49     64     -3     89    104
     19     36     40    -55      5     38     50    -26     24     21
     -4     26    -34      6      2    -39    -35     -8    -95    -70
     19    -52     18     20    -15    -31     62     76     -7     18
     -8    -12    -46     35   -107     -1     -2    -41     43    -80
     22     72    -86     11     68    -12     71     23     26     35
     25     14      1    -30     50     -9    -50     31    -53     56
   -105    -39     12    -85     73      7   -151     61    -16    -17
     41     -7    118    -32    -29    162      2    -34     36    -37
      5    -48     24    -21     43     60    -87     24     46    -55
    -13    -23    -30     34      3    -91    -47      3     15    -34
     37     -1    -17     34     15     12    -45     32     19    -18
     33     -5     -7    -24    -17      9    -26      8    -21     -1
     49     46     -3    -29     12    -75     51     74     27     44
     18    -27    -13    -28     -2    -24     31    -25    -65     28
    -35    -88     -3      6    -36    -56     23     41    -38     16
     97    -91     27     21    -10     92      0    -69     80     75
     18      7    -24     30     35    -24     51    -42    -69     39
    -22    -83     83    -31    -33     23   -127    -81    121     32
    -33    -59      8     26    -19     -9      9    -44    -44     50
     15     14     -7      9     54    -22    -41     34     21      9
     56    117    -20    -27    -25     85     18    -39    -54     46
    -24    -37     14    -73     -4     29     12    -90      3    -40
     33     76    -76     -1     94      3    213    -83   -151   -104
   -102     61     11    -39     68    -13    -38     69     11     28
     55    -31      6     76     91     42     50    -92    -62    -89
    -58     94    155    156    -55   -227     17    106   -196   -227
   -156    -75   -220   -105     -1     91    104     81    109    150
    113    228    255     17     86     20    -38    -10    -27    -64
   -143    -90    -80    -14     94    -20     28     75   -103    -35
     55    -51     66     47   -129    -77     88    -85     36    -89
    -30      0    -44     -4    103     44    -68    -30     43     66
    -60    113    -36    -25     99     42     -1    144    -34    -88
    -63    -86      5     30    -34   -163    -72   -109     12    110
    113     73    -61    -35     72    221    128   -145    -59    -39
   -168     28     93     17    -14      4    -80     68    173     11
     76    -99   -137     58     47     17      9   -113    -94    -84
     82    113     85     12    -88    -98    -12    -64     43     68
      0    -94     -8     10     29    110     28    -54   -172    -25
     75     68     70    -61    -95     -8     35     77     67    -72
   -105     10    130     48    -11     -3    -21     58     12    -81
    -34     24    -24     97      6    -21      6     88     -7    -29
     18   -131    -79      8     -1    -36    -58    -62     38     25
      1      5     18      5     27     64     13     89    -38     -2
    -46    -74     73     71    -30     12    -37      3     40    -32
     65      1    -59    -28   -104    -63     17    -57    -54     -9
    -73     32    117    130     38    -22    -71     -3     44    -46
    -25     14    -31    -12    117    102     38      4      4      4
     40     54     14    -29    -84    -73    -18     -2    -26    -20
    -16    -38      1     52     22    -17    -16    -20     -5     -2
     -2     -5    -15    -13     -7     11     22     12     17     59
     58     33     32    -10    -42    -41    -38    -35    -18    -22
    -38     -6     -7     -7     14     22     16     37     30     15
     23     -7    -48    -30    -15    -12      4     12     -9    -22
     -1      3      7     20      4    -29    -15    -11     -5     27
     39     14     18     17     20     11      3    -11    -11      4
    -16    -43    -39    -47    -33      7     20      7     22     46
     60     64     67     37      1     30     37     19     22    -19
    -39    -12      4     -2      4     -9    -13    -13      0    -26
    -59    -54    -55    -37      0    -32    -59    -51    -48    -21
     19     19      8     21     27     20     19     18     -6     -9
     12      3    -24    -18    -45    -58    -37    -16    -30      1
     11     14     42     70     73     62     47     31     31     54
     94    105     77     55     32     56     77     48     17     -4
    -18     -4      9     -2    -10    -42    -56    -38    -69   -108
    -90   -107    -86    -41    -63    -99   -107   -117    -85    -46
    -43    -25      5     22     32     40      2     -3      6     34
     54     47     28     22     40     51     34     26     33     49
     76     82     48     19      5      8     21     22     23     16
     22     31     43     23      5      4     19     40     63     33
     -7    -22    -36    -43    -28    -62    -87    -45    -30    -35
    -33    -71    -93    -47    -30    -36    -18    -24    -35    -10
     -3    -26    -36    -34    -38     10     55     56     45     28
     14     17     14     17     15     17     33     45     36     15
      3      5     13     23     26     26     48     62     54     41
     36     23     13    -12    -26    -34    -28    -21    -12    -17
    -17     -9    -14    -33    -36    -27    -19     -7      5      4
    -12     -4    -20    -23    -19    -28    -34    -21    -20     -2
      5     -3      1     15      2     -5    -17    -33    -22      4
     16     21     24     21     30     44     37     22     16     15
     24     40     32     16      4      0     -4      7     11      3
      0      8      2    -14    -20    -23    -28    -14    -10    -16
    -14    -17    -12     -6     -1     -1     -3      8      5      4
      8      4      3     10      3      0     18      8     -4     10
      2     -8     12     12     -8     -5     -3     -8    -12     -7
     -2      5      3     -1     -5     -8     -7      1      0     -3
     11      7      6     20     12      0      5      3     -3     11
     13     -1      2     -3     -8     -4     -8    -11     -7     -2
     -4     -3      3     -1      3     -2     -7     -4     -7     -7
     -3     -1     -6     -3      0     -2     -3      7     12     12
     17     15      8     12      8      2     -4    -10     -9     -8
    -10    -13    -11    -10     -9     -4    -11    -14    -13    -10
     -9     -5     -9    -14    -20     -9     -5     -1      0      7
     12     14     12     11     11     10      8      7      6      6
      7      5      0     -4      0     -3      0      5      2      0
      2     -4     -7     -6     -9    -14    -13    -15    -11     -8
     -8     -4     -7     -7     -6     -6     -2     -1     -6     -6
     -4     -8     -4      0      1      3     -3      1      1     -3
     -4     -7     -4     -5     -7     -8    -10     -3      2     -1
      4      7      9      8      5     10      0      0     -3      3
      5     -3     -7     -3     -2     -2      3      2      0     -1
      0     -1      0     -6     -5     -4     -4      1      1      2
      3      2     -1      1      5      2      0     -2     -7     -3
     -8     -7     -5     -8     -7     -7     -3     -5     -4     -4
     -4     -3     -5     -5     -3     -9    -12     -6     -5      0
      2      5      6      8      8     13     11      7      9      5
      6      3      2      0      7      9     10     10      8     12
     10      9      3      4      6      1     -1     -3    -10     -9
     -7    -12     -8     -2     -5     -5     -6     -7     -7      1
     -1     -3      1      2      5      8      9     -8     36     11
     -6     34    -20     23     17     -3     -1     13     -9     17
    -11     -9     -5      6    -15     -3     -2    -21      3      7
    -13      5     -4      2     13      2      5     15      5     14
     10     -1      9     12      4      3      3     -5      0      5
      2     -4     -3     -3     -1     -5     -6     -3     -8     -5
     -4    -10     -7     -3     -4     -6     -7     -2      3      3
     -1      6     10     10     10      7     10      9      9     10
      9      9      6      7      5      3      2     -2      2      2
     -4     -5     -4     -5     -1     -5     -1     -4     -7     -3
     -1     -4     -2      4      2     -2     -4      2     -1     -1
      5      9      5      8      5      3      4      1      0     -1
     -3     -6     -6     -4     -4     -6     -4     -5     -5     -7
     -6     -2     -2     -2     -1     -2     -2     -1      1      0
     -4     -1     -4     -4      1     -1     -1     -2     -7     -6
     -2     -3     -4     -3     -5     -3     -2     -4     -5     -2
     -2     -2      0      0      6      3      2      6      3      4
      4      6      5      6      2      1      4     -1      0     -2
     -3     -1     -3     -2     -6     -8     -4     -4     -3     -6
     -4     -2     -6     -2      1     -5     -3     -1     -2      1
      0      0     -4     -1     -1      2      1      5      0     -3
      1     -3     -1      3      1     -1     -3      0     -1     -2
     -7     -8     -7     -3     -3     -7     -8     -5      1     -1
     -1     -1     -1     -2      1      4      4      6      8      8
      7      6      8      9     13      9     11      9      8     10
      2      1      3     -1     -2     -1     -5     -6     -2     -6
     -9     -7     -8     -5     -9     -8     -9     -6     -4     -7
     -3     -5     -7     -6     -2     -2      0      0      1      2
     -1      3      1      0      1      1      1     -3     -1     -2
     -3      0     -3     -2      2      3      8      7     10     14
     10      8     12      8      9     10      7      8      8      5
      4      6      8      6      6      6      9      3     -2      4
      0     -4      2     -2      0     -2     -6      1     -1      1
      3     -1
EOF

# Analyze the  speech data to produce separate files containing 
# phase and cepstrum data.

echo "Running cepanal (outputs sp.phase.fea, sp.cepst.fea)."
cepanal -r1:13312 sp.sd sp.phase.fea sp.cepst.fea

# Recombine the cepstrum and phase data
# information to get reconstructed sampled data.

echo "Running cepsyn (output sp.syn)."
cepsyn -tSHORT sp.phase.fea sp.cepst.fea sp.syn

# Compare the result with the original.

echo "Comparing the result with the original.  There should be no diffs."
pspsdiff -H sp.sd sp.syn

# Clean up.

rm -f sp.sd sp.phase.fea sp.cepst.fea sp.syn

exit 0
