#!/bin/sh
# This material contains unpublished, proprietary software of 
# Entropic Research Laboratory, Inc. Any reproduction, distribution, 
# or publication of this work must be authorized in writing by Entropic 
# Research Laboratory, Inc., and must bear the notice: 
#
#    "Copyright (c) 1998  Entropic Research Laboratory, Inc. 
#                   All rights reserved."
#
# The copyright notice above does not evidence any actual or intended 
# publication of this source code.     
#
# @(#)mbs_dist.tst	1.1	9/10/98	ERL
# 
# Written by:  Rod Johnson
# Checked by:
# Revised by:
# 
# Brief description:  Test script for mbs_dist program.
#   "mbs_dist.tst clean" just removes the test files.
#   "mbs_dist.tst" runs the tests and leaves the test files in place.
# 

## CLEAN UP TEST FILES

rm -f tstA.spec tstB.spec log1.txt out1.fea ref1.fea dif1.fea tmp.fea


case "$1" in
clean)
    exit 0;;
esac

## TURN OFF COMMON PROCESSING

USE_ESPS_COMMON=off; export USE_ESPS_COMMON
ESPS_VERBOSE=0; export ESPS_VERBOSE

## MAKE TEST FILE

echo "Making test FEA_SPEC file tstA.spec."

esig2fea - tstA.spec <<aArDvArK
Esignal
   0.0B
  ASCII
     48
   1950
     -1
Tag: LONG <r>
tot_power: FLOAT <r>
re_spec_val: FLOAT 513 <r>
frame_len: LONG <r>
window_type: SHORT 1 <g> [0]       4
window_type.enumStrings: CHAR 10 11 <g> 
  [0][0]  "WT_NONE\0\0\0\0"
  [1][0]  "WT_RECT\0\0\0\0"
  [2][0]  "WT_HAMMING\0"
  [3][0]  "WT_TRIANG\0\0"
  [4][0]  "WT_HANNING\0"
  [5][0]  "WT_COS4\0\0\0\0"
  [6][0]  "WT_KAISER\0\0"
  [7][0]  "WT_ARB\0\0\0\0\0"
  [8][0]  "WT_SINC\0\0\0\0"
  [9][0]  "WT_SINC_C4\0"
sf: FLOAT 1 <g> [0]       8000.0000
nan: LONG 1 <g> [0]   2147483647
step: LONG 1 <g> [0]          160
frame_meth: SHORT 1 <g> [0]       2
frame_meth.enumStrings: CHAR 3 9 <g> 
  [0][0]  "NONE\0\0\0\0\0"
  [1][0]  "FIXED\0\0\0\0"
  [2][0]  "VARIABLE\0"
contin: SHORT 1 <g> [0]       1
contin.enumStrings: CHAR 2 4 <g> 
  [0][0]  "NO\0\0"
  [1][0]  "YES\0"
fft_length: LONG 1 <g> [0]         1024
start: LONG 1 <g> [0]            1
record_freq: DOUBLE 1 <g> [0]        50.00000000000000
input_data: CHAR 5 <g> 
  [0]  "real\0"
spec_type: SHORT 1 <g> [0]       2
spec_type.enumStrings: CHAR 5 5 <g> 
  [0][0]  "NONE\0"
  [1][0]  "PWR\0\0"
  [2][0]  "DB\0\0\0"
  [3][0]  "REAL\0"
  [4][0]  "CPLX\0"
freq_format: SHORT 1 <g> [0]       2
freq_format.enumStrings: CHAR 7 10 <g> 
  [0][0]  "NONE\0\0\0\0\0\0"
  [1][0]  "SYM_CTR\0\0\0"
  [2][0]  "SYM_EDGE\0\0"
  [3][0]  "ASYM_CTR\0\0"
  [4][0]  "ASYM_EDGE\0"
  [5][0]  "ARB_VAR\0\0\0"
  [6][0]  "ARB_FIXED\0"
num_freqs: LONG 1 <g> [0]          513
start_time: DOUBLE 1 <g> [0]      0.02000000000000000
FeaSubtype: SHORT <g>      7
FeaSubtype.enumStrings: CHAR 10 10 <g> 
  [0][0]  "NONE\0\0\0\0\0\0"
  [1][0]  "FEA_VQ\0\0\0\0"
  [2][0]  "FEA_ANA\0\0\0"
  [3][0]  "FEA_STAT\0\0"
  [4][0]  "FEA_QHIST\0"
  [5][0]  "FEA_DST\0\0\0"
  [6][0]  "FEA_2KB\0\0\0"
  [7][0]  "FEA_SPEC\0\0"
  [8][0]  "FEA_SD\0\0\0\0"
  [9][0]  "FEA_FILT\0\0"
recordFreq: DOUBLE <g>       50.00000000000000
startTime: DOUBLE 1 <g> [0]      0.02000000000000000
[Record 0]
  [tot_power]       43.409103
  [re_spec_val]
    [0]      -26.922068     -26.994484     -27.335205     -28.275818
    [4]      -30.333157     -34.413139     -42.110420     -39.965374
    [8]      -33.916939     -28.669580     -23.653427     -19.709940
    [12]      -17.097502     -15.850389     -15.976560     -16.899763
    [16]      -15.694704     -11.981340     -8.8004532     -6.8244085
    [20]      -5.9337029     -5.9187155     -6.4767542     -7.1900973
    [24]      -7.8193917     -8.6995411     -10.624735     -14.952946
    [28]      -24.401424     -16.108700     -10.752917     -8.3429451
    [32]      -7.4493856     -7.4935293     -8.0797548     -8.9010658
    [36]      -9.8618746     -11.154464     -13.150620     -16.351587
    [40]      -21.684610     -30.133316     -26.109676     -22.106560
    [44]      -20.702250     -20.728342     -21.719841     -23.436161
    [48]      -25.783178     -28.913795     -31.840403     -29.059319
    [52]      -24.677389     -21.786530     -20.227604     -19.723593
    [56]      -20.041994     -20.880682     -21.779671     -22.355835
    [60]      -22.814533     -23.858526     -26.336786     -31.107243
    [64]      -31.345491     -25.977415     -23.096304     -22.247663
    [68]      -23.098173     -25.449322     -27.587177     -26.395741
    [72]      -24.807426     -25.071962     -28.105797     -36.729778
    [76]      -31.416159     -25.190575     -22.516350     -21.554031
    [80]      -21.653179     -22.533230     -24.221107     -27.191568
    [84]      -33.024632     -44.932125     -32.778465     -28.438211
    [88]      -26.910830     -27.041222     -28.577301     -31.725107
    [92]      -37.452499     -43.992802     -37.542271     -33.765610
    [96]      -31.999271     -31.274372     -31.283567     -32.189545
    [100]      -34.702259     -40.813423     -41.646626     -33.671932
    [104]      -29.912109     -28.292120     -28.162910     -29.326014
    [108]      -31.771671     -35.583794     -40.613014     -44.098709
    [112]      -42.078087     -38.825241     -36.385548     -35.091629
    [116]      -35.067814     -36.476807     -39.113628     -38.943657
    [120]      -34.751060     -31.371632     -29.358353     -28.523392
    [124]      -28.818497     -30.395367     -33.717148     -39.128891
    [128]      -38.018303     -33.150990     -30.399401     -29.112841
    [132]      -28.963737     -29.989004     -32.461330     -35.864838
    [136]      -34.778679     -31.174013     -29.117001     -28.614925
    [140]      -29.337486     -30.650509     -31.139378     -30.203854
    [144]      -29.136194     -28.792391     -29.318987     -30.553085
    [148]      -31.998777     -32.958115     -33.337528     -33.370090
    [152]      -32.436985     -30.347347     -28.297436     -27.140047
    [156]      -27.195162     -28.755835     -32.591320     -41.656017
    [160]      -38.037514     -31.453764     -28.402576     -26.783907
    [164]      -25.919127     -25.570532     -25.729792     -26.500393
    [168]      -27.992115     -30.124557     -32.023483     -32.031178
    [172]      -30.621752     -29.240700     -28.344995     -28.127651
    [176]      -28.965149     -31.694717     -39.493980     -40.971867
    [180]      -31.193501     -27.685581     -26.702862     -27.796425
    [184]      -31.654501     -40.162292     -32.959389     -27.633123
    [188]      -25.269377     -24.516850     -24.863283     -25.946487
    [192]      -27.246683     -27.993767     -27.737894     -26.846224
    [196]      -25.900928     -25.269032     -25.141359     -25.605078
    [200]      -26.669739     -28.254452     -30.132729     -31.887827
    [204]      -33.069519     -33.502422     -33.222095     -32.281284
    [208]      -30.857285     -29.278355     -27.885103     -26.956045
    [212]      -26.713814     -27.358545     -29.099497     -32.069283
    [216]      -35.280685     -35.249958     -33.351620     -31.814199
    [220]      -30.375322     -28.987244     -28.210217     -28.631624
    [224]      -30.906281     -36.549156     -40.407524     -32.731869
    [228]      -29.238995     -27.794256     -27.145596     -26.337055
    [232]      -25.137779     -24.076262     -23.647284     -24.120102
    [236]      -25.760351     -29.189266     -36.776012     -38.674625
    [240]      -29.892550     -26.011745     -24.022711     -23.199419
    [244]      -23.334532     -24.449741     -26.776413     -30.859007
    [248]      -36.157524     -33.413567     -29.350536     -27.143604
    [252]      -26.059738     -25.658039     -25.807169     -26.676777
    [256]      -28.742050     -32.817059     -35.944172     -30.625608
    [260]      -26.738085     -24.751099     -23.931957     -23.695177
    [264]      -23.502804     -23.152113     -22.923956     -23.218348
    [268]      -24.276352     -26.035597     -27.513433     -26.864151
    [272]      -24.850212     -23.131998     -22.125916     -21.776783
    [276]      -21.881191     -22.079384     -21.946180     -21.381903
    [280]      -20.740969     -20.441025     -20.726048     -21.644815
    [284]      -22.910761     -23.633673     -23.106405     -22.011005
    [288]      -21.117113     -20.529989     -20.063728     -19.617430
    [292]      -19.293758     -19.232138     -19.431316     -19.739132
    [296]      -20.014860     -20.303232     -20.745003     -21.297140
    [300]      -21.580275     -21.201254     -20.295225     -19.273230
    [304]      -18.371431     -17.679289     -17.275143     -17.249985
    [308]      -17.649054     -18.364365     -18.986900     -18.927343
    [312]      -18.150425     -17.269148     -16.808552     -17.017141
    [316]      -17.998741     -19.712667     -21.561413     -21.865988
    [320]      -20.335598     -18.649071     -17.554222     -17.095972
    [324]      -17.113407     -17.307014     -17.306511     -16.966274
    [328]      -16.522224     -16.295132     -16.425314     -16.838915
    [332]      -17.318321     -17.677862     -17.935856     -18.212065
    [336]      -18.451586     -18.341391     -17.667412     -16.686630
    [340]      -15.843650     -15.424912     -15.539435     -16.150887
    [344]      -17.000143     -17.526773     -17.320435     -16.757048
    [348]      -16.498344     -16.929071     -18.129642     -19.637186
    [352]      -19.962793     -18.602829     -17.136980     -16.482363
    [356]      -16.843794     -18.222401     -20.248667     -21.315186
    [360]      -20.186407     -18.610735     -17.732592     -17.669119
    [364]      -18.298910     -19.440802     -20.778214     -21.646467
    [368]      -21.314690     -20.078363     -18.817461     -17.988394
    [372]      -17.647371     -17.642603     -17.722261     -17.690310
    [376]      -17.557156     -17.484423     -17.615450     -17.994778
    [380]      -18.552956     -19.074528     -19.237043     -18.927252
    [384]      -18.477062     -18.354187     -18.838831     -19.898237
    [388]      -20.940630     -20.958096     -20.066387     -19.281431
    [392]      -19.072165     -19.352642     -19.728476     -19.796537
    [396]      -19.552425     -19.282019     -19.150713     -19.130316
    [400]      -19.162041     -19.277927     -19.551367     -19.972633
    [404]      -20.410112     -20.717884     -20.872715     -20.924341
    [408]      -20.851013     -20.603342     -20.287056     -20.162193
    [412]      -20.461496     -21.249510     -22.308332     -23.083406
    [416]      -23.155113     -22.806738     -22.456249     -22.121052
    [420]      -21.644375     -21.112925     -20.870415     -21.250233
    [424]      -22.456509     -24.482845     -26.624680     -27.140303
    [428]      -26.184673     -25.481462     -25.652340     -26.729271
    [432]      -28.556574     -30.537739     -31.190258     -30.105612
    [436]      -28.870399     -28.438190     -28.938604     -29.596071
    [440]      -28.483419     -25.909220     -23.712582     -22.471966
    [444]      -22.213263     -22.880348     -24.403061     -26.656603
    [448]      -29.373970     -32.002861     -33.335175     -32.187927
    [452]      -29.814222     -27.697649     -26.225056     -25.412796
    [456]      -25.269699     -25.887754     -27.425034     -29.834639
    [460]      -31.447195     -29.896544     -27.772736     -26.801678
    [464]      -27.196650     -29.049505     -32.524937     -36.494774
    [468]      -35.673706     -33.098763     -31.563793     -30.641005
    [472]      -29.862463     -29.150387     -28.621983     -28.316673
    [476]      -28.141001     -27.973761     -27.811068     -27.808212
    [480]      -28.187115     -29.120222     -30.587765     -32.037754
    [484]      -32.367538     -31.628799     -30.962961     -30.857847
    [488]      -31.114470     -31.294788     -31.354284     -31.804796
    [492]      -33.158062     -35.263733     -35.957176     -34.184029
    [496]      -32.668495     -32.465946     -33.536983     -35.096180
    [500]      -35.071568     -33.342419     -31.821297     -31.127939
    [504]      -31.206631     -31.862120     -32.824303     -33.761826
    [508]      -34.456043     -35.004093     -35.643021     -36.351894
    [512]      -36.698658
  [Tag]            1
  [frame_len]          320
[Record 1]
  [tot_power]       14.051488
  [re_spec_val]
    [0]      -40.291603     -40.539703     -38.274853     -34.088116
    [4]      -31.087385     -29.558273     -29.369522     -30.626987
    [8]      -34.109306     -44.734791     -38.526268     -30.804615
    [12]      -27.780218     -26.941725     -24.351988     -18.372059
    [16]      -13.287376     -9.8356686     -7.8692245     -7.3609753
    [20]      -8.5545712     -12.406262     -25.361338     -17.095243
    [24]      -10.792893     -8.9750586     -9.6620531     -12.961390
    [28]      -20.498642     -19.223804     -13.662517     -11.640924
    [32]      -11.436491     -12.299413     -13.681431     -15.058939
    [36]      -16.137339     -17.162642     -18.860746     -22.415060
    [40]      -31.634026     -30.304026     -22.601807     -20.076357
    [44]      -19.887449     -21.504320     -25.063227     -31.883217
    [48]      -46.204453     -31.651468     -26.522463     -23.604294
    [52]      -21.928503     -21.288137     -21.648268     -23.065266
    [56]      -25.662918     -29.171963     -30.314360     -27.650698
    [60]      -25.292582     -24.104393     -24.042185     -25.155769
    [64]      -27.699762     -31.985405     -34.170509     -30.110012
    [68]      -26.918039     -25.132069     -24.325390     -24.298697
    [72]      -24.998060     -26.386271     -28.160757     -29.262646
    [76]      -28.779413     -27.664478     -26.905298     -26.679510
    [80]      -26.847090     -27.287672     -28.100811     -29.665524
    [84]      -32.729599     -39.472034     -48.021221     -36.043217
    [88]      -32.191181     -30.751104     -30.458111     -30.378004
    [92]      -29.803629     -28.879515     -28.144667     -27.844660
    [96]      -27.943764     -28.301821     -28.808977     -29.475046
    [100]      -30.444017     -31.928486     -34.050133     -36.367779
    [104]      -37.351738     -36.718182     -36.013210     -35.793175
    [108]      -35.941986     -36.500175     -37.918091     -41.071842
    [112]      -47.257816     -44.115002     -37.797161     -34.305218
    [116]      -32.523758     -32.089569     -32.943237     -35.158974
    [120]      -38.814945     -43.419872     -46.021778     -43.568092
    [124]      -39.351154     -36.094418     -34.230080     -33.645103
    [128]      -34.175434     -35.619934     -37.570824     -39.269760
    [132]      -40.352383     -41.339443     -41.057846     -37.579208
    [136]      -33.789280     -31.152220     -29.652328     -29.092651
    [140]      -29.295641     -30.113955     -31.345583     -32.414783
    [144]      -32.320038     -31.118832     -29.922895     -29.347284
    [148]      -29.514132     -30.401564     -32.023003     -34.583057
    [152]      -38.767891     -45.923073     -43.369747     -37.756512
    [156]      -35.013016     -33.935772     -34.043983     -35.086308
    [160]      -36.841625     -39.016357     -41.121319     -42.523094
    [164]      -43.240379     -43.971630     -44.626278     -44.413601
    [168]      -44.195839     -45.501625     -46.528519     -41.894264
    [172]      -37.320583     -34.226765     -32.006577     -30.283506
    [176]      -29.032707     -28.404749     -28.546064     -29.562288
    [180]      -31.594063     -35.055111     -41.637909     -52.723942
    [184]      -39.869091     -35.742493     -34.290394     -34.265350
    [188]      -34.705124     -34.659042     -34.285049     -34.450916
    [192]      -35.622490     -37.869236     -41.055569     -43.616852
    [196]      -40.456928     -35.790268     -32.567406     -30.741112
    [200]      -30.102303     -30.503397     -31.814291     -33.837826
    [204]      -36.188251     -38.266472     -39.627506     -40.403084
    [208]      -41.089733     -42.087875     -43.429329     -44.997543
    [212]      -47.570618     -53.759865     -48.943512     -41.315285
    [216]      -37.103081     -34.670464     -33.425236     -33.122917
    [220]      -33.698032     -35.198765     -37.570305     -39.503258
    [224]      -38.433792     -36.279644     -35.096722     -35.276257
    [228]      -37.063118     -40.942272     -44.582386     -40.992733
    [232]      -38.488285     -38.869148     -43.271339     -54.281807
    [236]      -40.599873     -36.191349     -34.987129     -35.981472
    [240]      -39.086792     -44.337147     -48.542965     -47.388737
    [244]      -44.810627     -42.029079     -40.357597     -40.180714
    [248]      -41.335274     -43.564934     -47.077545     -53.036118
    [252]      -50.792805     -44.256897     -40.238083     -37.545143
    [256]      -35.870083     -35.334110     -36.258583     -39.365505
    [260]      -46.596172     -43.834267     -37.281754     -34.010345
    [264]      -32.355408     -31.774174     -32.113251     -33.401485
    [268]      -35.756165     -39.225052     -43.431980     -48.633797
    [272]      -56.611790     -43.365219     -37.284454     -34.275925
    [276]      -33.260036     -33.900475     -35.872417     -37.809395
    [280]      -37.864273     -37.750938     -39.481541     -43.932175
    [284]      -45.316563     -41.002617     -39.448494     -40.979057
    [288]      -48.048843     -49.926380     -39.048584     -34.502769
    [292]      -31.871595     -30.237293     -29.265676     -28.844116
    [296]      -28.972511     -29.696085     -31.010647     -32.616028
    [300]      -33.509144     -32.792606     -31.211012     -29.699427
    [304]      -28.614759     -28.126957     -28.388514     -29.537628
    [308]      -31.654598     -34.598766     -37.522232     -38.578758
    [312]      -36.944847     -34.267685     -32.169914     -31.225498
    [316]      -31.535799     -32.969925     -34.868179     -35.851097
    [320]      -35.552906     -34.492851     -32.644432     -30.615015
    [324]      -29.227144     -28.843826     -29.586514     -31.573748
    [328]      -35.102119     -41.156647     -57.330956     -47.554615
    [332]      -41.587662     -38.451939     -36.156841     -34.476055
    [336]      -33.519180     -33.376419     -33.932629     -34.471272
    [340]      -33.776939     -32.122227     -30.776340     -30.346348
    [344]      -31.051216     -33.132088     -37.135479     -44.159443
    [348]      -46.024784     -42.083424     -41.145222     -40.493279
    [352]      -37.667152     -34.554737     -32.445869     -31.354876
    [356]      -31.132414     -31.747696     -33.383774     -36.514561
    [360]      -41.550484     -42.603333     -39.157173     -38.048222
    [364]      -39.448990     -43.690582     -53.209728     -57.848812
    [368]      -45.914482     -39.052700     -34.478958     -31.606853
    [372]      -30.013155     -29.389254     -29.481930     -30.056458
    [376]      -30.886272     -31.749050     -32.433418     -32.847591
    [380]      -33.187611     -33.879536     -35.347019     -37.697060
    [384]      -39.439846     -38.134888     -36.175140     -35.428543
    [388]      -36.283653     -39.341297     -46.934410     -44.979576
    [392]      -37.743057     -34.343166     -32.692444     -32.074455
    [396]      -32.064449     -32.269264     -32.320107     -32.045185
    [400]      -31.585108     -31.241869     -31.282526     -31.890076
    [404]      -33.206894     -35.377823     -38.301876     -39.811451
    [408]      -37.542648     -34.916439     -33.399010     -32.969303
    [412]      -33.409740     -34.358929     -35.251961     -35.615238
    [416]      -35.461994     -34.982742     -34.220207     -33.238548
    [420]      -32.247257     -31.474350     -31.027666     -30.855215
    [424]      -30.806217     -30.803692     -30.969902     -31.511164
    [428]      -32.486599     -33.604675     -34.229595     -34.056068
    [432]      -33.510803     -33.075924     -32.999958     -33.421490
    [436]      -34.314438     -35.094078     -34.618252     -33.048969
    [440]      -31.604473     -30.857267     -30.890293     -31.633907
    [444]      -32.949413     -34.627476     -36.412163     -38.098591
    [448]      -39.583115     -40.738224     -41.344971     -41.343761
    [452]      -41.000336     -40.603752     -40.189915     -39.639946
    [456]      -38.948772     -38.206581     -37.383644     -36.439037
    [460]      -35.589138     -35.205570     -35.567745     -36.790821
    [464]      -38.788872     -41.103931     -42.892181     -43.884926
    [468]      -44.767456     -46.147655     -48.341103     -51.620174
    [472]      -56.323715     -61.927837     -59.793262     -54.519180
    [476]      -50.999947     -48.869904     -47.688313     -47.212143
    [480]      -47.598278     -49.417625     -51.834793     -47.721363
    [484]      -42.455238     -38.993473     -36.886570     -35.764790
    [488]      -35.390045     -35.582218     -36.163670     -36.899841
    [492]      -37.489758     -37.740295     -37.775547     -37.889755
    [496]      -38.250935     -38.801102     -39.351200     -39.811142
    [500]      -40.313019     -41.037827     -41.985001     -42.870346
    [504]      -43.215210     -42.728340     -41.596764     -40.246910
    [508]      -39.014793     -38.061848     -37.422020     -37.066120
    [512]      -36.953411
  [Tag]          161
  [frame_len]          320
[Record 2]
  [tot_power]       39.703846
  [re_spec_val]
    [0]      -27.462112     -26.968479     -26.249205     -26.275637
    [4]      -27.432537     -29.726006     -32.587635     -34.872402
    [8]      -37.196213     -39.404488     -32.803020     -26.530163
    [12]      -22.451225     -20.118811     -19.573496     -21.583805
    [16]      -29.771076     -22.232025     -14.192757     -9.7378283
    [20]      -6.9218359     -5.1509023     -4.1934876     -3.9877717
    [24]      -4.5965729     -6.2205129     -9.2637587     -13.956860
    [28]      -14.512388     -10.423508     -8.0279160     -7.2749090
    [32]      -7.8352604     -9.6039553     -12.678557     -17.491081
    [36]      -23.901573     -22.035294     -18.442553     -17.510269
    [40]      -19.208773     -25.014139     -30.443558     -22.261829
    [44]      -20.292093     -22.291298     -27.777357     -23.484493
    [48]      -19.224838     -18.173311     -19.126789     -19.928064
    [52]      -18.501902     -17.185589     -17.607899     -20.220610
    [56]      -24.139641     -23.112270     -20.725510     -20.013397
    [60]      -19.208145     -17.140493     -15.345977     -14.817753
    [64]      -15.664150     -17.529995     -19.218567     -19.542759
    [68]      -19.231766     -18.883224     -18.441784     -18.231478
    [72]      -18.626499     -19.249861     -19.043833     -18.176933
    [76]      -17.853136     -18.597366     -20.058239     -20.950630
    [80]      -20.856888     -21.154516     -22.417971     -23.105427
    [84]      -21.701387     -20.369883     -20.438778     -21.823812
    [88]      -23.152098     -22.853760     -22.499666     -23.472454
    [92]      -24.616476     -22.958246     -20.596348     -19.495125
    [96]      -19.625988     -20.497139     -21.584419     -22.701611
    [100]      -23.598310     -23.437748     -22.510550     -22.094419
    [104]      -22.575577     -23.162172     -22.589478     -21.285110
    [108]      -20.310362     -20.000162     -20.453089     -21.878960
    [112]      -24.455063     -26.789898     -25.520571     -23.535757
    [116]      -23.133471     -24.618767     -27.919046     -29.388561
    [120]      -26.134560     -23.713575     -22.946569     -23.637459
    [124]      -25.688959     -28.370434     -28.463375     -26.151987
    [128]      -24.373117     -23.420031     -22.916172     -22.716949
    [132]      -23.038548     -24.049110     -25.119238     -24.748886
    [136]      -23.378059     -22.532442     -22.646063     -23.574253
    [140]      -25.096125     -26.991566     -27.825140     -25.930046
    [144]      -23.765566     -22.860693     -22.980864     -22.826107
    [148]      -21.591009     -20.457428     -20.335239     -21.188343
    [152]      -22.213936     -22.483191     -22.292351     -22.045815
    [156]      -21.342779     -20.235853     -19.461010     -19.456158
    [160]      -20.231859     -21.554239     -22.976862     -23.731651
    [164]      -23.265749     -22.293371     -21.842638     -22.330635
    [168]      -23.368734     -23.288580     -21.592213     -20.150379
    [172]      -19.962074     -21.294353     -23.973139     -25.640245
    [176]      -24.176771     -22.970673     -23.299232     -24.975965
    [180]      -27.182184     -28.434395     -28.172791     -27.003588
    [184]      -25.681927     -24.973400     -25.319181     -26.808998
    [188]      -28.886482     -29.591951     -28.415197     -27.438990
    [192]      -27.738237     -30.058352     -37.215878     -40.357197
    [196]      -29.363976     -25.329346     -23.756580     -23.954409
    [200]      -25.990377     -30.838470     -46.084789     -34.785732
    [204]      -29.034523     -26.477211     -25.080666     -24.370522
    [208]      -24.348673     -25.100338     -26.489943     -27.758776
    [212]      -27.906967     -27.379492     -26.966776     -26.300608
    [216]      -24.865244     -23.370815     -22.731552     -23.348162
    [220]      -25.053814     -26.006971     -24.419241     -22.654045
    [224]      -22.007393     -22.365688     -23.096590     -23.445530
    [228]      -23.501516     -24.004595     -25.100374     -25.323250
    [232]      -23.541460     -21.709358     -21.108431     -22.086750
    [236]      -24.860836     -28.470734     -27.685068     -25.367413
    [240]      -24.887796     -26.354465     -29.271696     -29.889849
    [244]      -26.893312     -24.546871     -23.472542     -23.456654
    [248]      -24.370369     -26.248114     -29.352781     -33.832905
    [252]      -34.760292     -30.856932     -28.469465     -28.068239
    [256]      -29.961632     -36.382893     -41.844883     -30.409346
    [260]      -26.450260     -24.810059     -24.250668     -24.109402
    [264]      -24.345747     -25.533461     -28.234116     -29.816059
    [268]      -26.193651     -23.189869     -22.112453     -22.760418
    [272]      -24.681013     -25.675360     -24.125124     -22.984570
    [276]      -23.948290     -28.446959     -32.625095     -24.109070
    [280]      -20.020702     -18.445869     -18.640017     -20.518538
    [284]      -24.287518     -27.734148     -24.979496     -22.410936
    [288]      -21.753111     -22.432219     -23.203169     -22.738464
    [292]      -21.829416     -21.511597     -21.575665     -21.267899
    [296]      -20.699789     -20.802498     -22.322765     -25.610189
    [300]      -27.764193     -24.835585     -22.681437     -22.571926
    [304]      -24.269215     -26.416756     -25.599106     -23.684647
    [308]      -23.214634     -24.644228     -28.291376     -32.203957
    [312]      -28.968369     -25.835686     -24.640131     -24.946264
    [316]      -26.426140     -27.842279     -26.577316     -24.076391
    [320]      -22.604845     -22.740627     -24.883202     -29.038874
    [324]      -27.873714     -23.553604     -21.495832     -21.318224
    [328]      -22.564356     -24.640268     -26.404497     -26.770479
    [332]      -25.840515     -24.454618     -23.320013     -22.501051
    [336]      -21.727812     -21.144341     -21.351368     -22.865891
    [340]      -25.297579     -25.201515     -22.695974     -21.139521
    [344]      -20.855143     -21.317169     -21.953955     -22.759153
    [348]      -24.364241     -27.293167     -29.286022     -26.400248
    [352]      -23.481033     -21.938446     -21.413631     -21.534534
    [356]      -22.036795     -22.705393     -23.158808     -22.898581
    [360]      -22.080603     -21.498434     -21.766771     -23.075035
    [364]      -24.619385     -24.118544     -22.303669     -21.380718
    [368]      -21.874014     -23.341135     -23.872124     -22.575460
    [372]      -21.515545     -21.649883     -22.864172     -24.397045
    [376]      -24.950150     -24.068924     -22.542194     -21.269732
    [380]      -20.888250     -21.802717     -24.188086     -26.681074
    [384]      -25.472567     -23.225418     -22.233503     -22.378325
    [388]      -23.237844     -24.614733     -26.867012     -30.400585
    [392]      -30.726254     -26.457603     -23.621822     -22.519014
    [396]      -22.886642     -24.747068     -28.558773     -34.612789
    [400]      -32.777077     -28.623747     -27.057476     -27.086935
    [404]      -27.312389     -26.342527     -25.021032     -24.678850
    [408]      -25.898268     -29.215584     -35.235310     -35.183552
    [412]      -31.061783     -29.711374     -30.539167     -33.624828
    [416]      -40.273331     -40.572212     -34.021492     -30.786594
    [420]      -29.307835     -29.087465     -30.075975     -32.094143
    [424]      -32.709351     -29.834332     -27.127497     -25.913528
    [428]      -26.248190     -28.101152     -30.858892     -31.272570
    [432]      -28.770161     -26.580837     -25.457964     -25.577078
    [436]      -27.301418     -31.499813     -40.447552     -37.740795
    [440]      -33.002632     -30.918865     -29.147831     -27.670439
    [444]      -27.169737     -27.871107     -29.462547     -30.912443
    [448]      -31.206715     -30.744108     -30.223803     -30.101732
    [452]      -30.851667     -32.779198     -35.062000     -34.647362
    [456]      -32.660667     -31.724861     -32.354633     -34.751534
    [460]      -38.010967     -35.914753     -31.986542     -29.737925
    [464]      -28.991377     -29.527117     -31.327097     -34.653320
    [468]      -40.204605     -43.029896     -37.636017     -34.342720
    [472]      -32.903004     -32.818451     -33.825531     -35.520779
    [476]      -36.942852     -37.112350     -36.560165     -36.323040
    [480]      -36.964939     -38.839024     -42.308872     -47.837990
    [484]      -54.608959     -51.247692     -46.169163     -43.737213
    [488]      -43.973412     -47.403873     -50.669842     -45.651127
    [492]      -43.250435     -43.870373     -46.517616     -45.357231
    [496]      -40.896248     -37.885071     -36.439316     -36.457108
    [500]      -38.094414     -41.743744     -45.656750     -42.411926
    [504]      -39.157753     -38.149731     -39.548939     -45.020214
    [508]      -49.965370     -40.140804     -36.252911     -34.654587
    [512]      -34.231422
  [Tag]          321
  [frame_len]          320
[Record 3]
  [tot_power]       4776.2305
  [re_spec_val]
    [0]      -31.900166     -35.597469     -38.012436     -28.133818
    [4]      -24.932930     -25.770895     -30.336174     -23.580706
    [8]      -17.405722     -14.163078     -12.419683     -10.247049
    [12]      -6.2801003     -2.1591842     0.95958525      2.9641397
    [16]       4.0864701      4.7933969      5.6323118      6.7259231
    [20]       7.7651219      8.5722246      9.2199020      9.7366714
    [24]       9.9366922      9.5910368      8.6629009      7.4414301
    [28]       6.4106879      5.6707463      4.8556142      3.8146911
    [32]       3.0180249      3.4525144      5.3449955      7.6156569
    [36]       9.3903046      10.373621      10.538018      10.021003
    [40]       9.3046103      9.3739138      10.631509      12.205865
    [44]       13.363661      13.907250      13.904621      13.580402
    [48]       13.247723      13.072766      12.854361      12.165539
    [52]       10.553340      7.4732742      2.3853271      1.4337066
    [56]       6.1950130      9.1370192      10.620731      11.156855
    [60]       10.971629      10.076401      8.2410774      4.7886767
    [64]      -2.7017314     -6.3688283      2.9221478      6.4039078
    [68]       7.5925117      7.1630430      5.0994196     0.71288943
    [72]      -8.7025375     -6.1638260    -0.88483113     0.38347608
    [76]     -0.77348107     -4.5407400     -13.803099     -13.921421
    [80]      -7.1067619     -5.2455683     -5.4507637     -6.6692519
    [84]      -7.9402437     -8.9819336     -10.870622     -15.831666
    [88]      -28.953068     -13.652371     -8.7378693     -6.7505364
    [92]      -6.3960304     -6.8585353     -6.6275716     -4.7812977
    [96]      -2.6066334     -1.0867165    -0.41899255    -0.56454813
    [100]      -1.3849539     -2.5400925     -3.3843992     -3.4488962
    [104]      -3.0577288     -2.6920681     -2.4003129     -1.9813324
    [108]      -1.4168212     -1.0032474     -1.1033010     -1.9978653
    [112]      -3.9400513     -7.2687402     -12.282209     -15.726387
    [116]      -13.823494     -13.158286     -15.287064     -21.683233
    [120]      -20.228527     -13.459753     -10.228630     -8.7606554
    [124]      -8.3719873     -8.7653437     -9.8896971     -11.929667
    [128]      -14.857306     -15.342824     -11.702037     -8.6789303
    [132]      -7.1571279     -7.0903406     -8.6004744     -11.925194
    [136]      -14.199938     -10.428835     -7.1925330     -5.7117290
    [140]      -5.6971426     -7.0529709     -9.7633963     -12.770584
    [144]      -12.484808     -10.605721     -9.9075794     -10.534569
    [148]      -11.470411     -10.672142     -8.5830336     -6.9084353
    [152]      -5.9598684     -5.3471684     -4.5364728     -3.4119925
    [156]      -2.3529303     -1.7261021     -1.6472734     -1.9657549
    [160]      -2.2418528     -1.9991707     -1.3156800    -0.71043444
    [164]     -0.57611471     -1.0597919     -2.1153221     -3.4329381
    [168]      -4.3755312     -4.5319505     -4.3053641     -4.2129259
    [172]      -4.3245592     -4.4120445     -4.3644676     -4.4506755
    [176]      -5.1342831     -6.8872399     -10.188337     -13.837771
    [180]      -11.408774     -7.9653554     -6.2972717     -6.1948590
    [184]      -7.5806255     -10.635526     -15.137047     -15.983913
    [188]      -13.401162     -12.472204     -13.559376     -16.800737
    [192]      -21.533844     -19.732094     -15.765707     -13.361170
    [196]      -11.951439     -11.304319     -11.575294     -13.102953
    [200]      -15.767601     -15.598235     -11.841820     -9.1706419
    [204]      -8.2101126     -9.0209627     -12.152749     -18.617697
    [208]      -15.475838     -10.313586     -8.2707605     -8.3270264
    [212]      -10.229139     -13.530493     -14.369429     -11.830982
    [216]      -10.068732     -9.1160221     -7.9339204     -6.3476510
    [220]      -5.1824713     -5.1159191     -6.4912457     -8.6020851
    [224]      -7.0624495     -3.2424006    -0.63337737     0.52176166
    [228]      0.29377761     -1.4847542     -5.4610982     -11.569304
    [232]      -7.4690614     -3.0929310     -1.1711125    -0.81058806
    [236]      -1.5864799     -3.1520030     -4.9309740     -6.1861210
    [240]      -6.8036656     -7.0955396     -6.7469525     -5.4554038
    [244]      -3.9318852     -2.9496186     -2.8364766     -3.7294669
    [248]      -5.7922564     -9.4281111     -15.888184     -21.425739
    [252]      -13.848095     -9.8235703     -7.6790705     -6.6887727
    [256]      -6.6286020     -7.3357191     -8.3075914     -8.3719988
    [260]      -7.1161489     -5.7210207     -5.0506749     -5.3749604
    [264]      -6.7186565     -8.6311722     -9.3791389     -8.1458597
    [268]      -6.8042226     -6.2899313     -6.5288153     -7.0145402
    [272]      -7.1908116     -7.2024007     -7.8428946     -10.027227
    [276]      -14.779210     -14.637940     -8.5072889     -5.0362482
    [280]      -3.4797337     -3.4275198     -4.8881688     -8.2440300
    [284]      -13.342589     -11.625075     -7.3920255     -5.0988302
    [288]      -4.0026283     -3.4756804     -3.1673398     -3.1162269
    [292]      -3.6884403     -5.4119201     -8.7852650     -10.544238
    [296]      -6.0292258     -2.3486621    -0.35793659     0.30245352
    [300]     -0.22929856     -2.0366271     -5.5012846     -11.281466
    [304]      -12.962273     -8.2537518     -5.5780168     -4.2891121
    [308]      -3.7519989     -3.7365415     -4.3137159     -5.7139692
    [312]      -8.0211535     -9.8200159     -8.3314362     -5.9122314
    [316]      -4.5147276     -4.2106514     -4.6303816     -5.1287861
    [320]      -5.2240133     -5.3033514     -6.1794810     -8.5286741
    [324]      -12.388396     -12.587591     -8.9679251     -6.5535588
    [328]      -4.8080015     -2.6874871    -0.24339420      1.8469867
    [332]       3.2123930      3.7703521      3.5663769      2.7774432
    [336]       1.8279012      1.2883956      1.1992958     0.93163598
    [340]     -0.12947012     -2.3128793     -5.1071043     -5.4135313
    [344]      -3.3032019     -1.9190179     -1.8874882     -3.1878555
    [348]      -5.7740068     -9.2996521     -12.253570     -13.830704
    [352]      -16.222939     -17.861568     -13.691937     -10.362906
    [356]      -8.9452877     -8.2544928     -6.4889331     -3.7558906
    [360]      -1.4999725    -0.29522467    -0.25865462     -1.4614967
    [364]      -3.8483336     -5.8689361     -4.4083509     -1.9578862
    [368]     -0.53441191    -0.20856869    -0.75358993     -1.8341271
    [372]      -2.9966710     -3.9948635     -5.2003360     -7.3930459
    [376]      -11.340411     -13.670877     -9.2458391     -5.9985809
    [380]      -4.6237645     -4.7591782     -6.3673282     -9.8032694
    [384]      -15.940516     -17.372629     -11.807235     -8.5015182
    [388]      -6.4136958     -5.0105820     -4.2479343     -4.2977366
    [392]      -5.4790168     -8.4684067     -15.244695     -15.272059
    [396]      -7.7347374     -4.0836611     -2.2987261     -1.7311282
    [400]      -2.1481066     -3.4927919     -5.8363085     -9.3812628
    [404]      -13.936098     -14.687052     -11.003799     -8.0528164
    [408]      -6.1281781     -4.9672818     -4.3972130     -4.2985544
    [412]      -4.5946975     -5.2754164     -6.4244938     -8.2447567
    [416]      -11.126590     -15.741824     -19.225254     -14.171995
    [420]      -9.9894400     -7.3692198     -5.7335529     -4.8179860
    [424]      -4.5464892     -4.9857931     -6.3770638     -9.3436146
    [428]      -16.178953     -22.676741     -10.749308     -6.2799854
    [432]      -4.0524468     -3.1375833     -3.2396531     -4.2835498
    [436]      -6.3555627     -9.8204727     -15.911207     -22.986700
    [440]      -14.453389     -9.7800922     -7.1009097     -5.5510364
    [444]      -4.9015040     -5.1488867     -6.4379659     -9.1348600
    [448]      -14.030314     -18.186735     -12.882725     -9.1851149
    [452]      -7.3339157     -6.6364093     -6.7820225     -7.6681604
    [456]      -9.3701630     -12.148935     -15.776848     -15.337660
    [460]      -11.224826     -8.2047491     -6.4747996     -5.7787809
    [464]      -5.9582477     -6.8961744     -8.3951960     -9.9335327
    [468]      -10.578999     -10.002189     -8.9361277     -7.9834042
    [472]      -7.3168831     -6.9316034     -6.7724032     -6.7616081
    [476]      -6.8015399     -6.7868996     -6.6413431     -6.3652592
    [480]      -6.0478106     -5.8177505     -5.7745829     -5.9466853
    [484]      -6.2805500     -6.6517920     -6.9001756     -6.8879752
    [488]      -6.5564265     -5.9476118     -5.1856441     -4.4344501
    [492]      -3.8589690     -3.6107879     -3.8418634     -4.7447495
    [496]      -6.6402583     -10.205645     -16.363438     -13.714479
    [500]      -7.8636813     -4.5023193     -2.5518684     -1.5146723
    [504]      -1.1493745     -1.3185372     -1.9403057     -2.9825783
    [508]      -4.4849634     -6.6137910     -9.8070307     -15.373437
    [512]      -26.202974
  [Tag]          481
  [frame_len]          320
[Record 4]
  [tot_power]       491629.66
  [re_spec_val]
    [0]      -42.517342     -43.091938     -30.317991     -24.901583
    [4]      -22.845390     -22.975843     -24.161657     -23.009991
    [8]      -20.276096     -16.420177     -7.7909722     0.21940598
    [12]       6.4708643      11.348239      15.130140      17.964209
    [16]       19.910242      20.960768      21.045223      20.039776
    [20]       17.947416      16.164707      17.615551      20.122211
    [24]       21.770990      22.860397      24.322012      26.524853
    [28]       28.859032      30.784964      32.155209      33.001637
    [32]       33.393776      33.373764      32.919655      31.924671
    [36]       30.175959      27.284065      22.465021      15.790195
    [40]       18.922102      22.510992      24.181171      26.099833
    [44]       29.273359      32.553261      35.127052      36.858593
    [48]       37.787117      37.959026      37.394184      36.077591
    [52]       33.947029      30.856131      26.449306      19.590269
    [56]       3.5566559      14.731940      19.485214      21.585443
    [60]       22.831018      24.011587      25.415289      26.794247
    [64]       27.767679      28.102922      27.690950      26.465393
    [68]       24.357420      21.306442      17.472483      14.073513
    [72]       12.824451      12.327196      11.038587      9.0587473
    [76]       8.1054773      9.3802471      11.150656      12.384777
    [80]       12.996586      13.075498      12.696989      11.890480
    [84]       10.623284      8.7860117      6.2000160      2.7545154
    [88]     -0.70364571     -1.4827342    -0.63835061    -0.53863823
    [92]      -1.1345954    -0.79984689      1.3517205      3.7882547
    [96]       5.5699039      6.5505018      6.7526460      6.2063355
    [100]       4.9602089      3.1957729      1.4599308     0.56328005
    [104]      0.56013590     0.78739327     0.87845463     0.79533988
    [108]      0.64618862     0.89691365      2.2442076      4.4060979
    [112]       6.4271836      7.7796416      8.3038158      7.9502273
    [116]       6.6768398      4.4497857      1.4624134    -0.99440545
    [120]      -1.1514105    -0.44150761    -0.40159494     -1.2637957
    [124]      -2.7592824     -4.0641026     -3.8501692     -2.0012832
    [128]      0.33593062      2.4057617      3.9090257      4.7162724
    [132]       4.7387438      3.8600967      1.8733118     -1.5458125
    [136]      -5.6741295     -4.5847101     -1.3223170     0.47222564
    [140]       1.0060480     0.76748103     0.47239569     0.92338789
    [144]       2.1105790      3.3553176      4.2046251      4.5066690
    [148]       4.2226448      3.3353517      1.8310047    -0.24881217
    [152]      -2.5536752     -3.9451606     -3.5727925     -2.5445256
    [156]      -1.8949418     -1.8203187     -2.0358009     -1.8909316
    [160]     -0.93289685     0.43991819      1.5819672      2.1379509
    [164]       1.9501213     0.92293352    -0.95815432     -3.1810198
    [168]      -3.8086979     -2.2684159    -0.60078067     0.37013513
    [172]      0.64600438     0.39626554   -0.056163952   -0.013367668
    [176]       1.2378604      3.3048291      5.2799082      6.6767368
    [180]       7.3120561      7.0717654      5.7935896      3.1925681
    [184]     -0.87361538     -2.5535300     0.86396211      3.4372108
    [188]       4.5431256      4.5292468      3.6886513      2.4034207
    [192]       1.3215287      1.0622730      1.5296010      2.2335310
    [196]       2.8673649      3.2324817      3.0726621      2.0401325
    [200]     -0.23227733     -2.7406592    -0.34396109      3.7324507
    [204]       6.4782753      8.0186424      8.7181854      9.0462236
    [208]       9.6181183      10.755530      12.125537      13.237289
    [212]       13.818110      13.754833      12.987329      11.491258
    [216]       9.5111208      8.4591885      10.001737      12.568908
    [220]       14.736553      16.284620      17.284479      17.841375
    [224]       18.064142      18.058332      17.895731      17.566992
    [228]       16.960545      15.883426      14.075016      11.140799
    [232]       6.2762399     -1.5648528      1.4100813      5.8655815
    [236]       7.6776338      8.0059614      7.2968559      5.6923490
    [240]       3.2511346     0.88746095      1.7334386      4.7017589
    [244]       7.0393119      8.3010530      8.5068035      7.6371913
    [248]       5.6279869      2.8901312      2.2773838      4.7251039
    [252]       6.9386516      8.0882435      8.2478294      7.5181761
    [256]       5.9742999      3.8470054      2.1048927      2.2346990
    [260]       3.5496247      4.5627980      4.7223754      3.8110008
    [264]       1.5378962     -2.3757467     -4.1509752 -0.00023813541
    [268]       3.3001328      5.1459651      5.9513178      5.9574890
    [272]       5.2857084      4.0449171      2.6021113      1.9586718
    [276]       2.7318909      3.8823614      4.3690939      3.7340121
    [280]       1.7365571    -0.87232471     0.35182163      3.9511199
    [284]       6.4935689      7.8354836      8.2101278      7.7832937
    [288]       6.6595478      4.9173894      2.7720106      1.2627175
    [292]       2.0924222      4.2288389      5.9046731      6.5411310
    [296]       5.8781567      3.4517210     -1.6161404     -2.2254288
    [300]       3.6963668      6.9904947      8.4446230      8.5878735
    [304]       7.6362181      5.6903667      2.8992045   -0.010420912
    [308]     -0.64346427      1.6625791      4.3107395      6.1265521
    [312]       6.8149114      6.3038559      5.3213816      6.8274112
    [316]       10.529492      13.661414      15.693601      16.701761
    [320]       16.764574      15.923249      14.297303      12.548192
    [324]       12.297854      13.704316      15.163628      15.918805
    [328]       15.761558      14.485845      11.829148      9.4556541
    [332]       12.699911      16.785013      19.487005      21.072697
    [336]       21.823687      21.929403      21.536196      20.787977
    [340]       19.850353      18.878963      17.898972      16.692511
    [344]       14.791692      11.329322      3.3076811   -0.030214719
    [348]       10.558544      14.655293      16.741592      17.688433
    [352]       17.816628      17.260422      16.047289      14.109404
    [356]       11.287210      7.5264931      4.5106316      5.4296746
    [360]       7.1028829      7.5060601      6.5441585      4.8398643
    [364]       4.9314814      7.5027533      9.8962355      11.303650
    [368]       11.761628      11.373537      10.197846      8.2281275
    [372]       5.3685069      1.5118153     -2.1705878     -1.7726692
    [376]     0.013191368     0.21668822     -2.0413983     -9.7259216
    [380]      -7.7713938     0.74954140      4.6131754      6.5607715
    [384]       7.3479357      7.3277078      6.7094393      5.5698757
    [388]       3.7759833     0.89703232     -3.7927709     -7.6083026
    [392]      -4.0294414     -1.9267582     -2.6937773     -6.0099945
    [396]      -3.2826393      2.5152164      6.0377560      7.9144654
    [400]       8.5847702      8.2768393      7.1472812      5.3652101
    [404]       3.1215355     0.43468890     -3.2147839     -8.4425287
    [408]      -7.9627109     -3.7093768     -2.0971193     -3.2832286
    [412]      -9.4118252     -14.396465     -2.1845920      2.1440635
    [416]       3.9582050      4.1434965      2.9668818     0.61021036
    [420]      -2.2466733     -4.1343646     -5.5469694     -9.3386431
    [424]      -22.500494     -10.054553     -5.1021504     -4.2010274
    [428]      -5.6244550     -4.2018809     0.77598912      4.3619223
    [432]       6.3219609      6.9424434      6.3586135      4.5924587
    [436]       1.6469203     -2.2210755     -6.1729493     -10.400047
    [440]      -14.180128     -8.1419992     -4.1725402     -3.1496954
    [444]      -4.0587788     -2.9805918      1.2757101      4.5644464
    [448]       6.2579627      6.5100360      5.3695464      2.7214060
    [452]      -1.6933472     -7.7274685     -12.516610     -15.361641
    [456]      -10.960818     -5.8373027     -3.8033636     -3.6983457
    [460]      -1.8979124      2.5303071      6.1768999      8.4070148
    [464]       9.3718548      9.1897593      7.8893404      5.4395108
    [468]       1.8711966     -2.2538049     -5.6185918     -8.9495602
    [472]      -15.091468     -15.489645     -11.783752     -12.933324
    [476]      -10.732507     -3.4195585      1.0833786      3.4985561
    [480]       4.3431664      3.7621512      1.6115214     -2.7514646
    [484]      -11.794118     -13.661638     -8.1688995     -7.9594517
    [488]      -10.648298     -10.447470     -5.4971466     -1.6676145
    [492]       1.1090778      3.2492852      4.8441100      5.8396335
    [496]       6.1591382      5.7268424      4.4454122      2.1523745
    [500]      -1.4629651     -7.0298147     -14.513121     -14.277516
    [504]      -12.771951     -14.202496     -18.243921     -23.760921
    [508]      -24.191730     -20.882397     -17.335333     -14.877248
    [512]      -14.034056
  [Tag]          641
  [frame_len]          320
[Record 5]
  [tot_power]       1084330.8
  [re_spec_val]
    [0]      -21.525713     -21.965162     -23.843212     -29.807013
    [4]      -27.663651     -20.850079     -20.801254     -25.090265
    [8]      -14.689626     -12.307059     -19.880241     0.60383618
    [12]       9.3215942      14.872066      18.558022      20.829062
    [16]       21.874149      21.758512      20.456282      17.817898
    [20]       13.383297      5.4073005     -3.1043038      5.8487773
    [24]       8.5449734      8.1526499    -0.19804521      13.893322
    [28]       23.602291      29.631104      33.705807      36.356766
    [32]       37.806160      38.145695      37.386978      35.470684
    [36]       32.244499      27.369461      19.878838      3.6977191
    [40]       10.305953      14.575344      15.051790      10.421996
    [44]       16.059500      26.840393      33.148670      37.303474
    [48]       39.974846      41.440388      41.827175      41.178017
    [52]       39.467789      36.595196      32.361393      26.571623
    [56]       20.615391      18.610542      16.826473      11.376326
    [60]       4.8141541      17.728386      24.376110      28.830652
    [64]       31.850851      33.689709      34.460590      34.201546
    [68]       32.886578      30.413010      26.552177      20.789797
    [72]       11.613603     -5.5735717      2.4038503      1.9978969
    [76]       1.2124753      4.8484221      10.120078      14.502705
    [80]       17.680992      19.744778      20.765924      20.760599
    [84]       19.695078      17.476803      13.914598      8.5994396
    [88]      0.42924243     -16.979635     -12.976466     -11.030719
    [92]      -11.580648     -12.999323     -9.0576792     -1.0359496
    [96]       4.7519088      8.6716824      11.131796      12.332976
    [100]       12.360874      11.218740      8.8192406      4.9142132
    [104]      -1.2080009     -12.733715     -14.464832     -9.3785791
    [108]      -9.4112349     -8.2551432     -1.6446375      4.1605759
    [112]       8.3836756      11.338729      13.198071      14.029988
    [116]       13.838895      12.573400      10.110646      6.2029519
    [120]      0.29758433     -9.4705305     -25.169273     -12.713647
    [124]      -10.014776     -8.8847628     -6.5028539     -1.4691917
    [128]       3.6044719      7.6041121      10.451669      12.200879
    [132]       12.890044      12.521842      11.054054      8.3847437
    [136]       4.3231220     -1.4716315     -9.6501465     -21.872953
    [140]      -29.316982     -23.644247     -14.158179     -5.7085676
    [144]      0.46582991      5.0070701      8.2695427      10.414677
    [148]       11.510016      11.567442      10.550549      8.3644238
    [152]       4.8237853    -0.44013172     -8.4005213     -25.612419
    [156]      -17.958817     -12.943151     -9.7479811     -5.5787654
    [160]     -0.90574914      3.2785563      6.6671572      9.1727018
    [164]       10.744381      11.340948      10.914562      9.3906183
    [168]       6.6421623      2.4433298     -3.6471951     -11.852929
    [172]      -12.218901     -8.6913671     -7.5512872     -7.7481170
    [176]      -3.8006911      2.6760879      7.7242789      11.295513
    [180]       13.623847      14.834254      14.968225      14.000953
    [184]       11.835942      8.2715645      2.8947606     -5.4045739
    [188]      -22.615698     -13.156108     -8.6185684     -4.9408927
    [192]     -0.15904370      4.5925293      8.5559874      11.662324
    [196]       13.921171      15.297877      15.732283      15.148884
    [200]       13.442706      10.434705      5.7166195     -2.0739520
    [204]      -8.3054972    -0.60409135      3.1254261      5.3772807
    [208]       7.3098717      9.8329010      13.334212      17.070141
    [212]       20.206762      22.399323      23.551737      23.618624
    [216]       22.520746      20.088009      15.984351      9.8510771
    [220]       5.2376189      5.6076918      3.2872915     -1.9783083
    [224]       5.9528656      11.407316      14.480207      16.475531
    [228]       18.176945      19.879314      21.335617      22.179453
    [232]       22.189667      21.259937      19.325518      16.330372
    [236]       12.240886      7.1308546      1.4711361     -2.1969342
    [240]     -0.90695673     0.95252991      1.9107808      4.1223502
    [244]       8.4171228      12.395076      15.188045      16.787577
    [248]       17.268517      16.663013      14.952207      12.076715
    [252]       7.9710703      2.6585469     -3.3302109     -5.4016156
    [256]      -2.1970394     0.36823374      2.6702964      6.0586553
    [260]       9.8664322      13.088671      15.437311      16.879923
    [264]       17.405973      16.978352      15.526238      12.951092
    [268]       9.1852484      4.4709749    -0.17816041     -4.2221379
    [272]      -6.2625537     -3.1546633    0.029466400      2.9136510
    [276]       6.4241009      10.111451      13.252604      15.537227
    [280]       16.864340      17.183306      16.436699      14.538498
    [284]       11.372864      6.8481617      1.1219841     -4.1897078
    [288]      -2.8163853      1.2550656      4.2741218      7.1680374
    [292]       10.559065      13.874159      16.543991      18.372643
    [296]       19.309164      19.326731      18.398027      16.504778
    [300]       13.643603      9.6764288      3.3271694     -13.302651
    [304]       4.2879419      9.7289476      12.708217      14.826498
    [308]       16.772297      18.762039      20.668747      22.230118
    [312]       23.201982      23.402882      22.700451      21.006708
    [316]       18.401098      15.703800      14.660571      14.925574
    [320]       15.031279      15.049601      16.117180      18.605373
    [324]       21.536154      24.213430      26.426039      28.107893
    [328]       29.210699      29.684416      29.480368      28.553879
    [332]       26.865547      24.387331      21.131910      17.278429
    [336]       13.535611      10.956090      8.8152027      4.7154636
    [340]      -2.5055773      5.1109619      10.299550      13.730317
    [344]       16.893383      19.729895      21.814827      22.960882
    [348]       23.142359      22.381660      20.713427      18.189188
    [352]       14.903444      11.108752      7.8037639      6.6627183
    [356]       6.3557076      4.1179886     -1.7492139      5.6884866
    [360]       12.364779      16.239109      18.517998      19.615450
    [364]       19.669682      18.689930      16.594482      13.206608
    [368]       8.3269987      3.2384341      3.0782249      4.5302963
    [372]       4.8193879      4.2789264      4.7494273      7.6949358
    [376]       11.112219      13.824805      15.728912      16.862730
    [380]       17.218395      16.743725      15.363210      12.997712
    [384]       9.6113548      5.3750978      1.2001181    -0.49838454
    [388]      0.78407133      2.2603831      3.0734499      4.7023869
    [392]       8.2163668      11.922729      14.794895      16.689585
    [396]       17.624367      17.599501      16.570606      14.429893
    [400]       10.939903      5.4890547     -2.6869822    -0.11974142
    [404]       4.4143548      6.6896877      8.2362719      10.229615
    [408]       12.805295      15.263825      17.160683      18.371613
    [412]       18.861908      18.585468      17.454624      15.311428
    [416]       11.833459      6.1373882     -5.7788320     -1.3112441
    [420]       4.1978092      6.4447908      7.9682655      10.041616
    [424]       12.738861      15.340774      17.386580      18.723494
    [428]       19.298822      19.068789      17.972767      15.929121
    [432]       12.852945      8.7604122      4.1362305     0.13189979
    [436]      -2.7845447     -2.2806728      2.3718314      7.0222735
    [440]       10.849487      13.879323      16.158274      17.716585
    [444]       18.563829      18.686306      18.047802      16.589590
    [448]       14.228332      10.866671      6.5595059      2.6965756
    [452]       2.4393678      3.8526988      4.5930295      4.1013041
    [456]       1.8530270     -1.3723162      3.1538308      8.6935282
    [460]       12.233772      14.317558      15.255196      15.186667
    [464]       14.170648      12.228785      9.3886938      5.7878890
    [468]       1.9566897     -1.0118096     -2.8485043     -4.9491458
    [472]      -9.4698601     -36.319782     -7.6731405    -0.76927572
    [476]       3.2778716      5.8749804      7.3763022      7.8933253
    [480]       7.4557819      6.0541015      3.6567678     0.24911669
    [484]      -3.9937582     -8.0865860     -10.178585     -10.716919
    [488]      -11.371037     -12.589749     -13.973589     -15.313761
    [492]      -16.288475     -13.121839     -8.3673668     -5.1499524
    [496]      -3.5274973     -3.2758608     -4.2298722     -6.2049460
    [500]      -8.8034897     -11.264259     -13.033307     -14.400413
    [504]      -15.795273     -17.464991     -19.646257     -22.396931
    [508]      -25.609947     -29.692966     -32.875042     -30.028580
    [512]      -28.458342
  [Tag]          801
  [frame_len]          320
[Record 6]
  [tot_power]       1350261.8
  [re_spec_val]
    [0]      -38.732601     -21.661850     -17.360546     -18.387320
    [4]      -24.954647     -18.122492     -17.146738     -22.273308
    [8]      -9.7886705     -6.8367734     -19.643801      1.1939168
    [12]       10.333671      15.745864      19.237988      21.388601
    [16]       22.441736      22.477522      21.439365      19.085007
    [20]       14.791121      6.6706944     -5.2950420     0.39653847
    [24]      0.48908725      5.6246839      1.5878583      11.678987
    [28]       23.401567      29.967039      34.231880      36.955399
    [32]       38.446205      38.835125      38.147488      36.311703
    [36]       33.118641      28.077301      19.846357      2.5040989
    [40]       5.4869900      6.4866428      9.7321205     -7.7067261
    [44]       21.452381      30.285118      35.638744      39.075470
    [48]       41.116673      41.979523      41.740398      40.378876
    [52]       37.769855      33.611336      27.153906      15.890590
    [56]       10.986964      13.341152      9.1995754      3.4033782
    [60]       16.946749      24.828024      30.147749      33.819538
    [64]       36.210354      37.493221      37.740757      36.955601
    [68]       35.070225      31.914574      27.108580      19.642355
    [72]       4.3793092      4.8458076      5.8323970    -0.22155528
    [76]      -6.5675645      6.6696582      14.004589      18.744753
    [80]       21.788502      23.542162      24.198259      23.825594
    [84]       22.401665      19.807831      15.779181      9.7807465
    [88]       1.4611570     -1.6817471     -1.8852497     -5.7516332
    [92]      -16.416452     -7.5899200      1.3189387      7.1181622
    [96]       11.193762      13.936570      15.519771      16.019184
    [100]       15.443396      13.733055      10.739831      6.2043805
    [104]   -0.0071592303     -5.8109536     -8.9556446     -14.452528
    [108]      -22.645182     -11.904835    -0.85232246      6.0460553
    [112]       10.594603      13.538914      15.220294      15.793740
    [116]       15.304060      13.705124      10.836943      6.3278890
    [120]     -0.74831825     -12.325400     -11.885565     -11.182239
    [124]      -14.036266     -21.127869     -3.6126950      4.7863913
    [128]       10.153551      13.732467      15.976387      17.086382
    [132]       17.142307      16.141443      13.998356      10.510897
    [136]       5.2897453     -1.9211458     -6.2420573     -6.1644850
    [140]      -7.7380199     -10.728671     -11.182129     -2.0036342
    [144]       4.8803883      9.5086746      12.577541      14.411447
    [148]       15.156473      14.857716      13.482972      10.917003
    [152]       6.9341264      1.2248359     -5.5062699     -8.5449848
    [156]      -9.6264677     -10.898603     -9.5031157     -2.1713369
    [160]       4.5543904      9.3775015      12.693856      14.788800
    [164]       15.810523      15.814229      14.780166      12.607061
    [168]       9.0809946      3.8572242     -2.8343732     -6.5222692
    [172]      -7.7194781     -9.8509045     -13.816128     -5.8060632
    [176]       4.3120780      10.632633      14.855307      17.614248
    [180]       19.190643      19.709791      19.203165      17.623497
    [184]       14.836058      10.624058      5.0840821     0.92772490
    [188]     -0.33209336     -2.7857511     -7.9572630     -9.5559902
    [192]       3.2380047      10.864744      15.956058      19.402800
    [196]       21.581430      22.665720      22.715008      21.697788
    [200]       19.481184      15.791842      10.248740      4.0458856
    [204]       2.4753509      1.6081409      1.1120967      6.2213187
    [208]       13.823417      19.959536      24.425659      27.502996
    [212]       29.400713      30.234982      30.045135      28.794725
    [216]       26.343462      22.351671      15.980804      6.6670671
    [220]       8.5242805      10.042898      9.1189899      8.5429363
    [224]       9.3536158      11.101099      14.505944      18.332047
    [228]       21.303268      23.177160      23.988138      23.762844
    [232]       22.457882      19.922129      15.818166      9.5422239
    [236]       3.1718087      4.1774335      4.2362480      2.4187825
    [240]       1.0046917      2.7993433      7.7960510      12.725140
    [244]       16.411907      18.872196      20.243567      20.606651
    [248]       19.968555      18.255211      15.285166      10.735632
    [252]       4.5728955      1.0038429      1.4559301      1.0455180
    [256]      0.40516624      2.8464174      8.9351397      14.409826
    [260]       18.402140      21.081917      22.624090      23.122271
    [264]       22.593567      20.975578      18.105043      13.723964
    [268]       8.2427244      6.0590672      6.4110017      4.9363265
    [272]      0.29463765     0.39671537      10.051771      16.320984
    [276]       20.630949      23.565504      25.365679      26.136948
    [280]       25.902390      24.612404      22.134497      18.265858
    [284]       13.253840      10.587484      11.423554      11.995786
    [288]       12.513288      14.301365      17.422226      20.760679
    [292]       23.567163      25.595732      26.796944      27.163404
    [296]       26.671432      25.250031      22.738182      18.764383
    [300]       12.240556      1.7001579      9.8859100      14.795650
    [304]       17.805445      20.053720      22.006910      23.923475
    [308]       25.769737      27.309368      28.317316      28.652048
    [312]       28.219616      26.920242      24.591637      20.917368
    [316]       15.252716      7.8748407      8.3608522      9.3196754
    [320]       6.5919318     -2.4144025     -5.4865937      3.3423426
    [324]       9.2417927      14.923967      19.165525      21.934351
    [328]       23.414745      23.703329      22.780161      20.475788
    [332]       16.340155      9.2816715      3.0499322      6.4035516
    [336]       5.8921113     0.70211476     -4.2497344      3.7338958
    [340]       8.0431099      11.545872      14.826188      17.499500
    [344]       19.323824      20.232315      20.186813      19.102856
    [348]       16.789309      12.807089      5.8693662     -13.110086
    [352]      -1.7410159     0.20812534     -1.6477550     -2.5322886
    [356]       1.0576396      6.4400039      11.475439      15.391535
    [360]       18.140581      19.819302      20.494007      20.165840
    [364]       18.750565      16.023428      11.434881      3.3545113
    [368]      -4.1378951      1.4446826      1.7828707    -0.27635106
    [372]      -1.3401449      1.2510773      6.0773683      10.899698
    [376]       14.666787      17.264008      18.773983      19.255886
    [380]       18.701200      17.006248      13.899773      8.7050295
    [384]     -0.18690510     -1.1866399      2.5673592      3.4131584
    [388]       3.9427853      5.9887538      9.7959204      14.014112
    [392]       17.587624      20.212435      21.864368      22.559862
    [396]       22.282402      20.948172      18.355801      14.060122
    [400]       7.1086240     0.94275421      4.0977116      5.2628050
    [404]       5.9901743      8.2354536      12.127227      16.555157
    [408]       20.393248      23.246969      25.080448      25.925529
    [412]       25.789429      24.622065      22.281321      18.453281
    [416]       12.447351      3.8116934      3.6004734      5.7683764
    [420]       7.7251887      10.682922      13.596262      16.284615
    [424]       18.770983      20.818113      22.185932      22.750065
    [428]       22.448690      21.217379      18.936499      15.356620
    [432]       9.9106789      1.2162472     -4.2571812     -1.2574056
    [436]      -1.7874991     -2.3617725    -0.19382618      3.3876989
    [440]       7.4473009      11.106707      13.864003      15.617023
    [444]       16.373981      16.125633      14.795897      12.186785
    [448]       7.8260040     0.32023892     -13.981019     -6.0202398
    [452]      -5.0766206     -5.5160117     -2.9493544     0.22576818
    [456]       3.2181394      6.2665277      8.9835234      10.987350
    [460]       12.134389      12.374901      11.645478      9.8047943
    [464]       6.5378017      1.0463607     -9.5249777     -10.735350
    [468]      -6.6403255     -7.3391795     -9.0303955     -7.4273787
    [472]      -4.0348544    -0.55573910      2.6276953      5.1371861
    [476]       6.7898769      7.5378079      7.3511491      6.1538572
    [480]       3.7700193    -0.18315914     -6.5560322     -14.385893
    [484]      -12.172276     -11.425586     -13.139994     -14.340875
    [488]      -13.073640     -10.791877     -7.8463187     -4.9341135
    [492]      -2.7464907     -1.4759163     -1.1209811     -1.6751517
    [496]      -3.1883402     -5.7935638     -9.7059069     -14.891903
    [500]      -18.860321     -19.397341     -20.394489     -22.703548
    [504]      -24.423979     -22.290752     -17.762487     -13.655867
    [508]      -10.569829     -8.4069004     -6.9935346     -6.1967139
    [512]      -5.9392495
  [Tag]          961
  [frame_len]          320
[Record 7]
  [tot_power]       1493187.0
  [re_spec_val]
    [0]      -34.474277     -28.415926     -25.378811     -28.045982
    [4]      -39.385685     -23.580952     -22.707220     -28.119085
    [8]      -13.511694     -9.8687859     -19.727659   -0.028911904
    [12]       9.7075052      15.728273      19.725403      22.231302
    [16]       23.465977      23.520079      22.420784      20.176607
    [20]       16.838511      12.560205      7.3393993    -0.74868006
    [24]     -0.47605899      6.9613910      7.5337310      6.2594161
    [28]       20.253551      28.041658      33.074303      36.382504
    [32]       38.359135      39.177914      38.903648      37.524487
    [36]       34.949337      30.967030      25.106043      15.989589
    [40]       1.2977103      11.145639      13.907619      9.0556116
    [44]       17.246429      28.463867      34.803925      38.909119
    [48]       41.485363      42.813667      43.009098      42.089790
    [52]       39.988312      36.523571      31.300123      23.377195
    [56]       11.668607      12.194001      12.886516      11.736308
    [60]       10.976006      18.838835      25.671396      30.305145
    [64]       33.404655      35.281052      36.066307      35.800892
    [68]       34.458942      31.939297      28.016428      22.182352
    [72]       12.947525     -7.2167487      2.9581873      4.2290974
    [76]       4.8225756      3.6534629      5.3846788      12.564154
    [80]       17.690332      20.968758      22.897179      23.701246
    [84]       23.458115      22.149008      19.664312      15.768417
    [88]       10.002557      1.5645679     -8.0186348     -8.8682356
    [92]      -4.7317967     -2.9532869     -6.1632237     0.28653216
    [96]       8.5282412      13.449235      16.477549      18.149149
    [100]       18.677687      18.136309      16.515181      13.733149
    [104]       9.6151209      3.8051500     -4.3731995     -12.059054
    [108]      -12.274865     -15.759225     -10.179323     -2.1564107
    [112]       3.5100145      7.8650599      11.111704      13.282379
    [116]       14.408545      14.516794      13.605780      11.621511
    [120]       8.4151011      3.6561379     -3.0618331     -7.0510736
    [124]      -4.4768949     -3.1188905     -3.8143125     -6.3262758
    [128]      0.26960850      7.5714025      12.366115      15.471685
    [132]       17.286232      17.991251      17.660069      16.295174
    [136]       13.836331      10.157419      5.1076961    -0.95840102
    [140]      -4.9099870     -4.5297337     -2.7138500     -1.6102865
    [144]      -1.9424888     0.43765828      6.4375629      11.153085
    [148]       14.229201      15.963509      16.537691      16.029604
    [152]       14.438537      11.682764      7.5658569      1.7704914
    [156]      -4.8470960     -6.4112391     -6.2499852     -7.7108183
    [160]      -10.889473     -4.2764692      4.0977745      9.6510353
    [164]       13.342558      15.638901      16.766266      16.833803
    [168]       15.875961      13.860844      10.679369      6.1766272
    [172]      0.93638325    -0.78351152     0.86556774      2.3470953
    [176]       2.9885933      2.5447061      4.2900634      9.9955530
    [180]       14.835163      18.089891      20.012131      20.786272
    [184]       20.502438      19.181580      16.788471      13.254776
    [188]       8.6671724      4.3568363      3.4032102      4.9559674
    [192]       6.8518009      8.2212381      10.130512      14.376587
    [196]       19.006405      22.539602      24.836720      25.996981
    [200]       26.106514      25.213919      23.330093      20.405439
    [204]       16.262041      10.925121      9.2177935      12.400865
    [208]       14.455509      15.175441      16.287174      20.207632
    [212]       24.875057      28.537683      31.016396      32.398834
    [216]       32.757095      32.120502      30.480286      27.804447
    [220]       24.099361      19.685535      15.872555      13.960047
    [224]       12.912068      11.831790      10.712892      9.1333847
    [228]       5.5133615      5.9314885      13.773458      18.595751
    [232]       21.318579      22.550020      22.552111      21.437300
    [236]       19.244787      16.007269      11.951822      8.0630054
    [240]       5.8191104      5.1236906      5.7091184      6.9662018
    [244]       7.7907410      8.8398790      12.023312      15.915952
    [248]       18.862350      20.607967      21.225796      20.795046
    [252]       19.363955      16.973028      13.781063      10.584668
    [256]       9.1939259      9.6671162      10.450104      10.761690
    [260]       10.164948      10.196267      14.654017      19.627106
    [264]       23.132689      25.284018      26.293034      26.300856
    [268]       25.405590      23.711372      21.443785      19.219891
    [272]       18.045341      18.031155      18.195690      17.814014
    [276]       17.087133      18.535450      22.626802      26.364210
    [280]       28.936983      30.387215      30.818161      30.303265
    [284]       28.894907      26.644953      23.633648      20.065418
    [288]       16.705044      15.177202      15.296401      15.321623
    [292]       14.650462      13.535645      13.226866      15.388055
    [296]       18.624954      21.202755      22.703806      23.110733
    [300]       22.460205      20.793049      18.191198      14.885221
    [304]       11.417089      8.7269707      7.8351922      8.6159935
    [308]       10.080922      11.736641      13.357262      14.899635
    [312]       16.587212      18.473261      20.177036      21.271935
    [316]       21.522934      20.824045      19.109638      16.319418
    [320]       12.481019      8.3687067      6.6057463      7.2260294
    [324]       7.9644432      8.3716125      8.5206165      8.6293983
    [328]       9.7108994      12.413979      15.378368      17.552349
    [332]       18.689310      18.775873      17.820621      15.811709
    [336]       12.731277      8.6800423      4.4490924      2.0813079
    [340]       1.6293637      1.4150100      1.4044242      2.3277349
    [344]       4.2263570      6.8039832      9.6746368      12.231712
    [348]       14.055178      14.993847      15.027031      14.174954
    [352]       12.463956      9.9179525      6.6210575      3.1867242
    [356]       1.6507921      2.5514460      3.9925263      5.3425431
    [360]       6.6944833      8.3876648      10.663073      13.123491
    [364]       15.154058      16.417500      16.800566      16.276495
    [368]       14.843720      12.520832      9.4140215      6.0016351
    [372]       3.6034460      3.1464953      3.7792728      4.8109918
    [376]       5.8136444      6.4271851      7.2193594      9.5644522
    [380]       12.770571      15.374443      16.938538      17.455994
    [384]       16.996250      15.632921      13.436001      10.503922
    [388]       7.2481699      5.2451615      5.8470716      7.6310830
    [392]       9.4650068      11.020786      12.539797      14.699118
    [396]       17.409468      19.824949      21.431545      22.098726
    [400]       21.842922      20.731749      18.861717      16.347889
    [404]       13.390435      10.839952      10.527913      11.968363
    [408]       13.491103      14.946849      16.834862      19.253096
    [412]       21.682350      23.613272      24.795628      25.134417
    [416]       24.595448      23.174158      20.913692      17.973026
    [420]       14.698925      11.515811      8.8374109      7.5901461
    [424]       8.1276407      9.2115154      10.050544      10.446428
    [428]       10.436935      10.478960      11.237571      12.495832
    [432]       13.431243      13.572827      12.787745      11.074603
    [436]       8.4959784      5.2368636      1.9592383     0.33302835
    [440]      0.89096314      2.0467987      3.0942400      4.0726333
    [444]       5.0565739      6.0948944      7.2523956      8.4313440
    [448]       9.3360519      9.6785593      9.2944975      8.1290789
    [452]       6.2094569      3.6423383     0.64047313     -2.3223128
    [456]      -4.2181253     -4.4428473     -3.8428552     -2.8496637
    [460]      -1.2260952     0.91480428      3.1376498      5.0994792
    [464]       6.5750904      7.4112334      7.5169401      6.8569398
    [468]       5.4496756      3.3711874     0.73517543     -2.3711042
    [472]      -5.7356100     -7.9820070     -7.5190253     -6.0883799
    [476]      -4.9271917     -4.0934291     -3.4443948     -2.6444292
    [480]      -1.3630261     0.12834729      1.2300130      1.5702951
    [484]       1.0186850    -0.43780202     -2.7358270     -5.6837168
    [488]      -8.7781267     -11.024822     -11.814849     -11.896803
    [492]      -11.969642     -11.965411     -11.611526     -10.837206
    [496]      -9.5888824     -8.0082455     -6.5936427     -5.7914400
    [500]      -5.8085732     -6.7017131     -8.4595499     -10.973040
    [504]      -13.627196     -14.578614     -13.416507     -12.125648
    [508]      -11.557408     -11.676856     -12.149883     -12.573871
    [512]      -12.726310
  [Tag]         1121
  [frame_len]          320
[Record 8]
  [tot_power]       1533630.5
  [re_spec_val]
    [0]      -17.297583     -20.053551     -22.457561     -20.336872
    [4]      -31.763685     -18.820654     -14.174855     -19.541998
    [8]      -12.932893     -6.6732616     -11.286008     -2.1007555
    [12]       9.2354288      15.470084      19.451603      21.933208
    [16]       23.221132      23.442202      22.604839      20.579485
    [20]       16.977812      10.701244     -2.3816140     -1.5462062
    [24]      -7.1959562      2.3029618      6.7555962     -19.332874
    [28]       17.575462      26.667185      32.221233      35.848942
    [32]       38.076508      39.123875      39.069798      37.893478
    [36]       35.462688      31.454561      25.064960      13.250908
    [40]       6.5201221      11.872677      12.406447      10.878378
    [44]       23.388605      31.773167      37.178455      40.757156
    [48]       42.972527      44.036114      44.035515      42.974327
    [52]       40.772705      37.227226      31.870733      23.378912
    [56]       4.8309879      11.385802      8.9020958     -5.4054317
    [60]       7.5239277      16.319080      22.425247      26.525599
    [64]       29.114637      30.516911      30.913458      30.384460
    [68]       28.929277      26.465712      22.807713      17.620153
    [72]       10.545386      3.9939063      2.0680027     -1.7486112
    [76]      -11.494150     -5.6591754      2.8555677      9.1970015
    [80]       13.975072      17.358318      19.506029      20.529827
    [84]       20.489967      19.395132      17.189981      13.712101
    [88]       8.5499210     0.40726742     -16.345631     -7.2199631
    [92]      -6.7325292     -16.022715     -5.1737313      4.5065584
    [96]       10.237142      14.148465      16.784986      18.353130
    [100]       18.934385      18.539719      17.118139      14.535282
    [104]       10.496717      4.2711859     -7.0447407     -15.245052
    [108]      -9.5603886     -12.062882     -16.641928     -13.681161
    [112]      -5.4683523      1.0538800      5.5740047      8.5178385
    [116]       10.147224      10.574856      9.8017588      7.7174087
    [120]       4.0435739     -1.8766209     -12.113835     -27.031900
    [124]      -22.182684     -25.447750     -25.658808     -20.420044
    [128]      -5.8833165      2.1173379      7.5671387      11.359342
    [132]       13.835758      15.151313      15.365178      14.462806
    [136]       12.344661      8.7693853      3.1534591     -6.4892063
    [140]      -22.665329     -12.072062     -13.181955     -23.287746
    [144]      -10.309850    -0.33277920      5.9263120      10.309208
    [148]       13.334740      15.215576      16.043989      15.842275
    [152]       14.571756      12.115601      8.2175798      2.2750459
    [156]      -7.7533779     -23.586626     -13.601057     -13.625504
    [160]      -13.158222     -7.0303683     0.35544807      6.1040821
    [164]       10.280542      13.131830      14.806179      15.365213
    [168]       14.795700      12.998087      9.7348099      4.4682808
    [172]      -4.2223716     -15.022445     -12.562209     -14.796684
    [176]      -18.418646     -16.946445     -1.6123049      6.2963481
    [180]       11.576482      15.240205      17.660761      18.992672
    [184]       19.283943      18.506393      16.546288      13.146147
    [188]       7.7069583     -1.6516160     -14.122731     -6.6638985
    [192]      -5.4640236     -5.5737233    -0.17642817      8.8119946
    [196]       15.189208      19.596405      22.551170      24.307240
    [200]       24.975332      24.567604      22.992468      19.985277
    [204]       14.841373      4.9951549     0.62096858      5.5784903
    [208]       4.2205477    -0.57016075     -6.5855989      5.0579510
    [212]       15.276631      21.813211      26.251671      29.198528
    [216]       30.923117      31.537516      31.052929      29.383036
    [220]       26.292379      21.194620      12.099771     -1.1873283
    [224]       7.6477151      6.3782430    -0.31750384     -11.996612
    [228]       3.1583691      10.865769      16.119209      19.725155
    [232]       22.073158      23.345760      23.600990      22.811636
    [236]       20.862015      17.483519      12.008771      2.1868787
    [240]      -2.3486125      2.4939802      2.1788018     -1.3118771
    [244]      -6.1017475      3.8605039      10.929958      15.618939
    [248]       18.775171      20.697077      21.489065      21.145947
    [252]       19.552538      16.405272      10.891593    -0.38342026
    [256]      -2.4609799      1.9680332      1.0881068      1.0851915
    [260]       5.5623860      11.439761      16.784367      21.028326
    [264]       24.150433      26.234140      27.336346      27.462151
    [268]       26.554588      24.472132      20.944153      15.615490
    [272]       9.9211226      8.8120832      6.8078480     -2.0006535
    [276]       3.4014583      10.433142      14.746771      18.663031
    [280]       22.140760      24.843742      26.665085      27.594168
    [284]       27.613302      26.656557      24.573309      21.040052
    [288]       15.241276      3.8357990      1.2911252      5.6745048
    [292]       3.9220834     -1.1751195     -2.8930726     0.30240804
    [296]       4.3499765      8.8611612      12.483625      14.919226
    [300]       16.218136      16.402611      15.396112      12.958512
    [304]       8.4534092    -0.21591665     -3.6647241      2.0245099
    [308]       3.0712950      2.3087225      1.4956361      2.3111224
    [312]       5.0730152      8.5208683      11.606860      13.964849
    [316]       15.501433      16.167492      15.888120      14.531253
    [320]       11.858882      7.4111385     0.34683245     -6.3253617
    [324]      -5.8074450     -9.0328093     -14.125999     -12.176886
    [328]      -16.553743     -2.9342287      4.8786392      9.5802984
    [332]       12.567636      14.318185      15.001737      14.637782
    [336]       13.134465      10.254660      5.4421439     -2.9896600
    [340]      -14.545983     -8.0161428     -9.1261730     -14.779435
    [344]      -18.280031     -9.6237574     -2.2314081      3.0391335
    [348]       6.7287273      9.1849174      10.548905      10.825048
    [352]       9.9097967      7.5546327      3.1884568     -4.7474141
    [356]      -11.590757     -7.5076795     -9.1856031     -17.144646
    [360]      -23.784201     -21.703104     -10.023683    -0.97093886
    [364]       4.8898215      8.9764214      11.744470      13.343640
    [368]       13.805243      13.086799      11.066529      7.5310860
    [372]       2.4114773     -2.0347853     -2.6913211     -3.3612776
    [376]      -4.5480890     -6.3584285     -12.497686     -1.1225034
    [380]       7.1824694      12.277150      15.556939      17.481133
    [384]       18.217115      17.785757      16.080812      12.804069
    [388]       7.2072039     -2.7440915     -5.6501946     -4.2615194
    [392]      -9.6453276     -8.5898151      1.6479663      9.0624914
    [396]       14.475562      18.273746      20.749718      22.078342
    [400]       22.332033      21.487633      19.399693      15.689300
    [404]       9.2994337     -3.1997614     0.80636162      2.0129027
    [408]      -3.4653714     -14.303902     -1.5432540     0.72308922
    [412]       3.2831597      8.4946604      12.855638      15.795079
    [416]       17.551737      18.278946      18.005545      16.651119
    [420]       13.998696      9.5472107      1.7877737     -22.454905
    [424]      -5.6905012     -5.7998095     -11.213598     -12.802327
    [428]      -12.107677     -13.577954     -4.3101964      1.6168221
    [432]       5.0277610      6.8593273      7.4601111      6.9208183
    [436]       5.1587143      1.8688792     -3.7914474     -14.565139
    [440]      -13.911540     -10.985223     -12.894613     -18.268106
    [444]      -20.774811     -15.346615     -9.1812172     -4.1861200
    [448]     -0.64517671      1.6553947      2.8855519      3.0961816
    [452]       2.2165937    0.015948609     -4.0708766     -11.505458
    [456]      -15.449115     -10.631587     -9.7971506     -11.171237
    [460]      -12.697745     -12.529894     -11.122628     -8.2031984
    [464]      -4.5257950     -1.4314815     0.69522804      1.8475533
    [468]       2.0369964      1.2072527    -0.80862063     -4.3995676
    [472]      -10.656199     -26.549490     -19.936773     -16.500561
    [476]      -17.439974     -19.584726     -19.355820     -15.420626
    [480]      -10.689005     -6.8251710     -4.0696077     -2.3486056
    [484]      -1.5969765     -1.8212372     -3.1251447     -5.7774553
    [488]      -10.473660     -19.973677     -25.679344     -17.950485
    [492]      -17.197363     -19.170961     -22.494135     -23.831398
    [496]      -20.127108     -15.374663     -11.694111     -9.2631044
    [500]      -7.9784403     -7.7790718     -8.7138777     -11.014714
    [504]      -15.332522     -23.343792     -23.503948     -18.719862
    [508]      -17.596409     -18.708574     -21.551504     -25.452234
    [512]      -27.765512
  [Tag]         1281
  [frame_len]          320
[Record 9]
  [tot_power]       912264.81
  [re_spec_val]
    [0]      -28.111528     -27.131721     -26.212132     -27.246054
    [4]      -27.343576     -23.261312     -23.105837     -30.618519
    [8]      -14.443370     -9.4344559     -13.664506     -4.1019149
    [12]       7.5845051      14.310949      18.741985      21.589762
    [16]       23.147167      23.556871      22.898933      21.238165
    [20]       18.663811      15.288957      10.908117      2.8113070
    [24]       2.0689847      11.138110      13.590652      14.093019
    [28]       21.591135      28.689009      33.485149      36.617813
    [32]       38.450485      39.166470      38.854450      37.547768
    [36]       35.249096      31.968391      27.816460      23.122688
    [40]       18.076670      13.717407      18.791452      25.273727
    [44]       30.374069      34.368488      37.346806      39.350563
    [48]       40.414139      40.562050      39.808968      38.174137
    [52]       35.726086      32.674759      29.415230      26.179642
    [56]       22.539845      17.641449      10.402535    0.097401872
    [60]       5.1834836      10.030828      12.486956      13.885270
    [64]       15.373484      17.033203      18.108690      18.114975
    [68]       16.844248      14.059286      9.1194229    -0.64264053
    [72]      -4.1940494      2.1623914      2.6775570    -0.27754670
    [76]      -10.188839     -6.6896539     0.27181453      1.9746984
    [80]      0.22098994     -5.2891712      1.0283852      7.1278105
    [84]       10.295126      11.673335      11.654627      10.316491
    [88]       7.4902730      2.5465460     -7.1413255     -16.238853
    [92]      -9.1032848     -16.199156     -9.2636385   -0.084543273
    [96]       4.0902357      6.1660919      7.1005902      7.7200260
    [100]       8.6430178      9.6652031      10.158875      9.6934710
    [104]       7.9949841      4.7079039    -0.85636628     -6.7008200
    [108]      -3.5298250     -1.5713208     -2.1916327     -5.6380420
    [112]      -10.354743     -2.8592088      2.5990698      5.7928319
    [116]       7.5629625      8.2298393      7.9427996      6.8295679
    [120]       5.1331539      3.3379006      1.9138701     0.69710171
    [124]     -0.75120741     -2.0448840     -2.1151667     -1.8059922
    [128]      -3.2996826     -10.273179     -5.1519003      3.3810804
    [132]       7.7708464      10.180115      11.222545      11.146506
    [136]       10.107205      8.3380527      6.3356462      4.6764340
    [140]       3.2203488      1.3256806    -0.75914526     -1.3200268
    [144]     -0.99696499     -2.4335227     -6.8555384     -1.7521160
    [148]       4.6722598      8.3081837      10.200768      10.781310
    [152]       10.205365      8.4907188      5.5889740      1.6166888
    [156]      -2.1734154     -3.8721707     -5.1349125     -6.5197763
    [160]      -4.8800945     -2.0286734    -0.46972254    -0.23930657
    [164]    -0.095599577      2.0447669      5.2406254      7.8032546
    [168]       9.3789768      10.017028      9.8058386      8.8185987
    [172]       7.1001601      4.6172805      1.1096314     -4.3094115
    [176]      -14.413679     -13.106229     -9.6821489     -7.1175909
    [180]     -0.71269023      4.4442658      7.7556224      9.6567783
    [184]       10.491219      10.594633      10.393514      10.277955
    [188]       10.238637      9.8494644      8.5693321      5.6973114
    [192]     -0.47860771     -8.7231369    0.037457272      1.9027897
    [196]      0.55162370      5.4294987      11.814217      15.897788
    [200]       18.316883      19.502371      19.710846      19.150751
    [204]       18.051483      16.660276      15.116445      13.260441
    [208]       10.495603      5.3383808     -8.0545120      1.8985583
    [212]       5.1298680      5.1777782      11.943384      18.582510
    [216]       22.966791      25.767704      27.383938      28.036209
    [220]       27.860470      26.947269      25.350006      23.067463
    [224]       20.006268      15.962990      10.915332      6.8133483
    [228]       5.1983228     0.14626488     -3.6098652      9.3783064
    [232]       14.547961      17.259310      18.518717      18.771250
    [236]       18.365065      17.649197      16.835487      15.799295
    [240]       14.166868      11.600828      8.4404554      7.1672263
    [244]       7.9546475      7.4540296      3.2934837     -1.0022402
    [248]       9.4452324      14.617817      17.466579      18.973761
    [252]       19.566662      19.510565      18.994864      18.118896
    [256]       16.849136      15.011850      12.421276      9.7941618
    [260]       10.115170      12.258522      13.276049      12.350668
    [264]       8.9617748      7.9437428      13.732674      17.643181
    [268]       19.762897      20.686607      20.764030      20.228575
    [272]       19.224804      17.782040      15.797490      13.063028
    [276]       9.4846802      6.8200178      8.4139595      10.727061
    [280]       11.584264      10.464688      5.8989434     -10.332188
    [284]       8.2596407      13.661202      16.170837      17.157207
    [288]       17.113806      16.304358      14.874722      12.856736
    [292]       10.231012      7.3722095      5.9791355      6.7083435
    [296]       7.4584656      7.0470290      5.0110168      1.9802281
    [300]       4.3268266      8.9527550      11.946530      13.502989
    [304]       13.899696      13.285925      11.779197      9.6184511
    [308]       7.4066515      5.9495220      5.3083329      5.2223992
    [312]       5.9887910      7.3601627      8.3259830      8.0977774
    [316]       6.1638818      3.5035808      6.2303815      10.309002
    [320]       12.604647      13.328987      12.738951      11.068875
    [324]       8.8914480      7.3378129      6.6518331      5.9331141
    [328]       5.6073737      6.9386606      8.7109394      9.4576464
    [332]       8.8528948      7.6627173      8.4408369      10.899810
    [336]       12.659297      13.139219      12.372919      10.556681
    [340]       8.3676844      7.1698489      7.0916610      6.9403925
    [344]       6.4668870      6.3379250      6.7982206      7.0783587
    [348]       6.5557613      5.6050243      6.1244564      8.3694935
    [352]       10.399302      11.571787      12.063939      12.270559
    [356]       12.487436      12.647564      12.453194      11.701909
    [360]       10.491469      9.3262825      8.6865950      8.2620068
    [364]       7.6824074      7.8256583      9.7442865      12.341321
    [368]       14.628872      16.469145      17.872940      18.760750
    [372]       18.994104      18.427629      16.915878      14.318909
    [376]       10.642984      6.5475597      2.8546627      1.3398764
    [380]       8.0209293      13.552453      16.990883      18.971750
    [384]       19.874512      19.957235      19.446810      18.561741
    [388]       17.459784      16.145630      14.430473      11.929285
    [392]       7.9417129      1.9791985      3.8027644      8.4593039
    [396]       10.804754      11.800192      12.333434      13.143867
    [400]       14.265631      15.203242      15.630467      15.514539
    [404]       14.987062      14.219518      13.299877      12.173223
    [408]       10.696654      8.7153816      6.0849447      2.7260652
    [412]     -0.90342319     -2.8141084     -2.2355804    -0.60232294
    [416]       1.7311392      4.1562967      6.0047550      7.0459409
    [420]       7.3045278      6.9055853      6.0156264      4.7779737
    [424]       3.2094955      1.1277868     -1.8591580     -6.4372783
    [428]      -13.146805     -12.845198     -9.3731947     -8.5792770
    [432]      -9.7532921     -10.801391     -8.3074789     -5.0995502
    [436]      -3.0224316     -1.9959658     -1.7259668     -1.9447497
    [440]      -2.4632995     -3.2216222     -4.2886868     -5.8149877
    [444]      -8.0084705     -11.168144     -15.724337     -21.345421
    [448]      -22.145510     -19.388147     -16.209114     -12.535963
    [452]      -9.2479982     -6.7345114     -4.9704070     -3.8695619
    [456]      -3.3897750     -3.5366511     -4.3439598     -5.8571677
    [460]      -8.1184778     -11.134172     -14.819217     -19.022242
    [464]      -22.701084     -20.436539     -15.940989     -12.891904
    [468]      -11.234624     -10.659454     -10.700485     -10.507945
    [472]      -9.4840765     -8.1827278     -7.3630471     -7.3457789
    [476]      -8.2261333     -10.076125     -13.036783     -17.295197
    [480]      -22.233728     -23.590866     -21.083057     -17.806974
    [484]      -14.862765     -12.856883     -11.879192     -11.681056
    [488]      -11.682681     -11.252007     -10.482954     -10.013635
    [492]      -10.309420     -11.628824     -14.260861     -18.811646
    [496]      -25.840107     -25.207445     -22.193495     -22.517618
    [500]      -25.559612     -25.083477     -20.377529     -17.701372
    [504]      -16.934448     -17.599255     -19.023119     -19.928951
    [508]      -19.889973     -20.205975     -22.045855     -26.756081
    [512]      -36.029671
  [Tag]         1441
  [frame_len]          320
[Record 10]
  [tot_power]       335562.31
  [re_spec_val]
    [0]      -29.704170     -26.336548     -26.594696     -31.733458
    [4]      -21.059246     -17.300995     -19.910547     -24.529875
    [8]      -12.808474     -11.534965     -18.180401     0.81114143
    [12]       8.9838810      14.168580      17.606012      19.728170
    [16]       20.705395      20.564157      19.201729      16.343235
    [20]       11.423190      3.5347683     -3.2092016     0.32906425
    [24]       3.7761889     -1.4217355      12.740348      22.907986
    [28]       29.131924      33.283817      35.975163      37.471760
    [32]       37.890427      37.256901      35.515709      32.504417
    [36]       27.863167      20.737480      8.7974939      4.0699162
    [40]       3.6337550      6.2645416      6.8301334      4.9590740
    [44]       17.252068      24.051786      28.147837      30.588261
    [48]       31.767017      31.846115      30.871576      28.806215
    [52]       25.524055      20.770327      14.104166      5.4235592
    [56]      -1.5381345     -10.315745    -0.11457780      7.0057983
    [60]       11.458767      14.697318      16.942720      18.206766
    [64]       18.494764      17.813856      16.164047      13.556015
    [68]       10.131247      6.5513115      3.9595923      1.9061812
    [72]      -1.3849962     -5.9238710     -4.4120750     -1.7111914
    [76]      -1.5212178     -2.8652272     -1.8324291      1.6314601
    [80]       4.0895696      5.0367289      4.5301852      2.5805027
    [84]     -0.28331667     -1.0271045     0.77908224      1.7705661
    [88]       1.0253578     -1.9329702     -9.0093966     -18.925648
    [92]      -8.3306646     -6.7458549     -7.5505447     -4.1829448
    [96]      0.75076604      4.1064515      6.1021566      7.0427041
    [100]       7.0561476      6.1285405      4.1476450      1.0843024
    [104]      -1.8679057     -1.7564795    -0.38528112    0.036344979
    [108]     -0.64035791     -2.0135136     -3.0955958     -2.4841440
    [112]     -0.34846830      2.0456004      4.0277367      5.3662415
    [116]       5.9674387      5.7786894      4.7601829      2.8867290
    [120]      0.21923460     -2.7773399     -4.8258228     -5.4954700
    [124]      -6.0446854     -6.0304441     -3.4064453    0.082815289
    [128]       2.6843324      4.1991091      4.7468204      4.4747210
    [132]       3.5849943      2.4491608      1.5864207      1.1538702
    [136]      0.64060009    -0.64717489     -3.4399955     -9.1150646
    [140]      -11.453173     -4.0530310    0.028014537      2.1476989
    [144]       2.8622477      2.2491302     0.11041791     -3.9255006
    [148]      -7.4668827     -4.5276089     -2.0363274     -1.4700224
    [152]      -2.3927891     -4.2281179     -5.6811676     -5.5896835
    [156]      -4.8708344     -4.4101534     -4.0814023     -3.4212294
    [160]      -2.3554468     -1.3199579    -0.79429632     -1.1163787
    [164]      -2.5316353     -4.9492846     -6.3513737     -4.7132192
    [168]      -3.0183735     -2.5768116     -2.8936505     -2.4872901
    [172]     -0.77079642      1.0894684      2.4892530      3.4966550
    [176]       4.2473826      4.7091928      4.7453527      4.2620902
    [180]       3.3072898      2.1533360      1.2834897     0.98722947
    [184]      0.98737341     0.81100947     0.15688418     -1.0520456
    [188]      -2.3256319     -1.9872005     0.31319022      2.7604115
    [192]       4.5896349      5.8566661      6.8165359      7.6595469
    [196]       8.3645353      8.7544909      8.6474714      7.9135766
    [200]       6.4233351      3.9019940    -0.47062522     -9.7745962
    [204]      -5.8540964     0.89688087      4.3225842      6.6249208
    [208]       8.5655813      10.267150      11.557025      12.303126
    [212]       12.553910      12.555845      12.610085      12.715237
    [216]       12.447255      11.186778      8.0046005    -0.34217888
    [220]      -1.6943514      7.4778261      10.741133      11.928232
    [224]       12.202396      12.590498      13.607036      14.746577
    [228]       15.395509      15.311705      14.477703      12.998297
    [232]       11.094603      9.0436430      6.9293456      4.4413810
    [236]      0.91690016     -5.2233515     -18.022972     -4.2619696
    [240]       1.0393125      3.7925446      5.2534037      5.9913616
    [244]       6.4597139      6.9540687      7.4802899      7.8463664
    [248]       7.8303242      7.2203364      5.7857633      3.2416434
    [252]     -0.81188554     -6.9775558     -12.592297     -7.2532802
    [256]      -2.0977376      1.3424554      3.4217393      4.5572681
    [260]       5.2476120      5.8519034      6.3266702      6.4317689
    [264]       6.1045165      5.5289855      4.8591700      3.8727674
    [268]       2.0468419     -1.2022309     -6.1912713     -8.2141867
    [272]      -4.1552291    -0.69397998      1.5512309      2.4847579
    [276]       1.9240975   -0.086421818     -1.4258653     0.85199630
    [280]       3.3392053      4.5885301      4.9186597      4.8519559
    [284]       4.6345901      4.0423384      2.7718308      1.0499949
    [288]      0.15959790     0.95670420      2.4677517      3.9611640
    [292]       5.0379786      5.2321725      4.0521235     0.83117545
    [296]      -5.5502391     -8.2768469     -5.5730476     -8.5038490
    [300]      -5.5174594      2.6062112      6.9709210      9.2955599
    [304]       10.347259      10.605327      10.502566      10.403043
    [308]       10.429628      10.425363      10.110129      9.1779327
    [312]       7.2545977      3.8194427    0.045929529      3.6297107
    [316]       8.3125277      11.501907      13.671861      15.115709
    [320]       15.982880      16.381723      16.433689      16.290934
    [324]       16.114006      16.009781      15.968968      15.860966
    [328]       15.483417      14.613609      13.077269      11.193885
    [332]       11.196303      14.060004      17.058867      19.182480
    [336]       20.406118      20.819839      20.508801      19.573833
    [340]       18.214296      16.899431      16.352661      16.737829
    [344]       17.358248      17.593702      17.272343      16.695484
    [348]       16.688698      17.742197      19.197823      20.341591
    [352]       20.930012      20.958460      20.496040      19.609531
    [356]       18.300709      16.483528      14.154831      12.100350
    [360]       11.946834      12.841989      12.917186      11.337591
    [364]       7.1276326     -3.1165159      3.1962280      8.8012934
    [368]       11.403515      13.142888      14.868133      16.666855
    [372]       18.264290      19.407974      19.927916      19.677322
    [376]       18.474047      16.024733      11.791395      5.7865844
    [380]       6.4306235      9.5602264      10.520200      9.9938831
    [384]       8.6803598      7.2278666      5.9003067      4.4118237
    [388]       2.3190982     -1.0182923     -7.2416310     -8.7611513
    [392]      -2.0482824     0.53988659    0.091874011     -3.8721526
    [396]      -5.9954319      1.0729234      4.8891397      6.4981318
    [400]       6.6472788      5.7038560      3.9362812      1.6866598
    [404]     -0.37250519     -1.3171464     -1.2523189     -1.2238834
    [408]      -1.7709402     -2.5533540     -2.4266441     -1.1038705
    [412]      0.26300487     0.91999477     0.71590155    -0.10522518
    [416]     -0.72886980    -0.30624098     0.67393339      1.3131874
    [420]       1.2722069     0.50577754     -1.0314438     -3.5280454
    [424]      -7.2637506     -10.754843     -8.4492264     -4.6602526
    [428]      -1.9086266    -0.16041388     0.60456467     0.36940327
    [432]     -0.77002311     -2.2956150     -3.0421515     -2.6026556
    [436]      -1.9661983     -1.7793655     -2.1541297     -3.0632794
    [440]      -4.4139113     -5.8730245     -6.7732320     -6.7706795
    [444]      -6.3686919     -6.1750207     -6.4579854     -7.0822034
    [448]      -7.3006611     -6.3837557     -4.9042549     -3.7023776
    [452]      -3.0324066     -2.8517618     -3.0933053     -3.7559862
    [456]      -4.8573909     -6.3101854     -7.8328838     -9.0954866
    [460]      -10.057425     -10.877313     -11.490650     -11.584822
    [464]      -11.025825     -10.060596     -9.0211124     -8.1006680
    [468]      -7.3626304     -6.8119321     -6.4506779     -6.3146157
    [472]      -6.5055556     -7.2193165     -8.7761316     -11.741855
    [476]      -17.537426     -26.814404     -17.746758     -13.717267
    [480]      -12.001378     -11.108198     -10.293361     -9.4129324
    [484]      -8.6952343     -8.3325129     -8.3776159     -8.8062649
    [488]      -9.5376329     -10.396744     -11.185616     -12.003739
    [492]      -13.446761     -16.611113     -24.725994     -26.059668
    [496]      -17.249475     -14.289174     -13.691633     -14.526061
    [500]      -15.692390     -15.701411     -14.931025     -14.767129
    [504]      -15.805610     -18.132475     -20.581802     -19.879175
    [508]      -17.838053     -17.064093     -18.101349     -21.357124
    [512]      -24.958597
  [Tag]         1601
  [frame_len]          320
[Record 11]
  [tot_power]       111463.84
  [re_spec_val]
    [0]      -27.655268     -29.712299     -31.814138     -32.070557
    [4]      -30.883217     -24.269556     -24.200863     -26.999681
    [8]      -16.924807     -16.002190     -11.103511      1.0279567
    [12]       8.1936474      12.871325      15.888300      17.605978
    [16]       18.217794      17.844170      16.561363      14.370051
    [20]       11.046070      5.6600132     -6.2796516     -3.6532276
    [24]       1.3442534      9.1040478      17.335905      23.314621
    [28]       27.584763      30.546883      32.412128      33.287659
    [32]       33.216419      32.190842      30.150267      26.961878
    [36]       22.383305      16.115108      9.5016890      7.5051665
    [40]       5.8341069      3.9026947      8.2125683      13.291285
    [44]       17.129921      20.010107      22.072996      23.350985
    [48]       23.837814      23.505337      22.295784      20.097179
    [52]       16.686476      11.577888      3.6949220     -1.8111207
    [56]       1.5537452      2.3120389      2.4883616      4.2573867
    [60]       6.9873309      9.5506525      11.706254      13.445137
    [64]       14.723886      15.455443      15.543672      14.900715
    [68]       13.445384      11.094457      7.7589455      3.3728335
    [72]      -1.9351182     -7.2848330     -10.999674     -12.286355
    [76]      -11.131541     -9.1592236     -7.4727454     -6.0424066
    [80]      -4.6497507     -3.3376708     -2.3243880     -1.7804742
    [84]      -1.7783042     -2.3368983     -3.4593260     -5.1374197
    [88]      -7.2941322     -9.4716558     -10.065461     -8.0135565
    [92]      -5.1271963     -2.6868505    -0.98530030   -0.041827921
    [96]      0.21434826   -0.046919871    -0.51315600    -0.81901121
    [100]     -0.85885787    -0.88291526     -1.1894581     -1.9232639
    [104]      -3.0945380     -4.6465178     -6.4885931     -8.4485464
    [108]      -10.184924     -11.362202     -12.028976     -12.335818
    [112]      -12.108456     -11.254971     -10.056032     -8.7400780
    [116]      -7.3707209     -6.0445976     -4.9060316     -4.0397258
    [120]      -3.4403419     -3.0593991     -2.8635271     -2.8615584
    [124]      -3.0968616     -3.6348560     -4.5707784     -6.0582089
    [128]      -8.3539829     -11.891338     -17.135174     -19.841473
    [132]      -16.382475     -13.914751     -12.277562     -10.543804
    [136]      -8.6492910     -7.0530114     -6.0706477     -5.8063788
    [140]      -6.2635651     -7.3805537     -8.9807453     -10.683101
    [144]      -12.004136     -12.737925     -12.793132     -11.861689
    [148]      -10.209032     -8.6596518     -7.7264700     -7.5548244
    [152]      -8.1268244     -9.3556004     -11.120802     -13.311428
    [156]      -15.896209     -18.965984     -22.569698     -26.200724
    [160]      -30.454493     -43.947014     -22.442339     -14.757525
    [164]      -9.9886408     -6.8039680     -4.6860213     -3.3208537
    [168]      -2.4611273     -1.9126068     -1.5788064     -1.4880977
    [172]      -1.7504897     -2.4856372     -3.7812705     -5.6828303
    [176]      -8.1632252     -10.881901     -12.505899     -12.000957
    [180]      -11.044859     -11.168578     -13.300097     -20.000021
    [184]      -25.147757     -13.286202     -8.9678717     -6.8787723
    [188]      -5.9854841     -5.7992091     -5.9751096     -6.3033829
    [192]      -6.8113322     -7.7782688     -9.6740427     -13.259150
    [196]      -19.650383     -19.143600     -14.012154     -11.382419
    [200]      -9.5708160     -7.5878835     -5.6215816     -4.2612314
    [204]      -3.8592393     -4.6499858     -6.9996133     -11.550146
    [208]      -14.577824     -9.9121437     -6.8733349     -5.5774765
    [212]      -4.9170828     -3.8496063     -2.4077604     -1.5189160
    [216]      -1.9830332     -4.7845855     -14.113848     -10.533781
    [220]      -2.3600962     0.96417606      2.2925007      2.3703420
    [224]       1.5283209    -0.12458777     -2.7583466     -6.8998137
    [228]      -12.244043     -10.799721     -7.0015211     -4.5213251
    [232]      -2.6575668     -1.1855869    -0.21428467     0.17720489
    [236]    0.0094485627    -0.66661268     -1.8502843     -3.6574728
    [240]      -6.3957911     -10.642162     -15.340800     -12.701544
    [244]      -9.5167150     -8.4882355     -9.2107124     -11.033430
    [248]      -11.852245     -10.317321     -8.5080233     -7.2630072
    [252]      -6.3761225     -5.6381273     -5.0489006     -4.6699777
    [256]      -4.5025816     -4.5322137     -4.8248439     -5.5405130
    [260]      -6.8728142     -9.0133352     -12.173432     -16.101152
    [264]      -15.715516     -10.799558     -6.7499638     -3.8990264
    [268]      -2.0379746     -1.0453799    -0.87004668     -1.5036407
    [272]      -2.9334168     -4.9788361     -6.8826618     -7.5624814
    [276]      -7.4790807     -7.8602228     -9.2091084     -11.258912
    [280]      -12.381807     -11.243852     -9.4689655     -8.1130209
    [284]      -7.3018184     -7.1363754     -7.9334192     -10.028444
    [288]      -11.026865     -6.5477571     -2.0772913     0.92236012
    [292]       2.7398431      3.6151435      3.6931114      3.0523713
    [296]       1.6918089    -0.54270142     -4.1451864     -10.460851
    [300]      -14.335922     -7.6523447     -4.2406268     -2.5059896
    [304]      -1.3004466     0.10070295      1.7587495      3.2253962
    [308]       4.0862727      4.1000972      3.0984576     0.87558925
    [312]      -2.9720938     -9.6717978     -30.992264     -13.823153
    [316]      -8.5842676     -5.7670889     -4.0840173     -3.3426392
    [320]      -3.2143922     -2.6549687    -0.76042795      1.5039016
    [324]       2.9832542      3.1546423      1.5460285     -3.0507660
    [328]      -18.789005     -7.7311063     -4.3715200     -7.7111278
    [332]      -9.8313656    -0.65885830      2.8465927      2.9935803
    [336]     0.054791544     0.46358877      6.8313756      11.025203
    [340]       13.563371      15.045738      15.732938      15.652690
    [344]       14.631229      12.235596      7.3871775     -2.1802437
    [348]       3.8124700      7.7273345      7.9670520      5.4125237
    [352]       1.5833164      4.2533727      7.6304135      9.0122824
    [356]       9.0136719      8.1813831      6.9259276      5.5575867
    [360]       4.6930380      5.2954044      6.9360199      8.3597164
    [364]       8.9955559      8.7036591      7.4534502      5.2588553
    [368]       2.2498169     -1.1095270     -3.3708971     -2.4866273
    [372]     -0.19200654      1.2033184     0.96000111     -1.4475552
    [376]      -4.8982983    -0.22861275      4.8221292      7.7614207
    [380]       9.1186628      9.0829296      7.5500116      3.9684145
    [384]      -3.5016429     -2.6559780      4.3119721      7.9682121
    [388]       10.036299      10.942263      10.699539      9.0920353
    [392]       5.4846153     -2.6148939     -7.9424462     0.78725284
    [396]       2.2488437    -0.29650134     -3.5777407      3.8489690
    [400]       8.7734518      11.397079      12.533078      12.508009
    [404]       11.437258      9.3033972      5.9519153      1.0386615
    [408]      -5.6464353     -8.4224901     -4.7956586     -1.3323798
    [412]       1.3326471      3.0195546      3.9774485      5.0623603
    [416]       7.1167660      9.7240877      12.072771      13.834797
    [420]       14.962219      15.473421      15.380319      14.666690
    [424]       13.277987      11.113835      8.0510778      4.2313933
    [428]       1.3826774      1.3809787      1.6393125     0.35568801
    [432]      -3.3425915     -8.1289339     -2.7415266      1.7018807
    [436]       3.9415889      4.7557321      4.5554013      3.8505051
    [440]       3.6600192      4.7390785      6.3916640      7.7984891
    [444]       8.7243109      9.1943913      9.2838182      9.0510616
    [448]       8.5196228      7.6668458      6.4046440      4.5582409
    [452]       1.8760920     -1.6686550     -3.8843098     -2.1494820
    [456]    -0.034553420      1.0951482      1.3751965     0.94410783
    [460]     -0.29210442     -2.7121921     -7.0945148     -13.504962
    [464]      -10.942532     -7.3810654     -5.9869094     -5.4392667
    [468]      -5.0284657     -4.9256406     -5.5380688     -6.7401977
    [472]      -7.5802727     -7.5733495     -7.8579779     -9.5820904
    [476]      -13.544310     -16.537563     -11.222696     -7.1406088
    [480]      -5.0064054     -4.5941072     -6.3180013     -12.194818
    [484]      -15.949483     -5.9089303     -1.7486188     0.15073767
    [488]      0.75398451     0.50287259    -0.37008262     -1.8078105
    [492]      -3.8072982     -5.9389620     -7.0025954     -7.1044364
    [496]      -8.1058693     -11.975344     -20.819416     -10.278419
    [500]      -4.8340883     -2.2102520     -1.1701201     -1.3182882
    [504]      -2.5582774     -5.0387697     -9.4257755     -18.817015
    [508]      -18.022629     -10.360009     -7.0815306     -5.5161009
    [512]      -5.0412641
  [Tag]         1761
  [frame_len]          320
[Record 12]
  [tot_power]       20134.035
  [re_spec_val]
    [0]      -25.188923     -26.725954     -33.282852     -38.565269
    [4]      -26.927855     -23.317345     -22.191141     -20.900173
    [8]      -17.869598     -14.621251     -9.6447868     -3.0783584
    [12]       2.6309230      6.9869976      10.123214      12.184002
    [16]       13.249511      13.330770      12.354804      10.105870
    [20]       6.0182967     -1.8705326     -15.476500     -4.8658500
    [24]      -4.7346239      2.5037415      9.7928734      14.447046
    [28]       17.350506      18.940321      19.442350      19.028807
    [32]       17.932230      16.511236      15.076814      13.520103
    [36]       11.391828      8.3948250      4.9064994      1.9868758
    [40]     -0.98678249     -6.2636013     -8.5872173     -5.7326322
    [44]      -8.3253555     -8.3355865     0.90250212      5.3345389
    [48]       7.1616030      7.0361509      4.9388261    0.075987473
    [52]      -11.010015     -6.6394134     -2.7282245     -3.0807095
    [56]      -6.5208254     -15.187784     -19.761053     -9.5634441
    [60]      -5.6356211     -3.3213277     -1.5020721     0.37696451
    [64]       2.1502149      3.3286231      3.5900903      2.7720451
    [68]      0.72690082     -2.8280687     -8.6697121     -20.585499
    [72]      -22.211178     -16.595335     -16.586212     -19.091280
    [76]      -23.485983     -27.640173     -28.232975     -29.034756
    [80]      -32.309669     -40.814182     -36.189178     -28.070915
    [84]      -24.070795     -22.282124     -22.209272     -23.716286
    [88]      -27.068741     -34.652546     -36.778759     -25.905678
    [92]      -21.152203     -18.709215     -17.850634     -18.351887
    [96]      -20.209343     -23.792040     -31.211302     -34.803272
    [100]      -24.436871     -19.797583     -17.177048     -15.696052
    [104]      -14.912695     -14.555558     -14.570165     -15.123951
    [108]      -16.500965     -19.037308     -23.144226     -28.578285
    [112]      -29.046329     -25.612520     -22.939545     -20.991415
    [116]      -19.725607     -19.138781     -19.146610     -19.643682
    [120]      -20.612711     -22.205626     -24.790771     -29.125210
    [124]      -36.281132     -34.051659     -28.429136     -24.511148
    [128]      -21.032177     -17.975254     -15.617481     -14.093307
    [132]      -13.427230     -13.605924     -14.607291     -16.407618
    [136]      -18.995094     -22.430666     -26.991402     -33.026711
    [140]      -36.316738     -34.629044     -34.968632     -34.586388
    [144]      -28.980951     -24.148468     -21.024561     -19.274857
    [148]      -18.760378     -19.558058     -22.048664     -27.439135
    [152]      -35.779243     -27.888510     -24.191324     -23.129229
    [156]      -23.486900     -24.471058     -24.947355     -23.781086
    [160]      -21.565834     -19.610495     -18.527172     -18.512712
    [164]      -19.656973     -21.955698     -24.623823     -24.743111
    [168]      -22.380199     -20.040310     -18.152903     -16.612780
    [172]      -15.408945     -14.645662     -14.454545     -14.910657
    [176]      -15.982052     -17.573900     -19.760563     -22.468031
    [180]      -21.742870     -17.306120     -13.973794     -12.193869
    [184]      -11.729156     -12.395799     -14.020123     -16.268217
    [188]      -18.295582     -18.872507     -17.999720     -16.683401
    [192]      -15.572543     -15.098348     -15.801208     -18.701324
    [196]      -26.675701     -21.393114     -14.775216     -11.892919
    [200]      -11.107430     -12.023427     -14.681520     -19.462700
    [204]      -26.886595     -32.751808     -32.418591     -27.363174
    [208]      -22.737103     -20.049345     -17.868746     -14.940266
    [212]      -11.714025     -9.0420218     -7.2007318     -6.1646805
    [216]      -5.7908101     -5.8722906     -6.2417583     -6.9421196
    [220]      -8.2759638     -10.717525     -14.915177     -20.875776
    [224]      -20.639957     -17.889780     -17.211340     -17.657007
    [228]      -17.748312     -15.898474     -12.299906     -8.4879293
    [232]      -5.3079224     -2.9781120     -1.5165703    -0.89131725
    [236]      -1.0366747     -1.8115751     -2.9557815     -4.2059574
    [240]      -5.6393709     -7.7773967     -11.219416     -14.670653
    [244]      -12.656295     -9.4355011     -7.3478894     -6.1101208
    [248]      -5.5846930     -5.8311391     -6.9147363     -8.7483168
    [252]      -10.951257     -13.031392     -14.874385     -15.361081
    [256]      -12.922824     -10.126533     -8.5557775     -8.3951035
    [260]      -9.6241112     -11.986809     -13.511442     -11.468974
    [264]      -8.4908600     -6.3190498     -5.2255974     -5.3528886
    [268]      -6.8980246     -9.9223518     -12.501362     -11.359953
    [272]      -10.229268     -11.203323     -15.192145     -27.890924
    [276]      -21.360077     -15.556623     -14.327765     -15.606492
    [280]      -19.527250     -26.617771     -23.917963     -20.597485
    [284]      -21.126719     -25.607679     -24.736570     -18.624483
    [288]      -16.270235     -17.045654     -17.890358     -11.539254
    [292]      -6.1249528     -2.7051511    -0.65666533     0.43865746
    [296]      0.89977431     0.96606523     0.71551603   0.0090329666
    [300]      -1.4745150     -4.2560344     -9.0858202     -10.978252
    [304]      -5.6125011     -2.2157197    -0.72543812    -0.82492524
    [308]      -2.6752722     -7.1931343     -18.319817     -12.122143
    [312]      -6.9636054     -4.2468891    -0.96962184      2.6073339
    [316]       5.4615040      7.2960682      8.0835037      7.7959113
    [320]       6.3775930      4.0140977      2.2769279      2.9512818
    [324]       3.8516448      3.2784996     0.61661130     -5.0627122
    [328]      -10.338622     -4.4383831      1.0855988      6.3176203
    [332]       10.603424      13.723133      15.740133      16.719419
    [336]       16.671415      15.544463      13.200190      9.2887239
    [340]       2.7122808     -1.2536727      6.4959617      11.018435
    [344]       13.586905      14.740423      14.618472      13.170758
    [348]       10.117037      4.7583704     -1.0836053      2.5385327
    [352]       5.0379071      5.4059100      4.4322634      2.6078546
    [356]      0.33865559     -2.0288754     -4.4322901     -7.6327949
    [360]      -13.345902     -10.143357     -3.4644620     0.13371257
    [364]       1.8100817      1.9798014     0.67168850     -2.4499450
    [368]      -7.9570584     -8.4369755     -3.4497788    -0.69181395
    [372]      0.60427278      1.3401628      2.3855245      3.9390814
    [376]       5.4174814      6.3397927      6.5613875      6.0933437
    [380]       5.0960364      4.5514636      6.3037572      9.3009672
    [384]       11.669523      12.906911      12.957743      11.897633
    [388]       10.259214      9.6412067      10.575764      11.385123
    [392]       11.185417      10.001222      8.5433588      7.8133025
    [396]       7.1186056      4.2211499     -1.1892110      7.8983250
    [400]       13.741537      16.863455      18.261820      18.255375
    [404]       16.920570      14.347754      11.637499      11.709200
    [408]       13.364034      14.287956      14.133533      12.936046
    [412]       10.688528      7.2712727      3.3800163      6.1762328
    [416]       11.559331      15.124101      17.012129      17.384438
    [420]       16.194036      13.124037      7.4156671      1.5355227
    [424]       3.9958913      3.6752725     -2.4200633     -9.5784569
    [428]       2.0171506      5.0679317      6.0615921      7.4089446
    [432]       9.9673424      12.576386      14.436028      15.315400
    [436]       15.095222      13.600738      10.611474      7.0673227
    [440]       7.8823810      10.518456      11.761081      11.610578
    [444]       10.333428      8.2578878      5.9787183      4.2276020
    [448]       3.3387787      3.5725338      4.6540952      5.3409872
    [452]       4.5643120      1.1516479     -9.4855890     -2.8965838
    [456]       3.0432432      4.4279757      2.3423440     -8.0376968
    [460]      0.24913031      8.1422215      11.972451      14.027623
    [464]       14.942334      15.003128      14.414096      13.421144
    [468]       12.350412      11.422603      10.462959      8.9732304
    [472]       6.3533401      1.8801314     -2.5588844      1.3880594
    [476]       5.1499538      7.3610311      8.6587620      9.3005419
    [480]       9.3166742      8.6821756      7.5183969      6.4210806
    [484]       6.2946796      6.8986320      7.1477323      6.3938956
    [488]       4.3622909      1.1025282     -1.9208177     -2.7403448
    [492]      -4.2197752     -11.261498     -11.402614     -1.1402488
    [496]       2.9642024      4.8193650      5.2243733      4.4235635
    [500]       2.4213693     -1.0019761     -6.4927320     -15.090675
    [504]      -14.599740     -11.557185     -11.857083     -15.338301
    [508]      -18.322508     -11.021948     -6.3662157     -3.9965518
    [512]      -3.2604709
  [Tag]         1921
  [frame_len]          320
[Record 13]
  [tot_power]       93491.352
  [re_spec_val]
    [0]      -32.765663     -33.252666     -34.665539     -35.789814
    [4]      -33.557446     -31.157343     -31.328131     -30.909929
    [8]      -26.071842     -22.737349     -18.880005     -12.523516
    [12]      -7.0127878     -3.1812537    -0.86701089    0.061453704
    [16]     -0.36793283     -2.0855596     -4.1457491     -4.0618467
    [20]      -2.8130741     -2.8040538     -4.6823592     -7.9092999
    [24]      -9.2563171     -7.6802158     -2.1022434      4.1684976
    [28]       8.7962160      11.919547      13.835897      14.747914
    [32]       14.791356      14.066720      12.655639      10.617648
    [36]       7.9627943      4.6125436     0.39985663     -4.7196393
    [40]      -9.6043940     -11.609094     -10.321710     -6.0612955
    [44]      -1.3389133      2.5620513      5.4878192      7.4667683
    [48]       8.5287104      8.6791315      7.8879972      6.0724373
    [52]       3.0583591     -1.5243927     -8.6247654     -21.439428
    [56]      -19.605497     -16.989731     -16.420225     -14.450300
    [60]      -10.742857     -6.8379049     -3.6856830     -1.5200931
    [64]     -0.35431862    -0.18694185     -1.0632418     -3.1101656
    [68]      -6.6039128     -12.175751     -21.696138     -34.141945
    [72]      -32.470840     -37.201668     -23.945492     -19.905966
    [76]      -18.985666     -20.184767     -23.397367     -28.973965
    [80]      -32.330772     -27.529673     -23.882872     -21.613113
    [84]      -20.496796     -20.537785     -21.732758     -23.837320
    [88]      -25.981710     -27.545692     -30.096050     -35.120010
    [92]      -29.931206     -24.228933     -21.276602     -19.968290
    [96]      -19.705416     -20.020792     -20.480078     -20.774094
    [100]      -20.811728     -20.711451     -20.772236     -21.406919
    [104]      -23.121092     -26.767138     -34.591515     -33.126095
    [108]      -26.764969     -24.051867     -23.016684     -22.829578
    [112]      -22.940636     -22.997150     -22.912741     -22.806229
    [116]      -22.858116     -23.213917     -23.960173     -25.107824
    [120]      -26.226561     -25.717400     -23.253042     -20.805542
    [124]      -19.311855     -18.904736     -19.476448     -20.524500
    [128]      -20.682425     -19.127068     -17.044689     -15.362730
    [132]      -14.310665     -13.921266     -14.186604     -15.060723
    [136]      -16.433220     -18.131334     -20.023863     -22.191828
    [140]      -24.883917     -27.720654     -28.065727     -26.038712
    [144]      -24.650204     -24.775120     -26.798740     -31.756828
    [148]      -43.535233     -38.216511     -35.957710     -33.850262
    [152]      -27.188400     -22.353100     -19.400620     -17.709724
    [156]      -16.847361     -16.493696     -16.445116     -16.665640
    [160]      -17.304428     -18.674648     -21.303108     -26.384485
    [164]      -40.631531     -31.753334     -26.215048     -23.903101
    [168]      -22.185997     -20.406685     -18.847483     -17.803114
    [172]      -17.313625     -17.209366     -17.040878     -16.176884
    [176]      -14.521535     -12.641835     -11.011066     -9.8112907
    [180]      -9.1013432     -8.9291391     -9.3634367     -10.488391
    [184]      -12.383886     -15.091555     -18.533443     -22.316742
    [188]      -25.311178     -25.352367     -22.067297     -17.976616
    [192]      -14.534339     -12.130926     -10.868628     -10.814294
    [196]      -12.041458     -14.285403     -15.232169     -13.053626
    [200]      -10.775861     -9.5626049     -9.3435831     -9.9300280
    [204]      -11.155888     -12.891048     -15.089807     -17.953102
    [208]      -22.424355     -32.526886     -25.276253     -18.217846
    [212]      -14.541677     -12.472020     -11.459809     -11.238632
    [216]      -11.641153     -12.560328     -13.901283     -15.261067
    [220]      -15.285645     -13.299195     -10.881598     -9.0783129
    [224]      -8.1114054     -8.0105238     -8.8508091     -10.907218
    [228]      -15.047479     -25.771597     -23.095591     -15.697582
    [232]      -13.208512     -12.247672     -11.436506     -10.568854
    [236]      -10.283979     -10.326326     -8.6156416     -5.3523064
    [240]      -2.6557374     -1.0878110    -0.57433295    -0.93184209
    [244]      -1.9158608     -3.2071521     -4.5033970     -5.7323422
    [248]      -7.0827546     -8.4796219     -8.4710321     -6.2345562
    [252]      -3.9139638     -2.7897744     -3.3190005     -6.2885675
    [256]      -14.816597     -10.559201     -3.6588602    -0.71611339
    [260]      0.33074000     0.16637890    -0.79397905     -2.2868657
    [264]      -4.5013065     -8.6166620     -19.465160     -11.874194
    [268]      -5.5900598     -3.1354966     -2.7331839     -4.0000563
    [272]      -6.9486814     -11.039019     -11.458030     -8.6472664
    [276]      -6.6133113     -5.1997485     -3.8674154     -2.4799738
    [280]      -1.1865569    -0.13125892     0.64021105      1.1481792
    [284]       1.4508390      1.6500815      1.9063039      2.4103627
    [288]       3.2824535      4.4687428      5.7538266      6.8713093
    [292]       7.5958886      7.7737117      7.3315930      6.3384619
    [296]       5.2048979      4.7619991      5.2801609      5.9290166
    [300]       5.9114008      4.7349229      1.7413131     -4.7892299
    [304]      -5.4483476      1.7579496      5.3354135      7.1995974
    [308]       8.1359119      8.5695524      8.7806120      8.9361563
    [312]       9.1179914      9.4122429      9.9812431      10.935650
    [316]       12.125770      13.261111      14.178037      14.885430
    [320]       15.426740      15.751287      15.765755      15.552074
    [324]       15.559371      16.279564      17.513857      18.698261
    [328]       19.543364      20.005241      20.070866      19.618078
    [332]       18.353233      15.723026      10.768093      8.7607355
    [336]       14.736276      18.455242      20.540819      21.741650
    [340]       22.473900      22.915890      23.055742      22.822382
    [344]       22.241850      21.542051      21.080385      21.004366
    [348]       21.148540      21.397943      21.816732      22.391464
    [352]       22.916370      23.183271      23.110205      22.692019
    [356]       21.895576      20.609600      18.692812      16.129984
    [360]       13.389771      11.553795      10.686628      9.5754938
    [364]       7.5165029      4.5045772      1.3925611     0.28963828
    [368]       2.2109909      5.3352103      8.0262346      9.7857542
    [372]       10.620143      10.742381      10.529263      10.401405
    [376]       10.514939      10.724006      10.902561      11.057649
    [380]       11.165423      11.036250      10.351225      8.7432241
    [384]       5.9493098      3.3223453      4.8380480      7.4155316
    [388]       8.7411766      9.0304976      9.0118380      9.4988213
    [392]       10.593177      11.748457      12.509483      12.595938
    [396]       11.731587      9.4577150      4.4352350     -13.955800
    [400]       5.5272255      12.356160      16.669992      19.799971
    [404]       22.080519      23.641893      24.557291      24.872515
    [408]       24.611115      23.775442      22.344631      20.254791
    [412]       17.309677      12.878227      6.1017313      10.103740
    [416]       16.022409      19.535183      21.712076      23.016748
    [420]       23.669731      23.761108      23.283709      22.158361
    [424]       20.258114      17.435678      13.708462      10.554667
    [428]       11.087546      13.020220      14.166780      14.203014
    [432]       13.226126      12.702473      15.274384      18.890779
    [436]       21.664026      23.424765      24.282948      24.345161
    [440]       23.719015      22.563116      21.138485      19.788727
    [444]       18.792082      18.253386      18.152662      18.350370
    [448]       18.589037      18.584970      18.069462      16.730124
    [452]       14.040925      8.5798206     -4.7161083      8.1257219
    [456]       13.075040      15.201410      15.893056      15.711105
    [460]       15.221263      15.205667      16.034983      17.179045
    [464]       18.027140      18.328255      18.059494      17.299997
    [468]       16.150732      14.636588      12.626979      9.8673573
    [472]       6.2702169      3.5328293      4.9584889      7.8122897
    [476]       10.189541      11.911164      12.938183      13.241937
    [480]       12.824751      11.729515      10.077704      8.1710911
    [484]       6.5599656      5.6661716      5.2498708      4.8151250
    [488]       4.1562905      3.3835027      2.7099380      2.1349599
    [492]       1.4360124     0.77552724      1.2974702      3.3104217
    [496]       5.3381205      6.4841943      6.5540414      5.6938381
    [500]       4.7277207      5.1449795      6.6516013      7.8609056
    [504]       8.3064728      8.0629044      7.3716326      6.4889159
    [508]       5.5467029      4.5291562      3.4402304      2.4917316
    [512]       2.0950687
  [Tag]         2081
  [frame_len]          320
[Record 14]
  [tot_power]       71994.383
  [re_spec_val]
    [0]      -36.311356     -36.160767     -35.419300     -34.057068
    [4]      -33.016983     -33.306099     -35.735485     -41.711956
    [8]      -59.418503     -50.897491     -39.354977     -28.547747
    [12]      -20.194176     -13.714731     -8.7438107     -5.0260644
    [16]      -2.3659365    -0.60070229     0.41733003     0.82101399
    [20]      0.70504713    0.098511077     -1.0325705     -2.7898409
    [24]      -5.5094395     -9.1807108     -5.5800076     0.98914176
    [28]       5.5779858      8.6749802      10.644266      11.672737
    [32]       11.852873      11.210156      9.6989031      7.1650081
    [36]       3.2283962     -3.1905968     -18.676781     -13.201272
    [40]      -10.241310     -13.589315     -22.770332     -14.298658
    [44]      -11.564690     -11.759197     -7.7385607     -2.3461745
    [48]       1.1649879      3.0417943      3.5729244      2.8735266
    [52]      0.92459023     -2.4251897     -7.4823918     -14.316534
    [56]      -18.951998     -19.780420     -22.096657     -25.893394
    [60]      -32.226685     -27.838915     -18.216654     -12.653415
    [64]      -9.1462288     -7.0816317     -6.2218723     -6.4757342
    [68]      -7.8455348     -10.447209     -14.635674     -21.541225
    [72]      -33.894821     -26.802654     -24.014355     -24.202158
    [76]      -26.083303     -28.598993     -27.972979     -24.162228
    [80]      -20.758980     -18.378794     -16.963907     -16.434280
    [84]      -16.707027     -17.666187     -19.140583     -20.929728
    [88]      -22.942806     -25.456411     -29.516581     -38.633015
    [92]      -33.442699     -26.507875     -23.175924     -21.539190
    [96]      -20.975777     -21.156435     -21.821907     -22.697250
    [100]      -23.464619     -23.827494     -23.680746     -23.191505
    [104]      -22.650122     -22.302994     -22.320654     -22.837030
    [108]      -23.989916     -25.928873     -28.637520     -30.834183
    [112]      -30.021488     -28.039818     -26.834526     -26.574062
    [116]      -26.967958     -27.529783     -27.706131     -27.111883
    [120]      -25.739138     -24.110542     -22.938885     -22.754986
    [124]      -23.957037     -26.724354     -28.291706     -25.064617
    [128]      -22.178923     -20.759905     -20.266741     -19.958570
    [132]      -19.325361     -18.553053     -18.116982     -18.306442
    [136]      -19.233555     -20.907707     -23.137001     -25.206717
    [140]      -26.105766     -25.804892     -24.649359     -22.801323
    [144]      -20.820923     -19.231369     -18.221273     -17.793184
    [148]      -17.890188     -18.403147     -19.051947     -19.288260
    [152]      -18.784302     -18.028566     -17.743654     -18.382370
    [156]      -20.240627     -23.659449     -29.364244     -39.516258
    [160]      -30.822927     -23.158594     -18.302160     -15.115169
    [164]      -13.177437     -12.271763     -12.288759     -13.190831
    [168]      -14.969985     -17.539125     -20.534218     -23.438683
    [172]      -25.750528     -24.043362     -19.588921     -16.174480
    [176]      -14.009580     -12.732395     -11.980268     -11.414968
    [180]      -10.781850     -10.052340     -9.4642630     -9.3567162
    [184]      -10.025831     -11.728036     -14.791093     -19.975691
    [188]      -31.265461     -27.674622     -19.581093     -15.125923
    [192]      -12.066490     -9.9986372     -8.8246984     -8.5612831
    [196]      -9.3093824     -11.259596     -14.669328     -19.091990
    [200]      -20.158653     -18.184971     -16.619865     -15.145668
    [204]      -13.663466     -12.540127     -11.754856     -10.944086
    [208]      -10.060482     -9.5787191     -10.023496     -11.754945
    [212]      -14.800071     -17.222300     -16.412884     -15.696409
    [216]      -16.956768     -20.814892     -27.660673     -29.150827
    [220]      -30.098249     -32.236675     -22.048262     -17.045361
    [224]      -14.608077     -13.252571     -11.830574     -10.157955
    [228]      -8.9540615     -8.7952442     -9.9929142     -12.784069
    [232]      -16.290991     -14.893718     -10.953501     -7.9658718
    [236]      -5.9506464     -4.8550916     -4.7803826     -5.9636545
    [240]      -8.8538742     -12.927432     -10.276900     -5.7297912
    [244]      -3.0634201     -1.8098514     -1.5892614     -2.1028523
    [248]      -3.0052345     -3.9685011     -4.9127545     -5.7527628
    [252]      -5.4655609     -3.3105328    -0.77512848      1.0063212
    [256]       1.7430836      1.3461741    -0.23715647     -2.5149393
    [260]      -2.7197206    -0.20720683      1.9713186      2.9960847
    [264]       2.8375113      1.4006587     -1.6260397     -5.8592439
    [268]      -4.5876470    -0.52226162      1.9239773      3.0528769
    [272]       3.2708187      2.8791578      2.1312671      1.1970662
    [276]     0.056776613     -1.5758824     -4.2542553     -8.6099682
    [280]      -11.350039     -7.9309855     -5.6438360     -4.8295307
    [284]      -4.0484042     -2.4411294    -0.57919633      1.1361481
    [288]       2.8621516      4.6386385      6.1557183      7.0161042
    [292]       6.8630495      5.2574205      1.2636212     -9.2312765
    [296]      -7.7911935     -2.1187744     -2.7556267     -5.2413673
    [300]      0.32509658      4.8576579      7.0926166      7.9383383
    [304]       8.0096207      7.6005535      6.7420688      5.8748393
    [308]       6.2103262      7.4634318      8.1319094      7.6433091
    [312]       6.3174362      5.3599496      5.6868305      6.9436002
    [316]       9.0292063      11.540590      13.816361      15.662230
    [320]       17.194473      18.525438      19.653734      20.534489
    [324]       21.146080      21.455206      21.348900      20.639475
    [328]       19.205149      17.496340      17.222298      18.676922
    [332]       19.984430      20.369484      19.853304      18.693314
    [336]       17.203455      15.543256      13.640236      11.479398
    [340]       9.9541321      11.634255      15.393241      18.564224
    [344]       20.580395      21.466522      21.309748      20.212400
    [348]       18.411453      16.741964      16.890625      18.861061
    [352]       21.023041      22.613783      23.501701      23.808908
    [356]       23.843706      23.927397      24.020617      23.695782
    [360]       22.452259      19.745564      14.457138      3.2738297
    [364]       11.107303      16.008677      18.166359      19.070036
    [368]       19.114265      18.378670      16.869911      14.632555
    [372]       11.852884      9.0329800      6.9880152      6.0406075
    [376]       5.6389127      5.2756925      4.8493133      4.4021969
    [380]       3.7847450      2.5722635     0.36555338     -1.8625610
    [384]     -0.56093252      2.1861520      4.0254083      5.2518191
    [388]       6.6016593      8.3482924      10.167065      11.674877
    [392]       12.660868      13.048306      12.872993      12.295935
    [396]       11.576129      10.946238      10.522491      10.393965
    [400]       10.711788      11.629176      13.052028      14.483283
    [404]       15.329047      15.142176      13.576917      10.591063
    [408]       8.9647713      11.435249      13.623460      14.699113
    [412]       15.504323      16.653399      17.787157      18.293194
    [416]       17.887945      16.584972      14.802954      13.586866
    [420]       13.501777      13.598662      12.890871      10.657506
    [424]       6.0066214      6.5632358      13.078601      17.075527
    [428]       19.321676      20.294081      20.163424      18.958199
    [432]       16.638412      13.165951      8.5185356      1.7546612
    [436]      -1.0437839      8.3662910      13.531800      16.722086
    [440]       18.864269      20.413250      21.571814      22.388687
    [444]       22.878527      23.095587      23.114679      22.955978
    [448]       22.546661      21.762201      20.479187      18.571823
    [452]       15.885588      12.589574      11.320761      13.734925
    [456]       16.095413      17.304461      17.418043      16.535189
    [460]       14.707587      12.077109      9.5491762      9.2733202
    [464]       10.868942      12.392664      13.239730      13.269737
    [468]       12.349591      10.311727      7.1715288      4.5371666
    [472]       5.2583642      6.9038167      7.7809262      7.9847779
    [476]       7.7326221      7.0357494      5.7727799      3.7867353
    [480]      0.82744837     -3.2160950     -4.1922774    -0.28000370
    [484]       2.5524940      3.7944176      3.7535002      2.6496444
    [488]      0.64074975     -2.1687543     -5.8541641     -11.134362
    [492]      -16.569220     -9.3526497     -3.6783850     0.14526995
    [496]       2.8566372      4.7128105      5.9088778      6.7897792
    [500]       7.7735429      8.8961935      9.7149191      9.7423840
    [504]       8.5945148      5.7728572   -0.059813526     -14.612583
    [508]      -2.8485739     0.84197044      1.2420877   -0.010658993
    [512]      -1.0384073
  [Tag]         2241
  [frame_len]          320
[Record 15]
  [tot_power]       82476.766
  [re_spec_val]
    [0]      -23.755701     -23.673822     -24.691328     -28.810720
    [4]      -30.996746     -26.042919     -24.154758     -22.070570
    [8]      -18.971209     -17.752220     -19.145159     -19.014051
    [12]      -15.301966     -13.607943     -11.793509     -6.7471328
    [16]      -2.4390645   -0.074715242     0.43526715    -0.98335928
    [20]      -4.8283010     -9.0981750     -4.3850636    -0.66134083
    [24]      0.76817364     0.51389658    -0.26564103     0.95899898
    [28]       3.4169335      4.9302249      5.0379410      3.8017199
    [32]       1.4623114     -1.2361840     -2.7883992     -2.8017085
    [36]      -2.7076795     -3.8025537     -7.4282002     -17.029905
    [40]      -10.403239     -5.0281930     -3.3504951     -3.7993865
    [44]      -5.7431374     -6.9808035     -4.3381925    -0.93888974
    [48]       1.4677982      2.8152452      3.1569598      2.4996157
    [52]      0.83633423     -1.7703899     -5.0102744     -8.2185497
    [56]      -11.065208     -14.252132     -19.270962     -27.060827
    [60]      -17.650778     -12.159240     -9.5459175     -8.8148756
    [64]      -9.7215643     -12.438865     -17.938841     -29.799778
    [68]      -22.868980     -19.343739     -19.225094     -19.742046
    [72]      -18.539818     -17.006613     -16.694878     -17.711922
    [76]      -19.322554     -19.866520     -18.723812     -16.959438
    [80]      -15.271661     -13.937101     -13.012709     -12.429826
    [84]      -12.140247     -12.173880     -12.577106     -13.376744
    [88]      -14.648776     -16.616320     -19.690048     -24.225203
    [92]      -26.569429     -23.116426     -20.418085     -19.073248
    [96]      -18.444654     -17.927092     -17.411072     -17.375641
    [100]      -18.280523     -19.892931     -20.244358     -18.289539
    [104]      -16.032633     -14.208585     -12.802697     -11.933500
    [108]      -11.825356     -12.656603     -14.491337     -17.079144
    [112]      -19.326431     -20.136322     -20.577208     -21.947260
    [116]      -24.872292     -29.956743     -32.877922     -27.874199
    [120]      -24.535822     -23.108355     -23.032310     -22.619965
    [124]      -19.668703     -16.203373     -13.852651     -12.801861
    [128]      -13.001230     -14.420957     -17.017878     -20.485676
    [132]      -23.798409     -26.228218     -28.961422     -32.708889
    [136]      -33.980854     -30.509203     -26.729567     -23.962738
    [140]      -22.369337     -21.677904     -21.085531     -19.773411
    [144]      -18.164158     -17.204098     -17.481604     -19.566971
    [148]      -24.846052     -28.771763     -20.831566     -16.858997
    [152]      -15.018036     -14.340814     -14.066520     -13.378150
    [156]      -12.119793     -10.953805     -10.485636     -11.054206
    [160]      -12.984693     -17.004509     -26.405035     -28.404140
    [164]      -19.936804     -17.547413     -17.447348     -18.500271
    [168]      -18.922487     -17.920462     -17.196276     -17.096472
    [172]      -15.595129     -12.500397     -9.9489393     -8.5774899
    [176]      -8.2593060     -8.6720915     -9.4960966     -10.827515
    [180]      -13.622145     -21.385885     -22.697653     -12.568824
    [184]      -8.7866545     -7.3661914     -7.5636621     -9.1831379
    [188]      -12.204262     -16.489878     -20.936209     -23.050428
    [192]      -21.763384     -19.383919     -18.602140     -21.053053
    [196]      -30.695570     -19.495548     -13.094372     -9.9247427
    [200]      -8.4541664     -8.1997032     -9.0621262     -11.247655
    [204]      -14.768265     -14.700016     -10.467375     -7.8511744
    [208]      -7.3599095     -9.4827271     -17.447184     -14.197698
    [212]      -5.9325724     -2.2342396    -0.53346419    -0.14224564
    [216]     -0.77170008     -2.2573617     -4.4615831     -7.2306013
    [220]      -10.501035     -14.870666     -24.299894     -21.963150
    [224]      -12.848270     -8.5160809     -6.0038958     -4.6943750
    [228]      -4.4486237     -5.3219142     -7.4486303     -10.374004
    [232]      -10.416118     -7.3256884     -4.9746490     -4.0241008
    [236]      -4.4701838     -5.9398661     -6.0948939     -3.5440955
    [240]      -1.2028916    -0.16171756    -0.40025812     -1.7160642
    [244]      -3.6451423     -4.9037952     -3.8084784     -1.1836681
    [248]       1.2936152      3.0252042      3.9377682      4.1230989
    [252]       3.7496493      3.0232434      2.1070480      1.0772448
    [256]      0.17745772     0.20584020      1.4988292      2.9897065
    [260]       3.7461903      3.4132152      1.8867046    -0.55908746
    [264]      -2.1278446    -0.85550374      1.3433181      3.1504982
    [268]       4.3108206      4.7179666      4.4850097      4.2762589
    [272]       4.9625049      6.1751528      6.9332771      6.8084102
    [276]       5.8561478      4.5218415      3.3401198      1.9747827
    [280]     -0.94310248     -6.7427454     -2.8504624      2.7695689
    [284]       5.5995717      6.8809104      7.3772764      7.7487621
    [288]       8.4163942      9.3731537      10.511989      11.889316
    [292]       13.507712      15.113273      16.353607      16.952095
    [296]       16.707520      15.442842      13.093168      10.731152
    [300]       11.561679      14.129929      16.054388      17.139084
    [304]       17.507826      17.153643      15.914517      13.478347
    [308]       9.3328037      4.0872116      6.0387778      10.046175
    [312]       12.864614      15.158244      17.148619      18.752420
    [316]       19.857004      20.411772      20.437845      20.037434
    [320]       19.403080      18.774584      18.315865      18.037224
    [324]       17.887266      17.900080      18.227715      18.958899
    [328]       19.901531      20.696951      21.065075      20.866768
    [332]       20.059879      18.679579      16.951077      15.675585
    [336]       16.111277      18.072046      20.352560      22.287558
    [340]       23.590380      24.107073      23.810951      23.028925
    [344]       22.828363      23.944324      25.353268      26.066618
    [348]       25.764847      24.367676      21.886038      18.596798
    [352]       15.322273      12.067149      4.6519184      4.4972577
    [356]       15.473953      20.468092      23.463652      25.226202
    [360]       25.945787      25.582085      23.920235      20.580050
    [364]       16.691402      18.956799      22.325075      23.894178
    [368]       23.964430      22.778349      20.487896      17.382578
    [372]       14.248929      12.296200      12.480150      14.578646
    [376]       16.909580      18.537949      19.352224      19.468447
    [380]       19.013298      18.059589      16.616579      14.654209
    [384]       12.138405      9.0710335      5.6039762      2.3545246
    [388]      0.17717190     -1.7343284     -5.8896780     -8.0797462
    [392]      0.57268465      5.5973258      8.4424820      9.9069605
    [396]       10.378366      10.140054      9.4518347      8.4861383
    [400]       7.1627789      5.0707183      2.0071998      2.1241570
    [404]       6.6806078      10.207875      12.253275      13.084992
    [408]       12.852820      11.599438      9.2884750      5.8386836
    [412]       1.2849636     -3.4489417     -5.5963264     -4.3830705
    [416]      -1.6898167      1.3013008      4.1819963      6.6203156
    [420]       8.3354988      9.2877722      9.7549648      10.278756
    [424]       11.177064      12.164610      12.851041      13.146825
    [428]       13.207064      13.223701      13.222421      13.042639
    [432]       12.470641      11.334403      9.5740891      7.4781265
    [436]       5.9819674      5.5583825      5.1923919      4.2468405
    [440]       3.5535939      4.4446740      6.2192831      7.9258595
    [444]       9.3783035      10.391767      10.653043      9.8679476
    [448]       7.7492652      3.8307929     -3.3010592     -26.851643
    [452]      -4.7009540      1.3404094      5.5669327      8.8153572
    [456]       11.239212      12.899418      13.801748      13.916327
    [460]       13.199469      11.635039      9.3731613      7.0373321
    [464]       5.4629421      4.2085686      1.9977285     -2.1661010
    [468]      -9.4260626     -27.365398     -11.694551     -2.3577702
    [472]       2.9844072      6.2113400      8.0510855      8.9236946
    [476]       9.1388035      8.9729862      8.6930323      8.5065517
    [480]       8.4362421      8.2698402      7.7002268      6.5542703
    [484]       5.2395720      5.2845478      7.0865364      9.0014448
    [488]       10.216792      10.655896      10.427717      9.7043676
    [492]       8.7243128      7.7911878      7.1966496      7.0729599
    [496]       7.3219123      7.7137380      8.0273628      8.1048603
    [500]       7.8370905      7.1392384      5.9474678      4.2552438
    [504]       2.2377138     0.48946124    -0.19660720   0.0011023603
    [508]      0.16730821    -0.30836862     -1.7098749     -3.9658842
    [512]      -5.4678717
  [Tag]         2401
  [frame_len]          320
[Record 16]
  [tot_power]       250030.16
  [re_spec_val]
    [0]      -21.430355     -22.267282     -25.565325     -33.609055
    [4]      -26.704823     -21.702324     -20.695715     -22.787359
    [8]      -19.921362     -13.256172     -9.5505333     -8.8509226
    [12]      -13.871032     -9.9619093      2.5138431      9.8876572
    [16]       15.357518      19.626738      22.966793      25.520699
    [20]       27.376925      28.591061      29.192471      29.186024
    [24]       28.552332      27.250013      25.233982      22.554745
    [28]       19.748026      18.204443      18.157196      18.105442
    [32]       17.297539      16.450844      18.303228      22.273962
    [36]       25.897852      28.686041      30.712784      32.091915
    [40]       32.917816      33.264038      33.180183      32.682861
    [44]       31.746410      30.298820      28.220327      25.330450
    [48]       21.329138      15.564010      5.6751108     -2.0958393
    [52]       5.8516402      7.1990633      6.3384919      4.3169498
    [56]       2.6277173      2.7823229      3.4656048      3.3162372
    [60]       1.8606901     -1.7317845     -10.939960     -5.1027141
    [64]       1.6893282      4.7691689      5.9916530      5.9042616
    [68]       4.7245207      2.5416756    -0.61738628     -4.7331433
    [72]      -9.6502218     -14.682690     -18.114122     -18.004025
    [76]      -15.514525     -13.008483     -11.144135     -9.8383427
    [80]      -8.8465891     -7.9129720     -6.8579669     -5.6486588
    [84]      -4.4249048     -3.4446237     -2.9729986     -3.2104623
    [88]      -4.2794895     -6.2156377     -8.8986292     -11.876858
    [92]      -14.257237     -15.315071     -15.367333     -14.995712
    [96]      -13.900668     -11.889819     -9.9319820     -8.8876314
    [100]      -9.2064857     -11.543616     -17.868164     -15.483045
    [104]      -7.7055163     -3.5491433     -1.2447938    -0.23194894
    [108]     -0.31257606     -1.4282871     -3.5881774     -6.8137646
    [112]      -10.985553     -15.369232     -18.369511     -19.423424
    [116]      -19.375698     -19.062635     -18.287783     -16.160042
    [120]      -13.485473     -11.457417     -10.378198     -10.007650
    [124]      -9.6838684     -8.8063316     -7.6944976     -7.0681391
    [128]      -7.3368945     -8.6689310     -11.154896     -14.827825
    [132]      -19.431402     -23.557688     -24.346270     -22.210779
    [136]      -20.005297     -18.725119     -18.177063     -17.477604
    [140]      -15.696124     -13.201195     -10.913317     -9.3117809
    [144]      -8.6115770     -9.0265989     -10.976886     -15.415948
    [148]      -18.690409     -12.127709     -8.0258198     -6.0499959
    [152]      -5.5687766     -6.3326116     -8.0539713     -9.7369719
    [156]      -9.9156771     -9.3376522     -9.4820423     -10.882509
    [160]      -13.758473     -18.493977     -24.906796     -22.876705
    [164]      -18.181793     -14.997385     -12.237258     -9.3269520
    [168]      -6.4342251     -3.9217451     -1.9657065    -0.60295194
    [172]      0.16871181     0.35108119   -0.047122233    -0.97063047
    [176]      -2.2607450     -3.6679373     -5.0985332     -6.9319625
    [180]      -10.053669     -15.794336     -15.607972     -9.4662619
    [184]      -6.1206441     -4.5256438     -4.1867514     -4.9332867
    [188]      -6.6030388     -8.3803654     -8.3006887     -6.5356555
    [192]      -4.8971186     -3.9672594     -3.8014357     -4.3981166
    [196]      -5.6106629     -6.6479197     -6.2474809     -4.9248271
    [200]      -4.0350246     -4.1279302     -5.3588123     -7.6952314
    [204]      -9.7158947     -7.9330387     -4.7104683     -2.4409695
    [208]      -1.3984009     -1.6697675     -3.4585412     -6.2880969
    [212]      -5.3202963     -1.5060889     0.98562592      1.9831425
    [216]       1.7154876     0.33047274     -2.0064721     -4.7494154
    [220]      -6.2294803     -5.2796259     -3.5009582     -2.1459444
    [224]      -1.5723633     -1.9108607     -3.3451126     -6.3915095
    [228]      -12.686574     -14.294540     -6.5243559     -2.5690405
    [232]     -0.48215872     0.57925540      1.2333421      1.9859771
    [236]       2.8770263      3.5448251      3.7400708      3.6032829
    [240]       3.6511197      4.2467694      5.0826664      5.6867533
    [244]       5.8644075      5.6037908      4.9022694      3.6731074
    [248]       1.7132647     -1.2136893     -3.7606514     -1.1449081
    [252]       2.9830823      6.1188102      8.4203463      10.079357
    [256]       11.081031      11.278482      10.458396      8.3086596
    [260]       4.1930470     -3.9372146     -9.0740376     -1.7554349
    [264]      0.49729916      1.1649195      1.5798293      2.4595444
    [268]       4.0705357      6.1183023      7.9385185      8.9567642
    [272]       8.8913641      8.4043694      10.284485      14.091420
    [276]       17.203808      19.106533      19.869343      19.574141
    [280]       18.253033      15.886337      12.380359      7.4664259
    [284]      0.49738955     -6.7487168     -7.0460410     -14.392382
    [288]      -6.6787767      1.8539340      5.3747621      6.2185955
    [292]       4.4158649     -2.9692626     -2.1696675      8.0346870
    [296]       12.743498      15.407593      16.736443      16.989683
    [300]       16.431313      15.765106      16.105959      17.332510
    [304]       18.319239      18.484114      17.701422      16.003506
    [308]       13.524972      10.588849      7.8649492      6.2522912
    [312]       5.9716477      6.1309500      5.4956627      2.4887750
    [316]      -6.7411728      2.5111876      8.7002096      11.299381
    [320]       11.752573      10.431645      7.4796882      3.7488270
    [324]       3.1636169      6.0603023      8.7363720      10.080873
    [328]       9.6060743      6.3804021     -2.6423616      4.1457510
    [332]       9.8987398      12.084660      12.480826      12.695228
    [336]       14.752228      17.730562      20.036131      21.314983
    [340]       21.660860      21.401144      21.171122      21.506521
    [344]       22.178247      22.774494      23.410490      24.451418
    [348]       25.811977      27.034754      27.815525      28.094433
    [352]       27.949253      27.513741      26.918049      26.240135
    [356]       25.493147      24.654007      23.684336      22.498438
    [360]       20.900774      18.557720      15.132809      11.953262
    [364]       13.532289      16.329763      17.953236      18.639172
    [368]       18.842081      18.920933      18.994503      18.966890
    [372]       18.723804      18.269978      17.758183      17.435593
    [376]       17.471163      17.787952      18.133827      18.258118
    [380]       17.974485      17.145281      15.678669      13.599441
    [384]       11.275209      9.5926218      9.0644093      9.2131090
    [388]       9.7214737      10.464731      11.071568      11.145218
    [392]       10.455556      8.8872585      6.3804145      3.0315492
    [396]     -0.35954237     -2.2002375     -2.7701371     -2.3052497
    [400]      0.50697327      3.9527435      6.4286861      7.6310248
    [404]       7.5059786      5.9772310      3.2763660      1.9175407
    [408]       3.8241804      5.5494094      5.9322190      5.0560255
    [412]       3.1645243     0.72300702     -1.3285024     -1.7750160
    [416]     -0.41075701      1.4945853      2.8136542      3.0656264
    [420]       2.0474529    0.043579254    0.044200633      3.5573878
    [424]       6.8396177      8.9819784      10.089976      10.275229
    [428]       9.5894403      8.0676479      5.8224983      3.2280653
    [432]       1.1017003     0.63746494      2.4180851      5.0322576
    [436]       7.0913415      8.1523438      8.1069136      6.8404922
    [440]       4.0561981    -0.76119959     -3.1252811      1.8181329
    [444]       5.2600751      6.9943132      7.3274884      6.1675601
    [448]       2.9806414     -3.7081769     -5.6134620     0.15552545
    [452]       2.3692904      2.9396832      2.9573514      2.6531448
    [456]       1.5327897     -1.0194865     -5.4393053     -10.206841
    [460]      -9.0082674     -4.9632716     -1.0776325      1.7444090
    [464]       3.2840347      3.5623891      2.5353472   -0.087035783
    [468]      -5.0040808     -8.3284931     -3.3482730    -0.34126350
    [472]      0.55615073    -0.18356393     -2.3808908     -5.7178750
    [476]      -9.2142658     -11.837691     -10.655410     -6.1997561
    [480]      -3.1241014     -1.8831717     -2.1372485     -3.2531040
    [484]      -4.0009270     -3.7998483     -3.6828034     -4.4298992
    [488]      -5.8861737     -6.7086525     -5.8358793     -4.6414394
    [492]      -4.2568474     -4.9452081     -6.7513814     -9.6335487
    [496]      -12.402640     -11.329193     -8.3597012     -6.2703223
    [500]      -5.3432589     -5.5348377     -6.8885617     -9.5972424
    [504]      -13.882482     -17.562054     -16.011076     -14.528438
    [508]      -14.925306     -16.972689     -19.688137     -20.720299
    [512]      -20.527050
  [Tag]         2561
  [frame_len]          320
[Record 17]
  [tot_power]       853439.69
  [re_spec_val]
    [0]      -32.767456     -23.841309     -23.386009     -27.937107
    [4]      -21.239357     -21.298628     -35.844044     -17.873253
    [8]      -16.198803     -24.774475     -11.573314     -8.1409950
    [12]      -16.468904     -5.3292012      1.9209687      2.8955615
    [16]       8.8575544      18.244564      24.597557      28.905169
    [20]       31.733992      33.348301      33.867092      33.321869
    [24]       31.674879      28.820694      24.600992      19.005596
    [28]       13.231297      9.1792812      4.2616663     -4.9806371
    [32]      -14.410979    -0.26996025      10.435667      17.152929
    [36]       21.683807      25.039904      28.316832      32.072510
    [40]       35.750069      38.734833      40.810684      41.949356
    [44]       42.162514      41.452435      39.799103      37.162506
    [48]       33.509563      28.916746      23.802486      18.801514
    [52]       13.594420      7.7280598      4.4759493      1.9839274
    [56]      -5.9640055    -0.54925025      4.5835423      5.9915037
    [60]       5.7659154      6.7577019      10.208861      13.548325
    [64]       15.866864      17.208002      17.695896      17.403597
    [68]       16.346680      14.488585      11.742774      7.9791832
    [72]       3.1050565     -2.3858747     -6.2540073     -8.0246248
    [76]      -9.8782425     -12.492394     -16.109875     -17.777592
    [80]      -14.317442     -11.576108     -10.153547     -8.9532108
    [84]      -7.2067089     -5.3584237     -4.0436206     -3.4311557
    [88]      -3.4450858     -3.9984217     -5.0841627     -6.7103000
    [92]      -8.7538099     -10.934943     -13.062234     -14.931787
    [96]      -15.524932     -14.449702     -13.115311     -12.114632
    [100]      -10.896891     -8.9476061     -6.7607055     -5.0029693
    [104]      -3.8341806     -2.9090402     -1.5735582     0.34239104
    [108]       2.2633171      3.6697237      4.3750148      4.3799634
    [112]       3.7654750      2.6356606      1.0495197     -1.0631646
    [116]      -3.9592831     -8.1578321     -14.920017     -31.946861
    [120]      -22.737001     -19.605558     -20.731518     -24.578547
    [124]      -25.633156     -21.479975     -18.943243     -16.963863
    [128]      -13.308657     -8.9088087     -5.2476115     -2.5788934
    [132]     -0.80686188     0.18372592     0.47335076     0.10601886
    [136]     -0.89278519     -2.4771423     -4.5348740     -6.9331760
    [140]      -9.8035021     -13.875344     -19.221363     -17.128904
    [144]      -13.405411     -11.836451     -11.288533     -10.465940
    [148]      -9.1327639     -8.1315985     -7.9689684     -8.4802628
    [152]      -8.6825933     -7.5737329     -5.8621206     -4.5525560
    [156]      -3.9647503     -4.1263461     -4.9996672     -6.4920692
    [160]      -8.3890972     -10.428283     -12.770519     -16.454975
    [164]      -24.118605     -26.004930     -19.374743     -17.102308
    [168]      -15.091734     -11.850482     -8.8254757     -6.6833138
    [172]      -5.1751161     -3.8416979     -2.4427958     -1.1027948
    [176]    -0.045261033     0.61004418     0.82182658     0.55892301
    [180]     -0.19415879     -1.3346080     -2.5314670     -3.4571190
    [184]      -4.3445468     -5.8214540     -8.1756382     -10.349871
    [188]      -10.431756     -9.9723797     -10.662746     -12.117585
    [192]      -12.010551     -10.091999     -8.2855740     -6.7148576
    [196]      -4.8764367     -2.8411851     -1.0791230    0.094705418
    [200]      0.57159728     0.36416870    -0.39301482     -1.4042190
    [204]      -2.3711104     -3.4334130     -5.2734909     -8.9813137
    [208]      -16.516802     -14.491869     -8.9104528     -6.5945592
    [212]      -5.7623515     -5.3502421     -4.6840339     -3.8575900
    [216]      -3.3583863     -3.4252071     -3.7832336     -3.5474467
    [220]      -2.2400732    -0.67600554     0.34730035     0.56946886
    [224]     0.059965231    -0.77357739     -1.2717845     -1.3680917
    [228]      -1.8789680     -3.7357075     -8.2111378     -21.117699
    [232]      -12.871871     -7.4947729     -5.7897000     -5.1284046
    [236]      -3.9767587     -2.2596166    -0.72675800     0.46054479
    [240]       1.6743897      3.2500126      5.0208392      6.5551758
    [244]       7.5457520      7.8714743      7.5785894      6.9363542
    [248]       6.4065638      6.1481938      5.6130810      3.9072709
    [252]     -0.30116227     -9.1480503     -1.8605720      2.7662711
    [256]       4.1855159      4.0759225      4.2152066      5.5133653
    [260]       6.7124434      7.3897872      8.8403482      11.758924
    [264]       14.866895      17.404285      19.277039      20.505888
    [268]       21.103231      21.130766      20.781248      20.316044
    [272]       19.711327      18.391958      15.229644      8.4487619
    [276]       12.707717      18.836611      21.977180      23.560993
    [280]       24.193388      24.193628      23.734642      22.892851
    [284]       21.712683      20.298681      18.911583      17.961376
    [288]       17.702274      17.947960      18.356974      18.763405
    [292]       19.129333      19.357536      19.228081      18.471510
    [296]       16.822916      13.992982      9.5713263      2.8624825
    [300]      -4.0314856      1.7840523      7.7223511      11.954709
    [304]       14.871638      16.875366      18.340590      19.550222
    [308]       20.625381      21.550308      22.278891      22.797028
    [312]       23.102154      23.152008      22.837309      21.985149
    [316]       20.356768      17.600918      13.225895      8.7361422
    [320]       10.977110      13.645606      14.424180      13.567674
    [324]       10.976186      5.6899018     -1.3170956      6.4208999
    [328]       11.084311      13.667693      15.119141      15.701228
    [332]       15.456234      14.512750      13.665475      14.342702
    [336]       16.073586      17.378399      17.682203      16.828281
    [340]       14.649811      10.761117      4.8922834      4.4355121
    [344]       8.4671192      10.655912      11.536131      11.640244
    [348]       11.347692      10.965167      10.661469      10.431161
    [352]       10.193463      9.9124184      9.6603594      9.6082106
    [356]       9.8755627      10.355605      10.784366      10.923840
    [360]       10.613810      9.7261705      8.1044521      5.4885225
    [364]       1.3237458     -6.0751109     -12.494683     -4.1169519
    [368]     -0.39482823      1.7525312      3.2503157      4.3560658
    [372]       5.1169906      5.5423951      5.6626844      5.5271540
    [376]       5.1877661      4.7643728      4.6114116      5.1566029
    [380]       6.1972084      7.0219564      7.0898638      6.0861778
    [384]       3.7317109    -0.15685469     -3.2099934     -1.1658356
    [388]      0.91871530      1.4779222     0.73186457     -1.0896813
    [392]      -3.5573454     -5.4321380     -5.7345080     -5.6929927
    [396]      -6.4288435     -8.1394911     -10.404396     -10.485599
    [400]      -5.9358959     -1.0739754      2.5624754      4.9684997
    [404]       6.2287273      6.3467355      5.1958194      2.3957615
    [408]      -3.0379243     -8.0467043     -2.2044632      1.1157212
    [412]       2.4816229      2.8401737      2.7755876      2.6988645
    [416]       2.7531424      2.8001776      2.6287713      2.1162500
    [420]       1.2296129     0.10794673    -0.29592380      1.4529320
    [424]       4.2215862      6.4134154      7.5706296      7.5941925
    [428]       6.3653555      3.5833931     -1.3803960     -5.9793544
    [432]      -2.0612853     0.77030742      1.7539253      1.7126969
    [436]       1.3763751      1.3244487      1.5090367      1.3977427
    [440]      0.52054816     -1.5288439     -5.7040887     -11.536171
    [444]      -2.2918019      4.1857829      8.3067942      10.960269
    [448]       12.439075      12.825128      12.067221      9.9567757
    [452]       6.0745945      1.3008884      3.1408582      6.3179011
    [456]       7.6912642      7.7570086      6.9622874      5.7015414
    [460]       4.4042115      3.4387128      2.8755400      2.5367877
    [464]       2.3535161      2.4963357      3.0915470      3.9577627
    [468]       4.7713547      5.2724829      5.2702122      4.5889740
    [472]       3.0215278     0.24587807     -4.4197702     -12.612086
    [476]      -13.140148     -8.3068533     -6.8511133     -7.2319136
    [480]      -8.7804394     -10.923501     -12.830219     -13.988538
    [484]      -14.965158     -16.567924     -19.231440     -22.426516
    [488]      -21.953770     -18.143700     -14.867619     -12.612643
    [492]      -11.344942     -11.079258     -11.897291     -13.983535
    [496]      -17.775454     -24.543509     -30.460487     -23.361256
    [500]      -19.839190     -18.311768     -18.272337     -19.841631
    [504]      -23.412659     -27.090937     -24.007721     -20.965015
    [508]      -19.803444     -20.040766     -21.301598     -23.058638
    [512]      -24.022224
  [Tag]         2721
  [frame_len]          320
[Record 18]
  [tot_power]       956213.31
  [re_spec_val]
    [0]      -36.954617     -21.406889     -19.427919     -26.632221
    [4]      -23.979380     -17.702574     -21.226067     -23.614086
    [8]      -13.109932     -13.138150     -32.502548     -7.9153090
    [12]      -4.4354358     -11.179224     -4.1085534      3.6308196
    [16]       1.8351541      6.7461491      19.298603      26.154985
    [20]       30.581047      33.402794      34.943214      35.336967
    [24]       34.613964      32.717598      29.485895      24.589067
    [28]       17.481302      9.4027815      6.9766693      3.3831310
    [32]      -5.7250738     -2.4543891      4.1130538      5.3252344
    [36]      -3.2207437      7.7329278      14.676368      15.014584
    [40]       14.123113      26.319212      33.511822      38.057327
    [44]       40.920090      42.472736      42.871693      42.159569
    [48]       40.290043      37.112434      32.310753      25.336027
    [52]       17.141878      14.611381      10.930129     0.11681369
    [56]       3.0027890      4.1448894    -0.35970592     -2.5432565
    [60]      -1.6943961     -5.4626613     -2.9603949      2.3244209
    [64]       6.2178478      10.448089      14.216826      16.870924
    [68]       18.343050      18.686913      17.925430      16.015676
    [72]       12.822557      8.0796251      1.5035251     -5.0596647
    [76]      -7.6774740     -12.042045     -20.764225     -16.375887
    [80]      -15.289415     -18.521753     -25.625597     -26.149218
    [84]      -20.050547     -16.246367     -13.854243     -11.856679
    [88]      -9.5714092     -7.1553564     -5.1593370     -3.9975529
    [92]      -3.8907919     -4.9421153     -7.1462760     -10.221758
    [96]      -13.314646     -15.772828     -18.453434     -22.275866
    [100]      -26.323416     -28.436302     -31.939047     -38.678307
    [104]      -27.133202     -20.821466     -16.494284     -13.211840
    [108]      -10.625689     -7.8184733     -4.0112190   -0.015739623
    [112]       3.2417648      5.4795241      6.6766415      6.8569436
    [116]       6.0339818      4.2119737      1.4332645     -2.0773661
    [120]      -5.7423162     -9.1737089     -13.222301     -19.683294
    [124]      -32.125210     -30.462435     -24.805038     -19.778711
    [128]      -16.858521     -15.886393     -15.840827     -14.585019
    [132]      -10.595727     -5.7261605     -1.5542564      1.5440866
    [136]       3.5614157      4.5504918      4.5519176      3.5823641
    [140]       1.6463833     -1.2149309     -4.7877789     -8.5236387
    [144]      -12.009120     -15.942345     -21.863348     -31.084545
    [148]      -26.397894     -21.206118     -18.177380     -16.676609
    [152]      -16.360136     -16.369637     -15.394116     -13.138190
    [156]      -10.154333     -6.9972816     -4.2334533     -2.2188931
    [160]      -1.0896946    -0.88406193     -1.6140063     -3.2752340
    [164]      -5.7864609     -8.8263178     -11.822643     -14.825119
    [168]      -19.212257     -27.509888     -27.610249     -22.750059
    [172]      -19.974516     -16.935093     -14.512107     -13.296411
    [176]      -12.728624     -11.134489     -7.8591433     -4.3017578
    [180]      -1.3191038     0.87303835      2.2190433      2.6931310
    [184]       2.2737300     0.94240022     -1.2865975     -4.2527637
    [188]      -7.4192038     -10.065692     -12.422249     -15.434296
    [192]      -19.489563     -24.113922     -27.050901     -21.496651
    [196]      -16.405146     -13.777814     -13.080888     -13.384412
    [200]      -11.807403     -7.6675305     -3.6808357    -0.61756128
    [204]       1.5149984      2.7558651      3.1216068      2.6181324
    [208]       1.2653972    -0.84361511     -3.4269068     -6.0019398
    [212]      -8.3979864     -11.181324     -15.148584     -20.705334
    [216]      -22.142517     -16.838552     -12.995267     -11.097006
    [220]      -11.072042     -12.634466     -12.419445     -7.8680663
    [224]      -3.3851135     0.18031487      2.9726098      5.0285511
    [228]       6.3245835      6.8360128      6.5501008      5.4773836
    [232]       3.6942861      1.4177558     -1.0529488     -3.8075650
    [236]      -7.7325773     -14.217110     -18.528654     -18.060699
    [240]      -25.472467     -13.813989     -7.9280648     -6.0453901
    [244]      -7.0228672     -9.4505157     -4.4645805      2.1453028
    [248]       7.0284820      10.558844      12.950135      14.305537
    [252]       14.693928      14.203196      13.034892      11.610134
    [256]       10.332701      8.9385252      6.5675607      2.2075636
    [260]      -5.8272972     -19.307573     -3.9658620      3.5405862
    [264]       7.8648710      10.568138      13.817455      18.396461
    [268]       22.779072      26.233253      28.730082      30.363140
    [272]       31.209455      31.317810      30.728157      29.515385
    [276]       27.867102      26.134474      24.612789      23.120493
    [280]       21.087555      17.895054      12.748006      3.5586627
    [284]      -8.7740841     -3.4304361     -8.4882135      2.8220344
    [288]       8.2280569      10.374119      10.512100      9.6299896
    [292]       10.341998      13.629122      17.010303      19.604862
    [296]       21.363604      22.311720      22.456108      21.780956
    [300]       20.243496      17.793102      14.524369      11.185214
    [304]       9.0592232      7.8654814      7.4367557      8.4150629
    [308]       9.7502031      11.427295      14.324170      17.465469
    [312]       19.831463      21.281506      22.025618      22.376381
    [316]       22.596436      22.744513      22.684908      22.238550
    [320]       21.279221      19.758667      17.776588      15.788490
    [324]       14.559603      14.071173      13.336502      11.507379
    [328]       7.9721794      2.2331014     -3.1471786     -5.6915507
    [332]      -11.281193     0.51740569      5.8090806      8.1196432
    [336]       9.0992222      10.088998      11.671737      13.266678
    [340]       14.349371      14.814761      14.711843      14.094935
    [344]       13.027185      11.678039      10.387983      9.4257183
    [348]       8.5788031      7.2852960      4.9339385     0.63799632
    [352]      -8.0374126     -8.0244751     -2.3997927     -1.0571004
    [356]      -1.9481634     -4.0557175     -6.0366607     -7.5735722
    [360]      -9.5530605     -8.8467836     -4.7980056     -1.5883889
    [364]      0.43280175      1.6112863      2.1638186      2.2096622
    [368]       1.8605411      1.2246026     0.31246608     -1.0432179
    [372]      -3.2029364     -6.8623414     -13.840941     -17.528294
    [376]      -10.849498     -9.1977434     -11.581458     -23.734676
    [380]      -12.293737     -5.7111464     -2.7143381     -1.2155565
    [384]     -0.37098977     0.24251710     0.70277822     0.93434221
    [388]      0.88975042     0.55446458   -0.096210502     -1.0459912
    [392]      -2.1109538     -2.9631536     -3.5343976     -4.2200985
    [396]      -5.4299974     -7.1863117     -9.0763416     -10.846089
    [400]      -12.364993     -11.026737     -7.2753000     -4.2454329
    [404]      -2.2536242    -0.83574361     0.41831350      1.5772295
    [408]       2.4714460      2.9710188      3.0724549      2.8404481
    [412]       2.3426225      1.6410667     0.82908928    0.018979002
    [416]     -0.80278075     -1.9337482     -3.9668763     -7.9047632
    [420]      -15.576500     -14.300460     -10.214760     -10.722957
    [424]      -14.888619     -11.250041     -6.1114988     -4.0400715
    [428]      -4.0555701     -4.9358888     -4.0896435     -1.4676100
    [432]      0.84882390      2.3904111      3.2861550      3.6861522
    [436]       3.7115941      3.5103946      3.2617807      3.0252659
    [440]       2.5740025      1.4938793    -0.49952444     -2.7736559
    [444]      -3.1659272     -2.4176559     -2.6576085     -2.8956316
    [448]     -0.23737596      3.2283933      5.7914686      7.6060691
    [452]       9.0358582      10.208792      11.021907      11.331490
    [456]       11.068941      10.251145      8.9586735      7.3042345
    [460]       5.3889632      3.2915599      1.1693518    -0.65424317
    [464]      -2.0709047     -3.6466117     -6.2222800     -10.399817
    [468]      -14.945776     -15.911398     -17.223448     -17.295235
    [472]      -12.032137     -8.4032202     -6.6886301     -6.1088982
    [476]      -5.9404659     -5.7550020     -5.6632495     -5.9752398
    [480]      -6.8263311     -8.1362753     -9.6876907     -11.254676
    [484]      -12.754586     -14.280915     -16.010141     -18.154629
    [488]      -20.983707     -24.601959     -27.167984     -25.940220
    [492]      -24.196447     -23.462744     -23.455479     -23.681652
    [496]      -23.866926     -24.021711     -24.169636     -24.200657
    [500]      -23.984522     -23.591604     -23.367622     -23.754257
    [504]      -25.068354     -27.168354     -28.491440     -27.682455
    [508]      -26.682337     -26.736431     -27.916731     -29.759357
    [512]      -30.823887
  [Tag]         2881
  [frame_len]          320
[Record 19]
  [tot_power]       1182102.1
  [re_spec_val]
    [0]      -32.499348     -45.173893     -27.374798     -23.018311
    [4]      -28.924589     -23.939390     -16.438997     -18.130404
    [8]      -26.087257     -11.826895     -10.713600     -23.129763
    [12]      -8.1243162     -5.9122653     -13.380193      3.6374764
    [16]       8.6268921      6.0952153      10.382153      22.534100
    [20]       29.115902      33.307564      35.924053      37.286568
    [24]       37.532253      36.696152      34.728958      31.479595
    [28]       26.641434      19.737062      11.716851      7.6391258
    [32]      0.42535600     -1.2322081      2.8700404     -2.3909669
    [36]      -10.534294    -0.60881007      9.0764418      16.645052
    [40]       20.871515      23.435131      27.280352      32.593639
    [44]       37.152130      40.419716      42.478283      43.436287
    [48]       43.346909      42.203083      39.932697      36.383518
    [52]       31.322971      24.765144      19.020464      15.818275
    [56]       10.680074      3.4672000      4.5732207      3.4469204
    [60]      -2.1686153     -10.812669     -16.439220     -18.284527
    [64]      -10.051162    -0.77172643      5.9593935      10.521789
    [68]       13.758880      16.074020      17.542604      18.111956
    [72]       17.719103      16.312365      13.837378      10.231109
    [76]       5.4856391   0.0094595654     -4.7586102     -8.4154272
    [80]      -13.184474     -21.962351     -27.738104     -22.266506
    [84]      -22.483065     -26.133516     -30.842455     -27.469254
    [88]      -24.866489     -21.747541     -13.969640     -7.2470675
    [92]      -2.4244440     0.89666867      2.9855249      3.9949763
    [96]       4.0142794      3.1018696      1.3024648     -1.3580624
    [100]      -4.9084001     -9.4259729     -14.576104     -18.554251
    [104]      -20.723642     -20.858847     -19.021683     -18.438334
    [108]      -19.797707     -21.674477     -20.871252     -16.457466
    [112]      -11.395201     -6.9709692     -2.8259752      1.1317395
    [116]       4.5298104      7.0796251      8.6888914      9.3552494
    [120]       9.0983295      7.9403000      5.9143353      3.0953293
    [124]     -0.35350236     -4.1685882     -8.1080160     -12.162936
    [128]      -16.341925     -18.326450     -16.715609     -15.957686
    [132]      -17.548214     -20.138006     -17.996651     -14.931747
    [136]      -12.371048     -8.3589916     -3.7100744     0.21428730
    [140]       3.1253607      5.0517869      6.0510988      6.1696229
    [144]       5.4479823      3.9356267      1.7080148     -1.1275563
    [148]      -4.4679713     -8.2928743     -12.718124     -18.076103
    [152]      -24.565580     -24.728039     -21.455122     -21.013847
    [156]      -23.942154     -36.370953     -26.617174     -18.613035
    [160]      -14.119201     -10.540526     -6.9237609     -3.3144679
    [164]     -0.22158875      2.0566664      3.4549143      4.0049667
    [168]       3.7676868      2.8068566      1.1756309     -1.0757488
    [172]      -3.8112009     -6.6239028     -9.0867786     -11.822517
    [176]      -16.740696     -27.027330     -20.462555     -17.336161
    [180]      -18.278675     -20.359062     -17.565283     -13.723598
    [184]      -10.676292     -7.8030114     -4.9348512     -2.2671158
    [188]    -0.035765562      1.5896392      2.5224872      2.7486653
    [192]       2.3068442      1.2608196    -0.34158972     -2.4967248
    [196]      -5.1778994     -8.1426153     -11.085693     -14.867201
    [200]      -24.133598     -22.816963     -14.394193     -11.681027
    [204]      -11.488687     -13.394111     -16.996454     -15.047304
    [208]      -9.5614758     -5.6101937     -2.6789427    -0.28349099
    [212]       1.7146866      3.2492850      4.2231216      4.5831122
    [216]       4.3129983      3.4087727      1.8791732    -0.20516771
    [220]      -2.6696169     -5.4798069     -9.4293776     -17.049437
    [224]      -17.317284     -11.484190     -10.189774     -11.546068
    [228]      -13.724977     -11.602936     -6.6017070     -2.3819275
    [232]      0.67192322      2.9954855      5.2458143      7.6702204
    [236]       9.9240427      11.643085      12.684797      13.023288
    [240]       12.655587      11.601390      10.008965      8.2870026
    [244]       6.7666864      4.8898525      1.3443367     -3.6428609
    [248]     -0.15904634      3.2543809      3.6285694     0.61150700
    [252]      -3.8500390      6.0474873      12.666121      17.182404
    [256]       20.470833      22.837954      24.436235      25.379045
    [260]       25.774145      25.716213      25.238903      24.249449
    [264]       22.498970      19.640923      15.894731      14.847655
    [268]       16.728455      17.476490      16.646187      15.376263
    [272]       15.686407      16.853561      17.276802      16.930758
    [276]       16.844955      17.942854      19.686420      21.314968
    [280]       22.577417      23.445171      23.959028      24.190945
    [284]       24.210163      24.053438      23.710941      23.117321
    [288]       22.161652      20.757593      18.981493      17.133200
    [292]       15.290486      12.615947      6.9490619     -2.2921474
    [296]       8.1379805      11.341840      11.314570      10.343391
    [300]       12.804760      16.647686      19.447783      21.352678
    [304]       22.783148      23.999950      25.045139      25.837816
    [308]       26.296938      26.385017      26.092075      25.406538
    [312]       24.299536      22.739737      20.756382      18.539377
    [316]       16.371939      14.080275      10.510180      2.1476359
    [320]     -0.83934957      8.2506533      10.516055      9.9754267
    [324]       8.0453396      8.2769279      10.811787      12.662868
    [328]       13.528377      13.817181      13.873838      13.826141
    [332]       13.655359      13.324159      12.798525      12.003264
    [336]       10.816553      9.1559496      7.1619444      5.2680178
    [340]       3.4917891     0.61841881     -6.4690337     -11.676766
    [344]      -1.6162270      1.1101484      1.2743732      1.0083845
    [348]       2.4083908      4.4304857      5.7398658      6.2943206
    [352]       6.4779048      6.6545444      6.9247084      7.1731782
    [356]       7.2699790      7.1380196      6.7248979      5.9992070
    [360]       5.0021915      3.8968148      2.8378599      1.6222064
    [364]     -0.42378968     -4.2433081     -8.5574121     -5.2146626
    [368]      -2.3406491     -2.1679652     -4.7078576     -9.0619917
    [372]      -5.5595350     -1.2844926     0.80560035      1.5158385
    [376]       1.4424928      1.1041439     0.92674857      1.0647730
    [380]       1.3982970      1.7397578      1.9580888      1.9851139
    [384]       1.8000244      1.4093440     0.78919584    -0.21091883
    [388]      -1.9495130     -5.1081710     -11.277028     -17.943714
    [392]      -10.597240     -8.1519699     -8.7859802     -11.284866
    [396]      -10.742417     -7.0209055     -4.4483447     -3.1286430
    [400]      -2.5747271     -2.3126695     -1.9292771     -1.2219237
    [404]     -0.29011574     0.59677953      1.1877989      1.3456386
    [408]       1.0761243     0.49351448    -0.36341044     -1.8098820
    [412]      -4.7089939     -11.530481     -21.336866     -8.3657598
    [416]      -5.3070354     -5.2947135     -6.7015200     -6.1124325
    [420]      -3.3018620     -1.1260195    0.090542547     0.86494088
    [424]       1.7659838      2.9877107      4.2847657      5.3342295
    [428]       5.9356871      6.0087180      5.5939970      4.9091778
    [432]       4.3135185      3.9170237      3.2511287      1.5163296
    [436]      -2.4814236     -11.235056     -5.4691997   -0.020766968
    [440]       2.4080038      3.6392405      4.6268883      5.7191668
    [444]       6.6898036      7.2426233      7.2842975      6.8956122
    [448]       6.2602549      5.5851851      4.9869652      4.4071345
    [452]       3.6413620      2.4244578     0.44343546     -2.8099995
    [456]      -8.5074825     -13.401998     -6.9006071     -3.5107732
    [460]      -2.5465674     -3.3657825     -5.2520332     -5.6650071
    [464]      -3.7913957     -2.3443747     -2.1786213     -3.2210033
    [468]      -5.1781378     -7.4576678     -9.2953281     -10.616590
    [472]      -12.016674     -13.743558     -14.784599     -13.225127
    [476]      -10.401178     -8.1429663     -6.8243370     -6.3638906
    [480]      -6.5208921     -6.8996449     -7.1389132     -7.3266444
    [484]      -7.9600878     -9.5648375     -12.622128     -17.516575
    [488]      -21.696762     -20.704792     -20.381969     -21.011454
    [492]      -20.037878     -18.316065     -17.651915     -18.293182
    [496]      -19.948927     -21.978001     -23.261181     -22.996218
    [500]      -21.827280     -20.728785     -20.120260     -20.070686
    [504]      -20.540037     -21.491920     -22.951939     -25.038204
    [508]      -27.960115     -31.998465     -37.524075     -45.499508
    [512]      -67.966484
  [Tag]         3041
  [frame_len]          320
[Record 20]
  [tot_power]       1249246.1
  [re_spec_val]
    [0]      -20.073845     -25.633663     -23.853674     -16.259167
    [4]      -16.690493     -26.966578     -16.774529     -14.061337
    [8]      -22.059057     -13.111238     -8.0721130     -11.298259
    [12]      -8.9432878     -1.4519398     -2.0498097     -12.731205
    [16]       5.1451092      7.6242051     -3.8451965      19.516344
    [20]       28.180368      33.606464      37.184998      39.393326
    [24]       40.438904      40.405518      39.296246      37.037468
    [28]       33.449890      28.155922      20.328527      9.9397860
    [32]       8.7239408      5.9173150     -5.4393630     -5.1313286
    [36]      -3.6394334     -27.508839     -2.0018277     0.41585925
    [40]       10.440751      17.712811      21.125555      21.127016
    [44]       21.944405      29.817448      35.792519      39.628342
    [48]       41.916939      42.944538      42.830845      41.591946
    [52]       39.151497      35.312126      29.672916      21.640450
    [56]       14.220901      12.233246      6.6644101    -0.58542335
    [60]       2.2019725     -1.5324991     -13.680324     -4.1305170
    [64]      -5.1657472     -19.405390     -10.273612     -7.4938436
    [68]      -8.5348539     -1.7815316      4.5910387      9.0891457
    [72]       12.199208      14.082274      14.793037      14.329753
    [76]       12.621023      9.4854631      4.5353003     -2.9875395
    [80]      -11.195257     -11.465452     -13.980925     -21.517773
    [84]      -38.440666     -27.338057     -30.771803     -37.065010
    [88]      -26.517513     -29.162870     -26.899963     -18.802856
    [92]      -17.624123     -11.407485     -2.7114625      3.0943708
    [96]       6.9453130      9.3961525      10.715408      11.030682
    [100]       10.390899      8.8002558      6.2537870      2.8044920
    [104]      -1.3339355     -5.8755565     -11.039588     -17.049948
    [108]      -19.931160     -21.252085     -25.610403     -24.779972
    [112]      -22.931816     -25.357121     -20.285934     -13.944655
    [116]      -10.614705     -8.5169125     -4.7119465     0.49791637
    [120]       4.8996654      8.0346489      9.9860401      10.857005
    [124]       10.704101      9.5391693      7.3416557      4.0936556
    [128]    -0.094799742     -4.6761112     -8.7631397     -12.518898
    [132]      -16.577433     -20.378668     -24.101252     -25.261332
    [136]      -22.193047     -21.344328     -20.539122     -15.678740
    [140]      -11.835894     -10.125393     -8.6559820     -4.4245329
    [144]      0.33625093      3.8500900      6.0477381      7.0681839
    [148]       6.9985185      5.8652854      3.6532054     0.34583816
    [152]      -3.9628072     -8.8921108     -14.086104     -19.824749
    [156]      -22.730228     -21.868912     -22.431269     -22.922945
    [160]      -21.827805     -20.531425     -18.552956     -15.519000
    [164]      -12.723913     -11.151151     -10.460894     -7.0821185
    [168]      -1.4069299      3.2300358      6.4473591      8.4374704
    [172]       9.3562174      9.2977343      8.3192520      6.4711905
    [176]       3.8374143     0.56889892     -3.1980402     -7.6620946
    [180]      -13.703279     -22.204683     -23.515186     -22.607695
    [184]      -22.025707     -19.884272     -19.904930     -24.255774
    [188]      -21.047695     -14.328334     -11.144199     -9.1213636
    [192]      -5.7998939     -1.6655371      1.6757852      3.8312571
    [196]       4.8230214      4.6967344      3.4598234      1.1056917
    [200]      -2.2620776     -6.1204667     -9.7197247     -13.870522
    [204]      -20.997917     -21.866337     -17.775822     -17.274033
    [208]      -18.118736     -18.051485     -17.593306     -18.689514
    [212]      -20.897436     -15.982901     -10.901292     -8.2279053
    [216]      -5.5979352    -0.65412682      4.3631883      8.1238070
    [220]       10.618909      12.008537      12.428572      11.998322
    [224]       10.851132      9.1426744      6.9875827      4.3552670
    [228]       1.1808122     -1.9619246     -3.7718325     -4.9902153
    [232]      -6.5794806     -6.2191367     -4.5432658     -4.6821666
    [236]      -7.6644659     -9.4103413     -1.7170604      5.9820728
    [240]       12.242079      17.045406      20.572651      23.003557
    [244]       24.465973      25.040161      24.776714      23.727842
    [248]       22.002655      19.815603      17.337980      14.197899
    [252]       8.8701982     -3.2716842      5.3655334      9.1666260
    [256]       9.1275082      7.1852050      6.8218117      8.8875256
    [260]       10.558105      11.746680      12.880876      13.761587
    [264]       14.197883      14.740170      16.326586      18.627089
    [268]       20.628904      21.873795      22.283968      21.910131
    [272]       20.872654      19.362644      17.576468      15.508186
    [276]       12.774214      8.5766449      1.0998186     -11.112218
    [280]      -2.1481044     0.31230780      2.5380759      4.8766632
    [284]       5.7629671      4.7228007      3.4726453      6.7685165
    [288]       10.779583      13.503173      15.631559      17.971239
    [292]       20.503805      22.667042      24.096727      24.678444
    [296]       24.402622      23.307152      21.500696      19.217793
    [300]       16.724409      13.920526      10.394255      7.6831641
    [304]       8.5719671      8.9127970      5.7430401     0.38727909
    [308]       9.9742556      15.315306      18.319283      20.099104
    [312]       21.097322      21.552301      21.744947      22.101715
    [316]       22.884605      23.830341      24.480562      24.564217
    [320]       24.002804      22.821934      21.097275      18.923733
    [324]       16.396502      13.605543      10.618123      7.4268446
    [328]       3.9632831     0.25464410     -3.2362185     -4.4210234
    [332]      -3.0186756     -2.5947900     -5.2767940     -15.039741
    [336]      -6.3734450    -0.70153517      1.4717046      2.5992706
    [340]       4.6855612      7.7395678      10.475796      12.400504
    [344]       13.493933      13.841925      13.546516      12.700236
    [348]       11.356955      9.5102406      7.1330905      4.3370380
    [352]       1.5627346    -0.86811399     -3.7442405     -8.5553226
    [356]      -12.230250     -8.1243591     -6.1650600     -6.5848608
    [360]      -7.3058376     -5.1646757     -2.2759736    -0.43402976
    [364]      0.73559475      2.3596361      4.8291183      7.2687769
    [368]       9.0193310      9.9128609      9.9655924      9.2422895
    [372]       7.8260202      5.8156042      3.3253694     0.48689562
    [376]      -2.5743473     -5.9379368     -10.311619     -16.253321
    [380]      -14.112745     -9.8154125     -7.7290621     -6.7120657
    [384]      -5.9726844     -5.3898830     -5.2386122     -5.5238643
    [388]      -5.3331947     -3.3207371    -0.29738328      2.3326955
    [392]       4.1239300      5.0512953      5.2156267      4.8023410
    [396]       4.0705843      3.2478082      2.3791077      1.3672289
    [400]      0.12378006     -1.5114981     -4.0961008     -9.2005157
    [404]      -22.562315     -10.556159     -6.1489372     -5.4156270
    [408]      -7.1656775     -9.3267841     -6.5319667     -3.1145732
    [412]      -1.1635760     0.10041991      1.8653243      4.4016886
    [416]       6.9219751      8.9016838      10.242961      11.004536
    [420]       11.263341      11.051008      10.330110      9.0272875
    [424]       7.1560192      5.0658545      3.4517410      2.2669833
    [428]      0.36511981     -3.3799448     -7.1556206     -4.0884252
    [432]      -1.5049056    -0.90747648     -1.3024108     -1.4707385
    [436]      -1.1550765     -1.1577526     -1.6826004     -1.6790168
    [440]     -0.25640538      1.5222524      2.6726882      2.9344282
    [444]       2.2784340     0.78513587     -1.1578033     -2.7102911
    [448]      -3.5851684     -4.6288934     -6.4015989     -8.5645723
    [452]      -10.619339     -13.492548     -19.850502     -30.092134
    [456]      -19.445080     -16.594915     -15.233355     -13.969588
    [460]      -13.128971     -11.411671     -7.6406279     -3.8357151
    [464]      -1.0029153     0.87703538      1.9835755      2.4848435
    [468]       2.5241470      2.2144241      1.6181779     0.73577660
    [472]     -0.46203420     -1.9446788     -3.4920142     -4.6715517
    [476]      -5.2526398     -5.6047878     -6.2932405     -7.6118793
    [480]      -9.1935453     -9.4474926     -7.8379641     -6.0180435
    [484]      -4.7348495     -3.9264743     -3.3908420     -3.0251079
    [488]      -2.8580604     -2.9696236     -3.4247427     -4.2677221
    [492]      -5.5479355     -7.3408527     -9.7544050     -12.909468
    [496]      -16.797365     -20.511593     -21.692940     -21.115921
    [500]      -21.025862     -22.056170     -24.186287     -26.472351
    [504]      -27.102453     -27.025042     -28.152693     -31.322655
    [508]      -37.714561     -57.264080     -44.902828     -41.267120
    [512]      -40.604298
  [Tag]         3201
  [frame_len]          320
[Record 21]
  [tot_power]       1549045.0
  [re_spec_val]
    [0]      -17.271709     -18.439447     -22.070423     -20.259647
    [4]      -18.682360     -26.831640     -15.374173     -10.632806
    [8]      -13.387841     -21.993240     -8.5368109     -9.1144428
    [12]      -14.524410    -0.91793525      1.3341222     -9.7750273
    [16]       4.5362296      10.534073      6.4256749      15.499410
    [20]       26.989311      33.498425      37.752720      40.483143
    [24]       41.985321      42.386036      41.716564      39.928699
    [28]       36.874668      32.224464      25.161625      12.654950
    [32]       8.1006575      10.049934      5.8693829    -0.67099500
    [36]      -2.8117645     -1.5542425     0.57843250      1.8679345
    [40]      0.29942426     -7.1316705      2.8612216      16.258535
    [44]       25.189821      31.583275      36.203381      39.444206
    [48]       41.524998      42.566792      42.625332      41.702953
    [52]       39.745548      36.620441      32.051865      25.418806
    [56]       14.945813      5.5342736      7.6816001      3.1172020
    [60]      -9.8724289     -9.4951077     -3.6323547    -0.95198274
    [64]     -0.75405103     -2.4700041     -3.4965866     -2.6378162
    [68]      -1.9199377   -0.069230340      3.9323671      7.9019914
    [72]       10.908790      12.902667      13.926865      13.976932
    [76]       12.983302      10.791439      7.0893817      1.1341302
    [80]      -9.8499794     -15.257041     -10.558622     -11.966236
    [84]      -16.075445     -21.398550     -22.595381     -19.416149
    [88]      -17.552202     -18.049477     -22.621166     -41.452148
    [92]      -24.065647     -32.697422     -10.351610    -0.82693863
    [96]       5.2072816      9.3201313      12.047570      13.627683
    [100]       14.168797      13.701983      12.193429      9.5306253
    [104]       5.4672480    -0.55375463     -10.155815     -23.567926
    [108]      -19.145472     -22.958761     -34.720108     -40.167564
    [112]      -30.234472     -24.122425     -22.935806     -24.430403
    [116]      -21.323931     -17.544222     -13.750905     -7.3016939
    [120]      -1.4002787      2.9296272      5.8875136      7.6863337
    [124]       8.4495993      8.2288246      7.0157213      4.7390494
    [128]       1.2430123     -3.7475619     -10.457951     -16.582664
    [132]      -18.458870     -21.315874     -26.770679     -32.436211
    [136]      -28.748806     -22.382854     -19.123945     -18.818527
    [140]      -21.169178     -20.837957     -16.978077     -14.518733
    [144]      -9.4234505     -3.0187933      1.8963677      5.2860007
    [148]       7.4136591      8.4526281      8.4930363      7.5625029
    [152]       5.6318846      2.6041710     -1.7251222     -7.7813234
    [156]      -16.625721     -31.771826     -29.689821     -26.708645
    [160]      -24.536720     -22.267763     -20.218771     -19.607546
    [164]      -21.335300     -22.988209     -19.437887     -16.076414
    [168]      -10.408973     -3.7001030      1.5083627      5.1731296
    [172]       7.5505147      8.8123760      9.0481710      8.2861214
    [176]       6.5069571      3.6671855    -0.18414401     -4.3943939
    [180]      -7.2634473     -8.8304653     -10.805810     -13.605696
    [184]      -16.363012     -17.377188     -16.303083     -14.700013
    [188]      -13.728860     -13.616928     -13.884474     -13.897874
    [192]      -12.845675     -8.0512657     -1.9029219      3.0510118
    [196]       6.6590533      9.1047354      10.531516      11.026719
    [200]       10.634315      9.3634624      7.1929369      4.0795813
    [204]    0.0014924301     -4.8579087     -9.6916008     -13.480696
    [208]      -16.280790     -17.595087     -17.170872     -15.737023
    [212]      -14.173104     -13.879991     -16.203009     -22.939819
    [216]      -22.159784     -13.262712     -4.1241984      2.8969884
    [220]       7.9584951      11.531285      13.916983      15.293893
    [224]       15.763383      15.371713      14.114818      11.930240
    [228]       8.6805859      4.1745453     -1.3501152     -5.2063413
    [232]      -6.5370822     -8.8016357     -11.392381     -9.4806862
    [236]      -5.0034671     -1.7498995    -0.90068597     -3.4548538
    [240]      -4.1044183      2.6708157      6.0634665      8.6660290
    [244]       14.459556      20.375360      24.777262      27.802757
    [248]       29.678106      30.547403      30.492325      29.558216
    [252]       27.782381      25.244753      22.169306      19.019567
    [256]       16.251404      13.817485      11.503632      9.5662069
    [260]       8.3716984      7.6754990      7.0249491      6.0595536
    [264]       4.2019281      1.0055615    -0.83645570     0.79487056
    [268]       4.3942556      11.178958      16.921146      20.877541
    [272]       23.360893      24.613907      24.769806      23.880472
    [276]       21.926712      18.808393      14.326060      8.3336782
    [280]       2.5297694     0.39430466     -2.2957401     -8.9635811
    [284]      -11.130599     -5.1319156     -1.7711658     0.28047830
    [288]      0.76820242    -0.25929883    -0.78868163     0.13315076
    [292]       4.1470795      12.188044      18.631535      23.175133
    [296]       26.240879      28.087528      28.845625      28.556803
    [300]       27.183550      24.594063      20.545332      15.090035
    [304]       11.918995      12.767643      12.705781      11.182500
    [308]       8.8270226      6.9218860      7.4996462      10.111573
    [312]       12.535885      13.862296      13.856694      12.474507
    [316]       10.083260      8.5060120      10.978119      16.357586
    [320]       21.293461      24.924723      27.284317      28.495890
    [324]       28.640985      27.743757      25.763538      22.567348
    [328]       17.840633      10.752634     -1.8455297     -2.8981693
    [332]     -0.48831305     -3.0378351     -10.102461     -12.111676
    [336]      -5.8609896     -4.6532502     -8.2770338     -22.113640
    [340]      -4.5809298    -0.55901414     -1.6187060     -9.3626747
    [344]       3.9550209      10.931923      14.835364      16.973700
    [348]       17.772697      17.380581      15.793713      12.847960
    [352]       8.0534878    -0.24872595     -11.038640     -3.1909909
    [356]      -2.1821334     -3.9171486     -6.7213469     -8.1426725
    [360]      -7.4126744     -6.4849596     -6.5451651     -7.9590158
    [364]      -9.1248579     -8.0672846     -9.2671413     -12.023382
    [368]      0.46537575      7.3755460      11.591023      14.145052
    [372]       15.434979      15.643233      14.853410      13.094010
    [376]       10.367210      6.7015252      2.2851465     -2.4009664
    [380]      -7.1528234     -13.100667     -21.829487     -28.194979
    [384]      -23.607075     -13.572781     -8.7266760     -7.0465617
    [388]      -8.2854757     -13.527472     -16.806583     -12.133657
    [392]      -8.2845411   -0.064921886      6.3270206      10.614046
    [396]       13.353774      14.857233      15.274468      14.650187
    [400]       12.931688      9.9245291      5.1125460     -3.2467465
    [404]      -17.785568     -7.0455351     -5.8113074     -6.2326155
    [408]      -5.0899215     -2.9896884     -1.4815460     -1.1096144
    [412]      -2.2610245     -4.5365548     -4.0096779     -2.1433225
    [416]      -3.9051754     -3.0827527      6.5198941      12.232294
    [420]       15.624713      17.437355      17.959450      17.283363
    [424]       15.363855      11.983829      6.5978656     -1.2456197
    [428]      -1.8524785     0.60674602     0.74996781    -0.32296032
    [432]      -1.7881802     -3.1307783     -4.0863552     -4.6283741
    [436]      -5.0173621     -5.5120392     -5.9036608     -5.2953272
    [440]      -2.8024876      1.1219903      5.2496419      8.8321247
    [444]       11.629008      13.608312      14.796854      15.228904
    [448]       14.930243      13.912607      12.169521      9.6683140
    [452]       6.3297162      1.9688076     -3.9131775     -13.204706
    [456]      -22.047859     -13.297422     -10.531357     -9.4826031
    [460]      -9.4637394     -10.664929     -13.539454     -16.426348
    [464]      -14.041836     -11.631603     -10.253091     -7.1312118
    [468]      -3.0369687    0.019679064      1.7193676      2.1827102
    [472]       1.6150163     0.44421315    -0.51708937    -0.78379041
    [476]     -0.97705960     -1.8774399     -3.8947423     -7.3216496
    [480]      -12.673140     -21.650953     -43.264336     -26.533268
    [484]      -24.308355     -23.379248     -22.351587     -21.622782
    [488]      -22.060066     -24.423197     -29.345234     -34.635998
    [492]      -29.782562     -21.357019     -15.329234     -11.467757
    [496]      -9.2795458     -8.4927530     -8.9956455     -10.786609
    [500]      -13.863110     -17.453405     -18.579365     -17.632458
    [504]      -17.348379     -18.231371     -20.206270     -23.204222
    [508]      -27.182919     -31.894039     -36.235931     -38.672245
    [512]      -39.362862
  [Tag]         3361
  [frame_len]          320
[Record 22]
  [tot_power]       847543.62
  [re_spec_val]
    [0]      -17.153278     -20.502026     -38.714973     -19.813465
    [4]      -18.764011     -21.041746     -16.078321     -15.892945
    [8]      -21.679008     -11.290797     -9.1829786     -20.589334
    [12]      -7.4036503     -2.8023362     -12.483086      1.9490739
    [16]       9.4410648      9.9473619      9.9454355      22.734068
    [20]       30.196463      35.053471      38.266037      40.217445
    [24]       41.085964      40.951244      39.832573      37.706444
    [28]       34.526993      30.293642      25.265079      20.141691
    [32]       14.920843      7.7093983      1.2939061      2.5898874
    [36]      -1.5193790     -9.1324902     -1.4574525      5.0306196
    [40]       10.865602      13.729874      14.101723      18.201717
    [44]       25.203598      30.312059      33.690578      35.724979
    [48]       36.630516      36.517490      35.435310      33.400749
    [52]       30.435678      26.658220      22.463097      18.474333
    [56]       14.686733      10.266324      5.0052304      1.5798815
    [60]      0.42846319     -1.3367177     -1.4160684     0.24900937
    [64]      0.46310505    -0.53476781     0.57675791      3.1732962
    [68]       4.4540524      3.8901246      1.3120923     -1.9506971
    [72]       1.2736593      5.6140122      8.1945152      9.3578606
    [76]       9.3681984      8.3751011      6.4920673      3.8388047
    [80]      0.54712826     -3.2584691     -7.3321986     -10.749449
    [84]      -12.509171     -13.829119     -16.176031     -18.301781
    [88]      -15.710569     -12.239173     -9.9008121     -7.8994389
    [92]      -5.1818185     -1.9099599      1.0647259      3.3433931
    [96]       4.8956947      5.8206468      6.2492671      6.3026061
    [100]       6.0700197      5.6032672      4.9105186      3.9392240
    [104]       2.5756037     0.69867057     -1.6966143     -4.2997699
    [108]      -6.4489026     -7.7421012     -8.1968851     -7.7938461
    [112]      -7.0129128     -6.5622058     -6.6337428     -6.7312045
    [116]      -6.0765438     -4.7982125     -3.6284494     -2.8374710
    [120]      -2.2502456     -1.6752334     -1.2394416     -1.2905533
    [124]      -2.1541808     -4.1164403     -7.6248355     -14.102205
    [128]      -48.956749     -15.557716     -10.767606     -8.7088585
    [132]      -8.0121412     -8.2380667     -9.0450115     -9.9625444
    [136]      -10.480676     -10.363443     -9.5849113     -8.1098022
    [140]      -6.0892906     -3.9209228     -2.0003076    -0.59620494
    [144]      0.12562796    0.070735216    -0.73687494     -1.9007787
    [148]      -2.3676679     -1.6628438    -0.85406923    -0.83106464
    [152]      -1.9051442     -4.1725674     -7.4890919     -10.745070
    [156]      -12.220751     -12.989980     -14.012317     -13.819407
    [160]      -12.048997     -10.366974     -9.3463039     -8.7786722
    [164]      -8.2020073     -7.1071105     -5.3296261     -3.2347786
    [168]      -1.3054603     0.17143528      1.0901884      1.4369109
    [172]       1.2106007     0.33889371     -1.4324709     -4.7754230
    [176]      -12.094414     -19.758160     -7.8820453     -4.1537681
    [180]      -2.7389483     -2.5464733     -3.0357656     -3.7972481
    [184]      -4.5283890     -5.0686460     -5.3678412     -5.4288468
    [188]      -5.2435422     -4.6984267     -3.6396511     -2.2012076
    [192]     -0.80743188     0.24560514      1.0364066      1.9491166
    [196]       3.1835878      4.3831134      5.0278115      4.7633042
    [200]       3.3492234     0.62791049     -2.6688662     -3.0506773
    [204]      -1.3822870    -0.77329659     -1.6481415     -3.8088350
    [208]      -6.3931723     -7.3353119     -6.6249866     -5.9756627
    [212]      -5.6703424     -5.2683625     -4.4559774     -3.3839250
    [216]      -2.3807750     -1.6121184    -0.98298723    -0.24282679
    [220]      0.64874989      1.3307843      1.3463504     0.43708268
    [224]      -1.1037735     -1.6178610    -0.15496083      1.4160138
    [228]       2.0815668      1.8509649      1.2430693      1.2740006
    [232]       2.4276619      4.0161090      5.4765201      6.6680779
    [236]       7.5090804      7.8974538      7.8609242      7.7441640
    [240]       8.2287989      9.8138380      12.211698      14.693042
    [244]       16.685444      17.893166      18.217213      17.821901
    [248]       17.591085      18.908972      21.261631      23.283131
    [252]       24.442690      24.572983      23.470236      20.613613
    [256]       14.096848      3.4998920      16.726004      20.859297
    [260]       22.642736      23.306170      23.410498      23.314913
    [264]       23.248051      23.330091      23.586191      23.930431
    [268]       24.164665      24.027952      23.246742      21.535921
    [272]       18.574572      14.357580      12.216748      14.238024
    [276]       15.641161      15.617636      14.448096      12.476471
    [280]       10.314742      9.0574865      9.1865206      9.8703480
    [284]       10.470386      10.959295      11.598572      12.643741
    [288]       14.110407      15.817755      17.568552      19.200155
    [292]       20.582354      21.638016      22.349674      22.730076
    [296]       22.782185      22.498209      21.928438      21.271341
    [300]       20.785461      20.416576      19.682728      17.989374
    [304]       14.845630      11.248696      12.634930      15.606801
    [308]       17.298634      18.136702      18.785522      19.762987
    [312]       21.212828      22.907955      24.538914      25.924648
    [316]       27.017223      27.820715      28.323536      28.485573
    [320]       28.274126      27.720617      26.978992      26.329617
    [324]       25.993900      25.865381      25.583765      24.816942
    [328]       23.385672      21.340363      19.223093      18.070864
    [332]       17.989759      18.078321      17.937681      17.718180
    [336]       17.694757      17.971359      18.409540      18.750759
    [340]       18.734856      18.118250      16.603754      13.637979
    [344]       7.6056724    0.053769559      9.9891300      14.211293
    [348]       16.038605      16.417404      15.644782      13.831429
    [352]       11.114767      8.0536108      6.0466409      5.8080163
    [356]       6.5702372      7.8914227      9.4432545      10.856196
    [360]       11.949975      12.695931      13.104888      13.165743
    [364]       12.818621      11.931253      10.256320      7.3934412
    [368]       3.8077066      5.7016830      10.248897      13.317664
    [372]       15.032918      15.627216      15.187753      13.718222
    [376]       11.216237      7.9100542      4.8999462      3.7979550
    [380]       4.5797915      6.7033420      9.2334013      11.340066
    [384]       12.791401      13.617714      13.869619      13.518302
    [388]       12.386687      9.9986496      4.8525186     -24.618103
    [392]       5.2553635      10.900433      13.482785      14.456193
    [396]       14.316595      13.482714      12.541686      11.911227
    [400]       11.322506      10.494917      10.289765      11.799942
    [404]       13.922706      15.534732      16.457731      16.838442
    [408]       16.881588      16.772638      16.632824      16.477627
    [412]       16.204914      15.648178      14.712478      13.685388
    [416]       13.559029      14.764808      16.153765      16.772142
    [420]       16.239727      14.307958      10.746138      6.8562579
    [424]       7.4339805      8.8179455      8.0977335      4.6268020
    [428]      -4.6731744     -6.3824916      1.4597750      3.6188691
    [432]       3.9983611      3.6143551      2.6594267     0.88745433
    [436]      -1.9081734     -4.9224720     -5.0397577     -2.8846951
    [440]     -0.90283817      1.0196848      3.3760731      5.7604990
    [444]       7.4754071      8.1513414      7.6350322      5.8624749
    [448]       3.0397205     0.41046819    -0.77118391     -2.4907248
    [452]      -8.0857582     -17.304319     -4.0293922    0.066059344
    [456]       1.5355346      1.5886388     0.85714400    -0.14963445
    [460]      -1.2162422     -2.6074662     -4.8503752     -8.5021830
    [464]      -12.607875     -10.341684     -6.4002867     -3.8255644
    [468]      -2.2225518     -1.2465918    -0.72430247    -0.60532516
    [472]     -0.91709024     -1.7399645     -3.2362926     -5.7595010
    [476]      -10.141162     -17.178371     -13.050212     -8.0974216
    [480]      -5.6473761     -4.5695276     -4.3494568     -4.6915159
    [484]      -5.3864107     -6.3069167     -7.4760451     -9.1165504
    [488]      -11.646189     -15.703647     -20.699898     -18.229820
    [492]      -14.323484     -12.259195     -11.464818     -11.511386
    [496]      -12.071407     -12.868407     -13.743140     -14.724976
    [500]      -16.019150     -17.972832     -21.088676     -25.918556
    [504]      -29.575111     -27.038885     -25.087416     -23.831791
    [508]      -21.774857     -19.267960     -17.262680     -16.059195
    [512]      -15.663842
  [Tag]         3521
  [frame_len]          320
[Record 23]
  [tot_power]       150186.02
  [re_spec_val]
    [0]      -20.958773     -19.103455     -17.956446     -19.096354
    [4]      -19.682592     -18.810879     -18.866396     -16.730896
    [8]      -14.132275     -14.216217     -14.143186     -11.085380
    [12]      -9.0476551     -4.4074955   -0.096968092     -1.6233051
    [16]     -0.73097557      14.279694      21.913589      26.977324
    [20]       30.442390      32.686226      33.889503      34.141495
    [24]       33.478588      31.903519      29.406387      26.016895
    [28]       21.939564      17.687241      13.562739      8.7839661
    [32]       2.0974143     -7.1478958     -16.662983    -0.73698246
    [36]       4.5982881      7.0476580      10.337786      15.312325
    [40]       19.579725      22.521744      24.242325      24.882969
    [44]       24.568407      23.506741      22.201777      21.421829
    [48]       21.274244      21.003990      19.985092      17.933252
    [52]       14.733628      10.548751      6.4954023      3.8285947
    [56]      0.78561580     -5.9484444     -14.943366     -3.2006667
    [60]      0.58557868      2.3667653      3.6689193      5.1850486
    [64]       6.7166834      7.7501655      8.0101776      7.4552975
    [68]       6.2018652      4.5520639      3.0081370      1.9481045
    [72]       1.1949972     0.27605605     -1.1736313     -3.4029033
    [76]      -6.6693726     -11.352892     -18.155542     -30.473057
    [80]      -28.192081     -18.764977     -14.131574     -11.509443
    [84]      -9.9131441     -8.6965542     -7.7329936     -7.3705363
    [88]      -8.0487843     -10.132376     -13.305774     -13.332628
    [92]      -10.142240     -7.9559817     -7.1115398     -7.3697691
    [96]      -8.5897522     -10.736822     -13.860008     -18.080248
    [100]      -23.594191     -29.439728     -26.665419     -21.276203
    [104]      -17.310234     -14.404268     -12.256151     -10.686422
    [108]      -9.5530243     -8.6643763     -7.7628341     -6.6864824
    [112]      -5.5567989     -4.6746793     -4.3015876     -4.5979333
    [116]      -5.6644015     -7.5974112     -10.555507     -14.890093
    [120]      -21.261051     -24.677427     -20.167503     -17.272903
    [124]      -15.720071     -14.932119     -14.639027     -14.638520
    [128]      -14.647135     -14.408154     -13.997105     -13.766432
    [132]      -14.043584     -15.112925     -17.475716     -22.223192
    [136]      -23.955950     -17.149267     -13.059153     -10.907809
    [140]      -10.034321     -10.137280     -11.158125     -13.424806
    [144]      -18.288019     -28.478983     -17.079796     -11.705624
    [148]      -9.0948896     -8.0037870     -7.9971089     -8.8416452
    [152]      -10.318317     -12.101294     -13.787460     -15.298693
    [156]      -17.192497     -20.508509     -27.750244     -37.552082
    [160]      -24.872833     -21.686268     -21.078449     -21.736084
    [164]      -22.749557     -23.034815     -21.044140     -17.582548
    [168]      -14.671833     -12.911890     -12.264706     -12.484907
    [172]      -13.150135     -13.880102     -14.802876     -16.024773
    [176]      -15.326274     -11.666849     -8.2762880     -6.1657267
    [180]      -5.3525782     -5.8435693     -7.7949905     -11.615526
    [184]      -17.673641     -19.489555     -16.386866     -14.303574
    [188]      -11.902529     -9.2873354     -7.2433600     -5.9771166
    [192]      -5.4034362     -5.4158010     -5.9867439     -7.1975875
    [196]      -9.2049017     -11.922606     -13.484144     -11.837331
    [200]      -9.8855286     -9.2589016     -10.214846     -12.193474
    [204]      -11.322253     -7.6341624     -4.8793125     -3.5056696
    [208]      -3.3556573     -4.3359170     -6.4331050     -9.6332827
    [212]      -13.569372     -16.715626     -18.087830     -19.292345
    [216]      -20.922457     -21.948942     -21.577635     -19.961157
    [220]      -17.261751     -14.392889     -12.311575     -11.526381
    [224]      -12.428865     -15.101726     -14.904667     -10.491729
    [228]      -7.7607470     -7.2318034     -8.9351664     -11.488993
    [232]      -8.2744017     -4.1525588     -1.8868438     -1.0365136
    [236]     -0.99009949    -0.91951889    -0.17426968      1.0323150
    [240]       2.1874979      3.0695016      3.6399558      3.8568857
    [244]       3.5678840      2.4175918    -0.38577983     -7.3167830
    [248]      -8.1001930     0.42975262      4.0367680      5.2826505
    [252]       4.6962867      2.8110228      3.3890660      7.4562516
    [256]       10.829789      12.988958      14.277160      15.025609
    [260]       15.435054      15.514185      15.141531      14.210752
    [264]       12.754386      11.048943      9.6703167      9.2544899
    [268]       9.9128332      11.107978      12.243488      13.011208
    [272]       13.309361      13.091265      12.285395      10.785274
    [276]       8.4820194      5.3697944      1.9889852     0.23892714
    [280]      0.99263924      2.4966495      3.7243698      4.3218789
    [284]       4.0658693      2.7036936    -0.17268416     -4.2537546
    [288]      -2.5493467      1.8103764      4.2851763      5.0581841
    [292]       4.2685218      1.7924095     -2.6173708     -7.1401353
    [296]      -4.9086661    -0.25368026      3.8426912      6.5894771
    [300]       7.6846609      6.9043136      4.3013992      4.4511766
    [304]       8.8484440      11.844351      13.056259      12.678714
    [308]       10.516406      5.4227710      1.0873263      9.3949709
    [312]       13.866649      15.958281      16.225204      14.431658
    [316]       9.0043325      1.0700911      12.080314      16.144979
    [320]       17.461248      16.968031      14.949225      12.001887
    [324]       10.855164      12.681834      14.695196      16.055540
    [328]       16.630844      16.153362      14.090769      8.9796476
    [332]      -4.6873775      9.4568777      14.606601      17.073526
    [336]       18.275269      18.659475      18.359943      17.393404
    [340]       15.773317      13.598931      11.315888      10.398678
    [344]       11.767983      13.597412      14.583242      14.376544
    [348]       12.796981      9.4835873      3.5418484     -1.7892369
    [352]       3.0608406      5.5556369      5.9483376      4.8331404
    [356]       2.0753803     -3.8583066     -16.360422     -1.4755754
    [360]       3.5475898      5.9775252      6.9121976      6.6398406
    [364]       5.2018046      2.6613247     0.14057472     0.33928207
    [368]       1.6513437      1.6194589    -0.32803667     -2.2057405
    [372]      0.85388023      3.8637290      4.6093774      2.4877949
    [376]      -6.5253873     -1.6144184      6.7259355      10.554317
    [380]       12.523129      13.320354      13.222792      12.358112
    [384]       10.730680      8.2060366      6.0256224      9.1667423
    [388]       13.656499      16.672237      18.259682      18.577169
    [392]       17.685661      15.608522      12.599858      10.065156
    [396]       9.7398138      10.031477      9.2776346      6.7512918
    [400]       2.7221942      5.6499562      10.802462      14.091276
    [404]       16.160103      17.448395      18.147617      18.320801
    [408]       18.018589      17.359943      16.508377      15.502253
    [412]       14.103529      11.841919      8.0616102      2.4756477
    [416]       2.4625154      6.1524196      7.8586893      8.1517773
    [420]       7.7063904      7.0728946      6.4669528      5.7485166
    [424]       5.1523070      5.8953581      8.1305532      10.383501
    [428]       11.887762      12.498457      12.202619      10.959975
    [432]       8.6274662      4.8322468     -1.0554413     -3.2814071
    [436]       1.4169079      4.2891197      5.7303920      6.3042431
    [440]       6.2677236      5.6865873      4.5275779      2.8558648
    [444]       1.1993611     0.40788558     0.15472662    -0.81228745
    [448]      -3.3190870     -5.9264374     -2.9976473     0.62828082
    [452]       2.5588341      2.9921300      2.1396356     0.48190677
    [456]     -0.21586895      1.1717731      2.6528857      3.0259185
    [460]       1.9951992    -0.71303707     -5.4367528     -8.3005514
    [464]      -5.0242934     -2.9883771     -2.6939299     -3.6586421
    [468]      -5.6342201     -8.7588625     -14.267519     -26.492525
    [472]      -14.075446     -8.4488955     -5.3775382     -3.5386245
    [476]      -2.6149528     -2.6312699     -3.7723370     -6.3023295
    [480]      -9.8913784     -10.012049     -6.4076972     -3.3292882
    [484]      -1.0067235     0.70290917      1.7789180      2.1789677
    [488]       1.9041905      1.0025508    -0.43481722     -2.2681632
    [492]      -4.2968802     -6.2402315     -7.7083707     -8.2646723
    [496]      -7.8145180     -6.8224950     -5.8345847     -5.1523871
    [500]      -4.8931160     -5.0914154     -5.7232580     -6.6356592
    [504]      -7.3949189     -7.3731265     -6.4790978     -5.2975225
    [508]      -4.3232956     -3.7294593     -3.4898832     -3.4662514
    [512]      -3.4859014
  [Tag]         3681
  [frame_len]          320
[Record 24]
  [tot_power]       34603.105
  [re_spec_val]
    [0]      -55.928654     -29.220055     -24.660564     -24.052689
    [4]      -27.171085     -35.879200     -26.776463     -21.842545
    [8]      -19.675844     -18.730530     -17.415403     -12.674683
    [12]      -7.7562780     -5.2029500     -5.5669975     -3.1622701
    [16]       5.0687227      11.087961      15.156942      17.815798
    [20]       19.335772      19.855312      19.450119      18.181896
    [24]       16.167133      13.686396      11.190939      8.8709908
    [28]       6.3099017      3.0477498    -0.45979267     -2.2819712
    [32]      -2.3097291     -1.9628848     -1.4725883     -1.0676302
    [36]     -0.43923441      2.6133435      7.3157430      11.277032
    [40]       13.981361      15.449562      15.699017      14.642263
    [44]       12.037527      7.8251071      6.2527266      9.4024611
    [48]       11.452105      11.946168      11.209883      9.4324656
    [52]       6.7008467      3.0462050     -1.5131562     -6.8584528
    [56]      -12.315248     -15.656950     -14.847654     -11.991693
    [60]      -9.4248304     -7.8060341     -7.1537166     -7.2804217
    [64]      -7.8074260     -8.2079840     -8.2621565     -8.3540621
    [68]      -8.9995756     -10.490715     -12.862941     -15.803016
    [72]      -18.743910     -21.969868     -27.346283     -31.223507
    [76]      -24.564304     -21.032309     -19.512020     -19.155878
    [80]      -19.477476     -19.909611     -19.876425     -19.441643
    [84]      -19.151474     -19.274035     -19.563107     -19.435371
    [88]      -18.741528     -18.099735     -18.181744     -19.476973
    [92]      -22.638990     -29.309986     -32.294724     -26.194077
    [96]      -24.939007     -28.140186     -33.189507     -22.994219
    [100]      -18.026251     -15.799845     -15.433382     -16.780611
    [104]      -20.153807     -25.922029     -25.873524     -21.681051
    [108]      -19.837070     -19.782360     -21.330233     -24.987499
    [112]      -32.171024     -29.027431     -23.303652     -20.759422
    [116]      -20.292334     -21.847866     -26.129646     -30.400902
    [120]      -24.745636     -21.150475     -19.557909     -18.936798
    [124]      -18.640633     -18.415796     -18.334421     -18.468613
    [128]      -18.683018     -18.718676     -18.492561     -18.209538
    [132]      -18.120741     -18.363644     -19.023838     -20.210594
    [136]      -21.877720     -23.039688     -22.070705     -20.012056
    [140]      -18.342239     -17.323879     -16.870377     -16.933956
    [144]      -17.546427     -18.725800     -20.339756     -21.999968
    [148]      -23.238190     -24.046072     -24.995646     -26.918051
    [152]      -30.759003     -33.306576     -28.545504     -25.501040
    [156]      -24.828112     -25.925318     -26.158127     -22.380178
    [160]      -18.366964     -15.552501     -13.850672     -13.140484
    [164]      -13.386107     -14.611224     -16.752827     -18.771870
    [168]      -17.996904     -15.520111     -13.629244     -12.777538
    [172]      -13.011930     -14.449078     -17.431200     -22.745859
    [176]      -27.105875     -21.989609     -18.695099     -17.348505
    [180]      -17.401203     -18.416498     -18.754782     -16.686571
    [184]      -14.137490     -12.521002     -12.017365     -12.586850
    [188]      -14.212113     -16.914728     -20.670532     -24.997971
    [192]      -27.859819     -27.562731     -26.361534     -26.363443
    [196]      -29.073145     -36.827560     -28.970919     -22.971087
    [200]      -19.876917     -17.925518     -16.429083     -15.481597
    [204]      -15.638887     -17.791935     -24.665949     -26.550423
    [208]      -16.917797     -13.232943     -11.945465     -12.311542
    [212]      -14.124162     -17.226274     -20.158356     -19.421406
    [216]      -17.176092     -15.697032     -15.020418     -14.804001
    [220]      -14.912592     -15.810997     -18.509193     -21.346081
    [224]      -15.690837     -10.934458     -8.4107075     -7.5449686
    [228]      -8.1193209     -10.170881     -14.024485     -20.310860
    [232]      -23.473867     -19.002853     -15.456490     -12.141834
    [236]      -9.0522966     -6.6087031     -5.0184178     -4.2674942
    [240]      -4.0904016     -3.9105012     -3.2764382     -2.4227848
    [244]      -1.6430559    -0.67822564     0.74256438      2.2160323
    [248]       3.1549828      3.2617352      2.4740164     0.89917713
    [252]      -1.0955726     -2.7402933     -3.1699762     -2.2676013
    [256]     -0.70387858     0.82999569      1.9975849      2.7205229
    [260]       3.0134625      2.8828132      2.2709653      1.0099040
    [264]      -1.2628897     -5.3607659     -12.786647     -10.101365
    [268]      -4.8166375     -2.4547400     -1.5331881     -1.2510852
    [272]      -1.1806124     -1.3213495     -1.8523885     -2.7623196
    [276]      -3.8094249     -4.9470773     -6.7316194     -10.298205
    [280]      -17.200243     -13.764283     -8.5365877     -6.7399826
    [284]      -7.6027312     -10.229907     -6.8047729     -1.5334948
    [288]       1.6386765      3.1424091      3.2928231      2.2099152
    [292]    -0.033615150     -2.8810732     -4.0864482     -2.9879239
    [296]      -1.9427266     -1.5305427    -0.98260856     0.45828682
    [300]       2.2000992      3.2807398      3.2082129      1.9251671
    [304]       1.0479263      3.6211257      7.0715733      9.5768604
    [308]       11.230711      12.384864      13.285923      13.955845
    [312]       14.259598      14.061598      13.263539      11.625594
    [316]       8.1992779     -2.1489019      5.3035998      13.288283
    [320]       17.113605      18.954529      19.350206      18.486635
    [324]       16.425310      13.120341      8.1144848     0.87860501
    [328]       5.2626376      10.291338      12.912781      14.776055
    [332]       16.817987      18.735910      19.824829      19.701790
    [336]       18.272381      16.245296      16.357306      18.547764
    [340]       20.314260      21.224680      21.524782      21.424009
    [344]       20.935019      19.905952      18.115902      15.298090
    [348]       11.055051      4.6702266     -3.7644136     -5.6116428
    [352]      -6.9970617     -2.8410020      2.5507398      5.1764774
    [356]       5.6730342      4.2724047     0.74839813     -4.9637775
    [360]      -5.7421980     -3.1325581     -2.6773815     -2.4670527
    [364]     -0.24832805      2.2591441      3.6029458      3.5540078
    [368]       2.0426221     -1.0020458     -4.4774866     -4.5707960
    [372]      -3.4768853     -2.8083813     0.61286217      5.4101357
    [376]       9.2291203      11.948471      13.808835      15.010274
    [380]       15.690364      15.949356      15.891828      15.656157
    [384]       15.366070      14.998158      14.338717      13.148853
    [388]       11.480239      10.071739      9.6612959      9.5644922
    [392]       9.6602383      11.551325      14.498813      16.626783
    [396]       17.369083      16.547024      13.914363      10.264567
    [400]       11.760124      15.354700      17.564896      18.808773
    [404]       19.517246      19.728645      19.176327      17.448811
    [408]       13.897410      6.6910419     -11.858725      4.4545074
    [412]       6.4412274      5.7017455      4.9493518      4.7399192
    [416]       3.9450860      4.8284187      8.5066328      11.583304
    [420]       13.400909      14.286772      14.583464      14.478583
    [424]       13.959107      12.873334      10.996342      7.9676590
    [428]       3.0655074     -2.0646718      2.4612393      6.1941590
    [432]       7.8334861      8.0647430      7.4819655      7.0304923
    [436]       7.2917318      7.4115243      6.1649008      2.0319641
    [440]      -12.064595     0.98152262      6.5734305      8.8168221
    [444]       9.3720074      8.7584743      7.1376162      4.3841701
    [448]     0.054461099     -5.0422807     -3.1668606     0.35724413
    [452]       2.6301899      4.2479229      5.3298931      5.6813240
    [456]       5.1083908      3.4722104     0.59888458     -3.8365388
    [460]      -7.4888725     -2.8882523      1.5936530      4.3672905
    [464]       5.8302259      6.1965723      5.5654440      3.9771895
    [468]       1.4605807     -1.8138796     -4.9119997     -5.6274848
    [472]      -3.8826292     -1.5383376     0.56349164      2.1438451
    [476]       3.0915091      3.3428180      2.8140872      1.3443614
    [480]      -1.3736343     -5.6674914     -8.3574295     -5.1171656
    [484]      -2.5670683     -1.6527842     -1.9545701     -3.0631201
    [488]      -4.4984808     -5.8006773     -6.6457129     -6.5276151
    [492]      -5.2378411     -3.5981500     -2.3796439     -1.8421665
    [496]      -2.0232329     -2.9308710     -4.6217628     -7.2538466
    [500]      -11.169853     -17.002728     -24.131992     -26.050095
    [504]      -22.916843     -14.226585     -8.2728043     -4.6150250
    [508]      -2.6907640     -2.3511629     -3.7997587     -7.8374805
    [512]      -13.582302
  [Tag]         3841
  [frame_len]          320
[Record 25]
  [tot_power]       75234.117
  [re_spec_val]
    [0]      -39.566628     -38.163074     -34.884552     -33.407143
    [4]      -36.052830     -41.542099     -33.784134     -32.043663
    [8]      -31.764736     -25.187296     -21.351618     -21.210146
    [12]      -21.817965     -17.022984     -14.012081     -13.423314
    [16]      -7.8011899    -0.95085412      3.6399627      6.3664207
    [20]       7.5340743      7.2406397      5.5315990      3.1621304
    [24]       3.0553493      4.9486432      6.0919099      5.9401116
    [28]       4.5533104      1.9358655     -2.1988752     -8.9513311
    [32]      -16.327600     -10.947361     -9.1635599     -9.5550480
    [36]      -7.4134135     -2.3919628      1.8277532      4.6799903
    [40]       6.1393690      6.0265307      3.8121071     -1.0232137
    [44]       1.4331490      6.8597555      9.5836411      10.408436
    [48]       9.6930056      7.4892011      3.7115119     -1.0039358
    [52]      -2.5825219     -1.6125102     -1.6320822     -2.8648303
    [56]      -5.0451665     -7.9640055     -11.087013     -13.196054
    [60]      -14.285641     -15.661116     -17.348845     -18.129633
    [64]      -18.038927     -18.258017     -19.257658     -21.115910
    [68]      -24.114416     -29.154221     -29.117228     -21.833721
    [72]      -17.194735     -14.377304     -12.834478     -12.309084
    [76]      -12.680967     -13.918002     -16.032459     -18.983601
    [80]      -22.473993     -25.675400     -26.917015     -25.285099
    [84]      -23.044737     -21.677021     -21.303951     -21.481441
    [88]      -21.198635     -19.755737     -17.965326     -16.781506
    [92]      -16.539808     -17.153032     -18.025557     -18.231655
    [96]      -17.948236     -18.383482     -20.695944     -26.814066
    [100]      -27.057943     -19.845945     -16.759974     -16.107460
    [104]      -17.674809     -22.616066     -45.520134     -23.497711
    [108]      -18.818811     -17.488628     -18.027515     -19.966822
    [112]      -22.922470     -26.198700     -29.329180     -32.760284
    [116]      -29.510534     -22.769524     -17.995924     -14.772831
    [120]      -12.764232     -11.822770     -11.873966     -12.816755
    [124]      -14.343410     -15.735385     -16.406359     -16.844957
    [128]      -17.862743     -19.962015     -23.774843     -30.212736
    [132]      -26.800356     -20.912813     -17.743969     -16.300110
    [136]      -16.260281     -17.655455     -20.756845     -24.576017
    [140]      -22.624212     -19.293985     -17.914703     -18.489256
    [144]      -21.467016     -29.818739     -30.991629     -22.139353
    [148]      -18.951374     -17.791168     -17.829453     -18.813702
    [152]      -20.935396     -25.577032     -50.116848     -23.045515
    [156]      -16.493025     -13.023807     -11.263185     -10.747191
    [160]      -11.107551     -11.817179     -12.368453     -12.853984
    [164]      -13.750277     -15.047926     -15.821334     -15.599783
    [168]      -15.563548     -16.788338     -19.767344     -23.152872
    [172]      -21.702339     -19.503036     -19.220135     -20.679123
    [176]      -22.936176     -23.822308     -23.527645     -23.695978
    [180]      -23.365723     -21.296896     -18.914078     -17.060518
    [184]      -15.606318     -14.391527     -13.454494     -12.835029
    [188]      -12.413368     -11.991390     -11.527560     -11.205382
    [192]      -11.262355     -11.874199     -13.179211     -15.340244
    [196]      -18.480032     -21.504335     -20.467585     -17.347284
    [200]      -14.785236     -12.818610     -11.230548     -9.9494181
    [204]      -9.0295830     -8.5701056     -8.6400309     -9.2244701
    [208]      -10.199142     -11.396969     -12.771852     -14.277026
    [212]      -15.112723     -14.320560     -13.092216     -12.735587
    [216]      -13.365336     -13.833652     -12.797536     -11.443237
    [220]      -11.070984     -11.699117     -12.024217     -10.747958
    [224]      -9.2782421     -9.0170002     -10.541267     -13.985257
    [228]      -13.873014     -8.9614496     -5.4890981     -3.3751378
    [232]      -2.1467764     -1.5490836     -1.4301417     -1.5941863
    [236]      -1.6985230     -1.3904476    -0.68135476   0.0024140426
    [240]      0.10302790    -0.99277937     -4.1323414     -8.1287870
    [244]      -3.3296559     0.84929860      2.5161984      2.1443233
    [248]     -0.23104666     -3.7432814     -2.6515932     0.52612942
    [252]       2.1511915      2.3912766      1.6034765    0.076465055
    [256]      -1.7678506     -3.1298993     -3.5117977     -3.6979063
    [260]      -4.7221699     -7.2153454     -11.356505     -14.203771
    [264]      -11.804593     -7.7516184     -3.6502223    -0.58602858
    [268]       1.0607817      1.1845003    -0.46177098     -4.7626815
    [272]      -15.626239     -9.5923443     -4.3498158     -2.9289439
    [276]      -3.7262254     -6.9433432     -11.242218     -3.5969250
    [280]       2.5709164      6.4951806      8.9552917      10.235799
    [284]       10.420699      9.4781523      7.2896605      3.8323700
    [288]      0.55039275     0.49370033      1.0333475   -0.075362504
    [292]      -2.5126128     -2.3014004     0.95437074      3.4667530
    [296]       4.8469872      5.3122578      5.0047116      4.1003671
    [300]       3.1547318      3.6474903      6.4721556      10.027184
    [304]       13.045904      15.208310      16.488888      16.891796
    [308]       16.332882      14.481148      10.213097     -4.7651930
    [312]       8.0955362      14.978314      18.573986      20.930975
    [316]       22.618362      23.726856      24.131823      23.637892
    [320]       22.014725      19.027367      15.323616      15.419891
    [324]       18.375931      20.789803      22.652664      24.146402
    [328]       25.240980      25.895761      26.146309      26.076118
    [332]       25.776093      25.340969      24.864365      24.350466
    [336]       23.600969      22.219212      19.598425      14.345717
    [340]      -6.4322491      12.088888      17.504353      19.516611
    [344]       19.667484      18.183777      14.836297      10.205083
    [348]       11.088403      14.042703      15.032919      14.285544
    [352]       12.124764      9.4687672      9.0169191      10.692867
    [356]       12.090744      12.662378      12.482160      11.672293
    [360]       10.376351      8.8458166      7.5618095      7.2136240
    [364]       8.0966892      9.6315451      11.072618      12.019293
    [368]       12.321735      11.941869      10.909017      9.3405418
    [372]       7.4811568      5.7357531      4.8107195      5.3675437
    [376]       6.7078252      7.6753726      7.8874359      7.6380377
    [380]       7.5033646      7.4455771      6.6370988      4.0967112
    [384]      -1.8270729     -20.261351     -6.4779382     -5.2414498
    [388]      -3.8205221      2.6436188      7.1600389      9.8257999
    [392]       11.292622      12.002292      12.361989      12.751123
    [396]       13.200172      13.207901      12.021683      9.3092546
    [400]       10.537366      16.139332      20.185717      22.714802
    [404]       24.145971      24.755751      24.755445      24.323606
    [408]       23.584330      22.569027      21.221823      19.454887
    [412]       17.208956      14.583301      12.434961      12.555824
    [416]       14.243229      15.613906      16.102148      15.720511
    [420]       14.696726      13.438750      12.299132      11.191623
    [424]       9.9115248      9.0234280      9.5585699      10.882564
    [428]       11.803431      11.930939      11.315352      10.305871
    [432]       9.7396622      10.417442      11.839616      13.054041
    [436]       13.583176      13.219848      11.806110      9.3198967
    [440]       7.1834612      8.5849781      11.123213      12.634301
    [444]       12.962282      12.199994      10.426164      7.8249626
    [448]       5.0969176      3.5840714      3.4043517      3.4681804
    [452]       3.2392204      2.4900038     0.95646429     -1.4891893
    [456]      -3.6994336     -2.7944102    -0.36039662      1.5659921
    [460]       2.8176908      3.3995271      3.0909963      1.3976403
    [464]      -2.8931456     -16.568333     -5.6269703     0.22590306
    [468]       2.4613543      2.9181740      2.1455150     0.36086333
    [472]      -2.4370353     -6.5844727     -12.884841     -16.377028
    [476]      -12.455122     -11.056197     -11.274746     -9.0497580
    [480]      -4.6237035     -1.1294326      1.1157197      2.3753285
    [484]       2.9124136      2.9562378      2.6936798      2.2420473
    [488]       1.6282974     0.81086695    -0.23025280     -1.3392597
    [492]      -2.1098652     -2.2619140     -2.0975795     -2.1334393
    [496]      -2.6862762     -3.8612118     -5.3981128     -6.0414686
    [500]      -4.6747231     -2.6576724     -1.2081076    -0.64078599
    [504]      -1.0909578     -2.8736401     -6.8610992     -12.224030
    [508]      -5.5918355    -0.42541066      2.4986453      4.0453587
    [512]       4.5333719
  [Tag]         4001
  [frame_len]          320
[Record 26]
  [tot_power]       110385.04
  [re_spec_val]
    [0]      -30.610128     -30.420591     -30.234592     -30.791874
    [4]      -32.621552     -35.320728     -37.312023     -36.916061
    [8]      -29.152258     -22.812075     -18.978699     -16.909031
    [12]      -15.764008     -14.611483     -13.390811     -12.442047
    [16]      -10.152933     -5.6275711     -1.2429689      2.0924795
    [20]       4.4707727      6.1362147      7.3180528      8.1663103
    [24]       8.7083302      8.8630505      8.4941196      7.4408784
    [28]       5.5044007      2.4062934     -2.1070223     -6.2069111
    [32]      -5.3677893     -4.0195651     -3.8143790     -3.7311404
    [36]      -2.9873812     -1.9246820    -0.64079040      1.2694975
    [40]       3.5317430      5.4306583      6.5859189      6.9286857
    [44]       6.5647368      5.7886100      5.0813017      4.7333746
    [48]       4.4405379      3.6446276      1.9047426     -1.1674973
    [52]      -6.1402049     -13.801533     -18.837292     -19.840637
    [56]      -33.983223     -20.176167     -14.532600     -13.516150
    [60]      -15.586495     -19.664209     -17.169250     -13.136909
    [64]      -11.188417     -10.697636     -11.231582     -12.569875
    [68]      -14.643645     -17.585638     -21.621153     -22.066853
    [72]      -16.336357     -11.811984     -8.8138494     -6.9854579
    [76]      -6.1184187     -6.0706635     -6.6931820     -7.7585349
    [80]      -8.9176884     -9.8249264     -10.445455     -11.128201
    [84]      -12.394760     -14.864561     -18.750233     -18.104134
    [88]      -13.401972     -10.395892     -8.9992390     -8.9022894
    [92]      -10.000597     -12.338182     -16.049505     -20.940924
    [96]      -24.835560     -27.177311     -30.023933     -23.061825
    [100]      -17.075474     -13.498540     -11.492088     -10.706339
    [104]      -11.031621     -12.476492     -14.973589     -17.512159
    [108]      -17.792437     -17.012274     -17.486500     -20.170538
    [112]      -24.699009     -21.399504     -16.598265     -13.572228
    [116]      -11.255660     -9.1643734     -7.4451103     -6.4352450
    [120]      -6.4068427     -7.6215129     -10.533032     -16.420231
    [124]      -29.773275     -20.248232     -17.295347     -18.226713
    [128]      -22.382858     -27.811022     -22.329592     -17.446394
    [132]      -14.107781     -11.876491     -10.763714     -10.853538
    [136]      -12.292944     -15.331279     -19.650209     -20.551950
    [140]      -18.531576     -18.304844     -20.469555     -22.786066
    [144]      -18.324350     -13.643457     -10.410654     -8.0763464
    [148]      -6.3257852     -5.0579333     -4.2878041     -4.0792875
    [152]      -4.5127039     -5.6683893     -7.5730443     -9.9300413
    [156]      -11.442616     -10.908364     -9.5600863     -8.4703369
    [160]      -7.7439151     -7.2156224     -6.7492781     -6.3344460
    [164]      -6.0797310     -6.1445885     -6.6729679     -7.7504697
    [168]      -9.3554192     -11.268399     -12.962208     -13.572207
    [172]      -12.351789     -9.8852472     -7.4207244     -5.5951982
    [176]      -4.5933142     -4.4640274     -5.2443647     -7.0122166
    [180]      -9.9659557     -14.733638     -24.560829     -24.231005
    [184]      -15.565636     -11.556699     -9.3068514     -8.3767586
    [188]      -8.8488932     -11.122566     -15.264811     -14.230869
    [192]      -9.8148985     -7.5804939     -7.2783227     -8.6009874
    [196]      -10.535028     -9.5435343     -6.4311686     -4.0698524
    [200]      -2.7288222     -2.1025159     -1.8468678     -1.7512174
    [204]      -1.8763795     -2.4679866     -3.7580464     -5.8194194
    [208]      -8.2125082     -9.2685814     -8.1623983     -6.6932063
    [212]      -5.9732051     -6.2748122     -7.4252563     -8.0048256
    [216]      -6.2757368     -3.9128463     -2.3765094     -1.8323017
    [220]      -2.0635772     -2.6583505     -3.1265180     -3.3169150
    [224]      -3.6232424     -4.6467423     -6.4710245     -5.6827178
    [228]      -1.2992750      2.2334058      4.2147865      4.8433905
    [232]       4.4886465      4.0833683      4.8173714      6.2559481
    [236]       7.3238831      7.7229304      7.6440506      7.3987365
    [240]       7.0847855      6.4457331      5.0528641      2.4223459
    [244]      -1.9558690     -5.6174068     -2.7488451    -0.46573597
    [248]     -0.14478508    -0.86206615   -0.091235876      2.8486190
    [252]       5.5542111      7.2343192      7.9194422      7.7389665
    [256]       6.8327727      5.3914223      3.7252707      2.2992356
    [260]       1.6183885      1.8951135      2.7797225      3.6354756
    [264]       3.9342961      3.2957687      1.5438969     0.20459057
    [268]       2.7913160      6.2255969      8.3716993      9.2412882
    [272]       9.2816391      9.5478563      11.065877      13.137691
    [276]       14.705804      15.401066      15.208859      14.301265
    [280]       13.013865      11.725286      11.501865      14.394244
    [284]       18.544518      21.891768      24.152908      25.432787
    [288]       25.850952      25.493874      24.408133      22.589619
    [292]       19.957380      16.292326      11.202661      6.9195552
    [296]       10.505584      14.398386      17.047659      18.965714
    [300]       20.516220      21.930326      23.303602      24.597637
    [304]       25.690908      26.447336      26.762245      26.585678
    [308]       25.951479      25.039370      24.217972      23.826824
    [312]       23.753202      23.520483      22.656420      20.669546
    [316]       16.613340      10.108939      16.429256      21.817690
    [320]       24.738287      26.240278      26.773884      26.616720
    [324]       26.015396      25.226046      24.492393      23.970846
    [328]       23.648418      23.354834      22.886082      22.118265
    [332]       21.044313      19.757357      18.397327      17.063145
    [336]       15.739469      14.336463      12.907300      11.926851
    [340]       11.867110      12.183040      11.906057      10.414064
    [344]       7.7674513      7.5677457      11.163281      14.030184
    [348]       15.464645      15.600391      14.454205      11.829115
    [352]       7.0837336     -2.3200305     -6.8468852     0.32295603
    [356]       2.4728763      3.7102783      4.7069178      5.1164331
    [360]       4.7951980      4.0818105      3.7486298      4.5424676
    [364]       6.4264579      8.6510162      10.500184      11.593081
    [368]       11.767337      10.953253      9.1749687      6.9049277
    [372]       6.0191193      7.6760869      9.9019737      11.517915
    [376]       12.236161      11.897063      10.243903      6.6477103
    [380]      -1.2886168     -4.5905399      4.1735353      7.6917124
    [384]       9.6165085      10.972755      12.157535      13.258973
    [388]       14.253883      15.155638      16.061596      17.084272
    [392]       18.229149      19.381510      20.406401      21.199074
    [396]       21.653122      21.627928      20.955561      19.467560
    [400]       17.034830      13.679781      9.8120651      6.1922374
    [404]       4.8579865      8.0661507      11.375592      13.236876
    [408]       13.926255      13.874983      13.320795      12.125028
    [412]       10.232564      9.6028500      12.160732      14.883222
    [416]       16.504225      17.109974      16.940571      16.227425
    [420]       15.177590      13.965405      12.757012      11.798788
    [424]       11.425164      11.712830      12.249746      12.528778
    [428]       12.248522      11.290706      9.6740541      7.5986061
    [432]       5.4574170      3.4642491      1.3596166    -0.33370838
    [436]      0.64094990      3.1265109      5.0139036      5.9894862
    [440]       6.1117353      5.2953658      3.1904418    -0.67968655
    [444]      -2.3019950      2.5670497      6.2830081      8.4918404
    [448]       9.7136793      10.253680      10.272140      9.8220940
    [452]       8.8632917      7.2769294      4.9069204      1.7861687
    [456]     -0.83780932    -0.85297430    0.045370515     0.16850457
    [460]     -0.25441229    0.051318739      1.6021124      3.2953792
    [464]       4.3842745      4.7356362      4.4232678      3.5934241
    [468]       2.4352098      1.1019214    -0.43621254     -2.3855467
    [472]      -4.5961051     -5.3512673     -3.8090646     -2.2912953
    [476]      -1.9541327     -3.0409303     -5.7509022     -10.519953
    [480]      -18.577353     -40.256168     -18.750299     -11.831131
    [484]      -7.8924217     -5.6499038     -4.2569795     -2.9238520
    [488]      -1.3283207     0.22260115      1.3381509      1.8210756
    [492]       1.6126677     0.75534832    -0.55141181     -1.8959694
    [496]      -2.8813496     -3.5036132     -3.9576113     -4.3850183
    [500]      -5.1020961     -6.6805859     -9.7812738     -13.980735
    [504]      -12.026163     -7.2915220     -3.7216561     -1.1442232
    [508]      0.46405074      1.0287777     0.53282267    -0.73409528
    [512]      -1.5538564
  [Tag]         4161
  [frame_len]          320
[Record 27]
  [tot_power]       56576.637
  [re_spec_val]
    [0]      -22.791206     -24.437599     -29.478903     -28.754436
    [4]      -24.133831     -21.946457     -21.026768     -20.713940
    [8]      -20.798332     -21.165901     -17.435816     -10.590106
    [12]      -5.6053081     -2.7401133     -1.8191795     -2.2865674
    [16]     -0.85927290      3.5712209      7.4360213      10.072372
    [20]       11.690908      12.465572      12.467736      11.717467
    [24]       10.293271      8.4950819      6.8360486      5.5568762
    [28]       4.7935901      5.3653927      6.9543009      8.0410538
    [32]       7.7967935      5.7353783      1.2478150     -1.0318319
    [36]       3.5906508      6.0532866      6.1724758      4.0913987
    [40]     0.036103558     0.19752215      3.9748609      5.8235865
    [44]       5.9321036      4.9829159      4.1452298      4.3246417
    [48]       4.6916285      4.1904612      2.3310711     -1.2245884
    [52]      -6.3967590     -9.3463621     -9.5872126     -11.405679
    [56]      -8.0198030     -2.9245636    -0.12663437     0.77027577
    [60]     0.023530334     -2.4233868     -6.9216542     -12.485582
    [64]      -11.707708     -10.194809     -11.259025     -15.367027
    [68]      -25.699371     -18.470936     -12.593707     -10.116305
    [72]      -9.7180729     -11.423420     -16.221130     -24.587822
    [76]      -17.988901     -15.226411     -16.411901     -22.980345
    [80]      -28.047768     -16.497808     -12.548702     -11.012581
    [84]      -11.119261     -12.830667     -16.505363     -22.697046
    [88]      -27.374659     -28.906540     -30.773540     -18.762508
    [92]      -12.541598     -8.8405323     -6.6130161     -5.4345641
    [96]      -5.0746236     -5.3509941     -6.0428128     -6.8345957
    [100]      -7.3360367     -7.1836715     -6.2157297     -4.7023559
    [104]      -3.1877499     -2.0850840     -1.5785211     -1.7137251
    [108]      -2.4801755     -3.8604853     -5.8575783     -8.4879942
    [112]      -11.682484     -14.856113     -15.999448     -13.867207
    [116]      -10.408309     -7.0050344     -4.1256371     -1.9580626
    [120]     -0.59168410   -0.078215912    -0.46526152     -1.8202062
    [124]      -4.2440429     -7.7998152     -11.786803     -13.266874
    [128]      -12.615587     -12.748527     -14.382999     -17.266275
    [132]      -18.041840     -14.948241     -12.244240     -10.720439
    [136]      -10.038116     -9.5805960     -8.6629190     -7.3187151
    [140]      -6.1918006     -5.7048397     -5.9034472     -6.5674000
    [144]      -7.3862600     -8.3447142     -9.8979063     -12.531827
    [148]      -14.865304     -12.866989     -10.045218     -8.6529980
    [152]      -8.5716505     -9.0300074     -8.3186331     -6.1190495
    [156]      -4.0336709     -2.7940292     -2.4388819     -2.8322458
    [160]      -3.8233464     -5.3695474     -7.6933002     -11.489731
    [164]      -18.893862     -25.076916     -16.357979     -13.917315
    [168]      -14.384771     -16.810415     -16.693157     -12.701732
    [172]      -9.9905653     -9.0914135     -9.5328293     -9.3571701
    [176]      -6.6772156     -3.8737106     -2.3878002     -2.4391947
    [180]      -4.1891694     -8.0920324     -14.779367     -16.739483
    [184]      -14.312694     -14.791319     -16.211136     -12.540950
    [188]      -5.7420382   -0.090723090      4.0908265      7.0043850
    [192]       8.8335810      9.7188740      9.7951965      9.2623005
    [196]       8.4751673      7.8960972      7.7036910      7.5752263
    [200]       7.0622582      5.9469590      4.7652850      5.5176072
    [204]       8.2718124      10.940262      12.832765      13.965132
    [208]       14.469189      14.484614      14.144044      13.573262
    [212]       12.908761      12.324905      12.000723      11.983101
    [216]       12.121033      12.204140      12.116796      11.885874
    [220]       11.685895      11.823433      12.580027      13.931397
    [224]       15.567748      17.189737      18.635773      19.835983
    [228]       20.747162      21.318066      21.481089      21.156645
    [232]       20.260231      18.714296      16.498230      13.876207
    [236]       11.962498      11.956565      12.889886      13.559036
    [240]       13.594916      12.894139      11.353827      8.7948208
    [244]       4.8972826    -0.62844026     -4.0420308     -1.7641702
    [248]     -0.58389729     -1.4398090     -4.5478964     -8.7038651
    [252]      -5.1043596     -1.2023286     0.44434869     0.46829298
    [256]     -0.14489734     0.70468366      3.4414196      6.3458829
    [260]       8.7681494      10.646730      11.971515      12.751963
    [264]       13.099027      13.314366      13.828765      14.809045
    [268]       15.971766      16.971588      17.656059      18.015652
    [272]       18.084427      17.898098      17.535261      17.224501
    [276]       17.367695      18.214891      19.544550      20.958685
    [280]       22.208336      23.188084      23.851793      24.172255
    [284]       24.138994      23.776680      23.175919      22.518845
    [288]       22.034761      21.831562      21.772211      21.590509
    [292]       21.064646      20.072521      18.582533      16.648163
    [296]       14.408594      12.053304      9.7491226      7.7142801
    [300]       6.6125965      7.3830466      9.6488199      12.234496
    [304]       14.526658      16.346724      17.661377      18.467232
    [308]       18.753592      18.497076      17.673979      16.293434
    [312]       14.486966      12.740158      12.069231      12.987150
    [316]       14.636635      16.125618      17.045399      17.205725
    [320]       16.452482      14.549139      10.963253      4.1113977
    [324]     -0.47196493      6.8833632      10.011910      11.150530
    [328]       11.164704      10.466874      9.3318806      7.9406967
    [332]       6.3298950      4.3512645      1.6646364     -2.2605097
    [336]      -6.2047963     -2.8848178      1.3759886      3.9205439
    [340]       5.0070596      4.6598949      2.5116158     -2.8697820
    [344]      -23.192146     -4.1591077    -0.33573592    -0.55027461
    [348]      -4.5588675     -7.2278428     0.43342629      4.7164965
    [352]       6.9580836      8.0267725      8.3725309      8.2987862
    [356]       8.0116177      7.5848145      6.9211650      5.7603245
    [360]       3.7316592     0.69375515    -0.72469282      2.2405670
    [364]       5.1380057      6.7996974      7.4800835      7.4749432
    [368]       7.0092840      6.2205434      5.2337484      4.3972087
    [372]       4.3019333      4.9747009      5.6825676      5.8151102
    [376]       5.0965085      3.4003417     0.69717902     -2.6004453
    [380]      -4.8460727     -5.4496164     -6.7282157     -11.061823
    [384]      -24.955170     -10.184537     -5.0501323     -3.1117456
    [388]      -2.7584641     -2.4532318    -0.47020173      2.4745443
    [392]       5.1596460      7.3682141      9.2179298      10.838622
    [396]       12.300498      13.591666      14.629680      15.311125
    [400]       15.563187      15.373231      14.808570      14.046061
    [404]       13.391794      13.167548      13.416551      13.834391
    [408]       14.071054      13.954341      13.544423      13.140410
    [412]       13.104836      13.452901      13.822386      13.860310
    [416]       13.387794      12.372016      10.941763      9.4768791
    [420]       8.4513702      7.7828393      6.7788415      4.7240100
    [424]      0.90069777     -5.8890853     -11.906130     -9.1333447
    [428]      -10.862130     -10.313529     -3.7578182   -0.014571356
    [432]       1.6336830      1.8087860     0.77928036     -1.3676128
    [436]      -4.6290760     -8.8578539     -12.968901     -14.252342
    [440]      -11.666713     -8.0086279     -5.1772590     -3.4457922
    [444]      -2.6519148     -2.5486326     -2.8904173     -3.5224447
    [448]      -4.3657775     -5.0677452     -4.7897339     -3.4885175
    [452]      -2.2490122     -1.8293394     -2.5559988     -4.7118149
    [456]      -8.5465107     -10.719222     -6.8715663     -3.6242013
    [460]      -1.8623641     -1.2168287     -1.4604776     -2.4456561
    [464]      -4.0006466     -5.8184061     -7.4077239     -8.3213320
    [468]      -8.4823084     -8.0903034     -7.4221263     -6.7423692
    [472]      -6.2138109     -5.8982730     -5.8407826     -6.1306801
    [476]      -6.8896337     -8.2139692     -10.050837     -11.795912
    [480]      -11.964620     -10.348526     -8.4420576     -7.0331335
    [484]      -6.3104916     -6.3246541     -7.1041317     -8.6318703
    [488]      -10.644775     -12.112299     -11.802918     -10.496939
    [492]      -9.3799686     -8.7656107     -8.5785341     -8.6471395
    [496]      -8.8308668     -9.0899324     -9.4501152     -9.9028578
    [500]      -10.348985     -10.621378     -10.560390     -10.123610
    [504]      -9.4544020     -8.7908297     -8.3110495     -8.0899429
    [508]      -8.1626606     -8.5875301     -9.3998184     -10.394371
    [512]      -10.898680
  [Tag]         4321
  [frame_len]          320
[Record 28]
  [tot_power]       204159.23
  [re_spec_val]
    [0]      -13.107632     -13.530910     -14.857790     -17.327927
    [4]      -21.663368     -27.639166     -23.226501     -19.590803
    [8]      -19.495678     -22.199080     -18.311516     -12.369248
    [12]      -9.2386208     -6.0663910      1.4167542      8.8401089
    [16]       14.675303      19.189526      22.657299      25.261784
    [20]       27.125381      28.331703      28.939924      29.000511
    [24]       28.582323      27.818737      26.948025      26.233656
    [28]       25.709742      25.102684      24.153431      23.158606
    [32]       23.428125      25.407913      27.688910      29.472095
    [36]       30.682159      31.457603      31.977726      32.379452
    [40]       32.689739      32.820694      32.631569      31.990009
    [44]       30.798042      29.005991      26.661158      24.045319
    [48]       21.782173      20.294725      19.113819      17.526024
    [52]       15.209085      12.768850      12.721953      14.951530
    [56]       16.947512      18.066166      18.330404      17.829529
    [60]       16.659504      14.951793      12.889963      10.629459
    [64]       8.1072750      4.9337530     0.39371979     -6.7055955
    [68]      -11.119927     -7.2493906     -6.5039163     -8.8145475
    [72]      -13.099820     -6.8503866    -0.76777327      3.0685110
    [76]       5.4959159      6.8709974      7.3483367      6.9876966
    [80]       5.7922053      3.7278070     0.74531484     -3.1702957
    [84]      -7.8958354     -13.171190     -19.203897     -22.375473
    [88]      -17.420740     -13.684715     -10.449008     -6.6538239
    [92]      -3.0468237    -0.40179637      1.0552958      1.2857825
    [96]      0.29555300     -1.6617088     -3.1097646     -2.1178844
    [100]     -0.26334223     0.99558085      1.4705071      1.2015958
    [104]      0.18842348     -1.6141583     -4.2459993     -7.5589190
    [108]      -10.502773     -11.259756     -10.741649     -10.345039
    [112]      -9.7192078     -8.1970453     -6.1438808     -4.1289206
    [116]      -2.2657697    -0.51592094      1.0652034      2.3421290
    [120]       3.1892121      3.5189588      3.2555752      2.2941961
    [124]      0.46751121     -2.4475155     -6.3668852     -8.7847948
    [128]      -7.5798287     -6.2246547     -5.4824591     -4.7607508
    [132]      -3.7977896     -2.7595673     -1.7527354    -0.72128445
    [136]      0.40796050      1.6252180      2.8095715      3.7675176
    [140]       4.3052540      4.2623076      3.4917319      1.8223113
    [144]     -0.90664345     -4.1855617     -5.0828218     -3.7200382
    [148]      -3.2189043     -3.8900843     -4.0631723     -2.5246003
    [152]      -1.2329708     -1.6242322     -4.4274845     -7.9344850
    [156]      -3.3409071     0.67414403      2.4523840      2.6001153
    [160]       1.4725919    -0.50127006     -2.3537035     -3.1343863
    [164]      -3.4644725     -4.1617470     -4.7777181     -4.1088986
    [168]      -2.5272329     -1.2477143    -0.65794182    -0.43318105
    [172]      0.38633862      2.4554505      5.0853443      7.5044732
    [176]       9.4649076      10.950658      11.995441      12.632068
    [180]       12.884804      12.773113      12.318811      11.553940
    [184]       10.524275      9.2833080      7.8889728      6.4601912
    [188]       5.3684988      5.3182235      6.5303116      8.2495909
    [192]       9.7242813      10.585389      10.649478      9.7743139
    [196]       7.8132977      4.7664165      1.9047306      2.0042083
    [200]       3.2718043      3.8161798      3.8760073      4.1242461
    [204]       4.6527338      5.0495214      5.2771482      5.9274540
    [208]       7.3573608      8.9564838      10.025691      10.240144
    [212]       9.4619789      7.6206594      4.8741260      2.3857155
    [216]       1.8022579      1.8372532      1.0835999    0.071865849
    [220]      0.40054086      1.5063664      1.6816288    0.083052047
    [224]      -3.6520996     -4.7663851    -0.66341114      1.7127204
    [228]       2.3764231      2.5577657      3.5699244      5.0543804
    [232]       5.9637742      5.9836607      5.3429260      4.5580730
    [236]       3.9567239      3.3044193      2.4665368      2.2757838
    [240]       3.4976411      5.0939455      6.0504732      6.0995741
    [244]       5.2487121      3.5417941     0.90140259     -3.0923941
    [248]      -7.7666597     -4.7780313    -0.54484820      1.7356924
    [252]       2.5922523      2.3199773     0.84080446     -2.5667114
    [256]      -7.1998434    -0.74937403      4.7968221      7.9679003
    [260]       9.5180273      9.6767702      8.3944435      5.4608331
    [264]       1.9239236      3.5312703      6.8723726      8.8631172
    [268]       9.7383518      9.7555723      8.9411449      7.1755195
    [272]       4.4307289      1.5070289    0.036244880     -1.3993900
    [276]      -6.7428684     -13.013763    -0.56910461      3.7645404
    [280]       5.3919535      5.2364845      3.5018735    0.066540524
    [284]      -5.4182334     -12.590113     -18.829258     -17.217688
    [288]      -7.9164996     -3.2698212     -1.2553892     -1.1674052
    [292]      -2.7783864     -5.7779899     -8.2494116     -7.9140840
    [296]      -7.2007561     -7.3121319     -7.7942896     -8.1214581
    [300]      -8.3970928     -9.1814928     -11.110872     -14.842849
    [304]      -20.105766     -21.099987     -18.532026     -13.437720
    [308]      -8.3433170     -4.7726426     -2.5161529     -1.2056445
    [312]     -0.54640770    -0.35523260    -0.60140264     -1.4289136
    [316]      -3.1696265     -6.4672928     -12.468402     -12.385024
    [320]      -6.3001914     -2.9354854     -1.2734275    -0.92186081
    [324]      -1.9006932     -4.5620952     -10.076826     -26.739988
    [328]      -14.624740     -9.8241625     -8.0635605     -7.4224143
    [332]      -7.6344719     -9.0237741     -12.082659     -16.444523
    [336]      -16.289207     -13.577822     -11.933526     -9.8763247
    [340]      -6.9716811     -4.4784341     -3.0794063     -2.9347818
    [344]      -4.0784016     -6.2809210     -8.0343466     -7.5293889
    [348]      -6.6245036     -6.8592148     -8.4807577     -11.376792
    [352]      -14.918694     -17.555920     -18.868999     -19.976522
    [356]      -20.661469     -19.526596     -16.411282     -12.749589
    [360]      -9.5450611     -7.1501894     -5.6291671     -4.9101424
    [364]      -4.8149943     -5.0845003     -5.4908953     -5.9528275
    [368]      -6.4368582     -6.8237462     -7.1171885     -7.6783891
    [372]      -8.9899569     -11.097514     -12.090438     -10.065011
    [376]      -7.8257546     -6.8061719     -7.2160993     -9.3409824
    [380]      -14.254828     -30.447247     -19.297943     -14.548729
    [384]      -14.115843     -14.863874     -12.243160     -8.3757830
    [388]      -5.8606839     -4.7600431     -4.8925052     -6.1294265
    [392]      -8.2884121     -10.816110     -12.479515     -12.281569
    [396]      -10.374337     -7.6934538     -5.2889228     -3.6966131
    [400]      -3.1241863     -3.7256176     -5.7286873     -9.1925802
    [404]      -10.925713     -7.9531665     -5.5172629     -4.5827670
    [408]      -4.7661943     -5.3166928     -5.0905318     -4.0341315
    [412]      -3.3238273     -3.8433855     -6.3674254     -13.045790
    [416]      -17.254711     -8.4314356     -5.7501421     -6.1105056
    [420]      -8.7722292     -9.0415764     -4.9202061     -2.1920934
    [424]      -1.1565099     -1.2837467     -1.9779980     -2.7139583
    [428]      -3.5430880     -5.0658836     -7.8218894     -11.048195
    [432]      -10.785390     -8.9475307     -8.6507006     -10.269850
    [436]      -13.364640     -13.895655     -11.063389     -9.2137146
    [440]      -8.8029089     -9.5090055     -10.941673     -12.531542
    [444]      -13.538179     -13.524613     -12.645653     -11.291581
    [448]      -9.9039059     -8.9128151     -8.6412067     -9.3082857
    [452]      -11.106337     -14.279486     -18.838720     -21.319658
    [456]      -19.407581     -18.517662     -19.839579     -23.241507
    [460]      -23.723845     -20.118641     -18.119535     -17.871994
    [464]      -19.006302     -21.500105     -25.184217     -24.458544
    [468]      -19.966652     -17.125673     -15.951192     -16.133495
    [472]      -17.526300     -20.161018     -24.507393     -33.039871
    [476]      -33.494339     -25.709349     -22.739021     -22.226973
    [480]      -23.814119     -27.250465     -28.605686     -25.745211
    [484]      -23.478754     -21.952745     -20.732721     -19.999176
    [488]      -20.041864     -20.848339     -21.926201     -22.473993
    [492]      -22.475973     -22.776731     -24.046444     -26.646484
    [496]      -30.275787     -31.095266     -28.215050     -25.600971
    [500]      -23.676451     -22.296541     -21.442043     -21.078653
    [504]      -21.080530     -21.267494     -21.495893     -21.722164
    [508]      -21.993443     -22.399172     -22.985943     -23.614025
    [512]      -23.906487
  [Tag]         4481
  [frame_len]          320
[Record 29]
  [tot_power]       406917.69
  [re_spec_val]
    [0]      -61.618549     -43.913036     -25.778429     -17.266443
    [4]      -13.347279     -13.323595     -19.879005     -21.413399
    [8]      -13.137681     -15.171939     -19.315086     -7.9000387
    [12]      -7.9461031     -4.0806127      8.2290735      15.181530
    [16]       19.691000      22.607208      24.266714      24.803610
    [20]       24.232349      22.468504      19.348665      14.875314
    [24]       10.670673      9.2376299      8.8558960      9.8198242
    [28]       10.883827      9.6549549      3.3807693      2.1204693
    [32]       16.173653      24.319208      30.185093      34.408867
    [36]       37.302868      39.046612      39.733925      39.393433
    [40]       37.994110      35.439266      31.560125      26.213861
    [44]       20.197649      16.359312      13.156734      7.9661102
    [48]       3.7450361      2.0211139      7.1528978      13.131290
    [52]       17.056488      20.128906      22.789145      24.839344
    [56]       26.039663      26.278198      25.493702      23.592060
    [60]       20.364098      15.321199      7.3543658      1.7687356
    [64]       4.5477738      3.6814685    -0.83667427     -12.280194
    [68]      -12.196211     -7.1427789     -3.9242482      1.3157756
    [72]       5.8702464      9.1310568      11.259934      12.371628
    [76]       12.486309      11.547574      9.4172077      5.8194928
    [80]      0.15588552     -8.6679993     -11.481428     -9.7195234
    [84]      -12.846113     -24.745369     -9.4588394     -3.0569394
    [88]       1.2198535      4.9017229      8.1724253      10.835997
    [92]       12.747456      13.846355      14.098431      13.455615
    [96]       11.827297      9.0407467      4.7893381    -0.97498715
    [100]      -3.8686197     -2.6741421     -3.3594677     -7.4708309
    [104]      -16.446003     -7.7151527     -2.7789745   -0.026641985
    [108]       2.2112098      4.2983246      6.0373063      7.2741470
    [112]       7.9808002      8.1139202      7.5133038      5.8745255
    [116]       2.7447517     -2.0207272     -4.0623083     -2.6027496
    [120]      -3.2456849     -3.0139415      2.0334680      6.2979198
    [124]       9.1876144      11.375072      13.303099      15.053363
    [128]       16.495424      17.485451      17.923563      17.729280
    [132]       16.812660      15.053718      12.277455      8.2264977
    [136]       2.8497744    -0.51823086      1.0105500      2.2437692
    [140]       2.3707619      1.9013946      1.6221305      2.2931736
    [144]       3.9057627      5.9567199      8.0297098      9.8363791
    [148]       11.186000      11.966275      12.110906      11.577512
    [152]       10.348956      8.4659843      6.1023326      3.6424563
    [156]       1.5609165    0.082273491    -0.86804563     -1.5757761
    [160]      -2.5141451     -4.1247931     -6.5798635     -8.6487122
    [164]      -6.7770033     -3.1513021    -0.28969726      1.6442853
    [168]       2.8172498      3.3543801      3.3168912      2.7557843
    [172]       1.8067828     0.71760386    -0.38818288     -1.8011825
    [176]      -3.9482775     -6.2802792     -6.3854871     -5.3025880
    [180]      -5.8384867     -9.8770227     -35.169708     -9.0973730
    [184]      -3.8421247     -1.9924865     -2.1146381     -3.8272908
    [188]      -6.7888551     -9.3972645     -9.4189882     -8.5549984
    [192]      -7.8450065     -6.7758017     -5.4607382     -4.6279697
    [196]      -4.7238150     -5.7953911     -7.2904658     -7.8015857
    [200]      -7.1077938     -6.6880097     -7.4250846     -9.7375355
    [204]      -13.836444     -14.980886     -10.540259     -7.3541551
    [208]      -5.7131028     -5.3059597     -6.0664711     -8.1816044
    [212]      -12.372014     -21.888088     -20.428827     -13.231789
    [216]      -10.291332     -8.8550596     -8.0873766     -7.8184566
    [220]      -8.3459749     -10.147739     -12.892602     -11.793220
    [224]      -7.9176931     -5.3781667     -4.3329430     -4.5834212
    [228]      -6.1017509     -9.0641565     -13.412221     -14.443716
    [232]      -10.986388     -8.7092266     -8.0141516     -8.7278404
    [236]      -10.725863     -13.205399     -13.981047     -13.741530
    [240]      -15.211171     -19.854942     -17.906614     -11.730368
    [244]      -8.3732023     -6.6570411     -5.8911901     -5.6899924
    [248]      -5.8590522     -6.2571683     -6.5497580     -6.2681327
    [252]      -5.4842715     -4.7767243     -4.4230890     -4.1676207
    [256]      -3.7038469     -3.4189737     -4.2750292     -7.8643417
    [260]      -23.291443     -7.5602946     -1.1086491      1.9482834
    [264]       3.3029656      3.4960439      2.8306122      1.6116861
    [268]      0.27446616    -0.63540989    -0.77654624    -0.33256721
    [272]      0.17907049     0.32901669    0.017389301    -0.35451788
    [276]    -0.055497639     0.89024800      1.6654017      1.6995456
    [280]      0.80350149    -0.92230314     -2.7075186     -2.9741507
    [284]      -1.8349637    -0.71652454    -0.13473900   -0.086040683
    [288]     -0.49216130     -1.3147420     -2.5620704     -4.2660432
    [292]      -6.4599185     -9.1384468     -11.943909     -13.113654
    [296]      -11.463077     -9.1695728     -7.3499389     -5.9553609
    [300]      -4.7439947     -3.6345038     -2.7607908     -2.3301291
    [304]      -2.5143824     -3.4451499     -5.2444634     -8.0311842
    [308]      -11.793276     -15.739873     -17.944220     -18.866804
    [312]      -20.417784     -23.545265     -24.713566     -18.267483
    [316]      -13.375902     -10.447332     -8.8692923     -8.1877756
    [320]      -7.9984603     -7.9979353     -8.0889683     -8.3115454
    [324]      -8.7029915     -9.3220472     -10.345601     -12.036668
    [328]      -14.529643     -17.032274     -17.056080     -15.114922
    [332]      -13.366478     -12.254703     -11.769715     -11.949240
    [336]      -12.901587     -14.715184     -17.072456     -18.274675
    [340]      -17.304541     -16.158220     -15.770850     -15.676607
    [344]      -14.931009     -13.590519     -12.594522     -12.538429
    [348]      -13.659685     -15.946336     -18.150757     -17.332235
    [352]      -15.133738     -13.662013     -13.025205     -12.931461
    [356]      -13.110629     -13.449178     -14.002746     -14.862224
    [360]      -15.987220     -17.052723     -17.437632     -16.825888
    [364]      -15.725273     -14.845818     -14.684514     -15.668648
    [368]      -18.253626     -20.863056     -17.496761     -13.743691
    [372]      -11.896012     -11.689494     -12.780567     -14.155744
    [376]      -13.808819     -12.201025     -11.073194     -10.831662
    [380]      -11.241553     -11.778567     -11.939722     -11.838220
    [384]      -12.104253     -13.352356     -15.868629     -17.076536
    [388]      -13.405990     -9.8249102     -7.6702394     -6.7337894
    [392]      -6.8377309     -7.8814178     -9.7159386     -11.763262
    [396]      -12.671042     -12.146963     -11.594777     -11.870748
    [400]      -13.188248     -15.300641     -16.784441     -16.085901
    [404]      -14.477353     -12.842956     -11.065247     -9.2668581
    [408]      -7.8324504     -7.0416112     -7.0371771     -7.9258637
    [412]      -9.8520880     -12.961232     -16.314096     -15.502821
    [416]      -12.307418     -9.7865229     -7.9888849     -6.7137523
    [420]      -5.9375706     -5.7864914     -6.4901309     -8.4363832
    [424]      -12.493237     -19.059370     -13.001983     -7.4834876
    [428]      -4.3730488     -2.7137640     -2.2293682     -2.9205272
    [432]      -4.9733953     -8.7169495     -12.889494     -10.998494
    [436]      -7.7203951     -5.5688138     -4.0634384     -3.0427184
    [440]      -2.6669409     -3.1580837     -4.7349782     -7.7395654
    [444]      -13.171859     -28.665386     -17.836103     -11.543366
    [448]      -8.6712294     -7.3464828     -7.1112328     -7.7434092
    [452]      -9.0072832     -10.561718     -12.031267     -13.265450
    [456]      -14.404683     -15.602945     -16.875412     -18.290108
    [460]      -20.268278     -23.771629     -31.498993     -32.323822
    [464]      -23.568632     -19.207558     -16.483620     -14.857967
    [468]      -14.236315     -14.588898     -15.810709     -17.529982
    [472]      -18.879534     -19.068075     -18.395655     -17.516069
    [476]      -16.838505     -16.665770     -17.265341     -18.926083
    [480]      -22.127884     -27.870701     -30.869192     -24.887520
    [484]      -21.372393     -19.546179     -18.808447     -18.961126
    [488]      -19.929298     -21.544159     -23.228458     -24.079903
    [492]      -24.184418     -24.522671     -25.683908     -27.783785
    [496]      -30.590248     -33.613354     -36.629295     -37.964237
    [500]      -34.755886     -31.397264     -29.494308     -28.824459
    [504]      -29.034203     -29.792452     -30.887724     -32.294334
    [508]      -34.058357     -36.133663     -38.439339     -40.851460
    [512]      -42.179932
  [Tag]         4641
  [frame_len]          320
[Record 30]
  [tot_power]       511179.81
  [re_spec_val]
    [0]      -13.446040     -12.357081     -11.599312     -12.717362
    [4]      -15.404243     -20.575914     -22.270262     -14.760893
    [8]      -14.338655     -30.603962     -10.247769     -5.7815728
    [12]      -12.564821    -0.70467466      9.9092817      15.934043
    [16]       19.836134      22.276796      23.496283      23.545326
    [20]       22.325972      19.531317      14.345510      3.3928304
    [24]      -1.1995057      3.4584076     0.38007697    -0.71662009
    [28]       4.3989773      8.6240320      8.9550753  0.00091197662
    [32]       20.078430      28.510437      33.800201      37.271870
    [36]       39.385109      40.337841      40.203751      38.970165
    [40]       36.534935      32.662231      26.849972      18.018221
    [44]       8.7574692      8.0416937      2.3575923     -7.0692611
    [48]      -12.027408     -2.6796031      6.4513640      15.719147
    [52]       22.590487      27.258825      30.259609      31.917086
    [56]       32.399620      31.767561      29.985775      26.898462
    [60]       22.131929      14.810867      5.0016870      5.2314482
    [64]       3.4854329     -3.3371773     -2.9651880     -1.0700053
    [68]      -2.5939767      2.6054335      8.8140707      12.950243
    [72]       15.649578      17.236053      17.825676      17.428671
    [76]       15.974765      13.290087      9.0077677      2.3926516
    [80]      -5.0398092     -4.2301021     -5.3419461     -10.808210
    [84]      -9.6027451     -6.0145683     -4.4828358      2.1482415
    [88]       8.7542477      13.374971      16.444227      18.267277
    [92]       18.992403      18.667742      17.257225      14.615718
    [96]       10.388227      3.6554370     -7.6719446     -6.8310657
    [100]      -6.1507411     -7.4594312     -5.7888904     -7.2188931
    [104]      -11.887250      3.7300305      11.079665      15.787968
    [108]       18.937115      20.898314      21.823523      21.770521
    [112]       20.749104      18.754345      15.835472      12.280766
    [116]       8.8396282      6.2039452      4.7120752      5.8083158
    [120]       8.9609041      12.141521      14.808887      17.046753
    [124]       18.980892      20.603254      21.783182      22.361891
    [128]       22.204334      21.188332      19.160183      15.851450
    [132]       10.648106      1.3940877     -10.480158     -1.0846823
    [136]      -1.0056924     -3.8138645     -4.5846109     -1.2026433
    [140]       2.0100081      4.5427442      6.5690017      8.2102222
    [144]       9.5576649      10.609129      11.247125      11.298955
    [148]       10.589058      8.9352312      6.0966940      1.6648303
    [152]      -5.0404215     -11.074245     -9.3269234     -8.8010664
    [156]      -9.3621206     -8.9793987     -6.7580633     -3.6445882
    [160]     -0.80316699      1.2570747      2.4307232      2.7551866
    [164]       2.3428035      1.4171778     0.33770770    -0.59776646
    [168]      -1.4752729     -2.6458995     -4.3532147     -6.5709085
    [172]      -8.9386120     -10.701527     -10.944475     -9.5865908
    [176]      -7.6298404     -5.9386806     -4.8944335     -4.6714211
    [180]      -5.4391084     -7.5179868     -11.749524     -22.002546
    [184]      -20.861904     -14.047092     -12.636933     -14.203124
    [188]      -19.578335     -35.090279     -20.364573     -16.816246
    [192]      -16.748411     -19.203461     -23.202921     -21.276114
    [196]      -17.403175     -15.642026     -16.054874     -19.695456
    [200]      -38.146923     -18.806187     -12.853650     -10.489578
    [204]      -10.360483     -12.520885     -18.598736     -31.132742
    [208]      -17.091984     -13.580080     -12.982066     -14.154399
    [212]      -16.557470     -19.362326     -21.477182     -22.560116
    [216]      -21.133499     -17.152414     -13.307111     -10.418321
    [220]      -8.5505877     -7.7523026     -8.1761742     -10.195409
    [224]      -14.905313     -28.182650     -19.009096     -13.993677
    [228]      -12.857336     -13.978302     -16.988358     -20.526667
    [232]      -20.902391     -21.068216     -25.804945     -29.175898
    [236]      -17.035931     -11.740031     -8.7686291     -7.2164450
    [240]      -6.8177977     -7.5620084     -9.6484337     -13.650915
    [244]      -21.089577     -23.667448     -18.729645     -17.860113
    [248]      -19.922392     -25.336021     -38.619156     -39.132515
    [252]      -33.882786     -25.004864     -18.116320     -12.947718
    [256]      -8.9424372     -5.9959269     -4.0944457     -3.2313170
    [260]      -3.4294527     -4.7936006     -7.6289682     -12.882709
    [264]      -25.798857     -20.107025     -14.645697     -12.950641
    [268]      -12.458722     -12.265549     -12.147560     -12.029119
    [272]      -11.547001     -10.078668     -7.1977491     -3.6097102
    [276]     -0.36871254      2.0549335      3.5609024      4.1599712
    [280]       3.8861825      2.7875497     0.96117634     -1.3624547
    [284]      -3.7066979     -5.3863945     -5.9956617     -5.9814825
    [288]      -6.2960978     -7.8111162     -11.593393     -21.679977
    [292]      -18.431847     -10.759966     -7.0749788     -4.8174758
    [296]      -3.6455247     -3.6717451     -5.0941849     -7.9478459
    [300]      -10.535990     -9.7419891     -8.6059303     -9.0743818
    [304]      -11.056464     -13.544592     -15.188552     -16.711304
    [308]      -16.595297     -12.170538     -8.1317129     -5.4982991
    [312]      -3.9445233     -3.2254291     -3.2443256     -3.9898007
    [316]      -5.4342604     -7.3716807     -9.2617502     -10.626861
    [320]      -11.845579     -13.734281     -17.036772     -23.394625
    [324]      -40.352543     -20.733173     -14.721075     -11.122412
    [328]      -8.9095497     -7.7807641     -7.4979424     -7.6226172
    [332]      -7.4862480     -6.8514800     -6.2666001     -6.3224053
    [336]      -7.3175344     -9.3830786     -12.525022     -16.370127
    [340]      -19.715168     -21.291420     -20.449772     -18.219784
    [344]      -16.659748     -16.687271     -19.197060     -28.503128
    [348]      -21.424706     -13.363671     -9.2885704     -7.0691824
    [352]      -6.1606278     -6.3960490     -7.7815857     -10.479601
    [356]      -14.913776     -22.116623     -30.892271     -29.038971
    [360]      -30.535234     -30.374418     -25.276556     -21.797588
    [364]      -18.600677     -14.762352     -11.021379     -8.0016394
    [368]      -5.8655457     -4.6352677     -4.3282104     -4.9950142
    [372]      -6.7395811     -9.7269840     -13.993175     -17.878164
    [376]      -18.399199     -18.822287     -21.795761     -30.149130
    [380]      -27.956657     -21.483793     -19.128084     -18.604174
    [384]      -18.300114     -15.904371     -12.251408     -9.2751732
    [388]      -7.4560523     -6.8313622     -7.4320812     -9.3828745
    [392]      -12.978749     -18.851288     -28.410110     -55.224545
    [396]      -29.161690     -21.613131     -18.276194     -17.886950
    [400]      -20.581593     -22.999954     -16.424816     -11.598322
    [404]      -8.5970783     -6.6377635     -5.4087820     -4.8719544
    [408]      -5.1264429     -6.3313990     -8.6882982     -12.435677
    [412]      -17.607241     -22.432024     -23.915009     -22.879044
    [416]      -19.254833     -14.972294     -11.191424     -8.1789751
    [420]      -5.8592782     -3.9218047     -2.0934324    -0.44940096
    [424]      0.68483829      1.0121238     0.32781145     -1.5464512
    [428]      -4.8262610     -9.6958704     -15.386459     -19.499615
    [432]      -24.986444     -22.469437     -16.131863     -13.403983
    [436]      -12.552556     -12.388367     -11.616681     -9.6071987
    [440]      -7.0444865     -4.7288876     -3.0304968     -2.0760202
    [444]      -1.8993558     -2.4962680     -3.8260126     -5.7745361
    [448]      -8.1095734     -10.567040     -13.174321     -16.382040
    [452]      -20.584242     -24.544252     -25.738148     -26.258484
    [456]      -24.203720     -19.447098     -15.625403     -13.027017
    [460]      -11.317657     -10.282498     -9.8653584     -10.118391
    [464]      -11.136597     -12.996781     -15.661978     -18.786230
    [468]      -21.758944     -24.793106     -29.550121     -38.976425
    [472]      -36.056023     -32.575069     -32.910793     -33.497696
    [476]      -30.826445     -26.917910     -23.187395     -20.157995
    [480]      -18.163774     -17.339291     -17.760632     -19.558846
    [484]      -22.985083     -28.078077     -31.194941     -30.212301
    [488]      -30.560633     -33.050552     -36.699951     -37.381290
    [492]      -34.698380     -31.756014     -29.346115     -27.719364
    [496]      -26.874195     -26.675444     -26.981911     -27.766846
    [500]      -29.206867     -31.747562     -36.306557     -42.649197
    [504]      -38.040333     -33.982479     -32.352386     -32.240170
    [508]      -33.207138     -34.994934     -37.467747     -40.456020
    [512]      -42.297989
  [Tag]         4801
  [frame_len]          320
[Record 31]
  [tot_power]       938982.31
  [re_spec_val]
    [0]      -26.937222     -22.876417     -18.228762     -15.917153
    [4]      -16.638929     -23.270855     -25.274847     -17.893349
    [8]      -22.729548     -16.659643     -7.6591468     -6.2496057
    [12]      -10.004969      4.0617695      12.233883      17.471661
    [16]       20.974005      23.166441      24.215700      24.158600
    [20]       22.937975      20.402029      16.278530      10.121316
    [24]       1.4512551     -1.6226590      2.2347400      3.9032655
    [28]       7.1512685      10.288838      8.0442467      13.685141
    [32]       24.832117      31.372528      35.650478      38.396351
    [36]       39.909832      40.318684      39.653164      37.866184
    [40]       34.828766      30.314020      24.023914      15.901152
    [44]       6.3973169      6.3507152      9.8656301      9.1083364
    [48]       13.741710      19.480722      23.722626      28.182941
    [52]       32.623375      36.203552      38.684586      40.091084
    [56]       40.473343      39.845325      38.167313      35.327900
    [60]       31.105314      25.100674      17.068399      11.835072
    [64]       11.089705      9.1712742      7.6793370      9.0505419
    [68]       12.772244      16.827393      20.179485      22.473446
    [72]       23.588257      23.457476      21.970406      18.865705
    [76]       13.518014      5.5809894      5.8333440      7.4277244
    [80]       5.4912758    -0.21309251     -1.4452190      3.8539746
    [84]       6.1043520      7.8519950      11.876456      16.499031
    [88]       20.079853      22.439001      23.647324      23.738155
    [92]       22.661852      20.241327      16.029579      8.6966362
    [96]      -5.7251539      1.8201326      2.3463843    -0.99925399
    [100]      -2.4719245     -1.3252082    -0.47116268      6.6064720
    [104]       14.054140      19.727192      23.970251      27.028681
    [108]       29.039644      30.079924      30.185236      29.358070
    [112]       27.572231      24.781639      20.951910      16.158766
    [116]       10.767671      5.4140782     0.96193087    -0.78128362
    [120]       2.8446941      8.3584042      12.400440      15.010283
    [124]       16.798981      18.399134      20.006201      21.277178
    [128]       21.797670      21.297930      19.563805      16.286978
    [132]       10.817770      1.6675967     -2.7623956     -1.3864646
    [136]      -4.6764216     -4.4716187   -0.036565289      3.2368448
    [140]       5.8157759      7.7205110      9.1091032      10.430810
    [144]       11.819057      12.884453      13.202076      12.529505
    [148]       10.717971      7.6211209      3.1082671     -2.5123999
    [152]      -7.4596767     -11.512339     -15.249350     -11.836609
    [156]      -7.9914622     -5.3200345     -3.4156837     -2.0379694
    [160]     -0.46808919      1.7718707      4.0331221      5.5858984
    [164]       6.1418467      5.6081042      3.9134157     0.96252352
    [168]      -3.2450724     -7.8668017     -10.765569     -12.977150
    [172]      -17.262527     -20.956108     -14.124566     -9.2932930
    [176]      -6.5919428     -5.3969092     -5.2171907     -5.2419248
    [180]      -4.6714568     -3.8144376     -3.4940875     -4.1375341
    [184]      -5.8517318     -8.4750614     -11.207998     -12.886503
    [188]      -14.211378     -17.111601     -24.773888     -26.488747
    [192]      -17.745796     -14.626718     -13.675132     -13.505606
    [196]      -12.340304     -9.8589230     -7.5108395     -6.0264649
    [200]      -5.5486112     -6.1066756     -7.7129526     -10.202957
    [204]      -12.643857     -13.668018     -14.253463     -16.186478
    [208]      -19.926502     -19.676262     -15.512382     -13.105842
    [212]      -12.344600     -12.714554     -13.348207     -12.724937
    [216]      -10.755706     -8.8617191     -7.7609262     -7.6236048
    [220]      -8.4726200     -10.175771     -12.075241     -12.974409
    [224]      -13.074804     -13.733516     -15.534379     -17.538349
    [228]      -17.077559     -15.314747     -14.366901     -14.294198
    [232]      -14.117377     -12.661311     -10.441661     -8.5899706
    [236]      -7.5608606     -7.4396110     -8.1656456     -9.4848108
    [240]      -10.864891     -11.953077     -13.313327     -16.146612
    [244]      -22.872435     -33.855816     -20.439653     -17.045374
    [248]      -15.998563     -15.155166     -12.893492     -9.7880192
    [252]      -7.0118575     -4.9892817     -3.8097241     -3.4721713
    [256]      -3.9107723     -4.9333229     -6.1721506     -7.3247428
    [260]      -8.6096087     -10.640600     -14.001656     -19.321690
    [264]      -30.746361     -22.700481     -13.607744     -8.5134478
    [268]      -5.2069397     -2.8679862     -1.0115745     0.52621585
    [272]       1.6313374      2.1159611      1.8641130     0.87689984
    [276]     -0.69677544     -2.5891457     -4.7085776     -7.5132499
    [280]      -11.757686     -15.132670     -12.474472     -10.127203
    [284]      -8.6015882     -6.4623051     -3.7613096     -1.2203234
    [288]      0.98473150      2.8960578      4.4717126      5.6071391
    [292]       6.2384014      6.3895350      6.1679749      5.7050385
    [296]       5.0341516      3.9982176      2.2773535    -0.55632818
    [300]      -4.9838777     -9.6855135     -8.6792879     -7.0329089
    [304]      -7.0980620     -7.1554785     -4.5628481    -0.86031926
    [308]       2.1756132      4.2418571      5.3128133      5.3530545
    [312]       4.2910199      2.0597863     -1.0765331     -3.3013866
    [316]      -2.8140492     -1.5005827    -0.23086418      1.1540897
    [320]       2.5990655      3.8758318      4.8039651      5.3125620
    [324]       5.4800711      5.5054269      5.4797254      5.1653605
    [328]       4.1192675      1.8870673     -2.0070977     -8.0519152
    [332]      -14.798787     -13.259429     -6.7898889     -1.9994428
    [336]      0.79133660      2.0773294      2.3690636      2.2744842
    [340]       2.3469670      2.6347888      2.7839665      2.5112698
    [344]       1.6921419     0.26382273     -1.7172987     -3.6306176
    [348]      -4.2301164     -3.9105461     -4.3563833     -6.8493710
    [352]      -14.004417     -14.196124     -5.7830443     -2.0267191
    [356]    -0.028543890      1.1627128      2.0162196      2.7073231
    [360]       3.2160819      3.4541566      3.3147476      2.6628022
    [364]       1.3576777    -0.57826644     -2.4073870     -2.6916158
    [368]      -1.9751897     -1.8787738     -3.1445608     -6.2954645
    [372]      -12.231776     -14.103024     -8.4966249     -5.0928731
    [376]      -2.8316255     -1.1250407     0.13914599     0.93461305
    [380]       1.2229424     0.97654438     0.22243714    -0.83666962
    [384]      -1.7512637     -2.2651093     -2.8774080     -4.4218483
    [388]      -7.4260082     -9.3299112     -5.9009905     -2.6082797
    [392]     -0.62290114     0.57584685      1.4336910      2.1472583
    [396]       2.6960354      3.0008929      3.0128975      2.7043247
    [400]       2.0885968      1.3290514     0.74425590     0.36598027
    [404]     -0.42021924     -2.6211751     -8.1787539     -16.928616
    [408]      -5.3178120    -0.66292495      2.0036538      4.0835443
    [412]       5.9541736      7.5229120      8.6675215      9.3682613
    [416]       9.6399202      9.4611912      8.7767849      7.5753565
    [420]       6.0279393      4.5833282      3.6171429      2.8686445
    [424]       1.8215905     0.31664485     -1.3480327     -2.7145159
    [428]      -3.6847711     -4.2854791     -4.1976929     -3.4215796
    [432]      -2.5604510     -2.0527854     -1.9767255     -2.2736559
    [436]      -2.9324770     -4.0312138     -5.5856848     -7.1937551
    [440]      -7.9994140     -8.1060944     -8.7805042     -11.218707
    [444]      -17.445410     -23.537167     -13.918726     -10.266273
    [448]      -8.6649208     -7.8272538     -7.2065401     -6.7834158
    [452]      -6.7464948     -7.2484980     -8.4658699     -10.767958
    [456]      -14.657985     -17.220972     -13.655373     -11.095673
    [460]      -10.759228     -12.721107     -18.218529     -52.342289
    [464]      -19.997616     -15.940229     -14.664350     -13.902540
    [468]      -12.865168     -11.977642     -11.735662     -12.299566
    [472]      -13.704893     -15.747208     -16.630224     -14.509191
    [476]      -12.046255     -10.782102     -10.957013     -12.766869
    [480]      -16.841934     -25.437756     -26.387589     -20.727602
    [484]      -19.268219     -19.273975     -19.144720     -18.550842
    [488]      -18.287420     -18.867292     -20.350573     -22.482975
    [492]      -24.380344     -24.537483     -23.236622     -22.081280
    [496]      -21.856190     -22.855358     -25.289227     -29.068611
    [500]      -31.608122     -30.676134     -30.082561     -30.465725
    [504]      -30.237837     -28.908772     -27.940634     -28.162897
    [508]      -29.796862     -32.835655     -36.098881     -36.568226
    [512]      -36.037628
  [Tag]         4961
  [frame_len]          320
[Record 32]
  [tot_power]       1651760.0
  [re_spec_val]
    [0]      -22.638449     -24.928146     -30.537399     -25.786106
    [4]      -24.348932     -23.425333     -18.560884     -18.387779
    [8]      -27.130709     -11.755838     -7.7151761     -16.763802
    [12]     -0.81604284      9.4188442      15.391434      19.274134
    [16]       21.699533      22.933119      23.092604      22.212418
    [20]       20.256912      17.080591      12.239711      4.1491938
    [24]      -12.676144     -4.0426435     -2.1857855      5.3612657
    [28]       8.0499020      10.355824      20.084337      27.314156
    [32]       32.171982      35.377682      37.272526      38.014736
    [36]       37.661983      36.203609      33.576054      29.686281
    [40]       24.493574      18.362669      14.100944      14.585983
    [44]       14.319139      10.552341      11.400162      18.275223
    [48]       24.805204      31.060801      36.071606      39.721020
    [52]       42.168739      43.562321      44.000507      43.542484
    [56]       42.222649      40.072468      37.172100      33.778484
    [60]       30.452551      27.552040      24.246260      18.348949
    [64]       8.0862579      19.824505      25.373547      29.186884
    [68]       32.113762      34.167225      35.305473      35.530369
    [72]       34.854984      33.277508      30.769615      27.276999
    [76]       22.749884      17.274437      11.320162      4.9346185
    [80]      -6.9673166      1.3407240      9.4469862      15.176974
    [84]       19.922791      23.695992      26.468590      28.271925
    [88]       29.149227      29.132156      28.237843      26.479908
    [92]       23.897726      20.604847      16.793556      12.531575
    [96]       7.5933051      3.5267236      4.7824922      7.0845199
    [100]       9.0846825      12.830347      17.792982      22.049015
    [104]       25.127388      27.085993      28.047352      28.131344
    [108]       27.463802      26.186619      24.443008      22.359343
    [112]       20.116997      18.028374      16.074844      13.207418
    [116]       6.5123668    -0.28895923      12.595429      17.981667
    [120]       21.881277      25.095270      27.645777      29.486525
    [124]       30.630516      31.125301      31.020512      30.340870
    [128]       29.060209      27.081976      24.236290      20.317186
    [132]       15.347089      10.980116      10.825476      13.764743
    [136]       17.178026      20.040524      22.220211      23.743116
    [140]       24.557602      24.548496      23.571692      21.434113
    [144]       17.794724      11.816606    -0.21629821     -1.4110901
    [148]       3.5823288      4.0286937      3.5318396      3.0915453
    [152]       3.3614774      5.1032310      7.6350765      10.028995
    [156]       11.965819      13.303746      13.913774      13.687598
    [160]       12.533367      10.343513      6.9251957      1.7678442
    [164]      -7.3699932     -16.281694     -5.6819849     -3.2849600
    [168]      -3.6929841     -5.8816385     -5.3584762    -0.92268157
    [172]       2.7538474      5.3268781      7.0643225      8.0641823
    [176]       8.3211594      7.8069196      6.5130777      4.4836102
    [180]       1.8444415     -1.2457112     -4.8563476     -9.6705647
    [184]      -17.801649     -23.873133     -14.535635     -9.4613152
    [188]      -5.6303020     -2.6193192    -0.27559540      1.4915217
    [192]       2.6754858      3.2052398      2.9964273      1.9779105
    [196]      0.10505729     -2.6095719     -6.0408969     -9.9984846
    [200]      -14.539427     -18.444719     -16.599247     -13.736125
    [204]      -12.086017     -10.827194     -9.2118330     -7.2595019
    [208]      -5.3507733     -3.7733757     -2.7181962     -2.3185096
    [212]      -2.6504147     -3.7292662     -5.5130649     -7.9584699
    [216]      -11.245557     -16.324213     -26.738585     -22.840435
    [220]      -18.173832     -17.737253     -17.757694     -13.866512
    [224]      -9.5785656     -6.5558200     -4.5623798     -3.3466206
    [228]      -2.7961397     -2.8767145     -3.5469639     -4.6887112
    [232]      -6.1215477     -7.8065958     -10.112062     -13.932506
    [236]      -21.683569     -33.071095     -20.500107     -16.923508
    [240]      -13.826657     -10.403871     -7.3862467     -4.9992967
    [244]      -3.1930733     -1.9512358     -1.3175029     -1.3330958
    [248]      -1.9830465     -3.1772432     -4.8085546     -6.9400024
    [252]      -9.9721031     -14.226808     -16.071045     -13.319101
    [256]      -11.347140     -10.082190     -8.3399191     -6.1180739
    [260]      -4.0437808     -2.3284574    -0.96075892    0.021360775
    [264]      0.53120327     0.52509153    0.031250440    -0.92366332
    [268]      -2.4691472     -5.0229039     -9.2109270     -12.816608
    [272]      -10.075250     -8.1979246     -8.7686481     -10.041851
    [276]      -7.3754306     -3.6017668     -1.0694592     0.48439944
    [280]       1.4822117      2.1198137      2.3594356      2.0841274
    [284]       1.2066867    -0.37739092     -2.9605546     -7.1050019
    [288]      -10.576248     -7.2112026     -4.6803932     -4.6680689
    [292]      -7.0653830     -8.6386404     -4.2621717    -0.43259627
    [296]       2.0017459      3.6506102      4.8525300      5.6836853
    [300]       6.1274161      6.1910429      5.8790555      5.0927300
    [304]       3.6105013      1.3913282   -0.086819865      1.2646499
    [308]       2.9877295      3.1651444     0.99298614     -4.5028419
    [312]     -0.75727063      5.6793251      9.4159431      11.744058
    [316]       13.266574      14.294844      14.989755      15.399886
    [320]       15.480983      15.140039      14.340890      13.334845
    [324]       12.872804      13.397775      14.133110      14.173318
    [328]       12.985637      9.9506817      3.8011403      4.5311971
    [332]       11.214273      15.123141      17.615662      19.247808
    [336]       20.219610      20.592890      20.362579      19.473457
    [340]       17.812923      15.182583      11.215728      5.1215177
    [344]      -2.7247040      1.6843598      6.4065661      9.6735268
    [348]       12.026532      13.600537      14.519831      14.897026
    [352]       14.787889      14.204365      13.191373      11.895449
    [356]       10.460337      8.6912146      5.8423691     0.47677153
    [360]      -4.4170966      1.7014815      4.7277775      5.5937724
    [364]       5.7920108      6.6606646      8.1514730      9.3843288
    [368]       9.9842606      9.9705086      9.4954967      8.7584219
    [372]       7.9207196      6.9322400      5.4218512      2.7514811
    [376]      -1.8158565     -4.6585288    -0.78502703      1.6350535
    [380]       2.3525693      2.6318014      3.7302983      5.4583917
    [384]       6.9781098      8.0218096      8.6617231      9.0132961
    [388]       9.1443863      9.0481033      8.5810719      7.3895922
    [392]       4.7967186    -0.83251464     -8.1712065     0.82459998
    [396]       4.3544230      4.9856029      3.5600712      1.2903284
    [400]       2.3740892      5.5585880      7.8849297      9.3521585
    [404]       10.378537      11.271303      12.145341      12.929940
    [408]       13.429185      13.403230      12.648281      11.156323
    [412]       9.6718731      9.8050289      11.093447      11.867582
    [416]       11.547337      10.191862      8.5954161      8.4866247
    [420]       9.8036633      11.030311      11.691990      11.902845
    [424]       11.866500      11.695210      11.338673      10.599569
    [428]       9.1761303      6.6209550      1.9961600     -8.7339134
    [432]      -6.1654606     0.85366565      4.0066423      6.2493691
    [436]       8.1849976      9.6902390      10.579949      10.795941
    [440]       10.365220      9.3453808      7.7912712      5.7283168
    [444]       3.0902574    -0.47494179     -5.8879323     -8.1650362
    [448]      -2.2267966      1.3627874      2.9897251      3.2351866
    [452]       2.5685670      1.8524482      2.1257904      3.1455891
    [456]       4.0086145      4.4020314      4.4739108      4.5106025
    [460]       4.6306505      4.6248488      4.0984664      2.6048090
    [464]     -0.44957733     -5.5710831     -5.5386496    -0.88289607
    [468]       1.6663003      2.7477651      3.1566489      3.6254141
    [472]       4.5043454      5.5548425      6.4196868      6.9305449
    [476]       7.0539165      6.7870674      6.0877552      4.8205719
    [480]       2.6894202    -0.96589136     -8.3925304     -18.755795
    [484]      -5.6493134     -2.0142434    -0.70380431    -0.46184078
    [488]     -0.57238638    -0.58685625    -0.50412130    -0.59298146
    [492]      -1.0548418     -1.9379954     -3.1816573     -4.6624341
    [496]      -6.2843914     -8.1658459     -10.802445     -15.161025
    [500]      -21.172882     -17.625994     -13.786682     -12.417077
    [504]      -12.663038     -13.889609     -15.200411     -15.736711
    [508]      -15.797011     -16.150194     -17.047159     -18.185879
    [512]      -18.757113
  [Tag]         5121
  [frame_len]          320
[Record 33]
  [tot_power]       1165082.2
  [re_spec_val]
    [0]      -30.338369     -44.098755     -25.010742     -21.324133
    [4]      -25.558823     -21.797184     -16.626183     -20.690975
    [8]      -18.751446     -9.4752131     -10.305081     -9.8779545
    [12]       4.4154749      11.369523      15.712833      18.456621
    [16]       19.996099      20.499325      19.991720      18.352283
    [20]       15.241667      9.9922314      3.7556584      3.8040652
    [24]      0.24468121     -2.1664677      8.0667772      11.187834
    [28]       16.305046      23.716232      29.315218      33.148849
    [32]       35.591572      36.857891      37.040230      36.132130
    [36]       34.010971      30.351406      24.315222      12.887826
    [40]       5.6416597      3.2363818      14.273725      21.733425
    [44]       25.538067      28.667862      32.401524      36.022919
    [48]       38.780006      40.493896      41.181786      40.885784
    [52]       39.644016      37.512363      34.613853      31.162596
    [56]       27.329718      23.229475      20.267235      20.148851
    [60]       21.031544      23.253168      26.925589      30.409178
    [64]       33.116825      35.070267      36.356541      37.025600
    [68]       37.093456      36.557774      35.410549      33.649132
    [72]       31.288139      28.363543      24.880598      20.589869
    [76]       14.308720     -1.2032802      9.6709766      15.261259
    [80]       18.606075      21.545200      23.982212      25.609476
    [84]       26.334812      26.184494      25.215065      23.477566
    [88]       21.015484      17.949900      14.733516      11.952174
    [92]       8.6497555     0.41913691     0.79320711      9.9084339
    [96]       13.838850      16.606089      19.198755      21.411386
    [100]       22.853052      23.350742      22.852375      21.328564
    [104]       18.785608      15.558406      12.988400      11.822570
    [108]       9.9806128      4.5174861     -1.9474717      9.1969481
    [112]       13.768850      16.470570      18.901529      21.541803
    [116]       23.973700      25.729374      26.595757      26.501261
    [120]       25.442837      23.534321      21.171234      18.954432
    [124]       16.854168      14.458221      13.581062      15.626020
    [128]       17.973736      20.335897      23.132023      25.879539
    [132]       28.054070      29.506914      30.268841      30.411699
    [136]       30.005951      29.119431      27.835848      26.279324
    [140]       24.607340      22.910021      21.048082      18.590437
    [144]       14.767625      7.7176700    -0.35000116      8.7834988
    [148]       12.182580      13.804779      14.948313      15.903666
    [152]       16.492266      16.542330      16.028126      15.028546
    [156]       13.673003      12.080599      10.258260      7.9683833
    [160]       4.5751715     -1.6126399     -19.650398     -3.1752429
    [164]      0.93290412      2.4394283      3.5759728      5.1710143
    [168]       6.7020831      7.6145658      7.8076200      7.4203348
    [172]       6.6764293      5.7714124      4.7622027      3.5228112
    [176]       1.7646413    -0.97308338     -5.3826246     -10.236722
    [180]      -7.1743684     -3.6270864     -1.5302927   -0.020602904
    [184]       1.2534763      2.1871092      2.5934947      2.3966238
    [188]       1.6452612     0.52567250    -0.62630570     -1.5355178
    [192]      -2.3892822     -3.7936769     -6.4583306     -10.897817
    [196]      -12.570895     -8.5839109     -5.9118352     -4.6051888
    [200]      -3.9467547     -3.4523039     -3.0114968     -2.7942009
    [204]      -2.9958093     -3.7051628     -4.8476958     -6.1111236
    [208]      -7.1058307     -7.9825211     -9.5770636     -13.199097
    [212]      -23.536592     -20.231264     -12.387143     -9.2845030
    [216]      -7.7593837     -6.7901273     -5.9119711     -5.1185031
    [220]      -4.6246877     -4.6095638     -5.1148591     -5.9560533
    [224]      -6.6514244     -6.8419771     -6.9337111     -7.7022591
    [228]      -9.8519974     -14.507733     -26.323275     -18.641665
    [232]      -12.810645     -10.033470     -8.2705727     -6.9232144
    [236]      -5.9286413     -5.4099603     -5.4523406     -5.9667640
    [240]      -6.5682526     -6.7612185     -6.6517372     -6.9510865
    [244]      -8.3394794     -11.321635     -14.668708     -12.286807
    [248]      -8.7187452     -6.6027765     -5.4903049     -4.8533459
    [252]      -4.3092461     -3.7578075     -3.3465514     -3.2205381
    [256]      -3.3308196     -3.4435406     -3.4277542     -3.5534041
    [260]      -4.3586974     -6.4996691     -11.246396     -22.745525
    [264]      -12.937971     -7.6065164     -5.1785412     -3.9765544
    [268]      -3.2367854     -2.5271327     -1.7989056     -1.2576187
    [272]      -1.0669585     -1.1998603     -1.4775313     -1.8044581
    [276]      -2.4307039     -3.9386237     -7.2709050     -13.974573
    [280]      -11.244381     -5.3198705     -2.4012892     -1.1088678
    [284]     -0.80547196     -1.0199087     -1.2651635     -1.2121663
    [288]     -0.90585232    -0.51368773   -0.042647183     0.49572885
    [292]      0.82912570     0.49529901     -1.0537283     -4.7664733
    [296]      -13.569647     -9.3006506     -2.8319943     0.13198742
    [300]       1.5112829      2.0037622      2.0657864      2.0983701
    [304]       2.3171768      2.6340544      2.9020300      3.2040787
    [308]       3.7211785      4.2909079      4.3849397      3.4001145
    [312]      0.51605165     -6.7616997     -9.0025120    -0.12357225
    [316]       3.3868706      4.8223953      5.1290174      4.9635329
    [320]       5.0005283      5.5850449      6.5380859      7.6485362
    [324]       8.8894930      10.193199      11.329199      12.012034
    [328]       11.994309      11.076318      9.2583237      7.8635783
    [332]       9.4891558      12.173200      13.896831      14.364166
    [336]       13.537107      11.306555      7.7194314      5.6348228
    [340]       8.7719364      12.530192      15.573792      17.860159
    [344]       19.310705      19.823135      19.240026      17.218109
    [348]       12.871419      6.5027909      12.539978      17.192968
    [352]       19.491426      20.442333      20.513723      20.015818
    [356]       19.218519      18.371819      17.697407      17.323364
    [360]       17.131802      16.743690      15.692941      13.463700
    [364]       9.1386719    -0.34350342      2.5560191      8.6832552
    [368]       11.045100      11.732164      11.461488      10.685873
    [372]       9.8395777      9.3347692      9.3871164      9.8738861
    [376]       10.433082      10.668598      10.231682      8.7432261
    [380]       5.5094028     -1.8352941     -5.4898357      3.9161487
    [384]       7.5885558      9.1439981      9.4470463      8.9008017
    [388]       7.8797946      6.9056840      6.6072903      7.3072019
    [392]       8.6469307      9.9435511      10.679166      10.536038
    [396]       9.2219448      6.1913753    -0.26567981     -5.8003769
    [400]       3.1458657      6.9343696      8.5892029      9.0437107
    [404]       8.7357073      8.0449409      7.4253731      7.3126407
    [408]       7.8635983      8.8576317      9.8828468      10.554590
    [412]       10.583176      9.7192335      7.6559353      4.0832381
    [416]       1.3431534      4.4900618      7.6600385      9.2856455
    [420]       9.6893053      9.1344786      7.8276906      6.0625048
    [424]       4.6063766      4.8708181      6.7952657      8.8652496
    [428]       10.326719      11.001933      10.833031      9.7252197
    [432]       7.5446591      4.8185744      5.1711187      8.4587698
    [436]       11.105693      12.638361      13.238598      13.104932
    [440]       12.451299      11.536447      10.635122      9.9777346
    [444]       9.7312355      9.9189882      10.290621      10.436283
    [448]       9.9860144      8.6101427      5.8348475     0.49983028
    [452]      -8.2012787    -0.63752288      3.6182408      5.3605056
    [456]       5.9198203      6.1027050      6.5749269      7.5856657
    [460]       8.9187956      10.253046      11.327389      11.918995
    [464]       11.802077      10.674584      7.9618425      2.3613546
    [468]       1.1989610      8.1598425      12.037637      14.177628
    [472]       15.303759      15.817402      16.009857      16.099028
    [476]       16.240709      16.552990      17.071518      17.657597
    [480]       18.037237      17.931210      17.104424      15.330010
    [484]       12.397544      8.9633284      9.0521851      11.694741
    [488]       13.451490      14.047837      13.705872      12.658529
    [492]       11.196741      9.7229471      8.6506853      8.1339121
    [496]       7.9494910      7.6819806      6.9340396      5.3964410
    [500]       2.8701227    -0.33941683     -1.9731266    -0.92429030
    [504]     0.017062759    -0.25875995     -1.9687293     -5.5528712
    [508]      -12.885551     -23.985947     -11.594671     -8.2319708
    [512]      -7.3612728
  [Tag]         5281
  [frame_len]          320
[Record 34]
  [tot_power]       899172.81
  [re_spec_val]
    [0]      -57.962830     -35.133766     -29.650682     -26.516369
    [4]      -23.857567     -22.037676     -23.524784     -34.795231
    [8]      -18.712267     -16.060173     -22.173012     -1.9181854
    [12]       6.6532006      12.066970      15.565340      17.584677
    [16]       18.317461      17.859137      16.280787      13.692145
    [20]       10.252100      5.8428521     -1.6484480     -6.9669471
    [24]       3.7144148      5.5872931      6.4690318      17.854507
    [28]       25.533108      30.628462      34.016735      36.066231
    [32]       36.943390      36.709690      35.353485      32.796650
    [36]       28.896246      23.514606      17.215790      13.863955
    [40]       14.263013      12.154507      5.5295115      23.415964
    [44]       31.082693      35.955189      39.166096      41.113003
    [48]       41.970997      41.817497      40.677475      38.551754
    [52]       35.463524      31.576117      27.383949      23.503893
    [56]       19.853073      16.238359      13.717922      12.282669
    [60]       10.494552      14.191191      20.212198      24.075253
    [64]       26.040173      26.380255      25.131983      22.068027
    [68]       16.388803      4.2228785      1.3091809      5.1760454
    [72]       3.0862267      3.3986721      4.2025666      4.2803111
    [76]       10.014894      15.466521      19.027132      21.174528
    [80]       22.170570      22.081116      20.837070      18.223795
    [84]       13.752348      6.1857743     -3.2474327    0.067922361
    [88]      0.31962743      1.1792922      1.7780831     0.48724329
    [92]       7.0385232      13.831503      18.177881      20.853374
    [96]       22.247541      22.520723      21.714682      19.803890
    [100]       16.735445      12.484660      7.0967836      1.8251632
    [104]       3.5584960      7.0501714      9.1982765      11.907128
    [108]       16.045475      20.098696      23.263962      25.433739
    [112]       26.618881      26.808716      25.946909      23.919277
    [116]       20.562555      15.977315      12.427984      12.148379
    [120]       11.586699      9.0071001      2.9321804     -1.9885927
    [124]       7.9310250      13.424224      17.262737      20.047102
    [128]       21.863523      22.720058      22.626163      21.604887
    [132]       19.708372      17.035387      13.683053      9.5875664
    [136]       5.0596628      3.6322265      4.4618363      2.6554079
    [140]      -8.5391665     0.78432661      8.6083384      12.206676
    [144]       13.963319      14.500690      14.027463      12.600252
    [148]       10.296345      7.5228634      5.1930132      3.4453397
    [152]       1.0337934     -3.1399677     -9.3566532     -14.835298
    [156]      -9.9540195     -2.6878870      1.9510323      4.7489204
    [160]       6.2949953      6.8948541      6.6564131      5.5658474
    [164]       3.6000972     0.96348166     -1.4919857     -2.7857985
    [168]      -3.3935015     -3.9789569     -4.4593558     -4.7011900
    [172]      -4.5488553     -3.6337826     -2.1501548    -0.77416027
    [176]     0.088885762     0.29474309    -0.25918087     -1.7208096
    [180]      -4.2647080     -7.8710408     -11.311843     -12.471946
    [184]      -12.892121     -13.743601     -14.135464     -14.035652
    [188]      -14.251837     -13.701242     -11.090542     -8.2559271
    [192]      -6.3744831     -5.5702291     -5.7788739     -6.9079018
    [196]      -8.6972399     -10.425610     -11.333832     -11.936537
    [200]      -13.293165     -16.019094     -20.332531     -25.138103
    [204]      -25.675657     -21.173273     -16.299370     -12.717586
    [208]      -10.419654     -9.1793871     -8.7939501     -9.0695457
    [212]      -9.7837210     -10.720810     -11.840853     -13.420396
    [216]      -16.005238     -20.467678     -29.043999     -48.517830
    [220]      -39.253487     -30.429512     -20.579126     -15.203475
    [224]      -12.005265     -10.203841     -9.4459028     -9.5397253
    [228]      -10.363488     -11.838475     -13.977919     -17.052877
    [232]      -21.955950     -30.196251     -27.289972     -23.864824
    [236]      -24.316378     -24.682148     -19.414852     -14.799114
    [240]      -11.919031     -10.293515     -9.5896416     -9.5880842
    [244]      -10.121643     -11.086036     -12.541297     -14.855144
    [248]      -18.946325     -28.039925     -31.881655     -24.236128
    [252]      -24.092573     -24.419605     -18.176657     -13.135735
    [256]      -10.003523     -8.1665773     -7.2774205     -7.1393080
    [260]      -7.6131678     -8.5826550     -10.018429     -12.157162
    [264]      -15.760399     -23.214025     -35.416325     -23.129303
    [268]      -23.027046     -26.200413     -17.262005     -11.385004
    [272]      -8.0933056     -6.3345246     -5.6547480     -5.8356938
    [276]      -6.7732697     -8.3922997     -10.551219     -13.051404
    [280]      -15.895183     -18.782869     -18.671970     -16.363426
    [284]      -15.454889     -16.347519     -16.285982     -12.511777
    [288]      -8.9348545     -6.6982913     -5.5993581     -5.4196653
    [292]      -5.9602785     -6.8697047     -7.5812960     -7.8955007
    [296]      -8.3934317     -9.6699266     -11.557309     -12.641474
    [300]      -12.321405     -11.622539     -9.9724569     -7.1812062
    [304]      -4.6268463     -2.9998324     -2.3591983     -2.5868657
    [308]      -3.4182785     -4.2817464     -4.5546031     -4.4912090
    [312]      -4.9383879     -6.3619618     -8.2432146     -8.7727270
    [316]      -8.3862543     -9.4629974     -13.170614     -12.084788
    [320]      -6.2026386     -2.7136385    -0.90722513    -0.17669716
    [324]     -0.14331375    -0.52061415     -1.1434594     -2.1334674
    [328]      -3.9691310     -7.1475201     -9.4019651     -7.0711932
    [332]      -5.8192711     -8.0818052     -10.015656     -1.9870373
    [336]       3.1104803      6.0135064      7.6233263      8.4473076
    [340]       8.8365345      9.0057564      8.9730635      8.5330038
    [344]       7.4189329      6.1093602      6.9990087      9.6384087
    [348]       11.317327      11.046390      7.6766195     -3.7983606
    [352]       8.2671890      14.359694      17.252829      18.513447
    [356]       18.689646      18.081663      16.903839      15.308610
    [360]       13.360612      11.030857      8.3158331      5.6414962
    [364]       4.0552039      3.3757114      1.8985612     -2.0002337
    [368]      -8.4011478     -2.5963070      1.7552499      3.5959933
    [372]       4.0986581      3.8997257      3.3939617      2.7034891
    [376]       1.6454260    -0.16479835     -3.0366135     -5.8223391
    [380]      -5.4039960     -4.5614033     -6.2674608     -10.969834
    [384]      -5.8827257    -0.28572708      2.6222215      3.9070590
    [388]       4.1083431      3.5841856      2.6482317      1.5435227
    [392]      0.30194518     -1.2672998     -3.1339271     -4.0486298
    [396]      -2.9398115     -1.6337055     -1.5311078     -3.0576289
    [400]      -5.8997526     -6.1012311     -2.9688694    -0.76364267
    [404]     0.087488547   -0.079104267    -0.93023241     -2.1908386
    [408]      -3.7716041     -5.9369521     -9.0898314     -10.588372
    [412]      -6.7816381     -3.5053160     -2.1020195     -2.5417345
    [416]      -5.0492592     -9.4203587     -8.4803782     -4.4633551
    [420]      -2.2788937     -1.3854449     -1.1795920     -1.3015523
    [424]      -1.6935170     -2.6297972     -4.6926699     -8.6713552
    [428]      -11.431614     -7.2392612     -4.6649604     -4.2947464
    [432]      -4.3835588     -2.2492301     0.72017586      2.7299778
    [436]       3.6329780      3.6670189      3.1065128      2.1531847
    [440]      0.82188731     -1.0944756     -3.8145392     -5.9948478
    [444]      -4.0659771     -1.1223595     0.45367414     0.50048417
    [448]     -0.77407408     -2.0990362    -0.97169280      1.3228599
    [452]       2.8982959      3.5529506      3.4844725      2.8859513
    [456]       1.8608575     0.45673251    -0.96916008     -1.0285960
    [460]      0.83909351      2.7619731      3.4463122      2.1311991
    [464]      -3.1202652     -12.088185      1.4100988      5.9596839
    [468]       7.8598647      8.3492079      8.1262903      7.7326717
    [472]       7.3744092      6.9580569      6.3002334      5.1166048
    [476]       3.8259320      5.3676901      8.7959270      11.037368
    [480]       11.414610      9.4114485      2.4731336     -1.9213759
    [484]       9.3895359      13.394056      15.154946      15.621021
    [488]       15.119320      13.749486      11.531327      8.6412897
    [492]       6.0644503      5.5983396      6.7928176      7.9959664
    [496]       8.4532003      7.8269963      5.9749699      3.5985692
    [500]       3.5561481      5.5700407      7.0534172      7.6043215
    [504]       7.4427838      6.7392220      5.4782667      3.4637327
    [508]      0.33713555     -4.5976472     -13.591067     -27.335684
    [512]      -17.734804
  [Tag]         5441
  [frame_len]          320
[Record 35]
  [tot_power]       724856.44
  [re_spec_val]
    [0]      -23.340525     -21.220604     -21.878536     -28.335367
    [4]      -20.121994     -17.748425     -25.437267     -19.113741
    [8]      -12.476493     -16.075783     -10.669353      1.4423070
    [12]       7.8314080      12.002795      14.795514      16.518549
    [16]       17.254728      16.929470      15.298364      11.828350
    [20]       5.2026815     -10.283735     -11.809196     -2.5427468
    [24]       3.7549193     -1.8728925      10.598386      21.775003
    [28]       28.156357      32.311020      34.949356      36.361443
    [32]       36.666157      35.876842      33.905651      30.515484
    [36]       25.150288      16.189745     -8.8531246      5.8058267
    [40]       8.1991529      5.3238821      12.749611      25.118406
    [44]       31.941996      36.347477      39.154526      40.690891
    [48]       41.092762      40.385887      38.499004      35.227631
    [52]       30.102160      22.044043      14.476588      16.771608
    [56]       16.323023      14.508024      11.463509      8.7565775
    [60]       16.650379      21.941402      24.821257      26.132383
    [64]       26.220287      25.181828      22.913034      19.005209
    [68]       12.291561      5.2790165      10.661651      12.547259
    [72]       11.698412      8.0521784     -5.3153353      7.1392269
    [76]       15.066049      19.460979      22.132042      23.518408
    [80]       23.758707      22.866808      20.754904      17.173735
    [84]       11.439808     0.70629883     -3.9840016      1.8273151
    [88]      0.75487852     -8.7691698      2.3427358      11.066948
    [92]       16.300180      19.807955      22.053444      23.199196
    [96]       23.290653      22.295176      20.091831      16.413347
    [100]       10.660950      1.0322257     -21.811394     -7.4755926
    [104]      -8.1628752      1.7082907      11.703965      18.309856
    [108]       22.824183      25.822081      27.578686      28.220554
    [112]       27.776041      26.178955      23.222715      18.383429
    [116]       9.9517803     -6.8541689      4.2297826      3.5970111
    [120]      -2.2664006     -10.759797     -18.710596    -0.50221980
    [124]       7.8355722      12.350288      14.772799      15.676437
    [128]       15.263704      13.532239      10.272766      4.8873248
    [132]      -4.2768583     -9.6660233     -7.1062479     -9.7563868
    [136]      -14.452965     -10.393056     -2.7919884      3.4629157
    [140]       7.9782209      11.030214      12.845224      13.540426
    [144]       13.144832      11.602787      8.7365170      4.1058869
    [148]      -3.4340672     -10.355925     -6.0746522     -5.1083336
    [152]      -6.5652161     -9.0752754     -7.0187464     -1.6923821
    [156]       2.5118170      5.4207487      7.2029457      7.9346333
    [160]       7.6171856      6.1825624      3.4648020    -0.89785194
    [164]      -7.8140373     -20.346884     -21.548557     -21.196070
    [168]      -26.398100     -22.648596     -15.300304     -9.0961828
    [172]      -4.3616800     -1.0674620     0.94610876      1.7871021
    [176]       1.4849426   -0.019904954     -2.9191983     -7.6712575
    [180]      -15.172872     -19.745209     -17.176954     -17.714304
    [184]      -21.691603     -31.139299     -20.239420     -13.152760
    [188]      -8.6788044     -5.7171526     -3.9678237     -3.3191144
    [192]      -3.7358239     -5.2405944     -7.9267201     -11.996983
    [196]      -17.770432     -24.391655     -26.237108     -27.349771
    [200]      -34.145660     -31.725037     -21.973429     -17.026314
    [204]      -14.015859     -12.293128     -11.656361     -12.054752
    [208]      -13.500380     -16.005924     -19.382954     -22.623356
    [212]      -24.121958     -24.456472     -24.983620     -26.205814
    [216]      -27.626278     -25.900259     -21.540899     -17.864685
    [220]      -15.408462     -14.131455     -14.031137     -15.209568
    [224]      -17.949398     -23.022158     -33.884869     -37.106895
    [228]      -30.978952     -31.207134     -33.300385     -33.366646
    [232]      -30.211786     -25.889915     -21.576876     -17.937107
    [236]      -15.226487     -13.510945     -12.796894     -13.070848
    [240]      -14.297377     -16.382915     -19.103374     -22.025145
    [244]      -24.527327     -26.149906     -27.155830     -28.225576
    [248]      -29.898403     -30.758451     -24.893923     -18.638504
    [252]      -14.276855     -11.466213     -9.9317837     -9.5259218
    [256]      -10.185916     -11.920318     -14.825521     -19.153339
    [260]      -25.537663     -35.989952     -37.697784     -31.860569
    [264]      -30.428583     -35.157387     -28.380939     -18.667313
    [268]      -13.257428     -10.005629     -8.2781382     -7.8465481
    [272]      -8.6778383     -10.925011     -15.082294     -22.366180
    [276]      -25.156866     -20.677055     -19.570251     -20.653269
    [280]      -22.930313     -22.753426     -17.997782     -13.299879
    [284]      -9.8498154     -7.6280394     -6.5566902     -6.6084948
    [288]      -7.8309426     -10.391795     -14.683761     -21.013718
    [292]      -22.698164     -19.781519     -18.969448     -20.042162
    [296]      -21.780422     -19.164433     -13.830523     -9.4974623
    [300]      -6.3921242     -4.3850451     -3.3992186     -3.4060707
    [304]      -4.4152479     -6.4697938     -9.6019192     -13.508796
    [308]      -16.439529     -16.957642     -17.373690     -19.471346
    [312]      -23.152645     -18.306570     -11.877274     -7.5534010
    [316]      -4.6824274     -2.9450171     -2.2089238     -2.4252319
    [320]      -3.5897913     -5.7145295     -8.7388334     -12.225990
    [324]      -15.075676     -16.871826     -18.452526     -20.197632
    [328]      -19.318558     -12.198640     -5.9106226     -1.4991419
    [332]       1.4147828      3.0794826      3.6078794      2.9988844
    [336]       1.1057016     -2.5145571     -9.2830038     -24.677881
    [340]      -14.437562     -13.728468     -18.005127     -14.086988
    [344]      -7.2089744    -0.67599314      5.1314688      9.5794134
    [348]       12.669667      14.521859      15.204246      14.703959
    [352]       12.909650      9.6023788      4.8132377      1.5889748
    [356]       1.9345952      1.0580258     -2.3426576     -7.0823555
    [360]      -8.3827248     -10.907669     -9.1935291     -1.4911262
    [364]       2.6150458      4.4564977      4.6785779      3.5126381
    [368]      0.95864493     -3.2315392     -9.7575598     -17.944626
    [372]      -16.229862     -15.020276     -16.465582     -21.416393
    [376]      -27.662422     -13.129860     -6.4399433     -2.2059026
    [380]      0.52170974      2.0574074      2.5198004      1.9328747
    [384]      0.25469568     -2.6120965     -6.7726192     -12.004951
    [388]      -16.812103     -20.487421     -24.595222     -21.629589
    [392]      -16.541958     -12.657860     -9.1289482     -5.9512148
    [396]      -3.4765713     -1.9263151     -1.3972291     -1.9598927
    [400]      -3.7316835     -6.9698710     -12.346069     -22.507162
    [404]      -27.807796     -21.660402     -21.223576     -20.572031
    [408]      -17.265289     -13.385597     -9.7074366     -6.5022578
    [412]      -4.0958195     -2.6672349     -2.2813444     -2.9792581
    [416]      -4.8390360     -8.0187254     -12.655168     -17.158195
    [420]      -17.142767     -16.095320     -15.676836     -14.452354
    [424]      -11.471622     -7.5493622     -3.7805009    -0.74083674
    [428]       1.3753021      2.5293937      2.7202604      1.9320210
    [432]     0.092151374     -3.0218592     -8.1031113     -17.705359
    [436]      -17.119162     -11.694994     -10.266718     -10.657602
    [440]      -11.959414     -13.552253     -12.011400     -6.6465979
    [444]      -2.2860267     0.38588503      1.5200226      1.1340469
    [448]      -1.0413220     -6.0191221     -17.434010     -10.262656
    [452]      -6.1845794     -5.2071948     -4.5925193     -3.0674655
    [456]      -1.6239880    -0.92215419    -0.24351217      1.5147300
    [460]       3.7630568      5.3903737      5.9692259      5.3580403
    [464]       3.3763645    -0.38571680     -6.4277215     -8.1969528
    [468]      -4.2240739     -1.2917626      1.7704978      5.0861282
    [472]       8.1472712      10.754223      12.872732      14.455272
    [476]       15.417901      15.659840      15.066369      13.486970
    [480]       10.689367      6.3076453     0.36958557     -2.3123927
    [484]      -1.4721755     -1.9065870     -2.0766931    -0.52136201
    [488]       1.7035096      4.6370764      8.0176535      10.930658
    [492]       12.940813      13.966086      13.995234      12.977384
    [496]       10.761184      6.9950609     0.97425073     -5.0450001
    [500]      -2.6102419     -1.5617688     -2.7182050     -4.2111449
    [504]      -3.2346599    -0.46275175      2.3955266      4.7405586
    [508]       6.2720776      6.8441463      6.4605842      5.4420848
    [512]       4.8112540
  [Tag]         5601
  [frame_len]          320
[Record 36]
  [tot_power]       759560.12
  [re_spec_val]
    [0]      -33.031746     -33.453506     -34.348701     -33.463531
    [4]      -29.808262     -27.257151     -31.223635     -26.588699
    [8]      -17.051861     -16.641939     -13.736316    -0.15615913
    [12]       7.3019328      12.049449      14.975538      16.417973
    [16]       16.518591      15.334444      12.903515      9.3022881
    [20]       4.5395274     -2.9155822     -9.7609930      3.2847419
    [24]       7.3091030      4.4795656      8.2408628      20.987860
    [28]       27.845057      32.290939      35.157169      36.769764
    [32]       37.274071      36.721992      35.097466      32.314068
    [36]       28.188353      22.393095      14.687284      10.373813
    [40]       14.505598      17.939774      19.299374      20.904360
    [44]       26.579384      32.120548      36.011070      38.461853
    [48]       39.693649      39.829441      38.922421      36.977970
    [52]       33.978447      29.998083      25.839802      23.824245
    [56]       23.760635      23.454769      22.320318      20.154484
    [60]       16.764635      19.279861      25.426472      29.367212
    [64]       31.489477      32.170589      31.596325      29.891872
    [68]       27.325790      24.729111      23.213163      22.352282
    [72]       21.028568      18.913462      16.643291      16.584793
    [76]       19.540438      22.802879      25.160152      26.424778
    [80]       26.588825      25.637062      23.496294      19.996248
    [84]       14.827044      7.8422275      2.8747082      3.2271664
    [88]       3.6243281      2.6742208      4.3266139      11.622435
    [92]       17.118418      20.660841      22.735424      23.591709
    [96]       23.333611      21.969818      19.423468      15.505707
    [100]       9.8293991      1.5568461     -10.055060     -3.6047664
    [104]       2.5012102      5.1137581      4.8715796      8.3087931
    [108]       15.683171      20.981230      24.461195      26.573584
    [112]       27.562126      27.563139      26.666792      24.962357
    [116]       22.589397      19.802111      17.033270      14.885074
    [120]       13.757133      13.306988      12.838014      11.775640
    [124]       9.5710001      7.8248420      12.363186      17.297213
    [128]       20.550213      22.480143      23.401131      23.556852
    [132]       23.203560      22.655596      22.223875      22.039902
    [136]       22.000149      21.945995      21.846672      21.863596
    [140]       22.263525      23.120024      24.145092      24.939699
    [144]       25.231787      24.900297      23.950916      22.536228
    [148]       20.970655      19.546265      18.208565      16.673336
    [152]       14.899483      13.260940      11.876499      9.7797642
    [156]       4.8256593     -2.0180740      7.9840646      12.330276
    [160]       13.934978      13.742460      12.080446      9.3189821
    [164]       6.6040487      5.2258306      4.1094265      1.9819700
    [168]     -0.95812201     -3.5813882     -7.6312971     -25.015114
    [172]      -2.3764639      3.8160944      6.8938122      8.1388168
    [176]       7.9251709      6.3426075      3.3285515     -1.2025839
    [180]      -6.4836593     -9.5404501     -11.646415     -15.533765
    [184]      -17.308475     -17.270103     -21.275099     -11.635625
    [188]      -4.4514470    -0.33152935      1.9651481      2.8960013
    [192]       2.6676598      1.4365580    -0.50146526     -2.5242579
    [196]      -4.0980673     -5.6457076     -8.0005836     -11.328032
    [200]      -13.286495     -11.749058     -9.7375298     -7.9799933
    [204]      -6.1572132     -4.4402556     -3.2404888     -2.8345490
    [208]      -3.3797388     -5.0319614     -8.0771341     -13.206687
    [212]      -21.870893     -21.544405     -17.958212     -17.806425
    [216]      -20.197292     -26.760916     -26.299372     -16.284704
    [220]      -10.852454     -7.4377346     -5.3823299     -4.4208808
    [224]      -4.4105034     -5.2530475     -6.8523769     -9.0739346
    [228]      -11.702636     -14.350327     -16.093031     -15.823729
    [232]      -14.426158     -13.362019     -13.034186     -13.037929
    [236]      -12.497692     -11.292077     -10.299935     -10.192984
    [240]      -11.282590     -13.769619     -17.305494     -18.324944
    [244]      -16.123919     -14.665464     -14.493830     -15.152971
    [248]      -15.430914     -13.517215     -10.043496     -6.7222385
    [252]      -4.1705761     -2.5020664     -1.7151293     -1.7840146
    [256]      -2.6698089     -4.3057179     -6.5784345     -9.3479061
    [260]      -12.470389     -15.211517     -15.454444     -14.109902
    [264]      -13.890433     -16.445768     -28.919554     -17.457336
    [268]      -10.022855     -6.6024127     -5.1659732     -5.1805282
    [272]      -6.3677411     -8.1858473     -9.3587275     -9.2652998
    [276]      -9.0615921     -9.5114012     -10.478386     -11.301763
    [280]      -11.407431     -10.603274     -8.6222467     -5.9002886
    [284]      -3.4356742     -1.7826158     -1.1234652     -1.5488676
    [288]      -3.2033267     -6.4325414     -12.273897     -27.691668
    [292]      -20.149370     -15.495709     -14.635324     -15.057188
    [296]      -15.307483     -12.324356     -7.1762781     -2.8382719
    [300]      0.23315260      2.1542845      3.0525033      3.0236838
    [304]       2.1610203     0.61075944     -1.3584100     -3.3893113
    [308]      -5.3119798     -7.2107987     -8.7849350     -9.2652960
    [312]      -9.0603914     -8.8498621     -7.3440485     -4.0851960
    [316]      -1.0521352     0.87772840      1.6254902      1.2373364
    [320]     -0.24170209     -2.6777997     -5.3901935     -6.7428985
    [324]      -6.6328859     -6.6491628     -7.1887288     -7.5470176
    [328]      -6.9586029     -4.7652454    -0.86352551      3.1119637
    [332]       6.1271000      7.9888568      8.7169523      8.3381796
    [336]       6.8486390      4.2429895     0.74020839     -2.4315977
    [340]      -3.6319897     -3.6172118     -2.6434741     -1.1760404
    [344]     -0.27183181      2.5894129      8.2889261      13.156666
    [348]       16.494804      18.475647      19.250553      18.890589
    [352]       17.409649      14.826816      11.433123      8.5303507
    [356]       7.5077715      7.1385880      6.2209654      4.4792547
    [360]       1.6300846     -2.2519872    0.078052029      5.7008348
    [364]       9.4414034      11.591237      12.459214      12.208637
    [368]       10.974675      9.0129147      6.8968830      5.3033552
    [372]       4.1241426      2.6858816     0.73208922     -1.1700374
    [376]      -1.7844720    -0.50510645      2.1371157      4.9907780
    [380]       7.1999416      8.4502497      8.6680717      7.8395486
    [384]       5.9825501      3.2841666     0.53432792     -1.0520469
    [388]      -1.8804276     -3.1665800     -5.1438031     -6.8179784
    [392]      -6.1756577     -3.1654084     0.28614783      3.0983214
    [396]       4.9738955      5.8768301      5.8469963      4.9838119
    [400]       3.5243616      1.9278930     0.62234545    -0.54149204
    [404]      -2.0788684     -4.2246370     -6.5451384     -7.8585410
    [408]      -7.3695927     -5.3786535     -2.9046035    -0.96333891
    [412]    -0.057856191    -0.43623832     -2.4101136     -6.6648679
    [416]      -12.489595     -8.3544273     -4.3990297     -2.5261741
    [420]      -1.7709994     -1.5399102     -1.3321704    -0.71399879
    [424]      0.49817428      2.1547048      3.8946588      5.3287506
    [428]       6.1622210      6.2032342      5.3101463      3.3304539
    [432]     0.038612582     -4.8276639     -9.3926716     -7.4598746
    [436]      -4.3509912     -2.1494069    -0.51273358     0.96985888
    [440]       2.6355839      4.4638929      6.1246929      7.3015742
    [444]       7.7989202      7.4804163      6.1893091      3.6550560
    [448]     -0.71438277     -8.4060116     -12.223656     -7.7270536
    [452]      -7.2025371     -8.1218042     -6.7944598     -3.9097507
    [456]      -1.0293292      2.1347923      5.1982532      7.5106492
    [460]       8.7849655      8.9334898      7.8861060      5.4937191
    [464]       1.4036463     -5.2877231     -14.263546     -11.303785
    [468]      -10.598524     -13.958300     -14.645735     -6.7132401
    [472]     -0.16100757      5.1895828      9.3054543      12.164862
    [476]       13.812721      14.279092      13.536716      11.463975
    [480]       7.7651544      1.7774525     -6.2999063     -5.6574545
    [484]      -4.5716810     -6.4249969     -10.759697     -8.9759617
    [488]      -1.5241593      4.1074691      8.2585363      11.129661
    [492]       12.776816      13.187778      12.256974      9.6809292
    [496]       4.5532889     -7.8392367     -4.3619781     0.49523279
    [500]      0.61161089     -1.8923460     -7.0156436     -12.037292
    [504]      -6.7474990     -1.6869569      2.3752317      5.4769182
    [508]       7.3579817      7.7733173      6.2917724      1.4899890
    [512]      -21.210096
  [Tag]         5761
  [frame_len]          320
[Record 37]
  [tot_power]       1391152.8
  [re_spec_val]
    [0]      -27.859924     -21.929876     -22.120237     -50.017635
    [4]      -19.230145     -16.539125     -23.808735     -18.491316
    [8]      -11.997801     -16.744196     -8.2994194      2.8644593
    [12]       9.0158463      13.066758      15.789081      17.480484
    [16]       18.230156      17.984932      16.551689      13.542670
    [20]       8.2224379    -0.51330251     -6.6690426      1.3363395
    [24]       6.7050409      5.2285395      8.2970810      20.957853
    [28]       27.810589      32.192261      34.968410      36.478832
    [32]       36.869034      36.178028      34.357151      31.247488
    [36]       26.494850      19.336088      10.016557      10.056823
    [40]       10.756369      9.0302954      12.331836      22.176834
    [44]       28.728601      33.085823      35.892780      37.433285
    [48]       37.821022      37.061485      35.062607      31.618919
    [52]       26.423550      19.569132      13.717523      13.551395
    [56]       17.442379      18.516373      20.533726      28.307625
    [60]       34.231148      38.137825      40.601170      41.926018
    [64]       42.261917      41.668633      40.144226      37.637196
    [68]       34.058540      29.326963      23.520821      16.925064
    [72]       7.9631791      2.0631733      12.970886      18.696379
    [76]       22.942101      25.928606      27.713194      28.388144
    [80]       28.016188      26.601349      24.071815      20.246904
    [84]       14.757848      7.0520372      1.0225351      2.5447614
    [88]       3.1076806      3.4329565      7.9790502      13.810739
    [92]       18.221315      21.217934      23.010344      23.721001
    [96]       23.395679      22.018511      19.512587      15.729848
    [100]       10.471794      4.0489259     0.74960774      2.2914999
    [104]       3.3146670      1.0204017     -3.7021711      9.1552019
    [108]       15.850261      19.849394      22.202761      23.287422
    [112]       23.263029      22.189070      20.066082      16.863354
    [116]       12.589086      7.5641670      3.1104293     0.81639332
    [120]      -1.0782969     -10.295574    0.097598024      10.049216
    [124]       15.649507      19.284845      21.586920      22.807131
    [128]       23.053421      22.367292      20.784592      18.482092
    [132]       16.116674      14.655354      13.810641      12.705732
    [136]       12.176154      13.619647      15.176917      15.007151
    [140]       11.920698      10.067026      17.634336      22.524475
    [144]       25.347736      26.885134      27.567022      27.733162
    [148]       27.697603      27.673307      27.673279      27.560472
    [152]       27.191969      26.510523      25.600714      24.783232
    [156]       24.612131      25.373087      26.679300      27.999643
    [160]       29.054289      29.755026      30.099577      30.123030
    [164]       29.880926      29.443350      28.889935      28.299732
    [168]       27.734457      27.223240      26.765471      26.363033
    [172]       26.069000      26.000689      26.249634      26.747702
    [176]       27.281906      27.636427      27.677673      27.355453
    [180]       26.681379      25.712442      24.536303      23.249928
    [184]       21.938835      20.677624      19.548565      18.646320
    [188]       18.067213      17.883060      18.041927      18.289061
    [192]       18.277462      17.719963      16.426430      14.297766
    [196]       11.443134      8.7004404      7.6860538      8.1553841
    [200]       8.8374519      9.5624161      10.710706      12.415589
    [204]       14.257133      15.713721      16.475676      16.390669
    [208]       15.355470      13.244841      9.8640566      5.0559893
    [212]      0.59308350      1.0711942      2.5202539      2.9909296
    [216]       2.9333358      3.0257525      3.7903144      5.1753163
    [220]       6.7097020      7.9582434      8.6374550      8.5581732
    [224]       7.5637722      5.4688039      1.9528005     -3.7703636
    [228]      -14.331231     -12.951079     -8.1595345     -6.3769379
    [232]      -5.0960631     -3.1216600    -0.50031912      2.0374742
    [236]       4.0124116      5.2333775      5.6131854      5.0714869
    [240]       3.4768867     0.55513680     -4.3905210     -13.146423
    [244]      -11.761261     -6.6757379     -4.4856625     -3.4586518
    [248]      -2.6513007     -1.1782649      1.1893666      3.6993275
    [252]       5.6587605      6.7775059      6.9515672      6.1117392
    [256]       4.1508436     0.86872029     -3.9385698     -8.1000719
    [260]      -6.4877610     -4.3045645     -3.2019877     -2.6876755
    [264]      -2.0739872    -0.56181717      1.8669236      4.3478298
    [268]       6.2328806      7.2751856      7.3883171      6.5099835
    [272]       4.5452294      1.3617413     -2.8786685     -5.6753869
    [276]      -4.6925869     -3.3496261     -2.6630943     -2.3044143
    [280]      -1.7221029    -0.18415019      2.2660348      4.6904230
    [284]       6.4432540      7.3135056      7.2562675      6.2685084
    [288]       4.3788552      1.7740709    -0.75591469     -1.7617077
    [292]      -1.3161262    -0.60623109    0.022166364     0.76962507
    [296]       2.0103614      3.9809194      6.3452058      8.4837713
    [300]       9.9974976      10.728587      10.633870      9.7143726
    [304]       8.0027971      5.6174626      2.9512961     0.87310874
    [308]   -0.0039178254    -0.14248404    0.056386456     0.79969758
    [312]       2.4339285      4.8737049      7.5052705      9.7392168
    [316]       11.282628      12.034237      11.961586      11.038291
    [320]       9.2204762      6.4721189      2.9652359    -0.27952558
    [324]      -1.7504015     -1.9329413     -1.2608436     0.81707466
    [328]       4.0999737      7.6962714      10.871862      13.288528
    [332]       14.844522      15.511788      15.245698      13.919874
    [336]       11.225574      6.4264426    -0.80980200      1.7930447
    [340]       5.1382442      5.8554044      4.8067422      2.7434261
    [344]       6.5932016      13.502049      18.555820      22.001850
    [348]       24.169308      25.230455      25.273155      24.374475
    [352]       22.758299      21.112108      20.359261      20.256201
    [356]       19.908625      19.120758      18.346767      17.935520
    [360]       17.709330      18.021164      19.777178      22.250935
    [364]       24.219677      25.261793      25.311989      24.358931
    [368]       22.373190      19.344231      15.582816      12.587204
    [372]       11.723292      11.523232      11.079889      10.650225
    [376]       10.792163      12.002203      14.023018      15.998269
    [380]       17.357563      17.890457      17.533426      16.273565
    [384]       14.182091      11.657642      9.7734470      9.2192030
    [388]       9.1185732      8.7638559      8.2576990      8.1235447
    [392]       8.8829498      10.531453      12.468957      14.075465
    [396]       15.007836      15.116160      14.334143      12.651315
    [400]       10.227145      7.7859721      6.5624647      6.3748875
    [404]       6.0658393      5.2719316      4.3502774      4.1147833
    [408]       5.2216129      7.2809234      9.3774586      10.930141
    [412]       11.702600      11.609130      10.616650      8.7387772
    [416]       6.1643686      3.6304219      2.3075259      2.0935898
    [420]       2.0905445      2.0415015      1.9490612      1.8462019
    [424]       2.3072910      4.0440235      6.3280473      8.0977678
    [428]       8.9481831      8.7966156      7.6413131      5.5439515
    [432]       2.8537214     0.70858711     0.14273725     0.27060086
    [436]      0.27069134     0.25894716     0.50283027      1.0783728
    [440]       2.2548990      4.1831589      6.2705498      7.8488922
    [444]       8.6221371      8.5147963      7.5393667      5.8139577
    [448]       3.7711039      2.3178647      1.8474756      1.5985398
    [452]       1.0934412     0.69164419     0.93963408      1.8398614
    [456]       3.3291228      5.3598185      7.4354591      9.0153923
    [460]       9.8386641      9.8346319      9.0410309      7.6734347
    [464]       6.3266101      5.7270184      5.7013168      5.5354500
    [468]       5.0692215      4.7459860      4.8942065      5.4017406
    [472]       6.6348624      9.0028982      11.664510      13.732132
    [476]       14.909573      15.168526      14.585675      13.394613
    [480]       12.131228      11.384441      11.002959      10.368679
    [484]       9.3228569      8.4534292      8.3964434      8.8062468
    [488]       9.4355774      10.822109      12.893976      14.770018
    [492]       15.905096      16.161983      15.587342      14.401609
    [496]       13.123870      12.366928      12.052088      11.530006
    [500]       10.377406      8.6030407      6.7052288      5.5471792
    [504]       5.5930190      6.7680521      8.6211548      10.383176
    [508]       11.525959      11.864533      11.437671      10.581182
    [512]       10.098834
  [Tag]         5921
  [frame_len]          320
[Record 38]
  [tot_power]       1301257.2
  [re_spec_val]
    [0]      -27.921061     -28.128651     -28.912863     -33.070721
    [4]      -43.509243     -29.850452     -31.428083     -21.189404
    [8]      -14.828042     -17.885668     -9.6116533      2.6171997
    [12]       9.3938732      13.707845      16.330101      17.582094
    [16]       17.637239      16.628370      14.705431      12.016006
    [20]       8.4104118      2.1036756     -9.6006565      5.4642315
    [24]       8.3598909      4.0509090      15.399827      24.520979
    [28]       30.112022      33.736534      35.927769      36.911709
    [32]       36.780170      35.543072      33.139317      29.416134
    [36]       24.022326      15.794878      3.3805509      11.770019
    [40]       13.520451      15.106837      23.085094      29.415215
    [44]       33.636547      36.310940      37.726208      38.011322
    [48]       37.198990      35.238377      31.963522      26.970043
    [52]       19.184563      7.6568770      7.2567644      10.006332
    [56]       22.130846      29.425200      34.415401      37.921745
    [60]       40.250416      41.534054      41.825199      41.124641
    [64]       39.387295      36.517994      32.368874      26.802286
    [68]       20.188883      14.624835      11.085039      8.9372759
    [72]       8.2785501      8.4786205      11.346658      15.881770
    [76]       19.884926      22.724279      24.320789      24.702419
    [80]       23.891302      21.871983      18.593145      14.028885
    [84]       8.3716040      1.8623043     -7.5511703     -7.4513059
    [88]      -3.6095035     0.48982459      7.8526487      13.292757
    [92]       16.832806      18.933214      19.841696      19.671162
    [96]       18.453611      16.165133      12.738070      8.0649128
    [100]       1.9474791     -6.1135869     -13.525404     -12.710125
    [104]      -3.7752414      4.6254878      10.304442      14.155233
    [108]       16.654673      18.040930      18.434320      17.888603
    [112]       16.410837      13.959899      10.415833      5.5190368
    [116]     -0.70759130     -3.6354785     -3.0560508     -6.1699257
    [120]      -9.2534628      2.3895800      8.4244318      12.085796
    [124]       14.281050      15.329808      15.365943      14.452363
    [128]       12.628724      9.9285641      6.3207064      1.4164778
    [132]      -6.3482957     -10.844428     -6.3808460     -9.5508032
    [136]      -8.7541246      3.6909258      9.7310610      13.363276
    [140]       15.441071      16.259987      15.914079      14.372165
    [144]       11.460941      6.8378005      1.7944391      3.6755118
    [148]       6.7743893      8.3593121      8.6662016      7.6635814
    [152]       5.5786138      6.1730776      10.359145      13.585212
    [156]       15.216330      15.399544      14.241071      11.920526
    [160]       9.1186571      6.9639959      5.0516911      2.0940225
    [164]     -0.96575862     -1.2806876    -0.52783990     0.70978516
    [168]       2.3640397      5.5442762      10.500707      14.751259
    [172]       17.534119      18.930893      19.124588      18.344868
    [176]       16.955864      15.467672      14.340498      13.906775
    [180]       14.153711      14.334105      13.702305      12.632444
    [184]       13.478027      16.094580      18.169823      19.197798
    [188]       19.381845      19.058573      18.559185      18.084587
    [192]       17.667530      17.255472      16.791203      16.304277
    [196]       16.002394      16.072323      16.250326      15.898078
    [200]       14.253055      9.8411970     -5.0386629      10.471517
    [204]       16.541864      19.673777      21.426603      22.358931
    [208]       22.777435      22.864449      22.696140      22.273352
    [212]       21.591919      20.725006      19.882017      19.372862
    [216]       19.412434      19.959160      20.809456      21.747343
    [220]       22.595043      23.226364      23.572643      23.615334
    [224]       23.368431      22.858709      22.111731      21.149357
    [228]       19.995472      18.673998      17.185387      15.490658
    [232]       13.633547      12.245214      12.632098      14.432964
    [236]       16.169125      17.248177      17.603756      17.315250
    [240]       16.533587      15.505996      14.591515      14.113813
    [244]       14.072658      14.194584      14.390260      15.076790
    [248]       16.676218      18.723944      20.458298      21.483528
    [252]       21.659819      20.929440      19.250761      16.604187
    [256]       13.097550      9.2502880      6.0021844      3.6430097
    [260]       2.3196819      2.8467591      5.2547822      8.8843441
    [264]       12.420311      15.055540      16.593788      17.031109
    [268]       16.389374      14.692832      12.014736      8.5838232
    [272]       4.7979412      1.0472958    -0.67163450      1.2846730
    [276]       3.2616940      4.6008539      6.8013015      9.9773417
    [280]       12.756905      14.523376      15.191814      14.794692
    [284]       13.407657      11.235646      8.7600451      6.4727325
    [288]       4.0946484      1.4078003      1.3368374      4.1997085
    [292]       6.6399956      8.6333361      10.927841      13.410695
    [296]       15.448319      16.669811      16.967037      16.342499
    [300]       14.866212      12.703602      10.113408      7.2726598
    [304]       4.3156662      2.7486811      4.0979309      6.0081553
    [308]       7.5008216      9.2115707      11.484911      13.728040
    [312]       15.349195      16.131428      16.070652      15.279970
    [316]       13.957447      12.266548      10.096017      6.9816904
    [320]       2.6423829     0.75548160      3.7678261      6.6640368
    [324]       9.4020443      12.350388      15.109961      17.244837
    [328]       18.559645      19.010717      18.649862      17.634342
    [332]       16.201986      14.432566      11.896000      7.6583490
    [336]       3.9599893      8.4267664      12.157188      14.793788
    [340]       17.692923      20.931856      23.820112      25.980177
    [344]       27.345921      27.960897      27.888687      27.163271
    [348]       25.732061      23.378609      19.562944      12.661699
    [352]      -15.238845      9.3610821      12.664415      15.678018
    [356]       20.975500      25.830891      29.425215      31.866240
    [360]       33.303715      33.842674      33.554790      32.486347
    [364]       30.647114      27.964832      24.173901      18.503124
    [368]       8.2636204      6.9844437      11.957245      13.447516
    [372]       15.462185      18.458986      21.036373      22.694771
    [376]       23.411737      23.243923      22.281076      20.677856
    [380]       18.622023      16.099819      12.535680      6.1644359
    [384]      -6.1917176      5.1363335      8.8740015      10.633101
    [388]       12.689500      15.308088      17.605469      19.122013
    [392]       19.794315      19.691879      18.928255      17.602882
    [396]       15.686198      12.858696      8.2367601     -1.2307020
    [400]      -1.8163261      4.7716084      7.0646596      8.7097225
    [404]       11.092475      13.653182      15.620660      16.771399
    [408]       17.135530      16.833277      16.015236      14.764377
    [412]       12.954149      10.161459      5.5293999     -2.5423505
    [416]      -2.0642464      2.5320716      4.5937877      6.4929771
    [420]       8.9796124      11.339840      13.004790      13.832788
    [424]       13.863753      13.228026      12.109389      10.613924
    [428]       8.5500212      5.3135586    0.025345486     -2.5963526
    [432]       1.7570665      4.2395482      5.3719730      6.5273900
    [436]       8.3266764      10.172650      11.460862      12.037033
    [440]       11.988890      11.479661      10.587324      9.1465902
    [444]       6.6942501      2.3379591     -5.4298806     -3.4219699
    [448]       1.5184249      3.9942608      6.0095048      8.3123188
    [452]       10.533415      12.209933      13.208163      13.610862
    [456]       13.585470      13.231619      12.432506      10.844462
    [460]       7.9529219      3.2219450     0.35217047      3.9385808
    [464]       6.5053778      7.8516879      9.1664915      11.148561
    [468]       13.338772      15.098190      16.207909      16.681479
    [472]       16.546125      15.695289      13.779310      9.9493113
    [476]      0.79824954    -0.64588088      8.0201902      10.983793
    [480]       12.246403      13.162330      14.628243      16.659927
    [484]       18.648756      20.150396      20.999035      21.153067
    [488]       20.588913      19.242746      16.982286      13.662243
    [492]       9.7381496      7.9919744      8.8018808      9.3765707
    [496]       9.6639872      10.661194      12.442058      14.220893
    [500]       15.500219      16.134586      16.132175      15.581189
    [504]       14.618970      13.385308      11.976491      10.453143
    [508]       8.8610611      7.1688018      5.2354846      3.1321621
    [512]       2.0007203
  [Tag]         6081
  [frame_len]          320
[Record 39]
  [tot_power]       1093846.8
  [re_spec_val]
    [0]      -18.243986     -20.420525     -29.616432     -26.612000
    [4]      -23.637165     -33.706581     -19.768888     -13.659078
    [8]      -14.121335     -23.597483     -3.1779599      4.8718071
    [12]       10.078685      13.657755      15.993931      17.206173
    [16]       17.266413      16.015299      13.131332      8.1622286
    [20]       1.7214746     -3.0572240    -0.15259948      5.4785991
    [24]       3.5661335      11.699585      22.490280      28.965433
    [28]       33.245277      36.012779      37.548676      37.963840
    [32]       37.265377      35.368237      32.074013      27.018948
    [36]       19.685253      10.755662      4.2537570      10.259681
    [40]       20.491556      27.954393      33.298164      36.975536
    [44]       39.286316      40.408184      40.424946      39.337685
    [48]       37.050320      33.306374      27.488695      18.152004
    [52]       13.339760      14.850257      13.315690      16.989929
    [56]       22.556561      27.042068      30.452278      32.785786
    [60]       34.071064      34.368328      33.748985      32.295677
    [64]       30.109068      27.288755      23.846272      19.548876
    [68]       13.687066      4.4268870     0.28707170      4.9644141
    [72]       9.1355171      14.327394      18.420654      21.067118
    [76]       22.446424      22.713543      21.948116      20.152521
    [80]       17.232027      12.929550      6.6330643     -3.1905408
    [84]      -12.120025     -14.033958     -9.2900686    -0.57193983
    [88]       4.8179955      8.9036026      12.057464      14.248246
    [92]       15.435562      15.601194      14.714992      12.704764
    [96]       9.4244137      4.5997591     -2.3018451     -12.736977
    [100]      -35.235073     -16.802237     -11.977853     -6.2331853
    [104]     -0.33440229      4.0734701      6.9878678      8.6304989
    [108]       9.1432171      8.5762539      6.8960137      3.9708691
    [112]     -0.52487636     -7.7355890     -35.252201     -11.127765
    [116]      -6.5776381     -5.5237045     -5.0434017    -0.80609947
    [120]       3.9896967      7.2582059      9.0778160      9.6218815
    [124]       8.9336243      6.9048758      3.2174101     -2.5544071
    [128]      -6.7224755     -5.0649772     -5.0653663     -7.2307100
    [132]      -11.181614     -21.033558     -7.2833652     0.79950780
    [136]       5.4914155      8.2981434      9.7313633      10.034409
    [140]       9.3764715      7.9853921      6.2561827      4.5554662
    [144]       2.6403961    -0.33643883     -4.9530053     -7.5931993
    [148]      -7.2277303     -12.335803     -6.7454000      2.1587546
    [152]       6.7137027      9.1041880      9.9520226      9.4427929
    [156]       7.5679088      4.4364686      2.0560462      3.3321748
    [160]       5.0069814      5.4289303      4.6449213      3.0476701
    [164]       1.9563646      3.3842201      6.2257643      8.7185173
    [168]       10.417245      11.306432      11.471850      11.064998
    [172]       10.294495      9.3332167      8.1618471      6.5539737
    [176]       4.2341094     0.96181905     -3.9101872     -16.485531
    [180]      -6.2904277      1.9708877      6.4290013      9.0864763
    [184]       10.463276      10.749900      10.001451      8.1962652
    [188]       5.2841344      1.3245616     -3.1968570     -7.7352061
    [192]      -12.405237     -10.759563     -6.6723709     -3.1644850
    [196]       1.1295166      5.1813641      8.1344662      9.8898563
    [200]       10.525187      10.126056      8.8208208      6.9631143
    [204]       5.3253136      4.4111004      3.5478590      1.8333044
    [208]      -1.2520850     -6.0756869     -11.635962     -6.5742121
    [212]     0.066650368      4.5878925      7.4778008      9.0120077
    [216]       9.3109255      8.4215803      6.4840846      4.2526889
    [220]       3.1896126      2.8878057      1.7512414    -0.51245296
    [224]      -2.3979826     -2.7361436     -1.4484053      3.0199258
    [228]       7.5766273      10.727476      12.543900      13.220967
    [232]       12.903192      11.737842      10.019728      8.3321781
    [236]       7.1135402      5.9865847      4.8651671      5.5941739
    [240]       8.1469879      10.089094      10.606011      9.9971037
    [244]       10.559464      13.836243      17.119244      19.366135
    [248]       20.700426      21.429747      21.865940      22.185692
    [252]       22.336926      22.153894      21.582088      20.905893
    [256]       20.829594      21.764322      23.220245      24.638695
    [260]       25.822330      26.734091      27.343355      27.604588
    [264]       27.491253      27.027489      26.289341      25.356714
    [268]       24.234562      22.830637      21.046282      18.972212
    [272]       17.384012      18.058998      20.820702      23.693716
    [276]       25.829960      27.051109      27.317966      26.587721
    [280]       24.766472      21.668659      16.960407      10.228554
    [284]       2.9684806    0.056220252      4.6758218      11.224352
    [288]       15.809004      19.099705      21.462238      22.965696
    [292]       23.580952      23.258213      21.942337      19.599859
    [296]       16.357515      12.813819      9.5030241      4.4546294
    [300]      -11.862290      6.7801247      12.675642      16.062027
    [304]       18.430662      20.163397      21.252626      21.581610
    [308]       21.030092      19.489967      16.913065      13.622254
    [312]       10.900043      9.2073994      6.4321175      3.1505659
    [316]       8.2464695      13.216310      16.617121      19.276054
    [320]       21.446428      23.043434      23.924635      23.984522
    [324]       23.140884      21.318239      18.509428      15.105823
    [328]       12.285173      10.054359      5.7598100     0.16645196
    [332]       9.2061567      14.588810      18.255747      21.254730
    [336]       23.687973      25.401342      26.282267      26.291250
    [340]       25.446558      23.843889      21.671144      18.997246
    [344]       15.080778      6.1399984      7.4974208      15.795925
    [348]       19.295874      21.523834      23.937626      26.662893
    [352]       29.039909      30.663780      31.427969      31.344576
    [356]       30.499319      29.095505      27.436682      25.571451
    [360]       22.801474      17.488001      14.300283      21.118484
    [364]       24.663567      26.366356      27.502865      28.807812
    [368]       30.131565      30.952425      30.952265      30.003248
    [372]       28.054239      25.132698      21.535345      18.003239
    [376]       14.519455      8.5696030      5.1068215      13.807145
    [380]       18.082472      20.576834      22.273239      23.455606
    [384]       24.066751      23.951046      22.975296      21.073114
    [388]       18.350098      15.303066      12.406549      8.3456516
    [392]      -4.8145514      5.2599702      12.371366      15.678220
    [396]       17.678926      19.194681      20.385183      21.055605
    [400]       20.971840      19.969408      17.958078      15.045084
    [404]       11.971831      9.6984272      6.8426175     -1.0851350
    [408]       2.3661511      10.348498      14.147309      16.367271
    [412]       17.897661      19.062555      19.817368      19.973751
    [416]       19.364382      17.894547      15.612256      12.941224
    [420]       10.686589      8.6416960      4.8137527     -7.8183680
    [424]       2.0182972      8.8184900      12.028528      13.897130
    [428]       15.137727      15.929180      16.164440      15.663274
    [432]       14.295975      12.100616      9.5815315      7.6373305
    [436]       5.7701306      1.4035791     -17.866980      3.1736414
    [440]       9.0259266      12.070690      13.974477      15.346603
    [444]       16.327459      16.790989      16.553909      15.488638
    [448]       13.599503      11.211745      9.0188999      6.9064870
    [452]       2.8746228     -4.5207987      4.9662809      10.500076
    [456]       13.559019      15.516660      16.968546      18.084835
    [460]       18.770857      18.889011      18.399632      17.410711
    [464]       16.132475      14.602777      12.283574      7.5572662
    [468]      -6.5948691      7.4071770      13.170725      16.031553
    [472]       17.737408      19.044851      20.244431      21.232870
    [476]       21.782248      21.743525      21.074427      19.807060
    [480]       17.990234      15.571553      12.315823      8.8056164
    [484]       9.4901686      12.513302      14.315365      14.907266
    [488]       15.044650      15.741710      17.122219      18.385561
    [492]       19.005569      18.853479      17.967072      16.464741
    [496]       14.522811      12.277260      9.5938358      5.8916388
    [500]      0.43603632     -1.4324193      2.4551942      4.4852438
    [504]       4.9859247      4.9429917      5.2148347      5.8449607
    [508]       6.3023634      6.2933884      5.8797174      5.3580332
    [512]       5.1184583
  [Tag]         6241
  [frame_len]          320
[Record 40]
  [tot_power]       1290383.5
  [re_spec_val]
    [0]      -22.691090     -22.487698     -24.904064     -48.097176
    [4]      -25.037481     -23.392244     -28.810322     -16.248426
    [8]      -13.089775     -22.793970     -3.8070967      5.1917591
    [12]       10.546886      13.895661      15.800326      16.540785
    [16]       16.270643      15.031367      12.736201      9.1507673
    [20]       3.2159576     -17.017960      4.2188635      7.5143003
    [24]      0.36263219      16.851168      25.983261      31.589062
    [28]       35.247429      37.488537      38.544075      38.513252
    [32]       37.408016      35.146885      31.482603      25.712275
    [36]       14.920858      8.6159620      11.256496      9.5692406
    [40]       25.313095      32.591743      37.275173      40.376038
    [44]       42.244545      43.021477      42.746204      41.382999
    [48]       38.810017      34.761734      28.636177      18.548811
    [52]      -1.8671634      9.5693455      8.4767160      6.4225631
    [56]       11.914973      18.949482      23.212994      25.475359
    [60]       26.247879      25.801584      24.290833      21.845070
    [64]       18.699141      15.356119      12.398588      9.8325033
    [68]       7.3967595      5.5900493      5.7917542      8.3308105
    [72]       11.752563      14.864858      17.157173      18.429844
    [76]       18.580584      17.505283      15.034679      10.887641
    [80]       4.9839144     0.65799624     0.19529954     -1.7769641
    [84]      -6.9090271     -27.924469     -4.4985652      3.1425643
    [88]       7.7023020      10.550011      12.108839      12.537985
    [92]       11.864949      10.012248      6.7583876      1.5562021
    [96]      -7.3988113     -29.370770     -15.081180     -21.299164
    [100]      -16.330271     -6.4750314     -1.4638618      1.8647256
    [104]       4.1821799      5.6359711      6.2077045      5.8305264
    [108]       4.4214540      1.8816061     -1.9019985     -6.9937806
    [112]      -13.169531     -20.330175     -35.938557     -20.518379
    [116]      -12.242404     -5.9323750    -0.96222490      2.6500099
    [120]       4.9795785      6.1090846      6.0761461      4.8479900
    [124]       2.2721102     -2.0877755     -9.5067444     -14.233956
    [128]      -8.5132399     -6.4272175     -6.9216909     -10.169151
    [132]      -10.141740     -3.1602316      1.4002701      4.0322990
    [136]       5.2620335      5.2997875      4.2067366      1.9658790
    [140]      -1.4196233     -5.4284487     -7.9274025     -8.3925810
    [144]      -9.4430027     -12.847474     -16.939322     -8.8194818
    [148]      -2.8166902      1.0511371      3.5483649      4.9526534
    [152]       5.3958883      4.9899631      3.8940299      2.3245003
    [156]      0.40350544     -2.1170104     -5.8149629     -8.9245310
    [160]      -5.4597669     -1.4876111      1.2724296      3.3066900
    [164]       4.8606997      5.9334354      6.4350982      6.2926059
    [168]       5.4859390      4.0578041      2.1178513    -0.17608675
    [172]      -2.6780624     -5.2106743     -6.9557118     -6.5731239
    [176]      -5.3085580     -5.2332153     -7.4638896     -9.4171104
    [180]      -3.7116163     0.74527413      3.0333848      3.7062533
    [184]       3.0226274      1.0722277     -2.1225469     -6.3288608
    [188]      -10.066581     -11.576035     -12.960924     -15.231888
    [192]      -12.019313     -5.9555025     -1.3857374      1.8214154
    [196]       3.8902674      4.9245706      4.9714332      4.0549870
    [200]       2.2183740    -0.33488649     -2.8587673     -4.1768928
    [204]      -4.5578151     -5.3175435     -7.0583792     -8.0876446
    [208]      -4.8627429    -0.91149563      1.7955000      3.2388680
    [212]       3.5059886      2.5888171     0.36152953     -3.4804265
    [216]      -9.3687620     -13.711895     -11.381705     -10.337548
    [220]      -11.762535     -17.539310     -15.618960     -5.9861574
    [224]     -0.56064969      2.9500508      5.1651487      6.3036575
    [228]       6.4539514      5.6473660      3.8780260      1.0980269
    [232]      -2.7934725     -7.7681313     -11.952866     -12.080828
    [236]      -10.736444     -7.1436868     -1.6395401      3.2441366
    [240]       6.9147587      9.4129658      10.829314      11.238597
    [244]       10.715965      9.3774023      7.4415212      5.2813911
    [248]       3.3716660      2.0886405      1.4682136      1.0346785
    [252]     -0.15506323     -2.2771177      1.5146477      7.6481266
    [256]       11.716478      14.042232      14.958155      14.658216
    [260]       13.314591      11.235854      9.1248751      7.9245276
    [264]       7.5109186      6.8705773      5.7962818      5.0754209
    [268]       4.7546515      8.1811342      15.094379      20.497412
    [272]       24.184332      26.512295      27.718412      27.947918
    [276]       27.311413      25.983986      24.410074      23.331173
    [280]       22.862162      22.051069      19.690351      13.312801
    [284]       7.6275411      19.597689      24.405542      27.035324
    [288]       28.381672      28.699661      28.037466      26.338064
    [292]       23.444218      19.033955      12.533051      5.5851817
    [296]       6.2889752      7.5868301      9.8440084      13.666730
    [300]       17.310776      20.172712      22.169037      23.275610
    [304]       23.470104      22.724949      20.996368      18.208361
    [308]       14.273329      9.6161728      7.3500710      8.2001495
    [312]       8.6845875      9.2698746      12.568152      17.031118
    [316]       20.642342      23.102802      24.464384      24.781107
    [320]       24.072788      22.326448      19.503838      15.599512
    [324]       11.081306      8.1247129      7.3899412      5.8461852
    [328]       3.7604408      9.0841513      14.939741      18.904987
    [332]       21.459368      22.863184      23.217800      22.543859
    [336]       20.804892      17.909912      13.799343      9.2759943
    [340]       7.2784419      6.8562598      5.8411846      6.9313645
    [344]       11.440200      16.288979      20.396624      23.507162
    [348]       25.561726      26.576389      26.574884      25.552536
    [352]       23.462223      20.306860      16.889664      15.744501
    [356]       16.102978      15.301763      12.620522      11.833737
    [360]       17.547586      22.751289      26.550484      29.165985
    [364]       30.713610      31.255089      30.825924      29.452902
    [368]       27.210009      24.411739      21.907364      20.313396
    [372]       18.603682      14.909401      4.4398494      11.981309
    [376]       19.040564      22.649029      24.742270      25.798580
    [380]       25.921900      25.081989      23.184254      20.097420
    [384]       15.851059      11.863954      10.573964      9.4197454
    [388]       6.4092555      7.8761792      13.615153      17.720646
    [392]       20.516321      22.369560      23.382793      23.544149
    [396]       22.803989      21.093449      18.328335      14.533783
    [400]       10.779168      9.8085346      10.230018      9.7452135
    [404]       8.9618855      10.928189      14.752178      17.978113
    [408]       20.197437      21.443041      21.740555      21.077494
    [412]       19.406694      16.647303      12.758058      8.4074841
    [416]       6.2717891      5.8849998      3.9761260     0.54247499
    [420]       5.2165375      10.841353      14.459807      16.748945
    [424]       18.022984      18.374958      17.794838      16.204952
    [428]       13.444824      9.2830601      4.3687453      3.3758690
    [432]       4.6267371      4.6827626      5.1809711      8.3191271
    [436]       12.043145      14.988214      17.029734      18.190575
    [440]       18.451113      17.741827      15.934185      12.840938
    [444]       8.5937796      6.0378451      7.0098071      7.4266758
    [448]       6.5205140      6.4910126      9.5440941      13.091699
    [452]       15.825659      17.681746      18.701046      18.892664
    [456]       18.257248      16.819881      14.669918      11.983577
    [460]       8.8947029      5.1028271    -0.40968353     -3.4078467
    [464]       2.5647674      6.9733462      10.222585      12.825269
    [468]       14.802564      16.050665      16.486773      16.068422
    [472]       14.793457      12.727197      10.068019      7.1879153
    [476]       4.4936309      2.2806189     0.83262384     0.19014870
    [480]      0.18989415     0.95166540      2.7271652      5.3912401
    [484]       8.2078571      10.477890      11.891037      12.363657
    [488]       11.883656      10.461446      8.2073202      5.7064223
    [492]       4.2742357      3.9511974      3.1441195     0.68514508
    [496]      -4.8047924     -12.382886     -3.9247448     0.74579495
    [500]       3.5303202      5.2362566      5.9139423      5.4214969
    [504]       3.4764140    -0.57064629     -7.5178833     -5.6321416
    [508]      -1.4321945    -0.10098767    -0.61410207     -2.2532754
    [512]      -3.3710299
  [Tag]         6401
  [frame_len]          320
[Record 41]
  [tot_power]       1450211.0
  [re_spec_val]
    [0]      -48.762081     -36.278954     -32.210304     -29.209646
    [4]      -23.685116     -22.155428     -26.978720     -20.045876
    [8]      -19.026613     -15.667762    -0.80098867      6.6605029
    [12]       11.320059      14.184661      15.683251      16.065632
    [16]       15.513853      14.184074      12.207367      9.4288855
    [20]       4.1008554     -14.058298      5.4383011      6.5502543
    [24]       8.6600971      21.420710      28.724237      33.472393
    [28]       36.569473      38.379253      39.068180      38.702145
    [32]       37.275082      34.701359      30.745846      24.691477
    [36]       12.783830      11.904768      16.105747      11.810097
    [40]       24.450659      32.700031      37.798359      41.080059
    [44]       43.013641      43.795353      43.495296      42.096779
    [48]       39.488461      35.396603      29.122126      17.907194
    [52]       9.0334206      14.784504      11.133644      2.4222128
    [56]       14.186493      19.781906      23.285664      25.604458
    [60]       26.872879      27.063213      26.105942      23.894241
    [64]       20.264544      14.997876      8.0208483     0.62606800
    [68]      -3.4459910     -6.1525025     -2.1133988      7.3189454
    [72]       12.941908      16.270504      18.020597      18.512974
    [76]       17.878778      16.123278      13.135098      8.6677446
    [80]       2.3960822     -4.9877200     -10.631976     -26.159966
    [84]      -10.266812     -1.8066492      3.8190958      7.8794284
    [88]       10.571627      12.033339      12.365134      11.609201
    [92]       9.7360096      6.6170440      1.9389304     -5.1899681
    [96]      -20.830725     -14.682638     -8.9464025     -6.7800398
    [100]      -5.4911070     -2.8088424     0.80047226      3.6444809
    [104]       5.3002305      5.8066425      5.2479124      3.6936634
    [108]       1.2068663     -2.2013628     -6.8754950     -14.135694
    [112]      -15.658545     -11.052858     -10.451950     -9.9204283
    [116]      -4.2835226     0.61366796      3.6277874      5.1397891
    [120]       5.3831568      4.4510417      2.3686812    -0.77666795
    [124]      -4.5101008     -7.9732490     -11.736479     -18.111570
    [128]      -20.281162     -14.824753     -9.0935583     -3.4325881
    [132]      0.74848378      3.4234226      4.8039331      5.0316987
    [136]       4.1644573      2.1966188    -0.88724262     -4.8853626
    [140]      -8.7135220     -10.630595     -10.260500     -8.2122087
    [144]      -5.9441800     -4.0485530     -2.2515471    -0.39546227
    [148]       1.2300613      2.2727978      2.5435550      1.9638870
    [152]      0.48527265     -1.9625189     -5.5298004     -10.661393
    [156]      -19.737803     -24.705854     -13.171234     -8.0457678
    [160]      -4.6620312     -2.2121878    -0.39679483     0.87590367
    [164]       1.5638599      1.5588048     0.74260151    -0.96318305
    [168]      -3.4881880     -6.3687778     -8.8677959     -11.203944
    [172]      -14.389174     -16.758083     -11.896802     -5.9349313
    [176]      -1.4195997      1.7237059      3.6557791      4.4917102
    [180]       4.3003716      3.1143739     0.94331604     -2.2266078
    [184]      -6.5485344     -12.867183     -18.967329     -12.649959
    [188]      -9.3103657     -8.3723574     -7.7056589     -4.8312030
    [192]      -1.3029526      1.2345860      2.5848088      2.8382914
    [196]       2.0892296     0.43616331     -1.9762491     -5.0238419
    [200]      -8.9899597     -14.512156     -14.558332     -10.575555
    [204]      -9.5841331     -11.420523     -10.922951     -5.2933292
    [208]      -1.3878279     0.61758816      1.1111875     0.24481630
    [212]      -1.9663291     -5.4269409     -9.1815701     -11.398398
    [216]      -13.016304     -13.937062     -11.549953     -8.5077810
    [220]      -5.7449894     -2.8219118    -0.10627076      1.8699136
    [224]       2.8954587      2.9408438      2.0424747     0.29245192
    [228]      -2.1702390     -5.4018679     -10.110250     -12.687892
    [232]      -7.3445969     -4.0338411     -2.8238194     -2.2820275
    [236]     -0.35842434      2.5363233      4.7982278      5.9839678
    [240]       6.1528544      5.5199995      4.4501038      3.3065982
    [244]       1.9507644    -0.46541256     -5.6015921     -13.481096
    [248]      -5.3745666     -1.3850720     0.93122494      3.6328721
    [252]       6.5783944      8.9006720      10.322707      10.918911
    [256]       10.887864      10.449598      9.6657505      8.2060089
    [260]       5.1090603     -3.0099254     -4.0669446      5.2478905
    [264]       8.8437700      11.130491      13.774919      16.663742
    [268]       18.978580      20.405819      21.002741      20.971113
    [272]       20.487606      19.459213      17.311424      12.497373
    [276]     -0.35266370      12.423287      17.523462      19.585360
    [280]       20.496141      21.975325      24.647331      27.341595
    [284]       29.301805      30.399984      30.685234      30.217907
    [288]       29.007744      26.956810      23.783834      18.967089
    [292]       13.274279      13.897390      15.643423      16.016642
    [296]       17.482424      20.298706      22.573996      23.749401
    [300]       23.894495      23.196440      21.897518      20.195679
    [304]       17.911564      14.032531      4.5726671      6.1507859
    [308]       13.955499      16.990582      18.738104      20.547979
    [312]       22.520702      24.079262      24.875042      24.851322
    [316]       24.108288      22.843405      21.224812      19.090603
    [320]       15.649405      8.9596233      7.0290403      13.814867
    [324]       16.772675      18.155285      19.348991      20.865873
    [328]       22.247408      23.008329      23.007456      22.315857
    [332]       21.088999      19.395426      16.941351      12.695776
    [336]       3.2347925      6.7729917      12.858684      15.056985
    [340]       15.938854      17.267355      19.413145      21.362696
    [344]       22.597221      23.158762      23.245483      22.927391
    [348]       21.957388      19.709757      14.755139      5.3017735
    [352]       14.576505      19.006128      20.746704      21.645208
    [356]       23.097029      25.155861      26.947763      28.055788
    [360]       28.489286      28.386959      27.825064      26.673393
    [364]       24.525471      20.529654      12.281783      11.530368
    [368]       17.810604      19.875877      20.490528      21.436539
    [372]       23.229301      24.965981      26.062729      26.438589
    [376]       26.170368      25.325815      23.859730      21.510025
    [380]       17.625326      10.680752      7.8315930      13.406628
    [384]       15.368175      15.547164      15.894190      17.612791
    [388]       19.601940      20.969637      21.655310      21.832605
    [392]       21.598227      20.817942      19.090452      15.614861
    [396]       7.8814192      2.8991508      12.117503      14.954970
    [400]       15.869162      16.623198      18.044628      19.574421
    [404]       20.612427      21.072670      21.087097      20.725225
    [408]       19.832970      18.011560      14.525558      7.4545722
    [412]       2.9133444      10.545251      13.393630      14.486723
    [416]       15.335050      16.614979      17.988503      18.963810
    [420]       19.342142      19.062824      18.036098      16.033417
    [424]       12.525042      6.3199587      3.0106845      8.6366367
    [428]       11.276624      12.156215      12.589572      13.646204
    [432]       15.231460      16.605236      17.407722      17.610243
    [436]       17.292191      16.527206      15.314052      13.535305
    [440]       10.942214      7.1153550      1.2518749     -9.3585358
    [444]      -13.717335     -2.3222642      4.0678926      8.3003283
    [448]       10.942090      12.347274      12.774460      12.479491
    [452]       11.769230      10.899582      9.8190536      8.1053200
    [456]       5.1037555    -0.16844957     -5.8779702     -1.8349229
    [460]      0.56538725     0.43717855     -1.6860911     -4.9471192
    [464]      -4.6756568     -1.3877259      1.2366847      3.2259712
    [468]       4.7735233      5.6448331      5.4348564      3.6435525
    [472]     -0.60049725     -5.8974204    -0.85975468      2.7600026
    [476]       4.1336317      4.2937360      4.0222368      3.9555125
    [480]       4.3465071      5.0656590      5.7934937      6.1177268
    [484]       5.5934601      3.6810610    -0.49029872     -4.5012832
    [488]      0.87610960      4.6794686      6.4590225      7.1412401
    [492]       7.5002270      8.1158848      9.0116873      9.8669386
    [496]       10.453363      10.656816      10.342120      9.2779160
    [500]       7.0943751      3.2368875     -1.4549282     0.51297450
    [504]       3.5580399      4.7124186      4.9361892      5.7073021
    [508]       7.5122418      9.3807726      10.710789      11.446822
    [512]       11.676831
  [Tag]         6561
  [frame_len]          320
[Record 42]
  [tot_power]       1164651.8
  [re_spec_val]
    [0]      -50.664185     -26.642317     -23.472956     -25.452982
    [4]      -27.663015     -22.038654     -19.636402     -23.678450
    [8]      -20.414221     -6.8143835     0.85035777      6.3411431
    [12]       10.360937      13.109886      14.615973      14.800631
    [16]       13.468617      10.257379      4.6481571     -2.9842372
    [20]      -5.6401610     0.55728978     0.25063342      6.4753590
    [24]       19.044853      26.332735      31.183767      34.423622
    [28]       36.391327      37.235069      36.996090      35.632401
    [32]       33.017345      28.934807      23.159220      15.860825
    [36]       6.2961974      4.6513000      15.625130      24.380678
    [40]       31.206936      36.105606      39.454479      41.531757
    [44]       42.500740      42.443542      41.383171      39.293278
    [48]       36.097481      31.651081      25.682098      18.073862
    [52]       14.413335      15.699111      16.721201      20.870525
    [56]       25.455585      28.523420      30.142782      30.513636
    [60]       29.724659      27.738966      24.358179      19.098473
    [64]       11.028104      4.4133773      3.5544219     -9.8930387
    [68]       5.7773576      12.811620      16.675323      19.134890
    [72]       20.590317      21.106548      20.652107      19.141594
    [76]       16.405924      12.097054      5.3896837     -6.4399447
    [80]      -16.869648     -24.045395     -3.1791837      4.1002607
    [84]       8.4490261      11.325070      13.123914      13.941919
    [88]       13.773545      12.556478      10.161672      6.3530574
    [92]      0.73785621     -6.9091454     -14.262280     -19.940189
    [96]      -10.239032     -4.0685043    -0.34309858      2.2924283
    [100]       4.1892982      5.2919211      5.4499192      4.5009770
    [104]       2.2556248     -1.4022782     -5.4104185     -6.6353617
    [108]      -7.1552763     -9.9154081     -15.245656     -11.218843
    [112]      -4.2601442     0.76491523      4.3100033      6.5777555
    [116]       7.6865215      7.6881628      6.5500512      4.1101732
    [120]    -0.054796208     -7.0882730     -17.399885     -14.399714
    [124]      -17.744749     -18.682781     -6.5209780    -0.73822397
    [128]       2.9830387      5.4720316      6.9499230      7.4541030
    [132]       6.9392428      5.2806716      2.2182524     -2.8106375
    [136]      -11.078768     -18.734411     -19.782381     -28.013870
    [140]      -11.541676     -5.6212368     -2.0341444     0.53416890
    [144]       2.3351755      3.2722042      3.1788216      1.8511000
    [148]      -1.0442977     -6.0949078     -12.144451     -11.308834
    [152]      -11.456614     -17.936747     -18.639662     -8.5411358
    [156]      -4.3036237     -1.8375899    -0.19205487     0.81207061
    [160]       1.0029391    0.058788393     -2.5667872     -8.4016247
    [164]      -31.863777     -10.627599     -7.3966546     -8.4750071
    [168]      -13.489638     -10.591809     -3.9839506   -0.034783423
    [172]       2.5657804      4.3205614      5.3385272      5.5771160
    [176]       4.9434605      3.3184950     0.55889505     -3.4465556
    [180]      -8.5232153     -14.412404     -21.449522     -12.521682
    [184]      -6.4546285     -2.8327832    -0.27496415      1.7260488
    [188]       3.1678431      3.8527274      3.5896842      2.2227163
    [192]     -0.34603292     -3.7645335     -6.1309104     -6.7227678
    [196]      -8.2391081     -12.091203     -11.842599     -6.3341832
    [200]      -2.5549436    0.041489843      1.9092872      3.0767460
    [204]       3.4018474      2.6963437     0.71656764     -2.8478327
    [208]      -7.4369388     -8.2384567     -7.2313046     -8.9444304
    [212]      -16.775101     -13.826286     -5.4565458     -1.4577435
    [216]      0.90167999      2.3225396      2.9677174      2.7666752
    [220]       1.5230085     -1.0890670     -5.5824413     -11.651864
    [224]      -13.306170     -15.153524     -19.453962     -7.9500651
    [228]      -1.9817331      1.6446847      4.1260371      5.8627720
    [232]       6.9038434      7.1514440      6.4654765      4.6960368
    [236]       1.7870023     -1.5142196     -2.9167376     -3.2141900
    [240]      -4.9127579     -6.1316190     -1.6719558      2.8705013
    [244]       6.1055813      8.4124937      9.9356012      10.614740
    [248]       10.300036      8.7908659      5.8846560      2.0715992
    [252]      0.54279691     0.76273113     -1.4162785     -7.3301244
    [256]     -0.21917395      5.9372191      9.7806225      12.652511
    [260]       14.857968      16.253780      16.594990      15.631114
    [264]       13.200423      10.372296      10.491688      11.170890
    [268]       9.2643108      8.1489477      14.526555      19.211292
    [272]       22.087807      24.015236      25.481251      26.586248
    [276]       27.182800      27.125143      26.427927      25.342575
    [280]       24.240837      23.124712      21.488926      19.238522
    [284]       18.678850      20.914339      22.891273      23.807344
    [288]       24.138781      24.627966      25.478683      26.176077
    [292]       26.237280      25.487692      23.999598      22.114893
    [296]       20.307384      18.458776      15.483168      9.6956062
    [300]       10.099910      16.483770      20.035545      22.140379
    [304]       23.484741      24.281609      24.476238      23.922899
    [308]       22.526245      20.433815      18.337399      16.816460
    [312]       14.601719      7.9766283      5.1926808      16.356852
    [316]       20.822084      23.171116      24.441759      25.079727
    [320]       25.224733      24.804071      23.675583      21.808075
    [324]       19.563267      17.735096      16.132296      12.707595
    [328]     -0.63953424      10.615989      17.647480      20.812469
    [332]       22.351065      23.041965      23.264315      23.074518
    [336]       22.330627      20.975664      19.339378      17.966080
    [340]       16.358578      12.259530     -5.3444781      14.442024
    [344]       20.519381      23.667828      25.514099      26.685390
    [348]       27.406595      27.622372      27.174059      25.985041
    [352]       24.254404      22.564156      21.116270      18.722555
    [356]       12.906290      13.209785      20.829954      24.620350
    [360]       26.541084      27.441442      27.806511      27.860035
    [364]       27.546564      26.670267      25.102425      22.985672
    [368]       20.898451      19.250528      17.288445      14.272439
    [372]       13.839845      17.494490      20.076683      21.114340
    [376]       21.072554      20.529163      20.030550      19.631142
    [380]       18.946987      17.780157      16.417107      15.215316
    [384]       13.637068      10.196639      4.7836175      10.751287
    [388]       15.756519      18.329657      19.558771      20.053143
    [392]       20.185595      20.067369      19.600544      18.676693
    [396]       17.316753      15.601873      13.335773      9.7199478
    [400]       5.7114196      10.357213      15.003719      17.634251
    [404]       18.952749      19.425407      19.404142      19.129839
    [408]       18.645462      17.819471      16.529314      14.897492
    [412]       13.448760      12.614121      11.921777      10.612171
    [416]       8.4940176      6.5344801      6.1128330      6.0779366
    [420]       5.2569361      4.9752393      6.9959760      9.2780972
    [424]       10.465534      10.505381      9.7153349      8.6716795
    [428]       7.8154879      6.6885996      4.0571275     -2.9047992
    [432]      -8.2607870      2.7056556      6.2973127      7.4469810
    [436]       7.1618886      5.9983273      4.4781966      2.9363756
    [440]       1.4261158     0.35071385     0.29098386     0.41408572
    [444]     -0.64955908     -3.5505047     -4.0414214     0.79101247
    [448]       4.3590312      6.3253293      7.1396937      7.0870466
    [452]       6.3476005      5.0584397      3.4020891      1.7278210
    [456]      0.36410394     -1.1182778     -4.1456523     -9.3120289
    [460]      -3.0606081      2.7570064      6.0284190      7.7727337
    [464]       8.4657307      8.3950462      7.7636600      6.6928396
    [468]       5.2674270      3.7561631      2.6962032      1.9731631
    [472]      0.18880805     -5.6024027     -7.5032220      2.7174783
    [476]       7.3017154      9.6442308      10.631048      10.684467
    [480]       10.111964      9.1398544      7.8619661      6.3777151
    [484]       5.1762414      4.7437057      4.2611556      2.2132244
    [488]      -1.5450200      2.5783389      7.9116325      10.876627
    [492]       12.174835      12.218285      11.302095      9.8023252
    [496]       8.1640625      6.4546990      4.1808853      1.2864285
    [500]      0.23018159      1.7420601      3.1066849      4.5992928
    [504]       6.9167757      9.1440077      10.436715      10.526634
    [508]       9.2985401      6.5956292      2.3310032     -2.1281524
    [512]      -3.4693491
  [Tag]         6721
  [frame_len]          320
[Record 43]
  [tot_power]       725796.56
  [re_spec_val]
    [0]      -18.168154     -19.527731     -24.926584     -36.665802
    [4]      -24.718891     -20.642223     -16.958477     -16.135948
    [8]      -18.556103     -6.0527463      1.8239977      6.8529859
    [12]       10.199391      12.303569      13.309538      13.195417
    [16]       11.854288      9.1674423      4.8883562     -2.4098516
    [20]     -0.61330241      4.1355114     -1.8984915      11.090291
    [24]       21.411226      27.435514      31.312023      33.679466
    [28]       34.801594      34.784100      33.630795      31.237970
    [32]       27.310112      20.979982      7.5266485      8.1649790
    [36]       11.070369      5.6636629      19.211927      27.062714
    [40]       31.907843      35.005367      36.784210      37.415447
    [44]       36.943256      35.312740      32.354763      27.767544
    [48]       21.552902      16.964296      14.276104      3.7948966
    [52]       10.715552      18.856041      24.730391      29.725437
    [56]       33.432110      35.836983      37.059631      37.192772
    [60]       36.274513      34.287628      31.167290      26.863678
    [64]       21.682766      16.775318      11.012315     -3.1631384
    [68]       15.327855      20.900734      23.641516      24.735685
    [72]       24.525522      23.087875      20.336575      15.965220
    [76]       9.0658560     -4.5741987     -3.1159015     -1.2377002
    [80]      -3.9694102      3.1751311      9.6280689      13.578437
    [84]       15.925361      17.036415      17.038982      15.922038
    [88]       13.542984      9.5334244      2.8372681     -13.049085
    [92]      -7.6202927     -4.6179271     -4.9130120     -2.0274017
    [96]       2.6672900      6.3754420      8.9749403      10.588353
    [100]       11.242063      10.877221      9.3447256      6.3173790
    [104]      0.89537680     -11.490678     -8.3426285     -3.3149815
    [108]      -3.0241790     -4.5641980     -2.1712072      3.0353515
    [112]       6.9051604      9.3585768      10.624067      10.802519
    [116]       9.8835812      7.7283645      3.9482534     -2.5308323
    [120]      -10.965343     -6.4015436     -5.4998989     -8.4599361
    [124]      -4.5876746      2.1107984      6.2709394      8.7536411
    [128]       10.005725      10.213462      9.4339151      7.6213026
    [132]       4.5757132    -0.26214868     -8.6283808     -16.194653
    [136]      -11.924767     -15.668894     -8.7983294    -0.76643276
    [140]       3.8473339      6.6537495      8.2006741      8.6881084
    [144]       8.1628742      6.5646677      3.6886461    -0.99378002
    [148]      -8.6843767     -11.211349     -7.1224422     -6.2792573
    [152]      -6.5908117     -4.3534136    -0.38625216      2.7510889
    [156]       4.7054768      5.5592051      5.3481884      3.9947693
    [160]       1.2142528     -3.8587587     -14.744766     -11.731505
    [164]      -7.2756314     -8.0299540     -14.628018     -8.0877266
    [168]     -0.49999839      3.6306925      5.9996743      7.1458788
    [172]       7.2726469      6.4325085      4.5662484      1.4928942
    [176]      -3.0799150     -9.0678787     -14.510672     -20.990993
    [180]      -10.092133     -2.4234550      2.2438126      5.3344984
    [184]       7.3408341      8.4406109      8.6759958      8.0118570
    [188]       6.3289075      3.3373704     -1.7536895     -11.951385
    [192]      -11.052681     -5.7798543     -4.6364746     -4.2425003
    [196]      -1.6860169      1.9307566      4.7906132      6.5851197
    [200]       7.3430090      7.0640917      5.6408453      2.7479625
    [204]      -2.5981662     -15.585592     -10.087913     -5.5722485
    [208]      -6.0196180     -11.284531     -11.223725     -2.3132918
    [212]       2.3350244      5.0374908      6.4715753      6.8344383
    [216]       6.1146407      4.1341381     0.45606777     -5.9321671
    [220]      -13.256003     -10.269459     -9.2023869     -5.2312155
    [224]      0.52393085      4.8388171      7.8720183      9.9625349
    [228]       11.279648      11.851094      11.584273      10.251569
    [232]       7.3744025      1.7488040     -5.0230074      1.8271762
    [236]       5.4633112      7.3605328      9.2174520      11.600082
    [240]       13.964782      15.741353      16.663567      16.573492
    [244]       15.253694      12.221967      5.9867544     -3.7427473
    [248]       5.9290695      9.5397987      11.211723      12.968244
    [252]       15.454136      18.044476      20.174232      21.639292
    [256]       22.371574      22.330986      21.486473      19.842358
    [260]       17.539379      15.119949      13.851925      14.972377
    [264]       17.890226      21.178795      24.118656      26.507597
    [268]       28.295368      29.454870      29.954872      29.754936
    [272]       28.799623      27.011248      24.297594      20.660818
    [276]       16.723879      14.126904      12.464062      9.2367954
    [280]      0.99635339      4.9041691      13.009683      17.646547
    [284]       20.674454      22.489386      23.192675      22.792650
    [288]       21.243635      18.530947      15.209827      13.418186
    [292]       13.312141      12.261564      8.7037401      3.8669229
    [296]       10.273881      15.484471      18.739628      20.855621
    [300]       22.083500      22.441948      21.840530      20.101507
    [304]       16.942122      12.173077      7.9877677      7.2472210
    [308]       3.7346368      2.4720469      12.882155      18.438370
    [312]       21.907764      24.144655      25.434248      25.842892
    [316]       25.317284      23.697702      20.671200      15.731524
    [320]       10.055073      10.328594      10.435490      9.7033920
    [324]       14.584538      19.583559      22.892870      24.955526
    [328]       26.037540      26.210947      25.427057      23.561876
    [332]       20.505136      16.693352      14.214293      13.025426
    [336]       9.9191380      9.1133718      16.073837      20.888712
    [340]       24.061962      26.221436      27.572063      28.131847
    [344]       27.852236      26.671648      24.570959      21.750412
    [348]       18.947924      16.731146      13.647264      4.5127454
    [352]       8.0113773      17.229946      21.649487      24.387484
    [356]       26.133118      27.079643      27.248564      26.592943
    [360]       25.036060      22.521343      19.222063      16.027813
    [364]       13.641850      9.9576769     -4.7218103      9.1628389
    [368]       16.072460      19.502039      21.437475      22.470480
    [372]       22.795368      22.416224      21.243551      19.159670
    [376]       16.130108      12.580078      9.6659117      7.0625949
    [380]       2.8447254      5.2327323      11.352935      15.182951
    [384]       17.592957      19.073555      19.778011      19.694485
    [388]       18.743692      16.834524      13.970758      10.674480
    [392]       8.3916559      7.0980468      4.6675777     -1.4867429
    [396]      -8.3505011      2.5103610      7.0703259      9.7375927
    [400]       11.409540      12.235507      12.164779      11.104577
    [404]       9.0078993      6.2315784      4.2982244      3.8098783
    [408]       2.4401538     -2.7327311     -10.833831      2.2374058
    [412]       7.0688553      9.4623556      10.550941      10.759382
    [416]       10.254853      9.0377865      6.9902835      4.0301194
    [420]      0.83082974    -0.43472159    -0.28983101    -0.71416926
    [424]     -0.55990422      2.0928681      5.2198415      7.4972558
    [428]       8.8720827      9.4576941      9.2971621      8.3382330
    [432]       6.4368763      3.3903675    -0.68925685     -3.5831988
    [436]      -3.8118572     -5.2479382     -10.200079     -6.4743800
    [440]      0.29283017      4.2065005      6.5533404      7.8594484
    [444]       8.3140240      7.9473062      6.7089782      4.5426011
    [448]       1.5859510     -1.3332725     -3.0314491     -3.5314558
    [452]      -2.0207593      1.2875401      4.3840423      6.6561480
    [456]       8.1749840      9.0559320      9.3218775      8.8957176
    [460]       7.6266932      5.3427596      2.1237032    -0.54838645
    [464]     -0.88557136     -1.2060753     -3.0413561     -3.0742486
    [468]       1.3907156      5.2856760      7.9088387      9.5942659
    [472]       10.531155      10.751152      10.184678      8.7095366
    [476]       6.2260756      2.9542103    0.038763069     -2.2112579
    [480]      -7.6419687     -9.9916620      1.4811033      6.7398534
    [484]       9.8553591      11.798718      12.945417      13.425935
    [488]       13.230224      12.274603      10.458501      7.7274871
    [492]       4.1278625    -0.34181729     -2.9460559      2.8515000
    [496]       8.0322094      11.403650      13.492363      14.646197
    [500]       15.103081      15.031186      14.519928      13.561325
    [504]       12.060965      9.8947678      7.1004848      4.7062511
    [508]       5.0322046      7.1398439      9.0093994      10.158805
    [512]       10.542125
  [Tag]         6881
  [frame_len]          320
[Record 44]
  [tot_power]       915942.62
  [re_spec_val]
    [0]      -41.648411     -32.914783     -29.966162     -23.198675
    [4]      -20.849821     -27.210590     -23.859688     -19.942053
    [8]      -20.975424     -4.1269317      3.3457673      7.7785420
    [12]       10.357908      11.595059      11.811961      11.240813
    [16]       9.9533482      7.6076250      2.7750280     -8.8203478
    [20]     0.051137667    -0.80748552      7.3406839      18.627207
    [24]       25.311989      29.732803      32.609741      34.243828
    [28]       34.768810      34.221657      32.552475      29.585451
    [32]       24.875582      17.248760      8.4755363      10.985831
    [36]       11.955250      19.832092      26.316875      30.628088
    [40]       33.434208      35.047073      35.596004      35.113750
    [44]       33.559326      30.796549      26.490839      19.677982
    [48]       4.9389563      6.5651555      9.4020004      15.168401
    [52]       23.070326      28.745375      32.828037      35.733364
    [56]       37.657940      38.707840      38.957546      38.489147
    [60]       37.438969      36.041695      34.565128      33.036320
    [64]       31.090656      28.436066      26.942772      29.518045
    [68]       32.632866      34.672321      35.672749      35.750828
    [72]       34.938377      33.191589      30.396460      26.336193
    [76]       20.511084      10.877664      3.4445200      13.281425
    [80]       17.073452      19.341169      20.990372      22.228455
    [84]       22.927534      22.893036      21.981848      20.096972
    [88]       17.188271      13.422904      9.8793430      8.4975290
    [92]       8.9036980      9.9291725      11.224696      12.501136
    [96]       13.450836      13.842761      13.569089      12.726963
    [100]       11.756141      11.270722      11.272321      11.181223
    [104]       10.657361      9.8116341      9.1505280      9.4430456
    [108]       10.930313      12.816322      14.249882      14.794732
    [112]       14.200031      12.141558      7.8304458     -1.8338379
    [116]     -0.74635714      5.2623048      6.8796043      6.6675196
    [120]       5.9865131      6.5880136      8.8971767      11.484237
    [124]       13.437068      14.471337      14.479983      13.355119
    [128]       10.888892      6.5870934     -1.1838880     -21.991611
    [132]      -4.8110490     -1.5855184     0.93282646      4.1048532
    [136]       7.1982260      9.7040138      11.421660      12.241343
    [140]       12.074228      10.819038      8.3697157      4.9079118
    [144]       2.3076327      2.6045995      3.3710005      3.4887893
    [148]       3.5357420      4.4035392      6.1892333      8.1364222
    [152]       9.5687647      10.126983      9.5829706      7.6480341
    [156]       3.6773636     -4.5580120     -8.3014622     -1.1792226
    [160]      0.87006390      1.1368401      1.1851331      2.4036319
    [164]       4.8489294      7.3164892      8.9995718      9.5984039
    [168]       8.9652185      6.9356270      3.3728759    -0.52357906
    [172]     -0.49977329      1.0637589      1.8657955      2.6088655
    [176]       4.2047582      6.6291766      9.1276236      11.062103
    [180]       12.093212      12.007902      10.538596      7.1267996
    [184]      0.76525164     0.56778044      5.6072240      7.9319110
    [188]       8.8278828      9.2186613      9.8222466      11.031058
    [192]       12.623832      14.022819      14.751679      14.491705
    [196]       12.907393      9.3116112      1.5874832      1.4503253
    [200]       8.0580196      10.743125      11.701375      11.893584
    [204]       12.007709      12.300095      12.419269      11.782675
    [208]       9.7475386      5.1846018    -0.21914585      6.7643356
    [212]       11.185133      13.438598      14.526317      15.016253
    [216]       15.350737      15.812638      16.420517      16.997877
    [220]       17.329653      17.232761      16.562895      15.233106
    [224]       13.326311      11.438995      10.765376      11.503534
    [228]       12.770813      14.169785      15.603325      16.918934
    [232]       17.956663      18.615566      18.827394      18.512646
    [236]       17.563290      15.862143      13.388774      10.629318
    [240]       9.0003452      8.7073021      8.1615496      6.7821946
    [244]       6.0450559      8.1695414      11.300179      13.913883
    [248]       15.846905      17.130590      17.777176      17.816732
    [252]       17.361254      16.629534      15.818027      14.837982
    [256]       13.258193      10.390637      4.7098331     -6.0821314
    [260]       5.9239669      11.428129      14.789730      17.151554
    [264]       18.783215      19.711813      19.912476      19.401129
    [268]       18.324469      17.035946      15.897290      14.745958
    [272]       12.852976      9.1507425      2.9700930      7.3886118
    [276]       12.870852      15.932407      17.581926      18.235647
    [280]       18.095308      17.326836      16.178806      15.024225
    [284]       14.122370      13.262708      11.893042      9.3929663
    [288]       5.3409381      4.4143667      9.1133165      12.492779
    [292]       14.285069      14.860794      14.487690      13.575917
    [296]       12.876808      12.874026      13.021135      12.619810
    [300]       11.626977      11.140826      12.626293      15.133417
    [304]       17.348030      18.895506      19.690353      19.676750
    [308]       18.837133      17.393562      16.266850      16.475624
    [312]       17.217123      17.302715      16.359449      14.883470
    [316]       15.088297      17.707451      20.460028      22.481024
    [320]       23.733692      24.289785      24.236347      23.707060
    [324]       22.904934      22.017933      21.014460      19.554731
    [328]       17.106163      13.401578      12.767920      17.189255
    [332]       20.671736      22.809837      23.920580      24.184727
    [336]       23.738573      22.852633      22.119551      22.070126
    [340]       22.328922      22.091986      20.849770      18.524370
    [344]       16.645681      18.132877      20.610025      22.153585
    [348]       22.638443      22.140434      20.674595      18.347347
    [352]       16.227095      16.525274      18.053524      18.806959
    [356]       18.355356      16.858541      15.366220      15.861145
    [360]       17.676397      19.107557      19.716084      19.506733
    [364]       18.563820      17.103823      15.685640      15.006535
    [368]       14.880918      14.427460      13.020557      10.509755
    [372]       8.4732389      10.128422      12.817467      14.560329
    [376]       15.293737      15.176895      14.448593      13.658241
    [380]       13.625414      14.393391      15.115192      15.140539
    [384]       14.150547      11.924770      8.5913620      7.0913587
    [388]       9.5401402      11.766104      12.730391      12.548642
    [392]       11.361192      9.4271364      7.6044736      7.1536708
    [396]       7.6143503      7.6934114      6.8932867      5.3214421
    [400]       3.8218894      3.6389573      4.3254652      4.6870861
    [404]       4.3171291      3.2989993      2.1258655      1.8026659
    [408]       2.6367655      3.5738921      3.7534466      2.8333523
    [412]      0.71425581     -2.0518515     -2.7893414    -0.84698945
    [416]       1.1597290      2.5806129      3.4615703      3.8572788
    [420]       3.9224336      4.0097475      4.3988228      4.8831096
    [424]       4.9792075      4.3167462      2.6826425    0.044141438
    [428]      -2.6638842     -2.5249493    -0.36680663      1.3088436
    [432]       2.0425797      1.9315331      1.3247848     0.95000231
    [436]       1.3133146      1.8765466      1.8604549     0.85388058
    [440]      -1.3259624     -4.4415641     -6.0129123     -3.9835927
    [444]      -1.6275189    -0.16839491     0.38460502     0.20067593
    [448]     -0.16992107     0.32555383      1.8412039      3.3142426
    [452]       4.0314093      3.7462149      2.3354082    -0.26289344
    [456]      -3.2721522     -3.3501058     -1.1193061     0.44303831
    [460]      0.94379997     0.79236221      1.0050309      2.4137330
    [464]       4.2550850      5.5444841      5.9046631      5.2123280
    [468]       3.3863487     0.49760059     -2.0820103     -1.4332955
    [472]      0.57678765      1.9184382      2.5466235      2.9947336
    [476]       3.9503415      5.4778748      6.9505906      7.8305597
    [480]       7.8395462      6.7891874      4.5052438      1.2947190
    [484]      0.24160174      2.4744418      4.3678918      5.2497034
    [488]       5.5417500      5.9425559      7.0154328      8.5679779
    [492]       10.022656      10.994697      11.273705      10.669960
    [496]       8.9135323      5.5712276     0.58696717   -0.089237921
    [500]       2.9861364      4.3510437      4.4750962      4.5659418
    [504]       5.3636622      6.2879891      6.6276932      6.1919813
    [508]       5.0811768      3.3745701     0.68272477     -4.6715140
    [512]      -33.476143
  [Tag]         7041
  [frame_len]          320
[Record 45]
  [tot_power]       886164.50
  [re_spec_val]
    [0]      -22.675976     -28.067801     -27.138836     -19.698870
    [4]      -20.285553     -23.108406     -17.760874     -20.181826
    [8]      -14.806294     -2.6893749      3.6468761      7.6308537
    [12]       10.140829      11.532433      11.959044      11.473510
    [16]       10.016280      7.1233258     0.66146988     -3.6566656
    [20]       4.7266641      5.9698415      11.159244      20.038858
    [24]       26.132721      30.208496      32.800621      34.154873
    [28]       34.367489      33.432148      31.232580      27.457260
    [32]       21.227188      9.1920252      12.425188      16.631870
    [36]       18.973288      22.997509      27.549503      31.119841
    [40]       33.457256      34.599129      34.565399      33.293804
    [44]       30.585041      25.952900      18.200764      12.207420
    [48]       16.229250      17.371218      17.828838      20.661732
    [52]       25.222715      29.039537      31.572983      32.885353
    [56]       33.066635      32.125904      29.913246      25.908546
    [60]       19.110708      20.097452      25.415960      28.061161
    [64]       29.405605      30.886925      33.519829      36.508755
    [68]       38.871227      40.290955      40.717522      40.140633
    [72]       38.530697      35.841080      32.119114      28.060081
    [76]       25.621607      24.939781      24.415266      23.882952
    [80]       23.735716      23.916653      23.954542      23.389309
    [84]       21.868359      19.006037      13.997315      3.2497268
    [88]       2.9177485      9.8490658      12.019604      12.783728
    [92]       13.223231      13.959283      15.087341      16.216955
    [96]       16.924335      16.963682      16.206373      14.544870
    [100]       11.805490      7.6219440      1.6833647      1.1019620
    [104]       6.0485435      9.7207193      12.655597      15.289412
    [108]       17.637962      19.504824      20.684795      21.028494
    [112]       20.413080      18.684053      15.554969      10.295036
    [116]      0.22892044      1.7333504      7.8867774      11.005323
    [120]       13.249158      15.228496      17.028652      18.447662
    [124]       19.223351      19.149616      18.053934      15.716767
    [128]       11.736278      5.4169335      1.4678848      5.6174397
    [132]       8.4236641      10.336086      12.031890      13.693560
    [136]       15.186080      16.217918      16.511108      15.840340
    [140]       13.955576      10.390219      3.7075195     -10.123294
    [144]       2.4055219      6.9797463      9.6881399      11.784167
    [148]       13.567176      15.102142      16.302019      16.981831
    [152]       16.960970      16.110727      14.336240      11.478806
    [156]       6.9259357    -0.94547266      4.2745237      10.662155
    [160]       14.316894      16.634853      18.197372      19.254381
    [164]       19.810453      19.702999      18.672752      16.340952
    [168]       12.293419      10.109510      14.447763      17.963449
    [172]       20.036423      21.155235      21.621555      21.606358
    [176]       21.168440      20.222647      18.490726      15.459361
    [180]       11.422562      13.562544      18.282681      21.366880
    [184]       23.215231      24.232834      24.692171      24.808168
    [188]       24.758266      24.658251      24.524340      24.269140
    [192]       23.745270      22.798977      21.304981      19.201298
    [196]       16.589525      13.953959      12.035216      10.706479
    [200]       8.9553432      6.1135473      4.3032341      7.7066159
    [204]       11.492799      14.011812      15.455865      16.016087
    [208]       15.819815      15.010419      13.847292      12.741810
    [212]       12.001140      11.495164      10.878163      9.9493446
    [216]       8.7082729      7.4506760      7.1001134      8.2914543
    [220]       9.9707975      11.072296      11.222545      10.330428
    [224]       8.4814005      6.3874850      5.8072915      6.7653880
    [228]       7.5867906      7.6643353      7.0215268      5.8528905
    [232]       4.5961518      4.0944519      4.7058702      5.5493875
    [236]       5.7492518      4.9107132      2.9085062     0.27029362
    [240]     -0.48916882      1.1580709      2.6125278      3.2025750
    [244]       3.1486988      2.8737762      2.8287871      3.1478634
    [248]       3.5113649      3.4940181      2.8104477      1.3807117
    [252]     -0.23390982   -0.068670601      2.1743615      4.4664130
    [256]       6.0533757      6.9273243      7.2270880      7.1563673
    [260]       6.9800787      6.8867617      6.7561445      6.1678519
    [264]       4.5770779      1.3288890     -2.8500569     0.15589043
    [268]       4.4148006      6.8159356      7.8905845      7.9924765
    [272]       7.3286071      6.1414199      4.9624505      4.5238624
    [276]       4.7763977      4.9197445      4.4744473      3.6040859
    [280]       3.1919637      3.9859626      5.3865485      6.6267767
    [284]       7.4657116      7.8848886      7.9443665      7.8559890
    [288]       8.0150499      8.6288366      9.3502293      9.6421204
    [292]       9.1501846      7.7496657      5.8243413      5.0709219
    [296]       6.4764519      8.3234205      9.7203331      10.636954
    [300]       11.124800      11.207834      11.043387      11.011483
    [304]       11.324170      11.559521      10.979210      8.7238398
    [308]       2.8389127     0.60467279      9.6755371      14.188687
    [312]       16.694399      17.944937      18.221766      17.702398
    [316]       16.622833      15.306947      13.858302      11.714988
    [320]       7.7263246      5.9243450      12.308188      16.768738
    [324]       19.426226      20.880951      21.411467      21.162552
    [328]       20.259485      18.916710      17.483982      16.163574
    [332]       14.575447      12.079026      10.202724      13.397219
    [336]       17.242188      19.729506      21.074034      21.533691
    [340]       21.261330      20.310181      18.630587      16.102070
    [344]       12.852469      10.634603      11.321448      12.445279
    [348]       12.747662      12.717082      13.317831      14.626672
    [352]       15.880378      16.593380      16.602867      15.809166
    [356]       14.054572      11.104185      7.0165277      4.5259171
    [360]       5.5188031      5.7196379      3.5594571     -1.0255172
    [364]       1.1447201      6.2037706      9.1012192      10.613796
    [368]       11.200360      11.019418      10.053003      8.1948566
    [372]       5.3889937      2.1243422    0.034321092    -0.96465427
    [376]      -2.9835021     -3.4647620      1.5674918      5.8491011
    [380]       8.5677481      10.137829      10.797510      10.617967
    [384]       9.5423765      7.3998542      3.9091818     -1.0789515
    [388]      -5.3502226     -5.6967206     -4.6818471     -1.0023577
    [392]       3.1148691      6.0514493      7.8769140      8.8472271
    [396]       9.1335459      8.7919617      7.7619028      5.8638501
    [400]       2.7493544     -2.3410919     -11.472621     -11.979141
    [404]      -6.5964441     -3.6129005    -0.88700515      1.5468825
    [408]       3.3753579      4.5735178      5.2243533      5.3749270
    [412]       5.0044150      4.0550919      2.4728522     0.21692626
    [416]      -2.8100052     -6.9883327     -12.536130     -10.697991
    [420]      -5.3520851     -1.8853467     0.33215895      1.6826621
    [424]       2.3028893      2.2092052      1.3777113    -0.18294813
    [428]      -2.3470016     -4.8841934     -7.9525714     -13.198103
    [432]      -19.075371     -9.2732525     -4.1600637     -1.2833676
    [436]      0.37368330      1.1952600      1.3116242     0.71476632
    [440]     -0.66037345     -2.8198123     -5.4669981     -7.8435388
    [444]      -9.5750999     -10.020066     -7.0984898     -3.3173306
    [448]     -0.63900745     0.82254362      1.2018344     0.56204271
    [452]      -1.1827481     -4.4155192     -10.365054     -19.642218
    [456]      -12.267387     -9.2616186     -9.1340046     -9.4746704
    [460]      -7.5296626     -4.7613087     -2.7790847     -1.5558858
    [464]     -0.78237128    -0.36259064    -0.46663925     -1.3446947
    [468]      -3.1444287     -5.6331353     -7.6272178     -8.0871429
    [472]      -7.9575539     -7.4678407     -5.8784189     -3.5954540
    [476]      -1.3985372     0.48688084      2.0026934      3.0307958
    [480]       3.4383504      3.1539121      2.2263389     0.92366320
    [484]     -0.22356012    -0.85016578     -1.2260480     -1.6761603
    [488]      -1.8219281    -0.75903463      1.4086946      3.7126648
    [492]       5.5972457      6.8924446      7.5551038      7.5847611
    [496]       7.0239253      6.0006256      4.7864828      3.7406108
    [500]       3.0070579      2.3691256      1.6209809      1.0263500
    [504]       1.3606101      2.8211300      4.5964618      6.0245943
    [508]       6.8690729      7.0949216      6.7942462      6.2535276
    [512]       5.9719582
  [Tag]         7201
  [frame_len]          320
[Record 46]
  [tot_power]       581104.62
  [re_spec_val]
    [0]      -27.748093     -30.760687     -45.481804     -37.976299
    [4]      -32.027065     -23.303326     -20.756742     -27.905016
    [8]      -12.022067     -3.0079017      2.5485954      6.2749147
    [12]       8.7712240      10.387139      11.356841      11.704350
    [16]       11.097881      8.8112307      4.2257428      3.6458249
    [20]       5.8898396      8.6694431      17.342094      23.951174
    [24]       28.381432      31.262836      32.935368      33.587936
    [28]       33.332130      32.224636      30.245001      27.205225
    [32]       22.476143      13.368075      8.1071072      19.047415
    [36]       24.369165      28.378700      31.335123      33.265041
    [40]       34.238476      34.324730      33.556705      31.898619
    [44]       29.191179      25.053425      19.259394      18.419626
    [48]       22.591049      25.534166      27.566490      28.937618
    [52]       29.643023      29.671598      29.118464      28.241154
    [56]       27.401251      26.745466      25.981701      24.658379
    [60]       22.791782      22.814440      26.491796      30.387699
    [64]       33.349144      35.416706      36.706013      37.291183
    [68]       37.209587      36.469032      35.048656      32.894588
    [72]       29.914820      26.003065      21.285622      17.162394
    [76]       15.337248      13.654373      10.403461      8.9380693
    [80]       12.543573      15.307143      16.543455      16.680485
    [84]       16.053610      14.897421      13.332096      11.368725
    [88]       9.0386848      6.6596913      5.0824113      5.3606324
    [92]       7.2887330      9.4322872      10.886648      11.436335
    [96]       11.182829      10.356913      9.1050320      7.3010612
    [100]       4.9963551      4.0231657      5.7091117      7.8159781
    [104]       9.8459692      12.151833      14.427475      16.221472
    [108]       17.394545      17.993734      18.071058      17.575445
    [112]       16.316849      13.944716      9.7742424      1.9623603
    [116]     -0.73170984      5.9158216      9.2592421      11.784739
    [120]       14.071843      15.981214      17.339409      18.041409
    [124]       17.979334      16.987751      14.775358      10.719299
    [128]       3.3200514      2.0800867      7.7860289      10.587355
    [132]       12.415422      14.126449      15.809875      17.211842
    [136]       18.049681      18.053989      16.870802      13.767935
    [140]       6.1283050      5.2623668      13.808324      17.539742
    [144]       19.543278      20.763639      21.647741      22.340839
    [148]       22.772127      22.789738      22.252666      21.068958
    [152]       19.282396      17.395666      16.668592      17.578348
    [156]       19.107391      20.632299      21.994841      23.077234
    [160]       23.758488      23.959017      23.634348      22.735847
    [164]       21.169025      18.771349      15.395176      11.691844
    [168]       10.543018      11.246144      10.720414      7.6802835
    [172]    -0.018993700      4.8126068      11.408778      14.929773
    [176]       16.982838      18.052313      18.263065      17.587454
    [180]       15.910398      13.077580      9.3101997      7.1558847
    [184]       8.1644363      8.8664560      8.0040016      5.2194543
    [188]      0.78429192      2.2692480      6.5370030      8.7964535
    [192]       9.4156942      8.7361603      7.0363345      4.8489094
    [196]       3.0383129      1.7985544     0.33621597     -2.0092618
    [200]      -5.8045878     -11.538380     -7.8961191     -2.1064537
    [204]       1.0368680      2.3725114      2.2471280     0.73783261
    [208]      -2.2510896     -6.7750902     -10.446592     -8.8747520
    [212]      -6.6342735     -5.1960273     -4.2185278     -3.2206428
    [216]      -1.8378651    -0.29308483     0.88107264      1.3474596
    [220]      0.98713857    -0.22274218     -2.2609532     -4.8795204
    [224]      -6.6851912     -5.8863544     -4.1924806     -3.2139056
    [228]      -3.1791878     -3.8252304     -4.5268369     -4.6476650
    [232]      -4.3488936     -4.2678194     -4.8105183     -6.1621718
    [236]      -8.3190079     -10.222040     -9.3902359     -7.2390676
    [240]      -5.9704924     -6.0151448     -7.3135104     -9.1541595
    [244]      -9.3414059     -7.6884251     -6.3502159     -6.0765891
    [248]      -7.0600710     -9.8350496     -16.914059     -20.663179
    [252]      -9.8944178     -5.7530999     -4.0022779     -3.9075501
    [256]      -5.3068943     -7.7953067     -8.4804316     -5.8106813
    [260]      -3.3348134     -2.0098662     -1.8144206     -2.8196459
    [264]      -5.3367367     -9.5012188     -10.172306     -6.4335876
    [268]      -4.3955317     -4.2857981     -5.8056121     -7.9691095
    [272]      -7.7745576     -5.7785573     -4.5859380     -4.6421952
    [276]      -5.7720714     -7.4794965     -8.5230417     -7.8785167
    [280]      -6.5431738     -5.5935936     -5.2050996     -4.8071551
    [284]      -3.4274988     -1.1969969     0.88481110      2.2778432
    [288]       2.8386047      2.5323684      1.3552508    -0.47688013
    [292]      -1.7083383    -0.61435515      1.4595959      2.9858351
    [296]       3.7350125      3.9753234      4.2240443      4.8871927
    [300]       5.7964311      6.4831142      6.6157842      6.0262752
    [304]       4.7024345      3.2156746      3.2344372      4.8024693
    [308]       6.0446577      6.1231184      5.0397296      4.2274995
    [312]       6.2619658      9.2974110      11.451685      12.490941
    [316]       12.486945      11.711730      11.240971      12.492917
    [320]       14.516289      15.859991      16.017555      14.752172
    [324]       11.909295      9.6684933      12.620326      15.859364
    [328]       17.651222      18.245035      17.870483      16.649475
    [332]       14.649644      12.032106      9.5187607      8.4961872
    [336]       8.7289066      8.7426796      7.9058022      6.2580004
    [340]       4.6083198      4.4962068      5.6323085      6.5146646
    [344]       6.5359855      5.6009288      3.8965492      2.2788165
    [348]       2.0023043      2.4933884      2.3871467      1.1496942
    [352]     -0.92212379     -1.6361159     0.31362349      2.3706467
    [356]       3.4758716      3.5873523      2.7533934      1.0728327
    [360]     -0.77950853     -1.0063010     0.36360472      1.4663703
    [364]       1.6090496     0.81486076    -0.53389245     -1.5789207
    [368]      -1.5273284    -0.72461915    0.037837785     0.27764016
    [372]     -0.25820091     -1.5788487     -2.9645197     -2.8848126
    [376]      -1.7073339     -1.0084034     -1.3859785     -2.9069734
    [380]      -5.2515001     -6.8193531     -5.8195691     -3.9852493
    [384]      -2.7860503     -2.5175066     -3.1995542     -4.5513659
    [388]      -5.3325891     -4.2713280     -2.5865386     -1.5007088
    [392]      -1.2509048     -1.7416040     -2.7045984     -3.5382721
    [396]      -3.4580898     -2.5648572     -1.7571853     -1.6677630
    [400]      -2.5511889     -4.2741418     -5.4962440     -4.3688345
    [404]      -2.4019876     -1.1073129    -0.67847997    -0.94600105
    [408]      -1.5924453     -2.1468186     -2.2470181     -2.0715361
    [412]      -2.1401629     -2.8688679     -4.4603391     -6.7145615
    [416]      -8.2200327     -7.5487499     -6.3095241     -5.7862225
    [420]      -6.0233860     -6.3787193     -5.8264427     -4.3920689
    [424]      -3.1004722     -2.6140890     -3.2524536     -5.3929582
    [428]      -9.9747210     -17.883148     -11.667819     -7.0088305
    [432]      -4.9862986     -4.4374228     -4.9015021     -5.9732451
    [436]      -6.8041577     -6.4870791     -5.6431837     -5.5045800
    [440]      -6.8364277     -10.062822     -11.211280     -6.5008707
    [444]      -2.9687014     -1.1024568    -0.47168836    -0.83251822
    [448]      -2.0620470     -4.1008220     -6.8886952     -10.161643
    [452]      -12.782482     -12.815631     -10.872721     -8.6950493
    [456]      -6.8951359     -5.5022669     -4.3397198     -3.2333856
    [460]      -2.1648788     -1.2409178    -0.55385482    -0.11927017
    [464]     0.088118218    0.071545467    -0.21787654    -0.86578202
    [468]      -1.9683348     -3.6254833     -5.9373078     -8.8571320
    [472]      -11.317029     -10.950756     -8.8509159     -6.9233871
    [476]      -5.4623427     -4.4423323     -3.9375391     -4.1216164
    [480]      -5.2411346     -7.7038689     -12.536141     -25.557264
    [484]      -18.707596     -12.790101     -10.997292     -11.108482
    [488]      -12.344288     -13.562694     -13.351051     -12.326916
    [492]      -11.822954     -12.285124     -13.560973     -14.655207
    [496]      -14.168685     -12.817326     -11.932326     -11.936386
    [500]      -12.928086     -15.033652     -17.869579     -17.378168
    [504]      -13.553608     -10.703765     -9.3421240     -9.3330870
    [508]      -10.392763     -11.413705     -10.734552     -9.3049612
    [512]      -8.6988926
  [Tag]         7361
  [frame_len]          320
[Record 47]
  [tot_power]       86857.266
  [re_spec_val]
    [0]      -44.028465     -26.209253     -23.965393     -29.443274
    [4]      -33.294685     -24.618259     -27.144663     -21.037928
    [8]      -10.465058     -4.4996133    -0.84576756      1.2435029
    [12]       2.3547869      3.0718055      3.3224230      2.2484980
    [16]      0.49268535      2.9299223      4.4938588     -5.2907782
    [20]       9.6305733      19.416805      24.977196      28.475317
    [24]       30.528460      31.394804      31.199198      30.017132
    [28]       27.950716      25.267008      22.523024      20.037600
    [32]       16.841576      12.018467      16.489515      22.288099
    [36]       25.502796      26.916279      26.825489      25.236340
    [40]       21.905165      16.353891      11.058819      12.482579
    [44]       12.815179      11.552984      12.448645      15.493106
    [48]       17.877821      19.221006      19.698143      19.469296
    [52]       18.647846      17.293684      15.409484      13.052831
    [56]       10.683686      9.1479530      8.3865595      8.3526592
    [60]       10.481489      13.749478      16.371323      17.945169
    [64]       18.456869      17.870258      16.174175      14.181190
    [68]       14.562833      16.599642      17.755098      17.429422
    [72]       15.479116      11.633561      5.7421017      2.0041852
    [76]       2.3256812     0.88341951     0.40342274      3.0824945
    [80]       4.8763733      5.0980721      4.1777749      2.6173432
    [84]      0.85559100    -0.72417271     -1.5801560     -1.4857237
    [88]      -1.0149473    -0.55774134    0.067495205     0.96981102
    [92]       1.7951696      2.1134572      1.6873339     0.41410848
    [96]      -1.7814683     -4.9807720     -8.0675907     -5.8218756
    [100]      -1.3410896      2.1102498      4.5695686      6.2881241
    [104]       7.4139729      7.9959927      8.0321436      7.5419412
    [108]       6.6299071      5.4654818      4.0889039      2.2248039
    [112]     -0.33194226     -1.4770215      1.2928588      4.2335515
    [116]       5.9076509      6.3295512      5.5866361      3.8593118
    [120]       1.9818842      1.4328327      1.6103313     0.78868049
    [124]      -1.8756707     -5.4024372     -2.9647105      1.3396674
    [128]       4.3954911      6.3647761      7.2513390      6.9397764
    [132]       5.4049592      3.3279359      2.7406361      3.2549379
    [136]       2.4694498     0.72481740      4.5746803      9.8697519
    [140]       13.408061      15.480324      16.329468      16.003529
    [144]       14.375053      11.047585      5.0007367     -1.4233998
    [148]       3.4265342      5.6457067      6.0658679      6.7397604
    [152]       8.5421448      10.538411      11.987888      12.651678
    [156]       12.381811      10.945588      7.8589292      1.7499864
    [160]      -8.7165575   -0.049794547      2.8566000      2.6671073
    [164]       1.0073107      1.0837338      3.7119482      5.8710690
    [168]       6.8060656      6.5721884      5.2565479      2.9439611
    [172]     -0.16473931     -3.4788597     -5.7231250     -6.1571803
    [176]      -6.0315504     -6.2545037     -5.8573771     -4.0324101
    [180]      -2.3590829     -1.9652131     -3.1539772     -6.0523334
    [184]      -10.553166     -15.435445     -20.673096     -27.885229
    [188]      -17.434513     -13.593080     -12.707166     -11.980620
    [192]      -9.4907875     -6.9146652     -5.3106418     -4.6179423
    [196]      -4.5701418     -4.9275002     -5.4903960     -6.0862741
    [200]      -6.6580272     -7.3121629     -8.0798750     -8.6437283
    [204]      -8.6544371     -8.3577003     -8.2068081     -8.3019886
    [208]      -8.5055265     -8.7545652     -9.1047831     -9.5693951
    [212]      -10.170316     -11.155225     -12.989918     -16.023678
    [216]      -18.408291     -16.098902     -13.219887     -11.637059
    [220]      -11.183805     -11.533396     -12.165322     -12.430410
    [224]      -12.320052     -12.578156     -13.965885     -17.363132
    [228]      -25.723799     -27.605478     -18.956001     -16.138737
    [232]      -15.724339     -17.000122     -19.204544     -20.375704
    [236]      -20.434238     -22.235363     -28.647285     -23.131517
    [240]      -16.185545     -12.615249     -10.852283     -10.368083
    [244]      -10.936186     -12.332219     -14.006555     -15.124046
    [248]      -15.816861     -17.198729     -19.602709     -19.722969
    [252]      -16.492634     -14.062102     -13.112548     -13.505868
    [256]      -15.254531     -18.800047     -26.004707     -29.820463
    [260]      -22.113171     -19.385376     -18.263670     -16.014107
    [264]      -12.646697     -10.056600     -8.9069157     -9.4446564
    [268]      -12.284971     -20.189734     -21.483053     -13.121627
    [272]      -10.356131     -9.9799232     -11.288156     -13.891431
    [276]      -16.656719     -17.629953     -17.768223     -18.908913
    [280]      -21.195181     -21.749540     -18.743784     -15.843298
    [284]      -14.068704     -13.456714     -14.206791     -16.968555
    [288]      -22.961765     -20.884233     -15.363666     -13.272501
    [292]      -13.782988     -16.723518     -16.819706     -11.626175
    [296]      -8.1697636     -6.5270729     -6.3132930     -7.3920584
    [300]      -9.7621431     -13.238257     -15.742365     -14.016331
    [304]      -10.995644     -8.7917585     -8.0500546     -9.5501709
    [308]      -15.396515     -13.167660     -5.3589830     -1.6194495
    [312]     -0.12291908    -0.44219923     -2.7935245     -8.0253706
    [316]      -8.7817640     -2.5464654      1.0891924      3.1643794
    [320]       4.4109440      5.3500819      6.3714514      7.4812961
    [324]       8.3170261      8.4832373      7.6826816      5.6219110
    [328]       1.8192606     -4.5063157     -7.5114489     -3.8360643
    [332]      -2.7225716     -3.8968225     -7.2757444     -13.234598
    [336]      -14.831839     -11.491241     -11.110604     -13.914019
    [340]      -21.950098     -22.947504     -16.284016     -13.847355
    [344]      -12.505931     -11.692717     -11.888354     -13.457186
    [348]      -15.567871     -15.310830     -13.798784     -13.573298
    [352]      -14.984069     -17.162575     -17.787813     -17.233614
    [356]      -17.695337     -19.741068     -22.377302     -20.860537
    [360]      -16.124212     -12.002542     -9.0059595     -7.0681491
    [364]      -6.0718622     -5.8935170     -6.3893061     -7.3587127
    [368]      -8.5186501     -9.5821266     -10.478790     -11.467143
    [372]      -13.011408     -15.740748     -20.599003     -23.594624
    [376]      -18.086578     -14.579399     -12.975696     -12.660218
    [380]      -13.311441     -14.623040     -16.030703     -16.799103
    [384]      -16.979151     -17.328812     -18.008268     -17.964294
    [388]      -16.554304     -15.079263     -14.525024     -15.118464
    [392]      -16.703232     -18.441889     -18.904774     -18.459358
    [396]      -18.516895     -19.587830     -21.188843     -20.973019
    [400]      -18.258503     -15.577007     -13.870450     -13.272288
    [404]      -13.874495     -15.823665     -18.888205     -20.286131
    [408]      -18.638567     -17.688969     -18.579002     -21.486444
    [412]      -26.052116     -27.895395     -25.413641     -22.185394
    [416]      -19.366207     -17.960613     -18.567108     -22.025434
    [420]      -26.904415     -21.215780     -17.660612     -17.179676
    [424]      -19.628307     -25.798681     -22.665110     -17.251741
    [428]      -14.828361     -14.087568     -14.445580     -15.639145
    [432]      -17.442419     -18.824009     -18.032312     -16.269405
    [436]      -15.357020     -15.858102     -17.951525     -20.538452
    [440]      -18.844885     -15.434065     -13.333226     -12.572012
    [444]      -12.981612     -14.508075     -17.214037     -21.360329
    [448]      -27.654043     -31.055801     -25.612934     -22.653509
    [452]      -22.094910     -24.013430     -30.197918     -34.885082
    [456]      -24.304314     -18.951296     -14.965493     -11.852486
    [460]      -9.6804800     -8.5242586     -8.4613705     -9.6653891
    [464]      -12.569407     -18.226742     -22.672237     -17.346735
    [468]      -15.142210     -15.604634     -18.098362     -20.135963
    [472]      -18.049147     -15.789016     -14.791210     -14.713463
    [476]      -15.252289     -16.301550     -17.475447     -17.592310
    [480]      -16.514280     -15.727201     -16.112797     -17.987967
    [484]      -21.572145     -26.707865     -30.536846     -30.571461
    [488]      -28.088018     -24.758991     -22.790598     -22.729303
    [492]      -24.977835     -31.395535     -43.959244     -29.613117
    [496]      -26.703255     -27.222195     -30.828119     -36.826122
    [500]      -32.872742     -29.581347     -28.686159     -27.554422
    [504]      -24.522820     -21.361563     -19.096115     -17.753178
    [508]      -17.184364     -17.230801     -17.695555     -18.268208
    [512]      -18.534082
  [Tag]         7521
  [frame_len]          320
[Record 48]
  [tot_power]       59830.945
  [re_spec_val]
    [0]      -32.477737     -33.255028     -50.991009     -28.088947
    [4]      -22.833191     -24.142971     -41.896736     -18.208530
    [8]      -11.136733     -6.6767712     -3.5331981     -1.2170501
    [12]      0.63943106      1.9602746      2.3288996      2.0971665
    [16]       3.0814962      3.9699144    0.076369628      7.6633363
    [20]       17.502707      23.408005      27.256149      29.668032
    [24]       30.906883      31.090342      30.257750      28.402748
    [28]       25.527439      21.838783      18.168522      15.239811
    [32]       11.805249      9.9374561      14.964845      18.890905
    [36]       20.887987      21.394072      20.609177      18.615700
    [40]       15.636199      12.724278      11.421250      10.775471
    [44]       9.3630457      7.3715954      6.5927343      7.6651254
    [48]       8.9888182      9.9130688      10.472402      10.759185
    [52]       10.860909      10.898498      10.895175      10.580596
    [56]       9.4150438      6.6662121      1.8130908      1.8402107
    [60]       5.9322209      7.6088095      7.4993114      7.0003090
    [64]       7.4577041      8.1046486      8.0893316      8.5296783
    [68]       10.632114      12.844150      13.983450      13.834455
    [72]       12.389853      9.6591978      5.8016372      1.6594949
    [76]      -1.4823120     -4.4007273     -8.1196966     -9.9943466
    [80]      -9.2247620     -9.1294184     -9.9924173     -10.913665
    [84]      -11.018662     -10.383939     -9.7523336     -9.5425787
    [88]      -9.6369591     -9.6215982     -9.3493652     -9.3008823
    [92]      -10.225286     -12.823540     -15.903975     -12.737914
    [96]      -8.8572788     -6.8047442     -6.1406083     -6.4878325
    [100]      -7.5598969     -9.0042524     -10.227543     -10.696018
    [104]      -10.712703     -11.070338     -12.267076     -13.553629
    [108]      -11.736197     -8.2228937     -5.8283510     -5.0490789
    [112]      -6.1141305     -9.7866716     -18.012924     -13.924716
    [116]      -9.4936523     -9.1338682     -12.539648     -20.485319
    [120]      -11.421066     -6.2244072     -3.6825745     -2.4722130
    [124]      -2.0603437     -2.1447458     -2.4611959     -2.7579839
    [128]      -2.9696500     -3.3205485     -4.0674334     -4.8421679
    [132]      -3.9302862     -1.1663721      1.4217857      2.9537566
    [136]       3.2480083      2.2550354     0.28839904    -0.61634308
    [140]       1.0829383      2.8261130      3.3897812      2.7974329
    [144]       1.6898193      1.6258020      3.0369713      4.4042616
    [148]       4.8800964      4.3151836      2.8712320      1.2327932
    [152]      0.47766221     0.34258819    -0.49331239     -3.0821693
    [156]      -9.4217606     -17.260588     -5.3005209    -0.68481141
    [160]       1.6793361      2.6747372      2.5031548      1.1874704
    [164]      -1.1652058     -3.6552641     -4.2974229     -3.6696134
    [168]      -3.5746858     -4.3453631     -5.4336071     -5.7778177
    [172]      -5.0536661     -4.0400081     -3.2511022     -2.7415960
    [176]      -2.4895344     -2.6072516     -3.3415735     -5.0231218
    [180]      -8.1498213     -13.785603     -20.008512     -14.016839
    [184]      -10.439692     -8.8384647     -8.2346201     -8.1466980
    [188]      -8.2800455     -8.4561749     -8.6347294     -8.9081373
    [192]      -9.4046049     -10.173451     -11.128294     -12.066220
    [196]      -12.769780     -13.143979     -13.294876     -13.496350
    [200]      -14.047812     -15.098429     -16.427834     -17.245806
    [204]      -16.925987     -15.974876     -15.020415     -14.244267
    [208]      -13.688611     -13.421937     -13.518566     -14.038833
    [212]      -15.068207     -16.779696     -19.495842     -23.804815
    [216]      -30.749472     -36.609112     -36.106258     -42.931149
    [220]      -30.776955     -23.627420     -19.851334     -17.977583
    [224]      -17.575943     -18.576839     -21.160110     -25.843323
    [228]      -33.585594     -38.660973     -33.998005     -27.850300
    [232]      -23.162815     -20.390957     -19.131889     -18.926428
    [236]      -19.224829     -19.598452     -20.247561     -21.857563
    [240]      -24.779850     -26.150866     -23.508362     -21.630798
    [244]      -21.632082     -23.309849     -25.532890     -25.270775
    [248]      -23.164261     -21.459469     -20.556744     -20.640957
    [252]      -22.115484     -25.610514     -30.215538     -27.869761
    [256]      -25.150137     -24.837494     -25.793810     -25.376478
    [260]      -23.089079     -21.077890     -19.921192     -19.529652
    [264]      -19.733639     -19.952021     -18.840715     -16.256187
    [268]      -13.612883     -11.668887     -10.621831     -10.577728
    [272]      -11.726687     -14.494221     -19.913303     -25.749575
    [276]      -20.259813     -17.507555     -17.243078     -18.570208
    [280]      -20.641073     -22.112846     -22.442980     -22.432936
    [284]      -22.388430     -21.782574     -20.156792     -18.183531
    [288]      -16.797207     -16.454130     -17.357866     -19.683643
    [292]      -23.344976     -25.438700     -23.551109     -22.332767
    [296]      -23.356853     -27.125675     -26.763386     -20.889795
    [300]      -17.353029     -15.507443     -14.702939     -14.548401
    [304]      -14.798429     -15.341111     -16.311855     -18.217579
    [308]      -20.868919     -18.122707     -12.775337     -9.0899496
    [312]      -6.8873129     -5.8840227     -5.9636297     -7.1280150
    [316]      -9.4459314     -12.845957     -16.102411     -16.083481
    [320]      -12.735545     -8.4970808     -4.8980660     -2.3681188
    [324]     -0.92338419    -0.52378291     -1.1748482     -2.9794698
    [328]      -6.2494855     -11.955408     -26.132925     -20.700478
    [332]      -15.949032     -15.910775     -17.555843     -16.331326
    [336]      -12.884445     -10.488910     -9.3320246     -9.1141624
    [340]      -9.5797167     -10.546254     -11.914395     -13.699952
    [344]      -16.101351     -19.516619     -23.178185     -21.365856
    [348]      -17.651243     -15.395165     -14.456341     -14.599156
    [352]      -15.729217     -17.869526     -21.084324     -24.540228
    [356]      -23.959488     -20.488741     -17.586340     -15.606136
    [360]      -14.488627     -14.209651     -14.782713     -16.249176
    [364]      -18.626442     -21.598852     -23.798048     -24.363125
    [368]      -25.045017     -27.145897     -30.466187     -31.488638
    [372]      -29.256865     -26.858658     -24.725548     -23.141354
    [376]      -22.349848     -22.266930     -22.593363     -23.083555
    [380]      -23.630871     -23.906342     -23.438021     -22.492025
    [384]      -21.701794     -21.289927     -21.260513     -21.825535
    [388]      -23.566378     -27.511555     -32.073112     -26.620560
    [392]      -22.707735     -21.177263     -21.259598     -22.449940
    [396]      -24.014544     -24.993832     -25.320721     -25.725407
    [400]      -26.547976     -27.487267     -27.355335     -25.365089
    [404]      -22.903606     -21.143475     -20.426359     -20.880714
    [408]      -22.715281     -26.425774     -32.356644     -31.463854
    [412]      -27.176826     -25.053755     -24.255684     -24.182152
    [416]      -24.306639     -24.016630     -23.156734     -22.297241
    [420]      -21.883442     -21.698553     -21.081184     -20.004673
    [424]      -19.244503     -19.416508     -20.831821     -23.741016
    [428]      -28.458797     -34.193024     -33.587120     -29.777384
    [432]      -26.901869     -25.191820     -24.661905     -25.239758
    [436]      -26.851683     -29.672665     -34.785633     -38.717022
    [440]      -30.872995     -26.382114     -24.221512     -23.684200
    [444]      -24.405155     -25.580782     -25.428322     -23.764523
    [448]      -22.092545     -20.826731     -19.736698     -18.656345
    [452]      -17.680473     -17.045040     -17.040569     -18.082949
    [456]      -21.022346     -29.105686     -29.161461     -20.216696
    [460]      -16.847933     -15.890744     -16.880730     -20.082117
    [464]      -24.088404     -20.326473     -16.430622     -14.677676
    [468]      -14.580473     -15.910698     -18.319324     -19.988317
    [472]      -18.901354     -17.217010     -16.215548     -15.788404
    [476]      -15.693677     -15.922598     -16.693949     -18.340019
    [480]      -21.365887     -27.044613     -39.477493     -29.149071
    [484]      -24.472555     -22.575567     -22.015007     -22.297525
    [488]      -23.207916     -24.676876     -26.795923     -29.836220
    [492]      -32.785706     -30.288588     -26.244850     -23.760807
    [496]      -22.822706     -23.380066     -25.669056     -30.570456
    [500]      -39.471115     -34.319191     -30.666676     -30.302126
    [504]      -32.477413     -38.581181     -45.912457     -34.872540
    [508]      -30.855856     -29.457850     -29.846098     -31.596579
    [512]      -32.956123
  [Tag]         7681
  [frame_len]          320
[Record 49]
  [tot_power]       35736.980
  [re_spec_val]
    [0]      -22.743992     -24.743727     -29.651848     -28.866695
    [4]      -31.678627     -33.050949     -20.315140     -15.045601
    [8]      -11.631405     -8.5656204     -5.4733186     -2.6762948
    [12]     -0.80652994    -0.59194070     -2.8960977     -6.1828876
    [16]      -3.3264930     -4.1597080      4.1666889      14.194565
    [20]       20.508791      24.717201      27.430916      28.912296
    [24]       29.267160      28.502096      26.533869      23.187243
    [28]       18.387686      14.028567      13.615933      13.662539
    [32]       12.962465      12.676287      12.973529      12.930547
    [36]       12.158522      10.888566      9.6612883      8.8084154
    [40]       8.0297604      6.7366452      4.3798776     0.59328032
    [44]      -1.7662716      1.4720135      4.3604927      5.8110337
    [48]       6.2657347      6.1068606      5.5300312      4.4256420
    [52]       2.3286881     -1.5561591     -4.6991925     0.49678057
    [56]       4.6748490      6.9592147      7.8886909      7.6495161
    [60]       6.1389356      3.0749936      1.1012732      5.7812943
    [64]       10.276929      13.267550      15.129594      16.085619
    [68]       16.231520      15.590599      14.137057      11.802110
    [72]       8.4706001      3.9854789     -1.7079413     -7.4802876
    [76]      -10.214207     -11.374813     -13.294527     -16.363813
    [80]      -17.629864     -14.040575     -10.980801     -9.4099140
    [84]      -8.9336977     -9.1830158     -9.8958788     -10.975116
    [88]      -12.538124     -14.881066     -18.086411     -19.529356
    [92]      -16.749027     -14.039143     -12.599541     -12.309195
    [96]      -13.032371     -14.673068     -17.019053     -19.412712
    [100]      -21.020098     -22.298944     -23.996508     -24.116709
    [104]      -21.532425     -19.462574     -18.881083     -19.100496
    [108]      -17.838667     -14.788640     -12.088757     -10.436924
    [112]      -9.8085260     -10.036497     -10.803622     -11.528579
    [116]      -11.681755     -11.461511     -11.477209     -12.126275
    [120]      -13.569354     -15.818451     -18.636616     -21.152473
    [124]      -21.329947     -18.262777     -14.522165     -11.650565
    [128]      -9.9078875     -9.2371111     -9.4038572     -9.6874809
    [132]      -8.8441172     -6.8194871     -4.7407379     -3.2293513
    [136]      -2.4555025     -2.4679430     -3.2555337     -4.6221480
    [140]      -5.9412947     -6.5444531     -6.9466796     -8.3532667
    [144]      -11.762791     -14.525144     -9.7349386     -5.9412436
    [148]      -3.9466326     -2.9517407     -2.2830651     -1.5858380
    [152]      -1.0318927     -1.0173841     -1.8229079     -3.5314443
    [156]      -5.9215479     -8.3833055     -10.887404     -15.436769
    [160]      -21.173471     -11.912532     -7.2108588     -5.1296239
    [164]      -4.7218862     -5.6798987     -7.9652462     -11.794736
    [168]      -17.894844     -25.566031     -21.541565     -18.348925
    [172]      -17.294029     -17.418322     -17.566292     -16.264669
    [176]      -14.148804     -12.638847     -12.247900     -13.109324
    [180]      -15.288629     -18.618277     -21.796394     -23.303843
    [184]      -24.754766     -25.287785     -22.011646     -18.749588
    [188]      -16.808830     -15.874327     -15.599171     -15.822620
    [192]      -16.603760     -18.162750     -20.838041     -25.202324
    [196]      -32.315941     -34.871658     -30.001966     -27.483961
    [200]      -26.060966     -24.840420     -23.490902     -22.324589
    [204]      -21.885128     -22.605934     -24.916918     -29.708941
    [208]      -41.415829     -40.002853     -33.798630     -32.135632
    [212]      -31.216047     -29.887978     -28.381603     -27.288397
    [216]      -27.091890     -28.271334     -31.516512     -36.251286
    [220]      -32.844486     -28.902287     -27.432009     -28.001026
    [224]      -30.959013     -39.633198     -38.836998     -29.481457
    [228]      -25.347904     -23.031199     -21.810862     -21.460157
    [232]      -21.940800     -23.368521     -26.156561     -31.787235
    [236]      -43.337833     -30.296663     -25.244148     -22.939217
    [240]      -22.337111     -23.305176     -26.248722     -33.005848
    [244]      -39.768471     -29.781071     -26.000755     -24.120790
    [248]      -22.894468     -21.719769     -20.411428     -19.157858
    [252]      -18.311596     -18.210360     -19.181805     -21.722565
    [256]      -27.165958     -40.416355     -28.831963     -24.375011
    [260]      -22.793882     -22.441875     -22.533724     -22.717459
    [264]      -23.115183     -24.100666     -26.166052     -30.187649
    [268]      -36.933502     -33.788841     -30.440073     -32.161648
    [272]      -44.558239     -26.307283     -19.508972     -15.771729
    [276]      -13.731125     -12.930394     -13.152656     -14.244690
    [280]      -16.012312     -18.115007     -20.037525     -21.361786
    [284]      -22.187258     -23.022293     -24.143063     -24.759632
    [288]      -23.735571     -22.227606     -21.579704     -22.039927
    [292]      -23.113239     -23.684488     -23.479515     -23.410973
    [296]      -23.650137     -23.485502     -22.925461     -22.990456
    [300]      -24.481407     -27.594765     -29.156208     -26.060585
    [304]      -23.286623     -21.594294     -20.488197     -19.566620
    [308]      -18.549372     -17.357702     -16.246317     -15.663520
    [312]      -16.070614     -18.028313     -22.524748     -26.583187
    [316]      -21.199858     -18.592283     -19.307806     -22.098921
    [320]      -17.197447     -11.586987     -8.3305435     -6.7687664
    [324]      -6.5803418     -7.6858282     -10.188199     -14.436666
    [328]      -21.289921     -30.522623     -29.038073     -26.344667
    [332]      -22.561546     -19.231932     -17.182619     -16.178362
    [336]      -15.918218     -16.224554     -17.010187     -18.100788
    [340]      -19.047007     -19.402582     -19.310169     -19.115074
    [344]      -18.844698     -18.526949     -18.517035     -19.298880
    [348]      -21.327450     -25.238628     -32.783173     -37.588997
    [352]      -29.964724     -26.619614     -25.041117     -24.642965
    [356]      -24.940331     -24.673664     -23.225655     -21.904181
    [360]      -21.701626     -22.970188     -25.877165     -29.488297
    [364]      -29.410395     -27.605236     -27.284714     -28.407494
    [368]      -29.031580     -26.590683     -23.466898     -21.252041
    [372]      -19.992161     -19.522566     -19.699524     -20.421764
    [376]      -21.647087     -23.419502     -25.850817     -28.662123
    [380]      -29.328558     -26.672127     -23.903172     -21.967272
    [384]      -20.757734     -20.111944     -19.970394     -20.403088
    [388]      -21.605013     -23.946474     -28.295189     -36.876656
    [392]      -32.463337     -26.710310     -24.114328     -23.214848
    [396]      -23.560671     -24.995657     -27.494091     -31.208897
    [400]      -37.048561     -46.752522     -36.249119     -30.245932
    [404]      -26.938217     -25.369232     -25.335304     -26.817068
    [408]      -29.379885     -30.475407     -29.180660     -28.465883
    [412]      -28.958309     -29.425808     -28.481653     -27.184385
    [416]      -26.726051     -27.313072     -28.636066     -29.604200
    [420]      -28.789196     -26.963840     -25.597607     -25.208817
    [424]      -25.630497     -25.624973     -23.855673     -21.560141
    [428]      -20.010511     -19.482315     -19.959946     -21.390545
    [432]      -23.689505     -26.568024     -29.132776     -30.366653
    [436]      -30.793020     -31.186018     -31.441280     -31.535854
    [440]      -31.977222     -32.852650     -33.145943     -32.494461
    [444]      -32.244015     -32.763142     -32.199539     -29.895618
    [448]      -28.040958     -27.484333     -28.153282     -29.607637
    [452]      -30.874208     -30.648275     -28.814816     -26.601236
    [456]      -24.943293     -24.187517     -24.447035     -25.837671
    [460]      -28.529638     -31.520491     -30.008039     -26.834927
    [464]      -25.305923     -25.826563     -29.353966     -44.936039
    [468]      -30.761505     -24.286617     -21.526394     -20.575092
    [472]      -20.749846     -21.275902     -21.116772     -20.216805
    [476]      -19.551439     -19.792061     -21.199331     -23.629745
    [480]      -25.356178     -24.294621     -22.755026     -22.194012
    [484]      -22.551603     -23.335268     -23.930544     -24.122704
    [488]      -24.178234     -24.267971     -24.309158     -24.231783
    [492]      -24.149179     -24.253632     -24.727251     -25.791519
    [496]      -27.815334     -31.544624     -38.932808     -40.107601
    [500]      -33.755985     -31.500391     -31.554678     -33.497364
    [504]      -37.452873     -43.672794     -49.660480     -45.768974
    [508]      -38.177692     -32.846039     -29.484880     -27.625139
    [512]      -27.028749
  [Tag]         7841
  [frame_len]          320
[Record 50]
  [tot_power]       13411.698
  [re_spec_val]
    [0]      -38.724091     -40.941574     -43.901188     -39.863194
    [4]      -29.148598     -22.788733     -20.425993     -22.771420
    [8]      -29.162058     -15.726544     -8.5404911     -3.3247082
    [12]      0.36457896      2.3287542      2.5136385      2.3868613
    [16]       5.7427082      10.146786      13.527690      16.118397
    [20]       18.228992      19.842878      20.811550      21.147240
    [24]       21.201742      21.493576      21.983702      22.012133
    [28]       20.945969      18.264427      13.419209      9.3099279
    [32]       11.955879      13.559351      13.398379      12.481363
    [36]       11.593587      10.782895      9.8440800      8.9074755
    [40]       8.1011410      7.2675557      6.1206865      3.9654129
    [44]      -1.1001997     -4.3683643      4.1441164      8.1151381
    [48]       9.6217623      9.6600037      9.2117949      9.3364878
    [52]       9.8097258      9.5754671      8.0009108      4.9154291
    [56]       1.4094381     0.42020926     0.59896368     0.58494121
    [60]      0.91784096      1.1473211      2.3933346      5.7598405
    [64]       8.5586433      9.4434671      7.8041844      1.6920284
    [68]    -0.048116598      8.0392370      11.002371      11.376991
    [72]       9.7406330      6.0252714    -0.35601881     -8.6002541
    [76]      -8.2992277     -7.0172963     -5.2115369     -3.0411460
    [80]      -1.2855793   -0.038839545     0.36581069    -0.42467353
    [84]      -2.3875051     -4.5774188     -5.7532325     -7.0860910
    [88]      -9.5642195     -8.9793119     -5.5579462     -3.5578156
    [92]      -3.0238519     -3.2660732     -3.5339837     -3.6191149
    [96]      -4.0174146     -5.2587447     -7.5743866     -10.673946
    [100]      -12.720668     -11.028561     -7.3889513     -4.1924176
    [104]      -2.0307455    -0.81254363    -0.17554221     0.34482640
    [108]      0.95548284      1.4320771      1.4578899     0.89618081
    [112]     -0.18646856     -1.5583494     -2.9212976     -4.0813398
    [116]      -4.9445376     -5.3424292     -5.1768713     -4.6423416
    [120]      -3.9343319     -3.0561850     -2.0866556     -1.3199190
    [124]      -1.0427679     -1.3384365     -2.0191791     -2.6957545
    [128]      -3.1823845     -3.7868502     -4.9071202     -6.5739222
    [132]      -8.2080746     -8.8311224     -8.1972313     -7.0137506
    [136]      -6.1445498     -6.2366509     -7.6781340     -10.301453
    [140]      -11.760069     -10.840023     -10.758000     -11.787588
    [144]      -9.8814993     -6.0022793     -3.3318913     -2.0360472
    [148]      -1.7927388     -2.1192060     -2.1853559     -1.4425558
    [152]     -0.52756262    -0.32600495     -1.3247390     -3.8316245
    [156]      -8.1781216     -14.187818     -12.934700     -6.5803084
    [160]      -2.1029749     0.62028694      1.9337354      2.2087543
    [164]       1.9911175      1.9058270      2.0728171      2.0660374
    [168]       1.5752953     0.65066200    -0.39563835     -1.1849411
    [172]      -1.4767671     -1.2346818    -0.56742096     0.38536149
    [176]       1.4777242      2.5012541      3.2293806      3.5085649
    [180]       3.2830565      2.5755835      1.4736404     0.13538525
    [184]      -1.2168461     -2.3813927     -3.2912252     -3.9687510
    [188]      -4.4097695     -4.6329279     -4.7214937     -4.6803765
    [192]      -4.4230704     -4.0355334     -3.8445196     -4.1683836
    [196]      -5.1673169     -6.8449607     -9.0665817     -11.588745
    [200]      -14.151348     -16.480799     -17.913818     -17.384417
    [204]      -15.215082     -12.864542     -11.125728     -10.205122
    [208]      -10.088802     -10.665666     -11.756015     -13.150217
    [212]      -14.668818     -16.095360     -16.949949     -16.690962
    [216]      -15.381942     -13.514292     -11.579702     -9.9625902
    [220]      -8.8673153     -8.3153496     -8.1857052     -8.2818108
    [224]      -8.4572639     -8.7192888     -9.1645145     -9.8162603
    [228]      -10.528045     -11.023609     -11.097114     -10.813954
    [232]      -10.453517     -10.286553     -10.395958     -10.556287
    [236]      -10.324020     -9.6058226     -8.8834181     -8.6598711
    [240]      -9.1858158     -10.504446     -12.398622     -14.178427
    [244]      -15.050674     -15.247628     -15.403947     -15.565333
    [248]      -15.386685     -14.671234     -13.660629     -12.816181
    [252]      -12.506075     -12.878329     -13.735329     -14.328219
    [256]      -13.930133     -12.978432     -12.188741     -11.729440
    [260]      -11.479997     -11.329020     -11.227425     -11.090979
    [264]      -10.828496     -10.519506     -10.402416     -10.634535
    [268]      -11.086759     -11.326252     -11.051635     -10.537837
    [272]      -10.233488     -10.325632     -10.696482     -10.897603
    [276]      -10.304866     -8.8768272     -7.2634716     -5.9969826
    [280]      -5.2646580     -5.0555072     -5.2697120     -5.7874107
    [284]      -6.5240822     -7.4328699     -8.4208212     -9.2489004
    [288]      -9.5963612     -9.3562937     -8.7700996     -8.2061539
    [292]      -7.9649382     -8.2379370     -9.0991869     -10.407219
    [296]      -11.503864     -11.334396     -10.024637     -8.6534834
    [300]      -7.8094869     -7.6483049     -8.1641817     -9.2418137
    [304]      -10.594653     -11.737844     -12.278677     -12.298141
    [308]      -12.065559     -11.600574     -10.835810     -10.052436
    [312]      -9.7907925     -10.446254     -11.814666     -12.187875
    [316]      -10.704679     -9.5689821     -10.078834     -12.724289
    [320]      -16.128170     -13.807650     -11.069672     -10.580567
    [324]      -12.075385     -15.055916     -18.103863     -18.919706
    [328]      -15.599792     -11.085159     -7.7983694     -5.7529411
    [332]      -4.4976130     -3.5638764     -2.6906896     -1.9011643
    [336]      -1.3033068    -0.92885000    -0.76182526    -0.81678343
    [340]      -1.1471350     -1.7914941     -2.7198184     -3.8048561
    [344]      -4.8246565     -5.5212498     -5.7217922     -5.4430676
    [348]      -4.8797617     -4.2874532     -3.8674297     -3.7239947
    [352]      -3.8794956     -4.3107834     -4.9836779     -5.8661728
    [356]      -6.9092712     -8.0093784     -8.9862061     -9.6057215
    [360]      -9.6768427     -9.2231531     -8.5308495     -7.9427810
    [364]      -7.6667180     -7.7395840     -8.0629215     -8.4785023
    [368]      -8.8917313     -9.3463354     -9.9538689     -10.776734
    [372]      -11.782006     -12.845181     -13.746384     -14.242561
    [376]      -14.352140     -14.453927     -14.902412     -15.595024
    [380]      -15.758217     -14.872418     -13.696463     -13.036086
    [384]      -13.135163     -13.880795     -14.805408     -15.130963
    [388]      -14.583950     -13.746272     -13.124139     -12.791824
    [392]      -12.553543     -12.190725     -11.726207     -11.411853
    [396]      -11.477106     -11.964496     -12.672654     -13.218610
    [400]      -13.386332     -13.374868     -13.448200     -13.550364
    [404]      -13.300872     -12.437257     -11.219452     -10.103869
    [408]      -9.3796358     -9.1699142     -9.5133104     -10.395268
    [412]      -11.716693     -13.173651     -14.131874     -14.047596
    [416]      -13.210771     -12.253588     -11.504227     -11.034458
    [420]      -10.821178     -10.832721     -11.067716     -11.559845
    [424]      -12.342604     -13.358045     -14.312246     -14.707449
    [428]      -14.413584     -13.912432     -13.679244     -13.877692
    [432]      -14.427322     -15.070551     -15.485295     -15.565251
    [436]      -15.563456     -15.844841     -16.628382     -17.852976
    [440]      -18.973280     -19.100853     -18.198860     -17.042179
    [444]      -16.082672     -15.402726     -14.967734     -14.732288
    [448]      -14.669656     -14.776085     -15.057853     -15.506217
    [452]      -16.070688     -16.650656     -17.149120     -17.587894
    [456]      -18.138113     -18.978565     -20.105473     -21.194801
    [460]      -21.658575     -21.154058     -20.041164     -19.019129
    [464]      -18.624691     -19.121733     -20.433746     -21.726027
    [468]      -21.677515     -20.788099     -20.247663     -20.235758
    [472]      -20.416618     -20.628653     -20.955597     -20.747427
    [476]      -18.835283     -16.188782     -14.189140     -13.214782
    [480]      -13.237782     -14.045861     -15.122134     -15.684813
    [484]      -15.508861     -15.136798     -14.967781     -15.019486
    [488]      -15.130726     -15.112696     -14.861431     -14.443678
    [492]      -14.047075     -13.834173     -13.870274     -14.160612
    [496]      -14.729404     -15.660045     -17.056372     -18.947426
    [500]      -21.163490     -23.248690     -24.604645     -24.821709
    [504]      -24.070845     -23.183044     -22.950996     -23.850340
    [508]      -26.222458     -29.857363     -30.697374     -28.280104
    [512]      -27.249626
  [Tag]         8001
  [frame_len]          320
[Record 51]
  [tot_power]       549716.88
  [re_spec_val]
    [0]      -49.836067     -29.670855     -22.639275     -19.458782
    [4]      -19.417109     -23.537668     -29.681353     -21.808212
    [8]      -18.959200     -9.9964571     -1.3669683      4.8002257
    [12]       9.2332039      12.335238      14.306339      15.241572
    [16]       15.170688      14.074450      11.903974      8.6756258
    [20]       4.9512534      3.0496721      5.3332620      10.323224
    [24]       15.747681      20.660328      24.812069      28.144211
    [28]       30.651833      32.343662      33.223576      33.279583
    [32]       32.475075      30.739294      27.958227      23.990709
    [36]       18.894630      14.272327      13.864632      16.693640
    [40]       19.995382      22.695429      24.737715      26.346996
    [44]       27.684591      28.741871      29.395533      29.502073
    [48]       28.936352      27.584276      25.332743      22.122559
    [52]       18.287529      15.246930      13.934587      14.194792
    [56]       17.212904      21.109409      24.316656      26.744923
    [60]       28.561768      29.884302      30.754349      31.167988
    [64]       31.113962      30.611216      29.750767      28.736427
    [68]       27.870485      27.439642      27.636951      28.549334
    [72]       30.005089      31.599756      32.985519      33.986050
    [76]       34.535286      34.604683      34.162033      33.153610
    [80]       31.498714      29.091009      25.815479      21.633194
    [84]       16.822847      11.775759      6.6060219      11.877443
    [88]       17.864124      21.482933      23.583006      24.566936
    [92]       24.616497      23.809553      22.168081      19.675650
    [96]       16.266510      11.816128      7.2128901      8.3274612
    [100]       12.351726      15.547275      18.006874      19.959959
    [104]       21.466610      22.478737      22.906660      22.649529
    [108]       21.592691      19.585590      16.416859      11.999842
    [112]       8.8302479      11.171734      14.368924      16.883745
    [116]       18.791792      20.173254      21.126448      21.765192
    [120]       22.146536      22.216364      21.826145      20.777472
    [124]       18.819918      15.542966      9.9016619     -4.6734715
    [128]       3.2264197      9.3442259      12.413888      14.752748
    [132]       16.758940      18.433018      19.764385      20.750181
    [136]       21.353264      21.502140      21.113541      20.103901
    [140]       18.382685      15.854662      12.624927      10.268137
    [144]       11.321620      13.563779      15.330140      16.724833
    [148]       18.119949      19.615410      20.980480      21.930645
    [152]       22.288713      21.969797      20.938562      19.212740
    [156]       17.021954      15.385938      15.873541      17.760242
    [160]       19.527361      20.705030      21.354254      21.847599
    [164]       22.739439      24.195713      25.778431      27.032761
    [168]       27.763212      27.944870      27.632130      26.921337
    [172]       25.949863      24.941774      24.258307      24.200720
    [176]       24.617807      25.080429      25.367212      25.580078
    [180]       25.933542      26.419760      26.763680      26.678047
    [184]       25.999157      24.655680      22.583052      19.576565
    [188]       14.918286      5.6526494      6.4025106      13.451659
    [192]       16.240475      17.296328      17.493437      17.401339
    [196]       17.312654      17.128052      16.561323      15.374679
    [200]       13.386172      10.321554      5.4123964     -4.3154588
    [204]      -1.1310188      5.2695937      8.1759424      9.6054964
    [208]       10.280919      10.637961      10.908802      11.073564
    [212]       10.966109      10.431098      9.3600521      7.6147962
    [216]       4.8795290     0.48063919     -4.1718879   -0.080554865
    [220]       3.8137500      5.7558193      6.4647350      6.5472379
    [224]       6.6247110      6.9998641      7.3819642      7.3322639
    [228]       6.6221256      5.2108531      3.1125569     0.12651166
    [232]      -4.7225976     -10.114352     -3.2047560      1.4402828
    [236]       3.7544467      4.6225829      4.6116014      4.4772115
    [240]       4.9663153      5.9031720      6.5544543      6.4769683
    [244]       5.4996471      3.5059512     0.23878504     -5.0427456
    [248]      -9.8628063     -3.7344086     0.76325303      3.3669338
    [252]       4.7927108      5.4418416      5.6644092      5.7623897
    [256]       5.8290682      5.7078671      5.1743641      4.0736284
    [260]       2.2852669    -0.43454677     -4.3887477     -5.8031983
    [264]      -1.2503012      2.3727324      4.4592023      5.4794908
    [268]       5.9177814      6.2928042      6.8667936      7.4150128
    [272]       7.5599475      7.0944629      6.0079412      4.3979707
    [276]       2.2617762    -0.69314158     -3.2764518    -0.27069098
    [280]       3.7860975      6.3133664      7.5606608      7.9436617
    [284]       7.9639053      8.1083193      8.4460716      8.6216612
    [288]       8.3074780      7.3932481      5.9159098      3.8930471
    [292]       1.2315618    -0.78096884      1.8574340      5.7721901
    [296]       8.4919930      10.049495      10.727831      10.870085
    [300]       10.891306      11.075160      11.318690      11.287481
    [304]       10.702236      9.3757401      7.1223660      4.0447922
    [308]       3.5222859      7.5591283      11.302399      13.876178
    [312]       15.486173      16.349840      16.696218      16.814781
    [316]       16.994617      17.325584      17.622316      17.605162
    [320]       17.073141      16.019154      14.991902      15.406126
    [324]       17.485430      19.812506      21.663855      22.921938
    [328]       23.599064      23.702801      23.232307      22.242317
    [332]       20.993065      20.061661      19.833050      19.842402
    [336]       19.381018      18.051266      15.741158      12.851180
    [340]       11.124295      11.749261      13.141935      14.374334
    [344]       15.240852      15.617967      15.478157      14.956822
    [348]       14.284459      13.542844      12.488485      10.681262
    [352]       7.6531072      3.4021487      2.2259521      5.4235806
    [356]       8.0043383      9.6928644      10.806385      11.434875
    [360]       11.574520      11.281595      10.726896      10.098149
    [364]       9.3770361      8.2655153      6.3356009      3.1153381
    [368]      -1.6069556     -3.4535277    0.044917207      2.8927915
    [372]       4.7897391      6.0320177      6.6770339      6.7493849
    [376]       6.3944001      5.9063559      5.5266123      5.1377888
    [380]       4.3398924      2.7496724     0.16761100     -2.8499286
    [384]      -3.5908985     -1.5994108     0.68609184      2.7077711
    [388]       4.3725638      5.5105882      6.0005751      5.8389945
    [392]       5.1616406      4.2394776      3.3049500      2.2403142
    [396]      0.61054718     -1.8156222     -3.5870216     -2.1546891
    [400]      0.10785241      1.5789903      2.4424262      3.1364877
    [404]       3.7944860      4.1760349      3.9830894      3.0743012
    [408]       1.5547656    -0.10285598     -1.3271637     -2.3642864
    [412]      -4.0705938     -6.6832218     -7.7942905     -5.7190123
    [416]      -3.7417347     -2.6316702     -1.8203229    -0.89095199
    [420]    -0.042822361     0.34404677     0.13692166    -0.50708455
    [424]      -1.2612814     -1.9534600     -2.7775996     -3.9279540
    [428]      -4.9848843     -4.9274807     -3.7659638     -2.3990457
    [432]      -1.1574099   -0.038752250     0.85044110      1.2990476
    [436]       1.1487336     0.37612295    -0.86003643     -2.2250776
    [440]      -3.4907827     -4.8841581     -6.6884532     -7.9605365
    [444]      -6.7516313     -4.3760023     -2.3735464    -0.82620192
    [448]      0.43855125      1.4149790      1.9671192      1.9919412
    [452]       1.5189124     0.75714070    0.039664198    -0.45438391
    [456]     -0.86407399     -1.3087809     -1.4949743    -0.87934649
    [460]      0.54975271      2.2556610      3.8056293      4.9928274
    [464]       5.7271814      5.9909120      5.8428078      5.4260316
    [468]       4.9288855      4.4709821      4.0272079      3.5243890
    [472]       3.0158834      2.7647190      3.1088691      4.1118860
    [476]       5.4473672      6.6881323      7.5256534      7.7815261
    [480]       7.3650961      6.2659793      4.6252232      2.8853164
    [484]       1.6670861      1.0205691     0.42726293    -0.36767572
    [488]      -1.2358266     -2.0351913     -2.6214759     -2.3649578
    [492]     -0.91746509     0.79256332      1.9296248      2.2727892
    [496]       1.9140866      1.1204391     0.23968415    -0.54286343
    [500]      -1.3519001     -2.4023609     -3.7731550     -5.3980103
    [504]      -7.0251064     -7.8560405     -7.0541153     -5.4540086
    [508]      -4.2153482     -3.7169514     -3.9053302     -4.4466987
    [512]      -4.7494693
  [Tag]         8161
  [frame_len]          320
[Record 52]
  [tot_power]       1942786.6
  [re_spec_val]
    [0]      -35.665112     -32.225487     -27.223042     -23.516903
    [4]      -22.192047     -26.078529     -26.610157     -16.940145
    [8]      -17.967775     -13.858789   0.0063937218      7.2713552
    [12]       11.943110      14.928812      16.587729      17.076450
    [16]       16.426092      14.540232      11.128640      5.4078312
    [20]      -3.8404095      2.2155499      6.8858037      7.9877696
    [24]       13.170031      21.599030      27.718122      31.938011
    [28]       34.716885      36.291645      36.773449      36.189777
    [32]       34.488415      31.498299      26.775982      18.880301
    [36]       1.8078036      12.950459      14.156399      14.710628
    [40]       20.262703      25.502420      29.200966      31.636602
    [44]       32.975731      33.265705      32.470421      30.460430
    [48]       26.928961      21.045868      9.0566206      8.6760139
    [52]       12.968819      11.638247      10.998677      17.769590
    [56]       23.302528      27.085249      29.551798      30.855127
    [60]       30.994680      29.845676      27.074411      21.763771
    [64]       12.010662      16.325493      19.750519      19.986961
    [68]       18.795475      18.726791      22.638597      27.928331
    [72]       32.472115      35.917416      38.286102      39.639252
    [76]       40.014591      39.409721      37.766434      34.942284
    [80]       30.700684      25.350548      23.193171      24.232986
    [84]       24.620964      26.297827      30.191935      33.974701
    [88]       36.847122      38.822784      39.983410      40.377716
    [92]       40.029705      38.956451      37.187016      34.785297
    [96]       31.867130      28.559444      24.839100      20.710070
    [100]       19.779999      23.910990      27.537855      29.857027
    [104]       31.033495      31.157562      30.217365      28.084784
    [108]       24.412279      18.172483      3.4697978      8.4742146
    [112]       11.050810      4.7897320      8.8102541      18.998177
    [116]       24.250576      27.573786      29.634958      30.626945
    [120]       30.567282      29.364498      26.804325      22.542612
    [124]       17.327724      17.023741      18.188086      16.766487
    [128]       11.383642      11.775128      19.697142      24.254372
    [132]       27.160759      28.986958      29.875238      29.808346
    [136]       28.687305      26.340830      22.578327      18.076904
    [140]       16.716915      17.353987      16.411201      13.392374
    [144]       12.804524      17.983324      22.168245      24.962915
    [148]       26.707382      27.518551      27.369514      26.129427
    [152]       23.524221      18.963598      11.759923      11.702963
    [156]       15.088939      15.717166      14.739985      15.162745
    [160]       19.164762      23.317802      26.424932      28.475664
    [164]       29.487822      29.380453      27.920902      24.501823
    [168]       16.783024      9.0517550      19.905750      22.819963
    [172]       23.505074      23.428247      23.875057      25.581738
    [176]       28.078695      30.648760      32.877201      34.543762
    [180]       35.518055      35.709385      35.034046      33.388523
    [184]       30.633617      26.691498      22.485338      21.113430
    [188]       21.234779      20.095694      18.340797      20.945545
    [192]       25.584593      29.084385      31.425465      32.813087
    [196]       33.372623      33.199093      32.429279      31.325748
    [200]       30.280268      29.531225      28.855326      27.761698
    [204]       25.717430      21.847281      12.493341      12.484268
    [208]       21.424973      24.839434      26.236488      26.353344
    [212]       25.514610      24.047464      22.437408      21.037914
    [216]       19.492662      16.825796      11.095390     -7.0557284
    [220]       12.176552      17.068552      19.246672      20.067646
    [224]       20.004618      19.256979      17.867517      15.851921
    [228]       13.558644      11.995755      11.366656      10.130305
    [232]       6.3037701     -9.9876966      5.5047731      12.129708
    [236]       15.413369      17.207115      18.062061      18.172153
    [240]       17.555439      16.164637      14.108974      12.166004
    [244]       11.514277      11.468456      10.447470      7.1649995
    [248]      -2.5245605      1.5812798      9.5119400      13.191466
    [252]       15.255943      16.361298      16.683617      16.198782
    [256]       14.821021      12.594583      10.214134      9.1233730
    [260]       8.8897514      7.6853414      4.3347092      1.6079462
    [264]       7.1954103      11.694427      14.427383      16.006208
    [268]       16.698816      16.566263      15.546582      13.555007
    [272]       10.867943      9.1494951      9.4708271      9.5967445
    [276]       7.9201288      3.3842809      3.2088554      9.9802170
    [280]       14.168641      16.713369      18.196465      18.835245
    [284]       18.669813      17.648165      15.733328      13.268145
    [288]       11.683455      11.730249      11.617423      9.9269638
    [292]       5.7633557      4.5763102      10.849328      15.058062
    [296]       17.640640      19.162312      19.829798      19.650019
    [300]       18.496777      16.172756      12.845082      11.165794
    [304]       12.734641      13.932942      13.830539      13.367334
    [308]       14.800826      17.895861      20.721087      22.713873
    [312]       23.840233      24.084169      23.335808      21.338844
    [316]       17.744055      14.397364      16.983809      19.896406
    [320]       21.173105      21.301548      21.146633      22.088636
    [324]       24.508337      27.284084      29.651180      31.370384
    [328]       32.350277      32.495655      31.640003      29.436907
    [332]       24.955416      13.298837      17.859959      24.390163
    [336]       26.500908      26.704903      25.727909      24.247782
    [340]       23.604931      24.726063      26.510658      27.900877
    [344]       28.565611      28.423365      27.464838      25.811031
    [348]       23.981066      22.912079      22.635035      22.051430
    [352]       20.238979      16.339460      11.001246      15.578262
    [356]       20.093805      22.414368      23.311693      23.124224
    [360]       22.035368      20.328917      18.751097      18.221247
    [364]       18.322399      17.882093      16.062281      11.702435
    [368]       1.3871338      10.188134      15.954389      18.762556
    [372]       20.090822      20.401850      19.889027      18.689756
    [376]       17.078562      15.708224      15.226144      15.205378
    [380]       14.685901      12.970717      9.2837801      2.7193182
    [384]       5.7692742      11.180614      13.988984      15.289099
    [388]       15.531828      14.908690      13.532940      11.662200
    [392]       10.179829      10.150630      10.801587      10.794638
    [396]       9.4876394      6.6213565      4.3813477      7.5889740
    [400]       11.141425      13.282850      14.262242      14.299299
    [404]       13.532482      12.137232      10.593276      9.8447924
    [408]       10.149400      10.484460      9.9603968      8.0620098
    [412]       4.2831526     0.74088323      4.6886587      8.4949818
    [416]       10.606293      11.518638      11.520230      10.806155
    [420]       9.6585445      8.6489954      8.4061394      8.7327547
    [424]       8.8312473      8.1163349      6.2070022      2.6975868
    [428]      -1.4186862     0.89053756      4.7171392      6.9187689
    [432]       7.8244395      7.7067103      6.7485914      5.2946682
    [436]       4.2964277      4.7204008      5.7716064      6.2452154
    [440]       5.5951400      3.5213358     0.18496694    -0.15231527
    [444]       3.6035869      6.4699936      7.9777479      8.3554173
    [448]       7.7419500      6.2734976      4.4793968      3.9129713
    [452]       5.1609039      6.5239391      6.9762106      6.2374268
    [456]       4.1922417      1.2690054      1.0476334      4.4029655
    [460]       7.3593636      9.1944838      9.9588785      9.6415405
    [464]       8.0920696      5.0079155      1.0544016      2.1680150
    [468]       5.4011145      6.9221964      6.8218546      5.4778237
    [472]       4.0208120      4.8196340      7.4306297      9.9366646
    [476]       11.790648      12.883986      13.137209      12.440155
    [480]       10.653296      7.9001637      6.3059416      8.1431017
    [484]       10.248756      11.247233      11.282845      10.869264
    [488]       10.767332      11.404504      12.420905      13.304622
    [492]       13.780397      13.711329      13.017393      11.718685
    [496]       10.169170      9.3436880      9.8108568      10.644740
    [500]       10.947974      10.399911      8.9142647      6.5568981
    [504]       4.0756803      3.6831088      5.4157343      7.1077909
    [508]       8.0282717      8.1163654      7.4769483      6.4722471
    [512]       5.9331822
  [Tag]         8321
  [frame_len]          320
[Record 53]
  [tot_power]       2178667.0
  [re_spec_val]
    [0]      -28.823668     -23.576904     -20.805290     -22.427370
    [4]      -28.785595     -28.731791     -28.550213     -17.818483
    [8]      -13.952411     -19.933317     -3.2519479      5.8740034
    [12]       11.447052      14.998279      17.071104      17.928499
    [16]       17.715448      16.496140      14.231501      10.686301
    [20]       5.0113254     -2.3859746      5.4131727      9.6095486
    [24]       9.6291304      12.870398      21.941875      28.210402
    [28]       32.381428      35.047302      36.480469      36.797253
    [32]       36.015438      34.061466      30.737864      25.635048
    [36]       18.165976      11.749824      10.471963      4.6486807
    [40]       3.7729628      14.044011      20.912811      25.959812
    [44]       29.470264      31.671730      32.719757      32.686016
    [48]       31.560785      29.244886      25.532480      20.213345
    [52]       14.431082      11.669181      8.1994543      1.4281774
    [56]       10.019347      16.703617      21.732306      25.562130
    [60]       28.213570      29.745659      30.204536      29.569895
    [64]       27.709988      24.305101      18.822533      13.458810
    [68]       14.511063      14.297995      12.933963      16.643572
    [72]       21.670044      25.916815      29.476700      32.215084
    [76]       34.006413      34.804276      34.582077      33.279716
    [80]       30.758953      26.777252      21.401173      17.951550
    [84]       17.811024      16.970907      18.413176      22.823309
    [88]       27.488611      32.035828      35.965752      38.920326
    [92]       40.809238      41.631710      41.375767      39.972733
    [96]       37.255630      32.920597      27.054819      24.257416
    [100]       24.783083      23.168440      19.267702      21.539562
    [104]       26.794058      30.360043      32.816734      34.485603
    [108]       35.428772      35.620720      35.030922      33.669689
    [112]       31.652325      29.268667      26.809170      23.996504
    [116]       19.900690      16.013252      19.648401      23.700258
    [120]       26.844318      29.649319      31.979761      33.560871
    [124]       34.259972      34.042099      32.920811      30.984783
    [128]       28.501724      25.899891      23.138649      19.013405
    [132]       11.615221      15.344925      20.742603      23.797762
    [136]       26.296404      28.647921      30.518091      31.602482
    [140]       31.782837      31.035593      29.403948      27.090044
    [144]       24.600578      22.356804      19.676722      14.721440
    [148]       9.3523645      16.489182      20.559175      22.664125
    [152]       24.045990      25.242464      26.186373      26.563852
    [156]       26.138233      24.822035      22.770411      20.648632
    [160]       19.217804      17.812050      15.028155      11.998473
    [164]       15.634327      19.768581      22.400902      24.238794
    [168]       25.718964      26.867479      27.490812      27.393990
    [172]       26.473431      24.843615      23.201908      22.585550
    [176]       22.503817      21.618950      19.468220      18.166140
    [180]       20.654949      23.530399      25.573040      27.141016
    [184]       28.443123      29.359421      29.676626      29.238731
    [188]       27.964087      25.957897      24.064615      23.800575
    [192]       24.471571      24.418320      23.292797      22.737055
    [196]       24.989557      27.920515      30.133783      31.676174
    [200]       32.719589      33.257790      33.132027      32.109722
    [204]       29.892687      26.155058      22.250669      23.622522
    [208]       25.957863      26.625473      25.865873      24.528320
    [212]       24.748793      27.134436      29.826902      32.090599
    [216]       33.859570      35.126667      35.874252      36.102673
    [220]       35.848320      35.183231      34.188667      32.891258
    [224]       31.181988      28.753164      24.958672      17.854483
    [228]       3.4274101      18.951412      23.223660      25.371786
    [232]       26.631557      27.333727      27.546635      27.330587
    [236]       26.815882      26.098526      25.034269      23.141132
    [240]       19.453457      10.554100      9.0646868      17.920471
    [244]       20.921993      21.988670      22.265690      22.462036
    [248]       22.787317      23.039776      23.082739      22.979879
    [252]       22.747190      22.129482      20.633705      17.474041
    [256]       10.425573      4.0462384      14.380033      18.044136
    [260]       19.667879      20.487778      21.110491      21.676651
    [264]       22.036819      22.097687      21.964800      21.806170
    [268]       21.566910      20.883947      19.222931      15.756920
    [272]       7.8160110      2.7709534      12.825099      16.170923
    [276]       17.672089      18.579315      19.348284      19.891888
    [280]       20.051397      19.968323      20.030888      20.324482
    [284]       20.346348      19.420116      16.765806      10.446157
    [288]       4.1593103      14.140765      18.024548      19.775290
    [292]       20.575724      21.014614      21.322870      21.510616
    [296]       21.653770      21.941462      22.341286      22.446373
    [300]       21.724195      19.556620      14.553921     -4.0908723
    [304]       13.315731      18.785215      21.222357      22.385851
    [308]       22.970020      23.306774      23.452139      23.411434
    [312]       23.413334      23.783487      24.380377      24.609884
    [316]       23.897987      21.684410      16.941938      11.028482
    [320]       17.318254      21.373827      23.237738      23.932640
    [324]       23.947796      23.441975      22.437830      21.677866
    [328]       22.926394      25.343836      27.049469      27.495310
    [332]       26.656635      25.022545      24.578209      26.320192
    [336]       28.151648      29.149557      29.357462      29.000433
    [340]       28.300695      27.404634      26.437223      25.858913
    [344]       26.504852      28.169331      29.727091      30.532368
    [348]       30.386513      29.266190      27.387384      25.699072
    [352]       25.565166      26.421925      27.090811      27.346472
    [356]       27.384428      27.361265      27.300432      27.317081
    [360]       27.732107      28.621492      29.509985      29.831484
    [364]       29.195417      27.230112      23.176289      13.778719
    [368]       12.480948      20.571735      23.234001      24.069504
    [372]       24.054207      23.786676      23.818520      24.463104
    [376]       25.401697      25.985558      25.690998      24.057619
    [380]       20.232676      10.527542      12.061344      19.511965
    [384]       22.137381      22.872210      22.585253      21.877544
    [388]       21.341379      21.396698      22.023857      22.816319
    [392]       23.280306      23.005041      21.603779      18.458733
    [396]       11.990569      9.0724230      16.043545      19.112871
    [400]       20.176533      20.069735      19.331772      18.539194
    [404]       18.266506      18.760958      19.745724      20.664274
    [408]       21.021055      20.446301      18.537773      14.436492
    [412]       4.1835365      6.1106606      13.345884      15.768158
    [416]       16.290075      15.771503      14.853355      14.255993
    [420]       14.529621      15.557040      16.699242      17.356787
    [424]       17.128918      15.654027      12.266781      4.4472013
    [428]      -2.2189898      8.7532892      11.976876      12.928566
    [432]       12.696835      11.940097      11.348708      11.510389
    [436]       12.470181      13.725764      14.695359      14.961168
    [440]       14.195947      11.942749      6.9732404     -11.076724
    [444]       3.9326506      9.3974009      11.377663      11.751617
    [448]       11.235541      10.456383      10.094258      10.547997
    [452]       11.609193      12.715399      13.350423      13.136327
    [456]       11.698777      8.3330040     0.43042484     -3.2913492
    [460]       5.9354992      8.9936943      9.8378172      9.4488945
    [464]       8.5484838      8.0648651      8.6492233      10.002256
    [468]       11.456755      12.523358      12.872198      12.200475
    [472]       10.031444      5.0885839     -6.2735085      4.1758137
    [476]       8.9459543      10.673313      10.761231      9.9172850
    [480]       9.1420927      9.6374989      11.307954      13.167234
    [484]       14.615820      15.393354      15.345258      14.290460
    [488]       11.875042      7.3479710      2.7229147      7.4743700
    [492]       10.989310      12.315974      12.135221      10.972929
    [496]       9.8824968      10.383835      12.149185      13.839590
    [500]       14.859162      14.986270      14.022238      11.598668
    [504]       6.6928458     -5.0965152      2.2713861      7.4492846
    [508]       9.1184597      8.9914618      7.6315498      5.6221352
    [512]       4.4720778
  [Tag]         8481
  [frame_len]          320
[Record 54]
  [tot_power]       2113167.5
  [re_spec_val]
    [0]      -39.853352     -26.029226     -23.375584     -27.653124
    [4]      -33.109169     -26.331163     -33.866848     -16.585445
    [8]      -11.004760     -12.970194     -11.191012      2.5215631
    [12]       9.5405159      14.085141      17.071718      18.837965
    [16]       19.506866      19.073555      17.417730      14.290976
    [20]       9.4164581      3.4785106     -1.9792832     -1.3499051
    [24]       5.3225007      7.6894073      14.418242      22.705038
    [28]       28.593569      32.632980      35.263382      36.710487
    [32]       37.078434      36.391903      34.607700      31.603695
    [36]       27.135481      20.710115      11.266004      4.4464521
    [40]       8.2121859      9.5270948      10.535729      16.213223
    [44]       22.267548      26.695877      29.719360      31.558519
    [48]       32.319847      32.034557      30.678045      28.172798
    [52]       24.384115      19.123173      12.173707      3.9081116
    [56]       3.6486096      6.5612993      5.6472092      8.6257811
    [60]       17.309752      23.137953      26.951998      29.310408
    [64]       30.450699      30.466099      29.371578      27.137720
    [68]       23.746166      19.344374      14.400807      9.1098700
    [72]       6.0683193      9.3902063      13.103827      18.238821
    [76]       23.659895      27.983330      31.065420      33.008518
    [80]       33.890457      33.742592      32.564999      30.357342
    [84]       27.175707      23.118504      17.575867      2.4904499
    [88]       14.299025      20.698036      23.196016      24.888987
    [92]       28.743967      33.516430      37.309509      39.866882
    [96]       41.277405      41.614185      40.895000      39.088173
    [100]       36.150063      32.208607      28.091129      24.773912
    [104]       20.662378      13.820764      17.251762      21.628410
    [108]       25.114702      29.160679      32.695477      35.133545
    [112]       36.456783      36.742638      36.047192      34.405899
    [116]       31.868336      28.522148      24.329502      18.491508
    [120]       11.850885      16.792980      19.733299      20.653379
    [124]       22.904005      26.919142      30.374405      32.694908
    [128]       33.948895      34.228943      33.587170      32.057507
    [132]       29.682636      26.496504      22.365438      16.913927
    [136]       13.603409      16.350519      17.999168      19.188236
    [140]       22.239901      25.944130      28.863743      30.802692
    [144]       31.819647      31.948900      31.183424      29.499294
    [148]       26.892977      23.436657      19.336386      15.276921
    [152]       13.967020      15.508934      16.318529      15.429888
    [156]       14.016563      16.281183      20.234293      23.150076
    [160]       24.911325      25.659594      25.478815      24.445856
    [164]       22.699657      20.431416      17.633766      13.832296
    [168]       10.031734      12.382907      15.758055      17.850426
    [172]       19.594112      21.642563      23.794668      25.584747
    [176]       26.746061      27.172726      26.838354      25.780634
    [180]       24.093939      21.804613      18.490543      12.355937
    [184]       1.9646622      13.480000      17.293598      18.528652
    [188]       19.386347      21.573957      24.373335      26.599695
    [192]       27.927671      28.337397      27.865017      26.612196
    [196]       24.848198      22.986053      21.102753      18.778074
    [200]       16.752707      17.856243      20.135160      21.440531
    [204]       21.967113      22.631031      24.021683      25.658733
    [208]       26.858788      27.278961      26.802940      25.557138
    [212]       24.223761      23.719357      23.453043      21.858295
    [216]       16.839041     -1.6399195      18.688051      23.798326
    [220]       26.423889      28.289188      30.092609      31.860327
    [224]       33.283833      34.093639      34.147449      33.411751
    [228]       31.993561      30.214031      28.430113      26.394646
    [232]       23.016663      16.576912      16.361822      21.755102
    [236]       23.977242      24.892565      26.221647      28.365433
    [240]       30.369400      31.668024      32.179230      31.977354
    [244]       31.175585      29.869719      28.056572      25.607162
    [248]       22.705151      21.359215      22.618618      23.684710
    [252]       23.428564      22.134979      21.562620      23.175987
    [256]       25.166367      26.411095      26.884459      26.788746
    [260]       26.309835      25.495419      24.185633      22.132490
    [264]       19.638935      18.952553      20.546036      21.780861
    [268]       21.947996      21.547012      21.632717      22.616201
    [272]       23.771969      24.552444      24.880665      24.850092
    [276]       24.523039      23.801945      22.370838      19.679127
    [280]       15.039341      12.244534      16.069145      18.225931
    [284]       18.344015      17.509533      17.841791      19.815063
    [288]       21.687819      22.829815      23.334335      23.412939
    [292]       23.190857      22.558584      21.092091      17.971476
    [296]       12.080573      13.421776      18.662273      20.921309
    [300]       21.279270      20.711758      20.779320      22.180483
    [304]       23.742039      24.754211      25.232908      25.385752
    [308]       25.313475      24.853346      23.594679      20.950207
    [312]       16.891247      17.631140      21.687983      23.945005
    [316]       24.639120      24.373636      23.988586      24.302629
    [320]       25.196365      26.069521      26.686903      27.093365
    [324]       27.311464      27.174248      26.329035      24.248161
    [328]       20.063108      15.087792      19.724649      23.441843
    [332]       24.903765      24.993258      24.538313      24.502565
    [336]       25.171206      25.987951      26.578192      26.935774
    [340]       27.088728      26.861389      25.849850      23.433626
    [344]       18.929060      17.946899      22.767014      25.414631
    [348]       26.044441      25.131790      23.368505      22.584023
    [352]       23.674097      25.023279      25.940746      26.560345
    [356]       26.930187      26.765146      25.529095      22.233669
    [360]       13.810173      18.000099      24.902428      28.000004
    [364]       29.284100      29.499739      29.263563      29.195288
    [368]       29.499470      29.886530      30.127983      30.291742
    [372]       30.528753      30.758696      30.631302      29.696640
    [376]       27.398857      22.729118      16.866184      22.558725
    [380]       26.382126      27.860420      27.970417      27.387056
    [384]       26.825077      26.745068      27.009861      27.305506
    [388]       27.457247      27.299597      26.555161      24.800999
    [392]       21.340036      15.803089      17.904421      22.518007
    [396]       24.682800      25.147821      24.413841      23.092710
    [400]       22.275484      22.635555      23.527153      24.300865
    [404]       24.733133      24.665728      23.856232      21.945047
    [408]       18.430054      14.457083      17.098543      20.613441
    [412]       22.258158      22.405659      21.392080      19.697510
    [416]       18.395458      18.502127      19.481916      20.496321
    [420]       21.208670      21.421421      20.913391      19.409086
    [424]       16.536777      12.433082      12.273726      15.688597
    [428]       17.672031      18.093718      17.277964      15.634916
    [432]       14.084453      13.856755      14.795043      15.918893
    [436]       16.713001      16.925400      16.326475      14.599972
    [440]       11.200546      6.3521452      8.5234003      12.726671
    [444]       14.801052      15.264617      14.514114      13.007746
    [448]       11.726757      11.781087      12.848025      14.021686
    [452]       14.854637      15.109474      14.560575      12.916036
    [456]       9.7629099      5.7872925      7.4666495      11.047297
    [460]       12.867281      13.139380      12.152093      10.252698
    [464]       8.3685942      8.0352783      9.2593660      10.855679
    [468]       12.149271      12.788633      12.494834      10.917761
    [472]       7.4273176      2.6922481      6.4911752      10.850357
    [476]       13.001789      13.605672      13.049129      11.693868
    [480]       10.206961      9.6655741      10.570890      12.185922
    [484]       13.614811      14.331234      14.005342      12.228827
    [488]       7.9321914     -6.3857360      4.0553274      10.503911
    [492]       13.064288      13.835648      13.418810      12.195116
    [496]       10.682797      9.6696396      9.7980499      10.855111
    [500]       12.031631      12.648676      12.301330      10.672493
    [504]       7.3425150      2.5492780      3.2724030      6.9685669
    [508]       8.9831314      9.7071877      9.6275415      9.2057438
    [512]       8.9701319
  [Tag]         8641
  [frame_len]          320
[Record 55]
  [tot_power]       2129624.5
  [re_spec_val]
    [0]      -27.331682     -26.012589     -24.100058     -24.325586
    [4]      -29.957111     -32.155228     -27.152071     -36.745953
    [8]      -16.310123     -11.644045     -15.934135     -3.4244368
    [12]       6.5059347      12.544994      16.487698      18.920156
    [16]       20.091957      20.112968      19.015121      16.754475
    [20]       13.097340      7.0295844     -9.8430042     0.46234140
    [24]       4.8916965      7.3081884      11.471476      15.725677
    [28]       19.829191      24.161177      28.156441      31.273912
    [32]       33.354290      34.390419      34.386932      33.306911
    [36]       31.033981      27.303528      21.551662      13.422686
    [40]       11.287658      11.542591      8.2824717      2.7913074
    [44]      -1.3677146      10.954390      19.410788      24.744555
    [48]       28.205791      30.301027      31.258694      31.168564
    [52]       30.025118      27.728827      24.062647      18.745935
    [56]       12.623624      9.2339211      3.6012847      3.3651111
    [60]       12.463699      16.150984      18.560543      21.781475
    [64]       25.362106      28.200619      29.990961      30.739765
    [68]       30.479149      29.189964      26.761944      22.948271
    [72]       17.574190      13.501030      13.802223      12.307558
    [76]       4.7064013      8.3655691      16.493559      21.031952
    [80]       24.617207      27.669645      30.022177      31.529751
    [84]       32.137718      31.811243      30.481024      28.031237
    [88]       24.519310      21.483891      21.098763      20.570093
    [92]       17.986835      19.034584      24.733898      29.162382
    [96]       32.862926      36.216953      39.020065      41.033203
    [100]       42.153896      42.357468      41.643593      40.021103
    [104]       37.524727      34.285053      30.737169      27.865147
    [108]       26.147739      24.186020      19.862881      15.832860
    [112]       23.224508      27.895264      30.865538      33.060390
    [116]       34.655937      35.542538      35.597443      34.742863
    [120]       32.926128      30.138357      26.639959      23.536953
    [124]       21.729450      19.541161      14.818786      14.028938
    [128]       20.375023      24.253077      26.885651      29.086636
    [132]       30.963745      32.300602      32.901386      32.659286
    [136]       31.516630      29.461384      26.672255      23.926773
    [140]       22.177225      20.464375      16.392664     -1.0606798
    [144]       14.830370      20.901012      23.628422      25.284363
    [148]       26.852468      28.457657      29.695988      30.237402
    [152]       29.944489      28.793900      26.882193      24.578587
    [156]       22.554712      20.900486      18.469891      13.008865
    [160]      -8.7422333      13.919938      18.689865      20.772167
    [164]       21.978621      23.224440      24.612995      25.729872
    [168]       26.263454      26.121971      25.352955      24.137129
    [172]       22.830605      21.784687      20.837420      19.238791
    [176]       15.886190      9.2447758      11.789327      17.630363
    [180]       20.731258      22.681709      24.229059      25.525108
    [184]       26.388008      26.610792      26.071093      24.749426
    [188]       22.871223      21.215477      20.492294      19.821716
    [192]       17.652649      12.351398      12.241467      18.755926
    [196]       22.118364      23.772665      24.678429      25.475410
    [200]       26.310822      26.903568      26.965096      26.402817
    [204]       25.368454      24.314938      23.698481      23.248150
    [208]       22.083172      19.110449      12.038146      12.179365
    [212]       19.396667      22.561686      23.968973      24.658161
    [216]       25.339743      26.215738      26.989775      27.330854
    [220]       27.107861      26.460617      25.929279      26.081896
    [224]       26.522276      26.280895      24.584995      21.195627
    [228]       21.158672      25.692593      28.899269      30.802895
    [232]       31.979492      32.792625      33.351669      33.584057
    [236]       33.371277      32.636761      31.429453      30.127172
    [240]       29.464231      29.506205      29.267744      27.811211
    [244]       24.606653      22.339392      25.871050      28.992708
    [248]       30.563839      31.147001      31.262287      31.234236
    [252]       31.077600      30.627838      29.807472      28.811327
    [256]       28.083437      27.779881      27.350164      25.973394
    [260]       22.623230      13.997491      13.420074      21.963570
    [264]       25.086803      26.286146      26.568539      26.544752
    [268]       26.528027      26.471405      26.210579      25.755026
    [272]       25.346567      25.183636      25.028873      24.291412
    [276]       22.230251      17.381207     0.91868478      16.448980
    [280]       21.872551      24.177303      25.023922      25.095728
    [284]       24.891859      24.722231      24.579578      24.316448
    [288]       23.974657      23.844522      24.028852      24.075039
    [292]       23.285727      20.855333      15.089625      11.043535
    [296]       19.355957      23.200426      24.921787      25.472765
    [300]       25.410969      25.191284      25.028130      24.771055
    [304]       24.179716      23.356150      22.947086      23.299463
    [308]       23.590742      22.786381      19.890791      12.759272
    [312]       14.669378      21.414345      24.517416      25.862490
    [316]       26.185621      25.946886      25.504725      25.033154
    [320]       24.505238      24.009777      24.071711      24.992174
    [324]       26.042824      26.328072      25.233948      21.964268
    [328]       15.378115      18.859642      24.327160      26.958685
    [332]       28.034615      28.176676      27.826353      27.366940
    [336]       27.008114      26.716003      26.484365      26.620811
    [340]       27.355381      28.221176      28.482496      27.574326
    [344]       24.916328      20.142818      20.866522      25.694584
    [348]       28.379915      29.480045      29.493034      28.757620
    [352]       27.604441      26.351038      25.197266      24.422955
    [356]       24.641285      25.765924      26.726416      26.712994
    [360]       25.269457      21.985743      18.492468      21.427105
    [364]       24.857691      26.586008      27.029074      26.502695
    [368]       25.225075      23.394381      21.228090      19.543039
    [372]       20.617157      23.590176      25.941261      27.018763
    [376]       26.730135      25.064671      22.712198      22.787556
    [380]       25.254444      27.188828      28.119713      28.262928
    [384]       27.864620      27.132099      26.215075      25.185829
    [388]       24.120855      23.413956      23.777641      25.033945
    [392]       26.146599      26.427425      25.547054      23.242476
    [396]       19.676886      18.852940      21.969353      24.257040
    [400]       25.203323      25.062571      24.015558      22.208260
    [404]       19.885609      17.730022      17.300415      19.011505
    [408]       21.035259      22.236963      22.269743      20.954195
    [412]       18.225805      15.725171      17.417702      20.052858
    [416]       21.470261      21.710129      20.955288      19.341732
    [420]       17.078993      14.825189      14.125211      15.533459
    [424]       17.464556      18.799025      19.128531      18.198441
    [428]       15.609852      10.699605      8.2927761      13.176240
    [432]       16.104967      17.230389      17.106071      16.017958
    [436]       14.216690      12.168451      10.818584      11.155476
    [440]       12.826084      14.625926      15.787846      15.972005
    [444]       14.943933      12.340305      7.6494160      5.4689493
    [448]       9.9830151      12.857935      13.962039      13.740108
    [452]       12.398532      10.158338      7.7938056      7.0446033
    [456]       8.2705326      10.051527      11.528715      12.289130
    [460]       12.045913      10.522117      7.4958949      4.8949361
    [464]       7.5703101      10.785000      12.556178      13.089209
    [468]       12.608327      11.331702      9.7290564      8.7995129
    [472]       9.3006449      10.654989      12.007983      12.888981
    [476]       13.025954      12.193713      10.123206      6.6371613
    [480]       4.4345837      7.5941176      10.657965      12.270131
    [484]       12.634717      11.878835      10.070485      7.5647569
    [488]       6.0118289      7.0587878      9.0139351      10.561619
    [492]       11.412382      11.442815      10.511495      8.4222193
    [496]       4.9698777      1.4726614      3.0821507      6.1616607
    [500]       7.9142141      8.3454237      7.5302658      5.4098077
    [504]       1.8522530     -2.8370185     -5.2371378     -3.3970003
    [508]      -1.2648243   -0.024577126    0.035857920    -0.93260556
    [512]      -1.6903158
  [Tag]         8801
  [frame_len]          320
[Record 56]
  [tot_power]       2076779.8
  [re_spec_val]
    [0]      -29.229630     -34.101463     -29.820486     -24.791683
    [4]      -27.799068     -34.760651     -22.376087     -23.315525
    [8]      -24.144020     -12.470215     -9.4962358     -10.669038
    [12]      0.23559092      8.5375433      13.961748      17.598734
    [16]       19.882311      20.992392      20.976315      19.779615
    [20]       17.228704      12.944642      6.0383496     -6.5885296
    [24]      -19.403059     -8.8843498    -0.24978553      3.9287503
    [28]       4.0557137      3.4165757      14.613274      22.150372
    [32]       27.114300      30.401770      32.380859      33.217022
    [36]       32.971184      31.628454      29.092295      25.130508
    [40]       19.152039      8.8161621     0.55081797      8.3139668
    [44]       9.3864346      8.9568806      8.4332333      6.1600509
    [48]       10.261446      19.027977      24.558691      27.985205
    [52]       29.886715      30.515844      29.969448      28.242794
    [56]       25.234430      20.720589      14.493285      9.4645748
    [60]       10.729420      12.301296      13.140495      13.455881
    [64]       12.941126      13.345622      18.519613      23.799978
    [68]       27.455265      29.675810      30.666111      30.529528
    [72]       29.296663      26.955841      23.501265      19.006437
    [76]       13.456999      5.3014460    0.094857708      7.0388637
    [80]       9.1068192      11.269115      15.969434      21.050003
    [84]       25.462811      28.981487      31.517773      33.049446
    [88]       33.584774      33.147800      31.799623      29.690912
    [92]       27.048409      23.848948      19.271526      11.459191
    [96]       11.683818      17.744940      21.966747      25.452490
    [100]       28.738138      32.470158      36.303139      39.497513
    [104]       41.730015      42.944973      43.154972      42.373459
    [108]       40.611141      37.915451      34.448917      30.435606
    [112]       25.466003      16.547892      12.513633      19.829403
    [116]       20.063038      14.556437      13.702162      23.176268
    [120]       27.796804      30.615582      32.351791      33.162971
    [124]       33.060478      32.046112      30.163982      27.512701
    [128]       24.125254      19.572889      12.628699      10.247057
    [132]       14.100986      14.703861      14.157757      16.573246
    [136]       20.880289      24.835894      28.041695      30.355862
    [140]       31.712988      32.106441      31.551140      30.058313
    [144]       27.606602      24.064718      19.072573      13.548462
    [148]       14.456221      16.073051      14.498424      7.5205359
    [152]       11.071958      18.379761      22.187531      24.770329
    [156]       26.829082      28.392570      29.297647      29.438416
    [160]       28.791107      27.372898      25.180441      22.084608
    [164]       17.725891      12.271636      10.673145      11.018788
    [168]       6.5886111      1.5157003      14.318820      19.442923
    [172]       22.418341      24.446911      25.919250      26.851992
    [176]       27.154728      26.786991      25.793451      24.249054
    [180]       22.092144      18.877047      13.494527      7.3904681
    [184]       11.801847      13.758990      12.195746      9.0633469
    [188]       13.966123      19.164564      22.601280      24.995668
    [192]       26.631254      27.563438      27.800278      27.366791
    [196]       26.286314      24.499304      21.743519      17.474411
    [200]       12.117473      12.579900      14.493651      14.199941
    [204]       14.077529      16.921782      19.979073      22.146048
    [208]       23.861904      25.446402      26.769232      27.570356
    [212]       27.715380      27.176901      25.917629      23.755766
    [216]       20.308174      16.070696      16.326023      18.379259
    [220]       17.945513      14.265753      14.760565      21.164223
    [224]       25.112230      27.576200      29.279848      30.490801
    [228]       31.229048      31.488317      31.340328      30.854069
    [232]       29.897032      28.005018      24.232225      16.108910
    [236]       16.079651      21.847612      23.073225      22.447809
    [240]       24.024666      27.893147      31.004364      33.007317
    [244]       34.139996      34.595669      34.500519      33.954475
    [248]       33.041733      31.764170      29.921717      27.005650
    [252]       21.934141      13.229739      17.217045      20.551744
    [256]       20.601778      19.877588      21.852245      24.848846
    [260]       26.919939      28.113317      28.783346      29.162329
    [264]       29.305063      29.178329      28.723343      27.803722
    [268]       26.123398      23.175367      18.339285      14.812589
    [272]       17.493685      18.462297      16.529966      14.328942
    [276]       18.662306      22.654907      24.905836      26.059427
    [280]       26.590973      26.788383      26.774002      26.543398
    [284]       25.985313      24.866671      22.830896      19.516544
    [288]       15.996985      16.631321      18.225168      17.788248
    [292]       15.573803      16.539448      20.888699      24.032747
    [296]       25.896584      26.932356      27.478325      27.741335
    [300]       27.792112      27.560810      26.835314      25.253416
    [304]       22.216742      16.630413      12.362833      17.135584
    [308]       18.860329      17.480024      13.904160      16.255142
    [312]       20.907740      23.607866      25.035486      25.813042
    [316]       26.349377      26.826054      27.196331      27.237894
    [320]       26.617304      24.910381      21.571430      17.011711
    [324]       17.890530      20.612713      21.048990      19.721300
    [328]       19.742626      22.924002      25.784019      27.503389
    [332]       28.390354      28.821571      29.088072      29.301270
    [336]       29.347719      28.937176      27.663528      24.959766
    [340]       20.052019      17.030796      21.050901      22.876669
    [344]       22.213762      20.582575      22.488829      26.095074
    [348]       28.567522      29.959455      30.664959      31.016523
    [352]       31.219528      31.302647      31.117601      30.388815
    [356]       28.750479      25.728216      21.123638      19.533255
    [360]       22.177406      23.041027      21.600452      19.054430
    [364]       20.753317      24.363411      26.657116      27.836338
    [368]       28.353764      28.554914      28.620228      28.521732
    [372]       28.051905      26.900347      24.713820      21.318449
    [376]       18.536379      19.524931      20.582485      19.620338
    [380]       16.301207      14.335250      18.501829      21.618696
    [384]       23.166462      23.800453      24.000086      24.035288
    [388]       23.932720      23.496166      22.362411      20.017847
    [392]       15.939894      13.395766      16.833221      19.108261
    [396]       19.387753      18.474842      18.386126      20.266922
    [400]       22.258375      23.438763      23.868692      23.829895
    [404]       23.618807      23.425491      23.229279      22.798029
    [408]       21.772921      19.712091      16.080040      11.594653
    [412]       12.817595      15.447285      15.971516      14.686238
    [416]       13.081304      14.231659      16.621868      18.179388
    [420]       18.831434      18.910046      18.730532      18.465990
    [424]       18.089722      17.382780      15.951364      13.150323
    [428]       7.6195135      1.1743729      7.9553785      10.898777
    [432]       10.910956      8.6667004      6.2688227      8.9539871
    [436]       12.330448      14.393224      15.517593      16.069258
    [440]       16.246454      16.101887      15.558525      14.402730
    [444]       12.260724      8.6049652      4.3422217      6.0639429
    [448]       8.8736172      9.6023712      8.4577217      6.2316771
    [452]       6.1017919      8.5741816      10.613027      11.720313
    [456]       12.191550      12.320065      12.272544      12.060221
    [460]       11.528319      10.359996      8.0905628      4.2734694
    [464]       1.4622147      4.2321568      6.3806996      6.4173074
    [468]       4.4579153      1.6143461      2.8142834      6.1010303
    [472]       8.3758926      9.7956400      10.698858      11.198776
    [476]       11.266867      10.819500      9.6940022      7.5423555
    [480]       3.6769414     -1.7064317     0.81012797      4.5117121
    [484]       5.7622395      5.2549896      4.0351262      4.2176189
    [488]       6.0471072      7.8414044      9.1482458      10.100439
    [492]       10.762039      11.048679      10.826767      9.9527569
    [496]       8.2129030      5.1681561    -0.25948837     -7.3958468
    [500]      -1.4951657      1.8800092      2.5684543      1.3860335
    [504]      -1.1387970     -2.6387560    -0.59391403      1.9881996
    [508]       3.8088834      4.9501967      5.5901299      5.8834438
    [512]       5.9621964
  [Tag]         8961
  [frame_len]          320
[Record 57]
  [tot_power]       2149706.8
  [re_spec_val]
    [0]      -29.997688     -29.644335     -32.257427     -35.737003
    [4]      -31.173233     -36.899971     -23.692030     -17.989017
    [8]      -18.825958     -20.636391     -11.311748     -9.5118732
    [12]      -13.575949      2.0566876      10.188128      15.303131
    [16]       18.628742      20.613894      21.454184      21.218111
    [20]       19.877289      17.290125      13.125681      6.6363959
    [24]      -3.8798389     -12.879414     -3.2559390      5.3117175
    [28]       9.9397287      11.451210      8.2434235      5.4833794
    [32]       19.116375      25.598211      29.553431      31.928740
    [36]       33.054062      33.051460      31.932173      29.614605
    [40]       25.898508      20.376013      12.223149      1.6145236
    [44]     -0.27591673     0.51445043      2.1969948      2.7045155
    [48]       2.4678864      9.1600266      17.176954      22.884808
    [52]       26.796833      29.309107      30.635139      30.877800
    [56]       30.063459      28.155653      25.065224      20.697462
    [60]       15.154910      8.8437538    -0.98428804    -0.49404463
    [64]       7.9723444      11.181511      12.389017      12.875844
    [68]       15.435830      20.215485      24.419315      27.363827
    [72]       29.103239      29.720688      29.232958      27.573833
    [76]       24.566338      19.861732      12.939578      5.0858965
    [80]       1.8868164      3.3977776      8.3955183      11.240148
    [84]       11.957774      10.875082      13.634567      20.955936
    [88]       26.493187      30.265690      32.665588      33.897785
    [92]       34.050320      33.140072      31.151333      28.125059
    [96]       24.401306      20.820791      18.039305      16.698223
    [100]       16.959940      17.273558      18.400753      22.057413
    [104]       27.259706      32.558628      37.044659      40.428455
    [108]       42.708858      43.943768      44.175938      43.414288
    [112]       41.629349      38.756786      34.735439      29.684072
    [116]       24.209385      18.174063      8.3586884      15.354656
    [120]       19.322863      19.247816      14.990045      12.261024
    [124]       21.976198      27.292524      30.508991      32.367168
    [128]       33.091717      32.744267      31.328629      28.861837
    [132]       25.517628      21.803459      17.965696      12.366680
    [136]      -4.1593695      8.6063232      13.428391      15.796960
    [140]       18.156406      20.878119      23.863985      26.840809
    [144]       29.344704      31.051134      31.824398      31.614677
    [148]       30.393993      28.150803      24.952328      21.067503
    [152]       16.805187      11.641889      5.8093977      6.7984324
    [156]       6.8292170     0.48002785      7.5634518      15.525828
    [160]       20.641693      24.575821      27.579056      29.626823
    [164]       30.700352      30.801743      29.939775      28.145878
    [168]       25.541489      22.420349      19.029394      14.849671
    [172]       8.5564470      5.5940437      8.1862011      6.2773199
    [176]     -0.36093026      10.851943      17.409866      21.749453
    [180]       24.924116      27.130981      28.383162      28.673727
    [184]       28.005533      26.422380      24.096651      21.403446
    [188]       18.532711      14.584038      6.2296863      2.3901613
    [192]       10.824938      12.839157      13.174361      14.391551
    [196]       17.024864      20.194477      23.348562      25.979092
    [200]       27.767529      28.617495      28.549421      27.646196
    [204]       26.031126      23.779402      20.668312      15.714331
    [208]       4.6445031      5.6191692      11.210891      10.984542
    [212]       8.3138571      12.060972      18.680569      23.893648
    [216]       27.815313      30.555626      32.189480      32.777870
    [220]       32.372334      31.040770      28.911215      26.139437
    [224]       22.532541      16.508167     -2.8600531      14.438995
    [228]       17.610390      16.021328      14.846476      22.070862
    [232]       27.147774      30.279747      32.214859      33.291241
    [236]       33.634506      33.253098      32.100746      30.154772
    [240]       27.615229      25.257446      23.802851      22.332209
    [244]       19.324415      14.069561      14.371265      18.098122
    [248]       19.420105      19.506348      20.345961      22.584929
    [252]       24.960411      26.832319      28.107557      28.761374
    [256]       28.765196      28.130795      26.959215      25.443211
    [260]       23.713465      21.549225      18.211121      11.845373
    [264]      -12.380891      10.934605      15.337952      17.637754
    [268]       19.641699      21.657288      23.485155      24.997658
    [272]       26.134254      26.802927      26.892838      26.331877
    [276]       25.139114      23.465656      21.527426      19.267700
    [280]       15.978368      9.9151134      2.9489021      10.032945
    [284]       12.162224      10.673841      8.0287008      13.288998
    [288]       18.523344      21.954798      24.212845      25.560877
    [292]       26.061174      25.723379      24.619837      23.024458
    [296]       21.404074      19.790173      17.211323      11.736128
    [300]       7.7503986      14.886168      17.892155      18.369993
    [304]       17.507429      17.531406      19.851099      22.531954
    [308]       24.615454      26.061935      26.910427      27.177135
    [312]       26.921949      26.283110      25.384483      24.112717
    [316]       21.962713      17.832476      7.2592354      9.1979990
    [320]       16.424419      18.443632      18.599571      18.770805
    [324]       20.439423      22.834152      24.957848      26.553453
    [328]       27.561102      27.939934      27.701515      26.961733
    [332]       25.912069      24.597630      22.632685      19.056948
    [336]       11.233677      7.2787533      15.284213      17.356855
    [340]       17.724239      19.520872      22.873140      25.885258
    [344]       28.143192      29.725590      30.680315      31.016743
    [348]       30.796932      30.197372      29.417147      28.371214
    [352]       26.485830      22.560497      11.974627      15.072302
    [356]       21.863012      23.484385      22.685560      21.794424
    [360]       24.310644      27.608995      29.860559      31.131546
    [364]       31.662113      31.631908      31.192148      30.525753
    [368]       29.826910      29.116415      28.089731      26.193829
    [372]       22.573212      14.722941      6.2954364      17.351650
    [376]       19.818869      19.777987      19.211258      20.228701
    [380]       22.270523      23.877447      24.726255      24.899368
    [384]       24.531839      23.783470      22.851570      21.863682
    [388]       20.669973      18.795603      15.474058      9.1993980
    [392]       3.6658523      10.091705      12.726819      13.590808
    [396]       14.519131      16.154942      17.775049      18.867262
    [400]       19.409344      19.548172      19.461885      19.340483
    [404]       19.300032      19.193508      18.591669      16.910473
    [408]       13.231080      4.7535620      4.5645747      11.348373
    [412]       13.323153      13.125465      12.371303      13.281011
    [416]       15.406036      17.097988      17.997578      18.232353
    [420]       17.991304      17.454845      16.791368      16.102369
    [424]       15.291181      13.998979      11.624646      7.0155849
    [428]      -4.8213005     0.46449894      6.1553144      7.4628735
    [432]       6.8624001      6.4824209      8.2485609      10.547096
    [436]       12.114814      12.879978      13.019484      12.745173
    [440]       12.307760      11.925142      11.562951      10.865996
    [444]       9.3443384      6.4689622      1.8642833    -0.82403916
    [448]       1.7590264      3.2221062      3.3125410      3.7043066
    [452]       5.3954368      7.2758527      8.5420389      9.1524019
    [456]       9.3062391      9.2514734      9.1981831      9.1919184
    [460]       9.0246277      8.3015070      6.5060453      2.7679203
    [464]      -5.4397678     -5.1262279      1.3351433      3.4788742
    [468]       3.6495948      3.3198669      4.1903257      6.0308986
    [472]       7.5621395      8.3803444      8.5675497      8.3465528
    [476]       7.9995599      7.7750654      7.6942687      7.4759402
    [480]       6.6937127      4.8663197      1.2242993     -6.6931047
    [484]      -10.130578     -1.5651240      1.6264402      3.1137755
    [488]       4.0461068      4.8590250      5.4667001      5.6148686
    [492]       5.1609144      4.1668577      3.0016069      2.2998855
    [496]       2.2714663      2.3628242      2.0107388     0.98268533
    [500]     -0.73590714     -3.0415885     -5.7495999     -8.2094717
    [504]      -8.3248043     -6.0872488     -3.9622657     -2.7254250
    [508]      -2.3355088     -2.5873342     -3.1970971     -3.8057656
    [512]      -4.0607624
  [Tag]         9121
  [frame_len]          320
[Record 58]
  [tot_power]       2336408.8
  [re_spec_val]
    [0]      -33.939095     -29.393702     -29.497852     -41.574669
    [4]      -27.757246     -25.409130     -35.274441     -24.347126
    [8]      -20.176176     -28.333347     -15.355638     -9.5427303
    [12]      -14.435295     -3.8513844      7.4441481      13.845133
    [16]       17.982643      20.574474      21.919512      22.154593
    [20]       21.323229      19.381882      16.150698      11.131912
    [24]       2.7071030     -18.731577     -9.7087049     -6.6223626
    [28]       6.2952037      12.200271      14.899739      14.409692
    [32]       6.0105658      14.101899      23.520832      28.364948
    [36]       31.142849      32.485035      32.616280      31.596554
    [40]       29.376543      25.791693      20.510063      12.951864
    [44]       2.7976813     -3.5798678     0.64306515      3.3240857
    [48]       3.5668092      5.1535497      7.2596083      9.7789307
    [52]       15.907166      21.604940      25.545506      27.981470
    [56]       29.148369      29.165010      28.057606      25.771269
    [60]       22.172113      17.113560      11.118148      7.4311399
    [64]       7.1095400      7.7320399      7.7443023      5.6598907
    [68]      -1.7829518      1.2737982      12.202415      18.573357
    [72]       22.998346      26.017805      27.848167      28.594126
    [76]       28.288704      26.900370      24.329453      20.422428
    [80]       15.211835      10.364612      8.7641754      8.4197006
    [84]       7.5185981      4.4720902     -3.9573903      3.4259913
    [88]       13.018907      20.296766      25.762159      29.664846
    [92]       32.254807      33.708298      34.130581      33.567547
    [96]       32.008327      29.377647      25.526579      20.313841
    [100]       14.641109      12.572116      12.355588      9.9164419
    [104]       7.0824590      13.608198      20.104380      26.954071
    [108]       33.091686      37.828926      41.219967      43.423634
    [112]       44.557083      44.685501      43.828773      41.966423
    [116]       39.043484      35.004669      29.989613      24.986555
    [120]       21.427814      18.337086      15.088554      14.272247
    [124]       14.913983      13.347460      9.8534250      19.620827
    [128]       26.574492      30.911673      33.584770      34.960583
    [132]       35.198536      34.363750      32.471783      29.529892
    [136]       25.631149      21.115984      16.272242      9.5244684
    [140]      -3.8014233      9.6486244      13.869168      15.356133
    [144]       14.981150      14.094567      18.943722      24.859875
    [148]       28.942703      31.478495      32.742889      32.874100
    [152]       31.924393      29.898680      26.812752      22.839827
    [156]       18.472530      13.840168      7.0078650     -9.7449818
    [160]       4.0361590      8.4078798      10.969739      13.220098
    [164]       17.683592      23.225937      27.640993      30.660357
    [168]       32.433723      33.090328      32.700787      31.292604
    [172]       28.886454      25.592813      21.818470      18.227921
    [176]       14.699049      9.6403971     -3.8170321      5.5024314
    [180]       11.654219      12.500462      6.9500027      14.966569
    [184]       23.577271      28.390638      31.223381      32.664425
    [188]       32.966675      32.255112      30.606024      28.111029
    [192]       24.963045      21.473808      17.668705      12.403299
    [196]     -0.25352693      4.6525946      9.3085394      4.5629020
    [200]       9.1645813      20.858988      26.880278      30.675959
    [204]       33.035675      34.266212      34.506668      33.815525
    [208]       32.205170      29.667000      26.204163      21.821449
    [212]       16.057945      4.0255399      9.6524477      17.587210
    [216]       21.829136      24.959024      27.556547      29.731665
    [220]       31.491306      32.828892      33.716602      34.099621
    [224]       33.905457      33.049553      31.425524      28.878796
    [228]       25.176470      20.156145      15.574901      15.119089
    [232]       14.861187      12.698360      9.5078325      9.1993771
    [236]       10.829734      11.790585      13.218588      16.673992
    [240]       20.728546      24.012880      26.249119      27.456596
    [244]       27.685968      26.971571      25.333042      22.809843
    [248]       19.573589      16.138988      13.172013      10.489355
    [252]       7.5138001      5.5134711      6.7829394      9.4873781
    [256]       12.029618      14.112072      15.946752      17.906780
    [260]       19.953176      21.655470      22.664082      22.828318
    [264]       22.112524      20.556091      18.333139      15.901326
    [268]       13.896738      12.387046      10.822325      8.8989153
    [272]       6.9237013      5.8527188      6.3910666      7.9724507
    [276]       10.415586      13.873962      17.480953      20.411430
    [280]       22.399742      23.415945      23.477003      22.602474
    [284]       20.847559      18.444761      16.032318      14.290156
    [288]       12.954473      11.567770      10.403717      9.4542971
    [292]       7.8967466      6.8188391      10.268228      14.876534
    [296]       18.651928      21.689434      24.049980      25.688278
    [300]       26.554111      26.618488      25.871956      24.342398
    [304]       22.168518      19.717785      17.446247      15.265491
    [308]       12.643673      10.223874      10.586303      12.478724
    [312]       13.916215      15.028650      16.582979      18.940397
    [316]       21.538626      23.705912      25.126734      25.701244
    [320]       25.405262      24.250610      22.332430      19.984886
    [324]       17.848198      16.178877      14.303017      11.600126
    [328]       9.5429678      11.721539      15.009030      17.406921
    [332]       19.243572      21.342646      24.009012      26.658743
    [336]       28.741783      30.061281      30.592291      30.367418
    [340]       29.465998      28.063166      26.449512      24.810040
    [344]       22.870899      20.075827      16.972301      17.584091
    [348]       20.305613      22.155855      23.378582      24.785284
    [352]       26.756517      28.922775      30.788576      32.091923
    [356]       32.729065      32.652874      31.829840      30.247221
    [360]       28.000887      25.515640      23.519398      21.962669
    [364]       19.746475      15.917818      12.921680      16.238613
    [368]       19.280369      20.918335      21.795462      22.454397
    [372]       23.191502      23.928511      24.355499      24.183313
    [376]       23.220057      21.338343      18.480560      14.916117
    [380]       11.948579      10.629671      9.4873857      7.9252563
    [384]       7.6309228      8.8435745      9.7480154      10.088450
    [388]       10.737783      12.270670      14.231412      16.075977
    [392]       17.546139      18.508291      18.892260      18.691441
    [396]       17.969210      16.868946      15.585953      14.216333
    [400]       12.564242      10.163110      6.5053277      2.3743386
    [404]       2.8146415      5.3542624      7.2082195      8.8972712
    [408]       10.725829      12.552819      14.206580      15.550900
    [412]       16.439711      16.739698      16.358681      15.261408
    [416]       13.518910      11.427863      9.5023718      7.8669543
    [420]       5.8583732      2.7612205    -0.44723976     0.56480783
    [424]       3.0882020      4.6005592      5.3606286      5.9788852
    [428]       6.9787683      8.3625660      9.6549282      10.421997
    [432]       10.451346      9.6958494      8.2872334      6.6789322
    [436]       5.5208440      4.7649755      3.5800200      1.2365983
    [440]      -2.4772439     -5.1506605     -3.5634196     -1.6738539
    [444]     -0.51032454     0.42987478      1.4520687      2.6387331
    [448]       3.9466312      5.1623583      6.0132799      6.3210239
    [452]       6.0479288      5.3177371      4.4258060      3.6401567
    [456]       2.8039694      1.3433446     -1.4711491     -6.7414169
    [460]      -13.172892     -7.7510409     -4.0570412     -2.0465608
    [464]     -0.51033503     0.99583346      2.4539506      3.6823483
    [468]       4.4894814      4.7159109      4.2462382      3.0394471
    [472]       1.2508572    -0.53556323     -1.6414319     -2.4959900
    [476]      -4.2272577     -7.7646561     -12.533195     -10.490998
    [480]      -6.9930091     -5.2228856     -4.3772531     -3.7845960
    [484]      -3.1429417     -2.4910080     -1.9632627     -1.6288412
    [488]      -1.4988053     -1.5861722     -1.9430102     -2.6335862
    [492]      -3.5935109     -4.3359995     -4.0677238     -2.9414575
    [496]      -1.9091706     -1.5315313     -1.9618843     -3.1927054
    [500]      -5.1256003     -7.5108895     -9.7782078     -11.004608
    [504]      -10.728832     -9.5820837     -8.2693176     -6.9504890
    [508]      -5.5091991     -3.9804630     -2.6303194     -1.7249243
    [512]      -1.4093696
  [Tag]         9281
  [frame_len]          320
[Record 59]
  [tot_power]       1929563.8
  [re_spec_val]
    [0]      -46.692577     -31.947746     -31.360327     -50.717068
    [4]      -27.848310     -25.314655     -37.035057     -23.485798
    [8]      -18.484446     -25.336252     -16.116770     -8.1489706
    [12]      -8.5793762     -6.2890387      6.6165180      13.694181
    [16]       18.219425      21.083939      22.641041      23.048914
    [20]       22.361866      20.546900      17.442730      12.580587
    [24]       4.2865381     -20.418497     -1.7865704     -4.6862512
    [28]      -4.4045987      5.9937806      9.4542160      7.4497156
    [32]       1.3163886      17.867792      24.853735      29.079453
    [36]       31.642403      32.916615      33.045853      32.055229
    [40]       29.870470      26.279741      20.774975      11.800672
    [44]      -14.146910      1.7765806    -0.31704029     -7.8461323
    [48]      -5.3142309     -2.9070110     0.85683417      10.356472
    [52]       17.594318      22.644022      26.093418      28.257364
    [56]       29.297594      29.284195      28.217165      26.020725
    [60]       22.497475      17.161549      8.4261284     -6.7396035
    [64]       3.1241558      4.1621399      2.5831232     0.64750266
    [68]       2.2103796      7.7764535      13.893009      19.056620
    [72]       23.009846      25.797462      27.494452      28.146341
    [76]       27.755901      26.272755      23.568865      19.372293
    [80]       13.053617      2.8316538     -1.2829331      2.8133001
    [84]       3.0324261     0.21541104     0.36336988      3.4392450
    [88]      -4.2023215      11.664947      21.271326      26.943729
    [92]       30.541931      32.653362      33.531002      33.289951
    [96]       31.967403      29.536646      25.886024      20.746056
    [100]       13.770103      8.7570639      9.6083202      9.3446760
    [104]       12.330247      16.913904      18.221468      12.273772
    [108]       21.603613      31.253496      36.756405      40.186268
    [112]       42.151386      42.892300      42.497231      40.958317
    [116]       38.172195      33.890202      27.566751      18.254074
    [120]       12.299480      11.010632      2.8506355      8.8032722
    [124]       12.850166      10.889201      4.9204178      20.533859
    [128]       27.731304      32.303162      35.300102      37.067284
    [132]       37.742249      37.371288      35.941010      33.378235
    [136]       29.521549      24.032459      16.202129      7.8217244
    [140]       8.2796803      6.2955561      1.0167642      7.3915839
    [144]       10.956313      14.639500      21.690983      27.617466
    [148]       31.763500      34.459286      35.934372      36.306080
    [152]       35.614307      33.835079      30.871031      26.498911
    [156]       20.166742      9.8901758     -3.7676291      4.2889090
    [160]       7.9650764      14.134735      18.299913      20.676937
    [164]       22.961042      26.652046      30.588495      33.617588
    [168]       35.521568      36.332176      36.083656      34.761765
    [172]       32.285278      28.491207      23.228298      17.533073
    [176]       15.297210      15.205305      16.129786      17.747688
    [180]       18.665169      20.014568      24.281408      29.085207
    [184]       32.779537      35.295399      36.761742      37.268333
    [188]       36.855934      35.525539      33.243370      29.941462
    [192]       25.520260      19.886444      13.191298      6.7063761
    [196]       4.5244384      9.0072737      13.934539      17.757177
    [200]       20.838488      23.656614      26.420906      28.948750
    [204]       30.936222      32.178371      32.570717      32.051041
    [208]       30.557734      28.005461      24.269037      19.169365
    [212]       12.400152      2.5544531     -5.5265908      4.3115602
    [216]       7.9409809      9.5543661      10.104349      9.8801842
    [220]       8.7059755      6.5996618      9.0674038      15.107844
    [224]       19.494270      22.223492      23.599331      23.776316
    [228]       22.800911      20.628860      17.101217      11.845660
    [232]       4.0991216     -2.3745332     0.19966219      1.1301256
    [236]      0.64380831    -0.28340134     -2.0511103     -11.514643
    [240]     -0.27683559      9.4811735      14.949574      18.398621
    [244]       20.447044      21.350183      21.229872      20.149323
    [248]       18.156948      15.340924      11.916715      8.2814465
    [252]       4.8373313      2.0299594      1.1819499      2.2651408
    [256]       2.9859655      1.6022893     -5.5731573    -0.45580626
    [260]       8.7361803      13.533088      16.322269      17.717611
    [264]       17.932735      17.029072      14.985274      11.731347
    [268]       7.2383156      1.8933152     -3.0949376     -8.2165489
    [272]      -19.117699     -12.044985     -5.2836499     -2.3518047
    [276]      -2.7596021     -13.218118     0.34850529      9.3543072
    [280]       14.408889      17.519161      19.258354      19.864468
    [284]       19.448862      18.062193      15.725800      12.459556
    [288]       8.3210192      3.4393830     -2.1081829     -8.8491449
    [292]      -11.277035     -4.2172070     0.10574817      1.7934169
    [296]       1.1524578      3.3457706      10.037239      15.085117
    [300]       18.371916      20.312607      21.150042      21.022646
    [304]       20.008890      18.136927      15.364619      11.539446
    [308]       6.4097090     0.12116636     -6.0294170     -20.480898
    [312]      -4.3669982      1.6395503      2.7067292    -0.61498785
    [316]       5.8909297      13.643924      18.238363      20.909885
    [320]       22.144318      22.136280      20.944538      18.535240
    [324]       14.771832      9.3367901      1.5883776     -6.2306466
    [328]      -6.0289178     -5.6197820   -0.071598954      5.2132154
    [332]       7.8686800      8.0840445      10.444542      17.530151
    [336]       23.171616      27.019022      29.475351      30.779634
    [340]       31.058077      30.370644      28.732702      26.122305
    [344]       22.473894      17.639954      11.246140      3.0026784
    [348]       3.2296491      7.5549135      9.9096766      10.604952
    [352]       9.1186104      3.3946421      8.2062073      16.286459
    [356]       20.865004      23.594940      25.046146      25.473921
    [360]       25.020580      23.774338      21.776974      19.002237
    [364]       15.317620      10.417517      3.4965332     -9.6925478
    [368]      -4.2669873      1.3474145      2.9030156      1.2808056
    [372]      -2.3399730      5.2709780      11.505163      15.259130
    [376]       17.393026      18.229824      17.870089      16.287848
    [380]       13.332404      8.6750221      2.0948536     -1.5906553
    [384]     -0.25905392    -0.27876800     -1.5744598     -3.4507406
    [388]      -5.4448290     -6.5556622     -5.2842827     -1.2609239
    [392]       4.0959725      8.8541794      12.418827      14.794513
    [396]       16.078632      16.350872      15.658446      14.016799
    [400]       11.408232      7.7722883      2.9817860     -3.2127030
    [404]      -11.515435     -23.059244     -13.392119     -8.0508633
    [408]      -5.8853889     -6.2915916     -6.8765373     -1.2681786
    [412]       4.1479502      7.6471543      9.6523991      10.450126
    [416]       10.209681      9.0663338      7.1833119      4.7751102
    [420]       2.0237825     -1.0702633     -4.6509118     -8.8353491
    [424]      -13.329674     -13.186906     -9.2885838     -7.4277639
    [428]      -8.9188690     -21.988928     -7.6519351     0.44410059
    [432]       4.6098166      6.8352919      7.6468291      7.2200065
    [436]       5.5744481      2.6095796     -1.9194372     -8.3141861
    [440]      -14.328945     -14.601736     -14.923230     -16.762877
    [444]      -18.557787     -17.364683     -14.864306     -12.324730
    [448]      -8.3653088     -3.6822968     0.25645757      3.0911322
    [452]       4.8683486      5.6880288      5.6416092      4.8104568
    [456]       3.2675982      1.0674579     -1.7753731     -5.2818804
    [460]      -9.3481379     -12.955458     -13.567694     -11.779321
    [464]      -10.055984     -9.3949718     -10.368885     -13.205470
    [468]      -11.897865     -6.2821479     -2.5335348    -0.50358981
    [472]      0.20642464    -0.18527026     -1.5547551     -3.8518131
    [476]      -7.1791396     -12.059741     -20.187912     -24.187277
    [480]      -19.363693     -19.376369     -23.442335     -26.242451
    [484]      -20.675354     -18.228415     -17.757473     -16.669157
    [488]      -13.985652     -11.672998     -10.591048     -10.666673
    [492]      -11.074444     -9.9624853     -7.3927469     -5.1423821
    [496]      -3.9222097     -3.8961589     -5.2128434     -8.2136106
    [500]      -13.620251     -18.853260     -15.393908     -13.108721
    [504]      -11.108610     -7.7591710     -4.4629884     -2.2140667
    [508]      -1.1897078     -1.4697646     -3.3238916     -7.5171475
    [512]      -12.934727
  [Tag]         9441
  [frame_len]          320
[Record 60]
  [tot_power]       2008068.8
  [re_spec_val]
    [0]      -41.829880     -33.827606     -33.855450     -39.188114
    [4]      -29.949106     -30.997818     -29.178020     -19.854509
    [8]      -19.032187     -34.486141     -12.328775     -7.8845119
    [12]      -10.326560      1.1419165      10.264489      16.013340
    [16]       19.813011      22.198175      23.413076      23.570185
    [20]       22.695885      20.728193      17.462862      12.361572
    [24]       3.7100682     -7.2462258     -2.5259104     -15.305557
    [28]       1.2607054      8.4303112      10.768130      11.641142
    [32]       17.636358      24.125528      28.676300      31.641275
    [36]       33.318848      33.859009      33.313091      31.651539
    [40]       28.746674      24.291374      17.494678      5.7691913
    [44]       3.8458917      5.4525743     0.27224675     -8.0075836
    [48]       3.7356465      7.8058105      12.595131      18.326723
    [52]       22.924517      26.113291      28.054216      28.882999
    [56]       28.670574      27.429688      25.113157      21.595291
    [60]       16.663706      10.461716      6.0956926      4.0655599
    [64]      -3.0226386     -2.6311655      6.6469107      10.495408
    [68]       13.547477      17.480783      21.487169      24.648024
    [72]       26.748062      27.801561      27.848312      26.908318
    [76]       24.962833      21.904480      17.384335      10.550268
    [80]       5.5363855      8.6171951      8.5221844      6.7079096
    [84]       10.978213      15.733895      19.223457      22.847092
    [88]       26.725615      30.082663      32.520031      33.973675
    [92]       34.468590      34.024399      32.619434      30.161369
    [96]       26.476694      21.650936      18.200512      17.806189
    [100]       15.733457      8.5776386      15.737743      22.118826
    [104]       25.515114      28.267681      31.718517      35.403519
    [108]       38.443535      40.536659      41.656837      41.828472
    [112]       41.060165      39.329842      36.599064      32.921417
    [116]       28.837437      25.464630      22.156303      15.498116
    [120]       10.876670      19.843096      23.263988      25.242064
    [124]       27.564791      30.453646      33.158207      35.200420
    [128]       36.433918      36.827553      36.363804      34.991310
    [132]       32.604252      29.163019      25.610584      24.438255
    [136]       24.080204      21.694548      17.954876      22.407267
    [140]       27.044720      29.827522      31.829762      33.766880
    [144]       35.758137      37.495014      38.669933      39.117950
    [148]       38.770626      37.615993      35.714291      33.276745
    [152]       30.688465      28.066904      24.507864      16.821203
    [156]       12.331751      23.234570      27.353031      29.794235
    [160]       31.853235      33.930336      35.834717      37.272369
    [164]       38.084557      38.222885      37.692837      36.525669
    [168]       34.768730      32.486263      29.771957      26.751938
    [172]       23.479494      19.719027      15.552845      14.908922
    [176]       17.326391      18.122511      15.819387      5.4430685
    [180]       17.106544      24.378452      28.261169      30.433010
    [184]       31.423307      31.471689      30.705036      29.193636
    [188]       26.995861      24.243048      21.225348      18.146458
    [192]       14.450720      8.5358801     0.62284631      5.2084384
    [196]       7.3580332      9.0200911      12.524602      15.968398
    [200]       18.626459      20.660898      22.173910      23.130421
    [204]       23.454878      23.074606      21.914112      19.896898
    [208]       17.029421      13.722941      11.020187      8.8770342
    [212]       5.3270159     -1.2522609      2.5965536      7.6729188
    [216]       10.247951      11.782605      13.023130      14.197184
    [220]       15.190889      15.821760      15.967058      15.555877
    [224]       14.544415      12.953845      11.033840      9.3708038
    [228]       8.1431961      6.3352513      2.1836677     -5.6584692
    [232]       1.8795104      6.6597028      8.7255640      9.5385046
    [236]       10.039500      10.853300      11.936674      12.888388
    [240]       13.433893      13.456628      12.893054      11.697611
    [244]       9.9136515      7.8476677      5.9935780      4.0980611
    [248]      0.53953117     -10.267662     -3.8610399      3.3411088
    [252]       6.2673154      7.3739347      7.5808372      7.8152556
    [256]       8.8632526      10.489801      11.967572      12.887686
    [260]       13.105108      12.584822      11.418429      9.9940119
    [264]       8.9574575      8.3092871      7.0772028      3.9646847
    [268]      -4.5137434     -5.8176317      3.7089560      7.3450098
    [272]       9.1982841      10.343398      11.339546      12.379271
    [276]       13.334074      13.968359      14.095605      13.608357
    [280]       12.492297      10.899603      9.2061214      7.6597090
    [284]       5.7399220      2.1322112     -6.4659734     -5.3283105
    [288]       1.6806430      4.1437817      4.6606350      4.3886247
    [292]       4.6447053      6.0634365      7.8216968      9.1092634
    [296]       9.5628462      8.9817886      7.3416348      5.5995159
    [300]       6.0025320      7.3912454      7.5226202      5.4847717
    [304]     -0.28543043     -6.0504560      2.6998796      6.3883381
    [308]       8.2335682      9.6963844      11.434570      13.388624
    [312]       15.242756      16.759737      17.785027      18.212311
    [316]       18.010212      17.326115      16.613663      16.342079
    [320]       16.244352      15.515605      13.350226      8.4244928
    [324]      -1.1368129      8.1723919      13.130767      15.570220
    [328]       16.855961      17.647076      18.465687      19.573198
    [332]       20.777258      21.718201      22.205015      22.277481
    [336]       22.125679      21.882961      21.411657      20.367369
    [340]       18.446175      15.763207      13.825104      14.047338
    [344]       14.514025      13.933629      12.347923      10.736508
    [348]       10.599090      11.540142      12.345217      12.640308
    [352]       12.381097      11.540852      10.294242      9.4230566
    [356]       9.5279055      9.5897131      8.2376976      4.0385637
    [360]      -4.6703820      3.3893692      8.0497437      9.9891644
    [364]       10.832490      11.538714      12.510971      13.558120
    [368]       14.405862      14.962793      15.234730      15.213668
    [372]       14.870620      14.242757      13.507319      12.850423
    [376]       12.139056      10.865356      8.3078718      3.1403656
    [380]      -5.8504553      2.3965311      6.8957114      8.8372469
    [384]       9.4781666      9.3702888      8.9056511      8.4042349
    [388]       8.0211201      7.7345176      7.5693254      7.7229271
    [392]       8.2197866      8.6140404      8.2966995      6.6871533
    [396]       2.8425689     -7.3591881     -5.0239854      2.3690760
    [400]       4.9116859      5.5397415      5.1268091      4.3994427
    [404]       4.1627326      4.6159835      5.1608381      5.2291961
    [408]       4.5528183      3.1210978      1.5645428      1.4323933
    [412]       2.5595112      3.1940694      2.4532125    -0.19694535
    [416]      -5.1413026     -4.9218788    -0.12035532      2.6217785
    [420]       3.9692745      4.5634885      4.8258147      4.9926238
    [424]       5.1045866      5.0835829      4.8573170      4.4532251
    [428]       4.0371809      3.8008459      3.6804175      3.2880998
    [432]       2.1271236    -0.38995484     -5.5272818     -17.366940
    [436]      -7.1539254     -2.0598404     0.11745358     0.81394100
    [440]      0.53817272    -0.36867470     -1.5548733     -2.7489789
    [444]      -3.8955662     -4.7142839     -4.1779032     -2.3333974
    [448]     -0.66605592   -0.031846885    -0.77772301     -3.2456961
    [452]      -7.2324600     -6.6046238     -2.5607038   -0.062704928
    [456]       1.1171374      1.4668868      1.3788884      1.1494689
    [460]      0.88510895     0.49375030    -0.16146269     -1.0949717
    [464]      -2.0465169     -2.4365137     -1.9970897     -1.3486257
    [468]      -1.2720909     -2.2747908     -4.8215151     -9.5447245
    [472]      -12.879852     -8.6143484     -5.7753248     -4.6708746
    [476]      -4.5399871     -4.7913570     -5.0670886     -5.3701038
    [480]      -5.8181462     -6.2809086     -6.4204936     -6.2101631
    [484]      -6.1002498     -6.5842252     -8.0183210     -10.756578
    [488]      -15.351388     -20.913721     -18.035318     -14.182390
    [492]      -12.263162     -12.014596     -13.599874     -16.388176
    [496]      -14.004785     -9.2716312     -6.0658894     -4.0235033
    [500]      -2.6538785     -1.6305462    -0.80795956    -0.21085916
    [504]     0.029774742    -0.26602069     -1.3166850     -3.3630326
    [508]      -6.2081861     -6.9497819     -4.3604746     -2.2203691
    [512]      -1.4990374
  [Tag]         9601
  [frame_len]          320
[Record 61]
  [tot_power]       1879266.4
  [re_spec_val]
    [0]      -54.848202     -37.603447     -29.220280     -26.668034
    [4]      -31.114536     -32.039089     -22.337536     -22.881269
    [8]      -29.750372     -13.490997     -9.5011673     -13.145022
    [12]      -3.3084891      6.7740278      12.942242      17.063107
    [16]       19.729744      21.177584      21.492569      20.679216
    [20]       18.699434      15.545124      11.439995      6.9452367
    [24]       1.3599370     -14.759382     0.18417066      5.4776006
    [28]       6.6665859      10.355885      18.403906      24.570917
    [32]       28.849878      31.688221      33.335022      33.916824
    [36]       33.484428      32.032913      29.514374      25.879957
    [40]       21.278467      16.520779      12.115065      4.8914771
    [44]      -5.2772441      7.1003461      10.033114      13.194457
    [48]       18.169411      22.448965      25.431267      27.229488
    [52]       27.946850      27.601065      26.123949      23.356026
    [56]       19.090759      13.743265      10.278934      7.8640499
    [60]       1.2611811      4.2781315      10.370141      13.308376
    [64]       15.911317      19.365847      22.943769      25.889879
    [68]       27.966433      29.114695      29.291637      28.417879
    [72]       26.349335      22.880070      18.108877      14.364136
    [76]       12.790216      8.0395184      5.3199511      15.023791
    [80]       19.543190      22.435116      25.228676      28.259630
    [84]       31.030609      33.114143      34.338276      34.643681
    [88]       34.004841      32.437267      30.101404      27.453360
    [92]       24.845755      21.321419      13.014221      11.391013
    [96]       20.730947      24.211779      26.309841      28.645611
    [100]       31.531059      34.351257      36.619255      38.136906
    [104]       38.831730      38.678280      37.689651      35.952602
    [108]       33.666832      31.016449      27.791868      23.924318
    [112]       23.665823      26.638330      28.104296      27.849716
    [116]       27.114412      28.517717      31.445677      33.921993
    [120]       35.580086      36.463802      36.587532      35.948040
    [124]       34.661766      33.147213      31.892496      30.506405
    [128]       27.565960      19.624487      19.331739      27.956095
    [132]       31.476196      33.490803      35.273163      37.215256
    [136]       39.067284      40.519718      41.423882      41.735020
    [140]       41.458927      40.636333      39.329109      37.578884
    [144]       35.355663      32.610874      29.654297      27.626724
    [148]       26.814098      25.669294      23.441513      22.422604
    [152]       25.156441      28.119564      30.166792      31.472067
    [156]       32.176640      32.316399      31.926653      31.121841
    [160]       30.064877      28.771942      26.936663      24.031046
    [164]       19.996662      18.610882      20.679077      21.494963
    [168]       20.565189      19.084278      19.717827      21.772339
    [172]       23.223516      23.802860      23.750788      23.324642
    [176]       22.709545      22.034960      21.376720      20.653336
    [180]       19.562809      17.681570      14.596492      10.453054
    [184]       8.4707384      9.3498726      9.0825872      7.7817688
    [188]       9.1463785      12.452123      14.845541      16.122372
    [192]       16.587862      16.545187      16.254236      15.879986
    [196]       15.398779      14.571995      13.023736      10.285663
    [200]       5.8039737     0.86655796      1.8036387      2.6381266
    [204]     -0.15546542     -9.3893824    -0.31840008      5.3592420
    [208]       7.9106164      8.9534445      9.2121687      9.1971769
    [212]       9.1874495      9.1000261      8.5983477      7.2848778
    [216]       4.8261809      1.9754345      2.8890476      5.8439260
    [220]       7.6264377      8.0804958      7.5301142      6.5731783
    [224]       6.1395473      6.5595798      7.1733689      7.4740930
    [228]       7.4442120      7.3111739      7.2597189      7.1829715
    [232]       6.7112069      5.4037981      2.8796508    -0.26792574
    [236]      0.20538028      2.9718678      4.5372214      4.7488604
    [240]       4.0640121      3.3140450      3.3975275      4.2232957
    [244]       5.1744280      6.0016732      6.6707149      7.0931263
    [248]       7.0687742      6.2966933      4.2946897    0.024507169
    [252]      -7.0329766    -0.57752711      4.2275352      6.3288250
    [256]       6.7519131      5.8915195      4.1398473      2.5462458
    [260]       2.5045335      3.5039866      4.5291977      5.4740372
    [264]       6.4360890      7.2617946      7.6340733      7.2379732
    [268]       5.8016930      3.3815484      2.1629815      4.3218412
    [272]       6.5306206      7.4040413      6.9361024      5.3349190
    [276]       3.3426914      2.7968483      4.1333499      5.8129387
    [280]       7.1607895      8.0483370      8.3928719      8.0879679
    [284]       6.9710045      4.7026258     0.36653769     -9.5054445
    [288]      -4.6023173      1.5970978      4.1375732      4.9294553
    [292]       4.6605997      3.9240415      3.4061930      3.4355817
    [296]       3.8060455      4.3984923      5.2865539      6.3125262
    [300]       7.0685310      7.1678047      6.2963967      4.1880674
    [304]       1.5151157      2.5301685      5.8683581      8.0397596
    [308]       8.7873507      8.2525444      6.5771990      4.3495965
    [312]       3.7128077      5.6868954      8.1567144      10.149839
    [316]       11.508496      12.174859      12.088468      11.204227
    [320]       9.7000618      8.7948427      10.146276      12.339162
    [324]       13.766521      14.008709      12.898675      10.118741
    [328]       5.0741835      2.0579312      6.9858012      10.515534
    [332]       12.642240      13.834084      14.183791      13.642547
    [336]       12.082396      9.1992617      4.3740411      1.6522474
    [340]       7.0658121      10.872027      12.872914      13.543185
    [344]       13.072682      11.537223      9.0529451      6.2061510
    [348]       4.8334751      5.9223685      7.7858405      9.3031511
    [352]       10.111118      10.044545      8.9666033      6.7240319
    [356]       3.6406746      3.1094201      6.0536952      8.5014925
    [360]       9.7525969      9.9681454      9.2973862      7.8058109
    [364]       5.4572649      2.3881302     0.93645054      3.3938000
    [368]       6.0037308      7.3275638      7.2766151      5.7264843
    [372]       2.2828023     -2.3500047     0.20936990      4.3065424
    [376]       6.5753069      7.5396609      7.5007954      6.5697713
    [380]       4.8104439      2.4068305    0.072750963    -0.37486300
    [384]       1.6348879      4.0975175      5.8526473      6.6263566
    [388]       6.3519120      4.9258976      2.0041761     -3.7212615
    [392]      -16.166561     -3.4635632      1.7312323      4.3412623
    [396]       5.5994306      5.8843126      5.3539853      4.0931277
    [400]       2.1998861    0.081305400    -0.89882648     0.11521521
    [404]       1.5640073      2.2924142      2.0488234     0.93518174
    [408]     -0.50456911     -1.0993577    -0.43781376     0.49796480
    [412]       1.0897155      1.3261853      1.3465517      1.1220948
    [416]      0.35315472     -1.4514303     -4.8388076     -8.0497026
    [420]      -5.0321326     -1.9096423    -0.77337468     -1.5187545
    [424]      -4.5517263     -12.243159     -13.303601     -5.1901140
    [428]      -1.8598784    -0.40016744   0.0050052945    -0.27911353
    [432]      -1.0087643     -1.9469119     -2.8736708     -3.6126530
    [436]      -3.8157072     -3.0208020     -1.5530909    -0.28302559
    [440]      0.25557792    -0.15606241     -1.6580330     -4.3776784
    [444]      -7.6527910     -7.4154677     -4.2801852     -1.7739592
    [448]     -0.18206349     0.71476346      1.0574857     0.86116123
    [452]    0.0029633562     -1.7604686     -4.6354241     -7.5724783
    [456]      -7.1740355     -5.6337442     -5.6270170     -7.2075553
    [460]      -7.8142796     -4.9775538     -2.1673286    -0.55942035
    [464]     0.053311259  -0.0074765785    -0.42679918    -0.95136571
    [468]      -1.5249703     -2.3429182     -3.6660309     -5.3599238
    [472]      -6.1073594     -4.9497223     -3.5351415     -3.0773733
    [476]      -3.9373519     -6.4498148     -11.507335     -18.390194
    [480]      -12.435681     -8.3837652     -6.4928098     -5.7283397
    [484]      -5.6409431     -5.9952116     -6.6522117     -7.5360022
    [488]      -8.6178083     -9.9031820     -11.493550     -13.756680
    [492]      -17.528921     -22.556322     -18.452587     -13.707988
    [496]      -11.146791     -9.9884853     -9.8019409     -10.345405
    [500]      -11.478851     -13.052016     -14.675701     -15.859073
    [504]      -16.639349     -15.901302     -12.233240     -8.4930859
    [508]      -6.1649318     -5.4447565     -6.5111475     -9.8008995
    [512]      -13.488028
  [Tag]         9761
  [frame_len]          320
[Record 62]
  [tot_power]       1404105.6
  [re_spec_val]
    [0]      -26.606934     -28.123474     -31.228857     -38.673599
    [4]      -28.479580     -21.624334     -21.914932     -30.691401
    [8]      -16.659679     -14.329021     -16.003300     -1.5503194
    [12]       6.2501612      11.132296      14.218050      15.941593
    [16]       16.507469      16.001230      14.385353      11.387336
    [20]       6.2202148    -0.63921726      2.3110268      4.6388316
    [24]       6.1069245      9.3184099      13.228783      17.997404
    [28]       23.104568      27.394817      30.512262      32.473156
    [32]       33.341507      33.148991      31.875118      29.424669
    [36]       25.557295      19.608480      8.6206398      3.4407074
    [40]       9.8631306      9.5426588      9.0313292      14.414647
    [44]       19.490988      23.069622      25.524467      27.007931
    [48]       27.527689      27.034006      25.447247      22.669209
    [52]       18.716776      14.764876      14.066277      15.099298
    [56]       15.270527      14.250814      13.617332      16.360071
    [60]       20.294256      23.573601      26.038750      27.699001
    [64]       28.542910      28.570066      27.794664      26.205557
    [68]       23.698450      20.227385      17.694386      19.202507
    [72]       21.019592      21.564108      21.906458      23.953218
    [76]       27.114990      29.932720      32.005695      33.293270
    [80]       33.780975      33.435184      32.200264      30.003345
    [84]       26.910355      24.156260      24.235397      25.332047
    [88]       25.249857      23.784719      23.087852      25.899918
    [92]       29.212290      31.704510      33.528637      34.829624
    [96]       35.608833      35.824760      35.460812      34.536510
    [100]       33.120453      31.405302      29.754091      28.300404
    [104]       26.374962      22.873850      20.421768      25.230913
    [108]       29.082890      31.244097      32.440861      33.177216
    [112]       33.695732      33.976551      33.841934      33.074238
    [116]       31.575245      29.961370      30.041443      31.482197
    [120]       32.301506      31.901634      30.985813      31.806429
    [124]       34.363186      36.677708      38.267117      39.266365
    [128]       39.825436      40.006554      39.826637      39.328922
    [132]       38.618813      37.820595      36.946712      35.787991
    [136]       33.922817      30.674730      24.467733      13.806040
    [140]       23.540337      26.866917      27.360508      26.342655
    [144]       24.873034      24.243906      24.563229      24.881052
    [148]       24.668137      23.843189      22.664803      21.753448
    [152]       21.360315      20.702744      18.683764      13.732702
    [156]       4.1066465      14.164696      18.826874      20.879404
    [160]       21.626987      21.599207      21.072239      20.180828
    [164]       19.014084      17.800817      17.015217      16.886179
    [168]       16.892599      16.309177      14.576899      10.970167
    [172]       3.0184901     -2.8045831      7.3791165      10.713251
    [176]       11.995727      12.202098      11.713381      10.721385
    [180]       9.3388596      7.7067237      6.3372955      6.1758294
    [184]       6.9751315      7.3808351      6.4901915      3.5364869
    [188]      -3.4075549     -4.8036098      2.3764153      5.3824739
    [192]       6.4504051      6.3359232      5.3633642      3.7038710
    [196]       1.5407314    -0.37718230    -0.14246301      2.0546975
    [200]       4.1419420      5.3650160      5.6248436      4.9323249
    [204]       3.3201644     0.97047043     -1.2114451     -1.4890584
    [208]     -0.28939986     0.77889329      1.2201313      1.0735379
    [212]      0.53684878   -0.029045541   -0.061514065     0.73265141
    [216]       1.8743972      2.7035251      2.8608973      2.1861157
    [220]      0.53234476     -2.3559072     -6.2910004     -6.3287315
    [224]      -2.5830159   -0.062763877      1.0190083     0.95287114
    [228]     0.010953180     -1.3343971     -2.1541967     -1.7709073
    [232]     -0.82548273    -0.22860336    -0.45599797     -1.8068910
    [236]      -4.6688175     -9.2412157     -9.6707506     -5.2235961
    [240]      -2.3350379    -0.92425120    -0.61529964     -1.1841887
    [244]      -2.4074261     -3.8756688     -4.6950526     -3.9233241
    [248]      -2.1718528    -0.67517704   -0.042857055    -0.55503011
    [252]      -2.5581543     -6.9002090     -14.032884     -8.7442884
    [256]      -4.2625933     -2.3874397     -1.9186465     -2.0410745
    [260]      -1.9285282     -1.2387626    -0.33888718     0.38403746
    [264]      0.78756768     0.80965072     0.33680356    -0.87152791
    [268]      -3.3475115     -8.7013903     -27.508007     -7.8329701
    [272]      -2.6825266    -0.55479395   -0.083352461    -0.68776190
    [276]      -1.6230183     -1.7920713    -0.83353555     0.60278827
    [280]       2.0072794      3.1314025      3.7861166      3.8079197
    [284]       3.0356209      1.2406081     -1.9828701     -6.9051776
    [288]      -7.8581982     -3.9178920     -1.5699660    -0.66012311
    [292]     -0.63380581     -1.0720956     -1.6837965     -2.3283670
    [296]      -2.9516673     -3.5189018     -4.0972261     -5.0162845
    [300]      -7.0118566     -11.954113     -31.586718     -9.6771774
    [304]      -4.3469067     -2.1132073     -1.6491703     -2.2441401
    [308]      -2.6130672     -1.5511129     0.10443793      1.3850797
    [312]       2.2019081      2.7765803      3.2423880      3.4750631
    [316]       3.1325727      1.7065858     -1.6182178     -6.3180456
    [320]      -1.7564217      2.9627721      5.3587589      6.1987138
    [324]       6.0103326      5.5410643      5.7948279      6.8641582
    [328]       7.9625182      8.6708860      9.0068121      9.0868254
    [332]       8.9001961      8.2597666      6.8708434      4.3244214
    [336]     -0.22941706     -10.226186     -7.7267561    -0.65302104
    [340]       2.5462587      4.2654853      5.1232843      5.3644028
    [344]       5.1299009      4.5076370      3.5240207      2.1546047
    [348]      0.35618892     -1.9436564     -4.8326325     -7.5111933
    [352]      -6.9649816     -4.7165670     -3.6165979     -4.1100507
    [356]      -5.5462260     -5.0948758     -2.3688412    -0.12684005
    [360]       1.0414553      1.3642451      1.1985588     0.92274153
    [364]      0.77241457     0.65076274     0.17993200     -1.1147457
    [368]      -3.7297084     -7.5170093     -7.5042562     -4.1829143
    [372]      -2.1692138     -1.3454679    -0.85870075 -0.00087523856
    [376]       1.1114141      1.9401680      2.1984293      1.8730892
    [380]       1.1040882     0.12426890    -0.80675668     -1.5365679
    [384]      -2.1663690     -3.0741875     -4.8590159     -8.5529966
    [388]      -18.005548     -17.142832     -9.0376902     -6.1531773
    [392]      -5.1475301     -5.0741277     -5.5699201     -6.7861094
    [396]      -9.2854757     -13.964530     -19.919235     -17.322090
    [400]      -15.099835     -14.575212     -13.705606     -12.538280
    [404]      -12.413284     -13.596378     -13.880891     -11.077955
    [408]      -8.1635590     -6.3235106     -5.3885574     -5.0385633
    [412]      -4.9682741     -4.9570274     -4.9683771     -5.1778450
    [416]      -5.9014797     -7.5685310     -10.928059     -18.407497
    [420]      -25.032467     -14.398821     -11.172959     -10.198535
    [424]      -10.090005     -9.8995848     -9.4686060     -9.3115911
    [428]      -9.7254009     -10.511550     -11.183167     -11.555138
    [432]      -11.985085     -12.892947     -14.506364     -16.581118
    [436]      -17.108282     -14.943531     -12.701116     -11.395164
    [440]      -10.828898     -10.605088     -10.600256     -11.151671
    [444]      -12.827580     -16.285007     -21.147635     -19.876059
    [448]      -16.791651     -15.769856     -16.125898     -16.677397
    [452]      -16.074038     -14.339643     -12.317703     -10.437530
    [456]      -8.8490305     -7.5832686     -6.5914211     -5.8083906
    [460]      -5.2315221     -4.9423008     -5.0565934     -5.6640339
    [464]      -6.8042436     -8.4964590     -10.856989     -14.366294
    [468]      -20.640415     -28.239992     -18.872425     -14.693624
    [472]      -12.537801     -11.214080     -10.379313     -10.145253
    [476]      -10.755705     -12.361047     -14.746287     -16.737103
    [480]      -17.260668     -17.527216     -18.442322     -19.372057
    [484]      -19.304247     -18.671192     -18.063732     -17.256018
    [488]      -16.124176     -15.034451     -14.308896     -14.041689
    [492]      -14.271192     -15.118487     -16.823959     -19.702591
    [496]      -23.340080     -23.095558     -19.666641     -17.117558
    [500]      -15.580287     -14.725039     -14.296817     -14.095839
    [504]      -13.951100     -13.730976     -13.393665     -13.007847
    [508]      -12.689485     -12.512630     -12.471377     -12.499577
    [512]      -12.520015
  [Tag]         9921
  [frame_len]          320
[Record 63]
  [tot_power]       774769.31
  [re_spec_val]
    [0]      -37.752586     -35.334156     -30.928280     -27.183432
    [4]      -25.066858     -26.713205     -38.159683     -22.155375
    [8]      -20.739826     -20.052013     -4.1311398      3.7818639
    [12]       8.8759604      12.200877      14.167657      14.978877
    [16]       14.749608      13.572101      11.573583      8.8426132
    [20]       4.7155347     -6.0167909     -1.2180583      5.9762540
    [24]       10.503901      17.376757      23.652510      28.277395
    [28]       31.456211      33.401577      34.226791      33.959812
    [32]       32.545109      29.812513      25.361168      18.048388
    [36]     -0.44390976      8.5886574      12.518586      14.184407
    [40]       16.118460      19.577246      23.410841      26.319212
    [44]       28.028612      28.564070      27.943987      26.102654
    [48]       22.838644      17.748838      10.870124      8.5814133
    [52]       10.418398      12.303526      14.598868      17.155071
    [56]       20.198563      23.331400      25.851507      27.426352
    [60]       27.963406      27.419333      25.726589      22.798780
    [64]       18.701006      14.206991      10.562228      9.6262197
    [68]       13.613278      17.805553      21.750755      25.768982
    [72]       29.274019      31.836905      33.352695      33.819946
    [76]       33.236141      31.573177      28.799889      25.003069
    [80]       20.808098      18.314466      19.503881      21.930285
    [84]       23.665350      25.033026      27.204300      30.013220
    [88]       32.365631      33.765438      34.120453      33.426865
    [92]       31.683071      28.919621      25.384356      21.934597
    [96]       19.701698      18.772249      18.750759      19.125462
    [100]       20.158121      22.766933      25.925192      28.357290
    [104]       29.718109      29.982759      29.166769      27.308693
    [108]       24.589922      21.474968      18.475447      17.848810
    [112]       21.877052      25.777048      28.400452      30.378363
    [116]       32.452515      34.716179      36.683311      37.960621
    [120]       38.391930      37.941116      36.630268      34.561729
    [124]       32.023556      29.609652      27.969807      27.097530
    [128]       26.288664      24.743000      22.210367      21.482588
    [132]       24.534718      27.196169      28.506119      28.655329
    [136]       27.832539      26.177896      23.926170      21.704153
    [140]       20.337242      19.549313      18.335270      16.239414
    [144]       13.623159      11.540535      10.377636      10.525549
    [148]       12.656822      14.933981      16.100878      15.986892
    [152]       14.720909      12.714138      10.940681      10.102035
    [156]       9.3325920      7.4841590      3.6818755     -1.9325998
    [160]      0.71659636      4.7358785      6.3903971      6.2221065
    [164]       4.1896195    -0.77244383     -19.548164     -3.9424465
    [168]       1.2896332      3.0200284      3.0997453      2.1959329
    [172]      0.87660420    -0.21607889    -0.74860901    -0.85536426
    [176]     -0.59307331    0.065784059     0.77747017     0.97515106
    [180]      0.18646966     -1.9847984     -5.7307491     -8.2575197
    [184]      -6.0439186     -4.0781746     -2.9586761     -1.5954973
    [188]     0.091910549      1.3411732      1.7142782      1.1804500
    [192]     0.066776499    -0.79197383    -0.71258581    -0.25205830
    [196]     -0.21464559    -0.85382503     -2.0136924     -3.3371778
    [200]      -4.7127838     -6.7006521     -10.466887     -17.932919
    [204]      -16.661169     -12.023182     -11.361548     -13.513083
    [208]      -15.447525     -12.105238     -9.1840763     -8.0305948
    [212]      -8.1894598     -9.2270002     -10.808398     -12.775203
    [216]      -14.855961     -15.709575     -14.581966     -13.189307
    [220]      -12.287459     -11.338526     -9.8118591     -8.1368494
    [224]      -6.9699416     -6.5883226     -6.9820080     -7.9163570
    [228]      -8.9401464     -9.7453394     -10.677372     -12.452736
    [232]      -15.434773     -17.081135     -14.402394     -11.990370
    [236]      -11.122263     -11.595096     -12.980221     -14.177570
    [240]      -13.708511     -12.059395     -10.487370     -9.4980574
    [244]      -9.2505112     -9.7331247     -10.562059     -10.806605
    [248]      -10.112872     -9.4379969     -9.6250381     -11.000575
    [252]      -13.341694     -14.582572     -12.988602     -11.079417
    [256]      -9.8890743     -9.2009888     -8.8391571     -9.0148096
    [260]      -10.250415     -13.482439     -22.135712     -22.405521
    [264]      -13.748787     -10.619343     -9.4151936     -8.9136810
    [268]      -8.2470503     -7.2812991     -6.4928923     -6.2090673
    [272]      -6.4177785     -6.9233708     -7.6059012     -8.6397552
    [276]      -10.395474     -12.987395     -14.961693     -14.252798
    [280]      -13.211214     -13.647886     -16.123478     -21.764542
    [284]      -35.019344     -24.819706     -20.272236     -18.151255
    [288]      -17.305870     -17.640696     -18.100281     -16.145920
    [292]      -13.085607     -10.901037     -9.7337399     -9.1962280
    [296]      -8.8267202     -8.4297075     -8.2052984     -8.4399185
    [300]      -9.2041759     -10.151358     -10.522084     -10.172988
    [304]      -10.095593     -11.441095     -15.737835     -19.354891
    [308]      -11.110354     -6.6232128     -4.5070906     -3.9740543
    [312]      -4.6659708     -6.1061211     -7.1893396     -6.9683394
    [316]      -6.1479001     -5.4712124     -4.9420528     -4.4089012
    [320]      -3.9034765     -3.5841606     -3.6593297     -4.4628778
    [324]      -6.6259027     -11.588342     -15.717938     -7.7645435
    [328]      -3.5628195     -1.6217369     -1.0843549     -1.5436059
    [332]      -2.7783265     -4.8364763     -8.0798721     -10.764522
    [336]      -7.3016486     -3.5393944     -1.4257922    -0.55469036
    [340]     -0.49838027    -0.86550349     -1.3805209     -2.0028386
    [344]      -2.8277650     -3.8371289     -4.7597356     -5.2423115
    [348]      -5.3281212     -5.5359964     -6.4756088     -8.7588301
    [352]      -13.183070     -16.753647     -11.925943     -8.4685755
    [356]      -6.8130960     -6.2395139     -6.3491178     -6.9535522
    [360]      -7.9793844     -9.2977791     -10.533819     -11.181019
    [364]      -11.165756     -10.901743     -10.850662     -11.475930
    [368]      -13.452966     -18.432268     -30.890903     -16.563538
    [372]      -11.301585     -8.7877626     -7.7251735     -7.6617041
    [376]      -8.3822021     -9.7692451     -11.732924     -14.095717
    [380]      -16.340397     -17.492966     -17.124647     -15.892444
    [384]      -14.371092     -12.782806     -11.293809     -10.097575
    [388]      -9.3536615     -9.1443377     -9.4743538     -10.279490
    [392]      -11.435099     -12.778630     -14.173202     -15.601507
    [396]      -17.164425     -18.737642     -19.203484     -17.589161
    [400]      -15.272388     -13.380353     -12.108456     -11.413525
    [404]      -11.280763     -11.774891     -13.010964     -15.063695
    [408]      -17.687574     -19.804655     -20.570543     -21.051571
    [412]      -21.902073     -22.466171     -22.344248     -22.010036
    [416]      -21.038601     -18.937382     -16.778694     -15.431932
    [420]      -15.016793     -15.263960     -15.657538     -15.796304
    [424]      -15.859420     -16.316368     -17.490456     -19.601448
    [428]      -23.070480     -28.314939     -26.829573     -21.277472
    [432]      -17.869608     -15.932599     -14.974279     -14.694188
    [436]      -14.891064     -15.460492     -16.415789     -17.905596
    [440]      -20.267551     -24.184105     -29.985609     -28.009266
    [444]      -23.736135     -21.934752     -21.799192     -22.388529
    [448]      -22.324955     -21.409210     -20.890827     -21.526402
    [452]      -23.463427     -26.253120     -28.739328     -31.577705
    [456]      -40.100788     -38.096237     -30.542513     -29.236368
    [460]      -29.511070     -25.086868     -20.474800     -17.871967
    [464]      -16.917875     -17.141109     -17.843515     -18.211632
    [468]      -18.313322     -19.009499     -21.045902     -25.259214
    [472]      -33.769196     -31.717281     -25.573179     -22.438313
    [476]      -20.482286     -19.108812     -18.131842     -17.584028
    [480]      -17.632650     -18.517908     -20.563440     -24.208576
    [484]      -28.455015     -26.543348     -23.334066     -21.860088
    [488]      -21.774385     -22.767076     -24.690002     -27.544958
    [492]      -31.253654     -34.101143     -33.801903     -33.263741
    [496]      -33.795063     -34.105713     -33.291454     -32.765388
    [500]      -32.944290     -31.962807     -29.337435     -27.129257
    [504]      -26.110647     -26.279600     -27.474613     -29.356539
    [508]      -31.237007     -32.423996     -33.035149     -33.463470
    [512]      -33.655846
  [Tag]        10081
  [frame_len]          320
[Record 64]
  [tot_power]       570976.62
  [re_spec_val]
    [0]      -41.402489     -30.455851     -27.891888     -32.778011
    [4]      -34.262058     -23.056671     -19.834946     -22.523649
    [8]      -23.963667     -8.5710764    -0.86521518      4.4184756
    [12]       8.1521959      10.587165      11.762674      11.586926
    [16]       9.8257027      6.0479865    -0.16156393     -6.6150198
    [20]      -9.6924400     -3.5492780    -0.23826566      8.6947384
    [24]       17.770069      24.010836      28.289164      31.098654
    [28]       32.681580      33.144928      32.504333      30.693230
    [32]       27.556156      22.897049      17.124363      12.779794
    [36]       8.1286383      4.4689426      15.149167      20.859888
    [40]       24.637766      27.261551      28.883734      29.512318
    [44]       29.114710      27.616934      24.874945      20.635210
    [48]       14.581788      7.3989806      1.5561366    -0.52848744
    [52]       9.6725197      15.965522      20.404873      23.695505
    [56]       25.968969      27.228760      27.437037      26.501703
    [60]       24.231333      20.241026      13.746057      3.7427804
    [64]      -11.054776      5.8658533      15.709508      21.681847
    [68]       26.051023      29.351639      31.669172      32.985748
    [72]       33.255291      32.389843      30.216026      26.391998
    [76]       20.252117      11.382034      6.9624486      11.360846
    [80]       18.867081      23.928968      27.559202      30.428141
    [84]       32.630299      34.042500      34.543636      34.037804
    [88]       32.409096      29.464874      24.884232      18.560129
    [92]       13.977580      12.728246      9.8389521      11.650756
    [96]       16.429260      19.851463      22.571938      24.740189
    [100]       26.099905      26.410078      25.478699      23.086452
    [104]       19.044230      14.001945      9.0643311     -9.8389196
    [108]       15.382706      22.526230      26.924833      30.193945
    [112]       32.797096      34.737526      35.893288      36.165085
    [116]       35.494167      33.864967      31.369377      28.371376
    [120]       25.488173      22.923983      20.943750      21.116558
    [124]       22.621723      23.784653      24.783371      26.133587
    [128]       27.528963      28.381876      28.397261      27.475229
    [132]       25.546751      22.468437      17.850760      10.213209
    [136]      -8.4101238      9.5505762      14.541780      17.366903
    [140]       19.069427      19.948988      20.178942      19.884018
    [144]       19.120365      17.849056      15.935925      13.164467
    [148]       9.2425232      4.0069995    -0.53823495     -1.0861392
    [152]      -1.6241764     -2.7405164     -1.5389227     0.74286389
    [156]       1.9108179      1.6104118    -0.23258293     -3.6339135
    [160]      -6.3283591     -4.5194879     -2.7699902     -2.9148788
    [164]      -5.2712374     -11.250969     -26.062740     -11.743092
    [168]      -8.4588423     -8.5999784     -11.534147     -18.605207
    [172]      -20.820419     -15.348518     -14.197320     -14.068246
    [176]      -11.423617     -8.3156452     -6.7970748     -7.3366284
    [180]      -10.976001     -24.401594     -10.847331     -4.5325227
    [184]      -1.3435082     0.36947456      1.0979863     0.98852974
    [188]    0.0071711829     -2.0245719     -5.4798255     -11.103360
    [192]      -18.881523     -19.288923     -21.380053     -30.913183
    [196]      -14.787554     -9.2873831     -6.6507187     -5.6321907
    [200]      -5.8030496     -7.0230007     -9.3383322     -12.825230
    [204]      -16.059685     -15.036321     -12.784963     -11.701673
    [208]      -11.817746     -13.010616     -15.281077     -18.723209
    [212]      -23.134960     -26.050293     -24.894142     -22.381813
    [216]      -19.538239     -16.678226     -14.192028     -12.376870
    [220]      -11.417306     -11.403291     -12.257991     -13.364959
    [224]      -13.307524     -11.899962     -10.491374     -9.7535744
    [228]      -9.7933197     -10.626360     -12.362636     -15.353891
    [232]      -20.492981     -26.211489     -20.969843     -17.443493
    [236]      -16.304516     -16.872066     -18.712063     -20.433901
    [240]      -19.907379     -18.380424     -17.158566     -16.016699
    [244]      -14.824933     -14.023292     -14.091908     -15.298204
    [248]      -17.630478     -20.203634     -21.404184     -22.609407
    [252]      -26.998125     -27.526104     -19.122253     -14.483212
    [256]      -11.705861     -9.9436569     -8.8348236     -8.2633152
    [260]      -8.2387772     -8.8028030     -9.9948854     -11.922946
    [264]      -15.026723     -20.804773     -23.868256     -15.651574
    [268]      -11.265189     -8.9484100     -7.9701686     -8.0441647
    [272]      -9.0387897     -10.917525     -13.825798     -18.512814
    [276]      -28.496317     -24.710762     -18.213949     -15.888753
    [280]      -15.934216     -18.432642     -25.723616     -29.606739
    [284]      -19.534237     -15.782124     -13.917823     -12.901608
    [288]      -12.417006     -12.500075     -13.261868     -14.648228
    [292]      -16.322332     -18.101416     -20.932182     -26.124969
    [296]      -21.152885     -14.893324     -11.333302     -9.3778849
    [300]      -8.5289917     -8.5402184     -9.2892714     -10.738496
    [304]      -12.914198     -15.900632     -20.035072     -27.772163
    [308]      -28.840525     -17.548481     -11.938974     -8.4532404
    [312]      -6.3708644     -5.4372702     -5.5503063     -6.6735616
    [316]      -8.7667484     -11.602418     -14.357575     -15.950138
    [320]      -16.701145     -17.340109     -18.045860     -19.093275
    [324]      -19.013016     -14.803520     -10.135210     -6.7429442
    [328]      -4.5181303     -3.2184465     -2.6283517     -2.5463278
    [332]      -2.8131852     -3.3794429     -4.2928658     -5.5231237
    [336]      -6.7812943     -7.8413210     -9.2466812     -11.826174
    [340]      -12.544846     -7.9114237     -4.0978160     -1.9237952
    [344]      -1.0076840     -1.0745933     -1.9408176     -3.4800613
    [348]      -5.6025901     -8.1116915     -10.128135     -10.044333
    [352]      -8.2258415     -6.1362257     -4.3800564     -3.1613250
    [356]      -2.5540333     -2.5435557     -3.0781088     -4.1682234
    [360]      -6.0048332     -9.0798998     -14.378148     -18.214247
    [364]      -12.544338     -8.9298468     -7.0826516     -6.2314348
    [368]      -5.8871770     -5.6780248     -5.4875088     -5.5212455
    [372]      -6.0867395     -7.3869452     -9.4138689     -11.734306
    [376]      -13.443080     -14.355151     -15.279727     -16.431120
    [380]      -17.233557     -17.706676     -18.923367     -22.127258
    [384]      -27.697309     -23.449474     -18.227417     -15.378510
    [388]      -13.881063     -13.144393     -12.700713     -12.202816
    [392]      -11.557657     -10.862833     -10.218403     -9.6746054
    [396]      -9.2709646     -9.0521126     -9.0544548     -9.3079166
    [400]      -9.8630171     -10.822497     -12.343302     -14.615524
    [404]      -17.878462     -22.706224     -31.308456     -27.403927
    [408]      -20.240187     -16.409689     -14.348070     -13.598856
    [412]      -14.047830     -15.846032     -19.722300     -29.796028
    [416]      -27.525223     -19.117069     -15.635660     -13.991797
    [420]      -13.500852     -13.915817     -15.115022     -16.955944
    [424]      -19.094990     -20.775591     -20.890661     -19.094603
    [428]      -16.623703     -14.640244     -13.575486     -13.534618
    [432]      -14.533038     -16.523472     -19.175043     -21.105680
    [436]      -20.460543     -18.285885     -16.144190     -14.581780
    [440]      -13.799437     -13.918731     -15.067993     -17.437733
    [444]      -21.217232     -25.038778     -24.171288     -22.105846
    [448]      -21.544401     -22.679729     -25.688372     -28.235764
    [452]      -24.520317     -20.924019     -19.034351     -18.367193
    [456]      -18.274067     -17.771151     -16.296665     -14.470675
    [460]      -12.983356     -12.062389     -11.698743     -11.804696
    [464]      -12.273486     -13.019216     -14.019684     -15.332881
    [468]      -17.009827     -18.698248     -19.073444     -17.668941
    [472]      -16.056274     -15.181358     -15.231084     -16.178608
    [476]      -17.924479     -20.309198     -23.151209     -26.012077
    [480]      -26.570696     -23.824778     -20.981689     -19.105879
    [484]      -18.168644     -18.016685     -18.461000     -19.215487
    [488]      -19.903782     -20.320004     -20.675316     -21.382757
    [492]      -22.787554     -25.188440     -29.072123     -35.963989
    [496]      -45.206905     -35.031021     -30.873037     -28.947012
    [500]      -28.372416     -29.028059     -31.157612     -35.617188
    [504]      -45.227345     -40.347347     -34.738804     -32.230743
    [508]      -31.077702     -30.777391     -31.174868     -31.992052
    [512]      -32.463757
  [Tag]        10241
  [frame_len]          320
[Record 65]
  [tot_power]       598387.69
  [re_spec_val]
    [0]      -22.740402     -24.408815     -31.692314     -36.117752
    [4]      -27.115551     -22.575254     -19.118673     -21.153248
    [8]      -18.795713     -6.4592299    0.020260392      4.0989194
    [12]       6.6956234      8.1235094      8.4202042      7.4867492
    [16]       5.1811314      1.3566000     -3.0987470    -0.85664159
    [20]       2.5608308      3.6617150      10.514978      18.356668
    [24]       23.828226      27.500057      29.771006      30.837875
    [28]       30.776030      29.566507      27.090919      23.153131
    [32]       18.163166      15.948800      16.229330      15.066056
    [36]       15.268200      20.342583      24.912575      28.027611
    [40]       29.949133      30.833181      30.724325      29.585663
    [44]       27.291101      23.568283      17.878010      10.292445
    [48]       9.0445108      10.983457      14.564631      19.274967
    [52]       23.050587      25.678572      27.293337      27.965992
    [56]       27.682833      26.349239      23.774916      19.699646
    [60]       14.717330      13.465689      15.228359      18.140711
    [64]       22.594570      26.926266      30.366053      32.835651
    [68]       34.358849      34.942020      34.563107      33.183159
    [72]       30.807482      27.733530      24.995916      23.423195
    [76]       22.539940      23.487040      26.779112      30.172127
    [80]       32.771542      34.496990      35.355453      35.335972
    [84]       34.418083      32.601696      29.981064      26.872791
    [88]       23.696117      20.128531      14.540283      10.903192
    [92]       17.422640      21.179476      23.147600      24.100637
    [96]       24.319172      23.868750      22.823633      21.654961
    [100]       21.395792      22.165031      22.909847      23.232878
    [104]       23.798023      25.590511      28.285303      30.891443
    [108]       32.892708      34.099918      34.432240      33.866165
    [112]       32.502411      30.782784      29.509890      28.767128
    [116]       27.541794      24.784866      19.421391      16.075871
    [120]       21.477119      24.784866      26.631184      27.674175
    [124]       28.035564      27.632132      26.342632      24.034115
    [128]       20.533926      15.635389      9.3964090      2.6931565
    [132]      -1.1271263      7.2281432      12.707046      15.803514
    [136]       17.448038      18.104992      18.028793      17.329439
    [140]       16.001411      13.992523      11.366068      8.5943670
    [144]       6.4461236      4.8981247      4.1390781      5.7470722
    [148]       8.4167919      10.316756      11.115912      10.894050
    [152]       9.7790909      7.9380860      5.7178850      3.9087968
    [156]       3.3188429      3.4761341      3.3819335      2.5903783
    [160]       1.2398782     0.29067487     0.88613415      2.2771637
    [164]       3.2485743      3.3510597      2.4578807     0.47739130
    [168]      -2.7450194     -7.4731297     -13.759315     -18.514429
    [172]      -20.201149     -26.754728     -26.698944     -16.174738
    [176]      -11.550929     -8.8998966     -7.3210287     -6.4564605
    [180]      -6.1654582     -6.3627949     -6.7833157     -6.8643618
    [184]      -6.3747849     -5.9480228     -6.3783860     -8.2992382
    [188]      -12.412131     -15.390471     -10.611221     -7.3183694
    [192]      -6.0409589     -6.3027377     -7.9782805     -11.098839
    [196]      -14.614346     -13.988608     -11.382337     -9.8793316
    [200]      -9.6050339     -10.493979     -12.693748     -16.554466
    [204]      -21.184568     -20.590055     -18.847963     -19.498730
    [208]      -23.119541     -32.807716     -34.905064     -28.630180
    [212]      -28.810768     -30.633055     -28.804979     -26.234909
    [216]      -25.185787     -24.633276     -22.411037     -18.949890
    [220]      -16.059931     -14.278984     -13.628353     -13.983268
    [224]      -14.919364     -15.469099     -15.144703     -14.909982
    [228]      -15.682055     -17.400969     -17.885752     -15.939153
    [232]      -14.358916     -14.342991     -16.198681     -20.095802
    [236]      -22.000816     -18.483105     -16.251780     -15.898363
    [240]      -17.213066     -20.590408     -28.683119     -27.153788
    [244]      -18.866890     -14.890938     -12.781756     -11.903555
    [248]      -12.019994     -13.060723     -15.093313     -18.301451
    [252]      -22.386736     -24.025522     -23.101936     -24.179827
    [256]      -31.133387     -31.342373     -21.159105     -17.192596
    [260]      -15.524575     -15.278704     -16.020702     -17.314064
    [264]      -18.366400     -18.020077     -16.344824     -14.647641
    [268]      -13.751172     -13.988032     -15.520844     -17.874172
    [272]      -17.904882     -15.169962     -12.981490     -11.938690
    [276]      -11.800568     -12.176958     -12.561046     -12.579153
    [280]      -12.357462     -12.338260     -12.919190     -14.445894
    [284]      -17.423811     -22.764128     -24.933697     -19.108023
    [288]      -15.507421     -13.440578     -12.167640     -11.265416
    [292]      -10.499978     -9.8114986     -9.2840967     -9.0798531
    [296]      -9.3770685     -10.339134     -12.091982     -14.637812
    [300]      -17.510084     -19.427490     -19.998804     -20.280689
    [304]      -20.221828     -18.910685     -16.712479     -14.649404
    [308]      -13.196323     -12.534749     -12.828332     -14.288390
    [312]      -16.793549     -17.447010     -14.309628     -11.376273
    [316]      -9.5399446     -8.4862261     -7.8456607     -7.3522563
    [320]      -6.9092498     -6.5659199     -6.4456010     -6.7015276
    [324]      -7.4934311     -8.9563599     -11.119085     -13.610779
    [328]      -15.046880     -14.070144     -11.575046     -8.7904577
    [332]      -6.3152041     -4.3885112     -3.0618706     -2.3036757
    [336]      -2.0657251     -2.3380406     -3.2002931     -4.8428559
    [340]      -7.4683065     -10.439446     -10.625060     -8.7836065
    [344]      -7.8482819     -8.0633936     -8.4141636     -7.4580550
    [348]      -5.6318107     -4.0733595     -3.0107212     -2.2102103
    [352]      -1.4529856    -0.78291517    -0.41262496    -0.44322020
    [356]     -0.59418339   -0.061066717      1.6744777      4.0067325
    [360]       6.2145653      8.0002003      9.2752018      10.003421
    [364]       10.148456      9.6542740      8.4321756      6.3456278
    [368]       3.1882815     -1.3331710     -7.3762374     -11.945498
    [372]      -8.9968643     -4.3494792    -0.65804839      1.8182138
    [376]       3.2113793      3.6769092      3.3194799      2.1806853
    [380]      0.23134185     -2.6372616     -6.5417614     -10.737179
    [384]      -11.728776     -10.375637     -9.6941042     -9.9581041
    [388]      -10.889280     -12.290574     -14.172002     -16.438475
    [392]      -17.412535     -15.204579     -12.411479     -10.624396
    [396]      -10.064071     -10.703060     -12.106936     -12.437235
    [400]      -10.476593     -8.1504021     -6.4757147     -5.5058541
    [404]      -5.1836872     -5.5284872     -6.6470637     -8.7410975
    [408]      -12.170056     -17.427652     -21.432512     -18.643272
    [412]      -16.655050     -15.830128     -14.626574     -12.495177
    [416]      -10.310764     -8.6968956     -7.8068538     -7.6667132
    [420]      -8.3158226     -9.8511715     -12.484439     -16.723438
    [424]      -23.611526     -23.972404     -18.365925     -15.372663
    [428]      -13.952217     -13.636381     -14.266196     -15.879792
    [432]      -18.872423     -24.905035     -42.936398     -23.724337
    [436]      -19.090628     -17.461903     -17.757059     -19.675539
    [440]      -21.412474     -18.844803     -15.213699     -12.632030
    [444]      -11.043056     -10.330751     -10.541156     -11.895001
    [448]      -14.931463     -21.293182     -27.134432     -18.510601
    [452]      -14.897068     -13.484820     -13.360408     -14.125340
    [456]      -15.299483     -15.811417     -14.833282     -13.313137
    [460]      -12.331607     -12.278627     -13.219971     -14.961309
    [464]      -16.803059     -17.855036     -18.045698     -17.086016
    [468]      -14.861178     -12.634768     -11.257153     -10.921929
    [472]      -11.661201     -13.578463     -17.005306     -22.477074
    [476]      -25.160971     -21.417723     -19.633270     -19.991169
    [480]      -22.263285     -26.132404     -27.572811     -24.828529
    [484]      -22.833982     -22.098707     -22.314272     -23.290283
    [488]      -24.823822     -26.161234     -25.868959     -24.278067
    [492]      -22.911930     -22.378790     -22.758001     -23.968792
    [496]      -25.774761     -27.604099     -28.585716     -28.478561
    [500]      -27.985312     -27.776739     -28.190254     -29.382286
    [504]      -31.418076     -34.282021     -37.854748     -41.860558
    [508]      -44.284798     -41.624081     -38.194881     -36.120522
    [512]      -35.445396
  [Tag]        10401
  [frame_len]          320
[Record 66]
  [tot_power]       723566.56
  [re_spec_val]
    [0]      -24.408321     -28.218361     -41.808937     -28.076569
    [4]      -33.259659     -26.175467     -19.626745     -24.704042
    [8]      -15.615008     -4.8101964     0.80425996      4.1605711
    [12]       6.1255617      7.1563926      7.5237083      7.2730622
    [16]       6.0970984      3.2579570    -0.88927960     0.87766153
    [20]       1.8498046      4.2683830      14.570140      21.446810
    [24]       25.984570      28.943102      30.663839      31.309849
    [28]       30.946367      29.563280      27.071583      23.322844
    [32]       18.575706      15.716058      16.114290      17.463354
    [36]       21.049780      25.344490      28.697376      30.898714
    [40]       32.021095      32.109455      31.135826      28.968773
    [44]       25.290407      19.426191      12.564220      14.409213
    [48]       16.136900      17.593357      20.876129      24.283113
    [52]       26.721540      28.121469      28.557775      28.051775
    [56]       26.529585      23.793184      19.706026      16.576319
    [60]       18.018145      19.469069      20.862253      24.681961
    [64]       29.089741      32.433254      34.571861      35.605404
    [68]       35.601742      34.583855      32.588440      29.924068
    [72]       27.790833      27.305206      27.301003      27.054235
    [76]       28.054701      31.056475      34.126514      36.299477
    [80]       37.462078      37.643280      36.853523      35.059669
    [84]       32.181259      28.122042      23.114202      19.380180
    [88]       19.185951      19.984413      20.812025      21.746572
    [92]       22.707355      23.535173      24.111948      24.351982
    [96]       24.207262      23.789982      23.555027      23.974384
    [100]       24.678961      24.825087      23.983740      23.231710
    [104]       25.509655      29.060150      31.676590      33.152340
    [108]       33.642715      33.338570      32.500126      31.494808
    [112]       30.635195      29.868122      28.801786      26.952770
    [116]       23.684744      17.719492      14.532050      20.982466
    [120]       24.316881      25.681179      25.719629      24.632477
    [124]       22.415588      18.990509      14.699504      11.719532
    [128]       10.797328      9.2798471      8.2839088      10.938943
    [132]       13.889306      15.622625      16.298758      16.141130
    [136]       15.267218      13.719652      11.566121      9.1238403
    [140]       7.1265712      5.9573679      5.1224570      4.7849908
    [144]       5.9564366      8.0723867      9.8999872      11.015379
    [148]       11.375569      10.995824      9.8803444      8.0548344
    [152]       5.7201619      3.5707586      2.5317581      2.3670077
    [156]       2.2378657      1.9414194      1.8510870      2.4235890
    [160]       3.5111756      4.4811788      4.8191166      4.2138801
    [164]       2.3809009     -1.1614155     -7.3397293     -10.774791
    [168]      -6.3230829     -4.4905219     -4.6601963     -6.1272068
    [172]      -8.3065166     -10.325998     -11.306005     -11.349698
    [176]      -11.096885     -10.921393     -11.025103     -11.566382
    [180]      -12.586326     -13.880908     -15.015294     -15.515951
    [184]      -14.710176     -12.411514     -9.8072271     -7.8578014
    [188]      -6.8661728     -6.9045391     -7.9903450     -9.9707727
    [192]      -11.859224     -11.873721     -10.763889     -10.139885
    [196]      -10.338402     -11.073082     -11.653698     -11.329880
    [200]      -10.224055     -9.1129427     -8.5705147     -8.9112062
    [204]      -10.405967     -13.498560     -18.999935     -22.029524
    [208]      -17.131657     -14.426181     -13.549240     -13.871587
    [212]      -15.054183     -16.822763     -18.831930     -20.670815
    [216]      -22.082764     -22.765154     -21.935951     -19.879791
    [220]      -17.941031     -16.818220     -16.709831     -17.730797
    [224]      -20.106119     -24.257986     -28.400587     -24.996176
    [228]      -21.218569     -18.841082     -17.110758     -15.440743
    [232]      -13.641794     -11.930471     -10.604153     -9.8341284
    [236]      -9.6680794     -10.070101     -10.932652     -12.068210
    [240]      -13.221287     -14.175353     -14.934185     -15.741105
    [244]      -16.826132     -17.978062     -18.230068     -17.180908
    [248]      -15.929545     -15.317274     -15.579789     -16.734535
    [252]      -18.642935     -20.532675     -20.549927     -18.753418
    [256]      -16.976965     -15.938533     -15.762223     -16.470707
    [260]      -17.997334     -19.738569     -19.978041     -18.481007
    [264]      -17.055685     -16.547764     -17.168531     -19.075350
    [268]      -22.437828     -26.475447     -27.411543     -26.323181
    [272]      -24.556623     -20.883230     -17.173580     -14.537640
    [276]      -12.985414     -12.335711     -12.395858     -12.950291
    [280]      -13.720345     -14.382763     -14.779294     -15.142071
    [284]      -15.952992     -17.694828     -20.721447     -23.785809
    [288]      -21.940233     -18.538328     -16.235334     -14.932028
    [292]      -14.444880     -14.709288     -15.716782     -17.427362
    [296]      -19.545521     -21.072935     -20.939590     -19.738434
    [300]      -18.343948     -17.010969     -15.847310     -14.963315
    [304]      -14.418505     -14.233800     -14.436097     -15.011744
    [308]      -15.741583     -16.196814     -16.348875     -16.873205
    [312]      -18.363312     -19.694088     -17.376200     -13.805652
    [316]      -11.222789     -9.6351881     -8.7905407     -8.4890146
    [320]      -8.6035480     -9.0881939     -9.9845343     -11.405933
    [324]      -13.486963     -16.272375     -19.446148     -21.788059
    [328]      -20.953573     -17.341637     -13.816483     -11.341583
    [332]      -9.9337301     -9.4250011     -9.6214390     -10.378851
    [336]      -11.673218     -13.413848     -14.276696     -12.095036
    [340]      -8.7690077     -6.0511255     -4.1418347     -2.9318867
    [344]      -2.3038235     -2.1841445     -2.5759001     -3.5750337
    [348]      -5.3198843     -7.7654958     -10.172434     -11.465010
    [352]      -11.052583     -7.5081310     -3.1726277   0.0050078365
    [356]       1.9212819      2.8682392      3.3080075      3.8467476
    [360]       4.8333855      6.0028653      6.8646021      7.0642605
    [364]       6.3581371      4.4939814      1.0620522     -4.9213052
    [368]      -16.493162     -11.033732     -5.4493442     -1.6499500
    [372]       1.1656803      2.8989604      3.5765684      3.3081291
    [376]       2.2592852     0.70884252    -0.87021714     -1.7424793
    [380]      -1.1340154     0.67515451      2.5606766      3.8450513
    [384]       4.3277917      3.9847400      2.8387671     0.92716652
    [388]      -1.6919031     -4.9184413     -8.6448441     -12.698121
    [392]      -13.652473     -9.0812836     -4.9339509     -2.1618919
    [396]     -0.53758591     0.13557722    0.020712482    -0.69665241
    [400]      -1.7827641     -3.0166183     -4.3193803     -5.7849526
    [404]      -7.5975046     -10.055140     -13.771046     -20.221460
    [408]      -31.946756     -26.185024     -24.884609     -20.080671
    [412]      -14.245860     -10.745550     -9.0592737     -8.6901407
    [416]      -9.1923971     -9.9946289     -10.461541     -10.197149
    [420]      -9.1276550     -7.5526299     -6.0274620     -4.9679608
    [424]      -4.5571723     -4.8534465     -5.8729277     -7.6195226
    [428]      -10.081370     -13.191224     -16.621544     -18.694883
    [432]      -16.738621     -12.995238     -9.6843119     -7.2198505
    [436]      -5.6280951     -4.8687234     -4.8638444     -5.4725308
    [440]      -6.4654522     -7.5797176     -8.6775808     -9.7981558
    [444]      -11.030711     -12.520892     -14.625065     -17.886303
    [448]      -22.556734     -26.384327     -24.863064     -18.865555
    [452]      -13.386840     -9.6186495     -7.2445679     -5.8764191
    [456]      -5.1522875     -4.7355170     -4.3429866     -3.7191882
    [460]      -2.6364763     -1.1259893     0.44834056      1.7010537
    [464]       2.4116409      2.4898498      1.9112664     0.68941569
    [468]      -1.1138865     -3.3366272     -5.6200361     -7.3537226
    [472]      -7.9550657     -7.4475889     -6.4219913     -5.4500446
    [476]      -4.8539009     -4.7788639     -5.2771711     -6.3311052
    [480]      -7.8277078     -9.5357609     -11.206737     -12.794512
    [484]      -14.400719     -15.886911     -16.866102     -17.431084
    [488]      -18.217731     -19.670351     -21.769947     -23.859028
    [492]      -24.597189     -23.669434     -22.327194     -21.443817
    [496]      -21.233814     -21.559210     -22.055511     -22.292051
    [500]      -22.053545     -21.473133     -20.886086     -20.620232
    [504]      -20.883501     -21.742195     -23.107941     -24.692636
    [508]      -26.123253     -27.400244     -29.035597     -31.360380
    [512]      -32.926964
  [Tag]        10561
  [frame_len]          320
[Record 67]
  [tot_power]       747453.88
  [re_spec_val]
    [0]      -30.748762     -28.079470     -25.300924     -26.609678
    [4]      -41.031422     -23.690834     -20.152765     -23.914093
    [8]      -12.731809     -4.5924082     0.19940983      3.1586943
    [12]       4.9192238      5.8226333      6.0161767      5.4021444
    [16]       3.5345423     0.13038300     0.72436082      4.4610281
    [20]       4.6008263      5.5845513      15.218144      21.866461
    [24]       26.200668      28.950697      30.430378      30.766794
    [28]       29.972275      27.944960      24.399202      18.686497
    [32]       11.512213      13.308219      15.855800      18.651098
    [36]       22.885691      26.808538      29.673391      31.437645
    [40]       32.138954      31.768282      30.237669      27.334097
    [44]       22.662357      16.756615      16.665094      18.873747
    [48]       20.023813      21.614571      24.173441      26.709873
    [52]       28.547430      29.486380      29.439871      28.257418
    [56]       25.567060      20.363417      12.917883      18.818199
    [60]       22.533037      24.549498      27.249781      30.728912
    [64]       33.737144      35.777122      36.796825      36.820545
    [68]       35.867813      34.013908      31.724529      30.372421
    [72]       30.539436      30.720087      29.951214      28.741301
    [76]       29.767176      32.872108      35.482410      37.007328
    [80]       37.479679      36.941586      35.360043      32.603844
    [84]       28.430696      22.985033      20.585060      22.455517
    [88]       23.991613      25.289549      26.760065      28.140436
    [92]       29.046722      29.284954      28.807974      27.681263
    [96]       26.234051      25.399637      25.988928      27.186417
    [100]       27.922644      27.829615      27.109732      26.801033
    [104]       27.976448      29.758324      31.020618      31.429544
    [108]       30.974293      29.750870      28.000143      26.244345
    [112]       25.102989      24.533045      23.882381      22.628279
    [116]       20.512131      17.437181      13.677939      11.334952
    [120]       12.691672      14.724713      15.677365      15.322622
    [124]       13.851981      12.133874      11.413207      11.076028
    [128]       9.6385841      6.1290493     -1.2130233     -19.741257
    [132]      -5.0004439     -4.2614460     -6.4736185     -3.9883325
    [136]      0.38681859      3.3759630      5.3458734      6.5246806
    [140]       6.8804202      6.2971454      4.7377911      2.7148569
    [144]       2.0702987      3.2574828      4.2832642      4.2153215
    [148]       2.7738419    -0.45169923     -5.8514795     -5.6040092
    [152]     -0.98509169      1.4539329      2.3480458      2.3134644
    [156]       1.9707325      1.9797673      2.5108037      3.1153381
    [160]       3.3115835      2.8044581      1.3925306     -1.0080668
    [164]      -3.6405547     -3.8957782     -2.3205297     -1.3726696
    [168]      -1.5664539     -2.8018630     -4.8019691     -6.9526038
    [172]      -8.2867212     -8.4653034     -8.1820154     -8.1565924
    [176]      -8.8123198     -10.417500     -13.201344     -17.459177
    [180]      -23.673990     -31.696634     -35.195309     -34.181038
    [184]      -26.938311     -21.089878     -17.496675     -15.597118
    [188]      -15.053239     -15.477929     -15.920783     -15.144807
    [192]      -13.598792     -12.435416     -12.062323     -12.458733
    [196]      -13.419520     -14.568561     -15.451226     -15.905492
    [200]      -16.251316     -16.978312     -18.348457     -19.429401
    [204]      -17.822477     -14.934163     -12.855983     -11.918660
    [208]      -12.032000     -13.049736     -14.742542     -16.639196
    [212]      -17.931179     -18.116444     -17.698935     -17.436247
    [216]      -17.774565     -18.915909     -20.738136     -22.114019
    [220]      -21.473129     -19.958931     -19.014765     -18.941006
    [224]      -19.671085     -21.047731     -22.797504     -24.387043
    [228]      -24.997114     -24.110401     -22.179096     -20.091452
    [232]      -18.459429     -17.570879     -17.539486     -18.370161
    [236]      -19.906029     -21.688570     -23.090471     -23.922634
    [240]      -24.263800     -24.204073     -24.598967     -27.084192
    [244]      -33.466045     -26.133867     -19.923183     -16.817148
    [248]      -15.597543     -15.871317     -17.526070     -20.547266
    [252]      -24.871639     -30.527523     -35.514942     -28.243853
    [256]      -22.781456     -19.691473     -18.121540     -17.604246
    [260]      -17.803308     -18.476099     -19.555536     -21.185373
    [264]      -23.535189     -26.174057     -27.324936     -26.877975
    [268]      -26.450994     -25.089785     -21.714024     -18.153284
    [272]      -15.450246     -13.667394     -12.671292     -12.304725
    [276]      -12.409475     -12.835585     -13.429749     -13.985515
    [280]      -14.290595     -14.393987     -14.679151     -15.507820
    [284]      -16.773100     -17.417868     -16.580746     -15.384455
    [288]      -14.876579     -15.307182     -16.612011     -18.551252
    [292]      -20.650681     -22.237467     -22.665113     -21.718168
    [296]      -20.043299     -18.454338     -17.317543     -16.696720
    [300]      -16.552338     -16.825041     -17.460245     -18.404562
    [304]      -19.591042     -20.963161     -22.670713     -25.457315
    [308]      -29.047091     -23.122847     -16.702276     -12.443937
    [312]      -9.6279716     -7.8854051     -7.0150499     -6.8806076
    [316]      -7.3694944     -8.3797073     -9.8131342     -11.548571
    [320]      -13.421942     -15.433724     -18.299467     -23.831163
    [324]      -22.089691     -14.789561     -10.653348     -8.2935696
    [328]      -7.0799894     -6.6764989     -6.8462505     -7.3980765
    [332]      -8.1841230     -9.1054440     -10.088910     -11.025444
    [336]      -11.742440     -12.104688     -12.137207     -11.954285
    [340]      -11.655584     -11.375937     -11.334324     -11.786201
    [344]      -12.983444     -15.159791     -18.117449     -19.105917
    [348]      -16.333496     -12.654978     -8.6370487     -4.7343683
    [352]      -1.5116086     0.81389314      2.2249727      2.7598481
    [356]       2.4605424      1.3603035    -0.50542188     -3.0274806
    [360]      -5.7602715     -7.3302960     -5.9263387     -2.4246142
    [364]       1.1620362      4.0568957      6.1474409      7.5003610
    [368]       8.2217588      8.4222021      8.2062712      7.6681533
    [372]       6.8912926      5.9516716      4.9195762      3.8522711
    [376]       2.7761130      1.6669974     0.44569007    -0.98989815
    [380]      -2.6499202     -4.1752105     -4.7292190     -4.1473255
    [384]      -3.3517346     -2.9732177     -3.0371101     -3.1946037
    [388]      -3.0614250     -2.6780326     -2.3587048     -2.1108766
    [392]      -1.4981616    -0.29729879      1.0083935      1.8469326
    [396]       1.9406940      1.2039452    -0.34857124     -2.5337586
    [400]      -4.6835613     -5.5964265     -5.1031761     -4.1410761
    [404]      -3.1574018     -2.1815143     -1.2651355    -0.58559757
    [408]     -0.34513602    -0.68565512     -1.6672016     -3.2446668
    [412]      -5.1735525     -6.8685694     -7.6737103     -7.6630592
    [416]      -7.4417076     -7.4385767     -7.8616481     -8.8342533
    [420]      -10.424278     -12.537691     -14.649455     -15.896860
    [424]      -16.169531     -15.720637     -14.257445     -12.116904
    [428]      -10.154689     -8.7949028     -8.0810413     -7.8388124
    [432]      -7.6783261     -7.1753187     -6.3618264     -5.7018838
    [436]      -5.5822420     -6.1131182     -7.0640774     -7.7230082
    [440]      -7.3727779     -6.3218379     -5.2722049     -4.5064797
    [444]      -4.0047216     -3.6587756     -3.4018762     -3.2758260
    [448]      -3.3978415     -3.8465011     -4.5302415     -5.1119547
    [452]      -5.2108035     -4.8287702     -4.2615314     -3.7179427
    [456]      -3.3169045     -3.2332275     -3.7190933     -5.0698280
    [460]      -7.6719604     -12.275159     -21.487888     -24.308229
    [464]      -16.313747     -11.998334     -8.3935108     -5.5336637
    [468]      -3.5767915     -2.4936492     -2.1909280     -2.5518658
    [472]      -3.4048309     -4.4622536     -5.3544569     -5.9156580
    [476]      -6.3891835     -7.1534324     -8.3750782     -9.7295265
    [480]      -10.251978     -9.5605650     -8.5924253     -8.0656290
    [484]      -8.1293907     -8.6948881     -9.5923700     -10.639729
    [488]      -11.710769     -12.769635     -13.797478     -14.660570
    [492]      -15.124166     -15.110735     -14.831266     -14.573006
    [496]      -14.541003     -14.867769     -15.649524     -16.959772
    [500]      -18.855984     -21.382679     -24.527496     -27.940298
    [504]      -30.115295     -29.339422     -26.801241     -23.994263
    [508]      -21.525694     -19.611694     -18.291372     -17.530170
    [512]      -17.282907
  [Tag]        10721
  [frame_len]          320
[Record 68]
  [tot_power]       614653.25
  [re_spec_val]
    [0]      -29.977180     -37.263103     -32.233391     -26.604471
    [4]      -31.625183     -28.106411     -21.019909     -24.291412
    [8]      -18.281841     -6.8685622    -0.72546214      3.2501049
    [12]       5.8673668      7.4130478      7.9705148      7.5284219
    [16]       5.9364824      2.5084600     -5.0246563     -1.7305704
    [20]       2.9956460     0.83607888      7.8496313      17.727793
    [24]       23.730593      27.633957      30.061125      31.271498
    [28]       31.370920      30.376322      28.236420      24.843262
    [32]       20.113514      14.563392      9.9889231      1.7385254
    [36]       9.2753925      19.828529      25.643690      29.334362
    [40]       31.550873      32.547935      32.434422      31.243109
    [44]       28.960817      25.568426      21.194183      16.602510
    [48]       12.691286      6.0099216      11.526488      20.865805
    [52]       26.191694      29.512226      31.415232      32.115433
    [56]       31.659712      29.963631      26.797173      21.976158
    [60]       17.614351      16.256639      14.360845      22.932869
    [64]       29.908590      34.308697      37.085270      38.651920
    [68]       39.192001      38.767971      37.347427      34.780151
    [72]       30.704813      24.379585      18.394768      21.430965
    [76]       23.195957      23.281197      22.665804      22.602140
    [80]       24.369835      26.846092      28.583559      29.172640
    [84]       28.568966      26.799501      23.997736      20.767311
    [88]       18.609591      18.433388      19.817602      22.225529
    [92]       24.792757      26.910271      28.359585      29.075171
    [96]       29.009762      28.076313      26.098551      22.704056
    [100]       16.992083      9.3369627      14.408353      18.487494
    [104]       20.953772      22.864500      24.463587      25.708572
    [108]       26.500231      26.741720      26.353323      25.279772
    [112]       23.492611      20.988483      17.777933      13.845678
    [116]       9.0717850      3.4784391      1.3292800      5.2481956
    [120]       9.0144176      11.894518      14.004519      15.379659
    [124]       16.012934      15.885548      14.976774      13.264057
    [128]       10.714538      7.2532377      2.6392953     -4.1066909
    [132]      -19.644289     -8.8926020     -3.4142327    -0.75592983
    [136]      0.92569178      2.3021636      3.5397143      4.4357595
    [140]       4.6955652      4.0733848      2.3206718    -0.99459553
    [144]      -7.1131015     -26.593699     -12.965838     -9.6769829
    [148]      -11.489078     -20.106230     -12.339161     -5.8362494
    [152]      -2.9253073     -1.9422855     -2.4072223     -4.1713381
    [156]      -7.2057300     -11.314309     -14.806663     -15.120914
    [160]      -14.924545     -16.488838     -16.790180     -11.121729
    [164]      -6.5590096     -3.9338284     -2.8380387     -3.0503361
    [168]      -4.4845982     -7.1312957     -11.011131     -16.116354
    [172]      -22.468075     -31.617714     -38.258228     -25.573254
    [176]      -19.792458     -16.236513     -14.266196     -13.667012
    [180]      -14.321066     -16.061993     -18.319258     -19.818514
    [184]      -20.233950     -20.839233     -22.481836     -25.499491
    [188]      -30.062319     -32.407173     -27.098318     -22.138512
    [192]      -18.670366     -16.530359     -15.625769     -15.916203
    [196]      -17.371223     -19.842993     -22.721325     -24.970594
    [200]      -26.829737     -29.418863     -29.917427     -25.252157
    [204]      -20.946835     -17.988697     -16.169031     -15.336184
    [208]      -15.394099     -16.255426     -17.791307     -19.763302
    [212]      -21.789837     -23.477348     -24.519136     -24.607252
    [216]      -23.953209     -23.459890     -23.932631     -25.979700
    [220]      -30.421217     -35.193916     -30.611092     -27.388643
    [224]      -26.292118     -26.535349     -27.664656     -29.198399
    [228]      -30.120102     -29.429859     -27.936155     -26.758238
    [232]      -26.069937     -25.334393     -23.924793     -22.058664
    [236]      -20.383095     -19.243912     -18.747221     -18.951515
    [240]      -19.944750     -21.824162     -24.466995     -26.400665
    [244]      -24.987513     -21.924829     -19.188171     -17.236048
    [248]      -16.217970     -16.246206     -17.451073     -19.967020
    [252]      -23.374895     -24.617504     -23.065973     -22.111443
    [256]      -22.449028     -23.917467     -26.298923     -29.429544
    [260]      -33.386353     -38.305897     -37.326412     -31.116528
    [264]      -26.565243     -23.602434     -22.050697     -21.947178
    [268]      -23.565550     -27.674875     -34.358376     -29.972242
    [272]      -25.919926     -24.007046     -22.640011     -21.117590
    [276]      -19.508713     -17.973986     -16.602835     -15.598393
    [280]      -15.242095     -15.785052     -17.436256     -20.339834
    [284]      -23.970631     -25.383385     -24.299847     -23.599806
    [288]      -23.557642     -23.521757     -23.107311     -22.549246
    [292]      -22.230017     -22.365839     -23.047987     -24.285341
    [296]      -25.924381     -27.446392     -28.075394     -27.494286
    [300]      -25.875603     -23.792166     -22.063169     -21.147984
    [304]      -20.902327     -20.406382     -18.932552     -17.360109
    [308]      -16.723803     -17.495752     -19.909288     -23.216698
    [312]      -23.309805     -21.445665     -20.622665     -20.089054
    [316]      -18.726496     -16.988611     -15.359484     -13.604233
    [320]      -11.734593     -10.234064     -9.5180693     -9.7981949
    [324]      -11.220544     -14.003166     -18.545851     -24.236515
    [328]      -23.562967     -20.985764     -20.262424     -20.924459
    [332]      -22.200903     -22.801346     -21.970106     -20.207411
    [336]      -17.987989     -15.742952     -13.909275     -12.755741
    [340]      -12.398450     -12.776635     -13.408120     -13.355212
    [344]      -12.484795     -11.541912     -10.543901     -8.9885330
    [348]      -7.1901846     -5.9918752     -5.9503064     -7.4866567
    [352]      -11.362744     -17.918573     -13.546941     -8.8842487
    [356]      -6.6291866     -5.6755328     -5.4942474     -5.5077453
    [360]      -4.7263765     -2.8852143     -1.0062796     0.13127765
    [364]      0.25100771    -0.78358871     -3.1623175     -7.1523962
    [368]      -11.846264     -12.153394     -11.175596     -12.527994
    [372]      -16.703564     -18.889164     -15.120253     -13.536543
    [376]      -14.330005     -16.824364     -17.936180     -14.900383
    [380]      -11.855392     -10.100247     -9.6031609     -10.141743
    [384]      -11.167052     -11.960168     -12.561120     -12.930840
    [388]      -11.217288     -8.0248098     -5.5876689     -4.4807262
    [392]      -4.7564130     -6.4975801     -9.8232155     -13.470174
    [396]      -12.653134     -10.291155     -9.0349884     -8.7400646
    [400]      -9.1475725     -9.9419899     -10.224518     -9.1276884
    [404]      -7.4668612     -6.2949705     -5.9657989     -6.5649495
    [408]      -8.1994200     -11.124322     -15.602073     -18.701750
    [412]      -16.386084     -14.810210     -15.247804     -17.469133
    [416]      -20.047922     -19.532303     -18.046549     -17.991287
    [420]      -19.274117     -20.252573     -19.320860     -18.231504
    [424]      -18.223057     -18.952618     -19.147074     -18.459328
    [428]      -17.795761     -16.878387     -14.843729     -12.501112
    [432]      -10.939633     -10.534317     -11.410054     -13.748466
    [436]      -17.933605     -23.265175     -21.827517     -18.662552
    [440]      -17.360365     -17.516293     -18.513294     -18.584589
    [444]      -16.488443     -14.057509     -12.405164     -11.650313
    [448]      -11.748329     -12.702016     -14.541313     -16.911934
    [452]      -17.895842     -16.527357     -15.256730     -15.381130
    [456]      -17.517502     -23.505861     -36.787960     -20.986160
    [460]      -16.919548     -15.674079     -16.114704     -17.652809
    [464]      -18.966736     -18.293020     -16.603451     -15.355795
    [468]      -14.959032     -15.623233     -17.699577     -20.666658
    [472]      -18.539570     -13.997655     -11.043532     -9.5513544
    [476]      -9.2631264     -10.071153     -11.964843     -14.919187
    [480]      -18.374746     -20.280430     -20.247133     -20.395990
    [484]      -21.101099     -21.190422     -19.941729     -18.415855
    [488]      -17.441954     -17.196941     -17.673155     -18.880772
    [492]      -20.916767     -23.982882     -28.010212     -30.146179
    [496]      -28.506874     -27.400602     -27.881336     -28.970551
    [500]      -27.882784     -25.277666     -23.557169     -23.277033
    [504]      -24.585867     -27.770025     -31.963501     -30.354704
    [508]      -27.151911     -25.765400     -25.797960     -26.605349
    [512]      -27.128975
  [Tag]        10881
  [frame_len]          320
[Record 69]
  [tot_power]       343362.31
  [re_spec_val]
    [0]      -43.006790     -42.414173     -30.227314     -27.107674
    [4]      -31.422461     -31.174143     -23.658075     -28.962446
    [8]      -17.327969     -6.6527529    -0.59754258      3.3174982
    [12]       5.8045759      7.1783605      7.6263766      7.2531023
    [16]       5.9017372      2.6594694     -5.9137120     -3.0111821
    [20]       3.1194987      7.8039494      15.056595      21.182287
    [24]       25.538055      28.431585      30.093752      30.647888
    [28]       30.140450      28.552244      25.773966      21.470888
    [32]       14.389020      1.8088294      13.119048      18.560427
    [36]       22.786465      26.471790      29.342396      31.241138
    [40]       32.143250      32.049740      30.927959      28.656542
    [44]       24.894913      18.594471      8.5003071      15.737695
    [48]       20.496212      23.826548      26.715382      29.020527
    [52]       30.545704      31.228725      31.077316      30.131132
    [56]       28.472610      26.271870      23.794287      21.192316
    [60]       18.313725      16.778179      20.708820      25.615202
    [64]       29.401091      32.133869      33.953098      34.932186
    [68]       35.099998      34.453300      32.958820      30.553648
    [72]       27.178217      23.039625      19.624517      18.761141
    [76]       19.007198      19.656099      21.023016      22.563324
    [80]       23.550207      23.676401      22.859482      21.072107
    [84]       18.306530      14.764502      11.908544      12.069243
    [88]       13.396027      14.060472      14.266262      15.508611
    [92]       18.173893      20.726353      22.354113      22.910107
    [96]       22.375477      20.699984      17.776779      13.707081
    [100]       10.750762      11.742366      13.187060      13.758672
    [104]       13.910583      14.462339      15.763296      17.264124
    [108]       18.357317      18.768171      18.396194      17.169691
    [112]       14.955474      11.429702      5.6676621     -5.5279131
    [116]      -1.0994930      3.5240273      5.3994098      6.7892990
    [120]       8.2534246      9.4670877      10.111336      10.061964
    [124]       9.2131319      7.3264370      3.8653781     -2.6455965
    [128]      -14.365338     -5.3464422     -2.8314440     -3.1897185
    [132]      -4.4129343     -5.2027774     -6.1003456     -7.8090439
    [136]      -8.6775532     -7.2168708     -5.8654947     -5.7747951
    [140]      -7.0499816     -10.019282     -16.540918     -29.435102
    [144]      -14.456786     -10.856687     -10.418157     -12.447166
    [148]      -17.824835     -28.874855     -18.715481     -14.014890
    [152]      -11.747423     -10.995599     -11.965158     -15.687588
    [156]      -24.198948     -16.060598     -10.500145     -7.5367455
    [160]      -5.5695286     -4.0166411     -2.8202462     -2.1232953
    [164]      -2.0443339     -2.6459827     -3.9976468     -6.2744775
    [168]      -9.9380417     -16.341780     -25.072819     -17.082323
    [172]      -13.478534     -11.980949     -11.327902     -11.075325
    [176]      -11.207604     -11.870270     -13.244073     -15.657576
    [180]      -19.940575     -25.943213     -20.377546     -15.245036
    [184]      -12.323291     -10.652333     -9.7886410     -9.4775639
    [188]      -9.5489140     -9.9049854     -10.537961     -11.540209
    [192]      -13.117136     -15.665247     -20.121275     -30.501596
    [196]      -28.162987     -21.184517     -18.871672     -18.533232
    [200]      -19.354525     -20.729183     -22.113194     -23.308386
    [204]      -24.449667     -25.791759     -27.869196     -31.469614
    [208]      -34.390697     -30.848047     -28.013716     -27.240715
    [212]      -27.872986     -28.478245     -27.184515     -24.807354
    [216]      -22.730587     -21.276558     -20.480024     -20.409180
    [220]      -21.226200     -23.214531     -26.690969     -29.846811
    [224]      -27.488985     -24.589634     -23.060488     -22.357458
    [228]      -21.826536     -21.073265     -20.135532     -19.233643
    [232]      -18.533646     -18.159214     -18.261641     -19.060936
    [236]      -20.894869     -24.364801     -30.254021     -30.410242
    [240]      -25.606253     -23.224752     -22.364174     -22.280840
    [244]      -22.403055     -22.387152     -22.317820     -22.668461
    [248]      -24.196209     -28.543526     -47.419178     -26.874676
    [252]      -20.771063     -17.690695     -16.157930     -15.687737
    [256]      -16.025887     -16.966999     -18.292498     -19.820820
    [260]      -21.591293     -24.000671     -27.441273     -28.444874
    [264]      -24.033924     -20.259037     -17.861214     -16.513021
    [268]      -15.991580     -16.159161     -16.922523     -18.228071
    [272]      -20.117422     -22.917822     -27.923590     -40.931526
    [276]      -27.427633     -21.179590     -17.832518     -16.018751
    [280]      -15.355721     -15.736632     -17.202225     -19.968096
    [284]      -24.685631     -34.324936     -38.278309     -29.311344
    [288]      -26.356287     -25.072075     -24.578951     -24.516006
    [292]      -24.636450     -24.735889     -24.653904     -24.257448
    [296]      -23.502270     -22.541107     -21.667561     -21.190582
    [300]      -21.415369     -22.745832     -25.920952     -31.562014
    [304]      -28.407871     -23.181767     -20.629002     -19.837191
    [308]      -20.302780     -21.372284     -21.748650     -20.781549
    [312]      -19.485266     -18.610809     -18.298235     -18.489595
    [316]      -18.927999     -18.956327     -18.087383     -16.936125
    [320]      -16.383814     -16.927813     -18.932344     -22.918268
    [324]      -28.045877     -25.883337     -22.778624     -21.641886
    [328]      -21.707008     -22.109083     -21.888966     -20.700989
    [332]      -19.041864     -17.388634     -15.910081     -14.628109
    [336]      -13.542966     -12.682181     -12.105766     -11.897144
    [340]      -12.163659     -13.053973     -14.749826     -17.020309
    [344]      -17.127234     -13.825389     -10.678039     -8.6330261
    [348]      -7.5598073     -7.1718354     -7.0717793     -6.8941298
    [352]      -6.6281962     -6.5682998     -6.9165039     -7.5693669
    [356]      -8.1214905     -8.0620060     -7.1439562     -5.6773739
    [360]      -4.3294835     -3.6661813     -4.0594144     -5.8567982
    [364]      -9.6194868     -15.764870     -16.088318     -13.316915
    [368]      -13.970325     -19.620300     -26.778267     -14.146903
    [372]      -9.8077602     -7.7348042     -6.6790967     -5.9902058
    [376]      -5.3097882     -4.6127806     -4.0840912     -3.9086430
    [380]      -4.1880040     -4.9536295     -6.1959987     -7.8742971
    [384]      -9.8583355     -11.712527     -12.603868     -12.315147
    [388]      -11.631995     -11.018907     -10.329239     -9.3783817
    [392]      -8.3924131     -7.7788372     -7.7948275     -8.5064936
    [396]      -9.8191090     -11.476936     -13.118670     -14.377523
    [400]      -14.814484     -14.278905     -13.485247     -13.266998
    [404]      -14.047978     -15.930830     -18.401344     -19.634644
    [408]      -19.319162     -19.599480     -21.684015     -25.747217
    [412]      -24.677135     -19.581490     -16.158918     -13.900286
    [416]      -12.287239     -11.067220     -10.161028     -9.5819197
    [420]      -9.3710814     -9.5641222     -10.189743     -11.293559
    [424]      -12.975815     -15.385331     -18.357382     -19.896212
    [428]      -18.476839     -16.868513     -16.179914     -16.031900
    [432]      -15.692874     -15.011477     -14.570523     -14.847750
    [436]      -15.927515     -17.514151     -18.926311     -19.498772
    [440]      -19.116236     -18.133032     -17.186823     -16.840067
    [444]      -17.370722     -18.776100     -20.586447     -21.687048
    [448]      -21.766033     -22.036869     -23.569233     -27.395411
    [452]      -35.051682     -29.839525     -24.391123     -21.713900
    [456]      -20.346849     -19.611557     -19.191090     -19.111681
    [460]      -19.630613     -21.077175     -23.809744     -28.115396
    [464]      -32.360119     -31.998894     -30.456060     -28.569387
    [468]      -26.159035     -24.420017     -23.960430     -24.804319
    [472]      -26.436647     -27.395071     -27.083635     -26.838369
    [476]      -27.104408     -27.177311     -26.819523     -27.006464
    [480]      -28.852077     -33.891491     -38.735580     -30.710011
    [484]      -26.778730     -25.140911     -24.936682     -25.888399
    [488]      -28.003325     -31.531017     -36.592957     -38.716976
    [492]      -36.198772     -35.135170     -35.881870     -37.087482
    [496]      -35.743305     -32.864437     -30.622076     -29.174822
    [500]      -28.198421     -27.440924     -26.908503     -26.820776
    [504]      -27.460112     -29.118090     -32.156120     -36.893024
    [508]      -40.641022     -39.279858     -38.970692     -41.431740
    [512]      -44.556290
  [Tag]        11041
  [frame_len]          320
[Record 70]
  [tot_power]       54813.238
  [re_spec_val]
    [0]      -26.565516     -25.504362     -25.294970     -27.631487
    [4]      -27.041702     -24.257858     -27.324886     -25.872889
    [8]      -12.665138     -5.8473420     -1.4567757      1.3203853
    [12]       2.8319919      3.3543851      3.0730836      1.6883016
    [16]      -2.3243978     -17.599211     -4.6663933      1.6013898
    [20]       9.5174284      16.808714      22.103783      25.742687
    [24]       28.023359      29.101809      29.027836      27.754747
    [28]       25.104691      20.624720      13.010706      5.1197481
    [32]       11.772793      15.659038      18.882246      21.636002
    [36]       23.635820      24.732094      24.832521      23.840736
    [40]       21.669016      18.472706      15.565829      14.559890
    [44]       13.610625      10.890967      8.1182384      11.632415
    [48]       15.432796      17.790485      19.270233      20.240536
    [52]       20.786076      20.784664      20.019539      18.229176
    [56]       15.060844      9.9292250      2.3581991     0.33244261
    [60]       3.8028026      7.3130746      9.9963436      10.859184
    [64]       9.2009506      3.4783056      5.9803014      12.904991
    [68]       16.338209      17.826727      17.924543      16.818649
    [72]       14.502963      10.784499      5.6672883      4.4455280
    [76]       8.2814178      10.968331      12.280971      12.471519
    [80]       11.670469      10.010890      7.8521972      6.0490251
    [84]       5.2786255      5.0226455      5.0057387      6.1756845
    [88]       8.6593733      11.174960      13.015586      14.043748
    [92]       14.267848      13.718301      12.479227      10.873260
    [96]       9.6801748      9.4210224      9.3759089      8.6134453
    [100]       6.6635365      3.6469324      1.9299881      3.4852595
    [104]       5.2052808      6.1049089      6.4899001      6.6339617
    [108]       6.5425229      6.0738525      5.0776792      3.4232898
    [112]       1.2161331    -0.10540508      1.2445325      3.2296362
    [116]       4.2767320      4.1574469      2.8986175     0.53866619
    [120]      -2.8384469     -6.8454194     -10.139475     -10.661474
    [124]      -8.4131317     -5.3859863     -2.9297810     -1.4547153
    [128]      -1.0029417     -1.4218780     -2.2103276     -2.4797974
    [132]      -1.9595925     -1.3901643     -1.3581938     -2.0044911
    [136]      -3.2457640     -4.8677235     -6.5241361     -7.7899051
    [140]      -8.4020643     -8.5086784     -8.5452442     -8.8974123
    [144]      -9.6794596     -10.586473     -10.995289     -10.774161
    [148]      -10.491424     -10.558823     -10.961597     -11.437799
    [152]      -11.688189     -11.527067     -10.948121     -10.140968
    [156]      -9.3650312     -8.7623453     -8.3080854     -7.9171457
    [160]      -7.6078076     -7.5534329     -7.9844661     -9.0817137
    [164]      -10.884847     -13.039469     -14.468327     -14.583740
    [168]      -14.399379     -14.640647     -15.085709     -14.983512
    [172]      -14.142330     -13.288911     -13.069418     -13.765174
    [176]      -15.430401     -17.780779     -20.004463     -22.086622
    [180]      -26.495739     -28.500111     -19.438610     -14.656964
    [184]      -12.216165     -11.356125     -11.826448     -13.607631
    [188]      -16.882910     -22.189850     -31.152681     -48.318634
    [192]      -41.328423     -31.660013     -24.611908     -20.366676
    [196]      -17.855888     -16.600418     -16.379131     -17.068926
    [200]      -18.552252     -20.629427     -22.934633     -24.966021
    [204]      -26.380159     -27.424112     -29.042685     -32.691719
    [208]      -36.226486     -29.558556     -25.008701     -22.767744
    [212]      -22.112442     -22.704370     -24.210033     -25.941269
    [216]      -27.172411     -28.615786     -32.541546     -42.344791
    [220]      -30.059402     -24.406385     -21.730276     -20.777260
    [224]      -21.073158     -22.138226     -23.088417     -23.201637
    [228]      -22.980419     -23.095423     -23.482418     -23.513168
    [232]      -22.602409     -20.874973     -19.003401     -17.623285
    [236]      -17.129545     -17.761967     -19.636023     -22.118650
    [240]      -22.414965     -20.656187     -19.612137     -19.850372
    [244]      -21.128477     -22.830038     -24.195896     -25.188358
    [248]      -26.134045     -26.693007     -26.744429     -26.900021
    [252]      -26.481781     -24.069511     -21.265650     -19.538603
    [256]      -19.177439     -20.230232     -22.760092     -26.448204
    [260]      -27.791864     -24.658344     -21.455627     -19.310429
    [264]      -18.354425     -18.644392     -20.049829     -21.620129
    [268]      -21.696899     -21.148624     -21.820704     -24.694153
    [272]      -31.015907     -36.490414     -34.415272     -42.440670
    [276]      -31.041428     -23.754368     -20.738647     -20.286068
    [280]      -22.085623     -25.054821     -23.775600     -21.003551
    [284]      -20.257734     -21.743088     -25.464180     -27.951204
    [288]      -24.981625     -22.741463     -21.752729     -21.297237
    [292]      -21.135078     -21.297928     -21.498508     -21.317997
    [296]      -21.123623     -21.803606     -24.057604     -27.712620
    [300]      -28.116762     -25.960052     -25.936920     -27.739511
    [304]      -25.358435     -20.610800     -17.578056     -16.137634
    [308]      -15.993300     -17.013384     -19.173727     -22.446203
    [312]      -26.330376     -28.625849     -27.254740     -23.728685
    [316]      -20.061827     -17.171963     -15.265678     -14.358659
    [320]      -14.466516     -15.657338     -18.078133     -21.976957
    [324]      -27.568924     -33.449741     -35.671738     -34.890087
    [328]      -31.519211     -28.562654     -26.603130     -25.153448
    [332]      -24.168921     -24.021215     -25.025892     -27.106396
    [336]      -28.900259     -28.069313     -25.639341     -23.305521
    [340]      -21.826412     -21.769194     -23.888138     -30.047972
    [344]      -29.983793     -23.066120     -20.447870     -20.593163
    [348]      -23.918344     -35.146954     -24.658995     -18.254688
    [352]      -15.060243     -13.313787     -12.373602     -11.871673
    [356]      -11.588298     -11.487420     -11.744838     -12.691489
    [360]      -14.624792     -16.610432     -14.972636     -11.716619
    [364]      -9.5762777     -8.6859055     -8.7108402     -9.0779467
    [368]      -9.1061726     -8.7001925     -8.3842716     -8.5596342
    [372]      -9.3161583     -10.581302     -12.262743     -14.359899
    [376]      -16.963417     -19.736153     -20.323126     -17.975447
    [380]      -15.622201     -14.235865     -13.843090     -14.364446
    [384]      -15.715560     -17.795650     -20.491718     -23.771721
    [388]      -27.797487     -31.150158     -28.025988     -23.573389
    [392]      -20.514086     -18.757925     -18.205690     -18.844587
    [396]      -20.572483     -22.442606     -22.250248     -20.701952
    [400]      -19.790674     -19.978079     -21.155807     -22.966673
    [404]      -24.918501     -27.200037     -31.726761     -44.882538
    [408]      -30.412115     -24.978571     -22.709166     -22.207771
    [412]      -22.954948     -24.582279     -26.747421     -29.294178
    [416]      -32.442101     -36.601742     -37.072441     -30.662964
    [420]      -25.813457     -22.840994     -21.366619     -21.125168
    [424]      -21.764273     -22.618851     -23.060650     -23.433964
    [428]      -24.554596     -26.275059     -25.365118     -21.487062
    [432]      -17.998093     -15.467049     -13.749795     -12.704017
    [436]      -12.219767     -12.200446     -12.563319     -13.260201
    [440]      -14.304150     -15.779002     -17.795935     -20.291536
    [444]      -22.464762     -23.095652     -23.036360     -23.862616
    [448]      -26.382790     -31.211298     -35.972363     -33.939571
    [452]      -33.203102     -35.055897     -37.093658     -35.661739
    [456]      -34.008068     -33.762981     -34.853497     -36.996693
    [460]      -36.109570     -30.984730     -26.909225     -24.383970
    [464]      -23.108536     -22.843008     -23.383026     -24.508976
    [468]      -26.001245     -27.760292     -29.909740     -32.664486
    [472]      -35.829704     -37.850151     -37.707706     -37.226341
    [476]      -37.306538     -37.309841     -36.108543     -34.273865
    [480]      -33.159134     -33.478367     -35.789944     -40.726887
    [484]      -41.273048     -36.622463     -34.525833     -34.225479
    [488]      -34.562599     -34.369553     -33.745953     -33.622883
    [492]      -34.478310     -36.388065     -39.221066     -42.602745
    [496]      -45.580036     -46.244549     -44.630814     -42.909775
    [500]      -41.963818     -41.945076     -42.955933     -45.040733
    [504]      -46.634232     -44.206379     -40.774139     -38.473217
    [508]      -37.362404     -37.325642     -38.269676     -39.860672
    [512]      -40.817055
  [Tag]        11201
  [frame_len]          320
[Record 71]
  [tot_power]       25250.238
  [re_spec_val]
    [0]      -30.054632     -29.807526     -31.598389     -37.159992
    [4]      -33.633766     -34.904362     -29.885088     -18.633196
    [8]      -11.897053     -7.0825095     -3.7064860     -1.8376472
    [12]      -1.8377106     -4.7880349     -12.661172     -3.5066078
    [16]       1.9239625      4.2144012      6.2528987      10.845632
    [20]       15.984557      20.099148      23.119211      25.186825
    [24]       26.409084      26.844656      26.513159      25.401796
    [28]       23.469196      20.653574      16.911470      12.386799
    [32]       7.9866166      6.0560002      7.6476707      10.442599
    [36]       12.854581      14.560280      15.568947      15.897285
    [40]       15.513448      14.345356      12.295493      9.2747440
    [44]       5.4048619      1.8530804     0.65746987      1.1131586
    [48]       2.3907347      4.5034680      6.8734407      8.9456863
    [52]       10.484262      11.381982      11.549683      10.884821
    [56]       9.2611780      6.5443649      2.7515557     -1.4122031
    [60]      -5.0816312     -5.9988222     0.64320600      5.9013271
    [64]       9.0274591      10.507534      10.525664      9.0382910
    [68]       5.8675580      1.8494306      1.9155995      3.7681844
    [72]       3.9014730      2.1103647     -1.7473624     -7.9833670
    [76]      -10.078620     -6.1515155     -4.0004520     -3.3296671
    [80]      -3.7727935     -5.1451478     -7.2752566     -9.7166233
    [84]      -10.871482     -9.7065430     -8.2075262     -7.5371733
    [88]      -7.5539412     -7.3779607     -6.4490156     -5.6323895
    [92]      -5.8933258     -7.1127510     -6.5132761     -3.3882244
    [96]     -0.90996987     0.16208318   -0.032578375     -1.1725981
    [100]      -2.6696379     -3.9155743     -5.1775584     -7.4884443
    [104]      -12.102395     -18.009995     -13.609859     -10.617575
    [108]      -10.104192     -10.836529     -11.166481     -10.055756
    [112]      -8.4571428     -7.1086068     -6.1288366     -5.6115632
    [116]      -5.7672973     -6.8870716     -9.4102821     -14.266994
    [120]      -21.700699     -17.024290     -13.474768     -12.610623
    [124]      -12.739713     -11.740194     -9.4571676     -7.5272179
    [128]      -6.5839815     -6.6771679     -7.7097802     -9.3138161
    [132]      -10.390324     -9.9537811     -8.9184151     -8.3243294
    [136]      -8.4190226     -9.0937977     -10.098053     -11.143407
    [140]      -12.066568     -12.962020     -14.149508     -16.040005
    [144]      -18.811256     -20.783817     -19.297762     -17.365154
    [148]      -16.729218     -17.450603     -19.349024     -21.874569
    [152]      -23.367929     -22.720251     -21.391039     -20.312426
    [156]      -19.601210     -19.352226     -19.906382     -21.941895
    [160]      -26.852968     -30.308336     -23.236971     -19.775146
    [164]      -18.788185     -19.582417     -21.748020     -23.914537
    [168]      -22.797268     -19.581100     -16.903700     -15.309994
    [172]      -14.686624     -14.403871     -13.442024     -11.826923
    [176]      -10.586647     -10.386588     -11.558862     -14.451976
    [180]      -19.085154     -20.462152     -18.011061     -17.464386
    [184]      -19.212889     -22.777992     -24.814283     -24.041357
    [188]      -25.029413     -30.152662     -53.181969     -30.744741
    [192]      -27.507734     -27.708916     -29.507936     -30.633011
    [196]      -28.703804     -25.026993     -21.689550     -19.370560
    [200]      -18.111769     -17.803310     -18.332907     -19.661062
    [204]      -21.897118     -25.336432     -29.959332     -31.485092
    [208]      -28.292801     -25.214336     -22.747564     -21.091335
    [212]      -20.527842     -21.263296     -23.498653     -27.394537
    [216]      -30.539183     -26.667374     -21.866453     -18.240696
    [220]      -15.743088     -14.272342     -13.718654     -13.931543
    [224]      -14.642001     -15.395687     -15.775663     -15.844605
    [228]      -15.964965     -16.278814     -16.562531     -16.409735
    [232]      -15.640346     -14.501212     -13.416298     -12.740035
    [236]      -12.715319     -13.529938     -15.416845     -18.870523
    [240]      -25.462948     -31.846365     -23.037031     -19.210442
    [244]      -17.553087     -17.169849     -17.653458     -18.540199
    [248]      -19.085087     -18.736752     -17.756582     -16.579287
    [252]      -15.352659     -14.149764     -13.095949     -12.302029
    [256]      -11.808825     -11.602897     -11.655542     -11.954717
    [260]      -12.541607     -13.570874     -15.392236     -18.732214
    [264]      -25.603855     -30.219477     -21.944534     -18.929188
    [268]      -18.251043     -18.947992     -20.352232     -21.887573
    [272]      -23.560135     -25.450287     -24.889179     -21.117765
    [276]      -17.678141     -15.298420     -13.809137     -13.025646
    [280]      -12.818152     -13.093590     -13.772414     -14.786254
    [284]      -16.137381     -18.018913     -20.764297     -22.786442
    [288]      -19.285362     -14.958833     -12.058420     -10.493440
    [292]      -10.183549     -11.240236     -14.107435     -20.305504
    [296]      -28.831839     -19.637781     -16.592234     -16.642771
    [300]      -19.742785     -29.620874     -21.664768     -15.290046
    [304]      -12.704383     -12.406809     -14.405702     -19.169395
    [308]      -17.988586     -12.398396     -9.3753510     -8.1186857
    [312]      -8.2081223     -9.6432886     -12.981514     -20.798340
    [316]      -22.284328     -13.735495     -10.440292     -9.3744335
    [320]      -9.8670721     -11.620704     -13.789251     -14.181758
    [324]      -12.888682     -11.962004     -12.022051     -13.106060
    [328]      -15.272833     -18.793587     -24.383057     -34.186481
    [332]      -48.251324     -31.678263     -23.448147     -18.153215
    [336]      -14.708576     -12.488674     -11.137297     -10.486043
    [340]      -10.532550     -11.426109     -13.461096     -16.940113
    [344]      -19.749056     -17.078934     -14.244178     -13.020146
    [348]      -13.204102     -14.727593     -17.959393     -24.731594
    [352]      -29.396072     -20.028242     -16.047230     -14.116814
    [356]      -13.236079     -13.021193     -13.592884     -15.656676
    [360]      -21.365616     -32.135597     -17.416731     -12.958988
    [364]      -11.300057     -11.409384     -12.927852     -15.052576
    [368]      -15.409103     -13.942024     -13.005410     -13.246143
    [372]      -14.344936     -15.274704     -15.206849     -14.917145
    [376]      -15.307953     -16.508240     -18.006414     -18.954901
    [380]      -19.306004     -19.898695     -21.459114     -24.535789
    [384]      -27.981461     -24.884598     -20.607128     -17.845818
    [388]      -16.147274     -15.210015     -14.983432     -15.544173
    [392]      -16.864452     -18.305454     -18.465326     -17.435232
    [396]      -16.512400     -16.070572     -15.901331     -15.830573
    [400]      -15.915603     -16.231619     -16.623213     -16.678864
    [404]      -16.037067     -14.829029     -13.579042     -12.770605
    [408]      -12.706036     -13.574262     -15.507194     -18.455873
    [412]      -21.427853     -22.436647     -22.605560     -24.087637
    [416]      -28.287359     -36.198730     -27.713865     -22.250725
    [420]      -19.450602     -18.246260     -18.290714     -19.333315
    [424]      -20.728968     -20.976551     -19.558554     -17.908993
    [428]      -16.969576     -17.038172     -18.258005     -20.819353
    [432]      -25.030891     -28.107367     -23.578747     -19.544331
    [436]      -17.309790     -16.439161     -16.477365     -16.829815
    [440]      -17.110033     -17.660204     -19.176916     -22.267529
    [444]      -27.376465     -32.284374     -31.095716     -28.115950
    [448]      -24.795052     -22.204147     -20.772278     -20.391668
    [452]      -20.865480     -22.092632     -24.204119     -27.709713
    [456]      -33.332333     -34.381199     -30.411825     -29.584398
    [460]      -33.145779     -41.817028     -27.631758     -22.011494
    [464]      -19.105513     -17.713507     -17.343483     -17.672745
    [468]      -18.451725     -19.545444     -20.945364     -22.613314
    [472]      -24.283693     -25.684074     -27.168716     -29.602564
    [476]      -32.980606     -31.372553     -26.697529     -23.506931
    [480]      -21.758312     -21.267056     -22.020475     -24.057430
    [484]      -26.950111     -28.446493     -27.869585     -27.979013
    [488]      -29.643736     -30.780569     -28.220413     -25.327797
    [492]      -23.569433     -22.689381     -22.297688     -22.110945
    [496]      -22.009722     -21.969555     -21.945755     -21.874041
    [500]      -21.776321     -21.789869     -22.055573     -22.593893
    [504]      -23.251711     -23.774258     -24.038181     -24.185236
    [508]      -24.444710     -24.934622     -25.607191     -26.242922
    [512]      -26.513777
  [Tag]        11361
  [frame_len]          320
[Record 72]
  [tot_power]       3590.3079
  [re_spec_val]
    [0]      -64.377304     -36.003349     -30.513405     -28.391844
    [4]      -28.682005     -31.445322     -33.817867     -27.745831
    [8]      -20.513655     -13.693789     -7.6699009     -2.7240052
    [12]       1.0720683      3.7357099      5.3073578      5.8307948
    [16]       5.3408604      3.8145754      1.2924299     0.73387152
    [20]       5.4436455      9.8441792      12.657977      14.023495
    [24]       14.011542      12.557658      9.6036777      6.6221757
    [28]       7.7344108      9.9615755      10.964293      10.782314
    [32]       9.5949945      7.4652762      4.4676743      1.0827830
    [36]      -1.8591752     -5.2801480     -11.576476     -7.5116959
    [40]      -2.2279449    -0.21227831    -0.30024278     -2.0878041
    [44]      -5.5038838     -10.893509     -20.548195     -15.772591
    [48]      -8.4779882     -4.4490981     -1.9471941    -0.22939290
    [52]       1.1784998      2.4194770      3.3165119      3.6119916
    [56]       3.1168017      1.6916900    -0.86562669     -5.1491146
    [60]      -12.784767     -7.9095526    -0.30635384      4.8339057
    [64]       8.6978569      11.579445      13.560815      14.670460
    [68]       14.913056      14.270258      12.693494      10.090954
    [72]       6.3065858      1.0985100     -5.7564669     -13.326637
    [76]      -18.712908     -21.647736     -19.139568     -17.699732
    [80]      -18.575428     -18.993662     -16.307123     -13.669946
    [84]      -12.241695     -11.742045     -11.654768     -11.360056
    [88]      -10.340085     -8.5635281     -6.4952521     -4.6249242
    [92]      -3.2155907     -2.3523238     -2.0257750     -2.1697462
    [96]      -2.6730647     -3.4090245     -4.3176546     -5.5087380
    [100]      -7.3249822     -10.494192     -17.110571     -20.058392
    [104]      -11.023629     -6.8731356     -4.8499599     -4.2229648
    [108]      -4.7637358     -6.4351244     -9.3489399     -13.874854
    [112]      -20.536703     -20.974689     -15.887589     -12.752010
    [116]      -11.034055     -10.498590     -11.047858     -12.069777
    [120]      -11.739446     -9.8936119     -8.5191259     -8.5709677
    [124]      -10.629845     -16.448481     -22.162157     -11.940912
    [128]      -7.7281213     -5.8526568     -5.3742461     -5.8749352
    [132]      -6.8961258     -7.7072387     -7.8376698     -7.7651558
    [136]      -8.2062302     -9.5722666     -12.114938     -15.856949
    [140]      -18.032337     -15.053078     -11.758946     -9.4494753
    [144]      -7.8931375     -6.8331594     -6.0670815     -5.4899125
    [148]      -5.1247478     -5.0665646     -5.3863192     -6.0724111
    [152]      -7.0323691     -8.1713724     -9.5253830     -11.315473
    [156]      -13.826516     -16.861225     -17.793680     -15.176926
    [160]      -12.211832     -9.8627853     -8.1387424     -7.0286379
    [164]      -6.5301065     -6.6004248     -7.1420970     -8.0552511
    [168]      -9.3705873     -11.335361     -14.168379     -16.694752
    [172]      -16.425312     -15.961395     -17.260815     -15.224957
    [176]      -9.4402971     -5.2959585     -2.8205113     -1.6479254
    [180]      -1.5917164     -2.6025476     -4.7659006     -8.3806362
    [184]      -13.939646     -16.731182     -12.389892     -9.4047232
    [188]      -7.7946730     -7.0360560     -6.8529634     -7.0748930
    [192]      -7.5760331     -8.2684603     -9.1193485     -10.148129
    [196]      -11.323130     -12.291986     -12.343821     -11.448256
    [200]      -10.492228     -10.137435     -10.622462     -11.986309
    [204]      -14.111800     -16.551390     -18.351185     -18.719526
    [208]      -17.814276     -16.134125     -14.057054     -11.823179
    [212]      -9.6613913     -7.8056445     -6.4046602     -5.4893255
    [216]      -5.0061622     -4.8855577     -5.1329441     -5.9046631
    [220]      -7.5554314     -10.819168     -18.131548     -24.035208
    [224]      -13.225942     -9.4812288     -7.9866643     -7.7670078
    [228]      -8.3881330     -9.5334454     -10.912607     -12.288274
    [232]      -13.560574     -14.804891     -16.131382     -17.386209
    [236]      -17.999701     -17.443073     -15.788097     -13.621529
    [240]      -11.612111     -10.117449     -9.1505308     -8.5006056
    [244]      -7.9136138     -7.3236008     -6.8967071     -6.8493080
    [248]      -7.3160734     -8.3243122     -9.7537060     -11.245223
    [252]      -12.348241     -13.154157     -14.378558     -16.693062
    [256]      -19.295637     -17.434736     -13.690943     -11.059474
    [260]      -9.3023977     -7.7822609     -6.0495715     -4.2035861
    [264]      -2.6345379     -1.6116997     -1.2265584     -1.4604619
    [268]      -2.2101490     -3.2502511     -4.1635447     -4.4487700
    [272]      -4.0029554     -3.2559168     -2.6649938     -2.4546566
    [276]      -2.6677477     -3.2372456     -4.0103912     -4.7397776
    [280]      -5.1196108     -4.9979610     -4.5647445     -4.1624274
    [284]      -4.0310183     -4.2895317     -5.0358195     -6.4306545
    [288]      -8.6852493     -11.654410     -13.252215     -12.152540
    [292]      -11.481484     -12.994642     -18.902122     -23.225235
    [296]      -12.545408     -8.3804493     -6.6801281     -6.6941729
    [300]      -8.4224510     -11.865790     -11.606165     -6.6137919
    [304]      -3.1119297     -1.1861684    -0.52599692     -1.0309945
    [308]      -2.7385364     -5.6121635     -8.2237396     -7.4854050
    [312]      -5.7249861     -5.1193480     -5.9032207     -7.8915696
    [316]      -9.4567614     -7.6325374     -4.7153668     -2.6482484
    [320]      -1.5746883     -1.4308290     -2.2419198     -4.1853924
    [324]      -7.7532797     -14.611528     -31.969660     -15.945970
    [328]      -12.815224     -12.760139     -14.204608     -14.540376
    [332]      -11.754458     -8.3712254     -5.5584593     -3.4147978
    [336]      -1.9748188     -1.3035166     -1.4864216     -2.6481640
    [340]      -5.0088334     -9.0179672     -15.422320     -18.121672
    [344]      -13.809301     -11.388113     -10.188080     -9.7111320
    [348]      -9.9095154     -10.789477     -12.075496     -12.885551
    [352]      -12.065325     -9.6852913     -6.8606873     -4.4200335
    [356]      -2.7168422     -1.8713137     -1.9161140     -2.8067446
    [360]      -4.2338972     -5.2270079     -4.8753548     -3.9618208
    [364]      -3.5492733     -4.0752130     -5.8099523     -9.2501040
    [368]      -14.384289     -11.981769     -7.1057010     -4.2874832
    [372]      -2.8735754     -2.4673269     -2.8456368     -3.8117707
    [376]      -5.0841022     -6.2168117     -6.7434273     -6.6251144
    [380]      -6.3109694     -6.2845650     -6.8312397     -8.0264263
    [384]      -9.6701422     -11.253038     -12.601645     -14.763786
    [388]      -20.580355     -23.295185     -12.483671     -7.4154177
    [392]      -4.4685845     -2.7647333     -1.9499635     -1.8174855
    [396]      -2.2013540     -2.9583979     -4.0069757     -5.3741565
    [400]      -7.1970377     -9.7272644     -13.527506     -20.522583
    [404]      -26.408741     -16.712351     -12.786053     -10.970798
    [408]      -10.046246     -9.2471838     -8.3918962     -7.8872809
    [412]      -8.2037258     -9.7112265     -12.903217     -18.594915
    [416]      -20.022003     -14.610799     -11.452021     -9.7319660
    [420]      -8.7967396     -8.3749886     -8.4937868     -9.4282751
    [424]      -11.660211     -15.697364     -17.636808     -13.472063
    [428]      -10.608253     -9.4982176     -9.6099024     -10.414990
    [432]      -11.126464     -10.814140     -9.4111118     -7.7821493
    [436]      -6.6734614     -6.4993052     -7.5947957     -10.563992
    [440]      -17.571516     -25.346291     -13.743685     -9.9459419
    [444]      -8.3843603     -8.0152445     -8.4925537     -9.7559795
    [448]      -11.886623     -14.771988     -16.806032     -15.809889
    [452]      -13.915233     -12.548651     -11.629059     -10.913684
    [456]      -10.360319     -10.089469     -10.218195     -10.746555
    [460]      -11.507370     -12.244019     -12.957335     -14.173850
    [464]      -16.743092     -20.077286     -16.730062     -12.133055
    [468]      -9.4919176     -8.3919592     -8.5435152     -9.8329372
    [472]      -12.278116     -16.047699     -21.040045     -22.009026
    [476]      -17.986155     -14.835817     -12.784941     -11.570912
    [480]      -11.012165     -10.877369     -10.825765     -10.580353
    [484]      -10.200869     -9.9787769     -10.137115     -10.741683
    [488]      -11.740075     -12.975902     -14.127439     -14.663029
    [492]      -14.203682     -13.079557     -11.971839     -11.340500
    [496]      -11.374951     -12.077719     -13.275112     -14.593777
    [500]      -15.452426     -15.081079     -13.289389     -11.028656
    [504]      -9.1285915     -7.8366504     -7.1063466     -6.7698526
    [508]      -6.6106358     -6.4476142     -6.2269173     -6.0227633
    [512]      -5.9397879
  [Tag]        11521
  [frame_len]          320
[Record 73]
  [tot_power]       1331.9440
  [re_spec_val]
    [0]      -43.463978     -45.001236     -50.899738     -39.878441
    [4]      -33.060013     -29.897888     -28.922052     -28.103703
    [8]      -25.762968     -24.095562     -24.758383     -24.957506
    [12]      -19.282764     -14.679221     -12.126060     -10.980045
    [16]      -10.448091     -9.7248707     -8.6892557     -7.1175785
    [20]      -3.7930634     0.60405242      4.4784656      7.3457184
    [24]       9.1881523      10.053012      9.9684687      8.9346962
    [28]       6.9373298      4.0049734     0.41096747     -3.0012381
    [32]      -5.5675101     -7.6116099     -6.5993137     -2.4424469
    [36]      0.97987300      3.0251632      3.8104939      3.4269249
    [40]       1.8957417    -0.79696649     -4.5292664     -8.2425356
    [44]      -9.6755619     -9.6495733     -9.9394894     -10.558866
    [48]      -10.664522     -9.5849142     -7.6739841     -5.6903977
    [52]      -4.2062407     -3.5758359     -4.0339694     -5.8172994
    [56]      -9.3261118     -15.564747     -30.049807     -25.218870
    [60]      -18.490358     -14.680982     -12.844195     -10.987878
    [64]      -5.7899938    -0.41969508      3.4922876      6.0479016
    [68]       7.4500365      7.8232231      7.2215600      5.6350646
    [72]       2.9729609    -0.99933672     -6.8445683     -15.411366
    [76]      -16.548418     -12.936952     -11.021287     -9.8687935
    [80]      -9.5208883     -10.192063     -11.923437     -14.522908
    [84]      -17.480869     -19.951056     -20.876814     -20.115761
    [88]      -18.791801     -17.565056     -16.737553     -16.713259
    [92]      -17.849566     -19.897753     -20.121580     -17.226643
    [96]      -14.364224     -12.359552     -11.141126     -10.706847
    [100]      -11.169380     -12.531646     -13.684573     -12.125866
    [104]      -9.1764174     -6.7769074     -5.1216888     -4.0554194
    [108]      -3.5165954     -3.5714631     -4.3327904     -5.8467612
    [112]      -7.8982506     -9.7580223     -10.799865     -11.634204
    [116]      -12.925789     -13.785634     -12.531566     -10.354378
    [120]      -8.6688385     -7.7054892     -7.4461627     -7.9777102
    [124]      -9.5270958     -12.122978     -13.246081     -10.315752
    [128]      -7.5175509     -6.2223454     -6.5272222     -8.8446541
    [132]      -15.308703     -23.754360     -10.243174     -5.7391343
    [136]      -3.5966663     -2.8162603     -3.1073310     -4.4444919
    [140]      -7.0216131     -11.439325     -19.511913     -21.010645
    [144]      -14.817664     -11.936340     -10.245350     -9.0814838
    [148]      -8.3616676     -8.1241970     -8.3437042     -8.9480724
    [152]      -9.9042444     -11.253868     -13.040954     -15.123666
    [156]      -16.695644     -16.308434     -14.509326     -12.995366
    [160]      -12.405949     -12.657360     -13.063331     -12.588084
    [164]      -11.132910     -9.2972593     -7.3978176     -5.6761589
    [168]      -4.4001117     -3.7428391     -3.7681301     -4.4883418
    [172]      -5.9221110     -8.1237669     -11.129271     -14.677824
    [176]      -17.814146     -19.242678     -16.836847     -12.352997
    [180]      -8.7148027     -6.2961082     -4.9575696     -4.6216173
    [184]      -5.3643661     -7.5092974     -11.976205     -20.738800
    [188]      -15.766760     -11.223328     -9.9709635     -10.488305
    [192]      -11.285004     -10.624062     -9.3378048     -8.9066544
    [196]      -9.7994823     -12.207891     -16.527735     -23.900633
    [200]      -28.044033     -21.904028     -18.366739     -16.009800
    [204]      -14.225215     -12.785509     -11.627242     -10.849119
    [208]      -10.711306     -11.660578     -14.597936     -23.081160
    [212]      -23.033556     -14.084248     -10.972943     -10.179739
    [216]      -10.702951     -11.430012     -11.438028     -11.485454
    [220]      -12.911922     -16.833891     -20.880140     -16.255365
    [224]      -13.649370     -14.243247     -19.372286     -30.114338
    [228]      -14.592900     -9.7846012     -7.5002947     -6.5092258
    [232]      -6.3015523     -6.5932360     -7.2368302     -8.1752996
    [236]      -9.3561230     -10.662030     -12.039195     -13.845839
    [240]      -17.071234     -22.843157     -20.223940     -14.872900
    [244]      -12.328447     -11.552870     -12.005973     -13.349822
    [248]      -15.121549     -16.070110     -15.210184     -14.060306
    [252]      -13.965653     -15.145019     -16.761818     -17.198576
    [256]      -17.217628     -18.587786     -20.639910     -17.944336
    [260]      -13.172924     -9.3367405     -6.5094652     -4.7105913
    [264]      -4.0256114     -4.5921025     -6.7151208     -11.277061
    [268]      -20.337425     -14.290309     -9.0263424     -6.4785700
    [272]      -5.1896439     -4.6678743     -4.7646165     -5.4922075
    [276]      -6.8975277     -8.8064337     -10.170910     -9.5307102
    [280]      -7.7616267     -6.2136612     -5.2574263     -4.9482527
    [284]      -5.3676877     -6.7559214     -9.6934109     -15.095810
    [288]      -14.246853     -8.4073935     -5.1997986     -3.7695265
    [292]      -3.7017479     -4.9398079     -7.4922452     -9.6031809
    [296]      -7.4263787     -4.6444607     -3.4342346     -3.9611449
    [300]      -6.4964962     -11.812720     -15.334611     -10.650070
    [304]      -8.3653421     -7.6946130     -7.1415157     -6.0274773
    [308]      -4.9078918     -4.3347688     -4.4250913     -5.1337438
    [312]      -6.4900031     -8.7543621     -12.581087     -19.663221
    [316]      -26.506710     -19.572720     -16.956558     -15.296254
    [320]      -13.746285     -13.282638     -15.009110     -20.447462
    [324]      -18.923397     -12.289595     -9.1602163     -8.2385588
    [328]      -9.2951298     -12.803746     -14.683515     -8.3908129
    [332]      -4.0034528     -1.5909888    -0.63192070    -0.95957702
    [336]      -2.5776198     -5.3058805     -7.1151471     -5.6257463
    [340]      -3.8343382     -3.2724166     -4.0220485     -6.0286813
    [344]      -9.0806446     -11.735603     -11.359864     -9.4830112
    [348]      -8.0020828     -7.3380985     -7.7076168     -9.2979403
    [352]      -11.344816     -10.132807     -6.7940135     -4.4234385
    [356]      -3.3138266     -3.2818720     -4.1358695     -5.6666908
    [360]      -7.7052956     -10.498033     -15.715964     -25.801764
    [364]      -12.298191     -6.6091638     -3.5443938     -1.9615520
    [368]      -1.4939122     -2.0250299     -3.5820134     -6.2692199
    [372]      -9.8036556     -11.674513     -10.616182     -9.6983690
    [376]      -9.4984894     -9.2221937     -8.3417559     -6.9731245
    [380]      -5.3276739     -3.8233202     -3.0467677     -3.5082154
    [384]      -5.7553611     -10.663572     -14.347360     -9.9252310
    [388]      -8.1064978     -8.5544577     -8.5876026     -6.3658781
    [392]      -4.5251241     -4.3647184     -6.2074752     -10.744960
    [396]      -20.323442     -19.810745     -16.183676     -15.309648
    [400]      -12.682473     -9.5293722     -7.3827920     -6.0865831
    [404]      -5.2749653     -4.7505999     -4.4313827     -4.2046766
    [408]      -3.9240463     -3.5391371     -3.1469336     -2.8877747
    [412]      -2.8328357     -2.9613185     -3.2338905     -3.7057495
    [416]      -4.5429273     -5.8991718     -7.7539492     -9.8456383
    [420]      -11.998739     -14.562135     -16.903576     -15.164378
    [424]      -11.865099     -9.6851759     -8.4838142     -7.7649379
    [428]      -7.1715479     -6.6686049     -6.4408689     -6.6719184
    [432]      -7.4524779     -8.6775980     -9.6021957     -8.8839016
    [436]      -6.9740901     -5.3851986     -4.7911749     -5.4731998
    [440]      -7.8192449     -12.712462     -17.496620     -12.092592
    [444]      -8.8848324     -7.9103260     -8.3499374     -9.5074129
    [448]      -10.278918     -9.9497290     -9.2847490     -9.1507540
    [452]      -9.8291864     -11.082626     -11.675675     -10.349793
    [456]      -8.3171053     -6.8196106     -6.1394019     -6.2629666
    [460]      -7.1516008     -8.8541603     -11.674668     -16.381531
    [464]      -19.701305     -14.341728     -10.744657     -9.2641354
    [468]      -9.3297873     -10.350815     -10.882074     -9.7615604
    [472]      -8.2346554     -7.2930865     -6.9662209     -7.0358548
    [476]      -7.4098639     -8.1793232     -9.3607397     -10.458470
    [480]      -10.494258     -9.4906788     -8.4219151     -7.7985511
    [484]      -7.6305184     -7.6478562     -7.4490361     -6.8518682
    [488]      -6.0598321     -5.3266559     -4.7365141     -4.2886930
    [492]      -4.0149984     -3.9906213     -4.2837806     -4.9259772
    [496]      -5.9180322     -7.2533560     -8.9458752     -11.035475
    [500]      -13.489477     -15.949669     -17.887621     -19.570524
    [504]      -20.349089     -17.333618     -13.533421     -11.066891
    [508]      -9.9635248     -10.037230     -11.089968     -12.676402
    [512]      -13.567327
  [Tag]        11681
  [frame_len]          320
[Record 74]
  [tot_power]       836.92841
  [re_spec_val]
    [0]      -24.896124     -24.859108     -24.906431     -25.383831
    [4]      -26.602057     -28.662012     -31.160435     -32.886299
    [8]      -32.990425     -31.722855     -29.147570     -25.659386
    [12]      -22.053665     -18.985346     -16.893574     -16.087870
    [16]      -16.614269     -16.856632     -14.126089     -11.233858
    [20]      -10.323406     -12.335445     -16.601852     -9.3700504
    [24]      -3.7781401    -0.87077117     0.23464759    -0.19791825
    [28]      -2.2647507     -6.5971560     -16.211605     -20.338873
    [32]      -12.808488     -11.715521     -10.933150     -7.6161056
    [36]      -4.2112927     -1.8704054    -0.48875731     0.11006314
    [40]    -0.028487539     -1.0147402     -3.1367042     -7.0134568
    [44]      -14.152483     -16.818394     -11.121859     -8.9994011
    [48]      -8.8133364     -9.5647821     -9.7897863     -8.3856964
    [52]      -6.6121154     -5.6847000     -5.9853506     -7.7038732
    [56]      -11.180479     -17.327814     -29.831524     -29.906143
    [60]      -24.193157     -18.731522     -14.640407     -12.205596
    [64]      -10.484442     -8.5025015     -6.3782725     -4.8631144
    [68]      -4.3825445     -5.0714235     -6.9620833     -10.049033
    [72]      -14.421544     -20.908276     -24.515387     -18.205671
    [76]      -15.179629     -14.276420     -14.006599     -13.038180
    [80]      -11.743612     -11.128057     -11.525405     -12.832067
    [84]      -14.553461     -15.487027     -14.795249     -13.638710
    [88]      -13.267272     -14.239333     -16.556959     -17.490934
    [92]      -14.668891     -12.248454     -11.321499     -11.397825
    [96]      -11.316259     -10.308904     -9.2754097     -9.1692438
    [100]      -10.349788     -12.967931     -17.103704     -21.867208
    [104]      -21.971521     -18.546171     -15.604398     -13.317451
    [108]      -11.395589     -9.6842947     -8.1060076     -6.5832033
    [112]      -5.1812186     -4.1555414     -3.7726898     -4.1724205
    [116]      -5.3191648     -6.9496188     -8.6549721     -10.347667
    [120]      -12.449224     -15.249433     -18.211529     -20.125126
    [124]      -19.465994     -16.270252     -13.524142     -12.412427
    [128]      -13.178121     -16.179979     -21.744875     -22.781630
    [132]      -19.326227     -16.943228     -14.249475     -11.872932
    [136]      -10.742656     -10.977274     -11.580026     -10.211845
    [140]      -7.5350118     -5.4997649     -4.5158429     -4.5394545
    [144]      -5.5574532     -7.7038956     -11.367984     -17.540493
    [148]      -27.829599     -25.352074     -23.927086     -24.085182
    [152]      -20.899380     -17.608669     -15.539330     -13.916011
    [156]      -11.970496     -9.8255463     -8.0617361     -6.9972320
    [160]      -6.6671534     -6.9563870     -7.6866927     -8.7359581
    [164]      -10.212687     -12.598806     -16.606340     -17.773033
    [168]      -12.492881     -8.9693270     -7.4415612     -7.6081672
    [172]      -9.5148506     -13.340022     -15.835726     -12.232080
    [176]      -9.1812992     -7.5475955     -6.8387122     -6.6981034
    [180]      -6.8414021     -6.9874740     -6.9138212     -6.6611037
    [184]      -6.5982375     -7.1949177     -8.7958984     -11.275088
    [188]      -13.101810     -13.415035     -14.973114     -20.626638
    [192]      -17.063374     -10.600265     -7.8669777     -7.5299506
    [196]      -9.3981581     -13.944891     -16.905128     -11.709136
    [200]      -8.3664064     -6.7252593     -6.1198969     -6.2393637
    [204]      -6.9066210     -7.9769764     -9.3703489     -11.178267
    [208]      -13.708963     -17.481318     -21.291029     -16.761595
    [212]      -11.312930     -7.6008959     -5.2075438     -3.8741794
    [216]      -3.4635892     -3.9125574     -5.2361293     -7.5679679
    [220]      -11.197384     -15.917142     -16.998758     -15.012913
    [224]      -15.132776     -19.308743     -29.775358     -14.405199
    [228]      -8.7716398     -5.7735920     -4.2391038     -3.7743897
    [232]      -4.1784844     -5.2376423     -6.5655975     -7.6150265
    [236]      -8.1320381     -8.3975897     -8.7520208     -9.2772942
    [240]      -9.7206926     -9.5677814     -8.7231922     -7.7815251
    [244]      -7.2627249     -7.3051596     -7.7943439     -8.4869499
    [248]      -9.1210041     -9.5515919     -9.8891926     -10.539441
    [252]      -12.123126     -15.426597     -18.691149     -13.940381
    [256]      -9.3765507     -6.4955759     -4.6044531     -3.3051910
    [260]      -2.4810805     -2.2349458     -2.8027718     -4.5262270
    [264]      -7.8912377     -12.308838     -10.785283     -7.5107861
    [268]      -6.2563038     -6.8115349     -9.0679731     -13.143518
    [272]      -18.599522     -19.243603     -14.678029     -10.701739
    [276]      -8.1546679     -7.1857862     -7.9947338     -11.287936
    [280]      -20.302439     -17.901371     -11.056062     -8.5328178
    [284]      -7.5708885     -6.8622885     -5.8133531     -4.7498994
    [288]      -4.1032186     -3.9400167     -4.0741282     -4.2864075
    [292]      -4.5219345     -4.8855619     -5.4665966     -6.2264719
    [296]      -7.0036759     -7.5569158     -7.6168022     -7.0679827
    [300]      -6.1549997     -5.3115268     -4.8786340     -5.0689111
    [304]      -6.0654106     -8.1613235     -12.008655     -17.739197
    [308]      -13.739791     -8.2427778     -4.7539902     -2.3432233
    [312]     -0.57485092     0.72942787      1.6183569      2.0809393
    [316]       2.0903795      1.6235167     0.65712535    -0.85813588
    [320]      -3.0526576     -6.2569265     -11.389862     -22.343914
    [324]      -18.718304     -12.855658     -11.066368     -11.018362
    [328]      -11.145192     -10.018003     -8.3940172     -7.3243132
    [332]      -6.6974936     -5.8468194     -4.6654220     -3.8302286
    [336]      -3.9663835     -5.5013075     -8.9615278     -14.292974
    [340]      -13.267187     -9.7365322     -8.3600674     -8.2313442
    [344]      -7.9675541     -6.6221652     -4.8549705     -3.4520643
    [348]      -2.6062899     -2.2633190     -2.3426609     -2.8473151
    [352]      -3.9602859     -6.1597567     -10.504633     -15.998238
    [356]      -9.5086432     -4.7634115     -2.1714666    -0.77925020
    [360]     -0.20222479    -0.36047956     -1.3663242     -3.4002793
    [364]      -6.3358116     -8.3478432     -7.6260643     -6.6952100
    [368]      -6.8856621     -8.0008478     -8.8796673     -8.0587149
    [372]      -6.3611169     -5.2096314     -5.1517534     -6.4990649
    [376]      -9.8118105     -14.344490     -9.9003468     -4.8643994
    [380]      -1.8608375    -0.18121928     0.58015096     0.72367340
    [384]      0.53087074     0.18619418    -0.33799636     -1.1831795
    [388]      -2.2416267     -2.7235863     -1.8681549    -0.39621073
    [392]      0.77078617      1.3865739      1.5559896      1.4832975
    [396]       1.3223417      1.0814689     0.63845581    -0.17805791
    [400]      -1.5128756     -3.3550842     -5.1816168     -5.8492365
    [404]      -5.2922330     -4.6332493     -4.3944998     -4.5063586
    [408]      -4.6903329     -4.6832957     -4.4313412     -4.1167617
    [412]      -3.9852564     -4.2223692     -4.9549909     -6.2406492
    [416]      -7.8809056     -9.1356468     -9.5154171     -10.000953
    [420]      -11.987758     -17.484369     -37.477089     -16.344114
    [424]      -11.917454     -10.275570     -9.8949986     -10.024234
    [428]      -10.151143     -10.090682     -10.043731     -10.422257
    [432]      -11.680021     -14.347000     -19.098787     -21.585585
    [436]      -16.218933     -11.989709     -8.9231367     -6.6535120
    [440]      -5.1750259     -4.5615115     -4.8897910     -6.2479396
    [444]      -8.7056131     -11.885348     -13.518858     -12.556921
    [448]      -11.805871     -12.429269     -14.579286     -17.369396
    [452]      -17.253479     -15.200765     -13.930315     -13.368672
    [456]      -13.031880     -13.042060     -14.070234     -17.102274
    [460]      -23.711626     -21.139822     -15.382497     -12.948942
    [464]      -12.689766     -14.620385     -20.555847     -29.543411
    [468]      -15.768048     -10.975347     -8.5702782     -7.4828415
    [472]      -7.2884951     -7.6647115     -8.2819662     -8.9801197
    [476]      -10.001462     -11.877218     -15.090226     -18.250774
    [480]      -16.456257     -13.748090     -12.516265     -12.613751
    [484]      -13.776303     -15.097600     -14.153129     -11.499860
    [488]      -9.5175228     -8.8575802     -9.6572618     -12.143359
    [492]      -16.920340     -25.787600     -31.106060     -24.127304
    [496]      -18.808027     -14.914534     -12.876574     -12.680320
    [500]      -14.554873     -19.842005     -37.275742     -19.574141
    [504]      -14.745937     -12.680808     -11.901766     -11.846465
    [508]      -12.132079     -12.351398     -12.213829     -11.863833
    [512]      -11.687381
  [Tag]        11841
  [frame_len]          320
[Record 75]
  [tot_power]       2984.8020
  [re_spec_val]
    [0]      -45.278763     -42.995457     -38.883869     -35.322559
    [4]      -32.748436     -30.952673     -29.388462     -27.439398
    [8]      -24.931484     -22.053301     -18.992571     -15.948086
    [12]      -13.130925     -10.694950     -8.7390842     -7.3450871
    [16]      -6.5947437     -6.5577264     -7.2369175     -8.3829126
    [20]      -9.0654726     -7.9982700     -5.4673305     -2.5868406
    [24]     0.044771131      2.1756113      3.7068765      4.6241593
    [28]       4.9688501      4.8403692      4.4222355      3.9853420
    [32]       3.7690203      3.7850187      3.8356955      3.7312982
    [36]       3.4180226      2.9828484      2.6129990      2.5198858
    [40]       2.8297687      3.5095186      4.3978195      5.3016472
    [44]       6.0680304      6.6042724      6.8704391      6.8664484
    [48]       6.6215777      6.1875916      5.6365108      5.0608249
    [52]       4.5604091      4.1964140      3.9402454      3.6916442
    [56]       3.3711882      3.0135863      2.7982204      2.9504852
    [60]       3.5359707      4.4019685      5.3336296      6.1687436
    [64]       6.7976704      7.1357179      7.1098533      6.6557980
    [68]       5.7158613      4.2334800      2.1466517    -0.59284532
    [72]      -3.7961431     -6.0633373     -5.4955044     -3.8018315
    [76]      -2.6074431     -2.1956308     -2.5540504     -3.6553133
    [80]      -5.4866056     -8.0306778     -11.225127     -14.946397
    [84]      -19.127510     -22.770739     -20.724104     -16.576445
    [88]      -13.664863     -11.906349     -10.959063     -10.268103
    [92]      -8.9375019     -6.6828961     -4.2826452     -2.3646698
    [96]      -1.0651143    -0.26074693     0.27623355     0.74134773
    [100]       1.1776190      1.4982084      1.6029872      1.4285897
    [104]      0.91902357  -0.0065292749     -1.4435831     -3.4380584
    [108]      -5.7884579     -7.5589738     -7.4685168     -6.1324663
    [112]      -4.8578548     -4.1593847     -4.1183906     -4.5539222
    [116]      -4.9458432     -4.7273741     -4.0548921     -3.5499682
    [120]      -3.5883541     -4.2637000     -5.5436602     -7.3193974
    [124]      -9.2658434     -10.595984     -10.756573     -10.469634
    [128]      -10.569821     -11.218785     -12.045371     -12.415660
    [132]      -12.002732     -11.057531     -10.108433     -9.7145042
    [136]      -10.399201     -12.811296     -18.064808     -19.436577
    [140]      -13.205052     -9.6452370     -7.5438590     -6.0548444
    [144]      -4.8046799     -3.6256626     -2.3655295    -0.99497712
    [148]      0.24460503     0.98778051     0.90792620    -0.27493793
    [152]      -2.4375877     -2.4169021      1.5291679      5.1238508
    [156]       7.4862971      8.7847567      9.1854610      8.8079586
    [160]       7.7500186      6.0757408      3.7217081     0.26963362
    [164]      -5.7211785     -15.619602     -5.8692803     -1.6588187
    [168]     -0.10554674   -0.076615438     -1.1887050     -3.3256607
    [172]      -6.6478825     -11.972651     -21.418118     -17.240271
    [176]      -13.053543     -12.259553     -12.887251     -12.416319
    [180]      -10.700034     -9.9697809     -11.181397     -14.554920
    [184]      -16.162067     -12.782173     -10.692896     -10.233821
    [188]      -10.181847     -9.2446709     -7.8188052     -6.9686875
    [192]      -6.8819046     -6.3408084     -3.7705481    -0.53553247
    [196]       1.9573287      3.4441121      3.9684238      3.6135335
    [200]       2.4863195     0.77298719     -1.1973265     -3.0480685
    [204]      -4.6731067     -6.2197199     -7.5504479     -8.0320349
    [208]      -7.4805126     -6.6720815     -6.3521295     -6.8689189
    [212]      -8.1838989     -9.3461237     -8.7334843     -7.0864472
    [216]      -5.7665777     -4.8551559     -3.9216714     -2.7596428
    [220]      -1.6063448    -0.77931112    -0.44605991    -0.65902120
    [224]      -1.4168100     -2.6678846     -4.2441239     -5.7176156
    [228]      -6.3109279     -5.4065990     -3.3923190     -1.1449251
    [232]      0.78993732      2.2139754      3.0952473      3.4664407
    [236]       3.3795164      2.8801901      1.9871672     0.67427981
    [240]      -1.1405681     -3.5863774     -6.7106214     -9.6795444
    [244]      -9.9423475     -8.1797829     -6.6250839     -5.6396451
    [248]      -5.0895782     -4.9028888     -5.1058769     -5.7203660
    [252]      -6.6557207     -7.6207509     -8.0350742     -7.2368145
    [256]      -5.3372211     -3.1384301     -1.1883564     0.33378443
    [260]       1.3775022      1.8792689      1.7210563     0.73115355
    [264]      -1.3090808     -4.5769677     -8.3310881     -9.4567709
    [268]      -9.1768723     -10.514552     -11.570399     -7.2512560
    [272]      -2.8863871   -0.022688895      1.7183069      2.6350536
    [276]       2.9074323      2.6556478      1.9781289     0.96249127
    [280]     -0.33303931     -1.9015654     -3.7241437     -5.4580350
    [284]      -6.0524607     -5.0194073     -3.4856160     -2.3216383
    [288]      -1.7456338     -1.7498494     -2.2818403     -3.3009005
    [292]      -4.8208728     -6.9824238     -10.204280     -15.628281
    [296]      -22.138105     -14.630025     -9.6949492     -6.6563640
    [300]      -4.5977840     -3.2695334     -2.6680086     -2.8750281
    [304]      -4.0048494     -6.2014260     -9.6182814     -13.938268
    [308]      -15.606814     -12.846678     -9.8744507     -7.6870604
    [312]      -6.2938137     -5.5231047     -5.0962143     -4.8440695
    [316]      -4.9280620     -5.7354207     -7.6610308     -11.030272
    [320]      -15.961574     -22.207369     -25.527119     -17.380787
    [324]      -12.598259     -10.929003     -12.354581     -18.905531
    [328]      -14.097503     -6.6344976     -2.7082076    -0.47881228
    [332]      0.69800538      1.1489943      1.1583909      1.1172991
    [336]       1.4491892      2.2209537      3.0729001      3.6251163
    [340]       3.6689107      3.1142728      1.9270210     0.11851021
    [344]      -2.2021546     -4.7025690     -6.7328167     -7.5945096
    [348]      -7.1394906     -5.9872460     -4.9330225     -4.3595157
    [352]      -4.1587501     -3.8419881     -3.0379355     -2.0162611
    [356]      -1.2547294    -0.94182497    -0.94815546    -0.94273567
    [360]     -0.68709165    -0.33661667    -0.27399147    -0.77220160
    [364]      -1.8180556     -2.8907218     -3.0828583     -2.4012377
    [368]      -1.6565149     -1.0851171    -0.33603328     0.77765459
    [372]       1.8570610      2.3661840      1.9182997     0.11500210
    [376]      -3.9171762     -13.687099     -9.7651281     -3.2764826
    [380]     -0.67468011     0.22994387     0.17888327    -0.34876105
    [384]     -0.93296123     -1.2827718     -1.3872056     -1.5097165
    [388]      -2.0161026     -3.2410810     -5.4580169     -8.7797232
    [392]      -12.252902     -12.949802     -11.895763     -11.213110
    [396]      -10.827765     -10.276317     -9.3378010     -8.0379353
    [400]      -6.5887928     -5.2628832     -4.2408390     -3.5850368
    [404]      -3.2771535     -3.2348309     -3.3039541     -3.2750340
    [408]      -2.9770448     -2.4102387     -1.7738897     -1.3601018
    [412]      -1.4527830     -2.3189557     -4.2984886     -8.1028461
    [416]      -16.587061     -20.698074     -10.855087     -7.7046185
    [420]      -6.8835454     -7.7551599     -10.467235     -15.871804
    [424]      -19.646738     -13.892983     -10.544143     -8.9130964
    [428]      -8.2405119     -8.2717314     -9.0167885     -10.564461
    [432]      -12.776998     -14.435444     -13.696451     -11.731823
    [436]      -9.9846764     -8.6471081     -7.6374960     -6.9608521
    [440]      -6.7139001     -6.9768558     -7.6802096     -8.4805870
    [444]      -8.9110088     -9.0013552     -9.3416471     -10.510272
    [448]      -12.954680     -17.027311     -20.331324     -17.676163
    [452]      -15.075143     -14.015328     -14.107843     -15.007874
    [456]      -16.348097     -17.596140     -18.333237     -18.925154
    [460]      -20.112705     -21.322487     -19.647362     -16.623447
    [464]      -14.630752     -13.444078     -11.723676     -8.9281912
    [468]      -6.1031771     -3.9309933     -2.4936941     -1.6846800
    [472]      -1.3675429     -1.4239708     -1.7823694     -2.4489675
    [476]      -3.5398102     -5.3174953     -8.2980871     -13.708293
    [480]      -20.914804     -13.485864     -9.2343464     -7.3505487
    [484]      -6.8903127     -7.5770206     -9.4541969     -12.956812
    [488]      -19.481758     -21.782230     -14.430696     -10.248640
    [492]      -7.5138612     -5.5671082     -4.2241416     -3.4715323
    [496]      -3.3613794     -3.9846272     -5.4817128     -8.0795622
    [500]      -12.154037     -18.027298     -22.117350     -21.298790
    [504]      -22.028421     -24.626642     -26.720284     -26.822956
    [508]      -22.876900     -17.398643     -13.548856     -11.388645
    [512]      -10.695072
  [Tag]        12001
  [frame_len]          320
[Record 76]
  [tot_power]       1317.3464
  [re_spec_val]
    [0]      -23.269495     -23.482315     -24.203751     -25.508413
    [4]      -27.110701     -28.133095     -27.299097     -24.746017
    [8]      -22.432014     -21.500460     -21.914705     -21.407612
    [12]      -18.113190     -14.880392     -12.792866     -11.713059
    [16]      -11.440619     -11.921062     -13.304492     -16.120640
    [20]      -22.049234     -21.988682     -13.409077     -8.4019537
    [24]      -5.1845555     -3.1644771     -2.1313021     -1.9753665
    [28]      -2.4997592     -3.1358149     -2.9940467     -2.0424478
    [32]      -1.1423018    -0.85575730     -1.3672619     -2.7659314
    [36]      -5.1980505     -8.9348145     -14.220530     -19.631622
    [40]      -21.480730     -17.271301     -11.196867     -7.3309979
    [44]      -5.5804868     -5.8179946     -8.3942642     -14.973322
    [48]      -23.925062     -15.475657     -14.276176     -13.453994
    [52]      -9.3832483     -6.2301702     -5.0143542     -5.5951610
    [56]      -7.7888989     -9.7969236     -7.7404633     -4.8001628
    [60]      -3.1260750     -2.7696664     -3.4694519     -3.9022565
    [64]      -1.8551468      1.1898210      3.4167221      4.5056872
    [68]       4.4652452      3.2800591     0.82454562     -3.2903087
    [72]      -10.497477     -24.933023     -11.602435     -7.2187018
    [76]      -5.0879245     -4.1870918     -4.3632050     -5.7578516
    [80]      -8.9039993     -15.744839     -19.493708     -10.538629
    [84]      -6.5432944     -4.4407144     -3.3366244     -2.8410921
    [88]      -2.7429316     -2.9428720     -3.4395525     -4.3086987
    [92]      -5.6639791     -7.5988550     -10.054927     -12.443273
    [96]      -13.390325     -12.541140     -11.051362     -9.5515442
    [100]      -8.0903711     -6.6357861     -5.3441205     -4.5269203
    [104]      -4.5003905     -5.5563240     -7.9979205     -11.486337
    [108]      -11.446460     -8.1470385     -5.9242353     -5.0135479
    [112]      -5.1578312     -6.2232819     -8.2169113     -11.284102
    [116]      -15.446867     -18.352814     -17.175215     -16.284769
    [120]      -17.456581     -20.401762     -19.252804     -14.911770
    [124]      -12.290578     -11.380991     -11.926141     -13.535611
    [128]      -14.238786     -12.126013     -9.7776718     -8.6720362
    [132]      -9.0620050     -11.212397     -15.753797     -19.916557
    [136]      -15.296192     -11.969762     -10.374659     -9.6807671
    [140]      -9.4134855     -9.2646360     -8.9861631     -8.4684849
    [144]      -7.7655959     -6.8664784     -5.6713786     -4.3235583
    [148]      -3.2462988     -2.8496368     -3.3842504     -4.6055121
    [152]      -4.3028860     -1.0018337      2.5381548      5.2222242
    [156]       7.0704155      8.2036781      8.6873827      8.5146122
    [160]       7.5937223      5.7038679      2.3436325     -3.7357249
    [164]      -7.8737640     -1.4060735      1.8276902      3.0157280
    [168]       2.8828292      1.7478751    -0.14141263     -2.4205835
    [172]      -4.6114612     -6.6030073     -8.9916391     -12.389516
    [176]      -13.411534     -8.7802515     -4.6473594     -1.7823665
    [180]      0.13456830      1.3108732      1.8800464      1.9596089
    [184]       1.6810074      1.1913196     0.62423909    0.062416192
    [188]     -0.46595079    -0.95173109     -1.3697900     -1.6671758
    [192]      -1.7825270     -1.6995087     -1.4802574     -1.2227030
    [196]      -1.0019051    -0.87243438    -0.90494537     -1.1909866
    [200]      -1.8068241     -2.7689590     -3.9949231     -5.2684884
    [204]      -6.2602930     -6.7157331     -6.6965032     -6.5210681
    [208]      -6.5268030     -6.9790692     -8.1130285     -10.234355
    [212]      -13.972352     -21.580957     -27.725084     -17.108870
    [216]      -13.055538     -10.940556     -9.8477488     -9.4782543
    [220]      -9.7263136     -10.558578     -11.953061     -13.777905
    [224]      -15.396928     -15.427943     -13.698548     -11.504762
    [228]      -9.5022163     -7.7961745     -6.3696189     -5.2124686
    [232]      -4.3530436     -3.8636076     -3.8534062     -4.4648561
    [236]      -5.8920341     -8.4264364     -12.316925     -14.910503
    [240]      -11.962724     -9.1999598     -8.0303593     -8.3136702
    [244]      -10.098081     -13.719488     -18.371264     -16.400043
    [248]      -12.805758     -10.876807     -10.034610     -9.7733288
    [252]      -9.7547636     -9.8035460     -9.8997040     -10.077396
    [256]      -10.247500     -10.130156     -9.5910940     -9.0088797
    [260]      -8.9953260     -10.103312     -12.789195     -14.842864
    [264]      -10.574973     -6.2393889     -3.4622171     -1.8843206
    [268]      -1.2745740     -1.5336587     -2.6260116     -4.4861217
    [272]      -6.7493777     -8.3112574     -8.3674622     -7.9185801
    [276]      -7.8926868     -8.4114647     -9.1652775     -9.6784887
    [280]      -9.7095299     -9.3889465     -8.8695068     -8.2205076
    [284]      -7.5983629     -7.2559538     -7.4288154     -8.3103456
    [288]      -10.114988     -13.114686     -16.919806     -17.277277
    [292]      -14.741602     -13.412827     -13.506849     -14.047744
    [296]      -13.238948     -11.208982     -9.4688787     -8.5065680
    [300]      -8.2425623     -8.4597683     -8.9422750     -9.5939074
    [304]      -10.511142     -11.923579     -14.076636     -17.119991
    [308]      -20.820919     -23.966560     -25.411455     -25.538692
    [312]      -24.383821     -22.534740     -20.546537     -18.283350
    [316]      -15.762049     -13.269934     -10.957927     -8.8182192
    [320]      -6.8415508     -5.0769634     -3.5944693     -2.4517100
    [324]      -1.7068573     -1.4500641     -1.8117714     -2.9003134
    [328]      -4.4733663     -5.0657487     -3.4710844     -1.3997128
    [332]    -0.054675091     0.37580791    -0.10079147     -1.5581942
    [336]      -4.3377624     -9.5391846     -16.306377     -8.7155762
    [340]      -4.1933551     -2.0241430     -1.2860135     -1.6580678
    [344]      -3.0119328     -5.2343407     -7.8770618     -9.4192057
    [348]      -8.7110100     -7.2121534     -6.0535440     -5.4917674
    [352]      -5.5673118     -6.2818966     -7.5837464     -9.2070351
    [356]      -10.274748     -9.6700850     -7.8906865     -6.0786724
    [360]      -4.6741734     -3.7263424     -3.1990659     -3.0852206
    [364]      -3.4504251     -4.4455018     -6.3111906     -9.2864962
    [368]      -12.073013     -9.9536724     -6.2964606     -3.7324452
    [372]      -2.2093384     -1.5547221     -1.7120832     -2.7342021
    [376]      -4.8207550     -8.5315046     -16.050026     -23.167372
    [380]      -11.963319     -7.9179668     -5.9294982     -4.9766822
    [384]      -4.5774531     -4.3947620     -4.2596216     -4.2229719
    [388]      -4.4570923     -5.1350312     -6.4240847     -8.5760841
    [392]      -12.148147     -19.019661     -34.417179     -17.666740
    [396]      -13.317746     -11.331076     -10.416509     -10.033655
    [400]      -9.8355312     -9.6037645     -9.2838621     -8.9531183
    [404]      -8.7052221     -8.5531349     -8.3996801     -8.0873308
    [408]      -7.5282860     -6.8013077     -6.0903096     -5.5608239
    [412]      -5.3058624     -5.3537307     -5.6948533     -6.3122301
    [416]      -7.2117434     -8.4435978     -10.103541     -12.289541
    [420]      -14.851250     -16.437851     -15.209575     -12.761440
    [424]      -10.653865     -9.1600161     -8.2685776     -7.9589367
    [428]      -8.2245216     -9.0575676     -10.438036     -12.349257
    [432]      -14.826273     -17.861889     -20.259943     -19.330683
    [436]      -17.132360     -15.826878     -15.604619     -16.172028
    [440]      -16.923323     -17.116129     -16.673105     -16.156874
    [444]      -15.962653     -16.184523     -16.775909     -17.623306
    [448]      -18.550484     -19.367001     -20.038799     -20.778522
    [452]      -21.835850     -23.157301     -24.200977     -24.595421
    [456]      -24.948950     -25.929535     -27.359098     -28.490646
    [460]      -29.560492     -27.734156     -21.004333     -15.316534
    [464]      -11.221946     -8.3402014     -6.4209852     -5.3223433
    [468]      -4.9639134     -5.2893143     -6.2051654     -7.4335136
    [472]      -8.3079176     -8.1678181     -7.3372893     -6.5943961
    [476]      -6.3634028     -6.7956176     -7.9543228     -9.8679686
    [480]      -12.471144     -15.418330     -18.050613     -20.176353
    [484]      -21.913946     -21.787512     -19.777632     -18.099056
    [488]      -17.435640     -17.615055     -18.153000     -18.355043
    [492]      -17.760471     -16.641912     -15.636450     -15.228889
    [496]      -15.662271     -16.848782     -17.814388     -16.994659
    [500]      -15.128398     -13.607768     -12.741899     -12.410327
    [504]      -12.428742     -12.659831     -13.061665     -13.699196
    [508]      -14.724471     -16.352362     -18.860991     -22.476986
    [512]      -25.251192
  [Tag]        12161
  [frame_len]          320
[Record 77]
  [tot_power]       549.12561
  [re_spec_val]
    [0]      -29.691692     -29.270649     -28.474676     -28.055227
    [4]      -28.392586     -29.115091     -28.761816     -27.639097
    [8]      -27.454832     -22.389723     -14.323059     -8.2490845
    [12]      -3.8413856    -0.64987975      1.6299480      3.2398028
    [16]       4.3780956      5.1608977      5.5830951      5.5480294
    [20]       4.9526777      3.7816050      2.2144926     0.67528814
    [24]     -0.51923305     -1.6610781     -3.2578282     -4.9208331
    [28]      -4.2725835     -1.4669197      1.0160812      2.5283933
    [32]       3.1049576      2.8953559      2.1418204      1.2041782
    [36]      0.39911428    -0.26515052    -0.96454519     -1.6883487
    [40]      -2.1972842     -2.4079823     -2.6267040     -3.2746801
    [44]      -4.6885610     -7.2244492     -11.615850     -19.906807
    [48]      -17.359844     -10.835838     -7.1789188     -4.7090888
    [52]      -2.9283726     -1.7184613     -1.1077465     -1.1916556
    [56]      -2.0991454     -3.9434996     -6.5899768     -8.8831100
    [60]      -9.1529264     -8.0795507     -6.2129693     -3.8111897
    [64]      -1.7711127    -0.67125386    -0.70350808     -1.9562806
    [68]      -4.5236692     -8.3012924     -11.509903     -11.429031
    [72]      -10.603723     -10.481486     -10.714779     -10.901115
    [76]      -11.170131     -12.018054     -13.986283     -17.683987
    [80]      -22.840893     -21.291073     -17.312700     -15.042021
    [84]      -14.027879     -14.077144     -15.161684     -16.935495
    [88]      -17.810448     -16.627853     -15.223082     -14.912226
    [92]      -16.093895     -18.321335     -17.597412     -13.992862
    [96]      -11.334487     -9.8830023     -9.2113504     -8.9140673
    [100]      -8.7786598     -8.8839941     -9.5426321     -11.164405
    [104]      -13.509335     -12.725345     -9.0094805     -6.4293323
    [108]      -5.5226474     -6.3159995     -9.1637087     -15.579854
    [112]      -40.147991     -18.491003     -16.193531     -16.531271
    [116]      -14.270854     -10.542616     -8.0227842     -6.7775960
    [120]      -6.5397887     -7.1254888     -8.4530869     -10.527258
    [124]      -13.303328     -15.889191     -15.899314     -14.180027
    [128]      -13.002759     -12.958295     -14.258313     -17.484747
    [132]      -24.890198     -24.324686     -16.452013     -12.600443
    [136]      -10.487621     -9.3952551     -8.9727488     -8.9889164
    [140]      -9.2883177     -9.7952881     -10.514360     -11.536127
    [144]      -13.088262     -15.696818     -20.825903     -30.076321
    [148]      -19.332565     -14.182703     -11.720777     -10.830282
    [152]      -11.175076     -12.723539     -15.737700     -20.549377
    [156]      -22.297747     -18.958359     -17.966473     -20.784193
    [160]      -37.496216     -19.040188     -12.538755     -9.3926449
    [164]      -8.1215372     -8.5615988     -11.375210     -20.057159
    [168]      -16.067120     -8.4290133     -5.0581031     -3.5567389
    [172]      -3.1913376     -3.5720983     -4.4016814     -5.3058085
    [176]      -5.7313657     -5.5044441     -5.3237762     -6.0707974
    [180]      -8.5601501     -14.482509     -21.375261     -12.014791
    [184]      -8.1662827     -6.4858770     -5.8504577     -5.8420658
    [188]      -6.3845911     -7.5582738     -9.4344082     -11.959174
    [192]      -14.884335     -17.909487     -21.213072     -25.886978
    [196]      -33.629669     -29.939880     -24.993284     -23.125025
    [200]      -23.145960     -24.374022     -25.780165     -26.363962
    [204]      -26.199541     -25.249430     -23.871292     -23.375271
    [208]      -25.019482     -31.480116     -36.286991     -25.291636
    [212]      -21.939718     -21.380325     -22.754280     -25.625223
    [216]      -29.218239     -32.982227     -39.351643     -51.570114
    [220]      -38.491104     -34.156986     -29.829998     -25.982216
    [224]      -23.627419     -22.816517     -23.384022     -24.949003
    [228]      -26.339720     -26.197741     -25.484722     -25.658541
    [232]      -27.595659     -33.204712     -48.032368     -30.672409
    [236]      -26.692278     -26.197378     -28.500204     -30.812113
    [240]      -26.408066     -22.844776     -21.418579     -21.629211
    [244]      -23.109447     -25.460283     -28.171547     -30.443693
    [248]      -30.327946     -28.096565     -26.112299     -24.792410
    [252]      -23.681812     -22.527601     -21.605839     -21.358574
    [256]      -22.124243     -23.869814     -24.541296     -21.923376
    [260]      -19.202894     -17.917479     -18.330631     -21.013243
    [264]      -28.774508     -30.546856     -21.480631     -18.504305
    [268]      -18.182875     -20.150471     -24.720407     -26.187870
    [272]      -21.685497     -19.537355     -19.683651     -22.132301
    [276]      -28.556141     -40.520035     -26.113888     -22.133810
    [280]      -20.770189     -21.008036     -22.629581     -25.576319
    [284]      -28.883209     -29.386787     -28.369980     -28.660275
    [288]      -30.490583     -30.782846     -27.531300     -24.888771
    [292]      -23.689976     -23.320887     -22.705843     -21.394619
    [296]      -20.128798     -19.546913     -19.800201     -20.759029
    [300]      -21.997597     -22.694744     -22.241982     -21.041252
    [304]      -19.775604     -18.827303     -18.404541     -18.679544
    [308]      -19.856495     -22.272100     -26.674496     -32.322060
    [312]      -26.247259     -20.592203     -16.886721     -14.417392
    [316]      -12.888397     -12.046952     -11.557402     -11.084158
    [320]      -10.500044     -9.8468513     -9.1112490     -8.2950544
    [324]      -7.6257353     -7.4712520     -8.1561661     -9.9566956
    [328]      -13.252433     -18.997961     -29.389565     -22.922129
    [332]      -18.396370     -16.755568     -16.853407     -18.162416
    [336]      -19.607363     -20.448261     -22.647814     -31.824139
    [340]      -24.782305     -17.471395     -14.696486     -14.457170
    [344]      -16.590992     -22.311783     -47.815300     -24.461699
    [348]      -20.849623     -20.577192     -22.419720     -26.961142
    [352]      -37.783695     -29.118824     -23.726559     -21.001717
    [356]      -18.993784     -17.406446     -16.748014     -17.624865
    [360]      -20.795565     -25.494678     -21.204079     -17.028372
    [364]      -15.263065     -15.174386     -16.325218     -18.052444
    [368]      -18.987162     -18.639723     -18.272385     -18.651863
    [372]      -19.730509     -20.998043     -21.989071     -22.942112
    [376]      -24.264904     -25.497253     -25.490202     -24.323050
    [380]      -22.668234     -20.822123     -19.203770     -18.164505
    [384]      -17.774206     -17.905439     -18.396376     -19.182262
    [388]      -20.242479     -21.382509     -22.241604     -22.786774
    [392]      -23.425068     -24.471836     -25.948631     -27.678780
    [396]      -29.105196     -29.082447     -27.677383     -26.362410
    [400]      -26.036268     -27.208519     -30.761673     -40.374695
    [404]      -38.979218     -32.681103     -32.172291     -36.015907
    [408]      -43.066891     -34.845669     -31.530231     -31.690269
    [412]      -34.896408     -38.257168     -33.508183     -30.115650
    [416]      -29.001720     -29.673723     -32.001865     -35.591900
    [420]      -37.553497     -36.783897     -37.179840     -40.471416
    [424]      -45.220551     -38.665619     -33.912544     -31.438101
    [428]      -30.413261     -30.617750     -32.225029     -35.976254
    [432]      -42.057625     -36.603634     -31.325466     -28.459995
    [436]      -26.993406     -26.440041     -26.434277     -26.639360
    [440]      -26.919758     -27.477226     -28.597328     -30.076786
    [444]      -30.560991     -29.403976     -28.207886     -27.979948
    [448]      -28.951460     -31.212046     -35.027580     -41.893272
    [452]      -49.212814     -37.026882     -31.610054     -28.559647
    [456]      -27.021923     -26.670473     -27.249868     -28.468239
    [460]      -30.270885     -33.669930     -44.334129     -36.557262
    [464]      -29.007051     -25.840782     -24.974648     -26.095768
    [468]      -29.575834     -35.558533     -33.686790     -30.103550
    [472]      -29.464289     -31.420219     -36.973442     -43.802738
    [476]      -35.827320     -33.057796     -33.713310     -38.804790
    [480]      -49.322998     -34.585911     -30.192711     -28.740368
    [484]      -29.211355     -31.013016     -31.951656     -29.917938
    [488]      -27.423439     -25.609337     -24.378435     -23.687214
    [492]      -23.711864     -24.741755     -27.111973     -30.800087
    [496]      -32.228573     -29.498568     -27.351671     -26.299910
    [500]      -25.843214     -25.631296     -25.565838     -25.650833
    [504]      -25.866106     -26.224592     -26.850117     -27.925848
    [508]      -29.600882     -31.950676     -34.947758     -38.221539
    [512]      -40.005421
  [Tag]        12321
  [frame_len]          320
[Record 78]
  [tot_power]       360.82965
  [re_spec_val]
    [0]      -22.484892     -22.865784     -23.804066     -24.972237
    [4]      -26.826096     -31.628891     -49.787090     -28.894220
    [8]      -24.646814     -24.363775     -21.690405     -13.647365
    [12]      -7.2802520     -2.5640593     0.97756040      3.5870531
    [16]       5.3829041      6.4192238      6.7085543      6.2241068
    [20]       4.8835497      2.5006690     -1.3544085     -7.8947110
    [24]      -20.831833     -14.267329     -13.165536     -20.833664
    [28]      -16.886181     -7.9936733     -4.5607777     -3.6064656
    [32]      -4.6467223     -7.8817420     -12.376311     -9.6616993
    [36]      -5.8464484     -3.9485004     -3.3318994     -3.5340421
    [40]      -4.2419853     -5.2349319     -6.3875141     -7.6713362
    [44]      -9.1030817     -10.632790     -12.036391     -12.999521
    [48]      -13.466609     -13.753179     -14.281589     -15.389852
    [52]      -16.957373     -17.176289     -14.715619     -11.825315
    [56]      -9.5163002     -7.6962867     -6.2080994     -5.0411878
    [60]      -4.2683778     -3.9558949     -4.1398997     -4.8518572
    [64]      -6.1647639     -8.2614098     -11.574733     -17.201805
    [68]      -24.189217     -18.064404     -14.560406     -13.616054
    [72]      -14.473695     -16.984320     -20.767492     -22.451809
    [76]      -20.781530     -19.884748     -20.580181     -22.547487
    [80]      -24.007151     -22.445742     -19.846743     -17.645325
    [84]      -15.741333     -13.936440     -12.253558     -10.846647
    [88]      -9.8551989     -9.3263264     -9.1617584     -9.0648651
    [92]      -8.6327524     -7.7240968     -6.6010489     -5.5971808
    [96]      -4.9155436     -4.6611547     -4.8836484     -5.5587082
    [100]      -6.5265803     -7.4810185     -8.1794615     -8.6698809
    [104]      -9.0202856     -8.9566078     -8.2158728     -7.1062698
    [108]      -6.1145992     -5.4677434     -5.2032828     -5.3311872
    [112]      -5.9147911     -7.0714259     -8.9022274     -11.234066
    [116]      -12.947343     -12.801722     -12.050070     -12.086818
    [120]      -13.336326     -15.648615     -17.111481     -15.519488
    [124]      -13.497504     -12.521741     -12.646729     -13.741231
    [128]      -15.654433     -18.136953     -20.615608     -21.924973
    [132]      -21.271168     -19.613548     -18.091318     -17.178720
    [136]      -17.056784     -17.871521     -19.864511     -23.570818
    [140]      -30.479435     -35.544216     -29.168390     -27.159763
    [144]      -27.648350     -27.562309     -23.590540     -19.670214
    [148]      -17.260046     -16.267668     -16.561077     -18.051876
    [152]      -20.561625     -23.617321     -26.801388     -30.394690
    [156]      -30.158278     -25.646049     -22.657251     -21.233805
    [160]      -20.840336     -21.130650     -21.864653     -22.156321
    [164]      -20.505913     -17.894144     -15.940317     -15.086738
    [168]      -15.336976     -16.515667     -17.983259     -18.355404
    [172]      -17.157917     -15.331161     -13.276628     -11.042280
    [176]      -8.8637218     -7.0546474     -5.8318639     -5.3146701
    [180]      -5.5682650     -6.5961466     -8.1729918     -9.3905439
    [184]      -9.0909061     -7.8917007     -6.9676166     -6.7309437
    [188]      -7.2411985     -8.5030909     -10.538196     -13.316953
    [192]      -16.332890     -17.971207     -17.872906     -17.869162
    [196]      -18.913744     -21.243216     -24.807470     -28.443727
    [200]      -29.489052     -29.107525     -28.933527     -28.404106
    [204]      -26.831005     -24.610849     -22.446400     -20.685255
    [208]      -19.392366     -18.469889     -17.731054     -17.016811
    [212]      -16.329321     -15.827327     -15.696548     -16.061014
    [216]      -16.973219     -18.432415     -20.402550     -22.823004
    [220]      -25.599983     -28.598629     -31.798014     -35.268345
    [224]      -35.588997     -31.262846     -27.790113     -25.896402
    [228]      -25.366314     -26.046453     -27.801798     -30.263266
    [232]      -32.211193     -31.931885     -29.917685     -27.658831
    [236]      -25.892605     -24.873848     -24.656017     -25.199793
    [240]      -26.380554     -27.913290     -29.282829     -30.008678
    [244]      -30.128778     -29.975773     -29.719923     -29.382029
    [248]      -28.991083     -28.648794     -28.511539     -28.700241
    [252]      -29.125095     -29.370382     -29.173927     -29.096331
    [256]      -30.085516     -33.157078     -38.783085     -35.953999
    [260]      -31.944342     -31.300138     -34.009037     -38.937183
    [264]      -32.685455     -28.124763     -26.252310     -26.188616
    [268]      -27.501438     -29.427029     -30.258570     -29.834530
    [272]      -30.031187     -32.084461     -37.724499     -53.514397
    [276]      -37.437477     -33.742493     -33.252300     -34.619747
    [280]      -36.716885     -37.476765     -35.747555     -32.473682
    [284]      -29.170742     -26.657524     -25.053511     -24.181549
    [288]      -23.709200     -23.251915     -22.639223     -22.074860
    [292]      -21.927435     -22.508175     -23.948835     -25.659708
    [296]      -25.612570     -23.935467     -22.806400     -22.910648
    [300]      -23.970501     -24.764191     -24.326126     -23.856846
    [304]      -24.398851     -25.616789     -25.767197     -24.616037
    [308]      -23.952505     -24.493587     -26.092695     -27.654854
    [312]      -26.750065     -23.619385     -20.546381     -18.374519
    [316]      -17.268164     -17.253523     -18.304401     -20.100645
    [320]      -21.129503     -19.773397     -17.605242     -15.959917
    [324]      -15.064274     -14.935975     -15.647150     -17.396622
    [328]      -20.649761     -26.865942     -52.379723     -27.736366
    [332]      -22.092407     -18.647295     -16.240192     -14.707224
    [336]      -13.912266     -13.530672     -13.115689     -12.513441
    [340]      -12.066126     -12.232434     -13.354719     -15.756707
    [344]      -19.956499     -26.328003     -26.931747     -23.625937
    [348]      -22.441242     -22.450609     -22.617889     -22.316151
    [352]      -21.544689     -20.507893     -19.472008     -18.807781
    [356]      -18.866352     -19.946604     -22.410624     -26.714823
    [360]      -29.831110     -26.128426     -23.305292     -22.421629
    [364]      -23.282953     -26.227205     -32.921677     -37.703106
    [368]      -30.007338     -27.361588     -26.951399     -27.423975
    [372]      -27.713472     -27.899113     -29.155123     -33.130173
    [376]      -41.490406     -32.112709     -26.829126     -24.315914
    [380]      -23.324968     -23.394699     -24.289890     -25.838879
    [384]      -27.828321     -29.881550     -31.462349     -32.299778
    [388]      -32.649887     -32.809917     -32.848328     -32.812481
    [392]      -32.883472     -33.272907     -34.077221     -35.212872
    [396]      -36.386497     -37.107113     -36.850636     -35.463383
    [400]      -33.378716     -31.198191     -29.329016     -28.001717
    [404]      -27.373129     -27.593199     -28.851297     -31.417360
    [408]      -35.522324     -39.482754     -39.409897     -39.854706
    [412]      -44.731453     -48.277981     -38.831879     -35.157860
    [416]      -34.240765     -35.548660     -39.908104     -53.203499
    [420]      -40.411209     -34.418182     -31.436546     -30.011908
    [424]      -29.767244     -30.533936     -31.994862     -33.382515
    [428]      -34.085941     -34.728104     -35.900379     -36.421780
    [432]      -34.867031     -33.030094     -32.229725     -32.664345
    [436]      -34.360439     -37.555725     -43.380241     -52.648708
    [440]      -42.530144     -37.223713     -34.205078     -32.519409
    [444]      -31.993168     -32.723442     -35.023373     -39.507069
    [448]      -44.668758     -42.034283     -40.106018     -40.994724
    [452]      -44.083168     -44.808983     -41.785294     -40.323795
    [456]      -41.110935     -44.396107     -46.877823     -41.332962
    [460]      -36.951675     -34.426281     -33.337639     -33.646835
    [464]      -35.565380     -39.066887     -40.070839     -37.092606
    [468]      -35.567863     -36.347176     -40.184662     -53.649738
    [472]      -44.256779     -38.195168     -36.104820     -35.843300
    [476]      -36.625683     -37.276241     -36.085926     -33.577362
    [480]      -31.259346     -29.632769     -28.777681     -28.746078
    [484]      -29.675623     -31.845743     -35.373169     -36.321678
    [488]      -32.204006     -28.804110     -26.635466     -25.292425
    [492]      -24.516155     -24.207136     -24.378475     -25.090382
    [496]      -26.393847     -28.294458     -30.726093     -33.532196
    [500]      -36.469963     -39.057785     -39.813274     -37.826862
    [504]      -35.169395     -33.196392     -32.185417     -32.137215
    [508]      -32.908718     -34.016102     -34.568089     -34.331963
    [512]      -34.105446
  [Tag]        12481
  [frame_len]          320
[Record 79]
  [tot_power]       26.020014
  [re_spec_val]
    [0]      -17.186008     -16.810596     -16.186037     -16.062714
    [4]      -16.860275     -18.835728     -22.320557     -27.817738
    [8]      -33.059345     -32.826160     -38.460590     -31.558426
    [12]      -21.681435     -16.808548     -14.421737     -14.028168
    [16]      -15.772875     -19.905561     -19.366480     -14.220233
    [20]      -11.232806     -9.9512625     -9.9669209     -11.152296
    [24]      -13.256135     -14.363719     -12.259486     -9.5701475
    [28]      -7.7327871     -6.7504802     -6.4885402     -6.9165115
    [32]      -8.1389103     -10.407163     -14.220840     -20.834774
    [36]      -31.684338     -25.622240     -23.887144     -25.317572
    [40]      -26.329685     -24.194450     -22.153318     -21.126219
    [44]      -20.567505     -20.036011     -19.666466     -19.898026
    [48]      -21.130747     -23.782173     -28.461742     -31.986641
    [52]      -27.020885     -22.884745     -20.063150     -17.991066
    [56]      -16.477230     -15.493688     -15.043551     -15.081136
    [60]      -15.456425     -15.922773     -16.247805     -16.242159
    [64]      -15.656023     -14.502703     -13.348172     -12.820636
    [68]      -13.324563     -15.192447     -18.972269     -26.068588
    [72]      -32.246212     -27.178854     -26.792145     -29.984911
    [76]      -32.559132     -28.343405     -25.683262     -25.188995
    [80]      -26.398432     -28.820227     -30.768064     -30.667681
    [84]      -30.555079     -32.183178     -37.505447     -50.635284
    [88]      -33.308052     -28.181688     -25.905308     -25.412437
    [92]      -26.385406     -28.627312     -31.642231     -34.002823
    [96]      -34.241371     -32.415028     -28.874020     -24.797625
    [100]      -21.258337     -18.619934     -16.926966     -16.143803
    [104]      -16.227314     -17.139072     -18.819143     -21.077650
    [108]      -23.326130     -24.591261     -24.802868     -25.001186
    [112]      -26.140409     -29.303547     -36.048008     -30.230179
    [116]      -24.126526     -21.054195     -19.837021     -20.149956
    [120]      -21.997210     -25.360016     -28.195444     -27.098417
    [124]      -25.921400     -26.463242     -28.389866     -29.681425
    [128]      -28.504837     -27.115601     -26.754192     -27.389147
    [132]      -28.659138     -29.851900     -30.088907     -29.422346
    [136]      -28.707350     -28.533865     -29.138493     -30.555647
    [140]      -32.535847     -34.339661     -35.123920     -34.420197
    [144]      -31.991884     -28.879297     -26.183817     -24.240980
    [148]      -23.083624     -22.726448     -23.272322     -25.016794
    [152]      -28.753729     -36.561886     -32.981136     -26.884085
    [156]      -24.038681     -22.845478     -22.668116     -23.133291
    [160]      -24.038059     -25.397562     -27.301100     -29.421814
    [164]      -30.871120     -32.121616     -35.689728     -44.940243
    [168]      -34.166836     -29.062422     -27.400244     -28.160948
    [172]      -31.546825     -39.436146     -53.667408     -41.616341
    [176]      -34.080257     -27.533812     -23.287645     -20.839779
    [180]      -19.839046     -20.163248     -21.893728     -25.408205
    [184]      -31.853537     -42.056847     -36.301437     -33.507172
    [188]      -31.512480     -29.357904     -28.297112     -29.050467
    [192]      -31.487806     -31.053122     -26.818022     -23.800774
    [196]      -22.301189     -21.980234     -22.580889     -23.874079
    [200]      -25.619789     -27.657431     -30.084324     -33.165451
    [204]      -36.136337     -35.674267     -33.252682     -31.556452
    [208]      -30.812315     -30.833160     -31.469515     -32.678329
    [212]      -34.532040     -36.584686     -35.820583     -32.243290
    [216]      -29.183445     -27.282959     -26.446329     -26.562063
    [220]      -27.570530     -29.473436     -32.366226     -36.498814
    [224]      -41.973717     -44.696960     -42.428570     -40.645184
    [228]      -38.792747     -35.996071     -33.086075     -30.802528
    [232]      -29.300381     -28.533749     -28.429813     -28.935804
    [236]      -30.020216     -31.610485     -33.411968     -34.820263
    [240]      -35.702209     -37.058079     -40.476364     -49.340652
    [244]      -43.669182     -37.346527     -34.408871     -32.833187
    [248]      -31.850023     -31.359982     -31.742880     -33.591202
    [252]      -37.349781     -38.099094     -33.562099     -30.661592
    [256]      -29.432381     -29.215736     -29.295225     -29.099768
    [260]      -28.744623     -28.771387     -29.590382     -31.451246
    [264]      -34.543026     -38.374840     -39.141369     -37.013866
    [268]      -35.907673     -36.626572     -39.948078     -49.807171
    [272]      -44.356659     -37.978619     -36.021076     -36.922142
    [276]      -41.961010     -50.627018     -36.975414     -31.771622
    [280]      -28.916361     -27.306400     -26.583641     -26.605196
    [284]      -27.256742     -28.328304     -29.508228     -30.716703
    [288]      -32.554867     -36.670414     -52.433052     -36.425190
    [292]      -29.758526     -26.288534     -24.331921     -23.350231
    [296]      -23.074018     -23.324751     -23.959944     -24.837296
    [300]      -25.743464     -26.321514     -26.262934     -25.727978
    [304]      -25.210938     -25.096495     -25.574600     -26.734638
    [308]      -28.602444     -30.904417     -32.180698     -30.948978
    [312]      -28.883623     -27.332254     -26.495773     -26.294397
    [316]      -26.613075     -27.354601     -28.454233     -29.765171
    [320]      -30.642841     -30.084946     -28.580141     -27.477825
    [324]      -27.540810     -29.382454     -34.370064     -37.020279
    [328]      -28.991579     -24.597967     -22.170935     -20.892740
    [332]      -20.367966     -20.320030     -20.499722     -20.693718
    [336]      -20.795481     -20.842619     -20.957035     -21.247778
    [340]      -21.725370     -22.225731     -22.468109     -22.414669
    [344]      -22.469614     -23.160772     -24.916084     -28.061544
    [348]      -31.988195     -32.228817     -29.932074     -28.614353
    [352]      -28.268854     -28.415222     -28.645264     -28.798479
    [356]      -29.105185     -30.046442     -32.073490     -35.073616
    [360]      -36.529476     -35.467411     -35.550446     -38.925358
    [364]      -51.224854     -38.271614     -32.354198     -29.614895
    [368]      -28.513912     -28.578964     -29.670435     -31.895609
    [372]      -35.824879     -43.654114     -43.740543     -36.058525
    [376]      -32.320904     -30.364590     -29.654371     -30.105825
    [380]      -31.842909     -35.093498     -38.941483     -38.190033
    [384]      -35.510071     -34.137794     -33.907955     -34.376461
    [388]      -35.180782     -36.253109     -38.020573     -41.577484
    [392]      -51.405720     -48.279736     -39.672131     -35.917351
    [396]      -34.006104     -33.254524     -33.369038     -34.064342
    [400]      -34.905811     -35.519653     -36.083763     -37.179607
    [404]      -39.100681     -40.183937     -37.530323     -34.126282
    [408]      -31.792175     -30.630320     -30.634684     -31.976118
    [412]      -35.249840     -42.930901     -50.294361     -39.218323
    [416]      -36.643955     -37.190727     -40.553291     -45.907738
    [420]      -43.563774     -40.692966     -39.230995     -36.494724
    [424]      -33.077908     -30.520674     -29.064140     -28.550550
    [428]      -28.779251     -29.570955     -30.808500     -32.473335
    [432]      -34.597778     -36.993484     -38.722988     -38.880676
    [436]      -38.433987     -38.461330     -39.120361     -39.973259
    [440]      -40.310310     -39.868221     -39.062717     -38.445049
    [444]      -38.500912     -39.740578     -42.960438     -49.549679
    [448]      -47.775475     -42.348137     -40.207306     -40.229866
    [452]      -42.153023     -45.228088     -44.015797     -40.123112
    [456]      -37.690876     -36.831921     -37.488277     -40.017746
    [460]      -46.133369     -56.648800     -43.692608     -39.599308
    [464]      -38.319077     -39.045673     -41.686707     -43.121517
    [468]      -39.101311     -35.736477     -34.148186     -34.037300
    [472]      -35.173523     -37.302582     -40.048531     -43.123890
    [476]      -45.193642     -42.707130     -39.409023     -37.591030
    [480]      -36.970226     -36.654648     -35.768017     -34.561047
    [484]      -33.807175     -33.881481     -34.858749     -36.706829
    [488]      -39.338100     -42.557098     -45.695686     -46.719398
    [492]      -44.685097     -41.689438     -38.891850     -36.627041
    [496]      -35.034126     -34.145660     -33.892933     -34.099571
    [500]      -34.509930     -34.939064     -35.448822     -36.285191
    [504]      -37.666592     -39.673656     -42.184780     -44.100109
    [508]      -42.417892     -38.719757     -35.764835     -34.010448
    [512]      -33.433899
  [Tag]        12641
  [frame_len]          320
[Record 80]
  [tot_power]       26.275639
  [re_spec_val]
    [0]      -23.769247     -21.249617     -18.290873     -16.838306
    [4]      -16.693178     -17.599291     -19.292297     -21.370384
    [8]      -23.198812     -23.956684     -23.356228     -22.285217
    [12]      -21.474792     -20.524181     -18.588877     -16.140694
    [16]      -14.177081     -13.101999     -12.957732     -13.640530
    [20]      -14.904677     -16.305552     -17.176413     -16.697029
    [24]      -14.808722     -12.603577     -10.890201     -9.8571339
    [28]      -9.4046030     -9.3598471     -9.6400728     -10.347234
    [32]      -11.710430     -13.931939     -16.825251     -18.751312
    [36]      -18.131475     -16.847216     -16.088488     -15.935951
    [40]      -16.360754     -17.438719     -19.335262     -22.240124
    [44]      -25.843628     -27.210526     -25.502626     -24.363045
    [48]      -24.845402     -27.259264     -30.833118     -28.877192
    [52]      -25.080797     -23.071360     -22.446325     -22.624922
    [56]      -22.989374     -23.072327     -22.830860     -22.420702
    [60]      -21.882050     -21.161949     -20.234829     -19.139524
    [64]      -17.968740     -16.871092     -16.038910     -15.663084
    [68]      -15.894550     -16.835394     -18.546698     -21.061300
    [72]      -24.400652     -28.448935     -31.500162     -30.473951
    [76]      -28.488375     -27.638893     -28.058573     -29.600952
    [80]      -31.950758     -34.442142     -36.403332     -38.004143
    [84]      -39.620316     -40.820469     -40.567955     -38.692261
    [88]      -36.257332     -34.040657     -32.239307     -30.886295
    [92]      -30.040003     -29.726870     -29.833456     -30.147490
    [96]      -30.650919     -31.725504     -33.990864     -38.247894
    [100]      -46.028488     -62.382179     -52.360077     -42.764561
    [104]      -37.234425     -34.395393     -33.452953     -33.953453
    [108]      -35.484402     -37.423027     -38.874794     -39.275322
    [112]      -39.033592     -38.913815     -39.389954     -41.039051
    [116]      -46.363304     -51.747330     -37.393852     -31.498819
    [120]      -28.077782     -26.110693     -25.163799     -24.934464
    [124]      -25.146112     -25.581499     -26.185390     -27.071388
    [128]      -28.366112     -29.996264     -31.544666     -32.558460
    [132]      -33.122852     -33.374096     -33.067776     -32.442245
    [136]      -32.292671     -33.085896     -34.273632     -33.752079
    [140]      -31.618317     -29.937460     -29.299299     -29.607410
    [144]      -30.543558     -31.519884     -31.850885     -31.538794
    [148]      -31.302856     -31.796986     -33.368736     -35.692722
    [152]      -36.458706     -35.054718     -34.263645     -34.850052
    [156]      -35.314480     -33.049049     -30.022692     -28.007336
    [160]      -27.165108     -27.430132     -28.820234     -31.501143
    [164]      -35.561008     -37.557838     -34.036430     -30.877424
    [168]      -28.973856     -28.063831     -28.026464     -28.885071
    [172]      -30.782068     -33.864540     -36.979626     -36.129177
    [176]      -33.859535     -32.962528     -33.747829     -36.520111
    [180]      -42.526459     -55.395023     -45.687672     -41.489361
    [184]      -37.430099     -33.040810     -29.568897     -27.224491
    [188]      -25.894167     -25.473303     -25.904583     -27.136990
    [192]      -28.944035     -30.379423     -30.000338     -28.391987
    [196]      -26.940367     -26.113556     -25.928026     -26.189632
    [200]      -26.405148     -25.884535     -24.500673     -22.821318
    [204]      -21.335480     -20.246008     -19.607752     -19.407415
    [208]      -19.582653     -20.033775     -20.660696     -21.418797
    [212]      -22.337706     -23.465332     -24.770275     -26.054548
    [216]      -26.972431     -27.299498     -27.188257     -26.980890
    [220]      -26.946266     -27.248745     -27.993780     -29.231117
    [224]      -30.872976     -32.484356     -33.275993     -33.119003
    [228]      -32.899220     -33.431606     -35.240967     -38.695202
    [232]      -41.836178     -39.720974     -37.349045     -35.971474
    [236]      -34.232410     -31.957098     -30.172522     -29.483597
    [240]      -30.108658     -32.074390     -34.024506     -32.306908
    [244]      -29.250580     -27.246346     -26.425068     -26.692062
    [248]      -28.054674     -30.617443     -34.281040     -36.947784
    [252]      -36.081783     -34.734444     -33.914120     -32.996281
    [256]      -31.849863     -30.992325     -30.861235     -31.708975
    [260]      -33.855057     -38.091881     -46.233074     -42.979275
    [264]      -37.910812     -35.978268     -35.422928     -34.952145
    [268]      -33.823837     -32.491955     -31.582451     -31.296196
    [272]      -31.641445     -32.693501     -34.791367     -38.664906
    [276]      -42.393559     -37.646194     -33.615265     -31.541489
    [280]      -30.681141     -30.426727     -30.260332     -29.978609
    [284]      -29.698833     -29.453278     -28.976120     -28.016901
    [288]      -26.768864     -25.670565     -25.038460     -25.019026
    [292]      -25.644058     -26.821575     -28.226000     -29.236631
    [296]      -29.448654     -29.237186     -29.159069     -29.380470
    [300]      -29.663265     -29.670105     -29.527290     -29.822969
    [304]      -31.177414     -34.299538     -40.873928     -47.542881
    [308]      -39.531982     -36.928177     -36.987904     -38.870167
    [312]      -41.638954     -42.139816     -40.249664     -38.938416
    [316]      -38.625755     -38.743237     -38.703831     -38.653118
    [320]      -38.889301     -38.453072     -36.195358     -33.426270
    [324]      -31.257708     -29.806042     -28.927780     -28.471369
    [328]      -28.263508     -28.011631     -27.361347     -26.237505
    [332]      -24.929354     -23.738468     -22.790806     -22.079638
    [336]      -21.534975     -21.066374     -20.590252     -20.045153
    [340]      -19.395647     -18.639233     -17.821304     -17.034861
    [344]      -16.392202     -15.989903     -15.886039     -16.083822
    [348]      -16.507206     -16.974104     -17.230494     -17.114815
    [352]      -16.694893     -16.158489     -15.641376     -15.200603
    [356]      -14.874759     -14.728901     -14.849039     -15.304290
    [360]      -16.099085     -17.117447     -18.090805     -18.726446
    [364]      -19.001339     -19.184729     -19.546976     -20.196297
    [368]      -21.067617     -21.932014     -22.494755     -22.665354
    [372]      -22.662346     -22.750145     -23.018591     -23.364803
    [376]      -23.575956     -23.482094     -23.097658     -22.604679
    [380]      -22.216436     -22.073193     -22.203461     -22.511845
    [384]      -22.788694     -22.795259     -22.434015     -21.830812
    [388]      -21.221809     -20.811258     -20.709452     -20.901140
    [392]      -21.197001     -21.243828     -20.793089     -20.004658
    [396]      -19.248905     -18.784212     -18.705824     -18.997089
    [400]      -19.549181     -20.153593     -20.549690     -20.602533
    [404]      -20.436977     -20.309462     -20.412153     -20.794571
    [408]      -21.337490     -21.753094     -21.751875     -21.346695
    [412]      -20.830290     -20.477318     -20.426531     -20.728977
    [416]      -21.408979     -22.483316     -23.898745     -25.301945
    [420]      -25.827232     -25.046885     -23.794048     -22.855858
    [424]      -22.492823     -22.721697     -23.466135     -24.580860
    [428]      -25.847866     -27.026470     -27.985922     -28.782116
    [432]      -29.563807     -30.434862     -31.358959     -32.072029
    [436]      -32.164623     -31.556143     -30.646883     -29.822666
    [440]      -29.210461     -28.762886     -28.385042     -28.025232
    [444]      -27.701258     -27.466076     -27.362993     -27.399458
    [448]      -27.521643     -27.570316     -27.278801     -26.462641
    [452]      -25.262928     -24.027369     -23.036087     -22.426199
    [456]      -22.232983     -22.425909     -22.915831     -23.545198
    [460]      -24.095913     -24.373384     -24.349092     -24.192091
    [464]      -24.142756     -24.395321     -25.050224     -26.050585
    [468]      -27.015287     -27.209835     -26.356289     -25.062544
    [472]      -23.896629     -23.053347     -22.555244     -22.392242
    [476]      -22.563541     -23.068056     -23.860504     -24.778528
    [480]      -25.498528     -25.703997     -25.417501     -24.950560
    [484]      -24.572241     -24.392895     -24.402401     -24.514954
    [488]      -24.618292     -24.636974     -24.555286     -24.375826
    [492]      -24.095083     -23.744038     -23.417068     -23.227333
    [496]      -23.235689     -23.405443     -23.594997     -23.622404
    [500]      -23.411821     -23.069311     -22.775194     -22.648684
    [504]      -22.706942     -22.883648     -23.066402     -23.146965
    [508]      -23.073647     -22.874207     -22.632370     -22.441898
    [512]      -22.370396
  [Tag]        12801
  [frame_len]          320
[Record 81]
  [tot_power]       7.2663765
  [re_spec_val]
    [0]      -24.306351     -22.966619     -20.854763     -19.461752
    [4]      -18.932993     -19.189150     -20.195396     -21.942772
    [8]      -24.180790     -25.410587     -23.672527     -20.822163
    [12]      -18.646992     -17.583858     -17.792332     -19.491837
    [16]      -23.063036     -27.938145     -27.496813     -25.142958
    [20]      -24.085857     -22.006018     -18.523130     -15.624947
    [24]      -14.077383     -14.137091     -16.365561     -22.859005
    [28]      -24.093178     -15.870315     -12.449788     -11.258272
    [32]      -11.546642     -12.962890     -15.163645     -17.640364
    [36]      -19.837326     -21.411570     -22.181778     -22.512758
    [40]      -23.330812     -25.447865     -29.632212     -36.840473
    [44]      -38.679283     -36.263489     -38.290352     -43.711182
    [48]      -35.521812     -29.821011     -26.535114     -24.575603
    [52]      -23.561556     -23.371523     -23.995943     -25.472301
    [56]      -27.819981     -30.849159     -33.686089     -35.026207
    [60]      -34.887726     -33.765167     -32.243427     -31.198112
    [64]      -31.172562     -32.343418     -34.301411     -34.981815
    [68]      -33.431435     -31.957003     -31.519352     -32.117031
    [72]      -33.537197     -35.277096     -36.148193     -35.197071
    [76]      -33.382221     -31.831684     -30.957493     -30.869497
    [80]      -31.596054     -33.140335     -35.472355     -38.379154
    [84]      -40.785629     -40.710190     -38.900455     -37.103989
    [88]      -35.745216     -34.743084     -33.966373     -33.448490
    [92]      -33.444996     -34.231018     -35.367352     -34.420937
    [96]      -31.305588     -28.607296     -27.003796     -26.450245
    [100]      -26.850250     -28.147375     -30.305387     -33.127346
    [104]      -35.563831     -35.946526     -35.253204     -35.106941
    [108]      -35.872849     -37.192554     -38.048912     -37.788200
    [112]      -37.158436     -36.782391     -36.474949     -35.690563
    [116]      -34.292652     -32.712292     -31.370787     -30.474394
    [120]      -30.118612     -30.378592     -31.361734     -33.290070
    [124]      -36.774132     -44.156860     -45.655979     -36.728069
    [128]      -32.680359     -30.722342     -30.220364     -31.062771
    [132]      -33.436687     -37.580784     -38.936344     -34.457577
    [136]      -31.262583     -29.687767     -29.380629     -30.148645
    [140]      -31.735710     -33.344692     -33.657730     -32.843643
    [144]      -32.014599     -31.403996     -30.706202     -29.806263
    [148]      -28.993992     -28.593777     -28.737915     -29.409882
    [152]      -30.561081     -32.228935     -34.536266     -37.215981
    [156]      -38.449596     -37.558212     -36.907013     -37.272472
    [160]      -37.185833     -34.859589     -32.117702     -30.361099
    [164]      -29.741865     -30.083868     -30.889458     -31.169411
    [168]      -30.463322     -29.633705     -29.517456     -30.523401
    [172]      -33.004982     -37.375626     -40.695236     -37.654797
    [176]      -35.577839     -35.704220     -38.069916     -42.754009
    [180]      -41.467770     -36.206612     -33.045837     -31.386089
    [184]      -30.819616     -31.139444     -32.135715     -33.463886
    [188]      -34.780731     -36.273014     -38.779499     -42.302650
    [192]      -40.187824     -35.969444     -34.035374     -34.378502
    [196]      -36.306606     -34.880646     -30.835270     -28.528643
    [200]      -28.369663     -30.673409     -35.828762     -33.903946
    [204]      -29.234873     -27.553774     -28.202587     -30.815334
    [208]      -33.015793     -31.175764     -29.509041     -29.793442
    [212]      -32.250042     -37.659531     -50.284401     -49.238190
    [216]      -47.837490     -60.212631     -47.260548     -41.013737
    [220]      -38.023167     -35.876675     -33.901325     -32.278008
    [224]      -31.360996     -31.456112     -32.962029     -36.752270
    [228]      -44.541962     -39.926407     -34.681309     -32.499500
    [232]      -31.920296     -32.181885     -32.545898     -32.415344
    [236]      -31.904655     -31.648783     -32.252991     -34.336475
    [240]      -39.221710     -51.715668     -40.872757     -36.232941
    [244]      -34.997562     -35.959141     -39.277809     -47.188107
    [248]      -55.415611     -44.587177     -42.324703     -42.383827
    [252]      -41.933701     -39.152588     -35.928661     -33.292950
    [256]      -31.294720     -29.913702     -29.173571     -29.070595
    [260]      -29.493942     -30.175934     -30.804176     -31.325769
    [264]      -31.927052     -32.523170     -32.530556     -31.757771
    [268]      -30.901918     -30.539906     -30.751089     -31.289099
    [272]      -31.824385     -32.288685     -32.954311     -34.176342
    [276]      -36.291752     -39.811478     -46.079311     -53.044319
    [280]      -44.807556     -40.375080     -37.726555     -35.901634
    [284]      -34.380634     -32.796356     -31.239321     -30.156317
    [288]      -29.913580     -30.593912     -31.705839     -31.934938
    [292]      -31.058393     -30.497019     -31.059999     -32.654392
    [296]      -33.755959     -32.857052     -31.927816     -32.662800
    [300]      -36.069191     -40.201439     -34.089691     -29.743435
    [304]      -27.694412     -27.164717     -27.820412     -29.512808
    [308]      -32.136280     -35.282085     -37.291058     -36.938290
    [312]      -36.299782     -36.991066     -40.169109     -50.320827
    [316]      -44.553749     -37.783707     -35.522633     -35.806782
    [320]      -38.633629     -44.706699     -43.801514     -38.821316
    [324]      -36.422535     -35.090427     -33.897404     -32.666183
    [328]      -31.698845     -31.354538     -31.952517     -33.788528
    [332]      -36.872272     -39.509739     -39.850193     -39.867123
    [336]      -37.267910     -32.999996     -30.325579     -29.686192
    [340]      -31.286963     -36.268761     -57.847061     -38.759605
    [344]      -33.544991     -30.760771     -28.919239     -28.335215
    [348]      -29.776781     -35.260273     -43.400089     -30.882984
    [352]      -26.694510     -25.195534     -25.377357     -27.006430
    [356]      -30.220102     -33.889137     -31.279938     -27.308153
    [360]      -25.124784     -24.520580     -25.349707     -27.641127
    [364]      -31.517796     -36.989388     -44.448399     -50.632519
    [368]      -38.596138     -33.617809     -31.684216     -32.041645
    [372]      -34.910206     -42.460453     -51.004726     -39.664223
    [376]      -36.778152     -35.697090     -34.851002     -33.928066
    [380]      -33.372601     -33.723209     -35.529022     -39.497353
    [384]      -44.245609     -42.291767     -40.690510     -38.284809
    [388]      -33.347042     -29.517075     -27.444681     -26.935553
    [392]      -27.883089     -30.374973     -34.881138     -42.295567
    [396]      -41.462601     -36.895916     -35.119606     -34.990055
    [400]      -35.562073     -35.824646     -35.845356     -36.778069
    [404]      -39.911140     -45.938457     -39.925102     -34.084358
    [408]      -30.879107     -29.319984     -29.101103     -30.187866
    [412]      -32.727924     -36.999409     -41.480972     -40.276424
    [416]      -38.854282     -40.554226     -47.477413     -40.777645
    [420]      -34.290161     -31.381390     -30.695559     -32.063000
    [424]      -36.199039     -46.206985     -40.834198     -35.899334
    [428]      -34.606892     -35.208542     -36.949055     -39.009678
    [432]      -40.338875     -40.685184     -40.992992     -41.698112
    [436]      -41.383320     -39.426338     -37.902836     -37.756500
    [440]      -38.684608     -39.386124     -39.040966     -38.500355
    [444]      -37.786995     -36.497700     -35.394157     -35.167255
    [448]      -35.401436     -34.761753     -33.323154     -32.492054
    [452]      -33.042168     -35.510384     -41.425415     -59.295254
    [456]      -42.345776     -39.088589     -39.760105     -44.556873
    [460]      -63.132015     -46.781776     -44.733891     -48.006783
    [464]      -43.663532     -37.463257     -34.365318     -33.226513
    [468]      -33.491756     -34.905579     -37.431946     -41.197048
    [472]      -45.710167     -48.701954     -51.305500     -46.493351
    [476]      -39.673992     -35.753857     -33.871288     -33.539967
    [480]      -34.523464     -36.699589     -39.832298     -42.205662
    [484]      -41.216381     -39.640469     -39.179153     -38.590584
    [488]      -36.181030     -33.598621     -32.349491     -32.902187
    [492]      -35.909161     -44.229111     -46.265598     -38.649807
    [496]      -37.493244     -40.262062     -46.001900     -40.192680
    [500]      -36.164524     -35.239006     -36.664303     -39.740696
    [504]      -39.968430     -37.235371     -36.049923     -37.040062
    [508]      -40.561470     -44.296734     -39.933548     -36.583660
    [512]      -35.568352
  [Tag]        12961
  [frame_len]          320
aArDvArK

echo "Making test FEA_SPEC file tstB.spec."

esig2fea - tstB.spec <<aArDvArK
Esignal
   0.0B
  ASCII
     48
   1950
     -1
Tag: LONG <r>
tot_power: FLOAT <r>
re_spec_val: FLOAT 513 <r>
frame_len: LONG <r>
window_type: SHORT 1 <g> [0]       4
window_type.enumStrings: CHAR 10 11 <g> 
  [0][0]  "WT_NONE\0\0\0\0"
  [1][0]  "WT_RECT\0\0\0\0"
  [2][0]  "WT_HAMMING\0"
  [3][0]  "WT_TRIANG\0\0"
  [4][0]  "WT_HANNING\0"
  [5][0]  "WT_COS4\0\0\0\0"
  [6][0]  "WT_KAISER\0\0"
  [7][0]  "WT_ARB\0\0\0\0\0"
  [8][0]  "WT_SINC\0\0\0\0"
  [9][0]  "WT_SINC_C4\0"
sf: FLOAT 1 <g> [0]       8000.0000
nan: LONG 1 <g> [0]   2147483647
step: LONG 1 <g> [0]          160
frame_meth: SHORT 1 <g> [0]       2
frame_meth.enumStrings: CHAR 3 9 <g> 
  [0][0]  "NONE\0\0\0\0\0"
  [1][0]  "FIXED\0\0\0\0"
  [2][0]  "VARIABLE\0"
contin: SHORT 1 <g> [0]       1
contin.enumStrings: CHAR 2 4 <g> 
  [0][0]  "NO\0\0"
  [1][0]  "YES\0"
fft_length: LONG 1 <g> [0]         1024
start: LONG 1 <g> [0]            1
record_freq: DOUBLE 1 <g> [0]        50.00000000000000
input_data: CHAR 5 <g> 
  [0]  "real\0"
spec_type: SHORT 1 <g> [0]       2
spec_type.enumStrings: CHAR 5 5 <g> 
  [0][0]  "NONE\0"
  [1][0]  "PWR\0\0"
  [2][0]  "DB\0\0\0"
  [3][0]  "REAL\0"
  [4][0]  "CPLX\0"
freq_format: SHORT 1 <g> [0]       2
freq_format.enumStrings: CHAR 7 10 <g> 
  [0][0]  "NONE\0\0\0\0\0\0"
  [1][0]  "SYM_CTR\0\0\0"
  [2][0]  "SYM_EDGE\0\0"
  [3][0]  "ASYM_CTR\0\0"
  [4][0]  "ASYM_EDGE\0"
  [5][0]  "ARB_VAR\0\0\0"
  [6][0]  "ARB_FIXED\0"
num_freqs: LONG 1 <g> [0]          513
start_time: DOUBLE 1 <g> [0]      0.02000000000000000
FeaSubtype: SHORT <g>      7
FeaSubtype.enumStrings: CHAR 10 10 <g> 
  [0][0]  "NONE\0\0\0\0\0\0"
  [1][0]  "FEA_VQ\0\0\0\0"
  [2][0]  "FEA_ANA\0\0\0"
  [3][0]  "FEA_STAT\0\0"
  [4][0]  "FEA_QHIST\0"
  [5][0]  "FEA_DST\0\0\0"
  [6][0]  "FEA_2KB\0\0\0"
  [7][0]  "FEA_SPEC\0\0"
  [8][0]  "FEA_SD\0\0\0\0"
  [9][0]  "FEA_FILT\0\0"
recordFreq: DOUBLE <g>       50.00000000000000
startTime: DOUBLE 1 <g> [0]      0.02000000000000000
[Record 0]
  [tot_power]       372.38959
  [re_spec_val]
    [0]       12.448946      11.896708      10.195791      7.1918936
    [4]       2.5243161     -4.7549024     -19.221857     -21.285086
    [8]      -19.846155     -24.520039     -24.447643     -21.186468
    [12]      -17.947308     -15.711055     -15.246424     -16.207806
    [16]      -15.670918     -12.101450     -8.8533859     -6.8328633
    [20]      -5.9136448     -5.8838162     -6.4565535     -7.2183537
    [24]      -7.8830247     -8.7408180     -10.601583     -14.848345
    [28]      -24.306480     -16.099197     -10.710791     -8.3132324
    [32]      -7.4466281     -7.5133038     -8.1027498     -8.9075966
    [36]      -9.8498249     -11.136916     -13.141644     -16.362804
    [40]      -21.735701     -30.252968     -26.105595     -22.116138
    [44]      -20.713608     -20.727396     -21.704582     -23.419147
    [48]      -25.780033     -28.941584     -31.938295     -29.087744
    [52]      -24.652529     -21.759295     -20.216354     -19.731457
    [56]      -20.061497     -20.895901     -21.774496     -22.332972
    [60]      -22.795015     -23.858751     -26.363302     -31.158827
    [64]      -31.349232     -25.979645     -23.099957     -22.248644
    [68]      -23.098152     -25.456524     -27.600271     -26.387623
    [72]      -24.792419     -25.062946     -28.107767     -36.715912
    [76]      -31.392771     -25.190214     -22.519690     -21.555553
    [80]      -21.653046     -22.535221     -24.227119     -27.196463
    [84]      -33.011433     -44.898205     -32.791122     -28.433809
    [88]      -26.899351     -27.032066     -28.578953     -31.742741
    [92]      -37.484730     -43.995228     -37.551968     -33.771931
    [96]      -31.999723     -31.276184     -31.290663     -32.195122
    [100]      -34.693489     -40.772728     -41.659336     -33.667850
    [104]      -29.902195     -28.285284     -28.163475     -29.333948
    [108]      -31.782106     -35.586178     -40.590286     -44.055779
    [112]      -42.067814     -38.837646     -36.401733     -35.098984
    [116]      -35.061974     -36.461060     -39.101860     -38.943802
    [120]      -34.744873     -31.366632     -29.358452     -28.527714
    [124]      -28.823513     -30.396595     -33.710644     -39.119308
    [128]      -38.022049     -33.146652     -30.393572     -29.110132
    [132]      -28.965382     -29.993654     -32.465954     -35.863167
    [136]      -34.774525     -31.173208     -29.116997     -28.614576
    [140]      -29.336416     -30.649920     -31.142090     -30.207924
    [144]      -29.137760     -28.790644     -29.315594     -30.551132
    [148]      -31.999456     -32.957584     -33.334930     -33.370739
    [152]      -32.440685     -30.348942     -28.297455     -27.140293
    [156]      -27.195927     -28.756243     -32.589417     -41.644493
    [160]      -38.038898     -31.452576     -28.400461     -26.782694
    [164]      -25.919611     -25.572018     -25.730871     -26.500299
    [168]      -27.991425     -30.124670     -32.023746     -32.028889
    [172]      -30.619564     -29.240299     -28.345224     -28.127428
    [176]      -28.964766     -31.695341     -39.497780     -40.967125
    [180]      -31.194016     -27.686983     -26.703964     -27.796381
    [184]      -31.652544     -40.160133     -32.959812     -27.632113
    [188]      -25.268341     -24.516499     -24.863758     -25.947205
    [192]      -27.246880     -27.993896     -27.738794     -26.847002
    [196]      -25.900749     -25.268240     -25.140738     -25.605064
    [200]      -26.670225     -28.254940     -30.132805     -31.887819
    [204]      -33.069939     -33.502739     -33.221664     -32.280506
    [208]      -30.856874     -29.278566     -27.885691     -26.956514
    [212]      -26.713724     -27.357826     -29.098572     -32.069176
    [216]      -35.281857     -35.249561     -33.351265     -31.815117
    [220]      -30.376406     -28.987556     -28.210058     -28.631529
    [224]      -30.906418     -36.548775     -40.405357     -32.732014
    [228]      -29.238960     -27.793747     -27.144993     -26.336983
    [232]      -25.138136     -24.076565     -23.647352     -24.120016
    [236]      -25.760242     -29.189211     -36.776230     -38.676464
    [240]      -29.892889     -26.011667     -24.022417     -23.199169
    [244]      -23.334545     -24.450096     -26.776920     -30.859146
    [248]      -36.157249     -33.414509     -29.350800     -27.143316
    [252]      -26.059372     -25.657896     -25.807230     -26.676743
    [256]      -28.741877     -32.817234     -35.945175     -30.625576
    [260]      -26.738089     -24.751318     -23.932241     -23.695248
    [264]      -23.502615     -23.151930     -22.923925     -23.218334
    [268]      -24.276196     -26.035398     -27.513592     -26.864378
    [272]      -24.850203     -23.132017     -22.126081     -21.776968
    [276]      -21.881203     -22.079250     -21.946112     -21.381912
    [280]      -20.740898     -20.440878     -20.725969     -21.644911
    [284]      -22.910915     -23.633690     -23.106438     -22.011175
    [288]      -21.117249     -20.529976     -20.063654     -19.617414
    [292]      -19.293762     -19.232073     -19.431198     -19.739090
    [296]      -20.014935     -20.303308     -20.745008     -21.297173
    [300]      -21.580416     -21.201361     -20.295202     -19.273184
    [304]      -18.371435     -17.679287     -17.275085     -17.249907
    [308]      -17.649040     -18.364429     -18.986950     -18.927341
    [312]      -18.150457     -17.269224     -16.808594     -17.017111
    [316]      -17.998665     -19.712627     -21.561417     -21.865892
    [320]      -20.335505     -18.649073     -17.554266     -17.095989
    [324]      -17.113407     -17.307047     -17.306580     -16.966303
    [328]      -16.522194     -16.295092     -16.425306     -16.838911
    [332]      -17.318279     -17.677813     -17.935867     -18.212122
    [336]      -18.451614     -18.341389     -17.667448     -16.686684
    [340]      -15.843664     -15.424884     -15.539400     -16.150877
    [344]      -17.000141     -17.526737     -17.320402     -16.757065
    [348]      -16.498390     -16.929098     -18.129639     -19.637209
    [352]      -19.962851     -18.602835     -17.136944     -16.482332
    [356]      -16.843788     -18.222401     -20.248629     -21.315149
    [360]      -20.186438     -18.610775     -17.732603     -17.669123
    [364]      -18.298931     -19.440842     -20.778212     -21.646406
    [368]      -21.314659     -20.078363     -18.817440     -17.988358
    [372]      -17.647358     -17.642630     -17.722300     -17.690321
    [376]      -17.557154     -17.484440     -17.615475     -17.994770
    [380]      -18.552914     -19.074497     -19.237045     -18.927244
    [384]      -18.477037     -18.354185     -18.838860     -19.898283
    [388]      -20.940643     -20.958097     -20.066414     -19.281456
    [392]      -19.072149     -19.352600     -19.728451     -19.796541
    [396]      -19.552418     -19.282000     -19.150711     -19.130350
    [400]      -19.162075     -19.277935     -19.551359     -19.972643
    [404]      -20.410124     -20.717863     -20.872669     -20.924318
    [408]      -20.851019     -20.603346     -20.287043     -20.162199
    [412]      -20.461531     -21.249550     -22.308334     -23.083385
    [416]      -23.155127     -22.806751     -22.456219     -22.121008
    [420]      -21.644358     -21.112930     -20.870413     -21.250227
    [424]      -22.456516     -24.482895     -26.624737     -27.140303
    [428]      -26.184664     -25.481478     -25.652344     -26.729227
    [432]      -28.556496     -30.537704     -31.190273     -30.105574
    [436]      -28.870375     -28.438223     -28.938677     -29.596111
    [440]      -28.483419     -25.909243     -23.712608     -22.471968
    [444]      -22.213234     -22.880320     -24.403059     -26.656626
    [448]      -29.373987     -32.002857     -33.335247     -32.188007
    [452]      -29.814236     -27.697647     -26.225067     -25.412815
    [456]      -25.269695     -25.887724     -27.424995     -29.834637
    [460]      -31.447208     -29.896521     -27.772730     -26.801708
    [464]      -27.196688     -29.049522     -32.524906     -36.494778
    [468]      -35.673744     -33.098728     -31.563745     -30.640978
    [472]      -29.862457     -29.150366     -28.621956     -28.316669
    [476]      -28.141026     -27.973787     -27.811068     -27.808208
    [480]      -28.187132     -29.120234     -30.587742     -32.037704
    [484]      -32.367512     -31.628805     -30.962969     -30.857841
    [488]      -31.114471     -31.294807     -31.354319     -31.804810
    [492]      -33.158035     -35.263702     -35.957195     -34.184021
    [496]      -32.668465     -32.465927     -33.536995     -35.096180
    [500]      -35.071568     -33.342426     -31.821320     -31.127951
    [504]      -31.206635     -31.862112     -32.824314     -33.761841
    [508]      -34.456001     -35.004036     -35.643070     -36.351856
    [512]      -36.698677
  [Tag]            1
  [frame_len]          320
[Record 1]
  [tot_power]       352.17380
  [re_spec_val]
    [0]       12.521987      11.980060      10.313191      7.3791699
    [4]       2.8527281     -4.0786886     -16.691425     -23.991886
    [8]      -21.313555     -28.926567     -44.746468     -43.160439
    [12]      -33.621475     -26.381672     -23.436615     -18.480534
    [16]      -13.295465     -9.7455931     -7.7936373     -7.3445578
    [20]      -8.5967474     -12.488629     -25.468899     -17.156767
    [24]      -10.841878     -8.9956493     -9.6531115     -12.934395
    [28]      -20.528002     -19.208672     -13.613140     -11.608281
    [32]      -11.433353     -12.324441     -13.716242     -15.071414
    [36]      -16.108444     -17.112877     -18.832880     -22.451008
    [40]      -31.820086     -30.183470     -22.620100     -20.122213
    [44]      -19.922235     -21.501514     -25.007458     -31.777834
    [48]      -46.300262     -31.577784     -26.482416     -23.596466
    [52]      -21.937529     -21.301071     -21.655342     -23.058350
    [56]      -25.636078     -29.134956     -30.327801     -27.680962
    [60]      -25.307961     -24.104267     -24.031628     -25.142824
    [64]      -27.695799     -32.016651     -34.236950     -30.121613
    [68]      -26.908276     -25.117172     -24.317106     -24.304293
    [72]      -25.015137     -26.401350     -28.156868     -29.245115
    [76]      -28.772381     -27.664421     -26.904596     -26.678679
    [80]      -26.847162     -27.286289     -28.096842     -29.662777
    [84]      -32.734928     -39.501694     -48.045494     -36.045826
    [88]      -32.198586     -30.757694     -30.456791     -30.365343
    [92]      -29.790564     -28.878317     -28.153761     -27.854771
    [96]      -27.946665     -28.295671     -28.799376     -29.470362
    [100]      -30.448709     -31.939297     -34.057411     -36.365685
    [104]      -37.354145     -36.725288     -36.012569     -35.786480
    [108]      -35.937553     -36.499893     -37.917694     -41.066410
    [112]      -47.243252     -44.137276     -37.811806     -34.310230
    [116]      -32.520420     -32.081860     -32.937244     -35.161510
    [120]      -38.831264     -43.444603     -46.021061     -43.542927
    [124]      -39.334988     -36.092278     -34.236385     -33.652901
    [128]      -34.178551     -35.614723     -37.558758     -39.261192
    [132]      -40.358738     -41.356365     -41.064152     -37.579475
    [136]      -33.792557     -31.155287     -29.652441     -29.089722
    [140]      -29.292053     -30.112967     -31.348755     -32.419456
    [144]      -32.321529     -31.117840     -29.921906     -29.346989
    [148]      -29.514177     -30.401348     -32.022453     -34.583267
    [152]      -38.771687     -45.939590     -43.370453     -37.754581
    [156]      -35.011559     -33.935345     -34.045086     -35.088528
    [160]      -36.843037     -39.014698     -41.118282     -42.522903
    [164]      -43.239277     -43.963371     -44.615955     -44.414650
    [168]      -44.206726     -45.514675     -46.530529     -41.890209
    [172]      -37.318047     -34.226063     -32.007767     -30.285353
    [176]      -29.033592     -28.404060     -28.544456     -29.561100
    [180]      -31.594530     -35.057602     -41.642162     -52.723507
    [184]      -39.868984     -35.742008     -34.290211     -34.266598
    [188]      -34.707684     -34.660175     -34.283428     -34.448074
    [192]      -35.620720     -37.870785     -41.061230     -43.621403
    [196]      -40.456604     -35.789776     -32.567108     -30.741108
    [200]      -30.102629     -30.503868     -31.814447     -33.837109
    [204]      -36.186638     -38.265488     -39.628948     -40.405869
    [208]      -41.091156     -42.087368     -43.429493     -44.999432
    [212]      -47.569973     -53.757057     -48.952744     -41.315582
    [216]      -37.100948     -34.668560     -33.424778     -33.123955
    [220]      -33.699718     -35.199696     -37.569099     -39.500660
    [224]      -38.433197     -36.279636     -35.096409     -35.275822
    [228]      -37.063187     -40.944386     -44.587002     -40.992970
    [232]      -38.487560     -38.868347     -43.270802     -54.289394
    [236]      -40.600185     -36.191391     -34.987103     -35.981457
    [240]      -39.086864     -44.336853     -48.537956     -47.384388
    [244]      -44.810749     -42.030071     -40.357876     -40.180668
    [248]      -41.335968     -43.566837     -47.078789     -53.034740
    [252]      -50.800030     -44.258957     -40.237244     -37.543652
    [256]      -35.869316     -35.334278     -36.259548     -39.366779
    [260]      -46.596203     -43.834141     -37.282185     -34.010437
    [264]      -32.355152     -31.773827     -32.113121     -33.401653
    [268]      -35.756382     -39.224968     -43.432438     -48.637657
    [272]      -56.608688     -43.365562     -37.285408     -34.276505
    [276]      -33.260063     -33.900188     -35.872349     -37.809563
    [280]      -37.863491     -37.749676     -39.480839     -43.933384
    [284]      -45.317291     -41.002365     -39.448612     -40.979496
    [288]      -48.049370     -49.926407     -39.048645     -34.502739
    [292]      -31.871580     -30.237383     -29.265806     -28.844162
    [296]      -28.972404     -29.695902     -31.010555     -32.616077
    [300]      -33.509094     -32.792480     -31.211056     -29.699583
    [304]      -28.614859     -28.126961     -28.388470     -29.537592
    [308]      -31.654593     -34.598724     -37.522057     -38.578667
    [312]      -36.944920     -34.267704     -32.169899     -31.225517
    [316]      -31.535910     -32.970066     -34.868111     -35.850559
    [320]      -35.552372     -34.492886     -32.644680     -30.615192
    [324]      -29.227165     -28.843760     -29.586418     -31.573698
    [328]      -35.102207     -41.156956     -57.332642     -47.554878
    [332]      -41.588196     -38.452271     -36.156776     -34.475739
    [336]      -33.518909     -33.376404     -33.932800     -34.471336
    [340]      -33.776909     -32.122349     -30.776529     -30.346434
    [344]      -31.051123     -33.131882     -37.135338     -44.159351
    [348]      -46.023258     -42.082985     -41.145233     -40.492802
    [352]      -37.666645     -34.554699     -32.446030     -31.354979
    [356]      -31.132431     -31.747715     -33.383919     -36.514729
    [360]      -41.550114     -42.602898     -39.157219     -38.048172
    [364]      -39.448803     -43.690365     -53.209629     -57.849155
    [368]      -45.915337     -39.052780     -34.478714     -31.606625
    [372]      -30.013088     -29.389360     -29.482111     -30.056561
    [376]      -30.886181     -31.748825     -32.433250     -32.847637
    [380]      -33.187809     -33.879742     -35.347015     -37.696785
    [384]      -39.439404     -38.134850     -36.175243     -35.428551
    [388]      -36.283634     -39.341408     -46.935333     -44.979736
    [392]      -37.743073     -34.343231     -32.692490     -32.074448
    [396]      -32.064369     -32.269184     -32.320103     -32.045273
    [400]      -31.585224     -31.241901     -31.282444     -31.889969
    [404]      -33.206841     -35.377895     -38.302135     -39.811680
    [408]      -37.542549     -34.916241     -33.398872     -32.969334
    [412]      -33.409897     -34.359104     -35.251984     -35.615097
    [416]      -35.461842     -34.982712     -34.220280     -33.238644
    [420]      -32.247299     -31.474302     -31.027573     -30.855146
    [424]      -30.806240     -30.803801     -30.969995     -31.511152
    [428]      -32.486481     -33.604546     -34.229568     -34.056171
    [432]      -33.510902     -33.075962     -32.999908     -33.421398
    [436]      -34.314400     -35.094090     -34.618233     -33.048946
    [440]      -31.604485     -30.857306     -30.890322     -31.633904
    [444]      -32.949406     -34.627460     -36.412186     -38.098488
    [448]      -39.582901     -40.738071     -41.345112     -41.343998
    [452]      -41.000469     -40.603672     -40.189705     -39.639771
    [456]      -38.948795     -38.206734     -37.383755     -36.439041
    [460]      -35.589081     -35.205532     -35.567730     -36.790821
    [464]      -38.788818     -41.103882     -42.892246     -43.885124
    [468]      -44.767578     -46.147560     -48.340881     -51.619923
    [472]      -56.323921     -61.929287     -59.793461     -54.519100
    [476]      -51.000195     -48.870106     -47.688408     -47.212048
    [480]      -47.598206     -49.417683     -51.834915     -47.721596
    [484]      -42.455292     -38.993462     -36.886536     -35.764774
    [488]      -35.390045     -35.582230     -36.163685     -36.899845
    [492]      -37.489719     -37.740246     -37.775524     -37.889755
    [496]      -38.250969     -38.801109     -39.351192     -39.811111
    [500]      -40.313019     -41.037827     -41.985004     -42.870350
    [504]      -43.215218     -42.728352     -41.596775     -40.246899
    [508]      -39.014824     -38.061859     -37.422012     -37.066200
    [512]      -36.953461
  [Tag]          161
  [frame_len]          320
[Record 2]
  [tot_power]       368.67538
  [re_spec_val]
    [0]       12.454575      11.902078      10.199003      7.1852303
    [4]       2.4809368     -4.9446197     -20.683418     -19.690880
    [8]      -18.938620     -25.898746     -42.031525     -34.813709
    [12]      -25.016418     -19.833830     -18.393219     -20.460676
    [16]      -29.672338     -21.459175     -13.867779     -9.6930695
    [20]      -6.9941993     -5.2252240     -4.2184443     -3.9649637
    [24]      -4.5547042     -6.1930342     -9.2819881     -14.053113
    [28]      -14.548981     -10.423450     -8.0337553     -7.2827697
    [32]      -7.8363924     -9.5915489     -12.655037     -17.479237
    [36]      -23.911612     -21.966932     -18.419424     -17.527346
    [40]      -19.248604     -25.065908     -30.417192     -22.252117
    [44]      -20.281813     -22.293104     -27.862085     -23.491350
    [48]      -19.222939     -18.188303     -19.153931     -19.935732
    [52]      -18.501245     -17.195274     -17.616436     -20.210842
    [56]      -24.121714     -23.126268     -20.720898     -20.000513
    [60]      -19.208738     -17.140411     -15.338086     -14.810455
    [64]      -15.663109     -17.529806     -19.209280     -19.538067
    [68]      -19.234886     -18.880541     -18.437195     -18.234653
    [72]      -18.632240     -19.249504     -19.044922     -18.183725
    [76]      -17.857845     -18.597462     -20.060644     -20.958292
    [80]      -20.858767     -21.151793     -22.419979     -23.109253
    [84]      -21.697702     -20.366470     -20.438757     -21.822485
    [88]      -23.144300     -22.849274     -22.499830     -23.469280
    [92]      -24.609158     -22.957829     -20.596674     -19.493305
    [96]      -19.624952     -20.499981     -21.588011     -22.701765
    [100]      -23.600220     -23.443277     -22.512558     -22.094410
    [104]      -22.578388     -23.165974     -22.589270     -21.284986
    [108]      -20.311949     -20.000538     -20.450827     -21.876333
    [112]      -24.454741     -26.787500     -25.515741     -23.534449
    [116]      -23.133789     -24.617657     -27.915701     -29.389818
    [120]      -26.134796     -23.712263     -22.946615     -23.640083
    [124]      -25.692274     -28.370773     -28.465761     -26.155754
    [128]      -24.374058     -23.419537     -22.916803     -22.717947
    [132]      -23.037664     -24.046886     -25.118704     -24.748611
    [136]      -23.376038     -22.530857     -22.646025     -23.574265
    [140]      -25.094625     -26.990843     -27.826387     -25.929047
    [144]      -23.764795     -22.861582     -22.982008     -22.826019
    [148]      -21.591360     -20.458614     -20.336027     -21.188278
    [152]      -22.214348     -22.484339     -22.292450     -22.045433
    [156]      -21.343246     -20.236120     -19.460438     -19.455551
    [160]      -20.231804     -21.553949     -22.975611     -23.731003
    [164]      -23.265726     -22.292574     -21.841820     -22.330704
    [168]      -23.368849     -23.287813     -21.592089     -20.150831
    [172]      -19.962324     -21.294300     -23.973679     -25.641539
    [176]      -24.176954     -22.970808     -23.299995     -24.976770
    [180]      -27.181919     -28.434515     -28.173910     -27.003550
    [184]      -25.681332     -24.973331     -25.319267     -26.808222
    [188]      -28.884926     -29.591612     -28.415049     -27.438139
    [192]      -27.737577     -30.058992     -37.219578     -40.353455
    [196]      -29.364220     -25.329981     -23.756962     -23.954412
    [200]      -25.990219     -30.838587     -46.086292     -34.786472
    [204]      -29.035507     -26.477598     -25.080271     -24.370016
    [208]      -24.348557     -25.100264     -26.489264     -27.758036
    [212]      -27.907036     -27.379267     -26.966112     -26.300558
    [216]      -24.865477     -23.370710     -22.731459     -23.348501
    [220]      -25.054369     -26.007000     -24.419449     -22.654505
    [224]      -22.007622     -22.365646     -23.096752     -23.445875
    [228]      -23.501476     -24.004387     -25.100523     -25.323313
    [232]      -23.541170     -21.709246     -21.108456     -22.086605
    [236]      -24.860352     -28.470446     -27.684978     -25.366962
    [240]      -24.887472     -26.354568     -29.271772     -29.889259
    [244]      -26.893330     -24.547066     -23.472561     -23.456631
    [248]      -24.370583     -26.248581     -29.353031     -33.832542
    [252]      -34.761131     -30.857380     -28.469257     -28.067795
    [256]      -29.961342     -36.383003     -41.843426     -30.409315
    [260]      -26.450260     -24.809856     -24.250370     -24.109333
    [264]      -24.345913     -25.533556     -28.234018     -29.816374
    [268]      -26.193817     -23.189842     -22.112507     -22.760647
    [272]      -24.681242     -25.675343     -24.125246     -22.984760
    [276]      -23.948307     -28.446653     -32.625626     -24.109142
    [280]      -20.020624     -18.445816     -18.640015     -20.518499
    [284]      -24.287287     -27.733957     -24.979479     -22.410776
    [288]      -21.752968     -22.432234     -23.203196     -22.738346
    [292]      -21.829393     -21.511707     -21.575712     -21.267876
    [296]      -20.699877     -20.802650     -22.322834     -25.610167
    [300]      -27.764475     -24.835726     -22.681419     -22.571934
    [304]      -24.269312     -26.416746     -25.598986     -23.684645
    [308]      -23.214647     -24.644104     -28.291071     -32.203880
    [312]      -28.968235     -25.835463     -24.640030     -24.946323
    [316]      -26.426188     -27.842167     -26.577364     -24.076519
    [320]      -22.604891     -22.740629     -24.883276     -29.039146
    [324]      -27.873735     -23.553640     -21.495916     -21.318268
    [328]      -22.564285     -24.640171     -26.404522     -26.770411
    [332]      -25.840364     -24.454599     -23.320000     -22.500940
    [336]      -21.727726     -21.144337     -21.351358     -22.865812
    [340]      -25.297533     -25.201563     -22.695934     -21.139486
    [344]      -20.855190     -21.317249     -21.953978     -22.759165
    [348]      -24.364344     -27.293310     -29.286018     -26.400356
    [352]      -23.481133     -21.938456     -21.413609     -21.534552
    [356]      -22.036818     -22.705336     -23.158733     -22.898586
    [360]      -22.080580     -21.498354     -21.766720     -23.075047
    [364]      -24.619349     -24.118464     -22.303671     -21.380745
    [368]      -21.874002     -23.341122     -23.872196     -22.575500
    [372]      -21.515543     -21.649912     -22.864252     -24.397083
    [376]      -24.950150     -24.069000     -22.542246     -21.269722
    [380]      -20.888237     -21.802734     -24.188084     -26.680996
    [384]      -25.472565     -23.225428     -22.233465     -22.378260
    [388]      -23.237827     -24.614735     -26.866940     -30.400492
    [392]      -30.726261     -26.457533     -23.621771     -22.519026
    [396]      -22.886688     -24.747091     -28.558773     -34.612984
    [400]      -32.777119     -28.623722     -27.057533     -27.087032
    [404]      -27.312420     -26.342520     -25.021070     -24.678890
    [408]      -25.898243     -29.215477     -35.235210     -35.183537
    [412]      -31.061661     -29.711267     -30.539154     -33.624966
    [416]      -40.273663     -40.572285     -34.021450     -30.786530
    [420]      -29.307796     -29.087511     -30.076075     -32.094189
    [424]      -32.709362     -29.834421     -27.127548     -25.913528
    [428]      -26.248175     -28.101173     -30.858906     -31.272505
    [432]      -28.770159     -26.580853     -25.457937     -25.577024
    [436]      -27.301390     -31.499836     -40.447411     -37.740719
    [440]      -33.002625     -30.918785     -29.147764     -27.670435
    [444]      -27.169744     -27.871096     -29.462542     -30.912502
    [448]      -31.206749     -30.744099     -30.223837     -30.101805
    [452]      -30.851702     -32.779198     -35.062099     -34.647434
    [456]      -32.660656     -31.724867     -32.354675     -34.751526
    [460]      -38.010887     -35.914803     -31.986557     -29.737890
    [464]      -28.991339     -29.527103     -31.327101     -34.653332
    [468]      -40.204613     -43.029842     -37.635906     -34.342651
    [472]      -32.903008     -32.818493     -33.825565     -35.520786
    [476]      -36.942802     -37.112274     -36.560143     -36.323055
    [480]      -36.964981     -38.839088     -42.308849     -47.837875
    [484]      -54.608616     -51.247715     -46.169029     -43.737141
    [488]      -43.973412     -47.403988     -50.669537     -45.651127
    [492]      -43.250481     -43.870396     -46.517559     -45.357288
    [496]      -40.896240     -37.885044     -36.439327     -36.457142
    [500]      -38.094429     -41.743752     -45.656811     -42.411949
    [504]      -39.157734     -38.149715     -39.548954     -45.020187
    [508]      -49.965321     -40.140881     -36.252983     -34.654663
    [512]      -34.231556
  [Tag]          321
  [frame_len]          320
[Record 3]
  [tot_power]       4898.8628
  [re_spec_val]
    [0]       12.217651      11.751925      10.320395      7.7968292
    [4]       3.8639169     -2.3211999     -12.121815     -9.8199587
    [8]      -7.3623824     -7.6541195     -7.7084045     -5.7832694
    [12]      -3.0974531    -0.41357604      1.8384182      3.3192389
    [16]       4.0407505      4.4292750      5.0779462      6.0634174
    [20]       6.9944911      7.7018328      8.3017683      8.8312492
    [24]       9.0868711      8.8393431      8.0681839      7.0764432
    [28]       6.3652396      6.0707436      5.8196468      5.3444405
    [32]       4.9061842      5.2914171      6.7738242      8.5327005
    [36]       9.8359871      10.418800      10.249521      9.4623213
    [40]       8.5730190      8.6307344      9.9532928      11.555109
    [44]       12.713799      13.257671      13.266537      12.971710
    [48]       12.696292      12.620818      12.553716      12.074506
    [52]       10.750264      8.0948591      3.5812795      1.5912951
    [56]       6.2338252      9.5235186      11.241140      11.844697
    [60]       11.523621      10.269242      7.8384428      3.4443362
    [64]      -5.7461467     -2.6918135      3.5830634      6.1747813
    [68]       6.9248710      6.2633295      4.1176496    -0.19989313
    [72]      -10.263024     -10.236796     -2.9030218    -0.92212510
    [76]      -1.3075497     -3.7288327     -9.0138817     -17.760422
    [80]      -10.442706     -6.3510695     -4.8149204     -4.7291641
    [84]      -5.8091764     -8.2062645     -12.782998     -24.784096
    [88]      -19.766037     -12.766601     -10.052425     -8.7791243
    [92]      -7.8401875     -6.6096458     -5.1284094     -3.7469215
    [96]      -2.6535320     -1.8509269     -1.2937016    -0.99150187
    [100]      -1.0311012     -1.5272229     -2.5220146     -3.7550111
    [104]      -4.3272595     -3.5084009     -2.0874476     -1.0024126
    [108]     -0.56679028    -0.80960780     -1.6900012     -3.1769481
    [112]      -5.3179879     -8.3382483     -12.686604     -17.259811
    [116]      -15.624773     -13.244215     -13.285156     -16.418566
    [120]      -21.167812     -13.958729     -9.1403885     -6.8912840
    [124]      -6.4188528     -7.5807514     -10.665401     -15.889450
    [128]      -15.910187     -11.845927     -9.8042440     -9.0703459
    [132]      -8.8201027     -8.6821346     -8.9410524     -10.088901
    [136]      -11.895201     -11.603754     -8.7398252     -6.4519157
    [140]      -5.5463214     -6.0973964     -8.3023376     -12.429223
    [144]      -14.799547     -11.406302     -9.2831087     -9.2156420
    [148]      -10.694325     -11.637301     -9.5169106     -6.9786906
    [152]      -5.4780769     -4.8210030     -4.4115901     -3.6885495
    [156]      -2.6881027     -1.8743246     -1.5550445     -1.7203063
    [160]      -2.0426321     -2.0141020     -1.4888800    -0.88521308
    [164]     -0.65398580     -1.0043514     -1.9391247     -3.2331405
    [168]      -4.3471537     -4.7432737     -4.5618386     -4.2981057
    [172]      -4.1594992     -4.1107016     -4.1623778     -4.5114684
    [176]      -5.4724765     -7.3858652     -10.430311     -12.806321
    [180]      -10.818459     -8.1712017     -6.8415947     -6.8570189
    [184]      -8.2219954     -11.155010     -15.764771     -17.540527
    [188]      -14.473640     -12.794631     -13.005515     -15.032114
    [192]      -18.440113     -18.044891     -14.070791     -11.359187
    [196]      -10.084050     -10.051446     -11.286152     -14.006580
    [200]      -17.574633     -16.393940     -12.756274     -10.626698
    [204]      -10.079373     -11.146039     -14.491055     -23.826735
    [208]      -21.128365     -13.197717     -9.9571190     -8.7081699
    [212]      -8.8741035     -10.387349     -13.289711     -15.347993
    [216]      -12.103292     -8.4331884     -6.1218119     -5.0398116
    [220]      -5.1111522     -6.3688188     -8.4268923     -8.4340467
    [224]      -5.3090529     -2.4475944    -0.73457336    -0.12874223
    [228]     -0.60032535     -2.2483549     -5.2671251     -8.7524986
    [232]      -7.5835562     -4.2796168     -2.1693969     -1.2253008
    [236]      -1.2196138     -2.0521600     -3.7297885     -6.2456899
    [240]      -8.7681084     -8.4621620     -6.0090933     -4.0040264
    [244]      -2.9488542     -2.8025506     -3.5121107     -5.0655737
    [248]      -7.4753423     -10.681934     -14.015252     -15.157084
    [252]      -13.597023     -11.570814     -9.8693056     -8.5475473
    [256]      -7.5749927     -6.9345927     -6.6172304     -6.5851302
    [260]      -6.7180400     -6.7994189     -6.6596851     -6.3983164
    [264]      -6.3384042     -6.7747965     -7.7727857     -8.8420630
    [268]      -8.7806454     -7.4425793     -6.0892305     -5.4578066
    [272]      -5.7539134     -7.0700693     -9.5169449     -12.871249
    [276]      -14.124043     -11.213004     -8.1792755     -6.0490313
    [280]      -4.7736721     -4.3568406     -4.9333591     -6.8126578
    [284]      -10.509690     -13.678860     -9.3377094     -5.4294314
    [288]      -3.2674136     -2.3480511     -2.3904784     -3.2482228
    [292]      -4.8226738     -6.9251647     -8.6955204     -8.1296768
    [296]      -5.5662398     -3.0473127     -1.2784187    -0.37818393
    [300]     -0.40485722     -1.5023043     -4.0471063     -9.1312180
    [304]      -17.268665     -9.6446066     -5.0973163     -3.0668797
    [308]      -2.4594054     -2.9072020     -4.3133059     -6.7451601
    [312]      -10.198422     -12.590592     -10.516849     -7.8780584
    [316]      -6.4073329     -5.9849949     -6.2200537     -6.4472790
    [320]      -6.0890899     -5.4553599     -5.3237014     -6.2948632
    [324]      -8.9670553     -13.821865     -12.712761     -7.1547685
    [328]      -3.5995638     -1.2790776     0.36499736      1.5918831
    [332]       2.4847641      3.0415525      3.2466023      3.1105931
    [336]       2.6792083      2.0132558      1.1460030    0.054035548
    [340]      -1.2924764     -2.7445726     -3.7436981     -3.7507892
    [344]      -3.2009122     -2.9130383     -3.3325846     -4.6353664
    [348]      -6.8752384     -9.8101625     -12.155331     -12.496310
    [352]      -12.216368     -12.641145     -13.719417     -13.830708
    [356]      -11.252465     -7.7764831     -4.8453555     -2.7191324
    [360]      -1.4037305    -0.88614792     -1.1579002     -2.1653459
    [364]      -3.5985503     -4.4746504     -3.8452518     -2.4650054
    [368]      -1.3409940    -0.77190524    -0.74623579     -1.2006314
    [372]      -2.1183145     -3.5828121     -5.8039603     -9.0284500
    [376]      -12.280811     -11.221581     -8.2644625     -6.3645411
    [380]      -5.5976825     -5.7865963     -6.8763685     -9.0301466
    [384]      -12.865746     -18.556002     -14.304126     -8.8511286
    [388]      -5.6954374     -4.0186305     -3.5125394     -4.1498280
    [392]      -6.1560287     -10.236306     -16.761719     -12.334171
    [396]      -7.2921982     -4.5694213     -3.1122644     -2.4749963
    [400]      -2.4946625     -3.1919725     -4.7727880     -7.7579012
    [404]      -13.590435     -19.101974     -10.916998     -6.8376575
    [408]      -4.8760753     -4.1086025     -4.1209445     -4.6523433
    [412]      -5.5126648     -6.5825901     -7.8420253     -9.4120836
    [416]      -11.634665     -15.266078     -20.568777     -16.317602
    [420]      -10.530433     -6.9618134     -4.8187833     -3.7669168
    [424]      -3.7082436     -4.6917286     -6.9566798     -11.232095
    [428]      -20.090424     -17.199133     -10.497808     -7.0701957
    [432]      -5.0204806     -3.8454688     -3.4441390     -3.8820105
    [436]      -5.3633952     -8.3952351     -14.761847     -30.862759
    [440]      -13.045650     -8.3929071     -6.2392025     -5.3450360
    [444]      -5.2956061     -5.9477401     -7.3640199     -9.8926783
    [448]      -14.453073     -20.274765     -14.295530     -9.6161098
    [452]      -7.1604438     -6.0760927     -6.0425930     -6.9740858
    [456]      -8.9470739     -12.178424     -16.083344     -15.195612
    [460]      -11.350109     -8.6161423     -7.0121455     -6.3068676
    [464]      -6.3768086     -7.1377487     -8.4268913     -9.7698784
    [468]      -10.280251     -9.6126432     -8.4862461     -7.5292368
    [472]      -6.9267950     -6.6615081     -6.6502771     -6.7843437
    [476]      -6.9415522     -7.0030994     -6.8896670     -6.6063333
    [480]      -6.2511296     -5.9632049     -5.8526230     -5.9580088
    [484]      -6.2353182     -6.5678873     -6.7999516     -6.7935514
    [488]      -6.4846478     -5.9065423     -5.1739063     -4.4432678
    [492]      -3.8756182     -3.6219952     -3.8361628     -4.7134924
    [496]      -6.5763631     -10.093350     -16.097128     -13.511291
    [500]      -7.7367764     -4.4072776     -2.4941022     -1.5041515
    [504]      -1.1900268     -1.4002280     -2.0328841     -3.0378184
    [508]      -4.4517703     -6.4624786     -9.5525904     -15.141218
    [512]      -28.178984
  [Tag]          481
  [frame_len]          320
[Record 4]
  [tot_power]       197135.16
  [re_spec_val]
    [0]       11.535675      11.172773      10.112146      8.4668264
    [4]       6.5273137      4.8497171      3.9757829      3.8154371
    [8]       3.9107051      4.3307528      5.8154373      8.3527670
    [12]       10.939228      12.934611      14.144488      14.510636
    [16]       13.972809      12.412786      9.6985188      6.9038544
    [20]       8.6706324      12.523871      15.418431      17.354965
    [24]       18.716320      19.972916      21.470169      23.130976
    [28]       24.626913      25.730120      26.397654      26.717539
    [32]       26.831125      26.824257      26.633984      26.057987
    [36]       24.822945      22.602554      19.037682      14.980124
    [40]       15.726727      18.478102      20.503374      22.955755
    [44]       26.207989      29.344057      31.791842      33.434849
    [48]       34.289322      34.381378      33.716320      32.270210
    [52]       29.983480      26.749987      22.388758      16.511797
    [56]       7.7382593      4.9022841      12.669281      17.015924
    [60]       19.882965      21.965984      23.541945      24.657446
    [64]       25.248917      25.238455      24.574553      23.245382
    [68]       21.307919      18.960640      16.588551      14.492383
    [72]       12.440427      9.9130430      6.9779310      5.8067760
    [76]       7.6707549      9.9990940      11.820330      13.109565
    [80]       13.896759      14.189198      14.004467      13.379978
    [84]       12.347966      10.879302      8.8128204      5.7640104
    [88]      0.82218140     -8.8741589     -5.8319001   -0.063018188
    [92]       2.3236997      3.2564421      3.4141161      3.1447392
    [96]       2.6271706      1.8942394     0.86420053    -0.63535684
    [100]      -2.9331710     -6.6695609     -10.989378     -7.0272932
    [104]      -2.3658431     0.42186138      2.0371752      3.0414937
    [108]       3.8871694      4.7961087      5.7005615      6.4489198
    [112]       6.9762774      7.2753611      7.2900238      6.8606410
    [116]       5.7332687      3.5378945    -0.36972147     -6.3624763
    [120]      -4.5984669   -0.098090202      2.1328502      2.9924140
    [124]       3.2921321      4.0268483      5.7355981      7.8534002
    [128]       9.7242374      11.103256      11.950750      12.269662
    [132]       12.039243      11.178489      9.4984865      6.5850730
    [136]       1.4695472     -4.1937146      1.7008207      5.6791248
    [140]       7.4986954      7.9896221      7.5861979      6.7620091
    [144]       6.2298875      6.4679070      7.0980797      7.4917822
    [148]       7.2997599      6.3453655      4.4374208      1.1983960
    [152]      -3.9769182     -6.1401057     -1.1018883      2.3316638
    [156]       4.2688193      5.2410269      5.5306091      5.3300490
    [160]       4.8185081      4.1711626      3.5086060      2.8581617
    [164]       2.2326560      1.7671791      1.6553408      1.8293449
    [168]       1.9166853      1.5645372     0.63320410    -0.70950001
    [172]      -1.7764040     -1.6068476    -0.26021779      1.4543201
    [176]       3.0851011      4.5030665      5.6679468      6.5319252
    [180]       7.0089483      6.9705720      6.2438302      4.5804720
    [184]       1.5486795     -3.6997540     -8.5511246     -3.7298152
    [188]     -0.54160976     0.71009171     0.84077543     0.45333183
    [192]      0.22770239     0.68020815      1.6113917      2.4093945
    [196]       2.6120718      1.9423957     0.19984041     -2.6038129
    [200]      -4.9495716     -4.0987206     -2.3636179     -1.5329349
    [204]      -1.4918530     -1.6025048     -1.0640570     0.41600803
    [208]       2.3562255      4.1498890      5.4183011      5.9485517
    [212]       5.5766883      4.0843897      1.0644755     -3.9278769
    [216]      -4.8511343   -0.010016203      3.2440851      5.3482866
    [220]       6.9519424      8.3860149      9.7304296      10.923674
    [224]       11.866682      12.460340      12.597198      12.140643
    [228]       10.891962      8.5076542      4.2403173     -3.1530466
    [232]     -0.57219189      4.5857711      7.0614877      8.2039080
    [236]       8.6820164      8.8674498      8.8717813      8.5807629
    [240]       7.7933335      6.3467340      4.2311158      1.9040754
    [244]      0.54959983     0.43762875     0.26710227    -0.86054158
    [248]      -3.3574064     -7.5932755     -12.194918     -10.318236
    [252]      -7.2547865     -5.3278284     -3.7978170     -2.1781797
    [256]     -0.49508548     0.97931182      2.0228200      2.5210209
    [260]       2.4228396      1.6929067     0.26625031     -2.0087950
    [264]      -5.4006429     -9.4388361     -8.9507303     -5.3617096
    [268]      -2.8253834     -1.3878115    -0.78052467    -0.86618531
    [272]      -1.6156420     -3.0719874     -5.3119006     -8.3747339
    [276]      -12.048919     -15.236247     -15.677360     -13.447769
    [280]      -10.850446     -8.9103260     -7.6652575     -6.6949983
    [284]      -5.4072299     -3.6317642     -1.7692679    -0.23338215
    [288]      0.78197974      1.2220995      1.1086780     0.55224669
    [292]     -0.19486624    -0.78130293     -1.0656593     -1.3462297
    [296]      -2.1432450     -4.0737810     -8.1656389     -11.629416
    [300]      -4.5405965     0.45580620      3.4164102      5.0135727
    [304]       5.4837885      4.8626738      3.0397356    -0.28736711
    [308]      -5.7586374     -13.174931     -13.334188     -12.871705
    [312]      -14.384225     -13.602185     -11.032290     -6.2874589
    [316]     -0.69400936      3.6722596      6.6501923      8.4569702
    [320]       9.3100710      9.4621716      9.3018093      9.3076077
    [324]       9.6509638      10.017174      10.019651      9.4528837
    [328]       8.2075844      6.1044178      3.0490096      2.0394261
    [332]       6.0944834      9.9150286      12.447758      13.976191
    [336]       14.767026      15.028411      14.921923      14.548221
    [340]       13.923920      12.967815      11.486519      9.1084204
    [344]       4.9896593     -3.6057184     -1.2945095      5.6612186
    [348]       8.9303265      10.588405      11.314173      11.456936
    [352]       11.243190      10.791832      10.100259      9.0769796
    [356]       7.6028881      5.5662732      2.8562932    -0.66432434
    [360]      -5.1198158     -10.046791     -13.333931     -15.192344
    [364]      -13.304537     -6.9894953     -2.2188053     0.86791050
    [368]       2.6906259      3.5142145      3.5248680      2.8951590
    [372]       1.7988101     0.34131810     -1.5445749     -3.9572902
    [376]      -5.9202967     -4.8659430     -2.2426562    -0.13001984
    [380]       1.2812937      2.2115543      2.8770006      3.4390466
    [384]       3.9928319      4.5228014      4.8752561      4.8124852
    [388]       4.0913301      2.5125351    0.069964461     -2.3322401
    [392]      -2.8007400     -2.3575284     -3.1176295     -6.1797447
    [396]      -11.847126     -8.7285643     -4.1564374     -1.9793164
    [400]     -0.80991083     0.39019963      1.8013113      2.9017265
    [404]       3.2865515      2.8809714      1.9301682     0.99906170
    [408]      0.40295079    -0.51616549     -3.0619442     -10.378907
    [412]      -12.439280     -2.1724086      2.1199620      4.6267085
    [416]       6.3954768      7.8106794      8.8899565      9.4994249
    [420]       9.5125151      8.8507156      7.4685678      5.3364019
    [424]       2.4529710    -0.95841318     -3.4665458     -2.8307264
    [428]     -0.66404563      1.3346374      2.9952393      4.4335012
    [432]       5.6499391      6.5128727      6.8598294      6.5667868
    [436]       5.5726137      3.9224677      1.8769556   -0.086569354
    [440]      -1.8618867     -4.2526169     -8.8103981     -19.542789
    [444]      -11.308464     -4.6207519    -0.30226928      3.0050251
    [448]       5.4182425      6.9096479      7.4760160      7.1215425
    [452]       5.8378625      3.6137238     0.56150943     -2.4690702
    [456]      -3.4898288     -2.8999305     -2.6417439     -3.0340569
    [460]      -2.6570232    -0.30301276      2.3177269      3.9700053
    [464]       4.3892078      3.4559743     0.88178515     -4.1129961
    [468]      -11.953444     -8.8171625     -5.8756623     -5.6001248
    [472]      -6.4399281     -7.6405034     -10.276134     -17.656794
    [476]      -11.895803     -5.4874883     -3.1239333     -3.6235623
    [480]      -7.6755357     -10.665778     -2.9826772      1.0294797
    [484]       2.6589291      2.6689942      1.4169550    -0.70727032
    [488]      -2.9955511     -4.4508042     -3.7157888    -0.86577529
    [492]       1.9411001      3.7057946      4.2934885      3.7923951
    [496]       2.5948567      1.8818574      2.6330283      3.7971261
    [500]       4.3067865      3.9097970      2.7315278      1.1907996
    [504]    -0.054962426    -0.64150620    -0.70099539    -0.40615261
    [508]     -0.11192713    -0.48157632     -2.3305368     -7.2586708
    [512]      -24.302038
  [Tag]          641
  [frame_len]          320
[Record 5]
  [tot_power]       263765.44
  [re_spec_val]
    [0]      -4.1903620    -0.40471616      2.7489429      3.4610069
    [4]       2.1811187    -0.70951402     -3.8809721     -5.4815540
    [8]      -6.3314114     -5.7781367     -5.0934300     -7.7992544
    [12]      -3.2708614      4.9548059      9.7368097      12.409296
    [16]       13.552990      13.427803      12.159622      9.7823954
    [20]       6.1805658      1.0049801     -5.6577740     -12.275152
    [24]      -12.539526     -3.4600952     -2.7043464      2.9208422
    [28]       13.903836      20.719561      25.199617      28.062969
    [32]       29.615036      29.987946      29.217726      27.271385
    [36]       24.053953      19.399927      12.988384      3.5131412
    [40]      -9.0370655      2.9768219      6.0688825      2.3069346
    [44]       9.8314829      20.982792      27.483160      31.751671
    [48]       34.493603      36.006622      36.428440      35.806355
    [52]       34.114418      31.242537      26.959658      20.900236
    [56]       13.422779      8.6522131      3.2629225      1.5819186
    [60]       8.4109964      11.599109      16.314289      21.532322
    [64]       25.427479      27.930887      29.218134      29.394865
    [68]       28.480555      26.406618      22.984457      17.796534
    [72]       9.8227940     -3.0783944     -4.0989246     -5.3281350
    [76]      -4.9070187     -5.7112322    -0.95028061      7.1535721
    [80]       12.135063      15.197375      16.985346      17.806782
    [84]       17.805279      17.025349      15.438243      12.945592
    [88]       9.3515482      4.2525930     -3.3829582     -15.632438
    [92]      -12.690920     -10.643147     -8.2202129     -4.8268614
    [96]      -2.6397753     -2.1849823     -3.8441916     -9.3346615
    [100]      -24.423500     -6.7435865     -2.4438784     -1.1431918
    [104]      -1.7181876     -3.8384182     -7.2005157     -10.252930
    [108]      -9.6917467     -7.9344621     -8.4866142     -12.161366
    [112]      -3.9898674      3.0684590      7.2330389      9.5862370
    [116]       10.556917      10.323767      8.9366922      6.3237538
    [120]       2.1517358     -5.0242295     -28.492779     -5.7039309
    [124]     -0.91960722      1.3411286      2.3781502      3.5585177
    [128]       6.5843081      10.394955      13.508548      15.598537
    [132]       16.697899      16.875572      16.177189      14.620034
    [136]       12.220705      9.1663532      6.4116192      5.4257464
    [140]       5.3211608      4.3107500      1.0420328     -9.7182493
    [144]      -2.2581713      5.7289476      9.6513004      11.702137
    [148]       12.334812      11.571463      9.1383514      4.2821198
    [152]      -1.8365394      2.2965796      5.4311576      6.4632020
    [156]       6.3458123      5.4408517      4.1464429      4.3758736
    [160]       7.0484123      9.8804331      12.045589      13.694730
    [164]       14.980597      15.858335      16.184381      15.834576
    [168]       14.736441      12.863369      10.254087      7.1202126
    [172]       4.0330567      1.6400841    -0.20700353     -1.7366853
    [176]      -2.1718705     -1.6166228     -1.4632503     -1.7296169
    [180]     0.024800682      3.6076295      6.5221171      8.1720486
    [184]       8.5922728      7.8986726      6.4179955      5.1555471
    [188]       5.2365952      6.0531254      6.7743506      7.4949722
    [192]       8.4370604      9.3285685      9.6888227      9.1569014
    [196]       7.4233623      4.0201702     -1.4423476     -2.0663011
    [200]       1.9301889      3.8123207      3.9809582      2.9138587
    [204]       1.0120327     -1.0852619     -2.3223016     -1.7437695
    [208]      0.65085256      4.0456457      7.5417314      10.570353
    [212]       12.865378      14.311284      14.833187      14.327343
    [216]       12.587200      9.1306009      2.4359109     -20.716473
    [220]      -1.6127251     0.25593099     -2.8828211     -6.5303378
    [224]     -0.69765133      1.7405953     0.39788228     -3.7415445
    [228]       2.6305861      8.3920383      11.623879      13.330835
    [232]       13.978054      13.813748      12.990894      11.607220
    [236]       9.6994982      7.1664138      3.5596337     -2.0479984
    [240]      -2.7512197      3.1253705      6.6224337      8.4394808
    [244]       9.1081953      8.8781786      7.8746219      6.1808438
    [248]       3.9656751      1.7074993     0.10827810    -0.78946537
    [252]      -1.4910123     -1.8704207     -1.2314402     0.18876053
    [256]       1.2415786     0.96429223     -1.7181652     -7.9018083
    [260]      -1.6915036      4.0434194      6.7769542      7.6574984
    [264]       7.1281328      5.5250826      3.5306129      2.1648195
    [268]       1.3390019   -0.041978229     -2.6278541     -6.4980369
    [272]      -10.754406     -11.028424     -7.1169472     -3.8594203
    [276]      -2.0552764     -1.4943472     -1.7978795     -2.4344702
    [280]      -2.8447380     -2.8288615     -2.7075481     -3.0648968
    [284]      -4.5375633     -7.9199605     -14.927704     -25.405319
    [288]      -20.301416     -27.582989     -20.119686     -12.783710
    [292]      -10.403863     -8.9918194     -6.3754983     -3.9379478
    [296]      -2.7323916     -2.2587934     -1.3034799     0.18685441
    [300]       1.2196072      1.5087121      1.5036039      1.5665352
    [304]       1.4023654      1.4204407      3.6624472      7.2068877
    [308]       10.068458      11.909444      12.882107      13.174716
    [312]       12.931708      12.262515      11.330431      10.462721
    [316]       9.9896431      9.7965164      9.4206686      8.5607843
    [320]       7.3139734      6.2765536      6.2517886      7.3681169
    [324]       9.1891222      11.349111      13.568525      15.596482
    [328]       17.235634      18.353218      18.869251      18.740223
    [332]       17.948414      16.499004      14.419229      11.735237
    [336]       8.3652182      3.8074899     -3.9963868     -10.136913
    [340]      -1.1889927      1.6384149      1.5990525    -0.52594519
    [344]      0.65341949      6.0357060      9.9053173      12.138443
    [348]       13.067234      12.846008      11.497971      8.9366465
    [352]       4.9616785    -0.48376274     -4.0459886     -1.8478163
    [356]      0.61881530      2.1797998      2.7959573      2.5248282
    [360]       1.8232534      1.7358323      2.7078362      3.8686585
    [364]       4.5448194      4.6175442      4.1966972      3.4364722
    [368]       2.4044521     0.95436496     -1.3862419     -5.8363576
    [372]      -17.528728     -7.5602703     -1.0625560      2.1973891
    [376]       3.8643112      4.4386010      4.2124224      3.5357606
    [380]       2.8329291      2.2160881      1.1953422     -1.0305649
    [384]      -5.2856603     -7.9860983     -3.8471367     -1.5135555
    [388]      -1.8169615     -5.4887075     -18.701704     -4.7075262
    [392]       1.5799664      4.9664478      7.0541525      8.3708696
    [396]       9.1315327      9.4036932      9.1727581      8.3825483
    [400]       6.9586005      4.8116941      1.8687173     -1.4234987
    [404]      -2.3721027    -0.36504963      1.4768697      2.3838825
    [408]       2.6114781      2.7928693      3.9116433      6.2624764
    [412]       8.8864460      10.941091      12.092731      12.219442
    [416]       11.239141      9.0605555      5.6505585      1.4475074
    [420]      -2.2047606     -5.7344618     -11.091097     -7.9248667
    [424]      -3.6782916     -2.2429945     -2.4627705     -3.3537924
    [428]      -3.7241213     -2.0000377      1.3453267      4.3870373
    [432]       6.4154396      7.3671012      7.2881398      6.2013340
    [436]       4.0946822      1.1209285     -1.1849385   -0.099722907
    [440]       2.4293878      4.5876541      6.1505919      7.0395942
    [444]       7.1149988      6.2923350      4.9221525      4.5185552
    [448]       5.8883638      7.3189206      7.7382507      6.8946776
    [452]       4.6477995     0.68233299     -5.8902059     -17.459570
    [456]      -16.195347     -13.712663     -7.3627095    -0.49342358
    [460]       4.3412614      7.5693378      9.5202923      10.369322
    [464]       10.207365      9.0775394      6.9948120      3.9480886
    [468]     -0.17947386     -6.1033106     -19.545046     -12.387016
    [472]      -5.3541384     -1.8782889     0.25840011      1.5745103
    [476]       2.3269458      2.9466388      4.0449700      5.7237844
    [480]       7.4262953      8.6753130      9.2926483      9.2524309
    [484]       8.5690918      7.2359486      5.1642509      2.0894334
    [488]      -2.3178756     -4.1987181     0.27526715      3.8783932
    [492]       5.9621949      6.8427720      6.6757693      5.5599790
    [496]       3.7438283      2.0242634      1.4727888      1.7144997
    [500]       1.6573726     0.81719029    -0.96192318     -3.8933651
    [504]      -8.6305113     -16.884560     -13.458081     -6.7645135
    [508]      -2.4942083     0.58491153      2.7357013      4.0133586
    [512]       4.4371457
  [Tag]          801
  [frame_len]          320
[Record 6]
  [tot_power]       267861.88
  [re_spec_val]
    [0]       15.095573      14.691392      13.476699      11.447248
    [4]       8.6175346      5.1591978      1.9942944     0.90154219
    [8]       1.1842178     0.56221670     -3.5217900     -8.7302237
    [12]       5.0186324      11.449664      15.391687      17.805250
    [16]       19.013859      19.150335      18.272114      16.410696
    [20]       13.612925      9.9871187      5.7372088      1.6956611
    [24]      0.98145872      1.3718712     -5.7530279      6.5425806
    [28]       16.395893      22.281683      26.165981      28.638779
    [32]       29.944927      30.186060      29.375179      27.442184
    [36]       24.204796      19.294920      12.100433      3.0055513
    [40]      -8.0767679     -1.4663855      3.4232523     -12.918138
    [44]       15.278181      23.977428      29.301146      32.734116
    [48]       34.771164      35.615795      35.334431      33.895039
    [52]       31.151407      26.746662      19.715614      5.7522044
    [56]       6.8768387      8.6590300      4.7394919     -11.575545
    [60]       9.8751011      18.308203      23.830137      27.662344
    [64]       30.193647      31.591497      31.923420      31.187925
    [68]       29.309858      26.097654      21.098057      12.944622
    [72]      -7.0559974      4.1295905      4.5083165     0.49137548
    [76]      -3.6508398     0.44213936      4.0743713      6.2500758
    [80]       7.5768609      8.2931614      8.2865505      7.2595167
    [84]       4.8256588     0.39108497     -5.6026883     -3.4163795
    [88]      0.12414402      1.7115786      2.0985823      1.8173604
    [92]       1.3756652      1.5120591      3.0739517      5.7068863
    [96]       8.2432909      10.073096      11.042378      11.139812
    [100]       10.389339      8.8527718      6.7174273      4.4545736
    [104]       2.7008028      1.5046490     0.25771993     -1.5497220
    [108]      -3.7235970     -3.1750112      1.2209647      5.5173626
    [112]       8.7617750      10.965908      12.166516      12.347110
    [116]       11.427077      9.2321930      5.4386849    -0.25710237
    [120]      -4.6512537     -3.9985127     -4.2883749     -4.9429383
    [124]      -4.1992831     -3.1215403    -0.61085159      3.7889915
    [128]       7.7448220      10.497051      12.055154      12.459402
    [132]       11.645116      9.3612480      4.8790841     -5.0191631
    [136]      -7.6875644    -0.43675700     0.91380441     0.62481278
    [140]       1.5067465      4.9259601      9.1060867      12.913715
    [144]       16.036346      18.386271      19.936869      20.670828
    [148]       20.555836      19.525414      17.449987      14.071985
    [152]       8.8118458   -0.099277250     -9.8197365     -2.6987228
    [156]     -0.47495645    -0.10632422     -3.6685576     0.35966885
    [160]       9.9182882      15.479489      18.918087      20.880527
    [164]       21.616543      21.203642      19.601795      16.637220
    [168]       11.910683      4.8157668    0.089957260      1.8941250
    [172]       1.8801275     0.69874460    -0.18288045    -0.70831865
    [176]      -2.2299972     -4.7478061    -0.29884732      5.3551731
    [180]       8.8103247      10.574013      10.965570      10.088980
    [184]       7.8519592      3.7959569     -3.8816986     -10.461896
    [188]      -1.6396517      1.9067293      3.9268763      5.3052993
    [192]       6.0613837      5.9358091      4.6319203      2.0522249
    [196]     0.083560884      1.9564692      4.1234851      4.6898317
    [200]       3.4619915     0.19222583     -4.5754385     -4.1527314
    [204]      -1.6996495     -1.1622370     -1.2833010     0.24504478
    [208]       3.5028830      7.2291155      10.732367      13.560401
    [212]       15.473747      16.369617      16.168222      14.721987
    [216]       11.678807      5.9949985     -9.0288534     -2.0915241
    [220]       1.9184602     0.79784966     -5.2429118     -4.7561460
    [224]       3.2837276      7.4778094      9.9898415      11.461348
    [228]       12.078254      11.874838      10.848923      9.0312233
    [232]       6.5646338      3.7709255      1.0297043     -1.4011474
    [236]      -2.9368567     -3.0531781     -2.8653200     -3.9741495
    [240]      -8.0047560     -6.0699115      1.9971964      6.9024830
    [244]       9.8709288      11.467819      11.928023      11.347946
    [248]       9.7437086      7.0598340      3.1583285     -1.9372908
    [252]      -5.1475596     -3.0223682    -0.69205517     0.74056894
    [256]       1.7093223      3.1112556      5.7089629      8.8567476
    [260]       11.594012      13.535820      14.595900      14.754240
    [264]       13.973205      12.152707      9.0658436      4.2455258
    [268]      -2.1701813     -2.1240404     0.54609126      1.2648749
    [272]      0.44299313     -2.2195654     -8.5707064     -2.7491269
    [276]       4.8173494      9.1918898      11.776593      13.035400
    [280]       13.123681      12.034797      9.5991087      5.4098411
    [284]     -0.22890513     0.46655712      3.7675428      5.5030293
    [288]       6.5249705      7.6535659      9.1275511      10.663856
    [292]       11.949759      12.809834      13.123808      12.752498
    [296]       11.493699      8.9947052      4.3978767     -6.1374669
    [300]      -3.0352337      4.0246396      7.2476163      9.1844912
    [304]       10.561469      11.733935      12.877108      13.934678
    [308]       14.678281      14.867786      14.322727      12.896845
    [312]       10.418164      6.6198859      1.3292226     -2.1887879
    [316]     -0.46227241     0.46950784    -0.71064973     -4.7608185
    [320]      -14.911098     -5.9345026     0.20216715      3.5668459
    [324]       5.7476759      7.4247403      8.9973125      10.454520
    [328]       11.452192      11.625677      10.683003      8.2794466
    [332]       3.6632056     -6.4325643     -9.1056137     -1.4680176
    [336]      0.66625899      1.5422401      2.4133081      3.6526120
    [340]       5.1561322      6.7016830      8.0480270      8.9239388
    [344]       9.0398159      8.0801315      5.6066546     0.84286863
    [348]      -4.6646509     -1.0285455      1.5093679      1.6063119
    [352]    -0.026962895     -2.8659995     -6.1614132     -8.8696575
    [356]      -9.5364790     -6.4197936     -1.5061866      2.8141627
    [360]       5.9761577      7.9771399      8.9091930      8.8731480
    [364]       7.9776282      6.3559399      4.1723919      1.6090616
    [368]      -1.0926387     -3.4295597     -4.6214242     -4.4781127
    [372]      -3.9223633     -4.1687212     -6.2360058     -8.8568754
    [376]      -4.1662545     0.62694693      3.3964756      4.7000794
    [380]       4.8702488      4.0463085      2.2051194    -0.85756952
    [384]      -5.1830106     -6.8177643     -3.2874367    0.063310340
    [388]       2.9136932      5.4847279      7.5907297      9.0169277
    [392]       9.6872025      9.6622734      9.1303988      8.3360596
    [396]       7.3399081      5.8267393      3.2156725     -1.0702760
    [400]      -4.6052423     -1.8767812     0.69446474      2.0877507
    [404]       3.2479987      4.8631077      6.9680567      9.1509418
    [408]       10.994879      12.228273      12.669981      12.132921
    [412]       10.303478      6.5139356     0.58569133      3.7620587
    [416]       8.3069401      10.458740      11.115361      10.783289
    [420]       9.8859787      8.9537935      8.4831715      8.5075788
    [424]       8.6476431      8.5210876      7.8251209      6.2056584
    [428]       3.1021075     -1.6463903    -0.60258162      3.7447069
    [432]       5.9803405      6.4799633      5.6083732      3.7458282
    [436]       1.9110495      1.6278917      2.6258798      3.8403118
    [440]       4.8428583      5.3011165      4.8103738      2.9100537
    [444]     -0.67385489     -1.5021968      2.9542258      6.2013311
    [448]       7.8846550      8.3485107      7.7361283      6.0646605
    [452]       3.4652970      1.2280214      1.8200877      3.8594871
    [456]       5.6905718      7.2159686      8.4036551      8.9907837
    [460]       8.6342821      6.9021554      2.8781178     -7.2577949
    [464]      -3.2143834      3.2260230      5.6142497      6.2461271
    [468]       5.9118052      5.1952729      4.7533817      5.1672487
    [472]       6.3764944      7.7415714      8.7175627      9.0318699
    [476]       8.5553303      7.2654424      5.6054864      5.2693462
    [480]       6.8971572      8.5656099      9.2816029      8.8961535
    [484]       7.4800115      5.3336892      3.3298109      2.8256125
    [488]       4.1221299      6.1429687      7.8138390      8.5597868
    [492]       8.0608759      5.8970513     0.86741072     -9.9955454
    [496]     0.041860759      4.8408976      6.8411312      7.3775077
    [500]       6.8983679      5.6044722      3.6244080      1.1127204
    [504]      -1.6584713     -4.2475681     -6.2592416     -7.8962178
    [508]      -10.009256     -13.715195     -21.004999     -32.049362
    [512]      -26.114136
  [Tag]          961
  [frame_len]          320
[Record 7]
  [tot_power]       287062.81
  [re_spec_val]
    [0]       11.000959      10.461341      8.7748451      5.6921349
    [4]      0.61500406     -6.2368193     -4.4281039     -1.4417784
    [8]     -0.73650056     -2.1835153     -7.5696979    -0.83553028
    [12]       7.8005118      13.111307      16.582808      18.722954
    [16]       19.739361      19.706461      18.599752      16.262114
    [20]       12.252609      5.2403731     -5.4874940     0.66134280
    [24]      0.86224526     -4.6725779     -30.434395    -0.82575667
    [28]       10.712013      18.141607      23.177916      26.549032
    [32]       28.601215      29.501787      29.314884      28.026964
    [36]       25.544529      21.669203      16.072432      8.4400330
    [40]      -2.0624950     -3.5195036      3.8998907     0.29316041
    [44]       12.442253      22.473173      28.541126      32.520405
    [48]       35.021420      36.302299      36.470310      35.540310
    [52]       33.443829      30.001734      24.832296      17.076200
    [56]       5.4849277      3.1866541      3.4620953      2.4136679
    [60]       1.4271216      13.127237      20.427786      25.085835
    [64]       28.095873      29.845922      30.498421      30.104063
    [68]       28.633831      25.968788      21.834183      15.557982
    [72]       4.7217803     -4.7641468      1.1387011     0.73134351
    [76]      0.62378979      1.8471128      4.0968099      6.8737969
    [80]       9.1301861      10.475294      10.946432      10.667861
    [84]       9.7193613      8.0636692      5.4797201      1.4011148
    [88]      -6.0739627     -20.779989     -5.1728969    -0.84301925
    [92]       1.3092703      2.0210345      1.1873246     0.45061707
    [96]       4.7076817      9.6435480      13.019433      15.009127
    [100]       15.818817      15.541964      14.194719      11.756919
    [104]       8.2741661      4.2133284      1.0383543  -0.0079112183
    [108]      0.19067842    -0.32469305     -4.1689854     -4.5405350
    [112]       5.1751180      10.528159      13.663777      15.348137
    [116]       15.878299      15.375440      13.872266      11.350503
    [120]       7.7993503      3.5099404     0.14582363    -0.24257161
    [124]      0.89821678      2.2634518      3.3392043      3.7798450
    [128]       4.0355153      5.8486085      9.0633774      11.806649
    [132]       13.401576      13.753629      12.817838      10.466383
    [136]       6.4452081     0.61885762     -4.1166334     -3.9133193
    [140]      -2.5040369    0.077320069      3.2817352      6.2772417
    [144]       8.5097017      9.7485361      10.253798      10.963178
    [148]       12.579849      14.355655      15.423354      15.473580
    [152]       14.421087      12.183255      8.6438074      4.6049933
    [156]       4.8178802      7.5831223      9.0892591      8.8084211
    [160]       6.9127059      8.6589746      14.302193      18.448919
    [164]       20.983511      22.218443      22.310915      21.306253
    [168]       19.169306      15.820136      11.391715      7.5779433
    [172]       6.8371234      7.0002456      6.8144751      6.7734475
    [176]       7.5748749      9.4274654      11.757044      13.833253
    [180]       15.264678      15.913772      15.746862      14.772958
    [184]       13.046478      10.724377      8.1776285      6.0498629
    [188]       4.9302139      4.7219143      4.7235217      4.2970014
    [192]       3.0965533     0.83953887     -2.9895105     -3.7129958
    [196]       3.0019977      7.9597535      11.112205      12.943281
    [200]       13.703813      13.540273      12.546853      10.753840
    [204]       8.0300837      3.8149793     -4.0168381     -14.709277
    [208]      -3.7375643     -1.0463282      2.4084044      7.6578317
    [212]       12.091011      15.261701      17.321806      18.393408
    [216]       18.521275      17.679554      15.762551      12.547169
    [220]       7.6770735      1.8927623      1.1727353      2.1944962
    [224]       1.6686741      1.0112240      2.1808455      4.5472207
    [228]       7.0481548      9.3421936      11.167798      12.318466
    [232]       12.692054      12.260929      11.043350      9.0897541
    [236]       6.4449539      3.0501735     -1.1285038     -3.8707025
    [240]      -2.2445459    -0.61164397    -0.58769524     -1.4173511
    [244]      0.87876296      5.7348471      9.6939049      12.378676
    [248]       13.949672      14.535321      14.217583      13.057456
    [252]       11.116080      8.4610872      5.1681128      1.5796988
    [256]     -0.50331974     0.36635256      1.9547936      3.1703920
    [260]       3.9391286      4.0865936      3.5404141      3.3919973
    [264]       5.4264765      8.2372189      10.241923      11.174908
    [268]       11.119890      10.251415      8.9729786      8.1945019
    [272]       8.6596813      9.6728010      10.153767      9.3844013
    [276]       6.7038641      4.6777492      10.171717      14.843895
    [280]       17.604919      18.957859      19.167397      18.369944
    [284]       16.674492      14.275452      11.617317      9.4152327
    [288]       8.1761217      7.9176784      8.3964558      9.1734667
    [292]       9.8912439      10.476597      11.055341      11.704657
    [296]       12.251416      12.361461      11.728566      10.119210
    [300]       7.3211327      3.0794809     -2.9339104     -10.812400
    [304]      -17.188694     -14.501039     -8.8978310     -4.0751925
    [308]     -0.45313811      2.0640044      3.9229901      5.7501111
    [312]       7.7299962      9.4372578      10.432471      10.501564
    [316]       9.5639544      7.6207623      4.8441930      1.7382113
    [320]      -1.3213501     -4.8117423     -6.3966451     -3.8354478
    [324]      -3.0680268     -7.4722433     -11.932545      1.6622490
    [328]       7.0707440      9.9446297      11.260637      11.342566
    [332]       10.294166      8.1114235      4.7709279     0.59804797
    [336]      -2.5639906     -3.0060616     -2.2288659    -0.89412516
    [340]      0.66874593      1.9679885      3.0200891      4.5274839
    [344]       6.9593306      9.6223392      11.740274      13.019851
    [348]       13.416325      12.986298      11.889622      10.446966
    [352]       9.0588417      7.8506427      6.5996599      5.2096229
    [356]       4.0200224      3.5537863      3.9795997      5.0793295
    [360]       6.5645604      8.2626543      10.039068      11.656816
    [364]       12.846730      13.429500      13.336123      12.578446
    [368]       11.214586      9.2952690      6.7777009      3.4530990
    [372]      -1.0544006     -7.3038912     -16.958538     -16.834949
    [376]      -9.4142313     -6.6534834     -7.3880911     -12.538267
    [380]      -8.5448332     -1.7567897      1.7349148      3.4578156
    [384]       4.0835819      3.9674788      3.3135548      2.2952697
    [388]       1.2793189     0.94644916      1.6776804      3.2324603
    [392]       5.5457215      8.4672012      11.365208      13.696878
    [396]       15.230220      15.897797      15.685513      14.593415
    [400]       12.632956      9.8375349      6.2369413      1.6480881
    [404]      -5.0210619     -13.466632     -6.0592871     -1.6187556
    [408]       1.3003367      3.8094444      6.1713061      8.3909807
    [412]       10.339487      11.819143      12.659273      12.747024
    [416]       12.000928      10.324610      7.5293021      3.1133404
    [420]      -4.5488715     -6.6581616     0.51085109      4.2114162
    [424]       6.3148751      7.3650818      7.4636712      6.5106316
    [428]       4.2381535     0.58486557    -0.44235748      3.1401360
    [432]       5.7256608      6.7185907      6.3582420      4.7852783
    [436]       2.2047794    -0.38691467    -0.66287899      1.2139318
    [440]       3.4463904      5.4489717      7.0133166      7.9517555
    [444]       8.0668707      7.1326337      4.9658127      2.4516687
    [448]       3.2777612      5.8251300      7.0824261      6.5505028
    [452]       3.6965775     -3.7502439     -3.1848199      4.0735049
    [456]       6.9661798      7.6503983      6.5474381      3.2893965
    [460]      -3.5332279     -1.5751498      4.8314233      8.2061253
    [464]       9.9723949      10.628611      10.355610      9.2262487
    [468]       7.2672458      4.4601665     0.81388402     -2.4785657
    [472]      -1.6647328      1.2128435      3.5945160      5.3505073
    [476]       6.5945454      7.4677491      8.2884483      9.3912230
    [480]       10.678679      11.711069      12.143875      11.831356
    [484]       10.754147      8.9828348      6.7167764      4.4412017
    [488]       3.1751666      3.7421076      5.3112969      6.7080374
    [492]       7.4376111      7.4042182      6.7587752      5.9861784
    [496]       5.7319365      5.9738894      6.0398574      5.4168959
    [500]       3.8654273      1.2047027     -2.9137163     -9.4333515
    [504]      -17.493793     -12.838850     -10.145284     -9.3136539
    [508]      -9.0105333     -9.0854425     -10.247848     -13.313548
    [512]      -16.563303
  [Tag]         1121
  [frame_len]          320
[Record 8]
  [tot_power]       293604.62
  [re_spec_val]
    [0]      -2.4150045     -2.3566024     -2.0540981     -1.5378734
    [4]      -1.3634696     -2.2297869     -4.5848074     -7.1855178
    [8]      -5.8912053     -3.2369814    -0.14501311      4.1549597
    [12]       8.3883829      11.774726      14.229661      15.784410
    [16]       16.435341      16.140051      14.842499      12.524932
    [20]       9.3359051      5.7484560      2.1742637     -1.6662470
    [24]      -4.0402045     -2.0977211     -1.9194032     -19.368587
    [28]       7.2779951      16.258108      21.826269      25.497688
    [32]       27.762646      28.826241      28.760721      27.540403
    [36]       25.021151      20.833349      13.928473     -1.9559329
    [40]       3.3283467      7.3922195      6.7267785     0.89979082
    [44]       17.255840      25.520233      30.777903      34.254547
    [48]       36.388992      37.372543      37.278019      36.095737
    [52]       33.729317      29.946014      24.201263      14.789174
    [56]      -5.1816912      6.7529187      6.4824347      2.8952827
    [60]       4.1801629      14.334402      20.391626      24.140173
    [64]       26.333841      27.284252      27.120571      25.871937
    [68]       23.492783      19.859316      14.732156      7.6170731
    [72]      -2.3374350     -5.0794849     -3.4236898     -7.3937135
    [76]      -4.3200936      4.6166620      9.9133749      13.701008
    [80]       16.591173      18.671629      19.909891      20.279600
    [84]       19.765835      18.341866      15.937268      12.376597
    [88]       7.2169080    -0.46348310     -3.5146346     0.47629383
    [92]       1.7579737     0.72198856     -3.5949037     -9.8715630
    [96]       1.2668209      7.0704675      10.580386      12.819064
    [100]       14.153984      14.741405      14.636639      13.829457
    [104]       12.258962      9.8113031      6.2513065     0.89558560
    [108]      -7.7118549     -5.0368123     -1.1270880   0.0024691466
    [112]       3.4828007      8.7768621      12.673656      14.955706
    [116]       15.820790      15.361948      13.532366      10.084354
    [120]       4.3182402     -5.2791905     -5.4880586     -2.6596377
    [124]      -2.1417742     -1.5640703     0.21997932      5.0779300
    [128]       10.731668      15.172345      18.251602      20.108328
    [132]       20.839779      20.470903      18.945629      16.095245
    [136]       11.563009      4.8813672    -0.59140950    -0.76318461
    [140]      -4.3165669     -30.695635     -2.6395998      3.4956810
    [144]       7.3994908      10.518473      13.037916      14.892406
    [148]       16.013643      16.347420      15.831384      14.376234
    [152]       11.850973      8.0857134      3.0960853     -1.0106595
    [156]     -0.73763686    -0.16189453     -1.8737428   -0.055721022
    [160]       7.4871221      12.703861      15.992218      17.904486
    [164]       18.747532      18.729517      18.021236      16.745794
    [168]       14.900308      12.257475      8.2659855      1.6470509
    [172]      -12.086062     -9.3595963     -14.957879     -5.6148200
    [176]       3.6873934      8.3442860      10.995969      12.356825
    [180]       12.685770      12.049466      10.394464      7.5720930
    [184]       3.5669305     0.52355641      1.8682834      3.8355379
    [188]       4.9201212      5.3882313      5.4846387      5.1676369
    [192]       4.0657191      1.3523747     -3.1045120      2.4032447
    [196]       8.7158060      12.714765      15.248336      16.699175
    [200]       17.237803      16.933868      15.789416      13.739003
    [204]       10.628172      6.1937866     0.37897483     -4.2462683
    [208]      -6.2425971     -12.911494     -13.646169     -5.7116780
    [212]      -5.5904679     -4.7193093      4.3761239      10.108570
    [216]       13.425275      15.025225      15.152991      13.805028
    [220]       10.704288      4.8768163     -9.9800749     -4.3504691
    [224]     -0.17180073    0.055077158     0.28059879      2.3989317
    [228]       5.2915716      8.1012249      10.620377      12.644662
    [232]       13.956162      14.384461      13.785220      11.977449
    [236]       8.6380653      3.0229409     -7.3284531     -14.274491
    [240]      -12.265916     -19.958364     -9.9875393     -6.7714939
    [244]      -8.5016079     -8.8752203     -1.5891691      3.1515172
    [248]       6.0241070      7.8140464      8.8643913      9.2461796
    [252]       8.8635130      7.5095515      4.8064051    -0.16906200
    [256]      -9.7107744     -4.4817195     0.61617672      3.0663393
    [260]       4.6522632      6.1978512      7.9421959      9.6572514
    [264]       11.010800      11.765309      11.758587      10.833210
    [268]       8.7679844      5.2369766     0.47416839    -0.76684058
    [272]      0.95807964     0.74503118     -2.4040494     -7.2049384
    [276]     -0.31562436      5.4311762      9.2453375      11.937089
    [280]       13.774631      14.878958      15.352365      15.293713
    [284]       14.761345      13.723926      12.049287      9.5580893
    [288]       6.2141538      2.8705993      1.6200612      1.8392394
    [292]       1.7384757      1.0006859    -0.16788262    -0.91264516
    [296]      0.45234632      3.2672234      5.7374043      7.2740893
    [300]       7.7548728      7.0710096      4.9711237     0.80588323
    [304]      -7.1817651     -7.2439785     -1.9194211   -0.044347443
    [308]     0.043106440     -1.2920839     -4.7704778     -9.9197874
    [312]      -1.6356094      4.5663438      8.3648863      10.671931
    [316]       11.811920      11.892549      10.900623      8.7007198
    [320]       4.9866314    -0.21163569     -1.3019710      1.7476385
    [324]       3.3260643      3.3504162      2.0112889    -0.41305593
    [328]      -1.0190798      2.4791489      5.8055091      7.8121543
    [332]       8.5918245      8.2474813      6.8059320      4.2164803
    [336]      0.31156850     -5.3320327     -12.919809     -12.639960
    [340]      -8.6228142     -6.4385090     -5.1718397     -2.8351805
    [344]       1.4714426      5.7573256      9.0641232      11.329276
    [348]       12.633395      13.035048      12.547366      11.133571
    [352]       8.6993799      5.0777731   0.0093982024     -6.8854208
    [356]      -16.270063     -16.197372     -9.8733740     -6.8789716
    [360]      -5.7349343     -4.1980386    -0.55968904      3.4275367
    [364]       6.6424894      8.9897451      10.522611      11.252618
    [368]       11.136689      10.074855      7.8791566      4.1810212
    [372]      -1.5658153     -4.7538328    -0.59092838      2.4624364
    [376]       4.5236244      6.0727611      7.1126785      7.4537029
    [380]       6.8618298      5.0598426      1.7319678     -2.3181567
    [384]      -1.8909732     0.39107373      1.0781289     0.18592845
    [388]      -1.8781029     -4.0210280     -4.5001626     -3.3467109
    [392]      -1.2111174      1.3738223      3.6612813      5.4027996
    [396]       6.7832150      7.9876881      8.8972311      9.1851921
    [400]       8.5298662      6.6399851      3.2141190     -1.2878493
    [404]      -2.1048868   -0.090416491     0.91591281      1.2866741
    [408]       1.8173306      2.4819529      2.6804581      1.8987976
    [412]     -0.33557507     -4.7887535     -9.6613092     -5.3346863
    [416]      -2.2136512     -1.4721231     -2.4264684     -4.4253926
    [420]      -6.4662175     -8.5984268     -13.488669     -17.986622
    [424]      -8.3350887     -4.2394075     -2.8975139     -3.6163843
    [428]      -6.2617369     -7.3544846     -2.9066615     0.68466514
    [432]       2.4080448      2.4038661     0.48809657     -4.1945562
    [436]      -12.872518     -8.9053469     -6.8207607     -10.311525
    [440]      -29.009657     -9.2469797     -5.8260384     -6.7754078
    [444]      -6.3230629  0.00016011264      4.7029281      7.6739292
    [448]       9.4641781      10.325460      10.300631      9.2634535
    [452]       6.8555970      2.0821218     -8.7421694     -2.3550897
    [456]       2.9329429      4.8045483      4.9332118      3.8242431
    [460]       1.7959841    -0.41285023     -1.3725730    -0.89903361
    [464]     0.070152260      1.3373978      2.6534553      3.3988552
    [468]       3.0311475      1.0511976     -3.5534465     -14.082915
    [472]      -7.8735003     -3.0367358     -1.3423237    -0.70567793
    [476]    -0.015580005      1.0640484      2.2063286      3.0254710
    [480]       3.2715991      2.8053398      1.6605709     0.21177880
    [484]     -0.98731405     -2.1919234     -4.6965761     -11.038925
    [488]      -20.097052     -8.1016283     -4.7123308     -3.8420317
    [492]      -4.0677905     -4.6674299     -5.4942055     -6.2902083
    [496]      -5.9419999     -4.5467110     -3.6186197     -3.9335158
    [500]      -5.7718511     -9.4465046     -15.716907     -22.632278
    [504]      -13.652950     -7.0247245     -2.6795194   0.0035075149
    [508]       1.2659945      1.1334828    -0.63972342     -4.8630557
    [512]      -10.635669
  [Tag]         1281
  [frame_len]          320
[Record 9]
  [tot_power]       252308.05
  [re_spec_val]
    [0]       9.0677319      8.8986492      8.5268698      8.1068230
    [4]       7.4087701      5.8924699      2.9131992     -2.6647582
    [8]      -12.969643     -6.5736499     -2.6379817     -1.5492693
    [12]      -1.6571686     -1.1507949      1.2541169      4.3719134
    [16]       7.2229657      9.5176916      11.065151      11.699422
    [20]       11.347452      10.182704      9.0201902      9.4953756
    [24]       12.186816      15.526746      18.186457      19.889984
    [28]       21.343630      23.847578      27.126001      29.949690
    [32]       31.822821      32.679821      32.539230      31.403048
    [36]       29.227022      25.901531      21.249811      15.250114
    [40]       9.6944256      9.1419487      13.845177      19.852003
    [44]       25.008047      29.051649      32.019333      33.968098
    [48]       34.941772      34.962917      34.032688      32.143646
    [52]       29.332901      25.849976      22.402712      19.628006
    [56]       17.018389      13.921425      11.138767      11.924809
    [60]       15.576408      18.870327      21.073999      22.194725
    [64]       22.314844      21.497002      19.798069      17.348347
    [68]       14.510336      11.873716      9.5873098      7.1182113
    [72]       4.2481775      1.5515881    -0.42583260    0.060507312
    [76]       3.7361956      7.1828761      9.4925442      10.860703
    [80]       11.513317      11.585109      11.182261      10.466326
    [84]       9.5862865      8.4061995      6.3725085      2.6131902
    [88]      -3.1000245     -2.4508908   -0.091751315    -0.88158709
    [92]      -1.6020033      2.5689576      6.0286031      7.5275192
    [96]       7.4773464      6.4758162      5.6022210      5.5553184
    [100]       5.4528537      4.2516127      1.5897113   -0.063776463
    [104]       3.2915404      6.8021512      8.9818583      10.007051
    [108]       10.034256      9.3001623      8.8230400      10.403143
    [112]       13.289703      15.802450      17.466293      18.258320
    [116]       18.233973      17.482613      16.180407      14.677845
    [120]       13.442760      12.663101      12.095959      11.548079
    [124]       11.246688      11.754654      13.294401      15.348312
    [128]       17.290825      18.796165      19.776022      20.274914
    [132]       20.404797      20.274639      19.911594      19.235594
    [136]       18.111849      16.417593      14.075812      11.078990
    [140]       7.6432347      5.0845084      5.8056402      8.2577581
    [144]       10.249142      11.220075      10.968707      9.1964903
    [148]       5.3421960     0.87583679      4.1643605      7.2274857
    [152]       8.0261736      7.0798922      4.8212814      2.5255618
    [156]       3.0354047      5.7859163      8.4969320      10.478196
    [160]       11.579948      11.776390      11.081636      9.5486345
    [164]       7.3722763      5.1720319      4.0194650      4.2395248
    [168]       5.1789842      6.2451906      6.9745831      6.9767208
    [172]       5.9065566      3.2346191     -2.6054347     -8.1838207
    [176]       1.3549087      5.9355712      8.3171968      9.2999392
    [180]       9.0704851      7.5588031      4.4413743     -1.1849777
    [184]      -13.148782     -15.865589     -14.628647     -11.132511
    [188]      -3.1411514     0.72456008      2.1159763      1.7316724
    [192]      0.13607377     -1.4265370     -1.1575351      1.4340819
    [196]       5.1237178      8.3556423      10.484163      11.363334
    [200]       10.922473      9.0388441      5.7571039      3.2323885
    [204]       4.3910503      5.5615396      5.1180754      3.0566051
    [208]     -0.31180632     -3.7131538     -5.8772707     -8.5996904
    [212]      -3.2012508      4.9239335      10.535792      14.475560
    [216]       17.198387      18.933817      19.814598      19.927830
    [220]       19.341019      18.124136      16.385775      14.356281
    [224]       12.514238      11.407643      10.886454      10.077745
    [228]       8.0091572      3.2193460     -4.3648458      4.2352891
    [232]       8.7783289      10.809643      11.536586      11.582191
    [236]       11.363185      11.018994      10.397930      9.2342129
    [240]       7.2430282      3.9745147     -1.8367028     -10.718842
    [244]      -1.4397044      3.4213018      6.0828986      7.7402549
    [248]       8.8589916      9.5918589      9.8974075      9.6752787
    [252]       8.8977537      7.7173281      6.5231814      5.7662778
    [256]       5.6162963      5.9617572      6.5656152      7.2006364
    [260]       7.8639441      8.6797609      9.4858770      9.8149691
    [264]       9.2325335      7.5483818      5.4494371      5.3703980
    [268]       6.9326811      7.7844534      7.4340739      6.2687011
    [272]       5.2974787      5.3977914      6.2074981      7.2352419
    [276]       8.3605003      9.4404001      10.364057      11.180365
    [280]       11.961358      12.634834      13.041591      13.084641
    [284]       12.771190      12.159775      11.310930      10.326566
    [288]       9.4169064      8.7409220      8.1134844      7.1722708
    [292]       5.8461566      4.6477041      4.4120069      5.5378990
    [296]       7.8296986      10.490048      12.743313      14.257343
    [300]       14.958032      14.845834      13.920145      12.151194
    [304]       9.4733744      5.8346610      1.5350819     -1.7979344
    [308]      -2.5491261     -1.4474274     0.71252197      2.5411115
    [312]       2.9571309      1.0434022     -5.0413365    -0.80262202
    [316]       6.2209134      9.8354549      11.539972      11.827620
    [320]       10.847323      8.5860624      4.9464216   -0.044090796
    [324]      -5.2552104     -7.0465317     -4.6396995     -2.3895760
    [328]      -2.6004601     -6.0979548     -2.0995691      4.7093840
    [332]       8.6180458      10.645107      11.282764      10.761786
    [336]       9.2254105      6.8015909      3.5271695     -1.1146396
    [340]      -9.9776239     -14.854640     -7.2817898     -8.3509531
    [344]      -27.129829     -5.2875338     0.69417846      2.8872383
    [348]       2.6865346     0.56210566    -0.58689457      2.5543294
    [352]       5.4553537      6.9296670      7.2850575      6.8734412
    [356]       6.0294218      5.0713367      4.2623715      3.8293090
    [360]       4.0006852      4.7557120      5.6406627      6.1551042
    [364]       6.0783210      5.5687022      5.3372240      6.2741914
    [368]       8.0719414      9.7089710      10.580787      10.415430
    [372]       9.0680151      6.6926150      4.7805595      5.1274171
    [376]       5.8744826      5.9224358      6.3029137      7.8859344
    [380]       9.5744839      10.428499      10.229247      8.9839821
    [384]       6.7818556      3.9632931      1.4871691     0.11093844
    [388]      -1.2110684     -4.1055865     -10.509906     -8.5248013
    [392]      -1.6245852      2.2135944      4.6087389      6.2212391
    [396]       7.3337793      8.0380173      8.3229179      8.1374531
    [400]       7.4223952      6.1133876      4.1288538      1.3598922
    [404]      -2.2731352     -6.2200866     -7.4169359     -5.2506585
    [408]      -2.9646361     -1.5128552     -1.1197677     -1.9786288
    [412]      -4.1132674     -5.6628799     -3.3688688    -0.51012945
    [416]       1.1079643      1.5067756     0.82732987    -0.84390771
    [420]      -3.2267787     -4.8430557     -3.9741147     -2.4924109
    [424]      -2.0109522     -2.8873951     -5.1498771     -8.1994467
    [428]      -8.9969015     -5.8121238     -1.8156809      1.4244709
    [432]       3.5401385      4.4844871      4.3012161      3.1736622
    [436]       1.8399794      1.6980026      2.5813282      2.9543624
    [440]       1.8578917     -1.7122078     -9.5265665     -3.7280235
    [444]       1.6210570      3.9174454      4.6494322      4.6641493
    [448]       4.7040691      5.0529180      5.3929348      5.3416467
    [452]       4.6637573      3.1170149     0.37829497     -2.9444144
    [456]      -2.1424222     0.94571137      2.7555280      3.3625131
    [460]       3.4521058      3.8397589      4.7572451      5.7159300
    [464]       6.2855425      6.3170753      5.7801270      4.6365833
    [468]       2.7581027    -0.20040520     -5.0592766     -9.4728823
    [472]      -3.6801858     0.68373078      3.1527092      4.4448075
    [476]       4.9557662      4.9963465      4.8285689      4.5679889
    [480]       4.1240892      3.2921529      1.8540398    -0.45042646
    [484]      -4.1634245     -11.348875     -21.893232     -7.5412478
    [488]      -2.6430883     0.16417296      1.9287577      3.0192635
    [492]       3.6281981      3.8801274      3.8444164      3.5225010
    [496]       2.8471458      1.7018325   -0.054667789     -2.5303295
    [500]      -5.3851442     -6.4100633     -4.3348804     -1.7970256
    [504]      0.13754626      1.4242088      2.1065524      2.1767178
    [508]       1.5633638     0.10339154     -2.5660715     -7.3472810
    [512]      -13.502720
  [Tag]         1441
  [frame_len]          320
[Record 10]
  [tot_power]       191170.53
  [re_spec_val]
    [0]       17.837248      17.307899      15.677439      12.795450
    [4]       8.2858362     0.94785792     -17.437344     -4.3213873
    [8]     -0.10374026      1.8648953      3.5789785      5.5128164
    [12]       7.1442308      7.9882731      7.9943662      7.4982080
    [16]       7.0423536      6.7292733      5.9746642      4.2826815
    [20]       2.3558378      2.6857841      5.1055665      7.6512966
    [24]       8.4761848      2.7501326      9.3990488      20.908245
    [28]       27.224121      31.335945      33.972309      35.416489
    [32]       35.784698      35.097340      33.289845      30.181225
    [36]       25.358749      17.730291      1.9534506      1.2112247
    [40]      -4.4967122     -1.0157435      3.9057019     -8.8622284
    [44]       10.534284      18.937956      23.583067      26.300522
    [48]       27.638649      27.807051      26.868753      24.791685
    [52]       21.451775      16.634209      10.415247      5.8667769
    [56]       4.7847910      2.1736569     -5.9956026     -5.8397098
    [60]       3.4880931      7.3955469      9.0305395      8.7691689
    [64]       6.1097078     -1.6553475     -2.4954190      5.5545540
    [68]       8.1798019      8.3916197      6.8507986      3.6529837
    [72]      -1.4637969     -7.4380083     -5.6477871     -2.4311166
    [76]     -0.64131397     0.32032952     0.81095952      1.0726793
    [80]       1.3394583      1.6865643      1.9379239      1.8887566
    [84]       1.5215260      1.0238192     0.61351180     0.19188662
    [88]     -0.89271826     -4.0724387     -10.046601    -0.74575686
    [92]       5.6821966      9.4755745      11.691813      12.683037
    [96]       12.546060      11.221512      8.4839411      3.9779701
    [100]     -0.67440224     0.39072219      1.5705417     0.56907827
    [104]      -1.3808415     -1.2779793    -0.80005598     -3.4504175
    [108]      -2.5983908      5.8585629      11.001145      14.048568
    [112]       15.666231      16.130095      15.554380      13.977725
    [116]       11.431528      8.0928488      4.5797639      1.6209172
    [120]      -1.4502817     -6.5136089     -18.854300     -14.331095
    [124]      -5.8507543    -0.13335721      4.2057118      7.2736716
    [128]       9.2540703      10.315300      10.577981      10.116701
    [132]       8.9647026      7.1263261      4.6349697      1.7569547
    [136]     -0.68530548     -1.9850138     -2.7667482     -3.4651284
    [140]      -2.8952999    -0.25641304      2.9395025      5.6261325
    [144]       7.5263004      8.5665216      8.6951742      7.8394389
    [148]       5.9148226      3.0460775     0.62533540     0.68331259
    [152]       1.2603452     0.36538962     -3.0244761     -8.4555883
    [156]      -2.6941483      2.2263119      4.7209315      5.6823001
    [160]       5.4486876      4.1294603      1.7411816     -1.6348047
    [164]      -5.1078057     -5.5366983     -2.9289100    -0.27047521
    [168]       1.5719717      2.5059652      2.6232078      2.1317046
    [172]       1.3328742     0.50937581    -0.15648580    -0.40579590
    [176]     0.068349898      1.0897706      2.1393323      2.9167602
    [180]       3.3890827      3.6356559      3.7505360      3.7811217
    [184]       3.6605241      3.1794376      2.0281579    -0.16686310
    [188]      -3.7203014     -6.6409640     -3.9653466    -0.63537109
    [192]       1.5970088      3.1476851      4.4073696      5.5805244
    [196]       6.6677523      7.5349393      8.0259676      8.0183125
    [200]       7.4010739      5.9921565      3.3529043     -1.9143015
    [204]      -24.413795     -2.6259143      3.0995355      5.8610716
    [208]       7.3173552      8.0570021      8.3595963      8.3428841
    [212]       8.1166201      7.9516406      8.1563377      8.5940914
    [216]       8.6779604      7.7728133      5.1219387     -1.0785016
    [220]      -4.2857985      3.7106814      7.1751781      8.5276432
    [224]       8.8098927      8.9199572      9.5573988      10.528002
    [228]       11.201892      11.221063      10.489851      9.0486221
    [232]       7.0683842      4.9266138      3.1806617      2.1953497
    [236]       1.8623693      1.8564247      1.8437110      1.4763616
    [240]      0.41885000     -1.2070768     -1.1580141      1.8034176
    [244]       4.6936784      6.4967246      7.3323131      7.5070219
    [248]       7.3368945      6.9427891      6.0962443      4.3159728
    [252]      0.98150539     -3.5967131     -1.9844197      2.1024594
    [256]       4.6714091      6.3321390      7.5639548      8.5056591
    [260]       9.1091795      9.3462152      9.3516712      9.4296227
    [264]       9.7691059      10.124522      10.002789      8.9435234
    [268]       6.4530778      1.7836502     -1.5349673      3.8452976
    [272]       7.7534680      9.9925375      11.114690      11.323229
    [276]       10.766357      9.8531637      9.4034815      9.6963110
    [280]       9.8522310      8.9498672      6.2371073     0.68851674
    [284]      0.14710340      5.9949698      9.2316074      10.986347
    [288]       12.025531      12.789468      13.480677      14.076329
    [292]       14.410024      14.282952      13.528762      12.036010
    [296]       9.7623529      6.7029305      2.5077929     -5.0349913
    [300]      -3.4470615      4.3774376      8.2515659      10.143348
    [304]       10.674954      10.142318      8.8074751      7.1088891
    [308]       5.7804894      5.3357358      5.4063206      5.3383131
    [312]       4.8445129      4.3163557      5.0339260      7.3001394
    [316]       9.7951841      11.763329      13.062624      13.715097
    [320]       13.777526      13.342468      12.584364      11.809248
    [324]       11.394180      11.515116      11.970268      12.388448
    [328]       12.470963      12.070365      11.281425      10.714306
    [332]       11.373950      13.165825      15.052215      16.435951
    [336]       17.128822      17.065401      16.202093      14.513800
    [340]       12.129753      9.9206791      9.6830063      11.015342
    [344]       12.255230      12.936783      13.238111      13.591083
    [348]       14.340865      15.366245      16.271103      16.759193
    [352]       16.687532      15.990265      14.626057      12.538604
    [356]       9.5473604      4.9261656     -5.2377400     -2.7655141
    [360]       5.0080500      8.0635538      9.0600996      8.6468973
    [364]       7.2666039      5.6851330      4.6888514      3.7542744
    [368]       1.4612706     -2.6688673      1.5192063      7.7205939
    [372]       11.681588      14.114713      15.332059      15.388875
    [376]       14.146739      11.131447      4.6034312     -10.238681
    [380]       5.0763302      8.7000809      9.5017414      8.6650076
    [384]       6.5980320      3.5770040  -0.0058569419     -3.6094410
    [388]      -6.8319564     -7.7521901     -4.4578233     -1.1352800
    [392]      0.57415050     0.48199254     -1.3289977     -2.1888437
    [396]       1.1790975      4.3001709      5.9046464      6.2985015
    [400]       5.9287362      5.2949615      4.7008643      4.0351524
    [404]       3.1187179      2.2042198      2.0112910      2.8584230
    [408]       4.2374587      5.6001678      6.6316328      7.1268020
    [412]       6.9277234      5.9190083      4.1162186      2.0575945
    [416]       1.1139610      1.4171981      1.5376265     0.95533919
    [420]      0.30724654     0.62092149      1.5554628      2.0536695
    [424]       1.5620415    -0.29310933     -4.3786998     -15.449467
    [428]      -10.942948     -3.2663786     0.46221328      3.1596532
    [432]       5.4332943      7.2366319      8.4205055      8.9101057
    [436]       8.6896563      7.7769389      6.2591853      4.4140549
    [440]       2.7078142      1.1446660     -1.3415959     -7.1750622
    [444]      -11.507653     -1.8560805      2.3802934      4.4455724
    [448]       5.3371334      5.5225091      5.3095074      4.9933972
    [452]       4.8788409      5.0529170      5.2556753      5.1712813
    [456]       4.6713324      3.7672031      2.3962471     0.19133431
    [460]      -3.7760856     -12.554965     -12.996930     -5.7674856
    [464]      -3.4295807     -3.1245093     -3.9295995     -5.2332125
    [468]      -6.6137314     -7.7744985     -7.9752822     -6.6191401
    [472]      -4.7509670     -3.5638788     -3.6554413     -5.5436997
    [476]      -9.6193514     -9.3865623     -4.5374370     -1.9372878
    [480]      -1.3473467     -2.4483538     -5.0200181     -7.8247256
    [484]      -8.1476707     -7.4382739     -7.7617021     -9.2296171
    [488]      -11.564151     -14.543593     -14.319167     -9.6189928
    [492]      -6.0515604     -4.1179214     -3.4245183     -3.5753591
    [496]      -4.2157593     -5.1828623     -6.4651403     -7.4979129
    [500]      -6.9958096     -5.4753900     -4.3965073     -4.1956615
    [504]      -4.6907072     -5.3756280     -5.6281314     -5.2026863
    [508]      -4.4064369     -3.6824241     -3.2803094     -3.1825485
    [512]      -3.1914706
  [Tag]         1601
  [frame_len]          320
[Record 11]
  [tot_power]       101215.93
  [re_spec_val]
    [0]       13.872315      13.275832      11.413311      8.0152435
    [4]       2.3930099     -6.4088860     -6.3446112     -3.9525073
    [8]      -3.8650260     -3.1557853     0.67114204      5.8235197
    [12]       10.196362      13.371819      15.408826      16.434381
    [16]       16.593096      16.063684      15.042376      13.618494
    [20]       11.601152      8.4662218      3.4053617     -2.9235809
    [24]      0.74089146      9.9524021      17.547499      23.184008
    [28]       27.293549      30.175802      32.003609      32.870296
    [32]       32.815475      31.835003      29.879663      26.842714
    [36]       22.535606      16.689213      9.4368486      3.3574502
    [40]      -3.7354002     -4.7567935      6.9001837      12.387507
    [44]       16.101709      18.840578      20.807182      22.041027
    [48]       22.533602      22.256489      21.160448      19.161392
    [52]       16.111572      11.738609      5.5126042     -3.1578567
    [56]      -6.8386464     -4.0700974    -0.54563200      3.0361283
    [60]       5.8747301      8.0562668      9.8090792      11.242361
    [64]       12.335092      12.995572      13.118794      12.614076
    [68]       11.409984      9.4533081      6.7182808      3.2501559
    [72]     -0.70897222     -4.4788365     -6.9184923     -7.4973397
    [76]      -7.0659018     -6.5281229     -6.1290874     -5.8290372
    [80]      -5.7000074     -5.9584231     -6.7977657     -8.3030043
    [84]      -10.458626     -13.226527     -16.615917     -18.476440
    [88]      -14.239761     -9.3411245     -5.5520940     -2.6306684
    [92]     -0.40947518      1.1450983      2.0219946      2.2354710
    [96]       1.8817048      1.1977026     0.54293686     0.14369790
    [100]     -0.15456395    -0.68908882     -1.6962200     -3.2580326
    [104]      -5.2850609     -7.1937551     -7.3083162     -5.0564947
    [108]      -2.2647741    0.030222474      1.6163998      2.5036445
    [112]       2.7714989      2.5492780      2.0037239      1.2868882
    [116]      0.46168324    -0.50678569     -1.6735284     -3.0433633
    [120]      -4.5731711     -6.2261319     -7.9797597     -9.5606937
    [124]      -9.8371258     -7.9689364     -5.2458310     -2.7890296
    [128]     -0.91043717     0.32883739     0.92604852     0.92403620
    [132]      0.44536892    -0.27359530    -0.93843198     -1.4065229
    [136]      -1.8122551     -2.3997097     -3.3161044     -4.4807053
    [140]      -5.4099736     -5.3915982     -4.4739647     -3.3802366
    [144]      -2.5387459     -1.9975395     -1.6647139     -1.4869800
    [148]      -1.5374011     -1.9905843     -3.0538702     -4.9370193
    [152]      -7.8199120     -11.332205     -12.439952     -10.236105
    [156]      -8.1083860     -6.7564373     -6.0052953     -5.6293221
    [160]      -5.3663301     -4.9610000     -4.3642049     -3.7761316
    [164]      -3.4154510     -3.3568075     -3.5392952     -3.8379822
    [168]      -4.1354718     -4.3759465     -4.5999680     -4.9367871
    [172]      -5.5418553     -6.5321054     -7.9697247     -9.8968172
    [176]      -12.415039     -15.834111     -21.020014     -30.345509
    [180]      -29.381901     -24.871998     -21.496311     -16.275253
    [184]      -11.698280     -8.5433140     -6.6181850     -5.6689606
    [188]      -5.4579644     -5.7357602     -6.2520547     -6.8527727
    [192]      -7.5939240     -8.7432356     -10.739317     -14.347930
    [196]      -21.382792     -22.590046     -16.064184     -13.010384
    [200]      -11.039387     -8.9077177     -6.6662683     -4.9316387
    [204]      -4.0783658     -4.3030200     -5.8683472     -9.4315357
    [208]      -17.287180     -18.987543     -11.831467     -9.1556444
    [212]      -7.6704783     -5.7957311     -3.7303216     -2.4503720
    [216]      -2.5816424     -4.8094902     -11.447060     -15.174407
    [220]      -5.2774067     -1.5760334    -0.19159830    -0.22232792
    [224]      -1.3243663     -3.4568815     -7.0855341     -14.361924
    [228]      -23.472694     -11.336666     -7.3964977     -5.3232484
    [232]      -3.9008539     -2.9366374     -2.5713143     -2.7986441
    [236]      -3.2532272     -3.3500354     -2.9574387     -2.5518043
    [240]      -2.6063311     -3.4290659     -5.3740788     -9.2486219
    [244]      -18.746325     -18.235882     -9.5063391     -5.9965239
    [248]      -4.3116035     -3.6662583     -3.6648247     -3.9796469
    [252]      -4.3825979     -4.8856778     -5.6979170     -7.0668192
    [256]      -9.3320198     -13.464878     -23.334068     -15.240120
    [260]      -8.3927641     -4.9565558     -3.4143057     -3.5274069
    [264]      -5.7139153     -11.730673     -11.608097     -3.7139277
    [268]      0.27903998      2.3462603      3.1614668      3.0197799
    [272]       2.1554759     0.95216578    0.024324134    -0.27831581
    [276]     -0.34454370    -0.70012426     -1.4911182     -2.4175613
    [280]      -2.8673017     -2.6337740     -2.2879603     -2.4816949
    [284]      -3.6494229     -6.1760206     -10.263131     -12.558226
    [288]      -9.6478796     -6.8297229     -4.3844061     -1.9544597
    [292]     0.098049179      1.4365470      1.9741044      1.7392893
    [296]      0.75637430     -1.0600214     -4.0687399     -9.3262300
    [300]      -16.076582     -9.2312288     -4.7628145     -2.3633523
    [304]     -0.74556249     0.86769241      2.6116977      4.0576849
    [308]       4.7641048      4.4529014      2.9023314    -0.14552137
    [312]      -4.7462363     -8.7516947     -10.501106     -17.457155
    [316]      -13.635184     -4.5573020    -0.78048205     0.50741065
    [320]     -0.20618826     -2.9251945     -4.7658138    -0.76583570
    [324]       2.6478863      4.1184678      3.7572334      1.2570556
    [328]      -4.6646471     -10.203771     -4.4717202     -3.8820384
    [332]      -8.7647820     -10.552869     -3.4183342     -2.2597005
    [336]      -7.8437719     -5.6015806      4.5529170      9.4512262
    [340]       12.341461      14.074142      14.972121      15.107102
    [344]       14.374078      12.505988      9.0175190      3.5487406
    [348]       1.9915843      4.6513357      4.6100912     0.86067843
    [352]      -7.6077771     0.96359110      5.4077158      6.9276867
    [356]       6.8660088      5.8711190      4.4021449      2.8964484
    [360]       2.3713427      3.7535217      5.7647748      7.1227469
    [364]       7.4750314      6.7718878      5.0270228      2.3834093
    [368]     -0.44371340     -1.6327742    -0.42024121      1.6431870
    [372]       3.3084474      4.0063424      3.4168031      1.2555928
    [376]      -1.4259901      1.2392173      5.5768666      8.3697653
    [380]       9.6955109      9.6362772      7.9856496      3.8799129
    [384]      -7.2759819     -1.0305563      5.6182256      8.5979834
    [388]       10.095386      10.654753      10.329247      8.8797960
    [392]       5.6663299     -1.5294720     -10.991277     0.66997176
    [396]       2.9509242      1.2476871     -3.5377951      2.7607336
    [400]       8.3939371      11.368222      12.693661      12.762136
    [404]       11.690138      9.4059153      5.6060286    -0.45442724
    [408]      -10.536776     -18.871946     -9.0694275     -1.2049319
    [412]       3.1266458      4.9884758      4.9204011      4.0415821
    [416]       5.7716470      9.4780588      12.431278      14.313675
    [420]       15.319915      15.615438      15.288042      14.352329
    [424]       12.759254      10.406464      7.1641192      3.0876846
    [428]     -0.29275498    -0.26060328     0.78734124     0.63015354
    [432]      -1.5587881     -6.0024672     -2.9540751      2.3233430
    [436]       5.0545883      5.9526162      5.3980794      3.7690849
    [440]       2.5357451      3.8891592      6.3286309      8.1994314
    [444]       9.2705421      9.6375761      9.4354877      8.8160543
    [448]       7.9372416      6.9101162      5.7179866      4.1726408
    [452]       1.9550788     -1.1223776     -3.4838438     -1.9664692
    [456]      0.42100692      1.7705833      2.0665085      1.3979747
    [460]     -0.32788345     -3.4621508     -8.8709068     -18.422441
    [464]      -15.191353     -9.8838692     -6.5392070     -4.2996612
    [468]      -3.2928402     -3.6483877     -5.4112582     -8.0444946
    [472]      -8.9463949     -7.7518926     -7.4606361     -9.2674036
    [476]      -14.317651     -17.565283     -10.038412     -5.8824100
    [480]      -3.8956430     -3.6830044     -5.6600757     -12.185614
    [484]      -17.431517     -5.8036299     -1.5805322     0.37814805
    [488]       1.0527066     0.79890126    -0.22212169     -1.8671553
    [492]      -3.8325624     -5.5654020     -6.7057748     -7.7009325
    [496]      -9.5977716     -14.468524     -27.792074     -10.842376
    [500]      -5.2852559     -2.5662105     -1.4784480     -1.6351341
    [504]      -2.8851764     -5.2336760     -9.0587654     -16.510290
    [508]      -22.057596     -10.936657     -6.5528159     -4.4322352
    [512]      -3.7809010
  [Tag]         1761
  [frame_len]          320
[Record 12]
  [tot_power]       20467.385
  [re_spec_val]
    [0]       12.428302      11.895670      10.257873      7.3708243
    [4]       2.8739276     -4.2826047     -19.492292     -15.007115
    [8]      -13.223066     -14.398517     -9.2841978     -2.6479907
    [12]       2.7546642      6.9757037      10.090706      12.166687
    [16]       13.248884      13.337847      12.360951      10.107101
    [20]       6.0161924     -1.8712286     -15.564108     -4.8431001
    [24]      -4.6880059      2.5036421      9.7939491      14.449648
    [28]       17.352108      18.940134      19.440981      19.027554
    [32]       17.932108      16.511868      15.076916      13.519881
    [36]       11.392879      8.3976545      4.9083638      1.9855126
    [40]     -0.98805946     -6.2652941     -8.5838652     -5.7237535
    [44]      -8.3169279     -8.3351688     0.90552235      5.3363709
    [48]       7.1618266      7.0351095      4.9372735    0.075185969
    [52]      -11.008995     -6.6448874     -2.7297621     -3.0797067
    [56]      -6.5180764     -15.184525     -19.759897     -9.5633163
    [60]      -5.6359248     -3.3213289     -1.5021101     0.37668842
    [64]       2.1501384      3.3289008      3.5904613      2.7721910
    [68]      0.72668558     -2.8284998     -8.6699619     -20.585794
    [72]      -22.211699     -16.594419     -16.586580     -19.094429
    [76]      -23.489779     -27.639984     -28.241247     -29.045382
    [80]      -32.312531     -40.787472     -36.153519     -28.065025
    [84]      -24.075233     -22.289249     -22.213352     -23.713972
    [88]      -27.060404     -34.644020     -36.775581     -25.901842
    [92]      -21.150654     -18.709095     -17.851500     -18.353184
    [96]      -20.209976     -23.789589     -31.202488     -34.813766
    [100]      -24.433880     -19.793921     -17.175337     -15.696626
    [104]      -14.914475     -14.556897     -14.570053     -15.122630
    [108]      -16.499481     -19.037010     -23.146263     -28.580452
    [112]      -29.045111     -25.614414     -22.941551     -20.992088
    [116]      -19.725197     -19.138008     -19.146051     -19.643888
    [120]      -20.613832     -22.206861     -24.790731     -29.122875
    [124]      -36.282227     -34.053547     -28.425512     -24.508148
    [128]      -21.031450     -17.975893     -15.618279     -14.093668
    [132]      -13.426999     -13.605347     -14.606804     -16.407749
    [136]      -18.996212     -22.432228     -26.991447     -33.022400
    [140]      -36.315342     -34.629452     -34.968285     -34.590874
    [144]      -28.982393     -24.147478     -21.023188     -19.274204
    [148]      -18.760721     -19.559116     -22.049725     -27.438784
    [152]      -35.778965     -27.890484     -24.191435     -23.128191
    [156]      -23.485620     -24.470652     -24.948393     -23.782524
    [160]      -21.566343     -19.610096     -18.526392     -18.512249
    [164]      -19.657196     -21.956608     -24.624386     -24.743120
    [168]      -22.380793     -20.040863     -18.152954     -16.612413
    [172]      -15.408525     -14.645539     -14.454762     -14.911046
    [176]      -15.982267     -17.573692     -19.759987     -22.467440
    [180]      -21.743057     -17.306406     -13.973920     -12.193864
    [184]      -11.729056     -12.395688     -14.020078     -16.268425
    [188]      -18.296000     -18.872681     -17.999514     -16.683077
    [192]      -15.572394     -15.098415     -15.801348     -18.701429
    [196]      -26.675770     -21.393578     -14.775368     -11.892922
    [200]      -11.107321     -12.023292     -14.681474     -19.462984
    [204]      -26.887533     -32.751690     -32.419571     -27.363621
    [208]      -22.737051     -20.049408     -17.868988     -14.940416
    [212]      -11.714002     -9.0419254     -7.2006636     -6.1646767
    [216]      -5.7908425     -5.8723197     -6.2417660     -6.9421210
    [220]      -8.2759790     -10.717542     -14.915192     -20.875950
    [224]      -20.640200     -17.889708     -17.211145     -17.656864
    [228]      -17.748327     -15.898622     -12.300002     -8.4879370
    [232]      -5.3078837     -2.9780769     -1.5165604    -0.89133394
    [236]      -1.0366918     -1.8115835     -2.9557815     -4.2059751
    [240]      -5.6393905     -7.7773900     -11.219337     -14.670545
    [244]      -12.656296     -9.4355125     -7.3478932     -6.1101246
    [248]      -5.5846925     -5.8311410     -6.9147439     -8.7483025
    [252]      -10.951191     -13.031337     -14.874425     -15.361084
    [256]      -12.922780     -10.126546     -8.5558376     -8.3951464
    [260]      -9.6241035     -11.986758     -13.511413     -11.468980
    [264]      -8.4908495     -6.3190365     -5.2255931     -5.3529000
    [268]      -6.8980479     -9.9223747     -12.501334     -11.359913
    [272]      -10.229241     -11.203335     -15.192151     -27.891026
    [276]      -21.360044     -15.556608     -14.327735     -15.606497
    [280]      -19.527260     -26.617619     -23.917839     -20.597530
    [284]      -21.126860     -25.607668     -24.736660     -18.624615
    [288]      -16.270279     -17.045673     -17.890448     -11.539303
    [292]      -6.1249537     -2.7051368    -0.65665203     0.43866092
    [296]      0.89976740     0.96605337     0.71551061   0.0090384688
    [300]      -1.4745045     -4.2560220     -9.0858231     -10.978291
    [304]      -5.6124988     -2.2157154    -0.72543406    -0.82492012
    [308]      -2.6752708     -7.1931324     -18.319775     -12.122128
    [312]      -6.9636040     -4.2468824    -0.96961522      2.6073306
    [316]       5.4614983      7.2960649      8.0835047      7.7959156
    [320]       6.3775973      4.0140996      2.2769272      2.9512866
    [324]       3.8516452      3.2784944     0.61660248     -5.0627193
    [328]      -10.338623     -4.4383864      1.0855992      6.3176212
    [332]       10.603423      13.723134      15.740131      16.719421
    [336]       16.671415      15.544464      13.200191      9.2887259
    [340]       2.7122841     -1.2536705      6.4959650      11.018435
    [344]       13.586904      14.740424      14.618472      13.170758
    [348]       10.117038      4.7583714     -1.0836036      2.5385382
    [352]       5.0379095      5.4059100      4.4322610      2.6078513
    [356]      0.33865362     -2.0288713     -4.4322858     -7.6327958
    [360]      -13.345895     -10.143332     -3.4644556     0.13371339
    [364]       1.8100804      1.9798001     0.67168891     -2.4499485
    [368]      -7.9570465     -8.4369764     -3.4497874    -0.69181991
    [372]      0.60427094      1.3401661      2.3855274      3.9390838
    [376]       5.4174814      6.3397932      6.5613880      6.0933437
    [380]       5.0960369      4.5514612      6.3037577      9.3009701
    [384]       11.669524      12.906912      12.957742      11.897631
    [388]       10.259214      9.6412067      10.575764      11.385122
    [392]       11.185417      10.001224      8.5433607      7.8133025
    [396]       7.1186051      4.2211475     -1.1892102      7.8983264
    [400]       13.741537      16.863455      18.261820      18.255375
    [404]       16.920570      14.347754      11.637500      11.709201
    [408]       13.364033      14.287955      14.133532      12.936046
    [412]       10.688528      7.2712736      3.3800163      6.1762333
    [416]       11.559333      15.124103      17.012129      17.384438
    [420]       16.194035      13.124038      7.4156675      1.5355209
    [424]       3.9958913      3.6752746     -2.4200587     -9.5784655
    [428]       2.0171509      5.0679340      6.0615911      7.4089427
    [432]       9.9673433      12.576386      14.436028      15.315401
    [436]       15.095222      13.600738      10.611473      7.0673227
    [440]       7.8823810      10.518456      11.761081      11.610579
    [444]       10.333428      8.2578878      5.9787188      4.2276030
    [448]       3.3387792      3.5725338      4.6540947      5.3409867
    [452]       4.5643134      1.1516466     -9.4855909     -2.8965826
    [456]       3.0432441      4.4279737      2.3423431     -8.0376987
    [460]      0.24912791      8.1422215      11.972451      14.027623
    [464]       14.942334      15.003129      14.414094      13.421143
    [468]       12.350412      11.422602      10.462958      8.9732304
    [472]       6.3533401      1.8801297     -2.5588870      1.3880594
    [476]       5.1499543      7.3610325      8.6587620      9.3005409
    [480]       9.3166723      8.6821747      7.5183988      6.4210825
    [484]       6.2946796      6.8986335      7.1477327      6.3938956
    [488]       4.3622909      1.1025302     -1.9208181     -2.7403460
    [492]      -4.2197814     -11.261498     -11.402618     -1.1402482
    [496]       2.9642036      4.8193645      5.2243738      4.4235620
    [500]       2.4213693     -1.0019792     -6.4927287     -15.090659
    [504]      -14.599745     -11.557185     -11.857087     -15.338297
    [508]      -18.322510     -11.021949     -6.3662148     -3.9965515
    [512]      -3.2604709
  [Tag]         1921
  [frame_len]          320
[Record 13]
  [tot_power]       89185.922
  [re_spec_val]
    [0]       12.839854      12.307597      10.666718      7.7654452
    [4]       3.2673049     -3.5280845     -12.292317     -12.975444
    [8]      -13.391476     -14.858775     -12.835688     -8.4959068
    [12]      -4.4729223     -1.6389815    -0.16699752    -0.10006228
    [16]      -1.5515915     -4.4459529     -5.9010282     -3.3111005
    [20]      -1.2908365     -1.1218475     -2.8747697     -6.4696131
    [24]      -9.9889584     -8.8205090     -2.4327466      3.9514337
    [28]       8.6066704      11.760672      13.707150      14.644273
    [32]       14.705983      13.992826      12.588404      10.557160
    [36]       7.9202485      4.6271558     0.58520359     -4.1096082
    [40]      -8.5623579     -11.105868     -10.210544     -6.1632924
    [44]      -1.6926433      2.0937159      4.9864669      6.9453011
    [48]       7.9639125      8.0295238      7.0970435      5.0614381
    [52]       1.7103885     -3.3570857     -10.346173     -13.489462
    [56]      -12.060660     -11.849021     -12.418236     -14.365781
    [60]      -21.914501     -17.462147     -8.0965872     -3.4839523
    [64]     -0.94589949     0.19531900     0.21136758    -0.74947280
    [68]      -2.5588679     -5.0314884     -7.7981052     -10.005949
    [72]      -10.537046     -9.8290100     -9.2123384     -9.2724123
    [76]      -10.052393     -11.330293     -12.649216     -13.495766
    [80]      -13.802401     -13.911090     -14.002872     -14.020521
    [84]      -13.988992     -14.077578     -14.305257     -14.418845
    [88]      -14.270843     -14.170607     -14.553570     -15.580990
    [92]      -16.932430     -17.697395     -17.240751     -16.021933
    [96]      -14.586628     -13.156819     -11.808406     -10.548697
    [100]      -9.4018888     -8.4603577     -7.8343058     -7.5854630
    [104]      -7.7034392     -8.0845718     -8.4744558     -8.4946470
    [108]      -7.9778914     -7.1986432     -6.5270038     -6.1306767
    [112]      -5.9932585     -6.0169239     -6.1100874     -6.2398033
    [116]      -6.4275212     -6.6932206     -6.9953303     -7.2317967
    [120]      -7.3315034     -7.3388190     -7.3691583     -7.5076699
    [124]      -7.7668967     -8.0819139     -8.3099356     -8.3071451
    [128]      -8.1000404     -7.9069920     -7.9466271     -8.3002825
    [132]      -8.9168777     -9.6835632     -10.486633     -11.211565
    [136]      -11.751020     -12.113425     -12.462296     -12.941601
    [140]      -13.484994     -13.783323     -13.501282     -12.637098
    [144]      -11.533716     -10.564029     -9.9493876     -9.7471085
    [148]      -9.8696070     -10.091473     -10.084834     -9.5772200
    [152]      -8.5847044     -7.3993516     -6.3271356     -5.5296192
    [156]      -5.0294781     -4.7690325     -4.6706505     -4.6838150
    [160]      -4.8025718     -5.0487633     -5.4339991     -5.9188905
    [164]      -6.4043808     -6.7998343     -7.1245861     -7.4992676
    [168]      -8.0205364     -8.6609249     -9.2590179     -9.6159906
    [172]      -9.6841240     -9.6651039     -9.8815918     -10.591424
    [176]      -11.818457     -12.959234     -12.663934     -10.928116
    [180]      -9.0572128     -7.6501722     -6.7962265     -6.4817944
    [184]      -6.6861553     -7.3645053     -8.4011860     -9.5740814
    [188]      -10.596834     -11.272505     -11.605144     -11.728271
    [192]      -11.789373     -11.926456     -12.306221     -13.049615
    [196]      -13.710661     -12.748423     -10.146227     -7.6554632
    [200]      -5.9986486     -5.2336984     -5.2676024     -5.9568086
    [204]      -7.0913858     -8.3711414     -9.4541311     -10.089744
    [208]      -10.146817     -9.5099020     -8.2172413     -6.6432476
    [212]      -5.2348137     -4.2453475     -3.7377052     -3.6650441
    [216]      -3.9383776     -4.4907703     -5.3443418     -6.6629739
    [220]      -8.8006907     -12.478718     -19.784182     -24.038076
    [224]      -15.794408     -12.635281     -11.499319     -11.315149
    [228]      -11.276070     -10.894499     -10.600876     -11.407238
    [232]      -14.801489     -28.810062     -17.093557     -10.518785
    [236]      -7.8918762     -6.7827201     -5.7644000     -4.1215734
    [240]      -2.4417105     -1.3827955     -1.1257304     -1.5926796
    [244]      -2.5736399     -3.7734153     -4.9507604     -6.1646647
    [248]      -7.8067751     -9.9811335     -10.195167     -6.9989119
    [252]      -4.1624660     -2.8557718     -3.2840700     -6.0948424
    [256]      -14.933118     -14.065882     -5.2184558     -1.9722713
    [260]     -0.86909723     -1.0721681     -2.1069200     -3.6654673
    [264]      -5.9690456     -10.112564     -13.148672     -6.8477740
    [268]      -2.6876557    -0.74056864    -0.40366930     -1.5015968
    [272]      -4.1702776     -9.1318226     -19.498150     -15.130025
    [276]      -8.6764126     -5.0673938     -2.4890070    -0.54035980
    [280]      0.89728272      1.9060813      2.5697758      2.9697809
    [284]       3.1867189      3.3163819      3.4856956      3.8381171
    [288]       4.4702435      5.3572478      6.3430400      7.2073250
    [292]       7.7421579      7.7930303      7.2867613      6.3165965
    [296]       5.3510537      5.1776319      5.8433805      6.4887013
    [300]       6.4208064      5.2204189      2.3610473     -2.8688097
    [304]      -2.9502568      2.5543740      5.8055234      7.5764642
    [308]       8.4882669      8.9171181      9.1156960      9.2351589
    [312]       9.3525343      9.5567369      10.022667      10.889757
    [316]       12.033961      13.166178      14.111672      14.864878
    [320]       15.451479      15.807087      15.832754      15.601728
    [324]       15.549857      16.192179      17.378366      18.546247
    [328]       19.387329      19.847223      19.910154      19.454681
    [332]       18.193697      15.617475      11.138034      10.090779
    [336]       15.162189      18.551079      20.477043      21.573027
    [340]       22.235096      22.636349      22.752193      22.495253
    [344]       21.882097      21.145426      20.660873      20.582716
    [348]       20.733685      20.999617      21.456081      22.081160
    [352]       22.645746      22.929867      22.852489      22.412975
    [356]       21.580172      20.237865      18.231995      15.543496
    [360]       12.743123      11.150809      10.656322      9.8210192
    [364]       8.0066414      5.2895722      2.4761734      1.4026096
    [368]       3.0831552      5.9631534      8.4895563      10.136141
    [372]       10.858219      10.809916      10.321660      9.8578453
    [376]       9.7111664      9.7872372      9.9040651      10.014942
    [380]       10.066415      9.8457365      9.0214672      7.2823029
    [384]       4.8904719      4.5664735      7.0886812      9.1982603
    [388]       10.091340      9.9651089      9.3216972      8.9887905
    [392]       9.5053425      10.454741      11.168388      11.207108
    [396]       10.208934      7.6250596      2.0300999     -2.2628462
    [400]       6.9117823      12.453212      16.415123      19.454187
    [404]       21.733688      23.320095      24.261585      24.593782
    [408]       24.335281      23.484276      22.013075      19.842287
    [412]       16.732433      11.885387      4.2388506      10.446097
    [416]       16.297211      19.708706      21.821636      23.078684
    [420]       23.688694      23.737049      23.214853      22.039408
    [424]       20.072065      17.131618      13.146041      9.6522255
    [428]       10.468753      12.674711      13.906111      13.921867
    [432]       12.780629      11.958439      14.657318      18.501329
    [436]       21.379364      23.180462      24.047052      24.097538
    [440]       23.442812      22.241766      20.758055      19.344976
    [444]       18.292788      17.714178      17.598063      17.806583
    [448]       18.067467      18.078285      17.554832      16.162695
    [452]       13.311713      7.2178712     -8.9887848      8.7065973
    [456]       13.327563      15.269219      15.779992      15.368833
    [460]       14.632017      14.551534      15.578834      16.946638
    [464]       17.934669      18.314028      18.092880      17.367727
    [468]       16.248449      14.767026      12.799904      10.089532
    [472]       6.4691868      3.2833960      4.3640556      7.3679981
    [476]       9.9133930      11.764287      12.890450      13.272042
    [480]       12.919694      11.888864      10.325823      8.5687771
    [484]       7.1567903      6.3835292      5.9173694      5.2807770
    [488]       4.2770104      3.0136685      1.7874352     0.76039892
    [492]     -0.15212508    -0.38825569      1.3386248      4.0875063
    [496]       6.2769694      7.4337678      7.5292773      6.7478442
    [500]       5.7981191      5.9399414      7.1288466      8.1861086
    [504]       8.5877237      8.3541927      7.7040319      6.8953543
    [508]       6.0889053      5.3066196      4.5574431      3.9646578
    [512]       3.7318618
  [Tag]         2081
  [frame_len]          320
[Record 14]
  [tot_power]       70441.180
  [re_spec_val]
    [0]       12.315000      11.735875      9.9451542      6.7527065
    [4]       1.6966523     -6.4157367     -15.516750     -12.511339
    [8]      -13.199253     -15.761006     -16.903059     -17.261322
    [12]      -18.707035     -18.244526     -12.467838     -7.3021374
    [16]      -3.6905315     -1.2894536     0.17236474     0.87482822
    [20]      0.92927325     0.38471448    -0.76140225     -2.5502191
    [24]      -5.0152550     -6.7526741     -3.0704825      2.1966972
    [28]       6.2542224      9.1106958      10.957109      11.922488
    [32]       12.079386      11.449818      9.9971886      7.5982094
    [36]       3.9690504     -1.5653819     -10.995358     -16.365572
    [40]      -12.583750     -13.497161     -12.297927     -9.0900879
    [44]      -7.8306508     -7.9683657     -5.9594655     -1.8466290
    [48]       1.3758490      3.2472951      3.8981051      3.4219892
    [52]       1.8274001    -0.95794517     -5.0789428     -10.693686
    [56]      -17.793636     -26.909695     -25.638464     -19.284739
    [60]      -16.254866     -13.851376     -10.740636     -7.6883135
    [64]      -5.4683681     -4.2296748     -3.9082942     -4.3988233
    [68]      -5.5791717     -7.3012462     -9.3871708     -11.639877
    [72]      -13.820778     -15.565027     -16.507671     -16.735878
    [76]      -16.634600     -16.273001     -15.378310     -13.894506
    [80]      -12.230927     -10.843955     -9.9780655     -9.6995802
    [84]      -9.9579515     -10.612806     -11.461312     -12.309916
    [88]      -13.075485     -13.812024     -14.598390     -15.365566
    [92]      -15.822027     -15.671245     -14.934393     -13.871856
    [96]      -12.761158     -11.845039     -11.319933     -11.323950
    [100]      -11.936611     -13.154012     -14.770521     -16.170313
    [104]      -16.640821     -16.408075     -16.189571     -16.174578
    [108]      -15.992501     -15.333781     -14.557795     -14.233665
    [112]      -14.575807     -15.267326     -15.445464     -14.681160
    [116]      -13.630090     -12.861078     -12.479318     -12.454513
    [120]      -12.823888     -13.674619     -14.984545     -16.442064
    [124]      -17.562487     -18.199705     -18.164104     -16.789162
    [128]      -14.572350     -12.660114     -11.475244     -10.958241
    [132]      -10.867512     -10.920380     -10.945876     -10.969828
    [136]      -11.118725     -11.471002     -11.985975     -12.508965
    [140]      -12.840288     -12.831619     -12.453320     -11.843344
    [144]      -11.278789     -11.033978     -11.264009     -11.957986
    [148]      -12.895378     -13.621246     -13.634958     -12.831933
    [152]      -11.639350     -10.639466     -10.257150     -10.718835
    [156]      -12.061741     -13.993948     -15.702917     -16.418119
    [160]      -15.825488     -13.751327     -11.240249     -9.3771906
    [164]      -8.5142536     -8.7207212     -10.063255     -12.720347
    [168]      -17.079178     -23.652308     -26.951851     -21.357431
    [172]      -16.171461     -12.363777     -9.9246712     -8.6751442
    [176]      -8.4165220     -8.9502077     -10.022493     -11.200587
    [180]      -11.917308     -12.135477     -12.611765     -14.234770
    [184]      -17.994413     -24.815235     -21.533154     -16.892330
    [188]      -15.007977     -14.653985     -15.071103     -15.429739
    [192]      -15.008405     -14.005315     -13.220801     -13.329003
    [196]      -15.015201     -19.962549     -40.636417     -18.319572
    [200]      -13.211408     -11.022420     -10.145433     -9.6891823
    [204]      -9.1406689     -8.5351877     -7.9521213     -7.1804805
    [208]      -6.2441587     -5.6925306     -6.1566210     -8.2229834
    [212]      -12.852791     -20.444202     -16.263994     -13.303309
    [216]      -13.458113     -15.322987     -16.784657     -16.324968
    [220]      -14.678021     -12.215454     -9.8755178     -8.3790369
    [224]      -7.7539463     -7.6058121     -7.3477135     -6.6960568
    [228]      -5.9334297     -5.4992962     -5.7462158     -7.0601363
    [232]      -10.213790     -18.358301     -20.365780     -10.194473
    [236]      -6.2521310     -4.3984852     -3.8468759     -4.3453140
    [240]      -5.7330399     -7.4091439     -7.6651640     -6.1199384
    [244]      -4.5706124     -3.8591635     -4.0325651     -4.7982321
    [248]      -5.5607176     -5.9155397     -6.2947941     -7.2281518
    [252]      -7.7841463     -5.7746530     -2.7834332    -0.69456518
    [256]      0.14077920    -0.36552757     -2.3981624     -5.6089859
    [260]      -5.1223974     -1.2438759      1.4115000      2.5953691
    [264]       2.4388459     0.77456325     -3.2049267     -11.165318
    [268]      -5.2695708     0.26554897      2.9377019      4.0982490
    [272]       4.2976284      3.8930886      3.1991863      2.4407616
    [276]       1.5963297     0.31407881     -2.0905082     -7.0956116
    [280]      -25.361128     -10.045955     -4.8968234     -3.0294530
    [284]      -2.0049772    -0.72694349     0.69374686      1.8663069
    [288]       2.8822706      4.0247521      5.2197547      6.0089455
    [292]       5.8691568      4.2141843    -0.16803384     -14.962526
    [296]      -5.3874855    -0.76774848     -1.7320875     -7.6148357
    [300]      -1.8628153      3.9240596      6.5519323      7.5414166
    [304]       7.6609712      7.2818766      6.5186934      5.9554534
    [308]       6.7084403      8.1437092      8.8577394      8.3876953
    [312]       6.9855170      5.6802464      5.6086226      6.7531056
    [316]       8.8811731      11.416104      13.682278      15.513951
    [320]       17.041054      18.374695      19.505821      20.384745
    [324]       20.989420      21.287165      21.164450      20.432924
    [328]       18.977692      17.293991      17.140522      18.674448
    [332]       19.999136      20.391647      19.889772      18.753542
    [336]       17.298309      15.690302      13.858239      11.745919
    [340]       10.107285      11.541919      15.243490      18.420202
    [344]       20.446941      21.347300      21.210419      20.135740
    [348]       18.344097      16.636492      16.733067      18.715124
    [352]       20.899069      22.495146      23.376001      23.670568
    [356]       23.694435      23.776199      23.875509      23.555431
    [360]       22.304653      19.559277      14.121190      2.4168069
    [364]       11.390982      16.132053      18.180403      18.993887
    [368]       18.964417      18.163809      16.583605      14.264039
    [372]       11.452188      8.8503990      7.3431745      6.8227806
    [376]       6.5531869      6.1982770      5.7857857      5.4019270
    [380]       4.9353013      4.0382605      2.3584735     0.15192057
    [384]     -0.42067853      1.3887320      3.2500684      4.7216930
    [388]       6.3364224      8.2501974      10.102745      11.550502
    [392]       12.435500      12.721951      12.472287      11.865806
    [396]       11.173184      10.621211      10.295881      10.248124
    [400]       10.614251      11.558805      12.985770      14.392351
    [404]       15.194979      14.952702      13.303662      10.143331
    [408]       8.3836994      11.033081      13.279119      14.336395
    [412]       15.119922      16.294487      17.476570      18.017427
    [416]       17.623096      16.304224      14.491798      13.301219
    [420]       13.326023      13.533088      12.924729      10.852386
    [424]       6.7690406      7.3234510      13.263005      17.140993
    [428]       19.343513      20.287443      20.131695      18.903957
    [432]       16.571772      13.126942      8.6333904      2.2504096
    [436]      -3.0574319      7.5239339      13.034239      16.363884
    [440]       18.586329      20.194036      21.399904      22.253508
    [444]       22.766821      22.989754      22.995050      22.808048
    [448]       22.366405      21.553898      20.250265      18.331148
    [452]       15.653221      12.460510      11.477749      13.966984
    [456]       16.324081      17.558937      17.720600      16.892920
    [460]       15.104446      12.430235      9.5912590      8.8818150
    [464]       10.434534      12.023669      12.894708      12.896664
    [468]       11.893337      9.7022858      6.3722501      4.0144267
    [472]       5.3243914      7.0571294      7.8617616      7.9549174
    [476]       7.5712128      6.7227817      5.2724209      3.0009978
    [480]     -0.58759665     -6.6766224     -6.8230357    -0.49419051
    [484]       2.8899860      4.4360518      4.7107601      3.9829175
    [488]       2.3976421    0.011351248     -3.2874525     -8.2500935
    [492]      -19.827631     -12.306393     -4.4837532    -0.12002307
    [496]       2.7796881      4.6797371      5.8207674      6.5701499
    [500]       7.4129143      8.4533119      9.2230358      9.1753006
    [504]       7.8781419      4.7466784     -2.0018449     -18.346941
    [508]      -2.4108539     0.57302922     0.43414247     -1.5586056
    [512]      -3.2337770
  [Tag]         2241
  [frame_len]          320
[Record 15]
  [tot_power]       76763.148
  [re_spec_val]
    [0]       13.760542      13.133227      11.151093      7.4177790
    [4]      0.67854261     -10.670493     -3.4324927     -1.1192526
    [8]      -1.1628523     -1.4669651     -1.5072399     -1.7703246
    [12]      -2.2248139     -2.7471473     -3.9652011     -5.7341323
    [16]      -4.2683434    -0.96241939     0.86148190     0.90093869
    [20]     -0.86510491     -4.9827509     -14.795773     -16.819620
    [24]      -9.5726871     -9.5938034     -13.101159     -7.6640682
    [28]      -2.2864897     0.34846067      1.3131206      1.3013209
    [32]      0.80622107     0.22450455     0.24814224      1.2828009
    [36]       2.3368309      2.2943962     0.45486328     -3.9585419
    [40]      -7.1014776     -2.2264626     0.58368111      1.2692758
    [44]      0.63176948   -0.029795777      1.0711484      3.2130497
    [48]       4.8459153      5.4755239      4.9633603      3.1280313
    [52]     -0.45236990     -6.7763500     -12.414028     -7.9328794
    [56]      -6.0499411     -6.1252570     -7.2804136     -9.3209028
    [60]      -11.682775     -10.904996     -7.8487563     -5.8540421
    [64]      -5.3685451     -6.3847423     -9.0806599     -13.791157
    [68]      -17.627331     -15.284311     -13.701896     -13.415743
    [72]      -12.818097     -11.483734     -10.458039     -10.315479
    [76]      -11.041982     -12.351029     -13.785270     -14.853823
    [80]      -15.275632     -15.110051     -14.581358     -13.851029
    [84]      -13.049965     -12.344813     -11.861363     -11.645777
    [88]      -11.740717     -12.253022     -13.305162     -14.847263
    [92]      -16.304419     -16.720234     -16.285477     -15.984703
    [96]      -16.117842     -16.279762     -16.017218     -15.627260
    [100]      -15.815022     -17.120710     -20.046078     -25.640587
    [104]      -34.106316     -26.168427     -20.603647     -16.970974
    [108]      -14.648659     -13.573162     -13.719960     -14.893790
    [112]      -16.136984     -15.796340     -14.418603     -13.435570
    [116]      -13.145577     -13.324808     -13.674366     -14.009493
    [120]      -14.334516     -14.901820     -16.200592     -18.369932
    [124]      -18.124714     -14.084000     -10.772149     -8.9305782
    [128]      -8.3402500     -8.7467976     -9.7841005     -10.907022
    [132]      -11.821777     -12.979772     -15.098819     -18.195539
    [136]      -19.144075     -16.964031     -15.461592     -15.156047
    [140]      -15.331599     -15.227575     -15.037647     -15.619347
    [144]      -17.770302     -22.595642     -29.080900     -23.330492
    [148]      -20.001308     -19.261240     -20.149099     -22.103674
    [152]      -24.488487     -26.039240     -24.263184     -20.412018
    [156]      -17.195095     -15.186911     -14.364237     -14.647276
    [160]      -15.998234     -18.606722     -23.566664     -29.558935
    [164]      -21.052183     -16.444845     -14.546303     -14.405373
    [168]      -15.158006     -15.344819     -14.644438     -14.108471
    [172]      -13.433708     -11.578883     -9.3491793     -7.8583422
    [176]      -7.3363972     -7.5977907     -8.3712196     -9.6306000
    [180]      -11.865898     -15.974337     -18.809338     -13.912808
    [184]      -10.437194     -8.8556366     -8.5776405     -9.2959185
    [188]      -10.771257     -12.403522     -13.002906     -12.563253
    [192]      -12.490835     -13.627038     -15.935132     -17.135891
    [196]      -15.148432     -12.999217     -11.771907     -11.199059
    [200]      -10.944404     -10.890934     -11.184502     -12.188396
    [204]      -14.581071     -20.154219     -29.300682     -18.242083
    [208]      -14.821754     -15.307559     -19.281897     -14.347754
    [212]      -7.7277517     -3.8399012     -1.5781771    -0.40820351
    [216]    -0.045831483    -0.32246375     -1.1530461     -2.5456824
    [220]      -4.6319146     -7.7026601     -11.930537     -13.704153
    [224]      -10.118487     -7.0619693     -5.3490024     -4.8242574
    [228]      -5.5618119     -7.9667039     -12.746575     -13.383904
    [232]      -7.6613050     -4.1943913     -2.4661713     -2.0536442
    [236]      -2.8256729     -4.4080830     -4.9695330     -3.2369266
    [240]      -1.4215511    -0.69578069     -1.1148584     -2.4506447
    [244]      -4.2569675     -5.5341172     -4.5380821     -1.6846850
    [248]       1.0197573      2.8516676      3.7782054      3.9385040
    [252]       3.5369771      2.8033826      1.8956480     0.83438355
    [256]     -0.23200442    -0.47019842     0.76176071      2.3818583
    [260]       3.2881837      3.0754390      1.6309972    -0.70544291
    [264]      -1.8167676    -0.16149087      1.8434008      3.1510906
    [268]       3.7573085      3.7241569      3.2436407      3.0475786
    [272]       3.9587545      5.4006996      6.3627896      6.4705515
    [276]       5.8047996      4.7921596      3.9835594      3.3095596
    [280]       2.0171204    -0.50684816     -2.7217984   -0.050575409
    [284]       3.5881588      6.1098447      7.7471914      8.7839117
    [288]       9.4196749      9.8595419      10.385881      11.295973
    [292]       12.648749      14.155083      15.419806      16.145226
    [296]       16.140013      15.287173      13.636843      11.946360
    [300]       12.006045      13.647721      15.236090      16.249931
    [304]       16.659853      16.420727      15.380598      13.273210
    [308]       9.6398935      4.1921473      4.5079832      9.6609697
    [312]       13.334817      15.996685      17.964283      19.322149
    [316]       20.085817      20.271509      19.936394      19.218901
    [320]       18.368446      17.702770      17.444889      17.579710
    [324]       17.933439      18.393642      19.016787      19.860413
    [328]       20.738214      21.301901      21.273052      20.520872
    [332]       19.079210      17.285440      16.029041      16.199186
    [336]       17.480965      19.149483      20.827328      22.269644
    [340]       23.237587      23.529118      23.060049      22.125774
    [344]       21.872002      23.098846      24.632843      25.431355
    [348]       25.193197      23.852890      21.420145      18.127710
    [352]       14.712529      11.335706      5.2748952      7.0497017
    [356]       15.371939      20.017288      22.898569      24.616192
    [360]       25.333630      25.024677      23.544912      20.764608
    [364]       17.967905      19.252834      21.868647      23.241993
    [368]       23.310446      22.239305      20.191378      17.504751
    [372]       15.017174      13.876293      14.383678      15.844080
    [376]       17.360167      18.406500      18.844187      18.717384
    [380]       18.116877      17.116032      15.756626      14.065521
    [384]       12.066015      9.7722883      7.2467194      4.8442049
    [388]       3.2389648      2.2112103     0.16011992     -5.8128734
    [392]      -5.6759872      3.3485973      7.7704105      10.133747
    [396]       11.226005      11.439184      11.046667      10.192016
    [400]       8.7283840      6.0148444     0.75198644     0.69918329
    [404]       7.3766627      11.127581      12.987595      13.485503
    [408]       12.799350      10.940559      7.8610930      3.8593714
    [412]      0.72566044    -0.77665937     -3.5818615     -6.5002246
    [416]      -1.4941829      2.5397735      4.7994285      6.2442126
    [420]       7.3324080      8.1106548      8.6770926      9.4413290
    [424]       10.654524      11.952276      12.864417      13.236279
    [428]       13.202606      13.059077      13.018136      12.977418
    [432]       12.627172      11.700138      10.105935      8.1199503
    [436]       6.5994129      6.0242438      5.5279751      4.4645267
    [440]       3.5633197      4.3029461      6.1173863      7.8872223
    [444]       9.3504143      10.356558      10.645978      9.9602013
    [448]       8.0584612      4.6094899     -1.1850642     -14.135983
    [452]      -8.5332699    -0.30150503      4.6985021      8.3592329
    [456]       11.017195      12.783163      13.690140      13.734010
    [460]       12.894430      11.169809      8.7058773      6.1235294
    [464]       4.3844810      3.1950905      1.2824862     -2.2686150
    [468]      -8.4672279     -23.820650     -11.721809     -3.3328323
    [472]       1.7585511      5.0933762      7.2092547      8.4199514
    [476]       8.9499159      9.0030117      8.8030233      8.5594416
    [480]       8.3316946      7.9456797      7.1073542      5.6255980
    [484]       3.9375401      3.9425857      6.0388732      8.1694908
    [488]       9.5360670      10.126356      10.072237      9.5359888
    [492]       8.7109766      7.8221216      7.0867586      6.6413012
    [496]       6.5005207      6.5903349      6.8013582      7.0107431
    [500]       7.0794978      6.8487134      6.1430287      4.7866712
    [504]       2.6953132     0.36488155    -0.35508531     0.79697287
    [508]       1.7215357      1.4470533    -0.47368771     -5.0410028
    [512]      -12.392879
  [Tag]         2401
  [frame_len]          320
[Record 16]
  [tot_power]       171866.05
  [re_spec_val]
    [0]       16.151434      15.509364      13.467154      9.5250711
    [4]       1.6385378     -8.3706961      2.9911363      5.8965240
    [8]       6.4288559      5.4820552      3.0553133     -1.6100056
    [12]      -12.342730     -6.0832529      2.9347174      9.3575420
    [16]       14.440804      18.406868      21.431047      23.662270
    [20]       25.216633      26.181162      26.617956      26.567215
    [24]       26.051720      25.087776      23.712053      22.041107
    [28]       20.363161      19.113676      18.484783      18.177900
    [32]       17.919001      18.126764      19.753851      22.516403
    [36]       25.275391      27.498432      29.101742      30.142582
    [40]       30.718271      30.930925      30.853512      30.493267
    [44]       29.777771      28.572718      26.703880      23.948725
    [48]       19.967279      14.096959      5.5065203      4.8175201
    [52]       7.5455160      7.9370127      7.4706330      7.2427731
    [56]       7.7367225      8.6929321      9.5479469      9.8310070
    [60]       9.2242193      7.6035295      5.7730336      6.3815374
    [64]       8.7270565      10.403629      10.942594      10.414521
    [68]       8.9399872      6.6946917      4.0492177      1.6432489
    [72]    -0.088371731     -1.4082550     -2.8359766     -5.0112710
    [76]      -9.4645262     -30.367760     -9.3842154     -2.7232735
    [80]      0.79077840      2.8840957      4.1082568      4.7307277
    [84]       4.9013367      4.6786909      4.0164022      2.7568543
    [88]      0.63128686     -2.7956219     -8.2993107     -14.558562
    [92]      -11.496759     -8.8096228     -7.4031520     -5.6279888
    [96]      -3.1579690    -0.54421693      1.9939487      4.4411945
    [100]       6.6921453      8.5844994      10.001377      10.889856
    [104]       11.236744      11.051557      10.375902      9.3265162
    [108]       8.1435385      7.1011238      6.1943579      5.0202751
    [112]       3.0260804    -0.40776560     -6.3277907     -16.512079
    [116]      -15.711338     -12.792040     -6.3550134    -0.59839141
    [120]       3.0841682      5.1817021      6.0077038      5.7292705
    [124]       4.5861239      3.4203970      3.6555886      4.8988829
    [128]       5.6949306      5.4130554      3.7996578     0.49081716
    [132]      -5.4069629     -12.964903     -9.0318584     -6.7275414
    [136]      -6.0602694     -5.1801853     -4.1381292     -3.9708602
    [140]      -5.3331513     -8.4454527     -10.261220     -7.1817141
    [144]      -4.8293066     -4.3770170     -5.6511645     -7.9049821
    [148]      -7.6240702     -4.5540676     -2.0183256    -0.49928844
    [152]      0.17579710     0.11034018    -0.69257993     -2.2475936
    [156]      -4.3765564     -6.3052411     -7.0756073     -7.2164283
    [160]      -7.7652531     -9.0802002     -10.885797     -10.824118
    [164]      -7.1905942     -3.4495151    -0.92113745     0.34899843
    [168]      0.39627677    -0.84052753     -3.4743569     -6.3881025
    [172]      -4.8293056     -1.4545304     0.71332818      1.6162610
    [176]       1.3998040     0.14312220     -1.9880714     -4.2722554
    [180]      -5.2916446     -5.1429777     -5.1690946     -5.8175201
    [184]      -6.7744474     -7.4412417     -7.7393465     -8.3253822
    [188]      -9.3452768     -8.3218660     -4.4905295     -1.0200889
    [192]       1.2701706      2.4953160      2.8586936      2.5850174
    [196]       1.9347272      1.1632310     0.43102244    -0.20859273
    [200]     -0.71930748     -1.0370619     -1.1137793    -0.97664434
    [204]     -0.76332968    -0.69893843     -1.0272958     -1.9829019
    [208]      -3.8430946     -6.9215703     -9.4385138     -5.8371429
    [212]      -1.5650334      1.1751781      2.5672851      2.7735753
    [216]       1.9162674     0.28204533     -1.4483529     -2.8224678
    [220]      -4.8307781     -9.6264067     -13.881955     -5.8220978
    [224]      -1.8929555    -0.45595509    -0.81848115     -3.1013703
    [228]      -8.8625975     -21.072624     -6.1885910     -1.3581845
    [232]      0.92120486      1.9517968      2.4649522      3.0124996
    [236]       3.6067564      3.7878952      3.1625719      1.7534076
    [240]      0.58563393      1.2630416      2.9448693      4.2659593
    [244]       4.9434533      5.0212727      4.5006742      3.2851758
    [248]       1.2911273    -0.84908527    -0.47321945      2.3063235
    [252]       4.9098487      6.8166256      8.1306047      8.8808908
    [256]       8.9422970      8.0889320      6.0191383      2.3242042
    [260]      -3.0348620     -5.3253260     -3.9906785     -4.3792367
    [264]      -6.1928630     -7.2393703     -5.9500747     -3.1604481
    [268]     -0.21484657      1.9338658      2.9480491      2.8222578
    [272]       2.4726532      4.8323970      9.0898638      12.662345
    [276]       15.103158      16.491610      16.927139      16.492861
    [280]       15.290059      13.491629      11.364493      9.1558743
    [284]       6.9453082      4.8420010      3.2021265      2.1376493
    [288]       1.5627915      1.9014286      2.9033828      3.3287046
    [292]       2.0583298     -2.7514212     -5.2340956      4.5832720
    [296]       9.7118034      12.700846      14.373776      15.085952
    [300]       15.131601      14.947730      15.062077      15.576422
    [304]       16.033291      15.973225      15.181308      13.629410
    [308]       11.461036      9.0892220      7.2673111      6.7113829
    [312]       7.3024149      8.1120071      8.2164440      6.8913245
    [316]       3.2071290     -1.6610470      3.6225975      7.7476010
    [320]       9.5953484      10.138952      10.009181      9.6947470
    [324]       9.6461306      10.204886      11.111087      11.633804
    [328]       11.208958      9.6808329      8.1636543      9.4208088
    [332]       11.989322      13.697805      14.256968      13.891339
    [336]       13.491699      14.682660      17.097404      19.163828
    [340]       20.314550      20.522654      20.018723      19.474911
    [344]       19.864172      21.205643      22.731386      24.059677
    [348]       25.149250      26.002333      26.583340      26.849859
    [352]       26.783993      26.395496      25.715206      24.801926
    [356]       23.771574      22.807615      22.039165      21.312517
    [360]       20.160561      17.915468      13.422021      4.0968132
    [364]       10.088062      15.107934      16.941643      17.133564
    [368]       16.471228      15.775253      15.624239      15.797405
    [372]       15.824285      15.559318      15.149718      14.875228
    [376]       14.946458      15.338261      15.844769      16.226440
    [380]       16.268961      15.803793      14.752023      13.196884
    [384]       11.428137      9.7969246      8.6636667      8.8765774
    [388]       10.549815      12.265732      13.119431      12.854283
    [392]       11.350999      8.4181519      3.9291880     0.44865343
    [396]       1.7706795      2.5555632     0.80670083     -4.8102932
    [400]      -3.1845436      3.8967485      7.5783286      9.3988180
    [404]       10.001307      9.8034868      9.2831125      8.9016151
    [408]       8.6952658      8.2768097      7.2893033      5.6058784
    [412]       3.3640864      1.0857058    -0.39761508    -0.73522538
    [416]     -0.37703750    0.076761745     0.20820417   -0.078118324
    [420]     -0.16834816      1.2883812      4.0997477      6.8312550
    [424]       8.8458357      10.023688      10.361958      9.8677502
    [428]       8.5505095      6.4690738      3.8743000      1.5066282
    [432]      0.72790164      2.1363475      4.4053745      6.2550836
    [436]       7.2003741      7.0792332      5.7410436      2.8336957
    [440]      -2.5742183     -7.6454873     -1.5232452      2.3213146
    [444]       4.2275419      4.8408089      4.2251153      2.1048574
    [448]      -2.1113701     -6.8929367     -3.9448690     -1.2050813
    [452]     -0.30921835    -0.18870531    -0.16222604    -0.26893994
    [456]     -0.71042997     -1.4329838     -2.5505142     -4.7129126
    [460]      -8.4948893     -9.2097206     -4.8200693     -1.5881474
    [464]      0.46343136      1.6804454      2.0069773      1.1814876
    [468]      -1.2367634     -6.2912655     -18.310154     -13.827225
    [472]      -10.927157     -15.332355     -22.690868     -10.054399
    [476]      -7.4537716     -9.7247725     -23.072529     -9.4658909
    [480]      -4.0057826     -2.4633396     -3.3014193     -6.1825933
    [484]      -10.769052     -12.110131     -7.7510290     -4.4523735
    [488]      -3.0544405     -3.6354883     -6.6814132     -14.529516
    [492]      -22.535805     -12.302632     -10.496301     -11.318398
    [496]      -13.494806     -16.212763     -18.383448     -17.279510
    [500]      -13.535850     -10.413824     -8.8374462     -8.8431692
    [504]      -9.4706821     -8.2090673     -5.8653536     -4.7469497
    [508]      -5.5660419     -8.9711332     -17.596249     -23.378382
    [512]      -17.246527
  [Tag]         2561
  [frame_len]          320
[Record 17]
  [tot_power]       281463.59
  [re_spec_val]
    [0]       16.085575      15.525610      13.788694      10.677406
    [4]       5.7732987     -1.1156811     -3.5223901     -1.7661327
    [8]      -1.5279316     -1.8449770     -1.7778906     -1.5860986
    [12]      -2.3922331     -5.3442345     -10.282442     -25.039158
    [16]     -0.87964457      9.8790035      16.563143      21.058960
    [20]       23.992353      25.634998      26.097797      25.386875
    [24]       23.410011      19.959023      14.806404      9.3802509
    [28]       8.1091805      7.1583643      3.8503644     -1.9140587
    [32]      -4.6940103    0.010309254      6.5500512      12.428109
    [36]       16.620441      19.558273      22.589825      26.636435
    [40]       30.728926      33.979870      36.184200      37.355122
    [44]       37.524372      36.694870      34.831539      31.870394
    [48]       27.797445      23.030960      19.007473      16.047585
    [52]       12.085758      5.5128050    -0.15563026     0.77419603
    [56]      0.43852288      3.8055832      7.8598533      10.081367
    [60]       11.217957      12.966704      15.951146      18.853867
    [64]       20.902742      21.980009      22.122103      21.373480
    [68]       19.776960      17.420395      14.534647      11.516355
    [72]       8.4928713      4.7584796     -1.0827636     -7.1600757
    [76]      -3.8986773     -3.1179957     -5.7215476     -8.3638086
    [80]      -5.1713352     -1.9201205      1.5716308      5.5395427
    [84]       8.9406366      11.382286      12.879634      13.513880
    [88]       13.358804      12.493729      11.036143      9.1436777
    [92]       6.9180088      4.2872314      1.1899761     -1.9373415
    [96]      -5.0603223     -11.699006     -9.4813957    -0.59417129
    [100]       3.8211589      6.4916377      8.4364576      10.149529
    [104]       11.798584      13.435311      15.058185      16.529945
    [108]       17.614660      18.100334      17.848953      16.788280
    [112]       14.925466      12.471528      10.137392      8.9434738
    [116]       8.8508253      9.0158663      8.8813734      8.1157045
    [120]       6.4762831      3.9464855      1.6655968      2.4771259
    [124]       5.3911452      8.3410711      10.967057      13.245166
    [128]       15.139419      16.593258      17.554764      17.999039
    [132]       17.939219      17.423750      16.514822      15.246023
    [136]       13.584939      11.456394      8.8932562      6.3880548
    [140]       4.9032645      4.3772173      3.7301877      2.4595444
    [144]       1.0648526      1.0804135      2.7381940      4.6124249
    [148]       6.0834885      7.1851907      8.0976105      8.9280519
    [152]       9.6299667      10.066045      10.120054      9.7556257
    [156]       9.0274267      8.0847540      7.1984496      6.7620645
    [160]       7.0069432      7.6113586      7.9696655      7.6141996
    [164]       6.2250714      3.5332401    -0.13227580    -0.80510795
    [168]       1.9529815      4.1225395      5.4935980      6.5526576
    [172]       7.5343356      8.3301544      8.7029076      8.4589138
    [176]       7.4614291      5.5861335      2.6870980     -1.3239136
    [180]      -5.6674128     -7.6704230     -8.6105099     -12.150033
    [184]      -18.242647     -10.449491     -6.2101002     -5.1241674
    [188]      -6.7961097     -12.846417     -11.744814     -3.8658254
    [192]   -0.0084886802      1.8197154      2.2902982      1.9303250
    [196]       1.7326298      2.6615119      4.2249098      5.6196251
    [200]       6.6804223      7.4776225      7.9781027      8.0218506
    [204]       7.4401569      6.1392074      4.1631627      1.8409647
    [208]   0.00023348130    -0.36334589     0.70567405      2.1714089
    [212]       3.1861460      3.3726864      2.5736887     0.53035837
    [216]      -3.7814794     -9.2016506    0.025789879      5.9556680
    [220]       9.5680962      11.775245      12.922914      13.173906
    [224]       12.626842      11.390679      9.6676998      7.7594638
    [228]       5.7415347      2.9695308     -2.3624938     -13.550941
    [232]      -2.1681318      2.3821969      4.0803638      4.2936997
    [236]       3.6802619      2.7578177      1.8703886      1.2974042
    [240]       1.7083880      3.4355206      5.5877843      7.3485904
    [244]       8.4646397      8.9592094      9.0172081      8.9821749
    [248]       9.1858664      9.5838690      9.7709799      9.3232718
    [252]       7.8842096      4.9692168    -0.69271225     -13.043734
    [256]      -2.6537743      1.9365689      3.8375380      4.5032945
    [260]       4.3503299      3.3546112      1.1839508     -2.4229579
    [264]      -2.3425045      3.2265985      7.4601922      10.137459
    [268]       11.565647      11.976355      11.740245      11.469944
    [272]       11.460486      11.097264      9.3801508      5.0827079
    [276]       1.0105987      7.2763577      11.189044      13.059660
    [280]       13.801720      13.891476      13.545836      12.802308
    [284]       11.650774      10.169333      8.6138573      7.4163465
    [288]       6.9139738      6.9876428      7.3422432      7.9767094
    [292]       8.9499693      9.9140844      10.313068      9.6988087
    [296]       7.6523323      3.3952150     -6.1946874     -9.3353901
    [300]      -1.4771752      1.3291798      4.0450664      6.9994798
    [304]       9.3929367      11.019737      12.030443      12.657396
    [308]       13.095582      13.447237      13.757229      14.085700
    [312]       14.486987      14.896222      15.095231      14.804326
    [316]       13.757272      11.712406      8.5784903      5.5240479
    [320]       5.5380759      6.7531648      6.8456035      5.4196963
    [324]       2.0669162     -5.3862758     -13.070678    -0.87190115
    [328]       3.3123748      5.4181838      6.4296575      6.6139860
    [332]       5.9714556      4.6023731      3.7974601      5.5489531
    [336]       8.1353674      9.8335543      10.326344      9.5528431
    [340]       7.3401895      3.1450682     -4.8252244     -7.1783967
    [344]     -0.66037887      2.2766852      3.9710155      5.2509542
    [348]       6.3626056      7.2712426      7.8561821      8.0717220
    [352]       8.0287495      7.9598627      8.1243038      8.8503313
    [356]       10.415194      12.491321      14.374980      15.594523
    [360]       15.925372      15.211450      13.236609      9.6751299
    [364]       5.2549868      5.9277554      8.6209631      9.6949301
    [368]       9.3251429      7.8543906      5.6254563      3.1411834
    [372]       1.0912566     0.20637773      1.0649164      3.1533101
    [376]       5.3555303      7.2493744      8.9633141      10.641126
    [380]       12.119068      13.046774      13.096341      11.950848
    [384]       9.1195393      3.7605200      1.6976250      6.8429689
    [388]       9.5572453      10.437251      10.184087      9.3684425
    [392]       8.5591316      7.9725990      7.3193636      6.3379154
    [396]       5.2601228      4.8215151      5.4345984      6.6094494
    [400]       7.7047491      8.3204956      8.2101831      7.1943302
    [404]       5.1107926      1.8424248     -2.1242142     -4.1277895
    [408]      -3.8186381     -4.2013302     -5.9021583     -6.3717957
    [412]      -2.8170302     0.90277743      3.4675562      4.9814601
    [416]       5.5972323      5.4209342      4.5809922      3.3832529
    [420]       2.5046723      2.6814766      3.8438325      5.3692360
    [424]       6.7406654      7.6090064      7.7314630      6.9081149
    [428]       4.8733845      1.0315472     -6.6102128     -8.7705097
    [432]      -1.1544659      2.2686453      3.9211171      4.4626436
    [436]       4.0702806      2.7369313     0.35659567     -3.0606747
    [440]      -5.7780242     -4.6374636     -2.7305441     -1.7523065
    [444]     -0.75733578      1.5667703      4.4593635      6.7276416
    [448]       7.9985743      8.1985683      7.2422776      4.8787065
    [452]      0.33985156     -10.267465     -9.8286810     -2.4306526
    [456]     -0.22908440   -0.029494300     -1.1542983     -3.0990067
    [460]      -4.0607324     -2.2238457     0.42413145      2.6471772
    [464]       4.4598846      6.0316539      7.4172006      8.5450344
    [468]       9.2744389      9.4436102      8.8753901      7.3298836
    [472]       4.3724303    -0.77677143     -3.3881660      2.0040269
    [476]       5.4293795      7.1133184      7.5976324      7.0950737
    [480]       5.6673856      3.3064959    0.020881318     -3.7414787
    [484]      -5.5301633     -3.6756306     -1.1024836     0.85401928
    [488]       2.0250607      2.4426417      2.1830068      1.3215768
    [492]     -0.12360193     -2.2790816     -5.5679140     -11.236032
    [496]      -18.747013     -9.9088354     -4.7026272     -1.5904021
    [500]      0.33845082      1.3562536      1.5714090      1.0847765
    [504]      0.13286777    -0.71182179    -0.73358953 -0.00092783984
    [508]      0.78692693      1.2068810      1.2175871      1.0131252
    [512]      0.89247942
  [Tag]         2721
  [frame_len]          320
[Record 18]
  [tot_power]       280208.22
  [re_spec_val]
    [0]       14.658295      14.039662      12.120967      8.6937199
    [4]       3.4570501     -1.9963309     -2.1033940     -1.8989844
    [8]      -3.9117422     -8.5650902     -15.117433     -11.042847
    [12]      -8.8115463     -12.512328     -20.347656     -7.9212976
    [16]      -12.049866    -0.73166621      10.947300      17.608332
    [20]       21.986025      24.813047      26.386923      26.835484
    [24]       26.190874      24.407982      21.354839      16.787369
    [28]       10.450284      3.7565806      1.0054724     -1.1494637
    [32]      -3.6925046     -3.2444348    -0.16297454     0.16247581
    [36]      -9.1780958      3.6126223      10.414787      11.798990
    [40]       12.624127      21.551453      28.360630      32.829235
    [44]       35.671440      37.221447      37.626900      36.927994
    [48]       35.076725      31.915640      27.090515      19.774248
    [52]       8.6542587      6.4863830      4.3538833     -5.9898891
    [56]      -3.7140484     -2.8954275     -9.6322298     -8.8188210
    [60]      -4.3066950    -0.24916251      3.9747400      7.2812161
    [64]       10.927477      15.134212      18.787252      21.367317
    [68]       22.820019      23.178911      22.451418      20.586794
    [72]       17.449604      12.770138      6.0679350     -3.0410306
    [76]      -11.674926     -15.271420     -8.2785711     -5.2077651
    [80]      -4.1937671     -2.8722594    -0.99777633     0.67834783
    [84]       2.0636072      2.8426294      2.0506001     -2.5689957
    [88]      -6.4042988      4.9045129      9.9614820      12.489616
    [92]       13.365335      12.852440      10.963397      7.4757962
    [96]       1.6692280     -8.5161934     -8.0121508     -4.6747603
    [100]      -4.7193961     -5.6133175     -5.2552223     -4.3926091
    [104]      -4.5834718     -4.5298676     -1.2992450      1.8683631
    [108]       2.5980079    -0.95600551    -0.55653352      9.5222778
    [112]       14.987880      18.175386      19.835453      20.247423
    [116]       19.516701      17.671698      14.737643      10.878581
    [120]       6.5591478      1.9830409     -4.2992001     -15.945177
    [124]      -13.508761     -13.604105     -17.362165     -14.034024
    [128]      -5.6601171      1.4167236      5.8308954      8.0416317
    [132]       8.4433193      8.2004881      10.290261      13.849588
    [136]       16.480640      17.789913      17.837275      16.651546
    [140]       14.180221      10.368411      5.8257985      3.2368004
    [144]       2.4210894     0.37459418     -4.0875173     -12.357217
    [148]      -22.723944     -20.562956     -21.839401     -16.714148
    [152]      -8.0515108     -1.3479648      3.2181888      6.1760182
    [156]       8.0035343      9.1443615      9.9367065      10.420925
    [160]       10.333691      9.2967081      6.8548498      2.1526327
    [164]      -7.8880386     -8.2872200     -2.9784091     -2.5912709
    [168]      -4.4641776     -6.7704625     -7.0912876     -5.9043994
    [172]      -4.5763230     -2.9703066     0.16669931      4.4898210
    [176]       8.4379702      11.444180      13.478111      14.605152
    [180]       14.885612      14.371239      13.140057      11.377410
    [184]       9.4727821      7.8598752      6.4691486      4.6939998
    [188]       1.8402773     -3.0001519     -12.295373     -13.818894
    [192]      -9.0660915     -9.7384930     -16.254860     -20.995632
    [196]      -10.606169     -6.7992864     -3.0565579      1.2614070
    [200]       4.8398476      7.2735696      8.6120672      8.9527435
    [204]       8.3765278      7.0062833      5.2224469      3.9586740
    [208]       3.9023752      4.2983098      4.2143588      3.2458370
    [212]       1.2298379     -1.8184637     -5.1990185     -7.0251966
    [216]      -6.6077437     -4.4852767     -1.4744229      1.6302912
    [220]       4.6694121      7.5318780      10.032125      12.107394
    [224]       13.829026      15.274566      16.420719      17.151627
    [228]       17.337587      16.891787      15.795002      14.128359
    [232]       12.125758      10.124195      8.2212095      6.0053306
    [236]       2.7701612     -2.4257116     -11.689541     -27.161640
    [240]      -29.234985     -16.893885     -9.3928680     -7.6560936
    [244]      -8.4057827     -4.0547719      1.6271840      5.4464130
    [248]       7.9503407      9.5921659      10.553970      10.841164
    [252]       10.432107      9.4594727      8.3814440      7.7160587
    [256]       7.2287979      6.1179361      3.6902430    -0.70522189
    [260]      -7.5519366     -10.763805     -9.3861485     -7.6970625
    [264]      -4.9057398     -2.3275328      2.4435117      8.3919411
    [268]       13.282273      16.917202      19.494005      21.173851
    [272]       22.056026      22.197590      21.637939      20.432610
    [276]       18.704411      16.685278      14.621873      12.489809
    [280]       9.8962307      6.3172665      1.2912052     -5.0990062
    [284]      -10.494867     -10.503824     -4.3475099     0.22595580
    [288]       2.5878725      2.9626534     0.94718307     -4.5561991
    [292]      0.21449035      7.2668672      11.532904      14.272935
    [296]       15.959103      16.778009      16.798944      16.017460
    [300]       14.345033      11.552710      7.1179357    -0.13786635
    [304]      -5.3514895     -1.2894597    -0.10048893    -0.25724277
    [308]     -0.61197793   -0.092323139      3.5165064      8.0094023
    [312]       11.432564      13.710050      15.076992      15.752052
    [316]       15.902282      15.640706      15.033760      14.113808
    [320]       12.882953      11.303349      9.2929249      6.7709975
    [324]       3.8570077      1.2850960    -0.15027849     -1.3627025
    [328]      -3.8041818     -8.2130795     -12.201543     -11.882197
    [332]      -11.984317     -9.0659027     -4.7611666     -2.5267227
    [336]      -2.7624226     -6.7703843     -14.001644     -1.2654184
    [340]       4.4860001      7.7544589      9.6791782      10.738103
    [344]       11.215504      11.269047      10.925280      10.111143
    [348]       8.7058830      6.5440230      3.3571751     -1.1841856
    [352]      -5.8741307     -5.8442979     -3.3709741     0.40060195
    [356]       4.2112775      6.9481802      8.6730785      9.9597940
    [360]       11.455529      13.227430      14.824954      15.898820
    [364]       16.333994      16.135458      15.362659      14.135322
    [368]       12.673693      11.255663      9.9489346      8.3936205
    [372]       5.9602952      1.8696114     -4.5261846     -7.0459132
    [376]      -6.1561108     -8.0520573     -2.5445001      3.0576653
    [380]       6.0915289      7.5885630      8.6285648      10.272057
    [384]       12.503258      14.587852      16.138380      17.096312
    [388]       17.507347      17.428757      16.896568      15.903717
    [392]       14.381277      12.188324      9.1003675      4.7547946
    [396]      -1.3487333     -5.3965988     -1.8366773     0.45332342
    [400]      0.52806324     -1.9814844     -5.4486604     0.42966694
    [404]       5.5073390      8.4908867      10.188412      11.016163
    [408]       11.185138      10.788671      9.8720675      8.5704870
    [412]       7.3418813      6.8444147      6.9670062      6.8710451
    [416]       5.9401417      3.8642390     0.41306701     -4.6523643
    [420]      -11.041875     -14.449153     -11.581384     -6.7460990
    [424]      -2.3847735     0.88129389      3.0072527      4.0335407
    [428]       4.0079961      3.0063334      1.2288611    -0.82220501
    [432]      -2.4705358     -3.6102703     -4.2494102     -3.3807096
    [436]      -1.1396744     0.92526853      2.1036823      2.2624221
    [440]       1.3943559    -0.44799623     -2.9642425     -5.1765571
    [444]      -5.7246814     -4.1886549     -1.3409423      1.4795656
    [448]       3.6203859      5.0999937      6.2505069      7.4230595
    [452]       8.6572762      9.6945629      10.277175      10.277238
    [456]       9.6617012      8.4430151      6.6661839      4.4733791
    [460]       2.3293271      1.0888796     0.84135866     0.47516870
    [464]      -1.0254849     -4.2335472     -6.9140587     -4.0477190
    [468]      -1.4114256    -0.41429961    -0.26509371    -0.17426659
    [472]     -0.19713263    -0.77174819    -0.73342180      1.8587493
    [476]       4.9171100      6.8457718      7.4311438      6.6163120
    [480]       4.1302552    -0.75418425     -4.8058252     0.42512912
    [484]       3.8204994      5.2099600      5.1732559      3.8795309
    [488]       1.3583270     -1.9276254     -3.6700528     -3.0181284
    [492]      -2.4934857     -2.6969192     -2.8700514     -1.9630954
    [496]     0.061566602      2.3592896      4.3106132      5.6738014
    [500]       6.4055691      6.5559330      6.2210183      5.5102105
    [504]       4.5100555      3.2610259      1.7788132     0.12118945
    [508]      -1.5416145     -2.9344726     -3.8405960     -4.2738543
    [512]      -4.3908472
  [Tag]         2881
  [frame_len]          320
[Record 19]
  [tot_power]       296353.25
  [re_spec_val]
    [0]       19.271620      18.704130      16.963837      13.936605
    [4]       9.4750929      3.8653779    -0.62044102     -3.4599986
    [8]      -8.4223194     -11.269944     -5.8728929     -2.7507362
    [12]      -1.2016730    -0.93933094     -1.5843018    -0.27553439
    [16]       2.1200078     0.96742588      3.2167792      13.812775
    [20]       20.304722      24.467533      27.054848      28.380516
    [24]       28.580118      27.688623      25.660465      22.367949
    [28]       17.636421      11.712113      6.8363671      3.2213516
    [32]      -2.6769414     -2.3353837    -0.79720956     -4.3377776
    [36]      -4.9977784    -0.94215506      3.2851431      9.4955702
    [40]       13.890615      17.160116      21.663599      26.929129
    [44]       31.317942      34.472485      36.459816      37.366821
    [48]       37.233204      36.042862      33.715614      30.089123
    [52]       24.917112      18.235197      12.620169      9.6647406
    [56]       5.4143214      2.3540075      2.5603454     0.61497754
    [60]      -5.1608057     -17.165361     -7.0717878     -1.6459849
    [64]       1.9418449      5.2866468      9.2658806      13.638824
    [68]       17.536339      20.491749      22.397209      23.260920
    [72]       23.103369      21.924444      19.693443      16.351173
    [76]       11.846464      6.3151040     0.59408528     -3.7850730
    [80]      -5.9537878     -6.3693666     -7.3275309     -9.9281025
    [84]      -9.7295914     -5.4995594     -2.8278105     -2.4104843
    [88]      -5.7970071     -14.232873      2.7908227      9.7955799
    [92]       14.120187      16.862099      18.398045      18.901487
    [96]       18.467981      17.165594      15.067152      12.265099
    [100]       8.8269920      4.6574955    -0.60130817     -7.3426924
    [104]      -14.087401     -8.8442774     -2.7611873     0.54008061
    [108]       1.8441733      2.1869831      3.3634512      5.7772131
    [112]       8.3082428      10.940039      13.969984      16.979977
    [116]       19.414587      21.023237      21.741468      21.561277
    [120]       20.485186      18.527102      15.747165      12.309518
    [124]       8.4583197      4.2884378     0.13925318     -1.6775022
    [128]      -1.7654864     -3.8518641     -12.407819     -10.611862
    [132]      -1.8868916      1.8956767      4.7107067      7.7051740
    [136]       10.743212      13.445900      15.672227      17.394053
    [140]       18.585022      19.205261      19.218874      18.612917
    [144]       17.418344      15.737926      13.754313      11.638251
    [148]       9.3675213      6.7252808      3.6471980     0.81490189
    [152]     -0.71576130     -1.6433845     -3.3032832     -6.1818733
    [156]      -8.7000179     -6.0922871     -1.7121009      2.0626109
    [160]       5.2447462      7.9228492      10.122555      11.849888
    [164]       13.102304      13.870892      14.150384      13.955824
    [168]       13.332911      12.336248      10.953565      9.0122766
    [172]       6.1612844      2.1363423     -1.0260178     0.27665657
    [176]       1.9839370      2.8560185      3.4921365      3.9623435
    [180]       3.9505210      3.8746212      5.1945148      7.8851967
    [184]       10.601912      12.840579      14.551172      15.716772
    [188]       16.305954      16.311518      15.776035      14.789479
    [192]       13.447047      11.772712      9.6937799      7.2072177
    [196]       4.8224826      3.4752290      2.6842735     0.82560444
    [200]      -3.8098776     -11.108568     -3.3968794     0.87192369
    [204]       2.7056797      3.2214873      2.7422185      1.1773214
    [208]      -1.9429927     -8.0671225     -12.981942     -4.0181656
    [212]      0.74172318      3.5069766      5.0600138      5.7479863
    [216]       5.7697001      5.1645608      3.8404911      1.8163838
    [220]     -0.34326750     -1.9479951     -3.7338514     -5.4811106
    [224]      -3.3040056    -0.48780385     0.16181105     -1.9053327
    [228]      -6.4310288     -1.6126568      4.4932880      8.6103630
    [232]       11.615743      13.825554      15.339014      16.208008
    [236]       16.486111      16.242378      15.567635      14.563739
    [240]       13.299841      11.768001      9.9240580      7.8337498
    [244]       5.7432728      3.7225227      1.1937444     -2.9735904
    [248]      -11.113512     -20.256580     -13.560643     -13.808210
    [252]      -7.1709175     0.10310908      5.4103761      9.4614697
    [256]       12.574411      14.899298      16.541039      17.596289
    [260]       18.163202      18.329145      18.127773      17.487068
    [264]       16.224798      14.147968      11.484076      9.9267702
    [268]       10.364365      10.538644      9.3150234      7.4029021
    [272]       7.6100168      9.2528667      9.8136549      8.8235836
    [276]       6.7680912      5.8892779      7.7553320      10.167210
    [280]       12.176576      13.774327      14.992421      15.838325
    [284]       16.330528      16.483580      16.266691      15.591238
    [288]       14.379622      12.758837      11.281710      10.368445
    [292]       9.2232389      6.2994213     -1.8189762     -3.7497084
    [296]       4.7108779      6.6280904      5.1565719     0.59316415
    [300]       3.0385048      8.6292076      11.829151      13.688352
    [304]       14.875950      15.760035      16.478100      17.008474
    [308]       17.276451      17.229874      16.871696      16.269041
    [312]       15.523170      14.672514      13.596362      12.034343
    [316]       9.6582489      6.0020466    -0.17341638     -21.029005
    [320]      -3.5259416      1.6007189      3.3560712      3.1530385
    [324]       1.1592395     -2.6098871     -5.0352507     -2.0425181
    [328]       1.0632207      3.6024003      6.0421605      8.3174400
    [332]       10.163127      11.415916      12.039401      12.118279
    [336]       11.905225      11.765642      11.783298      11.496181
    [340]       10.190004      6.9393153    -0.19798484    -0.35232010
    [344]       5.4721794      7.1129742      5.9034271      1.5259974
    [348]      -1.1353393      5.2290173      9.0856123      11.162609
    [352]       12.237196      12.690526      12.740129      12.533608
    [356]       12.180750      11.740875      11.176294      10.320042
    [360]       8.9506083      7.1450853      6.1143932      6.9645944
    [364]       7.9927921      7.6810222      5.1939096     -1.5469471
    [368]      -9.4473734     0.82540280      2.8738537     0.98127496
    [372]      -5.1345987    -0.18746611      5.8034296      8.9705219
    [376]       10.727141      11.705724      12.253561      12.560618
    [380]       12.679963      12.542641      12.002832      10.933353
    [384]       9.4766541      8.5095797      8.8485880      9.4351778
    [388]       8.9141531      6.4460044      1.8596522      3.0553477
    [392]       7.1989923      8.9233370      8.7331505      7.3791542
    [396]       6.7335038      8.2877951      10.327801      11.776836
    [400]       12.596271      12.910644      12.787220      12.233937
    [404]       11.273252      10.070308      9.0389729      8.5761328
    [408]       8.4879780      8.1646748      7.0706859      4.7228456
    [412]      0.47209135     -4.3982515     -1.6407994      1.0172493
    [416]       1.3093870  -0.0083522750    -0.64100575      1.6496842
    [420]       4.3784108      6.3154659      7.5729904      8.3955784
    [424]       8.9351101      9.2209702      9.1936646      8.7793636
    [428]       7.9758244      6.9334927      5.9618182      5.2881055
    [432]       4.7537074      3.9694471      2.6479058     0.74516946
    [436]      -1.4099329     -3.1907835     -4.6637125     -7.0395088
    [440]      -12.390442     -25.318193     -12.530549     -8.2749062
    [444]      -6.4971170     -4.9879999     -2.8453526    -0.49406886
    [448]       1.6060537      3.3706512      4.8069572      5.8770800
    [452]       6.5056734      6.6041579      6.0692277      4.7741885
    [456]       2.5965633    -0.37443441     -3.1783276     -4.6617727
    [460]      -6.6197901     -13.287312     -15.879872     -5.0387211
    [464]      -1.0479264     0.55588877     0.68056786    -0.28154561
    [468]      -1.9342574     -3.2973504     -2.7891693    -0.60770601
    [472]       1.9136318      4.1803060      5.9639144      7.1017652
    [476]       7.4517164      6.8658156      5.1319671      1.8407481
    [480]      -4.0801506     -18.568562     -15.130633     -12.852824
    [484]      -11.765328     -5.0638165    -0.81762713      1.1308819
    [488]       1.3565385     0.20084076     -1.6795121     -2.6319058
    [492]      -1.9725752     -1.1419802    -0.86325026     -1.2168130
    [496]      -2.3394210     -4.5156713     -7.7533097     -10.253952
    [500]      -10.401595     -11.044821     -12.423365     -11.170506
    [504]      -9.0850668     -7.6309853     -4.6620579    -0.89276594
    [508]       1.7200292      2.6984098      1.8862615    -0.93043995
    [512]      -3.7543793
  [Tag]         3041
  [frame_len]          320
[Record 20]
  [tot_power]       283514.84
  [re_spec_val]
    [0]       22.893984      22.432661      21.031382      18.637066
    [4]       15.161731      10.511600      4.7624283     -1.1474186
    [8]      -4.3021240     -3.4539852     -2.3686516     -2.8702180
    [12]      -3.6036713     -1.9541041    -0.78635246     -2.4295464
    [16]      -6.2807751     -10.320628    -0.58290476      12.192839
    [20]       19.772110      24.889984      28.363123      30.543465
    [24]       31.599949      31.604687      30.562733      28.416862
    [28]       25.031830      20.144287      13.223846      3.1110446
    [32]      -9.0401745     -16.387861     -9.0789938     -2.6251099
    [36]      -1.7674055     -5.6017137     -17.325586     -13.148992
    [40]       1.9866343      9.4959822      12.926777      13.220415
    [44]       16.498518      24.089560      29.633936      33.277016
    [48]       35.474556      36.459450      36.330223      35.094006
    [52]       32.671028      28.864719      23.288620      15.487666
    [56]       8.9208889      6.9615164     0.97094089     -14.024767
    [60]      -2.0895085     -1.6557291     -4.8586988     -8.0015659
    [64]      -5.4368782    -0.53159148      2.8266335      3.8356733
    [68]       2.9632087      7.6135883      14.534707      19.378393
    [72]       22.547251      24.405460      25.131878      24.799444
    [76]       23.412466      20.922134      17.244125      12.345452
    [80]       6.6554689      1.7234792     -1.8802615     -5.6430368
    [84]      -10.855334     -18.001326     -11.316796     -7.6131792
    [88]      -8.4492769     -17.106800     -5.5590625      1.0797745
    [92]       4.0138855      6.3515964      10.900460      15.789384
    [96]       19.469231      21.867498      23.135006      23.393476
    [100]       22.724798      21.190685      18.858995      15.834131
    [104]       12.266145      8.2648163      3.7219248     -1.4498903
    [108]      -5.1746483     -5.8723488     -7.8176956     -10.458497
    [112]      -7.1757050     -5.0794816     -4.9477458     -1.9134070
    [116]       2.3669229      5.5069213      8.8300934      12.920594
    [120]       16.651434      19.369085      20.985849      21.545605
    [124]       21.086189      19.614328      17.108477      13.538120
    [128]       8.9187155      3.4410934     -2.3198900     -7.3707910
    [132]      -11.921613     -21.013966     -18.965889     -12.107194
    [136]      -9.6636648     -7.3355875     -4.7624736     -2.8519778
    [140]      -1.2276096     0.36775172     0.96473002     -1.1142299
    [144]      -11.030383    0.075131364      7.2861123      10.902259
    [148]       12.622455      12.948905      12.072591      10.094591
    [152]       7.2479248      4.3486862      2.4679055     0.88463503
    [156]      -2.1038446     -8.3164911     -13.366380     -7.4421039
    [160]      -5.7560616     -6.9825621     -9.6247463     -7.3298030
    [164]      -2.5224226     0.55974817      1.5241253    -0.53522784
    [168]      -9.5341520      1.0790583      8.0649204      11.614525
    [172]       13.298598      13.627438      12.860085      11.226094
    [176]       9.0318975      6.6358857      4.2852736      2.1738591
    [180]      0.66392785    -0.11291425    -0.65356183     -1.8141952
    [184]      -4.7924919     -11.755080     -11.331072     -5.9404426
    [188]      -3.3688138     0.75143141      5.6682601      9.7080517
    [192]       12.846092      15.277241      17.059370      18.156649
    [196]       18.518211      18.115370      16.957153      15.116253
    [200]       12.770981      10.183146      7.4563241      4.2454257
    [204]     -0.21297668     -7.0940690     -14.602762     -12.994418
    [208]      -14.822649     -26.794319     -18.961342     -11.563010
    [212]      -6.8556342     -2.6079059      1.3619422      5.2766328
    [216]       9.1061621      12.529927      15.288733      17.276245
    [220]       18.468325      18.866663      18.479280      17.329008
    [224]       15.491631      13.154933      10.586337      7.8200331
    [228]       4.3906088   -0.079523236     -3.0238676     -2.5821722
    [232]      -3.7138085     -8.8077946     -7.5246282    -0.80620825
    [236]       2.6759617      4.3929725      4.8177376      3.6582808
    [240]     -0.82296258     -8.7475376      4.7016296      10.328313
    [244]       13.277825      14.595291      14.628500      13.553360
    [248]       11.583591      9.1379766      6.6183600      3.5863714
    [252]     -0.87619627     -2.1213272      1.4418238      2.9408219
    [256]       2.0673013     -1.2882636     -7.4611416     -5.3303475
    [260]      0.11991110      3.3735192      5.4267550      6.8050900
    [264]       7.8224740      8.8012505      10.207908      12.202477
    [268]       14.269159      15.833255      16.628857      16.594212
    [272]       15.763867      14.241814      12.190395      9.7135468
    [276]       6.5676055      1.8231792     -6.7460794     -7.3178067
    [280]      -3.4170692     -4.0101132     -4.0731053     0.23276711
    [284]       3.3350053      4.5168190      4.4572616      4.4094882
    [288]       5.4173555      6.7636108      7.8167439      9.1947794
    [292]       11.498600      14.003699      15.896213      16.898451
    [296]       16.971434      16.142515      14.493271      12.230638
    [300]       9.7147274      7.1428614      4.2352095      1.2381810
    [304]      0.10947468    -0.29901996     -3.3319058     -4.0646667
    [308]       3.5665388      8.2434597      10.932922      12.416655
    [312]       13.093774      13.193585      12.868072      12.300242
    [316]       11.822435      11.788779      12.127462      12.362268
    [320]       12.077265      11.062118      9.2367544      6.5938544
    [324]       3.1891825    -0.81998384     -4.8415675     -7.2435961
    [328]      -8.1852169     -10.483950     -13.842009     -7.7063394
    [332]      -1.8622621      2.2071416      5.2845759      7.6320362
    [336]       9.3382092      10.518695      11.390034      12.247796
    [340]       13.298096      14.472447      15.506301      16.147081
    [344]       16.232801      15.674541      14.443019      12.607816
    [348]       10.430536      8.3007069      6.1606731      3.0605109
    [352]      -3.2432086     -21.237162     -2.5385849      1.5013453
    [356]       2.9267600      3.2197464      2.9976988      2.5653505
    [360]       2.2297094      2.3956888      3.0465167      3.8192728
    [364]       4.9707932      7.1879253      10.016966      12.476870
    [368]       14.131801      14.894097      14.782594      13.874647
    [372]       12.366655      10.640633      9.0162125      7.1991496
    [376]       4.2996998     -1.1493518     -13.350019     -6.3335252
    [380]      -2.3870766     -1.0646311     0.50432473      2.8261139
    [384]       5.0632749      6.8282275      8.0282583      8.5518408
    [388]       8.2374516      6.9798598      5.3432975      5.7900457
    [392]       8.4560814      10.779674      12.060692      12.343334
    [396]       11.787981      10.644524      9.2363710      7.6557837
    [400]       5.3815274      1.1492977     -9.1336889     -6.8099132
    [404]     -0.96963620    -0.22291763     -2.3286755     -5.2522502
    [408]      -4.0469007     -2.3743632     -2.9292543     -6.2058091
    [412]      -13.759295     -14.968701     -7.8748875     -2.5335507
    [416]       2.1697648      5.7959914      8.2841177      9.7756691
    [420]       10.462999      10.576216      10.336692      9.7963867
    [424]       8.7001085      6.5042424      2.2873962     -4.6020365
    [428]      -1.9227607      1.6149982      1.8555137     -1.0489475
    [432]      -10.807920     -7.9692302    -0.36533794      2.4146745
    [436]       3.3710907      3.4452405      3.3168786      3.5554583
    [440]       4.3346853      5.3633437      6.2297812      6.6435647
    [444]       6.4790497      5.8122635      5.0083199      4.5569348
    [448]       4.4059525      3.9053416      2.4262538    -0.52787870
    [452]      -5.4813781     -11.644280     -13.492981     -17.226627
    [456]      -16.997179     -7.5396581     -3.0584650    -0.84746164
    [460]    -0.087924637    -0.55585575     -2.4344661     -6.6728048
    [464]      -18.708046     -10.907063     -4.4891000     -1.8696108
    [468]     -0.76047444   -0.050485302     0.95079660      1.9860041
    [472]       2.3402319      1.4866647    -0.82805568     -3.2773516
    [476]      -1.8505434     0.49419203      1.2128435     0.16185477
    [480]      -2.1784275     -2.9409995    -0.66999125      1.2845818
    [484]       2.0686703      1.9285703      1.2679945     0.49227601
    [488]     -0.28287214     -1.4503520     -3.8592527     -9.6107254
    [492]      -21.524555     -5.8433523    -0.82593107      1.6059737
    [496]       2.5728736      2.4247510      1.2631637    -0.97242546
    [500]      -4.5664573     -10.468214     -26.351589     -14.912967
    [504]      -7.4691405     -3.0588050   -0.063936576      1.8955460
    [508]       3.0596511      3.6602831      3.9227567      4.0220385
    [512]       4.0477424
  [Tag]         3201
  [frame_len]          320
[Record 21]
  [tot_power]       283134.06
  [re_spec_val]
    [0]       22.085657      21.551989      19.908415      17.004078
    [4]       12.475891      5.3419390     -7.5323472     -5.1528692
    [8]      -3.7054620     -5.5150666     -6.4613848     -5.7889261
    [12]      -4.1652160     -1.4012978    0.065308645    -0.88383996
    [16]      0.27309313      4.2661166      3.6616457      5.1573286
    [20]       17.262945      24.240450      28.721127      31.567020
    [24]       33.116276      33.508034      32.770050      30.834162
    [28]       27.501017      22.297367      13.862350    -0.50609088
    [32]       5.3182797      4.8717427      1.5090998     -1.9069695
    [36]      -4.6436801     -6.1802473     -5.0179758     -3.3107209
    [40]      -3.1043763     -3.9595284     -2.8508394      8.8068237
    [44]       18.062267      24.547153      29.154457      32.331429
    [48]       34.313950      35.225777      35.117519      33.978394
    [52]       31.728237      28.181700      22.948469      15.194225
    [56]       5.7706757      5.5812974      3.7732279    -0.99353796
    [60]      -5.5222454     -12.680373     -11.567088     -4.5350089
    [64]      -3.5584035     -5.3153453     -5.2286534    -0.80692422
    [68]       6.1441345      12.468955      17.260359      20.681528
    [72]       22.942350      24.175869      24.451561      23.795500
    [76]       22.208548      19.693882      16.318392      12.322998
    [80]       8.1130438      3.7654240     -1.2532445     -7.1037936
    [84]      -12.476706     -17.515245     -18.131096     -12.478817
    [88]      -8.8782120     -7.8328652     -9.7502947     -14.884315
    [92]      -12.925551    -0.68325847      8.2755156      14.620920
    [96]       19.146332      22.273279      24.226311      25.119169
    [100]       24.990986      23.815655      21.488424      17.774885
    [104]       12.167787      3.7572854     -1.1201288     0.51715648
    [108]     -0.67874080     -3.8183663     -8.2248535     -14.079373
    [112]      -15.242725     -11.833085     -10.744112     -10.478580
    [116]      -7.1592240     -1.1148617      4.8553815      9.8745346
    [120]       13.775844      16.579931      18.345329      19.121553
    [124]       18.939371      17.818968      15.801802      13.032084
    [128]       9.8756428      6.7801552      3.6403816    -0.23931015
    [132]      -5.2958803     -10.236141     -11.799935     -10.672269
    [136]      -8.9535637     -8.0163469     -8.2869358     -9.9894104
    [140]      -12.700768     -11.013261     -7.6695914     -7.8339419
    [144]      -12.807385     -2.3572609      5.0006223      9.2864132
    [148]       11.759093      12.859379      12.755477      11.495308
    [152]       9.1210461      6.0640388      4.0255184      3.9359889
    [156]       3.9131813      2.8740702     0.56878245     -3.2536645
    [160]      -8.6372385     -9.9077711     -6.7587361     -5.2453890
    [164]      -5.1461296     -5.3382421     -4.1369438    -0.30687451
    [168]       4.7707992      9.3484392      12.932447      15.519292
    [172]       17.191597      18.027969      18.091644      17.437057
    [176]       16.123100      14.235251      11.925147      9.4693155
    [180]       7.2594399      5.5069880      3.8869658      1.7094301
    [184]      -1.8845108     -8.3678646     -11.375899     -5.2309237
    [188]      -2.4632466     -1.6247288     -1.5482566    -0.89799273
    [192]       1.0389309      4.2929296      8.4170218      12.326337
    [196]       15.374488      17.395845      18.374228      18.296158
    [200]       17.093571      14.585517      10.330162      3.1150682
    [204]      -5.0823278   -0.044464841      1.1934052    -0.19694181
    [208]      -3.1223993     -6.3142023     -7.6715612     -6.3920183
    [212]      -4.4463224     -3.7492714     -5.4262223     -11.422958
    [216]      -30.972948     -16.405397     -2.5504704      6.7730951
    [220]       12.866555      16.993994      19.695553      21.225426
    [224]       21.698530      21.142859      19.519987      16.762684
    [228]       13.042186      9.9139757      9.2939129      9.0878696
    [232]       7.6914349      4.8951068      1.0948898     -1.9172812
    [236]      -2.4329052     -2.1065674     -2.3517704     -3.8417544
    [240]      -6.5261207     -6.4272532     -1.7088115      3.9075487
    [244]       9.1354055      13.389643      16.579161      18.790005
    [248]       20.121376      20.646320      20.410782      19.447943
    [252]       17.815697      15.685424      13.471188      11.697836
    [256]       10.370449      8.9506006      7.0536132      4.7685342
    [260]       2.6993675      1.3868768     0.33700842     -1.5164455
    [264]      -5.3166690     -11.397999     -8.7322292     -2.9577906
    [268]       3.3705461      9.0451241      13.310714      16.264544
    [272]       18.104588      18.982389      18.998768      18.208349
    [276]       16.609528      14.105797      10.393750      4.5280051
    [280]      -9.2141342     -3.9797702      1.8248365      3.5857413
    [284]       3.8406026      3.4015346      2.7715418      2.1612101
    [288]       1.4411464     0.59347713    0.043142553    -0.16140284
    [292]      0.39403045      4.4672165      9.7018661      13.681603
    [296]       16.267853      17.617929      17.831976      16.928604
    [300]       14.829126      11.279622      5.5095477     -5.8812246
    [304]      -3.3586524      2.3347657      4.5563402      5.2848349
    [308]       4.9241643      3.8348739      3.1887786      4.1366019
    [312]       5.5461316      6.1917024      5.7740750      4.4453521
    [316]       2.9385428      3.0226820      5.7149329      9.3587046
    [320]       12.524859      14.779615      16.057634      16.382429
    [324]       15.792739      14.338248      12.113592      9.3326101
    [328]       6.4050622      3.8650062      2.1627455      1.5012324
    [332]       1.5268652      1.6304532      1.6408880      1.8295522
    [336]       2.2467649      2.3216863      1.3349874    -0.95885342
    [340]      -2.1429927   0.0056648320      1.3761384      1.8154895
    [344]       5.3583751      10.192780      13.617912      15.516925
    [348]       16.042347      15.222621      12.893861      8.4909945
    [352]    -0.021334209     -5.4281216     0.89733207      1.5709804
    [356]     -0.71450722     -5.5477905     -10.580651     -8.8783302
    [360]      -6.3832788     -4.7578893     -4.3022418     -5.8078537
    [364]      -10.706100     -22.128716     -14.862411     -4.9743581
    [368]       3.5766444      9.5334797      13.588538      16.204351
    [372]       17.623405      17.961164      17.247274      15.431940
    [376]       12.356400      7.6486835     0.46159822     -6.8988805
    [380]      -3.8706548     -2.3669188     -2.2692897     -2.0566084
    [384]     -0.77870780     0.95366049      2.0305855      1.8577247
    [388]      0.13432284     -2.9044902     -4.4450445     -3.5412214
    [392]      -2.0732923      2.8738842      8.3036528      12.243140
    [396]       14.803883      16.228300      16.674978      16.236973
    [400]       14.963609      12.867407      9.9013968      5.8443208
    [404]     -0.19151542     -12.929855     -6.0709696    -0.60926437
    [408]       1.3214107      1.4024109   -0.076093592     -3.4031658
    [412]      -9.0783091     -7.5251756     -2.2188277     0.25613251
    [416]      0.11168955     -4.2274723     -12.746665      2.2602868
    [420]       7.8612051      10.879018      12.464615      13.079591
    [424]       12.992122      12.358737      11.200757      9.3749247
    [428]       6.5615053      2.1660919     -5.0740476     -10.645994
    [432]      -6.3393879     -5.5364852     -7.5195885     -12.485716
    [436]      -25.217911     -16.217266     -9.6022291     -5.8112688
    [440]      -3.3449886     -1.9976497     -1.4262511   -0.040136781
    [444]       3.3180511      6.8563499      9.4412384      10.922778
    [448]       11.336112      10.686066      8.8855143      5.6682835
    [452]      0.34430811     -7.6526122     -5.8324065     -2.8358691
    [456]      -2.6391668     -4.0730553     -5.2859249     -4.1483426
    [460]      -2.3268290     -1.3717141     -1.5028775     -2.6886899
    [464]      -4.8701482     -7.3500795     -7.3083920     -4.8013153
    [468]      -2.5011542    -0.60451543      1.4912792      3.8652925
    [472]       6.0313182      7.5975242      8.4032841      8.3805323
    [476]       7.4481602      5.4305534      1.8967706     -4.5244827
    [480]      -21.485910     -7.6287947     -3.8812873     -3.3656747
    [484]      -4.9031901     -8.7864943     -18.388548     -16.774822
    [488]      -8.4482622     -4.7582850     -3.0484755     -3.0811608
    [492]      -5.2960572     -7.8724504     -2.1757674      3.1052113
    [496]       6.4315801      8.4454746      9.5045757      9.8174992
    [500]       9.5330887      8.7745075      7.6355619      6.1511970
    [504]       4.2763977      1.9118904     -1.0165246     -4.4181333
    [508]      -7.8051248     -10.192821     -10.929631     -10.668533
    [512]      -10.448626
  [Tag]         3361
  [frame_len]          320
[Record 22]
  [tot_power]       237640.12
  [re_spec_val]
    [0]       23.155861      22.616175      20.955284      18.030777
    [4]       13.538370      6.9783831     0.42675516      1.1226214
    [8]       1.7282293     0.82121897     -1.5765049     -7.1159983
    [12]      -25.802256     -17.232601     -11.342866      2.4204211
    [16]       8.4074144      10.850259      12.992777      19.466934
    [20]       25.724480      30.222094      33.244896      35.045300
    [24]       35.758682      35.436935      34.064228      31.552280
    [28]       27.712601      22.209135      14.776408      8.4412088
    [32]       6.0372510      1.0992068     -6.0351553     -3.5978796
    [36]      -1.5431871    -0.71358937     -2.3376012    -0.78919429
    [40]       6.0755706      9.6879196      10.773228      13.513628
    [44]       19.560049      24.561159      27.939915      29.964474
    [48]       30.828354      30.631630      29.411724      27.168634
    [52]       23.905737      19.747238      15.188457      10.924844
    [56]       6.4594927    -0.46931899     -18.519819     -4.6754131
    [60]      -2.0284059     -3.0402696     -4.8248448     -2.7029479
    [64]     0.045377649      1.9474642      4.9989438      9.2934580
    [68]       13.139331      15.976210      17.804075      18.700138
    [72]       18.731482      17.957418      16.453856      14.351170
    [76]       11.860952      9.2061253      6.4371562      3.4604414
    [80]      0.60478532    -0.93200213    -0.77457893     0.27917162
    [84]       1.7937118      3.2681093      4.3081632      5.0403647
    [88]       5.9657230      7.1472802      7.9063349      7.6273394
    [92]       7.0389304      9.6441851      14.012257      17.367073
    [96]       19.466921      20.478230      20.539440      19.756664
    [100]       18.251116      16.225758      13.987977      11.743914
    [104]       9.2484360      5.8379989     0.93037194     -2.1624782
    [108]      0.33599186      2.0306625      2.2738647      1.5897939
    [112]      0.22313417     -1.6848862     -3.2618301     -3.2240512
    [116]      -1.5807192      1.8924960      5.9784994      9.2659721
    [120]       11.429435      12.509109      12.578050      11.676741
    [124]       9.8162661      7.0622816      3.9750729      2.4076316
    [128]       3.0198205      4.0246387      4.7010403      5.1356287
    [132]       5.4575067      5.6102886      5.3963890      4.5916362
    [136]       2.9752228     0.25351086     -4.1050277     -9.5079861
    [140]      -6.8325605     -2.8271055    -0.77564919   -0.040842697
    [144]     0.018650889     0.31092104      1.5314009      3.3156526
    [148]       4.9931417      6.2381430      6.9481421      7.1235242
    [152]       6.8474512      6.2607303      5.4678473      4.4460688
    [156]       3.1342580      1.7219471     0.83819318     0.90674925
    [160]       1.4726175      1.9831642      2.2315414      2.1171744
    [164]       1.4167261    -0.37547657     -4.4827085     -13.260068
    [168]      -4.6179051      1.0776323      3.9635246      5.4943643
    [172]       6.3030877      6.6847353      6.6278863      5.9170842
    [176]       4.2836933      1.4814907     -2.5278270     -6.4420438
    [180]      -7.9696989     -9.6370049     -13.919971     -11.079993
    [184]      -4.6089287    -0.62430924      1.8064572      3.1715050
    [188]       3.7996821      4.1833000      5.0291424      6.5505757
    [192]       8.1600494      9.2974300      9.7591829      9.5745831
    [196]       8.9222403      8.0779648      7.3457661      7.1267467
    [200]       7.8799973      9.3943081      10.863561      11.736427
    [204]       11.802361      10.983004      9.2071352      6.3231015
    [208]       1.9096967     -5.5630322     -13.209634     -4.0481677
    [212]     0.034255452      2.2584102      3.3553200      3.2938125
    [216]       1.5455284     -3.8824940     -13.468471      1.5254917
    [220]       7.0175128      10.141356      11.966499      12.823640
    [224]       12.860756      12.289266      11.641662      11.636782
    [228]       12.184532      12.442627      11.751529      9.6575346
    [232]       5.7905035      3.2237756      6.9355936      10.100359
    [236]       11.801831      12.566001      12.796287      12.791322
    [240]       12.748486      12.754539      12.843131      13.061690
    [244]       13.392186      13.611037      13.340219      12.196910
    [248]       9.9267273      7.3826661      8.3077621      11.255870
    [252]       13.245047      13.901767      13.081497      10.122823
    [256]       1.6910803      1.3851594      10.661880      14.264988
    [260]       15.893575      16.486183      16.579678      16.560015
    [264]       16.617132      16.773071      17.019470      17.331646
    [268]       17.561892      17.435072      16.652363      14.948242
    [272]       12.089626      7.9926128      3.6372032      1.7670964
    [276]       1.7571421      2.2606628      2.7111588      1.8337816
    [280]      -1.9485682     -15.500792     -5.2703376     0.31571302
    [284]       2.1547265      2.5311909      2.6828020      3.7867789
    [288]       6.2507801      9.2594509      11.995374      14.134024
    [292]       15.593674      16.360569      16.437498      15.843801
    [296]       14.636170      12.939878      10.979461      9.0973539
    [300]       7.7238474      7.1271238      7.1286912      7.4170170
    [304]       7.8353567      8.1333790      7.8632402      6.5908103
    [308]       4.1393538      1.6298090      2.4458852      5.6762571
    [312]       9.2381859      12.543712      15.261615      17.297421
    [316]       18.695198      19.524130      19.831085      19.639914
    [320]       18.971693      17.867474      16.420649      14.866496
    [324]       13.698009      13.350723      13.530983      13.605172
    [328]       13.284508      12.643208      11.880828      11.064981
    [332]       10.104555      8.9942207      8.0283127      7.7745214
    [336]       8.5976896      10.140433      11.730534      12.928886
    [340]       13.532001      13.421678      12.483124      10.676620
    [344]       8.7694998      9.3698568      11.984203      14.135933
    [348]       15.258805      15.346519      14.392694      12.299567
    [352]       8.8305206      3.6395984     -1.7043389     -1.4386816
    [356]      -1.0590885     -3.6335061     -13.044025     -10.078710
    [360]      -1.5043517      2.1924450      4.1018081      4.9011374
    [364]       4.7312016      3.5922420      2.3138711      3.9006882
    [368]       7.5526295      10.660819      12.847237      14.234136
    [372]       14.912898      14.900109      14.163520      12.664843
    [376]       10.438709      7.7724113      5.4180379      4.2055221
    [380]       4.3164849      5.3432169      6.4328294      6.9270315
    [384]       6.7293158      6.3619757      6.6878309      7.6704121
    [388]       8.4461470      8.4471569      7.4611511      5.5775270
    [392]       3.9659362      4.6180930      6.1311951      6.6834054
    [396]       6.0041299      4.9981818      5.7319150      7.6595736
    [400]       8.9533329      9.2516031      8.9327316      8.6618710
    [404]       8.7134047      8.6481667      8.0355825      6.9424419
    [408]       6.0926042      6.4629898      7.9220033      9.5434256
    [412]       10.687724      11.003692      10.203820      7.8733969
    [416]       3.2101631     -2.1820023      1.8142427      4.2863083
    [420]       3.7979558     0.40565839     -3.9729924     0.11745729
    [424]       3.5739694      5.1147995      5.7263260      5.8272686
    [428]       5.1833177      3.1133978     -1.8057004     -12.870648
    [432]      -2.7582676      1.8129798      3.4733956      3.7041671
    [436]       3.2371945      2.7374766      2.7860374      3.5226431
    [440]       4.6050901      5.5810432      6.1039424      5.9654689
    [444]       5.1869721      4.3694825      4.6409101      5.7952504
    [448]       6.5605159      6.2642241      4.6977663      2.0954449
    [452]      0.41585580      1.4852227      2.8249769      3.2264438
    [456]       2.8534224      2.1163890      1.2577966     0.13758324
    [460]      -1.5931870     -4.2557340     -8.1433640     -13.818449
    [464]      -22.026072     -15.901391     -9.0390940     -4.3748417
    [468]     -0.95327163      1.5332292      3.1740477      3.9459622
    [472]       3.7323895      2.2868769    -0.84554285     -5.2239242
    [476]      -3.1929872     0.95577449      3.2494767      4.1191525
    [480]       3.9017992      2.8033738      1.1855574    0.043479320
    [484]      0.35740936      1.3224792      1.8084525      1.3786592
    [488]     -0.15516433     -3.1194463     -8.7401934     -20.921282
    [492]      -7.7588382     -2.0145097     0.99021357      2.3080723
    [496]       2.0968449     0.11178628     -4.5208898     -10.371011
    [500]      -4.4004745    -0.52781117      1.1543401      1.6912423
    [504]       1.6396798      1.2665092     0.56408387    -0.63784266
    [508]      -2.5282147     -5.2715554     -9.0835667     -14.449492
    [512]      -19.694294
  [Tag]         3521
  [frame_len]          320
[Record 23]
  [tot_power]       121563.08
  [re_spec_val]
    [0]       17.332302      16.764648      15.036757      12.105847
    [4]       8.1490173      4.4610758      2.7763083      1.5899284
    [8]     -0.58428103     -3.7893543     -6.9808908     -8.6038361
    [12]      -10.678351     -12.397863     -8.9262781     -5.8145556
    [16]       6.9657240      15.910812      22.135660      26.611193
    [20]       29.774612      31.850628      32.961700      33.171551
    [24]       32.504795      30.958157      28.513720      25.172880
    [28]       21.049055      16.506744      11.935171      6.9147592
    [32]      0.57158166     -4.3482451     -1.9100718      3.2332318
    [36]       7.1835780      9.7028360      11.977921      15.026805
    [40]       18.240452      20.760441      22.305948      22.846048
    [44]       22.407242      21.091106      19.314478      18.105000
    [48]       18.019949      18.090652      17.408661      15.624332
    [52]       12.579269      8.2211447      3.2429924    0.037850820
    [56]      -1.8101953     -4.0450273     -3.7388713    -0.73081899
    [60]       1.9277394      3.9844055      5.7265182      7.1823974
    [64]       8.1470175      8.3907490      7.7760549      6.3286467
    [68]       4.4629092      3.1895964      2.9595830      2.8471308
    [72]       2.0849304     0.46073094     -2.0014923     -5.1329002
    [76]      -8.5711851     -12.048658     -16.195107     -21.252575
    [80]      -19.055424     -14.613156     -10.883424     -7.0382290
    [84]      -3.5937140     -1.0348232     0.60271519      1.5815732
    [88]       2.4659810      3.8489916      5.6634507      7.3625116
    [92]       8.5760155      9.1834421      9.1743193      8.5676861
    [96]       7.3868499      5.6661162      3.4800186     0.96374261
    [100]      -1.7765193     -4.9205003     -9.0240211     -12.860214
    [104]      -10.169711     -6.4591832     -4.0688152     -2.5379617
    [108]      -1.4770936    -0.64010775     0.13547650     0.94264942
    [112]       1.7785852      2.5453038      3.1034594      3.3262537
    [116]       3.1191382      2.4204535      1.2076288    -0.47452876
    [120]      -2.4614730     -4.4512458     -6.1598339     -7.5511975
    [124]      -8.7820034     -10.073898     -11.767275     -14.166621
    [128]      -16.459841     -16.067263     -14.392008     -13.672443
    [132]      -14.050619     -14.699352     -14.023069     -11.575275
    [136]      -8.6094732     -6.0056767     -4.0612440     -2.8267207
    [140]      -2.2489176     -2.2263401     -2.6409862     -3.3806334
    [144]      -4.3247385     -5.2751923     -5.9421320     -6.1756854
    [148]      -6.1715865     -6.2338142     -6.4914613     -6.8626208
    [152]      -7.1409526     -7.1617327     -6.9770775     -6.8361559
    [156]      -7.0055161     -7.6510172     -8.7982426     -10.273185
    [160]      -11.597750     -12.063508     -11.336455     -9.9082756
    [164]      -8.5463047     -7.7471867     -7.6962280     -8.2967768
    [168]      -9.0409498     -9.1204443     -8.4199610     -7.6202931
    [172]      -7.2170362     -7.4179358     -8.4070969     -10.434771
    [176]      -13.223464     -13.297428     -10.276961     -8.1557474
    [180]      -7.6279926     -8.5673580     -10.265423     -10.712359
    [184]      -9.9641771     -10.563658     -14.610310     -17.665594
    [188]      -8.8695965     -4.2156372     -1.7752295    -0.64282048
    [192]     -0.41738892    -0.89497435     -1.9780927     -3.6042669
    [196]      -5.6291595     -7.6625857     -8.9716587     -8.8440304
    [200]      -7.5817342     -6.3412957     -6.0386791     -7.3106313
    [204]      -10.718460     -11.757360     -6.4344115     -2.8014672
    [208]      -1.0391742    -0.69359338     -1.5200605     -3.1991732
    [212]      -4.7653747     -4.8383117     -3.9517603     -3.3785517
    [216]      -3.5095389     -4.3163476     -5.7230530     -7.7294769
    [220]      -10.165210     -11.419286     -9.8356867     -7.6525607
    [224]      -5.9935541     -4.3693762     -2.3297524    -0.31006369
    [228]       1.0159452      1.2144536    -0.10717791     -3.6271129
    [232]      -8.3531094     -4.0040889     0.12360570      2.0794866
    [236]       2.8192725      3.1688311      3.7517700      4.5651388
    [240]       5.2300086      5.5321045      5.4853678      5.1861005
    [244]       4.6715298      3.8220041      2.3106749    -0.50925475
    [248]      -6.3780413     -28.656988     -6.7376604     -2.9496944
    [252]      -3.2780106     -8.8807287     -8.0299377      1.5146998
    [256]       6.1959891      8.8961926      10.522716      11.568913
    [260]       12.301219      12.737721      12.738757      12.171971
    [264]       11.015306      9.4211483      7.8103786      6.8837557
    [268]       7.1029544      8.0977402      9.2139912      10.097035
    [272]       10.644908      10.840290      10.669426      10.119923
    [276]       9.2104149      8.0144691      6.6684151      5.3600326
    [280]       4.2591953      3.3676374      2.4559550      1.2067899
    [284]     -0.68180680     -3.6792319     -8.2814684     -6.0698180
    [288]      0.25002006      4.2353544      6.4380360      7.1844378
    [292]       6.5736527      4.7286825      2.6112955      2.5394440
    [296]       3.7448211      4.1969986      3.6625028      2.7111115
    [300]       1.6984575    -0.42902982     -7.2798929     -5.3125677
    [304]       3.9670317      8.3793850      10.651016      11.347243
    [308]       10.356971      6.6426721     -5.7232537      5.7570686
    [312]       11.933658      14.487304      14.885530      13.145570
    [316]       7.9233980     -3.7849164      9.2457809      13.673893
    [320]       15.310807      15.493695      14.944113      14.373943
    [324]       14.248323      14.478823      14.785812      14.933842
    [328]       14.600080      13.291352      10.129176      2.0718417
    [332]       2.0393131      10.859983      14.696754      16.669819
    [336]       17.536745      17.577639      16.920622      15.674746
    [340]       14.050161      12.507420      11.768513      12.197498
    [344]       13.234538      14.079618      14.245111      13.473292
    [348]       11.573616      8.3943214      4.5648704      3.7476368
    [352]       5.5275645      6.5418782      6.3266702      4.8564811
    [356]       1.7406865     -4.1436157     -4.2821574      2.3470495
    [360]       6.1413569      8.2641850      9.2574778      9.3202133
    [364]       8.4967813      6.7275133      3.8692763    -0.14175966
    [368]      -4.2436104     -6.2403784     -9.1548643     -18.429117
    [372]      -6.9983191     -1.4971308     0.36024231    -0.14224038
    [376]     -0.63889790      3.0976589      7.2468925      9.9396381
    [380]       11.323970      11.610474      10.935623      9.4219770
    [384]       7.3662310      6.1897068      8.3074074      11.895969
    [388]       14.854324      16.815241      17.815338      17.940989
    [392]       17.285059      15.948929      14.056992      11.823191
    [396]       9.6779013      7.9792585      6.0454879      1.8322215
    [400]      -5.6675005      4.6023526      10.150517      13.237077
    [404]       15.106680      16.259821      16.922716      17.203085
    [408]       17.185530      16.945721      16.475420      15.613523
    [412]       14.058597      11.365491      6.7273011    -0.81393528
    [416]       1.6210299      5.9346714      7.6321363      7.9807653
    [420]       7.7419038      7.4476824      7.2318006      6.9165063
    [424]       6.6575103      7.3392177      9.2132225      11.205047
    [428]       12.548140      13.024345      12.591874      11.219929
    [432]       8.8249016      5.2330246     0.48425567     -1.9301848
    [436]      0.70258051      3.2370050      4.8671079      5.8060040
    [440]       6.1049843      5.6895995      4.4788160      2.5916810
    [444]      0.80171049     0.18862857    0.063665189    -0.92048967
    [448]      -2.6367259     -1.9507971      1.0250155      3.1317134
    [452]       3.7950499      3.0659630      1.0347129     -1.6422254
    [456]      -2.3691897    -0.66118968     0.95883679      1.8324593
    [460]       1.9887376      1.3887236    -0.11608952     -2.5644617
    [464]      -5.0429168     -5.5342216     -5.3229589     -6.9257860
    [468]      -12.951225     -21.354593     -8.9879341     -6.1011472
    [472]      -7.1795702     -14.353821     -13.318028     -4.7109799
    [476]      -1.6455208     -1.2093866     -2.9563766     -7.2148910
    [480]      -15.141912     -21.413193     -13.974339     -6.4860930
    [484]      -1.4400997      1.5866374      3.1234879      3.5241714
    [488]       3.0621576      2.0039709     0.62006670    -0.89009422
    [492]      -2.4723954     -4.1239681     -5.6844363     -6.9204206
    [496]      -8.0901470     -10.005632     -13.017165     -13.190705
    [500]      -9.4935932     -6.8630147     -5.6877403     -5.5162840
    [504]      -5.7610722     -5.6576614     -4.7661800     -3.4878333
    [508]      -2.4688327     -2.0787334     -2.3996053     -3.1648018
    [512]      -3.6110568
  [Tag]         3681
  [frame_len]          320
[Record 24]
  [tot_power]       34875.160
  [re_spec_val]
    [0]       12.633328      12.107177      10.467082      7.5000143
    [4]       2.7112682     -5.2351294     -24.807232     -20.530371
    [8]      -28.430756     -18.490013     -16.740129     -15.585629
    [12]      -7.9611387     -4.5085535     -5.2557931     -3.8479009
    [16]       5.1023393      11.198899      15.215333      17.817608
    [20]       19.304422      19.819227      19.435478      18.205626
    [24]       16.220884      13.713202      11.118052      8.7533178
    [28]       6.3294969      3.2999406    -0.27131575     -2.6735635
    [32]      -2.7128503     -1.9625576     -1.1456484    -0.66955829
    [36]     -0.40701094      2.3361762      7.2264037      11.316603
    [40]       14.052037      15.504570      15.718675      14.618184
    [44]       11.962523      7.6826892      6.0994277      9.2881126
    [48]       11.354259      11.877810      11.196277      9.5011225
    [52]       6.8645158      3.2617991     -1.4317956     -7.3783460
    [56]      -13.969781     -16.844395     -14.228297     -10.771194
    [60]      -8.4966402     -7.6040573     -7.7421265     -8.1184158
    [64]      -7.9252744     -7.4562645     -7.5125604     -8.4200211
    [68]      -9.9681768     -11.488472     -12.585114     -13.938477
    [72]      -16.589222     -21.701675     -30.705400     -27.893030
    [76]      -25.046898     -24.821369     -23.570307     -20.485317
    [80]      -17.988628     -17.005882     -17.878042     -20.929050
    [84]      -22.945639     -19.271746     -16.977188     -17.202169
    [88]      -19.678370     -21.454288     -19.013504     -17.576736
    [92]      -18.892754     -24.501560     -32.275101     -22.563694
    [96]      -20.413738     -22.212242     -24.390417     -19.369362
    [100]      -15.670468     -14.339113     -14.962759     -17.621540
    [104]      -23.204967     -32.400948     -26.845226     -23.994896
    [108]      -23.627239     -23.487686     -22.574177     -22.176271
    [112]      -23.987419     -31.370430     -29.050217     -21.131283
    [116]      -18.357542     -18.498203     -21.898611     -35.048840
    [120]      -25.890039     -19.580952     -17.246752     -16.429935
    [124]      -16.262857     -16.450825     -17.054565     -18.127615
    [128]      -19.475481     -20.691601     -21.401773     -21.399193
    [132]      -20.721439     -19.719627     -18.816523     -18.350925
    [136]      -18.617584     -19.870626     -22.051933     -23.343813
    [140]      -21.350401     -18.600563     -16.611883     -15.520694
    [144]      -15.423368     -16.598478     -19.650530     -25.817013
    [148]      -27.194721     -22.112743     -20.681896     -22.353998
    [152]      -28.584610     -32.532822     -23.863811     -20.962343
    [156]      -20.609690     -21.564672     -21.549202     -19.106428
    [160]      -16.419685     -14.609515     -13.773639     -13.856512
    [164]      -14.796899     -16.533806     -18.969284     -21.252239
    [168]      -20.152573     -16.590784     -13.713244     -12.099129
    [172]      -11.794281     -12.929365     -15.871201     -21.039068
    [176]      -23.023256     -19.880310     -18.963194     -19.717953
    [180]      -19.541260     -17.669632     -16.339497     -15.973104
    [184]      -15.443351     -13.914112     -12.397789     -11.881317
    [188]      -12.727395     -15.157518     -19.476912     -25.842552
    [192]      -33.231430     -46.354553     -29.083061     -23.868679
    [196]      -23.051727     -27.116840     -35.894566     -21.994394
    [200]      -17.437033     -15.835762     -15.966076     -16.954105
    [204]      -17.825064     -18.811987     -21.710718     -26.360136
    [208]      -19.535778     -14.505868     -12.176765     -11.694908
    [212]      -12.761456     -15.115918     -17.326969     -16.793217
    [216]      -15.215549     -14.416134     -14.423853     -14.873282
    [220]      -15.642412     -17.295633     -21.101851     -22.981924
    [224]      -16.072281     -11.628945     -9.2694550     -8.3489809
    [228]      -8.5946426     -9.9484940     -12.649142     -17.796898
    [232]      -29.553495     -19.309462     -13.863146     -11.042240
    [236]      -9.0106115     -7.1632690     -5.6471786     -4.7377386
    [240]      -4.3640084     -4.0224938     -3.2640431     -2.3092418
    [244]      -1.4551698    -0.44916719     0.98812032      2.4650123
    [248]       3.3907840      3.4567173      2.5863442     0.86997813
    [252]      -1.3321478     -3.1938474     -3.6736321     -2.5528703
    [256]     -0.69168168      1.0377614      2.2678080      2.9414625
    [260]       3.1019328      2.7954865      2.0260706     0.70451128
    [264]      -1.4475034     -5.0974240     -11.379910     -10.853173
    [268]      -5.4517813     -2.7767591     -1.6033268     -1.1177765
    [272]     -0.88678479    -0.92340809     -1.4564492     -2.5628526
    [276]      -4.0222344     -5.5621138     -7.4908581     -11.007923
    [280]      -18.808044     -15.734421     -9.5358095     -7.4007363
    [284]      -8.1060162     -10.999918     -7.5510263     -1.8721108
    [288]       1.5350670      3.2116055      3.4965556      2.4850507
    [292]      0.14697957     -3.1760654     -4.6322846     -2.9001327
    [296]      -1.5149809     -1.2237402     -1.1361426     0.10156231
    [300]       2.0612564      3.3937476      3.4571083      2.1009407
    [304]      0.82052034      3.4228408      7.1043987      9.6901731
    [308]       11.316274      12.388541      13.221082      13.884817
    [312]       14.238010      14.104755      13.344083      11.687900
    [316]       8.1785793     -2.4232962      5.4737711      13.320115
    [320]       17.100620      18.921854      19.309959      18.446375
    [324]       16.391172      13.099030      8.1119194     0.75183415
    [328]       5.0729184      10.207648      12.901898      14.821690
    [332]       16.871881      18.763626      19.824490      19.679949
    [336]       18.233063      16.191422      16.305655      18.505686
    [340]       20.277945      21.194098      21.502150      21.412598
    [344]       20.938578      19.928030      18.158829      15.361485
    [348]       11.134166      4.7638803     -3.4482183     -4.9802461
    [352]      -6.1994224     -2.3728657      2.8233793      5.3664532
    [356]       5.7840481      4.2804022     0.59996521     -5.3003139
    [360]      -5.7659502     -3.2001991     -2.8588750     -2.6794484
    [364]     -0.45154959      2.0268457      3.3544133      3.3364034
    [368]       1.9454697    -0.79578298     -3.8779376     -4.4240699
    [372]      -3.7789316     -3.2116802     0.32063088      5.2127910
    [376]       9.1104116      11.905723      13.828691      15.066165
    [380]       15.749619      15.984389      15.888682      15.616597
    [384]       15.304704      14.938351      14.309595      13.180408
    [388]       11.575855      10.135828      9.5874548      9.4490499
    [392]       9.6728306      11.646720      14.535222      16.607700
    [396]       17.323313      16.497372      13.894179      10.354829
    [400]       11.822386      15.344773      17.532087      18.769821
    [404]       19.479153      19.695875      19.153521      17.443583
    [408]       13.927614      6.8278928     -13.041765      4.3116851
    [412]       6.4448471      5.8486366      5.1353011      4.8190556
    [416]       3.9458120      4.8357053      8.4989033      11.547913
    [420]       13.346601      14.222443      14.517897      14.422083
    [424]       13.924586      12.876376      11.053720      8.0968409
    [428]       3.3066294     -1.6424173      2.6957440      6.3626599
    [432]       7.9555616      8.1386967      7.5095882      7.0187869
    [436]       7.2412977      7.3135691      6.0047498      1.7646368
    [440]      -11.796380      1.1564344      6.5696220      8.7493086
    [444]       9.2688694      8.6334715      7.0026102      4.2541437
    [448]    -0.060719192     -5.3044419     -3.4915967     0.26982054
    [452]       2.7395697      4.4431362      5.4851189      5.7205462
    [456]       5.0074010      3.2500491     0.32927147     -4.0457296
    [460]      -7.8244982     -3.0824952      1.6279258      4.5091095
    [464]       5.9972711      6.3312216      5.6213002      3.9114141
    [468]       1.2332875     -2.2280128     -5.4821172     -6.1531730
    [472]      -4.1140542     -1.4654555     0.79917192      2.3957870
    [476]       3.2581406      3.3663654      2.6743405      1.0648334
    [480]      -1.6763660     -5.5507092     -7.5599022     -5.1214433
    [484]      -2.9427075     -2.0349660     -2.1181028     -2.8670332
    [488]      -3.9917672     -5.2618718     -6.3473234     -6.5419312
    [492]      -5.5075555     -4.0167480     -2.8142500     -2.1636584
    [496]      -2.1326187     -2.7732382     -4.1833997     -6.5432777
    [500]      -10.174850     -15.488582     -20.732811     -22.007744
    [504]      -24.887804     -16.032328     -8.8196201     -4.6548352
    [508]      -2.4773099     -1.9870627     -3.3169506     -7.1401596
    [512]      -12.171228
  [Tag]         3841
  [frame_len]          320
[Record 25]
  [tot_power]       73651.891
  [re_spec_val]
    [0]       12.515265      11.964078      10.267170      7.2737198
    [4]       2.6406920     -4.3370824     -11.656876     -9.8087378
    [8]      -8.8396311     -9.6832085     -12.015694     -17.292728
    [12]      -33.408638     -15.143565     -10.982091     -11.645512
    [16]      -12.640935     -3.7456982      2.0286026      5.2275958
    [20]       6.5857277      6.3618336      4.7538924      2.8775260
    [24]       3.3250158      5.0221219      5.8139191      5.3046627
    [28]       3.5075738     0.38205594     -4.1869364     -8.6618357
    [32]      -7.6663280     -5.7404084     -5.7478995     -7.9926400
    [36]      -9.1842251     -3.1863506      1.8795544      5.0516505
    [40]       6.6423144      6.6324339      4.5953832    -0.39438513
    [44]     -0.17699799      5.7759247      8.7700500      9.7172699
    [48]       9.0794897      6.9692860      3.4082658    -0.75828260
    [52]      -2.1984134     -1.6526396     -1.9664302     -3.5206020
    [56]      -6.2569580     -10.288952     -15.873910     -22.359579
    [60]      -27.309731     -34.275707     -25.915321     -19.740416
    [64]      -16.390562     -14.359652     -13.120831     -12.387440
    [68]      -11.897001     -11.525744     -11.407356     -11.798257
    [72]      -12.894641     -14.616998     -15.836000     -14.789159
    [76]      -12.773307     -11.434939     -11.109056     -11.662532
    [80]      -12.578702     -12.855755     -12.150828     -11.433023
    [84]      -11.592268     -13.203693     -17.268761     -29.478128
    [88]      -23.017609     -16.398117     -14.327670     -14.699712
    [92]      -17.730349     -24.942923     -19.978718     -14.195085
    [96]      -11.654491     -11.121097     -12.426115     -16.265751
    [100]      -27.005804     -21.849129     -15.220842     -12.794598
    [104]      -12.308983     -13.158965     -15.012131     -17.312281
    [108]      -18.886129     -19.027529     -18.641466     -18.576542
    [112]      -19.020296     -19.723833     -20.066051     -19.309944
    [116]      -17.152258     -14.153092     -11.222678     -8.9055195
    [120]      -7.4092035     -6.8174863     -7.2069044     -8.7115183
    [124]      -11.598870     -16.365574     -22.031275     -20.253412
    [128]      -17.403240     -16.053190     -15.366735     -14.819509
    [132]      -14.300119     -13.990470     -14.223626     -15.451960
    [136]      -18.485241     -26.181940     -28.456800     -18.853661
    [140]      -15.301636     -14.144519     -14.813630     -17.342411
    [144]      -20.214764     -17.591507     -14.183967     -12.631420
    [148]      -12.877451     -15.148372     -20.867598     -33.369987
    [152]      -20.936991     -17.696522     -18.420946     -24.237261
    [156]      -25.720568     -16.423832     -12.614432     -11.111648
    [160]      -10.930007     -11.282533     -11.363663     -11.007591
    [164]      -10.676455     -10.660019     -10.969944     -11.635300
    [168]      -12.833607     -14.655681     -16.317692     -16.070475
    [172]      -14.763095     -14.291896     -15.432633     -18.934982
    [176]      -25.536243     -21.533113     -16.544308     -14.193163
    [180]      -13.268616     -13.186280     -13.600330     -14.276548
    [184]      -15.106821     -16.210903     -17.768974     -18.558657
    [188]      -15.901675     -12.203949     -9.4694605     -7.8514590
    [192]      -7.2579722     -7.6663122     -9.1976700     -12.288555
    [196]      -18.587025     -37.595741     -17.696405     -12.876462
    [200]      -10.495333     -9.1893501     -8.4719591     -8.1249485
    [204]      -8.0706511     -8.3228807     -8.9462595     -10.015017
    [208]      -11.595745     -13.772610     -16.408180     -17.116175
    [212]      -13.920898     -10.681404     -8.7577991     -8.1990490
    [216]      -9.0124350     -11.269745     -14.701838     -16.862894
    [220]      -16.154783     -15.446031     -14.720966     -13.062551
    [224]      -11.478933     -11.140190     -12.793592     -18.306751
    [228]      -31.335520     -14.436361     -9.2347202     -6.2607198
    [232]      -4.2514248     -2.8391635     -1.9125168     -1.3533479
    [236]     -0.94774181    -0.47629514    0.096063398     0.54879218
    [240]      0.49713615    -0.51389825     -2.7784691     -4.2305608
    [244]      -1.2300954      1.7895381      3.0587554      2.5355294
    [248]      0.16681154     -2.9308865     -1.5191413      1.5326011
    [252]       3.1311042      3.3779535      2.5186739     0.65816134
    [256]      -2.1032443     -4.9266973     -5.5854154     -4.7685299
    [260]      -4.7743301     -6.2923031     -9.0577087     -10.259452
    [264]      -7.6808405     -4.2900591     -1.2250723      1.0613879
    [268]       2.2380507      2.0730610     0.22471678     -4.2293873
    [272]      -13.936434     -8.4733000     -4.0548615     -3.3430054
    [276]      -5.3811812     -11.148847     -8.3676710    -0.57443219
    [280]       4.2305059      7.4293022      9.4647923      10.471111
    [284]       10.462054      9.3756189      7.1092129      3.8085802
    [288]       1.2506320      1.4285159      1.7249336     0.67639595
    [292]     -0.76002681     0.27613404      2.7642055      4.5614791
    [296]       5.4117632      5.4639978      4.8702250      3.8609569
    [300]       3.0224125      3.6948690      6.6110115      10.229724
    [304]       13.298749      15.491824      16.784039      17.179813
    [308]       16.594091      14.694808      10.349034     -5.2155890
    [312]       8.2101116      14.997581      18.511522      20.802998
    [316]       22.452240      23.550089      23.961533      23.481760
    [320]       21.878891      18.935450      15.372025      15.551847
    [324]       18.424786      20.779119      22.598040      24.057165
    [328]       25.126793      25.765875      26.009785      25.942404
    [332]       25.654036      25.236528      24.778717      24.281357
    [336]       23.548428      22.191858      19.622135      14.511814
    [340]      -3.5062962      11.679259      17.276279      19.347378
    [344]       19.514004      18.003658      14.550802      9.7699099
    [348]       11.062666      14.112215      15.064429      14.222663
    [352]       11.853095      8.7936516      8.2899284      10.308569
    [356]       11.906137      12.589149      12.496313      11.771272
    [360]       10.554478      9.0720301      7.7498217      7.2146387
    [364]       7.8210068      9.1422243      10.472604      11.375554
    [368]       11.667207      11.288866      10.257195      8.6839437
    [372]       6.8307910      5.1814537      4.5326309      5.3409338
    [376]       6.6864257      7.4948182      7.4250507      6.7910504
    [380]       6.3946433      6.3948865      5.7785535      3.4053497
    [384]      -2.4112816     -20.856205     -6.5855980     -4.9048982
    [388]      -3.4964907      2.2675796      6.6151156      9.2307472
    [392]       10.684431      11.410030      11.819651      12.285975
    [396]       12.807372      12.858657      11.699125      9.1191301
    [400]       10.634910      16.136320      20.114801      22.612000
    [404]       24.027620      24.630953      24.629745      24.198803
    [408]       23.457602      22.434645      21.076136      19.302589
    [412]       17.070892      14.506956      12.464265      12.582433
    [416]       14.177635      15.482999      15.930887      15.515971
    [420]       14.451947      13.139800      11.947295      10.821546
    [424]       9.5987568      8.8836174      9.5829897      10.948318
    [428]       11.864130      11.975381      11.310702      10.164243
    [432]       9.3656759      9.9126921      11.378319      12.676602
    [436]       13.279061      12.986542      11.664353      9.3168097
    [440]       7.2483211      8.4264879      10.855687      12.355798
    [444]       12.694119      11.936471      10.138041      7.4367452
    [448]       4.4885936      2.8518698      2.8943594      3.3385940
    [452]       3.5192842      3.1554255      1.9400328    -0.45737654
    [456]      -3.9565570     -5.1408815     -2.0701020     0.79564428
    [460]       2.6658077      3.6026535      3.4736917      1.8726425
    [464]      -2.2929881     -13.165647     -4.6874981     0.94415218
    [468]       3.2280891      3.8139086      3.2311988      1.6842129
    [472]     -0.85200971     -4.7834764     -11.729494     -25.841719
    [476]      -12.622594     -9.2611170     -8.6115789     -8.0546198
    [480]      -5.4383650     -2.3200102   -0.057095505      1.2686483
    [484]       1.8737013      2.0118465      1.9130012      1.7285312
    [488]       1.4888012      1.1229522     0.55017495    -0.20940223
    [492]     -0.99019462     -1.6138476     -2.1325345     -2.8350091
    [496]      -4.0382338     -5.8971639     -7.6942844     -6.8915553
    [500]      -4.0544829     -1.6373967    -0.20063260     0.23426947
    [504]     -0.41717881     -2.5418756     -7.5849428     -19.391781
    [508]      -5.4993849     0.10230511      3.0649772      4.6081190
    [512]       5.0928016
  [Tag]         4001
  [frame_len]          320
[Record 26]
  [tot_power]       88970.820
  [re_spec_val]
    [0]       7.5801811      6.6748075      3.5961359     -3.9032798
    [4]      -11.874314    -0.19319472      3.1880260      4.3821115
    [8]       4.5641603      4.3191252      4.0254622      3.8824966
    [12]       3.9279175      4.1198606      4.4139013      4.7833667
    [16]       5.2108388      5.6650457      6.0588226      6.2382898
    [20]       6.0402565      5.3774233      4.3272052      3.2119935
    [24]       2.4524665      2.0409076      1.4452763    0.086904503
    [28]      -2.3856962     -5.0209579     -4.0016952     -1.3765279
    [32]     0.027697220    0.013700002     -1.2069116     -3.1492255
    [36]      -4.8584929     -5.7496018     -5.5417614     -3.2150512
    [40]    -0.093362577      2.1828117      3.2105701      2.8976185
    [44]       1.0424095     -2.7461381     -6.0977898     -2.3877554
    [48]      0.93461239      2.4536376      2.6519554      1.8991524
    [52]      0.63986701    -0.45570874    -0.82152754    -0.45172417
    [56]      0.38792804      1.3815705      2.1722519      2.5029700
    [60]       2.2840297      1.5818093     0.63812447    -0.10932983
    [64]     -0.24645537     0.20223396     0.86526126      1.4270037
    [68]       1.7236807      1.6693258      1.2080020     0.31328061
    [72]     -0.98453939     -2.5519478     -4.0933681     -5.1345444
    [76]      -5.2338376     -4.4266777     -3.2026129     -2.0057960
    [80]      -1.0338445    -0.31059393     0.22314747     0.65680820
    [84]       1.0809938      1.5626713      2.1151497      2.6824467
    [88]       3.1626439      3.4538553      3.4875138      3.2395773
    [92]       2.7318254      2.0340858      1.2674872     0.59675658
    [96]      0.19216740     0.15718564     0.46567979     0.97620261
    [100]       1.5172087      1.9624977      2.2531929      2.3822680
    [104]       2.3679962      2.2330415      1.9962136      1.6751343
    [108]       1.2932439     0.88558149     0.49816144     0.17420390
    [112]    -0.073679395    -0.28979385    -0.57929325     -1.0855075
    [116]      -1.9493172     -3.2492547     -4.8873177     -6.3895016
    [120]      -6.9307327     -6.1397042     -4.4901948     -2.6461983
    [124]      -1.0854465   -0.052928284     0.38614890     0.29157400
    [128]     -0.16706848    -0.70887381     -1.0036114    -0.86195904
    [132]     -0.38760135     0.12994465     0.41692320     0.29923505
    [136]     -0.30164415     -1.3825383     -2.8504028     -4.4920006
    [140]      -5.9538527     -6.8068275     -6.7602067     -5.9075742
    [144]      -4.6532254     -3.3804371     -2.2961211     -1.4712173
    [148]     -0.91332239    -0.61594522    -0.58438730    -0.84400558
    [152]      -1.4374638     -2.4202881     -3.8626540     -5.8591666
    [156]      -8.5219145     -11.755973     -13.947141     -12.634874
    [160]      -10.164321     -8.2666092     -7.0732393     -6.4770498
    [164]      -6.3700113     -6.6457210     -7.1857767     -7.8509960
    [168]      -8.4676962     -8.8237963     -8.7261953     -8.0973167
    [172]      -7.0032525     -5.6243978     -4.2100339     -3.0027952
    [176]      -2.1799250     -1.8441787     -2.0392542     -2.7644727
    [180]      -3.9843616     -5.6392026     -7.6449151     -9.7530079
    [184]      -10.984436     -10.083834     -8.0957985     -6.4794602
    [188]      -5.5762172     -5.0859389     -4.3775678     -3.1946414
    [192]      -2.0460532     -1.5165638     -1.9399921     -3.5860083
    [196]      -6.9636288     -13.346377     -15.199765     -8.6528502
    [200]      -4.9817033     -2.6556358    -0.99119121     0.16929841
    [204]      0.78909677     0.82406008     0.29906678    -0.66399670
    [208]      -1.8226149     -2.8215399     -3.3686640     -3.5582659
    [212]      -3.8564844     -4.7654729     -6.6799617     -9.8750334
    [216]      -13.989708     -16.970020     -20.653587     -25.699530
    [220]      -12.176166     -5.9794588     -2.3642962    -0.23142822
    [224]      0.79379112     0.80666417    -0.15391840     -1.4009538
    [228]     -0.65763092      1.9098948      4.0634642      5.3352094
    [232]       6.1259923      7.0195284      8.1594734      9.1448250
    [236]       9.5909414      9.3634014      8.5185003      7.2342196
    [240]       5.6883636      3.8188403      1.1959060     -2.4019830
    [244]      -2.9309330     0.97676694      3.9421861      5.4880524
    [248]       5.9244151      5.5904245      5.0875034      5.2417893
    [252]       6.1250062      6.9830327      7.2809014      6.8728094
    [256]       5.8301649      4.4274955      3.2127590      2.8034580
    [260]       3.3348207      4.4579186      5.7472649      6.8370471
    [264]       7.4272618      7.2505188      6.0006204      3.2685230
    [268]     -0.75511575    -0.75874776      2.2172749      3.4384503
    [272]       3.3988237      4.7559314      8.1620502      11.148160
    [276]       12.908926      13.403732      12.668752      10.854455
    [280]       8.5152493      6.3163390      5.7294493      11.020757
    [284]       16.674652      20.608755      23.124414      24.518270
    [288]       24.979395      24.625946      23.522043      21.674324
    [292]       19.007317      15.279322      9.7057858     -1.1370995
    [296]       4.1973171      10.800996      14.395971      16.837250
    [300]       18.751778      20.453253      22.063404      23.546307
    [304]       24.776922      25.616928      25.959845      25.752085
    [308]       25.026764      23.994045      23.134748      22.904875
    [312]       23.109949      23.134947      22.479692      20.678934
    [316]       16.741293      6.8245344      13.847404      20.553478
    [320]       23.821941      25.452765      26.023104      25.844297
    [324]       25.173615      24.275177      23.412497      22.780966
    [328]       22.403870      22.109486      21.661276      20.902206
    [332]       19.804489      18.453552      16.994492      15.536315
    [336]       14.049297      12.358166      10.332439      8.4044867
    [340]       7.7618604      8.1128225      7.7880702      6.2096148
    [344]       6.4430089      10.669025      14.380709      16.681789
    [348]       17.768639      17.783775      16.764503      14.665989
    [352]       11.411740      7.2764363      4.6610646      5.6966214
    [356]       7.5094500      8.9079161      9.7552767      9.9952841
    [360]       9.6497917      8.8250923      7.6455503      6.2343769
    [364]       5.0362659      5.0872602      6.3412423      7.3984179
    [368]       7.3929744      5.9463916      2.9195747     0.80059361
    [372]       3.9920611      7.5455427      9.9967241      11.539530
    [376]       12.237185      12.025414      10.790085      8.4466419
    [380]       5.4374022      4.2202363      5.6770616      7.1642151
    [384]       8.0121326      8.5665445      9.2334986      10.160493
    [388]       11.259574      12.448837      13.752001      15.189548
    [392]       16.669525      18.040836      19.192543      20.055925
    [396]       20.543411      20.511889      19.773487      18.119452
    [400]       15.346949      11.390905      6.7843909      2.0060015
    [404]      -5.6422887      2.2553396      8.2865267      11.155622
    [408]       12.463882      12.975526      12.925568      12.006186
    [412]       9.6535969      6.4749370      8.3216400      12.107442
    [416]       14.306850      15.154194      15.032365      14.230222
    [420]       12.981495      11.494922      10.038868      9.1085033
    [424]       9.2289352      10.158265      11.113268      11.576234
    [428]       11.358338      10.457088      9.0577803      7.6109838
    [432]       6.5518613      5.6085830      3.9249897     0.39250952
    [436]      -8.3192530     -9.7759876    -0.52718812      2.9406726
    [440]       4.3325567      4.2251487      2.4381583     -2.2429838
    [444]      -17.258106     -2.5172484      3.2352705      6.0762291
    [448]       7.5798941      8.2563000      8.2987070      7.7268114
    [452]       6.4240799      4.1418734     0.57043183     -3.1806035
    [456]      -2.0447407     0.50075442      1.5162702      1.0006610
    [460]     -0.89203310     -3.4569192     -3.6207309     -1.0408934
    [464]       1.2671726      2.6862321      3.3380539      3.3815532
    [468]       2.9607134      2.1910112      1.0990504    -0.41063672
    [472]      -2.3811290     -4.1611652     -4.2681403     -3.2575812
    [476]      -2.8358748     -3.6571441     -5.8064942     -8.7443132
    [480]      -10.767713     -11.898048     -14.545566     -18.180738
    [484]      -14.269694     -10.073950     -7.3088651     -4.8681083
    [488]      -2.4800019    -0.46753657     0.88585645      1.4611194
    [492]       1.2300063     0.24636579     -1.2713412     -2.8712304
    [496]      -4.1352639     -5.0221257     -5.4881487     -5.5266867
    [500]      -5.8109264     -7.3111100     -10.916705     -15.364825
    [504]      -11.899384     -7.8043022     -4.6578956     -1.9500707
    [508]    0.0036431202     0.88641739     0.61888444    -0.50597888
    [512]      -1.2723646
  [Tag]         4161
  [frame_len]          320
[Record 27]
  [tot_power]       55449.730
  [re_spec_val]
    [0]       11.878650      11.362827      9.7684622      6.9348693
    [4]       2.5236163     -3.9592006     -10.683790     -13.190826
    [8]      -21.049570     -14.683199     -8.9882784     -7.5275965
    [12]      -6.9047728     -4.9699688     -3.1449807     -1.9109668
    [16]      0.49650064      4.1367102      7.4000025      9.8105345
    [20]       11.423932      12.305181      12.445527      11.811720
    [24]       10.443753      8.5980806      6.7925534      5.4180140
    [28]       4.7208357      5.3645949      6.9248338      8.0016088
    [32]       7.8163481      5.9081535      1.7047551     -1.1989492
    [36]       3.1418359      5.7902331      6.1422057      4.4545431
    [40]       1.0651324     0.24505199      3.2759790      5.1505346
    [44]       5.5476851      5.1782136      4.9550915      5.1434283
    [48]       5.0501719      3.9704242      1.4128833     -3.2548804
    [52]      -10.758401     -14.153606     -16.481283     -17.257730
    [56]      -5.7316194    -0.72126496      1.5776315      2.0059834
    [60]      0.69263548     -2.7945809     -10.616740     -16.999538
    [64]      -7.9724956     -5.8271828     -6.3929119     -9.0840311
    [68]      -14.422097     -19.631460     -13.591233     -9.8068123
    [72]      -8.2921219     -8.5507135     -10.669740     -15.402780
    [76]      -26.000032     -23.808668     -19.389942     -19.450661
    [80]      -21.178085     -19.224672     -15.149856     -12.609534
    [84]      -11.844586     -12.878255     -16.030470     -21.753204
    [88]      -24.978552     -24.468243     -31.708929     -22.112919
    [92]      -13.830064     -9.3353567     -6.5928168     -4.9486361
    [96]      -4.1084867     -3.9133716     -4.2467542     -4.9592357
    [100]      -5.7856021     -6.3108444     -6.1723661     -5.4369922
    [104]      -4.5396972     -3.8725405     -3.6091237     -3.7396116
    [108]      -4.1617765     -4.7944989     -5.6406569     -6.7111158
    [112]      -7.8692007     -8.7467709     -8.8842745     -8.0759993
    [116]      -6.5229092     -4.6251130     -2.7734237     -1.2866220
    [120]     -0.40390155    -0.30233887     -1.1372414     -3.0991466
    [124]      -6.4948363     -11.749261     -16.830120     -15.672776
    [128]      -15.014751     -17.235115     -24.592670     -24.403059
    [132]      -15.692767     -11.629255     -9.3763161     -8.2295990
    [136]      -7.8452058     -7.7417126     -7.2578092     -6.2933021
    [140]      -5.4816904     -5.3440652     -5.9876881     -7.1066756
    [144]      -8.0373964     -8.5140162     -9.2063637     -10.894532
    [148]      -13.742891     -15.164901     -12.661979     -10.146464
    [152]      -8.5859289     -7.4022684     -6.0456233     -4.6124477
    [156]      -3.5898495     -3.3060815     -3.8156044     -4.8830924
    [160]      -5.9628611     -6.6618261     -7.3695765     -8.8338804
    [164]      -11.750329     -17.080917     -21.428289     -15.875054
    [168]      -12.287230     -10.417979     -9.5311708     -9.3216705
    [172]      -9.7211456     -10.816662     -12.128896     -10.906594
    [176]      -7.4633994     -4.8374138     -3.7439227     -4.3116889
    [180]      -6.8788004     -12.649909     -30.425325     -19.313484
    [184]      -17.472239     -21.128075     -24.757759     -16.863373
    [188]      -7.6610641    -0.94375491      3.7388306      6.9066172
    [192]       8.8734198      9.8336029      9.9404259      9.3900042
    [196]       8.5265284      7.8392472      7.5868988      7.4846802
    [200]       7.0661035      6.0975351      5.0287638      5.5981798
    [204]       8.1220064      10.734139      12.655684      13.855635
    [208]       14.452390      14.575244      14.334528      13.816807
    [212]       13.111149      12.367354      11.816968      11.635414
    [216]       11.752129      11.931699      12.005184      11.964988
    [220]       11.953646      12.215921      12.964342      14.190568
    [224]       15.672523      17.170620      18.536991      19.695858
    [228]       20.593916      21.170593      21.351698      21.054960
    [232]       20.198042      18.712276      16.596258      14.132116
    [236]       12.338152      12.230812      12.995780      13.547029
    [240]       13.500319      12.727210      11.104118      8.4284077
    [244]       4.3595562     -1.1629889     -3.2479501    -0.93092734
    [248]    -0.063373208     -1.1280309     -4.3105526     -8.0733843
    [252]      -4.6670709     -1.0499359     0.45124480     0.37433779
    [256]     -0.31563485     0.49562821      3.2091300      6.0979815
    [260]       8.5312252      10.450740      11.839709      12.704098
    [264]       13.155718      13.481421      14.058149      15.011165
    [268]       16.089613      16.996077      17.599058      17.894464
    [272]       17.916494      17.696951      17.308388      16.978512
    [276]       17.119572      17.987747      19.347881      20.789581
    [280]       22.062279      23.061922      23.742445      24.075216
    [284]       24.047800      23.683403      23.072874      22.401453
    [288]       21.903893      21.691914      21.627798      21.442589
    [292]       20.911282      19.907211      18.392641      16.415657
    [296]       14.116020      11.691721      9.3129578      7.1913714
    [300]       6.0422754      6.9161954      9.3451900      12.046195
    [304]       14.406931      16.265985      17.602791      18.423143
    [308]       18.721798      18.477005      17.664003      16.289852
    [312]       14.483541      12.725340      12.027569      12.921566
    [316]       14.561990      16.046455      16.958134      17.103912
    [320]       16.327105      14.381989      10.697615      3.4294419
    [324]     -0.86830127      6.9588618      10.045337      11.116809
    [328]       11.035085      10.197933      8.8735514      7.2588015
    [332]       5.4296689      3.2846932     0.58712316     -2.5831480
    [336]      -3.5683422    -0.58073479      2.4864879      4.4357471
    [340]       5.1823039      4.5679898      2.0664554     -4.2875586
    [344]      -14.720459     -1.8642151      1.3719717      1.2814339
    [348]      -1.9322187     -7.6235256     -1.3172746      3.6199582
    [352]       6.1641479      7.3981266      7.8523793      7.8635049
    [356]       7.6555142      7.3143568      6.7530422      5.7283769
    [360]       3.9232619      1.3380059     0.21742369      2.6587043
    [364]       5.2747459      6.8368101      7.4847579      7.4784765
    [368]       7.0237947      6.2412438      5.2470360      4.3898191
    [372]       4.2592425      4.8831396      5.5393119      5.6222467
    [376]       4.8495712      3.0705249     0.17991287     -3.6172826
    [380]      -6.6723843     -7.6740069     -9.5697508     -16.898876
    [384]      -15.689511     -6.5660720     -2.8668885     -1.4902418
    [388]      -1.6364983     -2.3283696     -1.4151540      1.3820266
    [392]       4.2581458      6.6480904      8.6337271      10.361362
    [396]       11.911411      13.269092      14.347061      15.043419
    [400]       15.291217      15.083504      14.491843      13.698417
    [404]       13.020537      12.795051      13.065864      13.511311
    [408]       13.766805      13.656589      13.248234      12.859392
    [412]       12.863305      13.252762      13.640397      13.670706
    [416]       13.170633      12.112908      10.641007      9.1808996
    [420]       8.2539349      7.7287774      6.8487859      4.9090729
    [424]       1.2552999     -5.1484933     -11.835120     -9.7025528
    [428]      -11.393308     -10.723675     -4.0563946    -0.29534858
    [432]       1.3360139      1.4518253     0.29671535     -2.0868464
    [436]      -5.7784600     -10.676702     -15.018399     -16.051804
    [440]      -13.942583     -10.004507     -6.7600155     -4.8021798
    [444]      -3.9597371     -3.9436574     -4.4340763     -5.1356692
    [448]      -5.7067976     -5.4415083     -3.9109740     -1.9771460
    [452]     -0.56294197   -0.031555519    -0.51736695     -2.1678119
    [456]      -5.2598233     -9.6911650     -10.196710     -6.6162710
    [460]      -4.3024616     -3.3474290     -3.3849115     -4.0855370
    [464]      -5.0008073     -5.5839200     -5.6356158     -5.4609299
    [468]      -5.3599591     -5.3740902     -5.4069662     -5.3892093
    [472]      -5.3398747     -5.3395362     -5.5032105     -5.9679580
    [476]      -6.8664360     -8.2731628     -10.056664     -11.483365
    [480]      -11.322661     -9.8080235     -8.1820593     -7.0445848
    [484]      -6.5703602     -6.8329158     -7.8838863     -9.6870384
    [488]      -11.696095     -12.188293     -10.661070     -8.8625393
    [492]      -7.5958672     -6.8802700     -6.5543013     -6.4465828
    [496]      -6.4448948     -6.5133128     -6.6459637     -6.8098183
    [500]      -6.9345450     -6.9469123     -6.8088899     -6.5331516
    [504]      -6.1781106     -5.8233442     -5.5366969     -5.3634739
    [508]      -5.3436513     -5.5169568     -5.8746181     -6.2773533
    [512]      -6.4624357
  [Tag]         4321
  [frame_len]          320
[Record 28]
  [tot_power]       156328.44
  [re_spec_val]
    [0]       14.885269      14.463481      13.188200      11.039754
    [4]       8.0448999      4.4742551      1.1206999     -1.4716824
    [8]      -4.0120425     -6.0373101     -5.2145147     -3.6967249
    [12]      -3.6792462     -4.1922793      1.3516450      8.3279991
    [16]       13.730378      17.868122      21.055098      23.489170
    [20]       25.298920      26.566866      27.343225      27.663340
    [24]       27.574993      27.173216      26.617535      26.071707
    [28]       25.561102      24.930786      24.049986      23.219229
    [32]       23.423334      24.998943      26.912790      28.435974
    [36]       29.437696      30.031118      30.410217      30.745672
    [40]       31.076735      31.289747      31.207550      30.676878
    [44]       29.597387      27.929296      25.732056      23.271627
    [48]       21.084772      19.560209      18.407328      17.118237
    [52]       15.514980      13.855828      12.778106      12.630525
    [56]       12.909917      12.983888      12.548277      11.496404
    [60]       9.7837334      7.3914828      4.3685884     0.98222935
    [64]      -1.9866885     -3.3208392     -2.8268671     -1.6212282
    [68]     -0.55732614    0.061321981    0.099941224    -0.70121664
    [72]      -2.9878449     -8.4626188     -9.4968033     -1.2286921
    [76]       3.2617967      5.8293695      7.1813602      7.6083798
    [80]       7.2650876      6.2853675      4.8723598      3.3556674
    [84]       2.0776222      1.1127529     0.25640878    -0.72770971
    [88]      -2.0636308     -4.0402927     -6.2480259     -4.5924959
    [92]     0.048034005      3.8304994      6.4658704      8.2105560
    [96]       9.3128662      9.9923420      10.414717      10.654776
    [100]       10.703772      10.521849      10.076311      9.3372355
    [104]       8.2601967      6.8155346      5.1338911      3.7307377
    [108]       3.1433923      2.8931680      1.8854048     -1.0708152
    [112]      -8.9090395     -5.1115408      2.7751398      7.0732155
    [116]       9.8847771      11.834029      13.151998      13.916230
    [120]       14.133541      13.778627      12.814459      11.205068
    [124]       8.9322395      6.0421805      2.7901008   -0.068238884
    [128]      -1.5081593     -1.6472818     -1.4843760     -1.7060871
    [132]      -2.6486747     -4.3482709     -5.8649740     -4.9770856
    [136]      -2.5020852    -0.45807210     0.62646341     0.64386827
    [140]     -0.55488747     -3.3160772     -8.4048977     -13.828705
    [144]      -9.2936220     -5.8326530     -4.0523810     -3.2562158
    [148]      -3.3920746     -4.6719632     -7.2776966     -10.785955
    [152]      -12.638940     -10.074144     -5.2194653    -0.96125686
    [156]       1.9657795      3.6020477      4.0724068      3.4778697
    [160]       1.9318930    -0.30266625     -2.5840273     -4.1075969
    [164]      -4.8130894     -4.9617672     -4.4264364     -3.3524051
    [168]      -2.2958009     -1.7059445     -1.8901627     -3.2776492
    [172]      -7.0189581     -17.295151     -6.2301354     0.78889483
    [176]       4.9449949      7.7392435      9.6440401      10.860517
    [180]       11.493388      11.612777      11.283131      10.577724
    [184]       9.5796547      8.3662977      6.9897056      5.5008092
    [188]       4.1023164      3.4444647      4.2858076      6.1616702
    [192]       7.9913702      9.1776552      9.4711971      8.7077703
    [196]       6.6771574      3.0398097     -2.2503552     -4.1366506
    [200]      -1.4460820     0.53713888      2.2144105      3.9604647
    [204]       5.4890499      6.5144820      6.9851460      7.1682849
    [208]       7.6890659      8.8419733      10.005524      10.442780
    [212]       9.7261400      7.5372453      3.5968795    -0.41404301
    [216]      0.51312447      1.7324736      1.0889350    -0.52840841
    [220]     -0.96368545    -0.24296449    -0.41704950     -2.0697639
    [224]      -3.0227485    -0.62771732      1.4916388      1.8295764
    [228]      0.87943393      1.2400627      3.8358788      5.8914375
    [232]       6.5071659      5.7124515      3.8920672      2.4136188
    [236]       2.6002188      3.1269133      2.9838560      2.8519998
    [240]       3.8929362      5.4974751      6.5567770      6.7215796
    [244]       5.9591146      4.1892405      1.0285883     -4.5214028
    [248]      -7.8889828     -2.2637446     0.73391521      1.6484996
    [252]       1.0694888    -0.97813684     -5.5437045     -23.473072
    [256]      -4.8789892      1.9247315      5.6533656      7.8162184
    [260]       8.7845573      8.5926409      7.0315909      3.4910614
    [264]      -2.7387576    -0.37808537      4.6204972      7.0254641
    [268]       7.8671956      7.6740055      6.8312454      5.8371077
    [272]       5.1817703      4.7237654      3.6710870      1.0085717
    [276]      -5.4792848     -15.800063     -2.7091730     0.88593185
    [280]       1.8038820      1.2937890     0.26289549    -0.41972545
    [284]     -0.85376203     -1.9638616     -4.6883793     -10.757876
    [288]      -19.415051     -8.7634964     -4.5494108     -2.5915720
    [292]      -1.7854840     -1.7331057     -2.2509887     -3.1852667
    [296]      -4.2801657     -5.1438785     -5.4279814     -5.1503057
    [300]      -4.7870069     -4.9690919     -6.2192640     -8.9505043
    [304]      -13.362758     -17.405821     -15.267993     -10.251511
    [308]      -5.8419104     -2.7356985    -0.85044539    0.018887792
    [312]     0.055906244    -0.58982110     -1.7793224     -3.3278673
    [316]      -4.9369040     -6.2529607     -7.0932546     -7.3301773
    [320]      -6.6868892     -5.4839458     -4.6771426     -4.9985690
    [324]      -6.7792397     -9.0826387     -8.3159857     -6.3008761
    [328]      -6.0057020     -8.2244129     -14.984574     -24.611952
    [332]      -12.811367     -10.863018     -13.190841     -22.687174
    [336]      -16.551500     -11.008098     -10.442567     -15.031343
    [340]      -15.395971     -5.7820573     -1.1724565      1.1774876
    [344]       2.0766623      1.8660100     0.72706980     -1.2756861
    [348]      -4.2934389     -8.8208647     -13.576358     -11.094921
    [352]      -8.4528828     -8.1873636     -10.317708     -16.148592
    [356]      -22.261400     -11.890635     -6.7663550     -3.5918846
    [360]      -1.6340252    -0.72568572    -0.81419367     -1.8566043
    [364]      -3.7577381     -6.2678590     -8.8977385     -11.122253
    [368]      -12.689719     -13.544389     -14.006872     -14.515347
    [372]      -14.779718     -13.927625     -11.989902     -9.8590536
    [376]      -8.2374754     -7.5681753     -8.2544832     -11.024250
    [380]      -18.731962     -22.418043     -12.319981     -9.2472010
    [384]      -8.8064423     -10.180814     -12.033463     -11.170524
    [388]      -8.9334955     -7.7634015     -7.9583015     -9.3347044
    [392]      -11.426126     -13.035531     -12.497368     -10.038017
    [396]      -7.3016863     -5.2058568     -4.0165071     -3.8061900
    [400]      -4.6940999     -7.0882659     -12.552924     -24.913971
    [404]      -10.162553     -4.8480778     -2.1304731    -0.83104408
    [408]     -0.57829499     -1.1778756     -2.3439140     -3.4948099
    [412]      -4.1720490     -4.9438939     -7.0393682     -12.105736
    [416]      -15.351826     -8.6218338     -5.5596666     -4.8647051
    [420]      -5.1813955     -4.6075625     -2.9142735     -1.7010864
    [424]      -1.6928910     -2.9654288     -5.1635456     -7.0014400
    [428]      -7.5407648     -8.3231592     -11.025003     -17.279902
    [432]      -18.304564     -12.692243     -10.812635     -11.438286
    [436]      -14.360087     -19.478619     -20.236076     -17.260744
    [440]      -16.535273     -17.701950     -18.863398     -17.096891
    [444]      -14.319225     -12.322624     -11.220857     -10.861952
    [448]      -11.020257     -11.321407     -11.410083     -11.396500
    [452]      -11.772130     -12.841811     -14.128611     -14.109129
    [456]      -12.806911     -11.839503     -11.871582     -12.902999
    [460]      -14.569898     -15.855974     -15.568559     -14.312856
    [464]      -13.402383     -13.492133     -14.935345     -18.184212
    [468]      -24.120302     -29.368162     -25.556595     -24.159492
    [472]      -25.190136     -28.317049     -35.248318     -42.658512
    [476]      -28.753632     -22.901436     -19.245993     -17.074993
    [480]      -16.236019     -16.647932     -17.928453     -18.680649
    [484]      -17.821835     -16.794235     -16.732590     -17.803541
    [488]      -19.711529     -21.580662     -22.158163     -21.088881
    [492]      -19.104967     -17.189034     -15.953157     -15.610886
    [496]      -16.187790     -17.667452     -20.152782     -24.124548
    [500]      -28.616638     -24.640156     -20.243820     -17.904442
    [504]      -16.992325     -17.093897     -17.939571     -19.405891
    [508]      -21.470139     -23.598534     -23.969046     -22.783312
    [512]      -22.168434
  [Tag]         4481
  [frame_len]          320
[Record 29]
  [tot_power]       241172.62
  [re_spec_val]
    [0]       11.138577      10.244291      7.3379540      1.7616644
    [4]      -1.6610698      2.1506977      3.5447791      2.7815871
    [8]      0.81641507    -0.66355491    -0.18471484     0.63802230
    [12]     -0.49103281     -8.0365782     -3.0299015      6.3815532
    [16]       10.907012      13.324394      14.338552      14.192955
    [20]       12.880392      10.151566      5.7547288      2.6929896
    [24]       4.2876697      4.9859462      5.3483076      7.1121397
    [28]       8.0323439      6.2078404     0.45527387      2.2913914
    [32]       13.092138      21.529232      27.688461      32.082951
    [36]       35.076466      36.881287      37.607857      37.293926
    [40]       35.914948      33.381317      29.535173      24.243130
    [44]       18.205622      14.113500      11.073756      7.5352607
    [48]       5.7386179      3.6639373      3.9005532      8.8426161
    [52]       12.143043      14.243846      16.046856      17.574478
    [56]       18.430441      18.365744      17.297688      15.201625
    [60]       12.063009      7.9372511      3.3986528     0.28491315
    [64]      -1.1413180     -3.1330590     -6.5420833     -7.0173578
    [68]      -2.7095032     0.96962035      3.9471235      6.7488141
    [72]       9.4164562      11.684404      13.297606      14.091591
    [76]       13.940069      12.686731      10.056059      5.4457359
    [80]      -2.4149895     -4.4488635    -0.75168794    -0.57444185
    [84]      -2.9376073     -6.1059971     -3.3966935     0.75915492
    [88]       3.4678447      5.2886810      6.9754839      8.9309397
    [92]       10.898616      12.438226      13.312710      13.455679
    [96]       12.872891      11.590364      9.6410971      7.0912991
    [100]       4.0675049     0.51361704     -4.7786794     -20.930887
    [104]      -9.6173344     -5.6743946     -8.3577394     -4.5258350
    [108]       4.2189002      9.5191545      13.144390      15.815432
    [112]       17.778425      19.050623      19.562017      19.231153
    [116]       18.007627      15.959409      13.485567      11.267031
    [120]       9.0496740      4.9645829     -5.8178220      1.8484846
    [124]       7.3503203      9.3555737      10.168003      11.253159
    [128]       12.976999      14.679634      15.925034      16.618870
    [132]       16.737862      16.225025      14.986454      12.900535
    [136]       9.8014908      5.4538493    0.047088459     -2.0572538
    [140]    -0.026975270      1.1804111      1.1226889    0.032135867
    [144]      -1.9572978     -4.5824447     -5.5326920     -2.5054598
    [148]      0.86323345      3.1543286      4.3948002      4.7098432
    [152]       4.1749811      2.8280671     0.71062613     -1.9887265
    [156]      -4.3245788     -4.3406696     -2.6645460     -1.3584068
    [160]      -1.2155750     -2.6579688     -6.6983337     -19.990934
    [164]      -9.7640057     -3.1552885    -0.24823958     0.95410043
    [168]       1.1029234     0.81307340     0.93631005      1.8113217
    [172]       2.7850351      3.1838319      2.7365384      1.5303402
    [176]      0.18701081    -0.47603294    -0.93521231     -2.4652038
    [180]      -5.9490347     -10.443558     -10.693454     -12.124144
    [184]      -16.393839     -6.4906874     -1.1644208      1.2813165
    [188]       2.0128393      1.7407899      1.1759962     0.67001718
    [192]    -0.093501680     -1.2055407     -1.5719825    -0.73093492
    [196]     -0.40041253     -2.1520605     -8.7562437     -10.443112
    [200]     -0.38984859      3.9283497      6.2851758      7.6494026
    [204]       8.4664669      8.9647379      9.2190361      9.1874447
    [208]       8.7624722      7.8283448      6.3128767      4.2344332
    [212]       1.7092813     -1.2182652     -4.8569207     -8.5451183
    [216]      -6.9780092     -3.7428360     -2.0885935     -1.6737784
    [220]      -1.5101855    -0.49135813      1.1513898      2.4688056
    [224]       3.0115936      2.6655359      1.3713266     -1.0117129
    [228]      -4.8810415     -11.627248     -37.755558     -14.322782
    [232]      -9.9089584     -8.2057457     -7.7204161     -8.0034227
    [236]      -8.9234161     -10.616653     -13.295362     -14.795563
    [240]      -11.463616     -7.9651170     -5.8148823     -4.6878991
    [244]      -4.1160965     -3.5969276     -2.7870386     -1.7919339
    [248]      -1.0380309    -0.91356421     -1.6288738     -3.1755102
    [252]      -5.2225184     -7.3631954     -10.303046     -17.534418
    [256]      -21.865259     -11.317957     -8.8047771     -10.287109
    [260]      -18.363924     -13.104218     -5.9195275     -2.9803340
    [264]      -2.2310960     -3.1717353     -5.7386179     -10.041689
    [268]      -15.870396     -21.678789     -21.382837     -14.572457
    [272]      -10.496386     -8.9578886     -9.4093742     -10.097211
    [276]      -7.3617206     -3.6818166     -1.2204119   -0.024777170
    [280]     0.068255544    -0.84006172     -2.6896415     -5.3740292
    [284]      -8.5164099     -11.151100     -12.283308     -12.099850
    [288]      -11.392282     -10.836806     -10.694797     -10.589313
    [292]      -9.7298632     -8.0770903     -6.3600316     -4.9977059
    [296]      -3.9973276     -3.2031498     -2.4706490     -1.7687693
    [300]      -1.1719409    -0.77435541    -0.63080978    -0.76504505
    [304]      -1.2228407     -2.1278672     -3.7087476     -6.3031640
    [308]      -10.231543     -13.876376     -12.622587     -10.742167
    [312]      -10.331058     -10.840383     -11.213686     -10.942969
    [316]      -10.693972     -11.094889     -12.213345     -13.538624
    [320]      -13.902490     -12.770805     -11.129876     -9.8280764
    [324]      -9.1652355     -9.2593822     -10.261723     -12.533392
    [328]      -17.153805     -31.351692     -21.789562     -15.584187
    [332]      -13.472980     -13.453695     -15.176591     -18.704048
    [336]      -23.262524     -23.764723     -21.943298     -20.307518
    [340]      -17.240904     -13.504896     -10.475261     -8.4614010
    [344]      -7.4218297     -7.2549338     -7.8194914     -8.9062414
    [348]      -10.259597     -11.660002     -12.762514     -12.733016
    [352]      -11.363005     -9.8006344     -8.9148884     -9.0244350
    [356]      -10.315567     -13.043985     -17.193630     -18.823168
    [360]      -16.088343     -14.177793     -13.411360     -13.045328
    [364]      -12.565481     -12.119587     -12.172059     -13.090584
    [368]      -15.229859     -19.362104     -27.337788     -23.248732
    [372]      -17.272409     -14.093764     -12.066202     -10.455478
    [376]      -8.9638138     -7.5982304     -6.4763999     -5.7113767
    [380]      -5.4145875     -5.7231421     -6.8059120     -8.8319092
    [384]      -11.681339     -13.554852     -12.325897     -10.455262
    [388]      -9.3286905     -8.8735008     -8.8166714     -8.9867201
    [392]      -9.4143639     -10.327719     -12.085815     -14.994740
    [396]      -17.632219     -15.887433     -13.283120     -12.159335
    [400]      -12.456349     -13.703068     -14.713059     -14.158401
    [404]      -12.586360     -10.920346     -9.4874897     -8.5249128
    [408]      -8.2805481     -8.9639254     -10.767810     -13.859065
    [412]      -17.731207     -19.146103     -18.111963     -17.779634
    [416]      -17.681461     -15.994285     -13.457456     -11.510301
    [420]      -10.389307     -9.8510962     -9.5854282     -9.4658947
    [424]      -9.6404009     -10.344833     -11.588572     -12.605019
    [428]      -11.989576     -10.276256     -8.9384794     -8.5475283
    [432]      -9.2928686     -11.453688     -15.901335     -26.405708
    [436]      -20.037945     -13.697991     -10.672107     -9.1416082
    [440]      -8.5755939     -8.7565260     -9.5824108     -11.032511
    [444]      -13.194659     -16.322964     -20.870632     -26.081308
    [448]      -25.223011     -22.819380     -22.339659     -23.305252
    [452]      -23.909733     -22.396669     -20.810875     -20.651449
    [456]      -21.560038     -20.419678     -16.761339     -13.628404
    [460]      -11.509206     -10.118160     -9.2218170     -8.7780552
    [464]      -8.8900661     -9.6672430     -11.028817     -12.360098
    [468]      -12.646187     -12.070824     -11.708166     -12.072455
    [472]      -13.156349     -14.648258     -16.169424     -17.823692
    [476]      -20.274803     -23.958696     -27.026964     -27.690697
    [480]      -29.640728     -25.977039     -19.633917     -15.982654
    [484]      -14.425497     -14.667830     -16.924856     -22.633965
    [488]      -38.609146     -22.288130     -18.056643     -16.855442
    [492]      -17.579222     -20.070295     -23.617289     -23.557972
    [496]      -20.842400     -19.074524     -17.905758     -16.477568
    [500]      -14.606022     -12.681453     -10.995812     -9.6497917
    [504]      -8.6938744     -8.1904621     -8.2133379     -8.8368225
    [508]      -10.132802     -12.171254     -15.000922     -18.418348
    [512]      -20.504465
  [Tag]         4641
  [frame_len]          320
[Record 30]
  [tot_power]       246448.42
  [re_spec_val]
    [0]       12.190297      11.716275      10.271012      7.8178806
    [4]       4.4977207      1.2147847    -0.69076419     -2.0416808
    [8]      -3.9405196     -4.8902788     -3.5761805     -2.9338331
    [12]      -5.5942540     -6.8915300      2.9797931      8.7578278
    [16]       12.148576      13.935712      14.420617      13.760639
    [20]       12.179950      10.302496      9.0763350      8.2737932
    [24]       6.5495954      2.8470230     -1.4697881     0.65873939
    [28]       4.4382839      7.4497676      8.0207300      9.8239460
    [32]       19.333464      26.395180      31.201799      34.428001
    [36]       36.394726      37.251972      37.052082      35.771172
    [40]       33.299309      29.388664      23.492075      14.273946
    [44]       5.7515860      7.4029546      4.9308305     0.80806541
    [48]      -2.3141739     -3.8606334     -1.6052592      9.7598019
    [52]       17.225460      22.001606      24.983572      26.583437
    [56]       26.996456      26.290096      24.423450      21.214901
    [60]       16.213137      8.3592424     0.84855568      2.8594410
    [64]      0.88884813     -6.3994737     -6.7871199     -3.8856165
    [68]      -5.9151454     0.63575327      7.8434715      12.427527
    [72]       15.392993      17.166475      17.902611      17.619091
    [76]       16.228750      13.499186      8.8553734     0.30937585
    [80]      -14.642004     -3.0672691     -3.6420422     -11.631405
    [84]      -13.368368     -5.1969695     -2.4797847      1.6724827
    [88]       6.7054801      10.536465      12.979414      14.179738
    [92]       14.228664      13.140455      10.867648      7.3633981
    [96]       2.9438491    -0.77342385     -2.9691744     -6.0511661
    [100]      -11.726165     -20.039946     -18.203796     -6.7442746
    [104]     -0.17558946      4.7764025      9.5755320      14.105297
    [108]       17.821022      20.513588      22.173069      22.827705
    [112]       22.484497      21.104946      18.577921      14.657419
    [116]       8.7954254     0.28630307     -1.0071598      2.7084589
    [120]       5.5330148      8.4294348      11.193822      13.452061
    [124]       14.990129      15.778516      16.093782      16.647848
    [128]       17.941628      19.435038      20.375965      20.399542
    [132]       19.350147      17.098465      13.462085      8.2020187
    [136]       1.1577975     -9.4179316     -7.8189483      1.4075363
    [140]       5.5779123      7.8125777      9.2052269      10.345250
    [144]       11.357857      12.055682      12.202600      11.600662
    [148]       10.047655      7.2602811      2.8072677     -2.8311586
    [152]      -3.0162919     -1.0047039    -0.72170609     -1.5892795
    [156]      -2.5867004     -2.6493604     -1.4418144     0.50751257
    [160]       2.5356998      4.2669115      5.5634079      6.3673410
    [164]       6.6053619      6.1606221      4.8758101      2.5713518
    [168]     -0.80469501     -4.2251558     -5.1133418     -4.9338579
    [172]      -6.1493235     -9.9476032     -20.737654     -15.341866
    [176]      -8.3721828     -5.2968822     -3.5945306     -2.2030866
    [180]     -0.37618968      2.0004995      4.4821672      6.6352725
    [184]       8.2207756      9.1169405      9.2457876      8.5332012
    [188]       6.8828573      4.1477184    0.078433998     -5.7838402
    [192]      -13.407849     -13.172693     -8.8256588     -5.6048574
    [196]      -3.3423448     -1.7856228     0.13014798      3.5463192
    [200]       7.4456682      10.635053      12.796323      13.909023
    [204]       13.979267      12.967917      10.751742      7.0544715
    [208]       1.2962904     -6.8015862     -8.6487160     -8.3551397
    [212]      -10.824937     -11.792544     -9.2957001     -6.4176464
    [216]      -3.6937029     -1.9712639     -2.0522659     -5.0167174
    [220]      -11.828122     -3.7751579      1.7169356      4.2719345
    [224]       5.0365405      4.3909507      2.4742460    -0.58767480
    [228]      -4.3619552     -8.0819063     -12.567433     -24.632286
    [232]      -16.872370     -10.431217     -8.2803926     -8.2546883
    [236]      -9.9038000     -13.217133     -16.304846     -13.907735
    [240]      -11.028597     -9.6699076     -9.3187475     -9.4524555
    [244]      -10.066090     -11.742519     -15.362541     -20.693651
    [248]      -18.893625     -16.078165     -15.905599     -17.661379
    [252]      -18.913242     -15.776376     -11.373812     -7.5730166
    [256]      -4.4965076     -2.1540463    -0.56984591     0.22627909
    [260]      0.19510046    -0.72050786     -2.5925152     -5.4258370
    [264]      -8.7068062     -10.640198     -10.633046     -10.216092
    [268]      -9.6742086     -8.8564310     -8.1335716     -7.9408517
    [272]      -8.3207922     -8.4266891     -6.7260199     -3.9427295
    [276]      -1.6844177    -0.50851470    -0.57798058     -2.1062059
    [280]      -5.6744170     -13.599396     -21.982597     -11.431522
    [284]      -9.2980108     -10.061392     -13.244886     -20.617258
    [288]      -21.305937     -13.057596     -9.6035166     -8.8857470
    [292]      -11.000710     -14.958261     -9.5578451     -4.7417989
    [296]      -2.5411944     -2.2414777     -3.6212804     -6.7804437
    [300]      -12.143545     -20.396975     -30.106535     -30.014830
    [304]      -20.228331     -16.017426     -14.825352     -14.749880
    [308]      -12.396845     -8.5822363     -5.7043648     -4.1020479
    [312]      -3.7050731     -4.5312929     -6.8249798     -11.451153
    [316]      -22.964828     -18.257444     -12.137669     -10.280879
    [320]      -10.547571     -12.638822     -17.031248     -25.576311
    [324]      -24.311016     -17.788980     -13.648393     -10.545400
    [328]      -8.4056511     -7.2171807     -6.8679285     -7.1657114
    [332]      -7.8521442     -8.6337729     -9.2208233     -9.3790855
    [336]      -9.1217327     -8.8209953     -8.9541979     -9.8924656
    [340]      -11.934366     -15.425735     -20.883648     -28.637239
    [344]      -28.350563     -20.616154     -14.833893     -10.809244
    [348]      -8.0824451     -6.3338313     -5.3447351     -4.9294858
    [352]      -4.8667693     -4.8749866     -4.7329412     -4.4790416
    [356]      -4.3775301     -4.7016883     -5.6306949     -7.2647729
    [360]      -9.6383114     -12.576407     -15.054855     -15.401206
    [364]      -14.419548     -13.401671     -12.184910     -10.527651
    [368]      -8.9455881     -8.0079937     -7.8812628     -8.3417454
    [372]      -8.8245335     -8.9271240     -8.9827690     -9.4893532
    [376]      -10.438996     -11.256496     -11.564003     -11.945148
    [380]      -13.068947     -14.411100     -13.470824     -10.772326
    [384]      -8.6788549     -7.6879988     -7.7114143     -8.5689287
    [388]      -9.9944916     -11.595144     -12.965733     -14.018535
    [392]      -15.178905     -17.230047     -20.655075     -20.622425
    [396]      -16.194187     -13.408017     -12.472489     -13.097484
    [400]      -15.144085     -18.518587     -23.031727     -27.147980
    [404]      -24.313047     -19.191214     -15.301318     -12.499859
    [408]      -10.653487     -9.7997694     -10.069972     -11.695271
    [412]      -15.152406     -21.685511     -29.014557     -23.435287
    [416]      -21.146084     -19.098591     -15.753856     -12.680553
    [420]      -10.621128     -9.5862846     -9.5207682     -10.530419
    [424]      -13.159212     -19.743252     -27.416494     -14.192199
    [428]      -9.7286100     -7.7376413     -7.2312150     -7.8387766
    [432]      -9.3152180     -11.353546     -13.471900     -15.179796
    [436]      -16.435873     -17.529537     -18.516731     -19.227930
    [440]      -19.751856     -20.412754     -21.257872     -21.829643
    [444]      -21.394327     -19.812574     -17.958418     -16.731598
    [448]      -16.602402     -17.825150     -20.440886     -22.643267
    [452]      -20.736494     -17.894606     -15.971699     -14.884948
    [456]      -14.518771     -14.901654     -16.197075     -18.883238
    [460]      -23.764299     -21.575377     -14.878192     -10.793267
    [464]      -8.5213299     -7.6907072     -8.2377949     -10.316722
    [468]      -14.196101     -17.636316     -15.013104     -12.398166
    [472]      -11.467511     -11.914073     -13.625872     -16.827518
    [476]      -22.496155     -31.219492     -23.467651     -18.269663
    [480]      -14.899712     -12.255044     -10.095529     -8.4580622
    [484]      -7.4452400     -7.1537137     -7.6573973     -8.9825068
    [488]      -10.990792     -13.088007     -14.372263     -15.044195
    [492]      -16.052294     -17.272343     -16.981789     -15.140017
    [496]      -13.606336     -13.061671     -13.518528     -14.856826
    [500]      -17.086233     -21.086546     -33.658607     -22.403603
    [504]      -14.881515     -11.090244     -9.0858021     -8.2832079
    [508]      -8.3660355     -9.0606403     -10.045828     -10.920467
    [512]      -11.275231
  [Tag]         4801
  [frame_len]          320
[Record 31]
  [tot_power]       238355.16
  [re_spec_val]
    [0]       6.9422479      6.3360019      4.4683557      1.2072926
    [4]      -3.2583344     -5.7753720     -4.5476503     -3.9826012
    [8]      -5.3652062     -10.014651     -11.605642   0.0089525515
    [12]       7.1666741      12.260629      15.957747      18.498327
    [16]       19.984016      20.444443      19.854803      18.135893
    [20]       15.146809      10.704875      4.9175076     0.23472151
    [24]      0.16494638      1.5881449      2.2494318      2.5449374
    [28]       4.4506950      5.9622617      4.0789413      9.8980198
    [32]       19.063522      25.010853      29.011204      31.625452
    [36]       33.104404      33.565578      33.058529      31.600182
    [40]       29.214867      26.000154      22.156897      17.669470
    [44]       11.429358     -1.6685613     -3.4830644     -9.1035194
    [48]       2.8930547      11.264395      15.833011      20.466311
    [52]       25.252287      29.166933      31.939220      33.621910
    [56]       34.292854      33.990871      32.705723      30.370913
    [60]       26.843319      21.854305      14.934266      6.0653706
    [64]      0.81335127     -3.9764280     -9.3144999      1.8569493
    [68]       6.7612233      9.4983845      10.687867      10.077832
    [72]       6.8515491      4.4071012      10.784800      14.925151
    [76]       16.774433      16.949284      15.658452      12.843162
    [80]       8.0529737    -0.44796804     -8.2896099     -2.1563594
    [84]      -2.2604163     0.32471561      7.5985751      12.887382
    [88]       16.386255      18.507923      19.422897      19.155790
    [92]       17.602619      14.452661      8.8442183     -1.6484294
    [96]      0.87217766      4.0861793      3.5899796     0.92669064
    [100]      -2.5498021     -4.1878681     -6.7522731     -2.6943929
    [104]       7.6744566      14.181670      18.563227      21.494339
    [108]       23.260805      23.991001      23.728714      22.456282
    [112]       20.093893      16.475557      11.279001      3.8940918
    [116]      -3.5598428    -0.86804330      1.8169714      2.9924452
    [120]       2.8409390      1.3031973     -2.0119023     -5.6582527
    [124]      0.85359663      7.4550819      12.287461      15.915932
    [128]       18.579102      20.382343      21.377306      21.586414
    [132]       21.010622      19.630928      17.404633      14.251935
    [136]       10.027632      4.5239077     -1.8607070     -4.7194839
    [140]      -2.0386355      2.2533329      6.1803923      9.4937229
    [144]       12.505296      15.262803      17.533735      19.100008
    [148]       19.853941      19.756054      18.791883      16.955765
    [152]       14.259015      10.767421      6.6831770      2.4885314
    [156]     -0.76213360     -1.2495281      1.1028208      4.1728740
    [160]       6.9158163      9.1774845      10.971385      12.235230
    [164]       12.833250      12.636012      11.609794      10.009956
    [168]       8.6799021      8.3516121      8.3354959      7.7055564
    [172]       6.1467509      3.7111650     0.67726368     -2.3435724
    [176]      -3.7529359     -2.2466927     0.22606330      2.1789899
    [180]       3.2927725      3.5061264      2.7550299     0.84563243
    [184]      -2.9181561     -12.271601     -11.421374     -2.4621859
    [188]       1.0202177      2.3484969      2.1837461     0.74306083
    [192]      -1.6217510     -2.9528675     -1.0609748      1.6362418
    [196]       3.9437840      6.1471829      8.3950014      10.378306
    [200]       11.727653      12.238583      11.846964      10.630070
    [204]       8.9434013      7.4610128      6.3968892      4.9601388
    [208]       2.1395302     -3.3247952     -16.608698     -14.851057
    [212]      -12.521460     -10.798115     -2.6337273      2.9074323
    [216]       6.5829897      9.0266972      10.454154      10.896254
    [220]       10.280080      8.4189615      4.9044466     -1.1398774
    [224]      -6.8373466     -3.1571214     -1.7638098     -2.9306324
    [228]      -6.2805233     -12.983564     -24.667618     -9.4520645
    [232]      -3.9394255    -0.83902544      1.0625713      2.5324414
    [236]       4.2445292      6.3598967      8.4949446      10.262318
    [240]       11.473089      12.057031      11.985434      11.234942
    [244]       9.7693472      7.5231824      4.3849378     0.27724788
    [248]      -3.6538401     -3.1156273   -0.093894742      2.6181662
    [252]       4.8400865      6.5493484      7.6450114      8.0509176
    [256]       7.7925344      7.0853910      6.3680973      5.9456973
    [260]       5.5202098      4.5057383      2.4768665    -0.73835665
    [264]      -4.6774707     -7.5329819     -8.5984383     -7.6658015
    [268]      -4.3941202     -1.1782036      1.1333847      2.6357887
    [272]       3.4549060      3.6050026      3.0371437      1.7556431
    [276]     0.072639607     -1.1041442     -1.2586236     -1.3989288
    [280]      -2.6735706     -6.0771894     -14.579081     -17.813295
    [284]      -9.2971077     -7.3442903     -7.9971881     -8.9520769
    [288]      -6.4522028     -2.7998867   -0.034705184      1.8886858
    [292]       3.2404740      4.2091866      4.8669333      5.1838799
    [296]       5.0777407      4.4625697      3.2722073      1.4730463
    [300]     -0.86806297     -3.2591217     -4.2631254     -3.1307373
    [304]      -1.1275828     0.94693416      2.9444141      4.7558484
    [308]       6.1949916      7.0715837      7.2341242      6.5660911
    [312]       4.9871092      2.5376720    -0.31323606     -2.5719922
    [316]      -4.4077516     -7.7369914     -16.175245     -15.756996
    [320]      -9.2591667     -8.4090271     -12.644820     -22.381834
    [324]      -6.2835512    -0.88456261      1.8288417      2.9634731
    [328]       2.9032538      1.8769612     0.21160834     -1.3651218
    [332]      -1.8529155     -1.2556603    -0.53176743    -0.39224881
    [336]      -1.2149690     -3.2788687     -6.7513380     -10.232139
    [340]      -9.6847401     -8.0959654     -7.8154631     -8.6987686
    [344]      -10.096210     -10.777048     -9.5673304     -7.1713371
    [348]      -4.9933567     -3.7362463     -3.6729131     -4.8696127
    [352]      -6.6025443     -6.1832070     -3.8346903     -2.1154971
    [356]      -1.6067442     -2.2446632     -3.6820498     -4.4668541
    [360]      -2.8487802    -0.34553921      1.5648155      2.6025972
    [364]       2.7379084      1.8748370    -0.28590375     -4.6202579
    [368]      -15.639267     -12.540074     -5.5107274     -3.3184278
    [372]      -3.3741610     -5.4375901     -10.031549     -11.858548
    [376]      -6.4345460     -3.2585123     -1.9240168     -1.6521538
    [380]      -1.7699628     -1.7810631     -1.6560516     -1.5796885
    [384]      -1.5520322     -1.4874874     -1.4813253     -1.7603580
    [388]      -2.4751022     -3.6558335     -5.3461013     -7.8499351
    [392]      -12.098347     -18.786915     -13.490562     -8.2961521
    [396]      -5.6056852     -4.2668529     -3.6411476     -3.2409947
    [400]      -2.7902756     -2.3148756     -1.9570179     -1.7619975
    [404]      -1.6731241     -1.6633532     -1.8441668     -2.4463739
    [408]      -3.7366543     -5.9517274     -9.0498123     -11.295588
    [412]      -9.9559431     -7.2760768     -4.7431302     -2.4484096
    [416]     -0.46712047      1.0746788      2.0495358      2.3092847
    [420]       1.6514034    -0.22303997     -3.6463864     -6.9312716
    [424]      -4.8671479     -2.4574397     -2.0477996     -3.8112295
    [428]      -8.6860714     -19.239548     -10.666771     -6.3887091
    [432]      -4.7787066     -4.0424824     -3.4761870     -3.2129087
    [436]      -3.7044814     -5.3167915     -8.3334255     -12.432722
    [440]      -13.205157     -10.353549     -8.3837786     -7.7608881
    [444]      -8.4854860     -10.829843     -15.253389     -17.924143
    [448]      -14.251568     -12.188513     -12.359394     -14.545811
    [452]      -18.610735     -21.471956     -19.176453     -16.742838
    [456]      -15.240183     -14.570349     -14.706354     -15.415908
    [460]      -16.184189     -16.492229     -16.095852     -15.380295
    [464]      -15.461142     -17.517506     -19.291092     -13.719187
    [468]      -9.2131214     -6.8656292     -6.0817699     -6.4247022
    [472]      -7.4943552     -9.1165943     -11.922608     -18.528954
    [476]      -21.853783     -11.934188     -7.8491654     -5.8492646
    [480]      -4.9684420     -4.9381671     -5.9594722     -8.7546263
    [484]      -15.611335     -19.138943     -10.274609     -7.0576391
    [488]      -6.2372274     -7.0285830     -9.1495371     -12.126830
    [492]      -13.786804     -12.663833     -11.645944     -12.279687
    [496]      -14.705722     -14.477560     -9.9566231     -6.8361335
    [500]      -5.6305809     -6.3460646     -9.7492886     -20.041451
    [504]      -12.610839     -6.1195607     -3.3220100     -2.3491383
    [508]      -2.6689336     -4.0897455     -6.5541105     -9.8806286
    [512]      -12.083848
  [Tag]         4961
  [frame_len]          320
[Record 32]
  [tot_power]       297415.44
  [re_spec_val]
    [0]       11.445886      11.495428      11.508492      11.253657
    [4]       10.657328      9.8638887      9.0307674      7.9631791
    [8]       6.0813122      2.7290616     -2.0299072     -3.9331598
    [12]       2.1677277      9.7776947      15.448263      19.359472
    [16]       21.864538      23.177113      23.408482      22.602972
    [20]       20.756805      17.826344      13.740753      8.5343933
    [24]       3.0099423     -2.1800530     -7.9779205      2.0268042
    [28]       7.0259080      9.1485262      12.293897      17.687294
    [32]       22.291651      25.409645      27.173536      27.707390
    [36]       27.045122      25.129440      21.807207      16.855450
    [40]       10.349303      4.1217003     0.60793787     0.73734874
    [44]      0.85891193      5.9355946      12.254931      16.143940
    [48]       19.440243      23.920227      28.573223      32.276836
    [52]       34.846310      36.351078      36.867569      36.437611
    [56]       35.066971      32.735504      29.445999      25.440567
    [60]       21.666897      18.857710      15.280591      6.4321418
    [64]       6.5787835      14.732881      17.870741      19.869001
    [68]       21.953539      24.056692      25.732298      26.764721
    [72]       27.088707      26.653610      25.377415      23.147940
    [76]       19.869188      15.699533      11.715276      8.9970198
    [80]       6.2022839      4.0484242      6.1280231      8.8871307
    [84]       11.588173      14.955761      18.296829      20.913551
    [88]       22.635122      23.487316      23.531620      22.831696
    [92]       21.454792      19.473297      16.946426      13.882864
    [96]       10.278635      6.5993476      4.5812879      4.2049108
    [100]       3.0792072      2.6066813      7.6175680      12.485409
    [104]       15.587366      17.218355      17.602020      16.868792
    [108]       15.172381      12.913610      10.931878      9.7764482
    [112]       8.9922743      8.1710672      7.2438903      5.9131432
    [116]       3.5936923    -0.49918282     -7.1860518     -3.6160688
    [120]       2.6039331      6.2479339      8.3035755      9.4601154
    [124]       10.611953      12.356412      14.242506      15.579052
    [128]       16.022997      15.415421      13.601709      10.349871
    [132]       5.4121256    -0.49801114     -4.1931906     -2.2143779
    [136]       3.8441551      8.0291996      10.405651      11.774229
    [140]       13.095810      14.968416      16.993387      18.536762
    [144]       19.297295      19.203264      18.321814      16.929493
    [148]       15.568574      14.532501      13.216143      10.476945
    [152]       4.1694994     -5.2070198      6.4277258      10.251747
    [156]       11.898383      12.851217      13.715795      14.508670
    [160]       15.115246      15.548898      15.792577      15.662336
    [164]       14.968464      13.883744      13.287053      13.724245
    [168]       14.150999      13.405130      10.561904      4.2594867
    [172]       6.5307603      12.599173      15.715986      17.279427
    [176]       17.905483      17.895077      17.406395      16.523293
    [180]       15.299327      13.791441      12.084384      10.304821
    [184]       8.6494036      7.4643512      7.0768547      7.1578388
    [188]       6.8381238      5.3303232      1.8060985     -5.4520817
    [192]      -6.3983083     0.68898112      5.3747067      9.1222591
    [196]       11.894516      13.586330      14.207231      13.803782
    [200]       12.459217      10.413238      8.2795563      6.7528934
    [204]       5.5761180      4.0277834      2.4279480      2.9354639
    [208]       5.6246233      8.3127995      10.258785      11.373137
    [212]       11.663623      11.141291      9.7694960      7.3227692
    [216]       2.9159181     -8.2221184     -2.7406061      3.9823432
    [220]       6.1775932      5.6702747      1.6526651     -23.518068
    [224]       2.4114280      8.2674484      11.041294      12.395885
    [228]       12.929589      12.952886      12.645634      12.139986
    [232]       11.571448      11.054189      10.607611      10.136306
    [236]       9.5129061      8.7883949      8.4737482      9.0934410
    [240]       10.073822      10.405457      9.3929768      6.1928349
    [244]      -2.4919012     -3.6074328      5.1856408      8.1032715
    [248]       8.9288092      8.8577557      9.1931763      10.697268
    [252]       12.566612      13.964195      14.639134      14.620807
    [256]       14.082840      13.295560      12.435959      11.311403
    [260]       9.3401241      5.4772859     -3.9067409     -2.2945595
    [264]       5.4566245      8.6166706      10.007961      10.320939
    [268]       9.7520237      8.2695007      5.6959300      1.8049200
    [272]      -2.9129391     -5.1665616     -5.1799879     -4.5370207
    [276]      -1.3546703      2.2344511      4.7747779      6.2867241
    [280]       6.9610710      6.9221416      6.2498922      5.0656862
    [284]       3.6177700      2.2051778     0.87964004    -0.51531637
    [288]      -1.6980201     -1.7796959    -0.73407263     0.60721952
    [292]       1.8639454      2.9076607      3.5224476      3.4609418
    [296]       2.5842783      1.1215752     0.28572255      1.1992157
    [300]       2.5672963      3.1472464      2.6394539      1.3308553
    [304]      0.81568366      2.6747222      5.2098770      7.1655030
    [308]       8.4131956      9.0267286      9.0201883      8.2877665
    [312]       6.5371814      3.0086348     -5.5559387     -6.2267237
    [316]       3.2469859      7.2573476      9.4349785      10.588202
    [320]       11.029243      10.900798      10.293177      9.3563137
    [324]       8.4108686      7.8356600      7.6109757      7.2652130
    [328]       6.3351641      4.5855289      2.2866869      1.4136034
    [332]       3.5361574      6.3238716      8.5854273      10.239067
    [336]       11.332050      11.874051      11.835851      11.160559
    [340]       9.7614994      7.4847994      3.9532051     -2.1870096
    [344]      -16.974609     -2.3718362      2.8064237      5.1855216
    [348]       5.9673924      5.4852195      3.9527326      1.9145200
    [352]      0.67697662      1.0131416      2.0499675      2.9982691
    [356]       3.4101493      2.9115233      1.2481723     -1.4187938
    [360]      -3.5488653     -3.6541955     -2.9806232     -1.2867002
    [364]       1.3684654      3.5621545      4.7247210      4.9680700
    [368]       4.7501044      4.7302957      5.1895056      5.7497602
    [372]       5.9930511      5.8040185      5.3211021      4.8385315
    [376]       4.5971203      4.5466242      4.4378810      4.0855069
    [380]       3.4550204      2.6190722      1.7012854     0.82703507
    [384]     0.056442972    -0.60947913    -0.96635938    -0.45490193
    [388]      0.95116323      2.3891466      3.1419117      2.8748558
    [392]       1.3891518     -1.4327717     -4.7854600     -5.3031497
    [396]      -3.8596663     -3.0742838     -2.6488874     -1.7683990
    [400]     -0.57157648     0.35697928     0.82135832     0.93912613
    [404]      0.94503456      1.1632475      1.9458225      3.2936397
    [408]       4.7650490      5.9337268      6.6043801      6.7487898
    [412]       6.4342961      5.7879109      4.9601479      4.1151576
    [416]       3.5616040      3.8205216      4.9755883      6.3448324
    [420]       7.2851810      7.4900723      6.7900505      4.9414191
    [424]       1.2841053     -7.1936898     -9.5155420     0.49503449
    [428]       4.5214906      6.6713142      7.8033562      8.3086405
    [432]       8.4732723      8.5083780      8.4593401      8.1835451
    [436]       7.4698391      6.1904221      4.5491290      3.6437042
    [440]       4.6977997      6.7179656      8.4766579      9.6298876
    [444]       10.140742      10.023373      9.3064203      8.0684347
    [448]       6.5348377      5.1982327      4.6290083      4.8622756
    [452]       5.4628396      6.0939579      6.6081667      6.9383140
    [456]       7.0623331      7.0194840      6.9211392      6.9110661
    [460]       7.0637422      7.3176327      7.5366740      7.6064429
    [464]       7.4481153      6.9633036      5.9834180      4.2724276
    [468]       1.6524742     -1.1946456     -1.5448312    -0.13095164
    [472]      0.25053534     -1.3878319     -6.7710309     -21.309549
    [476]      -3.4964418      1.5699831      4.0374174      5.1228456
    [480]       5.2312102      4.5560050      3.2938139      1.9139116
    [484]       1.2935632      1.7302893      2.3844807      2.5062649
    [488]       1.7822680    0.086526193     -2.4170458     -3.9023781
    [492]      -1.8787974      1.1239221      3.4815402      5.0894208
    [496]       6.0199957      6.3157568      6.0010357      5.1271272
    [500]       3.8486626      2.5076320      1.5167470     0.92808354
    [504]      0.39740744    -0.30059409    -0.94279760    -0.92937368
    [508]   -0.0043240893      1.3375443      2.5372162      3.3207476
    [512]       3.5897884
  [Tag]         5121
  [frame_len]          320
[Record 33]
  [tot_power]       288378.09
  [re_spec_val]
    [0]       8.7729549      8.6449871      8.2167578      7.3672457
    [4]       5.9440932      3.8712623      1.3804640    -0.80452400
    [8]      -2.1688855     -2.3051353     0.97671306      6.6042128
    [12]       11.926519      16.269733      19.573034      21.876621
    [16]       23.228893      23.666880      23.212725      21.871370
    [20]       19.617451      16.351562      11.786735      5.1790199
    [24]      -1.8951620      2.8920231      6.6025934      8.2125912
    [28]       10.792438      16.601713      21.937412      25.756220
    [32]       28.228807      29.538654      29.777927      28.947716
    [36]       26.937906      23.446930      17.698996      6.7624245
    [40]      -1.2956405      7.4513302      13.776245      18.595070
    [44]       21.705029      24.327766      27.441626      30.641163
    [48]       33.179394      34.766956      35.362518      34.988358
    [52]       33.683228      31.509727      28.554312      24.804590
    [56]       19.807604      13.345151      14.036765      17.033215
    [60]       18.110643      19.575260      22.581209      25.615391
    [64]       27.903049      29.426853      30.286516      30.556942
    [68]       30.279989      29.465895      28.088137      26.091877
    [72]       23.465647      20.474686      17.911327      16.134674
    [76]       14.010323      10.026541      2.3013687      3.6507492
    [80]       9.7051105      13.332863      15.919658      17.662086
    [84]       18.559498      18.657953      18.012749      16.605913
    [88]       14.271028      10.644258      5.3305955     0.97867775
    [92]       1.9007642      2.0340536     0.53129631    -0.79292417
    [96]      0.22645502      3.8216751      7.8339286      10.876077
    [100]       12.776474      13.676093      13.722793      12.980947
    [104]       11.379601      8.7132254      4.9613099      2.2146590
    [108]       2.8434730      3.5285218      4.0267344      6.3288999
    [112]       9.3981810      11.772032      13.371179      14.505911
    [116]       15.398382      16.002296      16.077673      15.336248
    [120]       13.440207      9.8064566      3.3964431      2.5980074
    [124]       7.6796460      9.9408846      10.457521      10.171662
    [128]       10.373034      11.776753      13.509111      14.802730
    [132]       15.519731      15.773709      15.730545      15.520418
    [136]       15.180862      14.638854      13.768297      12.598756
    [140]       11.766152      12.254782      13.524926      14.311279
    [144]       14.031370      12.596005      10.824466      11.321886
    [148]       13.748951      15.800495      17.004814      17.473063
    [152]       17.369694      16.865192      16.120842      15.211554
    [156]       14.065219      12.555419      10.779653      9.4833565
    [160]       9.6368389      10.788546      12.011009      13.082952
    [164]       14.160253      15.354391      16.560490      17.560183
    [168]       18.168545      18.270998      17.808178      16.788618
    [172]       15.387491      14.103914      13.489203      13.314999
    [176]       12.835073      11.563735      9.3833265      6.7110162
    [180]       5.0138044      5.2394891      6.2205520      7.2328010
    [184]       8.2753448      9.4183083      10.607138      11.696134
    [188]       12.522894      12.936465      12.806952      12.068387
    [192]       10.819734      9.4063692      8.0769300      6.2374511
    [196]       2.1178997     -11.998488      1.5350119      7.6917553
    [200]       10.550200      11.828568      12.097999      11.651031
    [204]       10.706987      9.5301704      8.4349442      7.4761777
    [208]       6.1250262      3.3034832     -3.4567566     -4.5375504
    [212]       3.7323349      7.3763738      9.0469952      9.7245026
    [216]       10.088224      10.541714      11.017352      11.266557
    [220]       11.251468      11.197747      11.327151      11.519593
    [224]       11.384640      10.519864      8.5004730      4.4934921
    [228]      -5.2818551     -4.6008940      3.8408387      7.1792593
    [232]       8.8432178      9.7423611      10.346351      10.869589
    [236]       11.280889      11.438576      11.282471      10.980552
    [240]       10.947096      11.452196      12.188046      12.619312
    [244]       12.397754      11.363426      9.4686766      6.8196468
    [248]       3.9897950      2.3687849      2.4978576      3.1767361
    [252]       3.8170948      4.7538843      6.2541857      7.9071980
    [256]       9.2355223      10.100020      10.583197      10.843293
    [260]       11.023192      11.163657      11.138179      10.690105
    [264]       9.5618992      7.7734866      6.5500917      7.8048739
    [268]       10.033092      11.601958      12.237587      11.985653
    [272]       10.914416      9.1377869      7.0469060      5.5986047
    [276]       5.3014250      5.1044955      3.8336198     0.49522030
    [280]      -6.5438037     -4.4535089      1.2325824      3.7089362
    [284]       4.4743981      4.2130175      3.4031017      2.5191770
    [288]       2.1396594      2.8281193      4.3727384      5.8871322
    [292]       6.7230186      6.5698524      5.2740722      3.0801990
    [296]       2.0678775      3.9035840      5.8956728      6.8163104
    [300]       6.6467571      5.5357065      3.6951718      1.4898304
    [304]     -0.57664937     -2.0987728     -2.6665521     -2.0851688
    [308]      -1.2213275    -0.99628556     -1.5532978     -2.1878211
    [312]      -1.9591053     -1.2512255    -0.96191365     -1.4722434
    [316]      -3.1546092     -7.3652081     -18.857450     -6.0393028
    [320]     -0.21069667      2.4905009      3.3819132      2.7663853
    [324]      0.42880517     -5.0449438     -32.169014     -4.1834784
    [328]       1.1081960      3.5584176      4.5435524      4.5176883
    [332]       3.7047455      2.1743917    -0.26456407     -3.8009140
    [336]      -4.2532473     0.40051609      4.0576954      6.3478785
    [340]       7.7884526      8.8864117      10.007672      11.147827
    [344]       11.999594      12.220314      11.497748      9.3906746
    [348]       4.7653632     -7.5778770      2.4240034      8.2565918
    [352]       10.968642      12.311295      12.898745      13.031702
    [356]       12.861472      12.488594      12.038196      11.621964
    [360]       11.200198      10.547899      9.3636408      7.3047414
    [364]       3.7800856     -3.1513507     -12.426669    -0.20562303
    [368]       4.1192498      6.2197847      7.1443892      7.2680697
    [372]       6.7607656      5.6938744      4.0822277      1.9421026
    [376]     -0.55708891     -2.7485039     -3.4335039     -2.3981454
    [380]     -0.73171991     0.66474348      1.3372688      1.0609823
    [384]     -0.27759281     -2.6315229     -5.2050152     -5.1748209
    [388]      -1.8844014      1.8111789      4.7361584      6.6594787
    [392]       7.5507956      7.3944006      6.1174493      3.5110724
    [396]     -0.97982019     -8.8746939     -11.107702     -5.5990133
    [400]      -3.1964538     -2.0704005     -1.6577560     -2.0797544
    [404]      -3.7475493     -7.1912370     -10.968422     -8.3112478
    [408]      -5.3504982     -4.5283999     -5.6863546     -8.8582392
    [412]      -11.928948     -8.8310070     -5.0846601     -2.2299283
    [416]      0.34072292      2.7511020      4.7914591      6.2589307
    [420]       7.0298443      7.0156369      6.1290097      4.2896700
    [424]       1.5241071     -1.6564777     -3.6385834     -2.6734200
    [428]      0.44481307      3.6082425      5.9234786      7.3261113
    [432]       7.9545484      7.8981996      7.0570369      5.0632844
    [436]       1.2634284     -3.2448618    -0.51328534      2.3985343
    [440]       2.9988208      2.0134339     0.92000812      1.1155270
    [444]       1.1976871    -0.70146441     -6.6004295     -6.0462012
    [448]       1.2962888      4.8786449      6.5659862      7.0551848
    [452]       6.7630067      6.2875729      6.3926911      7.0549636
    [456]       7.5271873      7.5904808      8.1027279      9.8963070
    [460]       12.060451      13.578568      14.118256      13.573635
    [464]       11.780332      8.2651558      1.4190509     -3.3027999
    [468]       4.8446574      8.6611147      10.748944      12.004264
    [472]       12.770237      13.172416      13.230685      12.926629
    [476]       12.265931      11.352799      10.449061      9.8542967
    [480]       9.5500002      9.1290359      8.1019049      5.9976983
    [484]       2.2371988     -2.2386951     0.41834316      3.9883442
    [488]       5.5467863      5.4832168      3.9933546      1.1176795
    [492]      -2.9062057     -6.0254273     -4.8350325     -1.8790112
    [496]      0.57184565      1.9412862      2.0234988     0.58812374
    [500]      -3.0045979     -11.491042     -12.595685     -4.7388306
    [504]      -1.8717496    -0.86827689    -0.75130117    -0.87168938
    [508]     -0.80827320    -0.54287976    -0.27816477    -0.13010068
    [512]    -0.088841386
  [Tag]         5281
  [frame_len]          320
[Record 34]
  [tot_power]       269962.41
  [re_spec_val]
    [0]      -2.0103364     -2.8743174     -5.7439260     -10.949440
    [4]      -10.502649     -6.4653244     -4.8676815     -3.6665969
    [8]     -0.83020246      1.8183620      3.0187709      4.3946500
    [12]       8.6837921      13.298725      16.591013      18.519253
    [16]       19.194435      18.640495      16.757252      13.284521
    [20]       7.9822874      3.3631809      2.8337741      1.8262215
    [24]       4.2101579      7.2953300      6.3423071      4.1033015
    [28]       15.283460      21.883297      25.866570      28.173859
    [32]       29.143684      28.887144      27.389076      24.553652
    [36]       20.387487      16.015036      13.863157      12.827666
    [40]       12.574582      12.107442      2.4736154      15.435264
    [44]       25.199127      30.671385      34.113926      36.150589
    [48]       37.034267      36.876152      35.718079      33.570683
    [52]       30.461393      26.525530      22.069078      17.218996
    [56]       11.687791      8.6822281      9.0787773      6.4459958
    [60]       9.2150888      16.821419      21.277668      23.689327
    [64]       24.588928      24.165932      22.464909      19.556751
    [68]       16.078770      13.763070      12.432514      9.8774719
    [72]       5.1834860      2.9372149      4.4738040      3.7563713
    [76]       5.8353043      11.482804      15.396469      17.591513
    [80]       18.455475      18.188078      16.875938      14.570912
    [84]       11.406559      7.7674046      4.0887871    -0.16147722
    [88]      -7.0059342     -13.260140     -5.4237485     0.13781251
    [92]       4.6964211      8.1982985      10.672046      12.264033
    [96]       13.093669      13.219409      12.654247      11.408184
    [100]       9.5565586      7.3157525      5.0031404      2.7714145
    [104]      0.41702452     -2.7068579     -3.3784916      4.3329191
    [108]       10.589223      14.932957      17.886303      19.704630
    [112]       20.495497      20.274979      18.988712      16.547312
    [116]       13.084010      10.073121      9.3619566      8.7739010
    [120]       6.5477300      3.0185122      1.5803089      2.4092104
    [124]       5.3457894      10.290954      14.256148      16.734699
    [128]       17.933418      18.064825      17.331549      16.007492
    [132]       14.480991      13.068288      11.688057      9.9176826
    [136]       7.2117777      2.7539322     -3.4752829     0.13469948
    [140]       5.4447732      9.7569551      13.606838      16.692936
    [144]       18.814421      19.951330      20.147942      19.465754
    [148]       17.983116      15.809874      13.088269      9.9567537
    [152]       6.5289707      3.0002518    -0.25467718     -2.8061092
    [156]      -3.9124684     -2.4838884     0.86143112      4.1094198
    [160]       6.2017794      6.8038378      5.7152758      2.9696147
    [164]       1.5843575      4.3769765      6.5438161      6.9852958
    [168]       5.8690343      3.3475034    -0.40009862     -4.1688657
    [172]      -2.1608019      2.8042910      6.4765182      8.7370710
    [176]       9.7992163      9.8091841      8.8469906      6.9447446
    [180]       4.1234436     0.52534974     -3.1823938     -5.5166292
    [184]      -5.9413848     -5.8721008     -6.0154915     -3.0061090
    [188]       2.5965672      7.1323757      10.293849      12.346006
    [192]       13.499931      13.885933      13.567179      12.559340
    [196]       10.869891      8.5732880      5.9072123      3.2257626
    [200]      0.72683734     -1.2097827     -1.5824724    -0.91102642
    [204]     -0.55520171    -0.49573243     0.43758810      2.6593673
    [208]       5.1583762      7.2261114      8.6437368      9.3544855
    [212]       9.3624020      8.7262287      7.5654616      6.0243654
    [216]       4.1549692      1.8236207     -1.1004497     -3.9075363
    [220]      -4.7193794     -4.4434867     -5.2754984     -8.0783653
    [224]      -10.031792     -5.4600568     -1.4015236      1.0997678
    [228]       2.5213490      3.0638614      2.6696374      1.1083599
    [232]      -1.8888971     -5.9104700     -8.4357634     -9.3287725
    [236]      -4.3778396      2.3725448      6.9816561      9.9206791
    [240]       11.622975      12.331553      12.178667      11.230298
    [244]       9.5169468      7.0758615      4.0390067     0.80691671
    [248]      -1.8201065     -3.2241013     -4.0180273     -5.6070318
    [252]      -8.9686165     -7.7334871     -1.8835781      1.9114002
    [256]       4.0563388      5.0979209      5.4199381      5.3305392
    [260]       5.0385127      4.5956550      3.8794122      2.5815454
    [264]      0.15156999     -4.1292601     -6.6264453     -2.6777706
    [268]     -0.71312457     -1.8557980     -6.5577559     -2.7781374
    [272]       3.5046914      6.8896208      8.5421476      9.0114851
    [276]       8.5934973      7.4913073      5.8440323      3.6608732
    [280]      0.73528504     -3.0438848     -5.1665668     -3.3001187
    [284]      -1.9121236     -2.3555770     -3.8183811     -2.3667030
    [288]       1.4152794      4.2569094      5.8312826      6.3248224
    [292]       5.9177976      4.8295574      3.3624892      1.7227232
    [296]     -0.25440195     -2.7140260     -4.3199902     -3.5476556
    [300]      -2.4346144     -1.8774804    -0.87089479      1.1061332
    [304]       3.1111302      4.4735050      5.0751400      4.9664702
    [308]       4.2136517      2.8685172     0.96512669     -1.4863451
    [312]      -4.4810510     -7.8398442     -10.591919     -10.979225
    [316]      -9.3904676     -7.5354500     -6.2094321     -5.5448937
    [320]      -5.2577357     -4.8306346     -4.0870757     -3.4556248
    [324]      -3.4377215     -4.3121257     -6.1675143     -8.8324938
    [328]      -11.696411     -14.521046     -19.268637     -23.724091
    [332]      -14.539262     -9.6176424     -6.9100690     -5.4045157
    [336]      -4.6332779     -4.3395147     -4.3929071     -4.7254066
    [340]      -5.2597175     -5.9826860     -7.3603115     -11.160272
    [344]      -15.308396     -4.3675089      1.6416166      5.0182638
    [348]       6.5266671      6.1898088      3.3496735     -3.7673359
    [352]       1.2642933      7.3491292      10.260046      11.473905
    [356]       11.583866      10.952841      9.8923149      8.6729927
    [360]       7.4493804      6.2225218      4.9487419      3.7228842
    [364]       2.7403641      1.8327488     0.25342205     -3.1621799
    [368]      -11.403998     -13.370646     -5.5399280     -3.1817429
    [372]      -2.6105509     -2.1904669     -1.4436588     -1.1927830
    [376]      -2.3181210     -5.7883787     -14.252748     -10.759295
    [380]      -4.6797738     -2.2709825     -1.5136682     -1.2582711
    [384]     -0.41543818      1.2224296      3.0359676      4.5949574
    [388]       5.7457995      6.4160056      6.5587635      6.1458087
    [392]       5.1254859      3.3225501     0.27533761     -4.8650670
    [396]      -7.4440360     -2.4896946     0.24016894     0.79109055
    [400]     -0.54537326     -4.0849833     -10.269181     -8.9214573
    [404]      -4.3526282     -2.1193120     -1.1978096     -1.0401727
    [408]      -1.4568183     -2.4567003     -4.0796680     -6.1562285
    [412]      -7.8808107     -8.1223812     -7.2112050     -5.8776336
    [416]      -4.0015392     -1.6831144     0.45782119      1.9895099
    [420]       2.8064098      2.9626563      2.5422673      1.5417171
    [424]     -0.26966327     -3.6038098     -11.149323     -16.808640
    [428]      -5.3952103     -1.5113584     0.20871432      1.1423078
    [432]       2.4101856      4.3326864      6.2677059      7.7026949
    [436]       8.5044966      8.7009544      8.3500290      7.4820952
    [440]       6.0552502      3.8840442     0.46238562     -5.7398539
    [444]      -14.550683     -5.1402092     -1.4599608    -0.67509776
    [448]      -2.2584081     -7.6758461     -17.504816     -3.2690821
    [452]       2.0420418      5.0425887      6.8197613      7.6934981
    [456]       7.7442374      6.9525318      5.2840152      2.9233382
    [460]      0.94878352     0.66534793     0.74905705    -0.61770457
    [464]      -4.8379164     -9.9580746     -3.5706105    -0.17376465
    [468]      0.44338453    -0.93809456     -3.7318137     -6.3155785
    [472]      -5.7846203     -2.6617332   0.0034600522     0.78079045
    [476]      -1.3373132     -9.9846306     -4.1901450      2.4958956
    [480]       4.7197075      4.0840378    -0.27645591     -15.691934
    [484]       1.3092982      6.6375461      9.0678015      9.9811468
    [488]       9.7949047      8.6367111      6.4969001      3.2859969
    [492]     -0.98294759     -4.5474982     -3.5766296     -1.4910395
    [496]     -0.64202440     -1.3258907     -3.5955524     -5.8042741
    [500]      -3.6916285    -0.60108072      1.3207703      2.2408869
    [504]       2.4278104      2.0296073      1.1306736    -0.15232055
    [508]      -1.5955408     -2.8815866     -3.7501671     -4.1672969
    [512]      -4.2764773
  [Tag]         5441
  [frame_len]          320
[Record 35]
  [tot_power]       260758.78
  [re_spec_val]
    [0]       7.0676255      6.6327062      5.3064966      3.0432642
    [4]     -0.10819134     -3.3185301     -3.6465347     -1.3387167
    [8]   -0.0049838712     -2.2419984     -7.1623168      6.5950875
    [12]       13.487905      17.659988      20.165722      21.376190
    [16]       21.446835      20.436314      18.345015      15.115686
    [20]       10.562271      4.0860429     -2.9622362      1.0851747
    [24]       3.1881053     -1.4281534      3.2884481      15.003140
    [28]       21.341228      25.435837      28.038094      29.432611
    [32]       29.730566      28.941332      26.977198      23.602385
    [36]       18.245945      9.2900820      3.5820549      8.7570095
    [40]       10.082253      6.8652229      9.5893440      21.331541
    [44]       27.958361      32.263302      35.025543      36.548191
    [48]       36.954266      36.264366      34.408993      31.195246
    [52]       26.190380      18.464336      11.124136      13.094523
    [56]       12.779089      10.574296      6.3714757      4.1540780
    [60]       13.123827      18.561428      21.763477      23.494213
    [64]       24.020355      23.391464      21.501451      18.022238
    [68]       12.147692      5.2664237      8.9452677      11.154946
    [72]       10.795013      7.9888783     0.84479213      4.5340652
    [76]       12.169672      16.441595      19.020494      20.368145
    [80]       20.610556      19.742435      17.664951      14.149128
    [84]       8.7022266     0.61292666     -2.8609345    -0.88016808
    [88]      -1.4165156     -4.1118622     -9.6530342     -8.1311398
    [92]      0.13051058      5.4386921      8.9141493      10.974813
    [96]       11.768337      11.321702      9.5518608      6.2086024
    [100]      0.73378628     -6.7958736     -6.8650136     -4.6054525
    [104]      -3.3146567    -0.56463116      4.8244829      10.275494
    [108]       14.503470      17.441099      19.195990      19.841068
    [112]       19.386509      17.764902      14.784243      9.9603767
    [116]       1.6901642     -13.636679     -2.8941441     -2.0962653
    [120]      -6.7576175     -10.436999      3.5656271      10.478616
    [124]       15.178593      18.474058      20.617607      21.703518
    [128]       21.747229      20.692770      18.381693      14.454534
    [132]       8.0599365     -1.1962612     0.17896549     0.90052301
    [136]      -1.3378795     -3.5320191     0.53171587      7.2242794
    [140]       12.272445      15.644753      17.641426      18.450609
    [144]       18.153799      16.741331      14.102843      9.9742174
    [148]       3.7817583     -5.6591630     -13.574107     -13.161876
    [152]      -12.836460     -14.445156     -10.281427    -0.40101671
    [156]       5.4458642      9.0885363      11.263563      12.272091
    [160]       12.209867      11.021139      8.4520187      3.7619498
    [164]      -6.4317160     -8.9278889     -1.4092288    0.032699116
    [168]      -1.0237610     -4.2713265     -7.8261137     -2.7767856
    [172]       2.4288385      5.8864460      8.0720682      9.1579924
    [176]       9.1456137      7.9212680      5.1936097     0.15532944
    [180]      -11.080616     -11.050232     -4.8769045     -3.7059383
    [184]      -3.8680456     -2.5760212      1.5547166      6.1083345
    [188]       9.7662916      12.335126      13.836263      14.294523
    [192]       13.693314      11.948984      8.8604288      3.9637830
    [196]      -3.9567020     -12.624056     -8.5189304     -7.6560073
    [200]      -7.8527598     -6.7273555     -3.8344924    -0.47918260
    [204]       2.3090289      4.2038693      5.1570497      5.1671014
    [208]       4.2055969      2.1838129     -1.1048528     -6.1879272
    [212]      -15.121090     -26.715590     -14.565640     -10.927354
    [216]      -8.6654463     -6.6632090     -4.5324168     -2.2964714
    [220]     -0.27759916      1.2085277      1.9899983      2.0080013
    [224]       1.2762706    -0.11386545     -1.9392619     -3.8090203
    [228]      -5.3483129     -6.4983926     -7.4214091     -8.5365372
    [232]      -11.410303     -25.213049     -8.0754433    0.041553695
    [236]       4.7949309      7.7945919      9.5035887      10.089968
    [240]       9.5884695      7.9281135      4.8841310    -0.14108096
    [244]      -9.2938623     -17.792013     -10.641908     -10.918727
    [248]      -14.286398     -12.062961     -6.4423113     -2.4066849
    [252]      0.39598641      2.1275380      2.7618556      2.1994128
    [256]      0.24378353     -3.5466909     -10.463863     -27.317997
    [260]      -18.977537     -19.666231     -23.622078     -16.024239
    [264]      -12.943663     -10.934058     -5.3847647    0.071424477
    [268]       3.8748891      6.2229624      7.3232770      7.2615027
    [272]       6.0104117      3.4097903    -0.90320337     -7.3326807
    [276]      -11.825244     -11.360997     -13.273293     -15.086956
    [280]      -10.145274     -4.6260104     0.20336649      4.1315098
    [284]       7.0191250      8.8772879      9.7515593      9.6620502
    [288]       8.5795507      6.4012690      2.8929789     -2.5034511
    [292]      -11.726094     -27.146816     -13.773795     -9.6813211
    [296]      -5.9947176     -2.3064673      1.0814091      3.8734014
    [300]       5.8879528      7.0455980      7.3075895      6.6299009
    [304]       4.9367232      2.1064203     -2.0034204     -7.2855453
    [308]      -12.234404     -14.184310     -12.945826     -10.783077
    [312]      -9.9481573     -11.304320     -16.142572     -25.033573
    [316]      -15.211648     -11.198289     -9.9813662     -10.353644
    [320]      -11.665432     -13.104436     -13.828866     -13.965338
    [324]      -14.338266     -15.595357     -18.350706     -24.033831
    [328]      -28.728411     -19.450346     -14.000416     -10.317850
    [332]      -7.7430015     -6.0811043     -5.1789618     -4.8036313
    [336]      -4.6474996     -4.4840055     -4.3263211     -4.3650675
    [340]      -4.8404155     -5.9845471     -7.8060107     -9.2885857
    [344]      -8.2660875     -4.6990771    -0.27670136      3.6547339
    [348]       6.5437226      8.2648211      8.7785864      7.9869471
    [352]       5.6351118      1.2402238     -3.6107557     -1.3874648
    [356]      0.69018787     0.47194830     -1.6769415     -5.5001793
    [360]      -10.178066     -11.059470     -6.0363002     -1.4197464
    [364]       1.6746238      3.4676514      4.1893053      3.9872913
    [368]       2.9279425     0.98521423     -1.9990665     -6.3726954
    [372]      -12.002998     -13.151136     -11.246126     -12.094374
    [376]      -16.996498     -9.9332657     -2.4703715      2.0427845
    [380]       4.8486371      6.3792825      6.7761459      6.0318308
    [384]       4.0129514     0.45450044     -4.6084104     -7.4883251
    [388]      -6.7974830     -7.2417488     -7.3521500     -4.7170453
    [392]      -1.9020096     0.24673043      2.2644832      4.2859702
    [396]       5.9068098      6.7488003      6.6059470      5.3192124
    [400]       2.6322117     -2.0501254     -10.264512     -13.072521
    [404]      -8.7568998     -8.1760120     -9.6065960     -11.204144
    [408]      -9.3367186     -5.1165080     -1.3247637      1.5429233
    [412]       3.5013421      4.5888743      4.8015351      4.0737090
    [416]       2.2438526     -1.0517175     -6.8046937     -19.068802
    [420]      -13.823119     -9.3680277     -7.9271774     -6.9473863
    [424]      -5.1587911     -2.5242400     0.18859974      2.3875010
    [428]       3.8198712      4.3943014      4.0671377      2.8315628
    [432]      0.89668834    -0.74004912    -0.76632649   -0.087166458
    [436]     -0.13813078     -1.4675716     -4.2847509     -8.3171024
    [440]      -10.993232     -10.213059     -7.3103156     -3.5773690
    [444]     -0.76841813     0.51474351    0.048019744     -2.7058105
    [448]      -8.8633070     -7.2073450     -1.8831075     0.14923973
    [452]    -0.035967402     -2.0090506     -4.6329594     -4.5801945
    [456]      -3.1379719     -3.1128671     -5.0310249     -8.0586987
    [460]      -7.5065274     -4.9517088     -3.9284062     -4.4026699
    [464]      -5.0683007     -3.8791933     -1.7453594    -0.34718499
    [468]     -0.11260564     -1.0626153     -2.6773243     -2.2583044
    [472]       1.1727065      4.6340404      7.2345810      8.9733028
    [476]       9.8836432      9.9399948      9.0586863      7.1013789
    [480]       3.9425659    0.088381700     -1.8524350     -1.9088494
    [484]      -3.2067692     -7.0471091     -14.041306     -18.147816
    [488]      -15.228515     -5.5372515     0.95728058      4.9929357
    [492]       7.4045539      8.5869837      8.7281666      7.8999805
    [496]       6.0875330      3.1873558     -1.0087668     -6.6915855
    [500]      -12.281773     -13.438483     -13.624905     -14.341290
    [504]      -13.520434     -9.6875420     -5.2122321     -1.5724777
    [508]       1.0779655      2.8744195      3.9867120      4.5731721
    [512]       4.7533607
  [Tag]         5601
  [frame_len]          320
[Record 36]
  [tot_power]       246730.17
  [re_spec_val]
    [0]      -4.8437304     -2.3714132    -0.38619331     -1.0712339
    [4]      -4.6502099     -12.330770     -20.047352     -5.2339592
    [8]       1.1091042      3.7590735      2.3355787     -18.283451
    [12]       7.2346330      14.827170      19.087969      21.594006
    [16]       22.813023      22.901651      21.862843      19.590904
    [20]       15.957609      11.443507      8.4669132      6.7497182
    [24]       4.2962904      6.1456614      11.699119      17.621239
    [28]       22.746925      26.600773      29.202450      30.666946
    [32]       31.082079      30.489265      28.881508      26.199095
    [36]       22.327898      17.154369      10.942131      6.7138710
    [40]       9.8640251      13.773216      16.096416      18.693832
    [44]       23.292171      27.918201      31.404324      33.696270
    [48]       34.908302      35.127666      34.396801      32.717094
    [52]       30.060501      26.457228      22.504822      20.155758
    [56]       19.598799      18.871517      17.756207      16.797663
    [60]       14.823606      6.7996955      11.878537      20.776928
    [64]       24.848141      26.742937      27.136082      26.306911
    [68]       24.471590      22.054968      19.895620      18.475454
    [72]       17.097027      14.975389      12.354169      12.480452
    [76]       15.790811      18.659334      20.342436      20.899382
    [80]       20.427889      19.036112      16.919498      14.448007
    [84]       12.040040      9.7569914      7.4280024      5.3220530
    [88]       3.8049572      1.9737972     -2.4752645     -8.2143021
    [92]       2.4334700      7.7637382      10.513116      11.550645
    [96]       11.048960      8.8119555      4.2254395    -0.13509338
    [100]       4.2587271      7.3429284      8.3785992      8.0079241
    [104]       6.7739024      6.0003538      7.2764769      9.7522726
    [108]       12.325051      14.736666      16.823175      18.403231
    [112]       19.366348      19.676716      19.340509      18.386616
    [116]       16.881363      15.008119      13.195691      11.917784
    [120]       10.911394      9.0764303      4.4231586     -8.6607924
    [124]       6.9166522      12.579266      15.375074      16.585560
    [128]       16.689581      16.149017      15.710582      15.947999
    [132]       16.490019      16.723476      16.496822      16.054270
    [136]       15.797014      16.011181      16.755404      17.865644
    [140]       18.991352      19.764408      19.908407      19.199642
    [144]       17.364815      13.900671      7.5135880    -0.60188836
    [148]       5.8911610      8.3680038      8.6162243      8.5737162
    [152]       9.4808340      10.707236      11.121251      9.8782072
    [156]       5.2859488     -9.4286470      7.8191032      13.037346
    [160]       15.256877      15.755126      14.950283      13.067376
    [164]       10.365388      7.3758192      5.1988735      4.8311100
    [168]       5.3828511      5.4562993      4.9940896      6.0242314
    [172]       9.0655003      11.796350      13.371847      13.727077
    [176]       12.832043      10.510160      6.3232045     0.66107213
    [180]       1.7706243      4.8434486      5.9597878      5.9211712
    [184]       5.9223366      7.0315590      8.8124781      10.318343
    [188]       11.125148      11.057688      9.9132643      7.3174777
    [192]       2.8293159     0.55828416      4.3754416      6.7949057
    [196]       7.4501939      6.8804631      5.5770907      4.1033974
    [200]       2.9380987      2.2262216      1.9917433      2.3332858
    [204]       3.1758609      4.1952662      5.0709062      5.6244049
    [208]       5.8013802      5.6411486      5.2789812      4.9386897
    [212]       4.8254819      4.9623394      5.2020054      5.3978796
    [216]       5.5157681      5.6778703      6.1694517      7.2359533
    [220]       8.7316084      10.218815      11.345402      11.962630
    [224]       12.084480      11.846527      11.445141      11.012776
    [228]       10.527190      9.8761911      8.9629622      7.7180634
    [232]       6.0768352      4.0296912      1.8363963     0.71263856
    [236]       2.3399217      5.2529106      7.5850496      8.8258505
    [240]       8.8743753      7.6483855      4.9567103     0.39095977
    [244]      -5.8437233     -5.9985108     -3.2983365     -2.1956582
    [248]      -1.6361926   -0.051190760      2.8588083      5.8027549
    [252]       7.9936285      9.2180643      9.3993464      8.4236584
    [256]       6.0565519      2.0200696     -1.3576809      1.0608455
    [260]       3.4343536      4.2500601      4.0672441      3.6333399
    [264]       3.5967638      4.0497613      4.8596897      5.9743934
    [268]       7.0765843      7.6464195      7.2644405      5.5993986
    [272]       2.1903644     -4.1149826     -16.709099     -11.041598
    [276]      -9.9224501     -15.446629     -14.509331     -6.6802769
    [280]      -3.9447784     -4.7455406     -11.316508     -7.0191798
    [284]       1.0950543      4.9956031      6.8832374      7.4616828
    [288]       7.0765662      5.9356651      4.1504960      1.7694846
    [292]      -1.0664309     -3.7033799     -4.8192363     -4.1796913
    [296]      -2.9245958     -1.8645458     -1.4942673     -2.3973663
    [300]      -5.8118649     -17.752829     -7.1057844    -0.47056425
    [304]       2.5288126      3.7663047      3.8855863      3.3014441
    [308]       2.3876753      1.4793559     0.83939135     0.63962215
    [312]      0.89168543      1.4033127      1.8589760      1.9342065
    [316]       1.3643446   -0.027327361     -2.2725396     -5.0260158
    [320]      -7.3073201     -8.5706072     -9.4188957     -9.7366247
    [324]      -9.0357256     -7.9610372     -7.1576014     -6.6739001
    [328]      -6.4606833     -6.6679864     -7.5393286     -9.1127701
    [332]      -10.502448     -9.7380285     -7.4612541     -5.4330487
    [336]      -4.0971060     -3.4431815     -3.4282119     -4.0367332
    [340]      -5.2502847     -6.9433479     -8.7708788     -9.7181997
    [344]      -5.9362340     0.50380510      5.8296900      9.7486973
    [348]       12.439442      14.032463      14.588722      14.107636
    [352]       12.527077      9.7334299      5.7747278      2.3071849
    [356]       2.1558011      2.6229272      1.6670090     -1.4116322
    [360]      -6.9912534     -2.1308556      4.0924921      7.8899117
    [364]       10.185907      11.324268      11.428521      10.564843
    [368]       8.8919458      6.9647832      5.7991638      5.5148730
    [372]       5.0893087      3.8318799      1.5166186     -1.8067454
    [376]      -4.5862322     -2.4691000      1.4725214      4.3078094
    [380]       5.7295380      5.6571755      3.8173752    -0.49764112
    [384]      -5.2191763    -0.35544065      3.0878041      4.3617172
    [388]       4.1785173      2.8190353     0.49008036     -1.6473732
    [392]      -1.1205726     0.77065194      2.0354552      2.5547774
    [396]       2.8505743      3.4253097      4.1638465      4.5393758
    [400]       4.1488223      2.7739511     0.26303282     -3.5478287
    [404]      -8.8764009     -16.078966     -18.438528     -10.383489
    [408]      -4.6469488    -0.83221620      1.4583292      2.3340952
    [412]       1.7262683    -0.57061583     -4.1253037     -4.2229657
    [416]      -1.6024830    -0.57248753     -1.4167193     -3.6902220
    [420]      -5.2666125     -3.8194003     -1.7935879    -0.40545225
    [424]      0.44778663     0.88912183     0.92167556     0.51109922
    [428]     -0.33125561     -1.2937456     -1.4642015    -0.53776354
    [432]      0.27439767   -0.051055152     -1.6828326     -2.3233297
    [436]      0.56773424      3.3845100      4.7357221      4.5967226
    [440]       2.8335037     -1.3668739     -11.700512     -4.9451761
    [444]       1.0156686      3.3298872      3.4895587      1.4988472
    [448]      -3.8104243     -9.4378052     -1.7983575      1.5244141
    [452]       2.3295846      1.6145134     0.17921008    -0.99790412
    [456]      -1.8180759     -3.3682849     -6.3745222     -7.0670805
    [460]      -2.8767536     0.24862529      1.6920333      1.6899232
    [464]      0.25640357     -2.7746680     -6.2058430     -4.1131334
    [468]     -0.36604568      2.0329955      3.1751521      3.0265934
    [472]       1.1019745     -3.7419872     -3.4747581      3.2991755
    [476]       6.9786592      8.6027813      8.6390181      7.1260805
    [480]       3.7047567     -3.0136244     -12.325609     -4.2747025
    [484]      -1.8908441     -2.3948104     -4.8822722     -7.4586267
    [488]      -5.7358484     -2.7582896    -0.16158815      2.4501274
    [492]       4.7300448      6.1181350      6.3235393      5.2231541
    [496]       2.9186285     0.65461683     0.74724954      1.7707447
    [500]       1.9288841      1.0865196    -0.35236841     -1.7280713
    [504]      -2.5178835     -2.9838157     -3.7931561     -5.0559974
    [508]      -5.8688822     -5.8914375     -6.6787314     -9.7863531
    [512]      -13.864000
  [Tag]         5761
  [frame_len]          320
[Record 37]
  [tot_power]       274761.97
  [re_spec_val]
    [0]       18.691744      18.360184      17.362980      15.713272
    [4]       13.547414      11.462451      10.657792      11.234705
    [8]       11.868093      11.569052      9.5837460      6.1052327
    [12]       10.093301      15.788021      19.246349      21.015509
    [16]       21.375711      20.358606      17.746490      12.702426
    [20]    -0.088507213      4.8009582      11.251356      13.528679
    [24]       14.164404      14.016797      14.941146      18.674330
    [28]       23.020897      26.489460      28.875164      30.212234
    [32]       30.537930      29.860571      28.159332      25.398535
    [36]       21.591501      17.068792      13.223762      11.997813
    [40]       12.533121      12.747453      11.544677      12.437086
    [44]       18.686731      23.808083      27.140007      29.010649
    [48]       29.577150      28.841379      26.647127      22.574104
    [52]       15.485468    0.065817483      1.2029614      6.2151566
    [56]       10.885049      10.866281      7.3803740      19.711905
    [60]       26.687420      30.919640      33.536274      34.965530
    [64]       35.394627      34.895161      33.466663      31.052036
    [68]       27.541603      22.781923      16.650347      9.4828835
    [72]       3.5846908      2.0320675      3.4821839      7.5252242
    [76]       11.800735      14.740670      16.283947      16.614231
    [80]       15.868631      14.102032      11.276941      7.2110333
    [84]       1.2774339     -9.5877123     -9.1437120     -3.0811126
    [88]      -1.3077669    -0.82472217     0.36775562      2.5956895
    [92]       4.8038297      6.6243901      8.0869808      9.1897774
    [96]       9.9233027      10.379163      10.715312      10.969196
    [100]       10.939826      10.280289      8.5775957      5.2380934
    [104]      0.11523215      2.2623434      7.4877582      10.835743
    [108]       12.930622      14.068947      14.299434      13.576484
    [112]       11.841991      9.1420355      5.9363699      3.3062911
    [116]       2.0797317      3.1657550      6.0025969      8.4505386
    [120]       9.7664404      9.9109116      9.0669422      7.9860697
    [124]       8.1989346      9.6757593      10.988777      11.590345
    [128]       11.550032      11.137244      10.636923      10.170832
    [132]       9.7179976      9.3773642      9.3152504      9.2589664
    [136]       8.5646420      6.9589362      5.8358417      7.0386195
    [140]       8.1768818      7.1955628      2.0781283     -9.1720133
    [144]       5.6595874      10.032236      11.893023      13.089543
    [148]       14.757305      16.767977      18.411886      19.333946
    [152]       19.478376      18.990822      18.407719      18.693733
    [156]       20.026840      21.502287      22.491404      22.831087
    [160]       22.544739      21.725784      20.518770      19.118710
    [164]       17.738033      16.537340      15.615954      15.087411
    [168]       15.017531      15.263036      15.683341      16.521687
    [172]       18.098888      20.065430      21.760427      22.797649
    [176]       23.025377      22.367416      20.741243      18.042364
    [180]       14.347124      11.195539      11.243072      12.297535
    [184]       12.597065      12.094848      11.025922      9.8465748
    [188]       9.5387840      10.546016      11.777755      12.247854
    [192]       11.492388      9.0230789      3.4454653     -6.7226315
    [196]       3.7595437      7.8776884      9.2215881      8.8445053
    [200]       6.8696733      2.6283231     -8.5996122     -4.1392636
    [204]       3.3614230      6.4687757      7.9791856      8.8472443
    [208]       9.5763235      10.073441      9.8311644      8.2865305
    [212]       4.8015323    -0.46692163     0.50338662      3.4176517
    [216]       3.8389750      2.1543474    -0.25802448      2.0211878
    [220]       6.5367818      9.7658300      11.539658      11.882524
    [224]       10.632998      7.3885360      3.3694429      6.1816378
    [228]       9.5417929      10.752194      10.126861      7.7459445
    [232]       4.0781302      3.7395561      7.2752423      10.286095
    [236]       12.445313      13.802634      14.245371      13.599795
    [240]       11.626507      7.9813905      3.1993196      3.1693594
    [244]       5.5370502      6.4193597      6.2734571      5.8056617
    [248]       5.2711196      4.7102785      4.7853527      5.9352155
    [252]       7.1223330      7.4474416      6.9837017      7.0843105
    [256]       8.8682022      10.921646      12.117535      12.241400
    [260]       11.315933      9.3842621      6.4481316      2.3382862
    [264]      -3.2646704     -4.0479145      1.5973635      5.8481989
    [268]       8.9860735      11.375893      13.128002      14.273607
    [272]       14.835419      14.839936      14.311028      13.264123
    [276]       11.717046      9.7615585      7.7989473      6.7369933
    [280]       6.9168329      7.3337603      7.0401053      5.4843407
    [284]       1.9242517     -6.4934616     -10.497458    -0.68570977
    [288]       2.7396202      4.4862633      5.6087432      6.4005013
    [292]       6.8873496      7.1966119      7.6646390      8.5611963
    [296]       9.8109512      11.185422      12.510640      13.629703
    [300]       14.370312      14.580910      14.159324      13.061646
    [304]       11.331666      9.1955538      7.1670370      5.8013740
    [308]       5.2130561      5.3233371      5.9931226      6.7884655
    [312]       7.3343515      7.6197386      7.8653021      8.1493664
    [316]       8.2246904      7.7455735      6.4610682      4.1720715
    [320]      0.48760077     -5.7450557     -7.2622175    -0.24343994
    [324]       3.7038100      5.7642040      6.4908705      6.1025925
    [328]       4.7424402      2.6905656     0.65346032    -0.46004915
    [332]     -0.38067955     0.89858025      2.8494811      4.4368644
    [336]       5.0521288      4.4772220      2.6767831   -0.012174945
    [340]      -2.2565143     -2.8595095     -2.3829796     -1.2548321
    [344]     -0.43670213    -0.37667811      1.8742334      6.7023673
    [348]       10.659839      13.168386      14.427853      14.707647
    [352]       14.407434      14.083662      14.001888      13.758824
    [356]       12.773873      10.755498      8.0564661      6.0145035
    [360]       4.3770456     0.77910316      3.3559475      9.9736605
    [364]       13.735984      15.485243      15.662476      14.400352
    [368]       11.768905      8.5904055      7.6971641      8.6755514
    [372]       9.0459013      8.5777292      7.8908296      7.6961908
    [376]       8.2088432      9.0941324      9.8532600      10.051502
    [380]       9.3539276      7.5002828      4.8136811      4.7233558
    [384]       7.9001851      10.495195      11.869824      12.187736
    [388]       11.620424      10.353725      8.7005320      7.2276917
    [392]       6.6658201      7.3361239      8.7934809      10.370292
    [396]       11.657819      12.495473      12.839036      12.678564
    [400]       12.003728      10.792988      9.0106869      6.6032472
    [404]       3.4949255    -0.38327804     -4.8424926     -8.3306732
    [408]      -7.5883207     -3.5059321     0.78193444      4.1604795
    [412]       6.4760580      7.7559185      8.0137253      7.2064476
    [416]       5.2306371      2.0398960     -1.5031613     -2.8587611
    [420]      -3.4163156     -6.7170687     -17.587406     -6.1450920
    [424]     -0.41212410      2.2039359      3.3730733      3.8946385
    [428]       4.2796502      4.6051965      4.5647306      3.7602258
    [432]       1.7395518     -2.4204671     -11.256698     -5.4457173
    [436]      0.59136796      3.4524860      4.5217185      4.0497875
    [440]       1.8386132     -1.7522494    -0.20131801      4.3032565
    [444]       7.1645303      8.6591921      9.2252312      9.2147408
    [448]       8.9239569      8.4879913      7.7872186      6.5398726
    [452]       4.4479318      1.2957529     -2.3788297     -2.9686749
    [456]     -0.35351753      1.9417858      3.3164799      3.8336418
    [460]       3.6161416      2.8060508      1.3942701     -1.1390193
    [464]      -6.6702213     -26.471823     -5.6070600     -1.1926671
    [468]      0.20133516     0.55647314      1.3925666      2.5499241
    [472]       2.7723098      1.4458885    -0.33966357      1.2111697
    [476]       3.8318288      4.9717479      5.0015893      5.8759985
    [480]       8.4799414      10.985250      12.484627      12.894370
    [484]       12.258363      10.581906      7.7771268      3.5428221
    [488]      -2.6617873     -4.0683093      1.0426824      4.0615354
    [492]       5.3869429      5.5945463      5.5819955      6.5329475
    [496]       8.2409296      9.6388206      10.268035      10.118305
    [500]       9.3655024      8.3276072      7.4258833      6.9778590
    [504]       6.9724736      7.1487088      7.2089067      6.9148936
    [508]       6.0893903      4.5818229      2.2360251    -0.93575811
    [512]      -3.0753281
  [Tag]         5921
  [frame_len]          320
[Record 38]
  [tot_power]       269132.41
  [re_spec_val]
    [0]       19.259390      18.793385      17.367052      14.884675
    [4]       11.132256      5.5720239     -3.2571738     -3.7445755
    [8]       1.3393945      3.1950443      4.9052439      9.6217537
    [12]       14.642666      18.351898      20.761442      22.024448
    [16]       22.221500      21.349237      19.310610      15.876066
    [20]       10.585408      2.5370743     -8.3462000     -7.2613363
    [24]      -5.2382565     -2.1866910      10.220617      18.029333
    [28]       23.193392      26.626528      28.719097      29.651199
    [32]       29.492685      28.239283      25.826902      22.148636
    [36]       17.099373      10.408385     -1.7539693      3.9039485
    [40]       10.465718      13.901629      18.050112      22.699169
    [44]       26.434389      28.939028      30.264244      30.465670
    [48]       29.531374      27.345985      23.600414      17.460108
    [52]       5.5155592      1.2423375     0.25560951      5.5315166
    [56]       17.449541      24.058947      28.637178      31.876209
    [60]       34.006775      35.121151      35.246578      34.359138
    [64]       32.374329      29.113892      24.231747      17.206150
    [68]       10.484502      10.150629      8.5196781      3.9952471
    [72]      -3.5811362     -11.320368     -7.2082496     -6.5281811
    [76]      -8.1318855    -0.88109636      4.4548569      7.0103087
    [80]       7.5209012      6.1200252      2.3707373     -2.6455159
    [84]       2.3117650      7.2665415      10.427691      12.578187
    [88]       14.039668      14.950197      15.395816      15.449082
    [92]       15.167824      14.583426      13.698137      12.499699
    [96]       10.990952      9.2341785      7.3965683      5.6823473
    [100]       4.0231500      1.8919114     -1.1817247     -2.7488317
    [104]      0.18227431      2.7756109      3.7956722      3.8013163
    [108]       4.2169371      5.9706554      7.8657255      8.9095049
    [112]       8.8997583      7.9782524      6.6658092      5.8670068
    [116]       5.7805986      5.5613670      4.6123099      3.1082997
    [120]       2.3264041      3.3141358      4.9447660      6.3039927
    [124]       7.3491507      8.2988157      9.3134098      10.340546
    [128]       11.169463      11.601589      11.529696      10.890372
    [132]       9.5142651      6.8168125     0.72775853     -1.8813854
    [136]       8.0062866      12.945669      15.868140      17.563492
    [140]       18.311501      18.217367      17.304087      15.542130
    [144]       12.853443      9.1321993      4.7941346      3.7517803
    [148]       6.8636870      9.7664900      11.663291      12.429833
    [152]       11.758872      8.7975187     0.52280712      5.2605667
    [156]       12.107430      15.099993      16.078197      15.528903
    [160]       13.538067      9.9433174      4.2917657     -3.6530461
    [164]      -9.1197004     -27.616833     -3.2885325      5.1537709
    [168]       10.205323      13.615465      15.822925      16.911444
    [172]       16.801600      15.246136      11.611344      3.8513484
    [176]       2.2021728      9.1467180      12.335821      14.295884
    [180]       15.570850      16.045675      15.565060      14.132783
    [184]       12.002022      9.6610069      7.2644901      4.2557054
    [188]       1.0642555      1.2886715      3.2469931      4.4901547
    [192]       5.3444319      5.9118443      5.5820918      3.6285942
    [196]      0.30845553      1.9970738      6.1491885      8.3264456
    [200]       8.4961243      6.2564006     -1.6271892    -0.87755919
    [204]       8.9144382      13.207209      15.526417      16.679443
    [208]       17.016483      16.743822      15.975850      14.715528
    [212]       12.860273      10.353629      7.8060513      7.1545963
    [216]       8.4574385      9.9560061      11.149729      12.009447
    [220]       12.461495      12.488379      12.261745      12.041491
    [224]       11.832746      11.296888      10.097837      8.3194714
    [228]       6.9723706      6.9588022      7.0271640      5.9943900
    [232]       5.3760443      8.8550653      12.978027      15.837379
    [236]       17.526270      18.248175      18.118284      17.152391
    [240]       15.232708      12.031804      7.2360902      5.4357333
    [244]       9.1282806      11.406113      11.941536      11.176826
    [248]       10.062394      10.693955      13.074238      15.364086
    [252]       16.966484      17.852032      18.033493      17.482801
    [256]       16.139814      13.912154      10.601026      5.5586414
    [260]      -3.0732365     0.87475264      7.1079116      10.744308
    [264]       13.221938      14.909568      15.830215      15.933752
    [268]       15.209568      13.766262      11.996276      10.727245
    [272]       10.526109      10.764990      10.473561      8.9320202
    [276]       5.3260922    -0.24681358      3.1421959      7.2705688
    [280]       8.8850470      8.7057266      6.9474788      3.4985325
    [284]      -1.0322429    -0.52419347      3.0785568      5.6383753
    [288]       7.2378092      8.0076590      7.9183269      6.8642020
    [292]       4.5653477    0.017213572     -12.505630     -2.2445664
    [296]       4.1845727      7.0720968      8.0043011      7.2329922
    [300]       4.5195260    -0.23081721   0.0067049772      4.3708439
    [304]       6.9711657      8.2442284      8.5057516      7.6755724
    [308]       5.5542951      3.1891131      4.7445555      7.9321232
    [312]       10.030020      11.094609      11.504154      11.573345
    [316]       11.472065      11.181048      10.509681      9.1642513
    [320]       6.9646754      5.0674934      6.4240918      8.9496813
    [324]       10.363159      10.352421      8.8038301      5.2560172
    [328]      -2.1939287     -10.658503    -0.77107197      1.8984443
    [332]       2.0884767     0.84298527    -0.89922267     -1.4245999
    [336]     -0.92600930     -1.4792649     -2.5728860      1.6903375
    [340]       7.0277867      10.688871      12.990459      14.269881
    [344]       14.750441      14.591703      13.906559      12.757993
    [348]       11.214810      9.6472368      9.1062584      10.050990
    [352]       11.296937      11.815718      10.940679      7.2881331
    [356]     -0.88361490      11.076296      17.394640      21.013084
    [360]       23.110067      24.090965      24.135332      23.324318
    [364]       21.665953      19.061113      15.163408      8.7907782
    [368]      -7.9996815      3.8344102      8.3094568      9.5377607
    [372]       9.2442827      7.8729215      5.2713971     0.34961322
    [376]      -13.375900     -5.6641154    -0.83617860    -0.70726734
    [380]      -2.3819208     -1.6223065   -0.066235550     -1.5832565
    [384]      -8.6297569     0.13271968      6.5595088      9.7908764
    [388]       11.314321      11.712657      11.296225      10.220573
    [392]       8.4789696      5.9118371      2.7119169      2.1864946
    [396]       5.4553547      8.2095175      9.5713205      9.5470333
    [400]       8.0654135      4.9314170     0.58762032    -0.54594362
    [404]      0.90747923     0.73269403     -1.2835726     -2.7827401
    [408]     -0.26995438      2.9157624      5.3590403      7.3234940
    [412]       8.9991541      10.336793      11.186688      11.415989
    [416]       10.931447      9.6504717      7.4426508      3.9960213
    [420]      -1.6661723     -15.324821     -8.3534088     -2.7582295
    [424]     -0.80639005    -0.10267185     0.34575200     0.97154450
    [428]       1.7807766      2.7486382      3.7986827      4.6444702
    [432]       4.9913249      4.7835922      4.3323369      4.2082009
    [436]       4.5834932      5.0047359      5.0563111      4.5929770
    [440]       3.5196841      1.5586836     -1.8180975     -5.8370857
    [444]      -3.6618187   -0.014485823      1.9681392      2.7204599
    [448]       2.5028474      1.1074904     -2.3381977     -9.1884327
    [452]      -4.8723092     0.43627223      2.9252372      4.2600136
    [456]       5.4524512      6.6550384      7.3530989      7.0734429
    [460]       5.4632263      1.8322868     -7.6355205     -4.9449892
    [464]       4.5773387      9.3805685      12.427444      14.326530
    [468]       15.302957      15.470288      14.888462      13.567863
    [472]       11.441429      8.2810001      3.4321833     -4.8643494
    [476]      -4.2684636     0.93365264      2.3591127      1.1208978
    [480]       1.1559333      7.0765615      11.935037      15.016613
    [484]       16.764881      17.453630      17.250660      16.282522
    [488]       14.670634      12.541883      9.9986486      7.0403166
    [492]       3.4732831     -1.0132214     -4.3942561     -1.3136677
    [496]       2.4916098      5.0991468      6.7234306      7.5370007
    [500]       7.6378784      7.1131811      6.1303539      5.1175323
    [504]       4.7567053      5.1691747      5.6936851      5.9854207
    [508]       6.5198598      7.8991499      9.6540823      10.955724
    [512]       11.418242
  [Tag]         6081
  [frame_len]          320
[Record 39]
  [tot_power]       250989.47
  [re_spec_val]
    [0]       10.722350      10.242252      8.7343035      6.0627508
    [4]       2.5142529     0.29841867     0.56717598      1.0997659
    [8]       1.4573288      1.5014677      3.4350815      9.1175346
    [12]       14.203201      17.690702      19.788088      20.688921
    [16]       20.493242      19.217541      16.792259      13.074504
    [20]       8.1981602      4.5345502      4.0439811      3.3499210
    [24]       3.2666459      9.5263271      16.593683      21.985947
    [28]       25.899252      28.569469      30.136116      30.664089
    [32]       30.157881      28.565319      25.776016      21.632448
    [36]       16.053202      9.6835775      4.5169983      8.2565613
    [40]       17.320610      23.927599      28.588184      31.754606
    [44]       33.670326      34.463737      34.184555      32.810829
    [48]       30.230167      26.177822      20.114027      12.282910
    [52]       11.060046      11.265096      10.770220      15.417289
    [56]       20.951422      25.091993      27.927605      29.589235
    [60]       30.136221      29.576027      27.877161      25.007755
    [64]       21.122744      17.104704      14.078896      10.785566
    [68]       4.2028852     -11.498637      4.7932467      8.7553997
    [72]       10.222493      10.567693      10.713319      11.256446
    [76]       11.800387      11.627675      10.334949      7.7115264
    [80]       3.6490865    -0.92108083     -1.8826047    -0.22165659
    [84]       1.4038404      2.9272778      4.1468048      4.5207982
    [88]       3.3216901    -0.53744388     -1.1924729      5.7794256
    [92]       10.011227      12.240954      13.079335      12.805084
    [96]       11.579946      9.5726891      7.0943108      4.7403240
    [100]       3.3802450      3.6603956      5.1967230      7.1698399
    [104]       9.1815586      11.026583      12.463812      13.274894
    [108]       13.314721      12.482795      10.676028      7.7816396
    [112]       3.9744978      1.2567247      1.8591043      3.7029405
    [116]       6.3100290      9.3918591      12.092453      14.025992
    [120]       15.164474      15.582250      15.367925      14.609877
    [124]       13.414092      11.930031      10.320106      8.6678839
    [128]       7.1701660      6.7074566      7.6520319      8.5357990
    [132]       8.1075468      6.1381021      6.5104146      11.068691
    [136]       14.618094      16.571339      17.185219      16.592175
    [140]       14.777545      11.536053      6.2608409     -1.0800388
    [144]       1.7986652      5.6921721      7.5064626      8.3709488
    [148]       9.1510143      10.275562      11.436389      12.170518
    [152]       12.283148      11.757521      10.590429      8.7794695
    [156]       6.8917074      6.9597526      8.9153862      10.531046
    [160]       11.135675      10.883040      10.275217      9.8981428
    [164]       9.7963810      9.5844450      9.2254038      9.1226387
    [168]       9.4272442      9.8439779      10.331384      11.144716
    [172]       12.169445      12.922111      13.066509      12.532611
    [176]       11.441936      10.078256      8.8634605      8.2021885
    [180]       8.2546568      8.9535961      10.093338      11.295026
    [184]       12.133546      12.301589      11.616608      9.9590950
    [188]       7.2202382      3.2401907     -2.3945208     -9.1223373
    [192]      -5.6881218     -1.7939512    -0.78305078     -3.0108414
    [196]      -14.326463     -5.7638021      1.5060511      4.0834432
    [200]       4.0879927      2.1754107      1.9735550      5.7114196
    [204]       8.5903454      9.7699575      9.4004326      7.4907703
    [208]       3.7874684     -2.5407605     -13.043448     -6.0382023
    [212]      0.70146668      5.3497005      8.5277529      10.485208
    [216]       11.389434      11.332259      10.336684      8.3555965
    [220]       5.2799253      1.3418477    -0.13346699      2.8127356
    [224]       5.8233542      8.0064774      9.4963341      10.428262
    [228]       10.946122      11.262218      11.614491      12.077916
    [232]       12.461477      12.465393      11.847516      10.445826
    [236]       8.1321621      4.7625146     0.51409441    -0.79485548
    [240]       2.5324025      5.2419891      6.5887270      7.1482177
    [244]       8.1890297      10.375083      12.669628      14.252213
    [248]       14.997429      15.150569      15.250154      15.797132
    [252]       16.647120      17.271544      17.348841      16.848484
    [256]       15.975406      15.135884      14.758484      15.035900
    [260]       15.924592      17.202751      18.524349      19.602230
    [264]       20.300671      20.595932      20.509945      20.064358
    [268]       19.271612      18.172462      16.885778      15.530913
    [272]       13.905728      11.157454      5.4811854      5.7241869
    [276]       12.955133      16.771036      18.631969      19.136095
    [280]       18.529346      16.952250      14.586956      11.818613
    [284]       9.1751823      6.6965270      4.0135961      2.4265661
    [288]       3.9166579      5.8876996      6.7435083      6.3681717
    [292]       5.2316833      5.1517339      7.2064886      9.4097567
    [296]       10.680587      10.903590      10.140630      8.4624643
    [300]       5.9407372      2.6709926     -1.1889163     -5.5320330
    [304]      -11.666327     -23.614208     -7.7046528     -1.9745494
    [308]       1.0732577      2.9125330      4.3755398      5.7336001
    [312]       6.6417098      6.6336079      5.4153247      3.1358562
    [316]       1.6784160      2.8395858      4.3361626      5.6316042
    [320]       7.7839022      10.558574      12.918469      14.432305
    [324]       15.036920      14.742250      13.559663      11.569740
    [328]       9.2520428      7.8893085      7.9942117      8.3630114
    [332]       8.3409348      8.0858660      7.9523511      8.1392241
    [336]       8.7436905      9.7227163      10.707665      11.269426
    [340]       11.238415      10.785273      10.323572      10.034680
    [344]       9.5184908      8.2173023      5.8536286      2.6979487
    [348]      -1.1519026     -12.544739      2.5077560      11.019262
    [352]       16.115389      19.473913      21.638769      22.861547
    [356]       23.281332      22.980278      21.988768      20.242682
    [360]       17.468702      12.895068      5.0710874      7.3845878
    [364]       12.038078      13.752517      14.423395      15.716890
    [368]       17.768465      19.489424      20.337130      20.225868
    [372]       19.194454      17.331329      14.846451      12.233623
    [376]       10.141360      8.5353565      6.5606990      3.0923908
    [380]      -3.4306290    -0.65813327      5.7704120      9.2507401
    [384]       11.011914      11.484507      10.801128      9.0048847
    [388]       6.3054318      3.7958322      3.1216977      3.3882015
    [392]       3.2591963      2.7546234      2.6795130      3.7656808
    [396]       5.5473204      7.1258368      8.0539827      8.2146521
    [400]       7.6323457      6.4233756      4.8132830      3.1307907
    [404]       1.6724120     0.52755356    -0.39079747     -1.2165377
    [408]      -2.0692933     -3.0266266     -4.1762447     -5.5712671
    [412]      -6.2995620     -4.4621902     -1.6168163     0.27162290
    [416]      0.71763480    -0.47452733     -3.3372509     -4.9287062
    [420]      -1.9281546     0.52911127      1.2805792     0.65666163
    [424]     -0.51700336    -0.58803999     0.69611728      1.9307300
    [428]       2.6362021      3.1435978      3.9432762      5.1102591
    [432]       6.3341074      7.3722944      8.1605139      8.6925592
    [436]       8.9342422      8.8338194      8.3848019      7.6609516
    [440]       6.7322893      5.4464135      3.2688160    -0.50757837
    [444]      -1.8625119      3.3294454      7.1887174      9.4188051
    [448]       10.551726      10.949225      10.898287      10.622140
    [452]       10.225683      9.6824226      8.8992977      7.7617335
    [456]       6.1456347      4.2806888      4.1540637      6.8990846
    [460]       9.8355684      11.831203      12.843318      12.963084
    [464]       12.225358      10.515715      7.4030952      2.0433633
    [468]      0.78570610      6.2669849      9.3293486      10.587017
    [472]       10.733207      10.548950      11.032304      12.366335
    [476]       13.805819      14.842548      15.361093      15.386897
    [480]       14.948383      14.013493      12.452917      10.009979
    [484]       6.2925553      1.5659398      1.0846752      3.6865962
    [488]       4.9639983      5.1729450      5.2050152      5.6242571
    [492]       6.1641145      6.3824668      6.1948724      5.8437948
    [496]       5.7465158      6.1260018      6.6797609      6.8635440
    [500]       6.2462220      4.5488324      1.9859290      1.3492632
    [504]       4.1345153      6.7263637      8.1302814      8.3987331
    [508]       7.6061044      5.7606359      2.8247526     -1.0937208
    [512]      -3.8013639
  [Tag]         6241
  [frame_len]          320
[Record 40]
  [tot_power]       280926.25
  [re_spec_val]
    [0]      -13.655310     -10.179437     -6.3797169     -4.1940188
    [4]      -3.1518629     -2.6786556     -2.0931089     -1.2107373
    [8]     -0.93888390     -2.8182697     -3.6134493      4.7480860
    [12]       10.697141      14.379256      16.447845      17.158495
    [16]       16.562292      14.536857      10.674736      3.7210367
    [20]      -12.287688     -3.7476432    -0.62364239    -0.13858922
    [24]      -8.8892412      6.6064458      16.366983      22.166166
    [28]       25.910326      28.194036      29.275568      29.271690
    [32]       28.209539      26.020306      22.459927      16.801907
    [36]       6.3749704      3.7418427      4.5438361      4.3222656
    [40]       19.077608      26.347122      31.074812      34.226135
    [44]       36.146046      36.977959      36.767628      35.491802
    [48]       33.056976      29.274614      23.802197      16.027428
    [52]       5.2369294      1.0450393      5.3773732      10.290398
    [56]       16.334229      21.271742      24.574554      26.447733
    [60]       27.094685      26.631041      25.090454      22.426413
    [64]       18.493429      12.990580      5.4208851     -1.7659233
    [68]      0.43135348      4.1598301      8.1017818      11.886611
    [72]       15.003523      17.231941      18.529440      18.901634
    [76]       18.342592      16.811314      14.222095      10.457536
    [80]       5.5225224     0.40175390     -2.1718662     -2.2596152
    [84]      -1.8048270     -1.9232671     -1.6305774      1.6846095
    [88]       5.5366201      8.0924721      9.2337627      9.0053625
    [92]       7.3124995      3.7664149     -2.9733014     -26.909649
    [96]      -8.4332829     -5.6072049     -6.2750049     -9.8007097
    [100]      -7.5632424      1.7220486      7.9064283      12.179969
    [104]       15.115499      16.956879      17.817526      17.744026
    [108]       16.731936      14.715393      11.545371      7.1383128
    [112]       3.2707815      3.4177775      3.4023023      1.7562605
    [116]       7.1679277      13.895838      18.442104      21.389744
    [120]       23.087271      23.687420      23.235041      21.693020
    [124]       18.925671      14.614459      7.9321980     -4.7070990
    [128]      -10.358379     -8.5794296     -9.8622189      1.2967136
    [132]       7.2156906      10.911054      13.205673      14.332985
    [136]       14.318754      13.049520      10.207764      4.9401031
    [140]      -5.3469915     -3.0232656     0.91989493      1.6883140
    [144]       1.9809636      3.4427743      6.0694551      8.8291922
    [148]       10.982211      12.259586      12.630804      12.168752
    [152]       11.016401      9.3762016      7.4465952      5.3472819
    [156]       3.2753527      1.7837642      1.2184186      1.2242233
    [160]       1.9571403      3.8835948      6.3180819      8.3897600
    [164]       9.7842751      10.452838      10.408936      9.6839495
    [168]       8.3537617      6.6241074      4.9362159      3.8027008
    [172]       3.2962930      3.2107511      3.6655829      4.8101015
    [176]       6.2655215      7.5285735      8.4011440      8.9443951
    [180]       9.3122787      9.5945168      9.7652903      9.7699833
    [184]       9.5953741      9.2217865      8.5569534      7.4976501
    [188]       6.1143689      4.7852311      3.9465265      3.9311059
    [192]       5.5110574      8.5079441      11.532277      13.888383
    [196]       15.458835      16.263187      16.316460      15.595759
    [200]       14.032088      11.519583      8.0290251      4.2269545
    [204]       2.0025742     0.79422665    -0.51808602      2.2492440
    [208]       6.7843199      9.8733797      11.496590      11.865476
    [212]       11.105165      9.3815517      7.2702789      5.9827995
    [216]       5.7341914      5.3933415      4.5671182      3.8867998
    [220]       3.9596560      4.2681255      4.1304498      3.4713714
    [224]       2.7406187      2.5347459      2.8704424      3.2608650
    [228]       3.3905036      3.2743597      3.1380725      3.1900582
    [232]       3.3526754      3.2834966      2.6031153     0.95901906
    [236]      -2.1496797     -8.0957088     -15.984358     -6.1777477
    [240]      -1.3393250      1.1353233      1.9892501      1.2305578
    [244]      -1.4646807     -5.1515088     -2.3598022      1.8441116
    [248]       4.3884802      5.8078175      6.4742594      6.4813166
    [252]       5.6833191      3.6622939    -0.61830205     -8.6886406
    [256]      -2.2745800      2.6171868      4.4063039      4.1252093
    [260]       1.8103741     -3.4123335     -14.075120     -8.2107401
    [264]      -5.0385013     -4.8805523     -4.4945464     -3.2554357
    [268]      -4.0639610     -11.841905     -3.5071788      4.7887692
    [272]       9.0524206      11.360320      12.376235      12.464739
    [276]       11.976248      11.447352      11.527670      12.202435
    [280]       12.644643      11.996738      9.3727226      3.4375429
    [284]       5.1806293      11.072902      13.800444      14.683157
    [288]       14.536742      14.266221      14.575956      15.140419
    [292]       15.259982      14.595894      13.083607      10.790539
    [296]       7.9187841      4.8990378      2.3678777     0.82275170
    [300]      0.51366484      1.2808375      2.2910180      2.8140864
    [304]       2.5951838      1.6870205     0.34089664     -1.0132594
    [308]      -1.8801556     -1.9781344     -1.3126606    -0.28453916
    [312]      0.23383345    -0.35479537     0.11546590      4.5570331
    [316]       8.8014774      11.452330      12.616757      12.396356
    [320]       10.742665      7.4484692      3.0554399      3.5624607
    [324]       7.0910163      9.3289261      10.274242      10.009872
    [328]       8.3438234      4.8300419      1.2290334      4.8178773
    [332]       8.4037342      9.9959726      9.9324293      8.2414150
    [336]       4.5856299    -0.47312015      1.3486468      4.9706588
    [340]       6.7183409      7.2052360      6.9391956      6.3653226
    [344]       6.0181046      6.3306251      7.0637922      7.4642167
    [348]       6.8378410      4.4512725     -1.6920365     -12.620702
    [352]       1.9652050      6.7091603      9.0399446      9.8848915
    [356]       9.3215361      7.0771246      2.5105860     -5.2573123
    [360]      -7.6424685    -0.32884178      6.6922145      11.495370
    [364]       14.433123      15.921898      16.212492      15.427257
    [368]       13.580064      10.665466      7.5030584      7.1324830
    [372]       8.5920277      8.9395266      7.3389783      2.6640568
    [376]      -9.9381065      1.9732130      7.4184337      10.023770
    [380]       11.181917      11.225486      10.173264      7.8810787
    [384]       4.0257664     -1.8401055     -6.9715052     -6.2821865
    [388]      -7.4312372     -12.227823     -9.9429817     -4.7666836
    [392]      -2.2635214     -1.0787691    -0.28415653     0.41253054
    [396]      0.79977804     0.71979821     0.27208301    -0.42794150
    [400]      -1.5785364     -3.6602845     -6.8645844     -8.0554981
    [404]      -4.4428620    -0.72564858      2.1652842      4.3253179
    [408]       5.7624159      6.4688702      6.4731526      5.8517747
    [412]       4.7545304      3.4661334      2.4452369      2.0959349
    [416]       2.3276901      2.6545491      2.6453693      2.1010790
    [420]       1.1442778     0.35464805     0.26359564     0.38257906
    [424]     -0.18534862     -2.0916748     -6.2286315     -15.930031
    [428]      -11.589544     -5.0384793     -2.2661624     -1.3531222
    [432]      -1.7081773     -2.8222778     -3.8204710     -3.5241604
    [436]      -1.7209309     0.34233460      1.5462818      1.3195059
    [440]     -0.75878459     -4.3044257     -3.3069403     0.27276775
    [444]       2.0580733      2.2842820      1.5819622     0.71658921
    [448]      0.16658053    -0.30588692     -1.0926540     -2.5426509
    [452]      -5.7161727     -13.728844     -6.2729821     0.46215838
    [456]       3.7030096      4.9288430      4.5957537      3.0011985
    [460]      0.90070879    -0.25428954    -0.53143042     -1.3116001
    [464]      -2.8991251     -4.2093315     -3.2573044    -0.19103719
    [468]       3.0488887      5.4746075      6.8621087      7.2106190
    [472]       6.5546074      4.9184709      2.3316286     -1.0722566
    [476]      -4.8464489     -8.3582592     -10.775205     -8.9539423
    [480]      -5.3466635     -3.0470963     -2.1425047     -1.8789693
    [484]     -0.88247925      1.1173614      2.9929371      4.1820507
    [488]       4.7591577      5.0197859      5.1677237      5.1102629
    [492]       4.5719109      3.3125877      1.2203996     -1.4780735
    [496]      -3.2306182     -2.1270845   -0.084489651      1.2826555
    [500]       1.7850194      1.7460111      1.8465152      2.5980575
    [504]       3.6902242      4.5690327      4.9808130      4.8964581
    [508]       4.4141402      3.7768738      3.3237352      3.1944869
    [512]       3.2004166
  [Tag]         6401
  [frame_len]          320
[Record 41]
  [tot_power]       291580.31
  [re_spec_val]
    [0]       1.4181285     0.83234334     -1.0339828     -4.5124359
    [4]      -8.7793026     -6.6332340     -2.6793737    -0.52177852
    [8]     -0.32813868     -3.3741827     -6.3803988      4.6032968
    [12]       10.911692      14.814890      17.193853      18.370693
    [16]       18.476822      17.560619      15.648692      12.847630
    [20]       9.5734348      6.7863684      5.2644682      3.9180698
    [24]       3.2493615      11.131861      18.171629      22.952461
    [28]       26.108824      27.973389      28.704714      28.361921
    [32]       26.927752      24.296501      20.187387      13.681748
    [36]      0.15348636      7.2349029      9.7827816      2.6978598
    [40]       17.134054      25.886250      31.166313      34.550739
    [44]       36.552868      37.384655      37.123234      35.754734
    [48]       33.167747      29.086315      22.810102      11.630159
    [52]       3.1245043      8.7217922      6.5224547      7.1016741
    [56]       14.111610      19.320288      22.799408      24.924822
    [60]       25.872019      25.704533      24.402149      21.856297
    [64]       17.834068      11.929175      4.3920465      1.8546281
    [68]       2.5681913      1.6758584    -0.88214225      3.8610160
    [72]       10.529620      14.795016      17.363834      18.664385
    [76]       18.898220      18.149111      16.435385      13.748988
    [80]       10.124170      5.8237391      1.7719765    -0.19988692
    [84]      0.84315431      3.5562961      6.5759516      9.2270031
    [88]       11.185626      12.311503      12.537086      11.785457
    [92]       9.8991451      6.5190153     0.68393731     -10.511592
    [96]      -6.4003229     -2.5350091     -1.0711381     0.81650156
    [100]       4.1121073      7.9935827      11.444065      14.026508
    [104]       15.642823      16.303572      16.042933      14.901809
    [108]       12.937333      10.226604      6.8064580      2.6684725
    [112]     -0.86571318    -0.90193135      1.2296973      7.2678223
    [116]       13.625181      18.373768      21.667063      23.748369
    [120]       24.763605      24.781757      23.811682      21.800570
    [124]       18.604900      13.900135      7.0041814    -0.16110617
    [128]       1.5338106      2.0891581      2.1030149      6.1608081
    [132]       10.882045      14.287283      16.469614      17.605844
    [136]       17.782907      17.017340      15.263858      12.393991
    [140]       8.1096678      1.6016434     -11.021513     -13.546222
    [144]      -10.048723     -22.737928     -4.7025371      3.8875329
    [148]       8.8320570      11.884164      13.558847      14.070748
    [152]       13.521102      11.962465      9.4442902      6.0842624
    [156]       2.2016282     -1.5659028     -4.5686498     -6.6070919
    [160]      -6.5590324     -3.2699783     0.64835316      3.7303565
    [164]       5.8370404      7.0362210      7.3939233      6.9792080
    [168]       5.9083257      4.4015298      2.8103957      1.5033205
    [172]      0.60192662   -0.028583594    -0.22260334     0.78401291
    [176]       2.8892660      4.9369493      6.2460961      6.6152244
    [180]       5.9546576      4.1166549     0.78219444     -4.6427846
    [184]      -11.115817     -11.469867     -13.784687     -16.844891
    [188]      -7.7170291     -2.4331119      2.4322598      7.4491019
    [192]       11.645274      14.688512      16.626194      17.569155
    [196]       17.623875      16.891685      15.465766      13.385489
    [200]       10.520174      6.3699770    -0.39393651     -7.9388623
    [204]      -3.1302559     -2.6038806     -3.1120305      2.9439361
    [208]       8.2166691      11.493069      13.319725      13.998273
    [212]       13.669508      12.379695      10.098189      6.7207985
    [216]       2.2257500     -1.9907688     -2.6810439     -2.0489740
    [220]      -1.3976904     0.37890798      2.8961048      5.0384378
    [224]       6.4148993      6.9857473      6.7742858      5.8163199
    [228]       4.1909018      2.0959389   -0.057215400     -1.6781142
    [232]      -2.2861552     -1.7587181    -0.45551986     0.94900030
    [236]       1.9503400      2.4476702      2.8272219      3.7517457
    [240]       5.2276888      6.5520382      7.1979046      6.9558716
    [244]       5.7507544      3.5719957     0.59195679     -2.3895767
    [248]      -3.8767216     -3.5799789     -2.4137039     -1.2111717
    [252]     -0.48900175    -0.17229582     0.39745969      1.6174438
    [256]       2.9667075      3.9219973      4.4632015      4.8566055
    [260]       5.2780385      5.5968580      5.5910029      5.2850118
    [264]       5.1401453      5.7363472      6.9128938      7.9924831
    [268]       8.5080662      8.2065754      6.8353395      3.9558094
    [272]      -1.0978178     -3.7552199     0.39648661      2.4306059
    [276]       2.1013470    -0.45493394     -5.1970158     -9.5501280
    [280]      -7.7261209      1.5883920      8.6283779      13.347254
    [284]       16.453053      18.330170      19.197420      19.196484
    [288]       18.439150      17.043869      15.178203      13.096666
    [292]       11.103425      9.4553213      8.5365200      8.8695288
    [296]       10.051573      11.044049      11.253811      10.467397
    [300]       8.5856237      5.5638437      1.7757670    -0.72426289
    [304]     -0.59842211    0.058350712     0.84943396      2.4594316
    [308]       4.8354902      7.4311175      9.8742132      11.925310
    [312]       13.400660      14.171807      14.162611      13.360747
    [316]       11.902576      10.253123      9.0497732      8.1439161
    [320]       6.5783319      3.3586674     -3.0081987     -10.934517
    [324]      -3.3612766      1.2202183      4.9560208      7.9786410
    [328]       10.054755      11.261771      11.825347      11.981059
    [332]       11.851727      11.387783      10.445301      8.9267530
    [336]       6.9378662      5.0251741      4.0935850      4.2717991
    [340]       4.7682633      4.9193244      4.2724094      2.2525270
    [344]      -2.5334489     -12.415092     -1.8313366      2.9856091
    [348]       4.7065473      4.2769299      1.5098530     -4.9832191
    [352]      -7.1168795    -0.11930112      3.9932253      7.1332135
    [356]       9.4399128      10.638607      10.597740      9.4477911
    [360]       8.1119452      8.2320032      9.1566286      9.2359486
    [364]       7.8473616      4.7897778     0.59983921     -1.1218423
    [368]     -0.21507607     0.61694986      2.2782774      4.8215408
    [372]       7.3077455      9.4478283      11.226393      12.570001
    [376]       13.371127      13.549437      13.055063      11.845322
    [380]       9.8641357      7.0464168      3.4175334    -0.49316463
    [384]      -3.1081276     -3.0456362    -0.45984170      2.8823130
    [388]       5.6548276      7.5769506      8.6823502      9.0137691
    [392]       8.5446110      7.1403384      4.4862471   -0.066446133
    [396]      -5.7037926     -2.5177763      1.0962369      2.7566695
    [400]       3.1563983      2.4478843     0.34284139     -2.2400806
    [404]      0.95186740      5.6034937      8.5526028      10.064049
    [408]       10.437247      9.8798342      8.5950689      6.8484101
    [412]       4.9808445      3.3855050      2.4893732      2.4329371
    [416]       2.7456858      2.8408487      2.3816671      1.1157255
    [420]      -1.4202155     -6.2940493     -10.286327     -3.6013167
    [424]      0.67662716      3.0755284      4.4165144      5.0670938
    [428]       5.1617064      4.6763124      3.4918430      1.5237972
    [432]     -0.75671375     -1.3622165     0.16260001      1.6846285
    [436]       2.5021687      2.8785415      3.2913961      3.9087405
    [440]       4.4144192      4.4210143      3.7546306      2.5021214
    [444]       1.0712703    0.069798775    -0.30809498    -0.39509159
    [448]     -0.39153352    -0.18166591     0.32374617     0.87164265
    [452]       1.0079006     0.34041589     -1.4192853     -4.3996382
    [456]      -7.2984452     -6.1175714     -3.2397354     -1.1785513
    [460]    -0.048222523     0.24966091    -0.27233437     -1.7495378
    [464]      -4.6873870     -11.028582     -20.554625     -7.6786461
    [468]      -3.4315403     -1.8893062     -2.1534991     -4.1158361
    [472]      -7.9776196     -12.918758     -13.530342     -13.230233
    [476]      -16.302687     -19.007566     -13.433856     -10.830448
    [480]      -11.507617     -16.025461     -19.251793     -12.868392
    [484]      -10.591402     -11.550200     -13.930069     -10.553375
    [488]      -6.2370567     -3.9327817     -3.3587403     -4.4841256
    [492]      -7.8362098     -13.256665     -8.7873125     -3.7349031
    [496]     -0.85358346     0.93276453      2.2084661      3.1738529
    [500]       3.7503839      3.8114147      3.3791511      2.6754062
    [504]       1.8880637     0.73878402     -1.5810592     -6.5871286
    [508]      -22.593327     -12.415791     -9.0699854     -12.066845
    [512]      -27.164225
  [Tag]         6561
  [frame_len]          320
[Record 42]
  [tot_power]       261980.88
  [re_spec_val]
    [0]       5.4757638      4.9039726      3.1328623     0.24738911
    [4]      -1.5394882     0.77141404      3.3544264      4.2483921
    [8]       2.5068274     -4.2369261      3.3523660      10.514707
    [12]       14.282104      16.129181      16.523106      15.619232
    [16]       13.409364      9.6874218      3.6583536     -10.071524
    [20]      -5.3908458     0.19382097     0.39359391     -2.9436526
    [24]       7.1323166      15.194227      20.449427      23.978050
    [28]       26.179401      27.206364      27.081423      25.715214
    [32]       22.867767      18.019051      10.064442    -0.17212108
    [36]      -6.0757704     -3.0368633      8.1562595      17.208738
    [40]       24.449774      29.661531      33.244862      35.505707
    [44]       36.622257      36.683033      35.709373      33.658398
    [48]       30.398722      25.615280      18.427431      5.8336868
    [52]       7.1740890      7.8639531      5.6256866      14.519046
    [56]       20.580368      24.240252      26.392622      27.372988
    [60]       27.286734      26.112795      23.721949      19.825821
    [64]       13.766109      3.4795547     -18.139397     -12.020679
    [68]      -4.3298674      3.9654391      7.6247773      9.3527203
    [72]       10.182470      10.750907      11.297053      11.606387
    [76]       11.350703      10.373152      8.7605944      6.8640804
    [80]       5.1187377      3.5478642      1.6656157     -1.2831087
    [84]      -6.9255877     -9.2946110    -0.36291108      4.7445426
    [88]       7.8717070      9.6807737      10.392925      10.082871
    [92]       8.7725677      6.5032887      3.5349710      1.0525476
    [96]       1.2948644      3.7367017      6.4756322      8.8711739
    [100]       10.787649      12.149636      12.861410      12.815742
    [104]       11.899926      9.9796896      6.8570900      2.1538081
    [108]      -5.2614121     -25.699705     -10.532338     -5.8975286
    [112]      -2.7497380      2.4297464      7.9034076      12.191899
    [116]       15.238428      17.209282      18.245970      18.448935
    [120]       17.877228      16.523750      14.246904      10.634899
    [124]       4.9142275      1.1956826      4.9378328      6.6726861
    [128]       7.0118771      8.3182278      10.734591      12.506018
    [132]       12.976983      12.056984      9.8653860      7.4035254
    [136]       6.8197246      7.1272860      6.1426034      3.1351631
    [140]    -0.016310465      2.0658243      4.1405778      4.5730805
    [144]       5.6075120      8.8556910      12.125146      14.327417
    [148]       15.421404      15.498710      14.629287      12.883647
    [152]       10.425884      7.6876230      5.3879604      3.9170461
    [156]       3.0781667      2.7719641      3.0485981      3.7318392
    [160]       4.4394140      4.8342361      4.6942506      3.8122468
    [164]       2.0038846     0.19123447      1.8765796      5.2978811
    [168]       7.7733445      9.1555414      9.6832132      9.5095253
    [172]       8.6013880      6.7016220      3.2605507     -3.0420444
    [176]      -13.990084     -7.1877122     -4.6525064     -4.3126354
    [180]      -4.2586274     -5.1723762     -7.9786592     -3.7982469
    [184]       2.8375492      7.2242885      10.121578      11.970445
    [188]       12.950974      13.122183      12.512776      11.214438
    [192]       9.4957418      7.7541618      6.0026984      3.6628423
    [196]       1.0964007      2.2515461      5.5682235      8.0284386
    [200]       9.7867956      11.331035      12.732181      13.716619
    [204]       14.000582      13.402275      11.811160      9.2189846
    [208]       6.0078683      3.2293301     0.77184331     -4.2626853
    [212]      -10.861712    -0.54905200      3.5204494      4.6922135
    [216]       3.7789671     0.99624854     -1.6093556     0.31494626
    [220]       2.6299899      3.4610443      3.2802057      3.1068482
    [224]       3.7363863      4.6434569      4.9844327      4.3773098
    [228]       2.6996927    0.082028367     -2.1373022     -1.4269636
    [232]      0.72497392      2.3977833      3.2323453      3.1342573
    [236]       1.9242018    -0.80740327     -6.2007198     -15.639706
    [240]      -7.8610659     -3.5148020     -1.4423634   -0.022109542
    [244]       1.3589408      2.5753860      3.2540255      3.1246874
    [248]       2.0185962    -0.17094351     -3.2273896     -5.5787315
    [252]      -5.9279494     -6.6977148     -10.156774     -14.994107
    [256]      -7.9243493     -3.0518899    -0.24427795      1.4117892
    [260]       2.1074204      1.7786096     0.38573056     -2.1740265
    [264]      -7.8533616     -13.440178      1.2670839      7.4310083
    [268]       11.089104      13.358807      14.863135      16.105402
    [272]       17.338411      18.465479      19.257021      19.556541
    [276]       19.303965      18.511328      17.284922      15.872018
    [280]       14.534592      13.134568      10.965385      6.8494396
    [284]      0.54401577      5.1770582      9.4895744      11.222659
    [288]       11.424739      10.876090      10.552800      10.977619
    [292]       11.556745      11.596237      10.864711      9.6556253
    [296]       9.0634232      9.7503729      10.489712      10.068678
    [300]       7.6491747      1.5790066     0.15412576      7.3867817
    [304]       10.775281      12.249524      12.556359      12.000487
    [308]       10.847642      9.8708429      10.142465      11.036541
    [312]       11.153165      9.8422575      7.8174086      9.2739773
    [316]       12.927610      15.555947      17.012228      17.526304
    [320]       17.220322      16.099054      14.095952      11.206465
    [324]       7.9530129      5.8681760      5.3139029      5.5298429
    [328]       7.0824099      9.4392214      11.434728      12.756915
    [332]       13.484155      13.677752      13.270638      12.115837
    [336]       10.104926      7.4187341      5.1761403      5.1004562
    [340]       6.6350021      8.2927494      9.3756914      9.8706512
    [344]       10.691037      12.859688      15.565889      17.727699
    [348]       19.012558      19.381115      18.837822      17.406059
    [352]       15.281339      13.230805      12.217920      11.498069
    [356]       9.3641996      4.1635141      5.1370878      11.896196
    [360]       15.664687      17.709482      18.621584      18.641678
    [364]       17.849712      16.229507      13.695335      10.146935
    [368]       5.9619007      3.9494314      5.3404102      6.8599925
    [372]       7.5484719      7.3268538      6.0965428      3.6821382
    [376]    -0.064248197     -4.4072733     -5.2831254     -2.1735446
    [380]       1.3134167      3.7846968      4.7176514      3.6399267
    [384]     -0.82384330     -8.3456717      2.0276749      6.6075940
    [388]       8.4552994      8.7824106      8.5666285      9.0397711
    [392]       10.296996      11.309340      11.480700      10.702349
    [396]       9.1582041      7.4655995      6.4291239      5.7154007
    [400]       3.9522123    -0.88430369     -7.4723563      3.0458555
    [404]       7.9382529      10.335552      11.213823      10.889748
    [408]       9.4512482      6.8405776      2.7796595     -3.7520659
    [412]      -19.554308     -8.9963369     -3.9891608     -2.0383837
    [416]      -1.4620755     -1.6550808     -2.0667388     -2.0865180
    [420]      -1.4397706    -0.46687818     0.29154068     0.48114035
    [424]     0.052343398    -0.46905202     0.12194169      2.0022840
    [428]       4.0573134      5.7088151      6.9157171      7.7643442
    [432]       8.3192520      8.6081533      8.6545830      8.5039120
    [436]       8.2124691      7.8015819      7.2085810      6.2654734
    [440]       4.6972556      2.1592531    -0.98902810    -0.48898038
    [444]       3.0843165      5.7200890      7.1496396      7.6485105
    [448]       7.4524040      6.7307949      5.5591712      3.9051883
    [452]       1.6914794     -1.0516846     -3.9686739     -6.2663031
    [456]      -7.0090070     -6.1406121     -4.9668756     -4.3526993
    [460]      -3.6352727     -1.3426056      1.7983526      4.4089093
    [464]       6.1178703      6.9328289      6.8968449      6.0085173
    [468]       4.1972613      1.2983325     -2.9834616     -9.0202322
    [472]      -15.819471     -16.566465     -11.232038     -6.1253152
    [476]      -2.6946595    -0.69483793     0.18876745     0.24569091
    [480]    -0.088767797   -0.099574931     0.67790520      1.8049793
    [484]       2.5951025      2.6232183      1.5406017     -1.2731686
    [488]      -6.9466228     -5.7670498     0.39755720      3.6542385
    [492]       5.0906482      5.2011237      4.1896753      2.1659534
    [496]     -0.78643835     -4.7486982     -10.938248     -28.512007
    [500]      -9.0174189     -2.1213641      2.5473690      6.0554838
    [504]       8.6051626      10.263353      11.076036      11.073066
    [508]       10.251617      8.5396414      5.7081246      1.2301558
    [512]      -3.1814415
  [Tag]         6721
  [frame_len]          320
[Record 43]
  [tot_power]       225928.09
  [re_spec_val]
    [0]       5.2243562      4.4798250      2.0930119     -1.6723832
    [4]     -0.75057065      3.6919906      6.5106091      7.5686293
    [8]       6.5742254      1.4086921     -5.3279643      8.9792242
    [12]       14.499225      17.527384      19.050985      19.383593
    [16]       18.612005      16.671822      13.270878      7.4094915
    [20]      -7.9284244      2.1139948      9.2563038      14.575346
    [24]       19.206177      22.872349      25.482111      27.065113
    [28]       27.663292      27.295572      25.943481      23.529440
    [32]       19.857862      14.445016      6.4321771      3.7109113
    [36]       6.9270263      11.114947      17.591999      23.072817
    [40]       27.075987      29.831158      31.524574      32.266109
    [44]       32.107983      31.053883      29.059364      26.028788
    [48]       21.804436      16.031733      7.0056381      3.7779672
    [52]       11.007194      14.016210      17.960445      23.363173
    [56]       27.806383      30.848177      32.636166      33.304829
    [60]       32.912548      31.441038      28.786217      24.732437
    [64]       18.972029      11.940516      7.0774789     0.78854966
    [68]      -4.5785069      6.5533419      9.8451786      10.825082
    [72]       10.640705      9.4998093      7.0865169      3.0350449
    [76]      0.13380016      2.7596216      5.0406337      5.9618864
    [80]       6.3783946      7.4449067      9.3448658      11.178956
    [84]       12.434078      13.143476      13.566074      13.925498
    [88]       14.243919      14.397419      14.255586      13.722611
    [92]       12.715053      11.139709      8.8667917      5.7096953
    [96]       1.6673067     -1.7623882     -3.2002869     -5.6903601
    [100]      -3.4915521      2.8843725      6.6209064      8.2667255
    [104]       8.2858086      6.8799300      4.1330123     0.10610370
    [108]      -5.1647201     -12.897976     -20.205147     -7.4445090
    [112]      -2.2998939    0.019204909    0.082082883     -2.5132356
    [116]      -9.0062342     -7.0436101     -2.3722138     -1.7458298
    [120]      -4.9834943     -19.757717     -7.6804199     -1.5654097
    [124]       1.8741512      5.5748081      9.3811779      12.498355
    [128]       14.691441      15.972939      16.381990      15.925217
    [132]       14.560531      12.189152      8.6843615      4.2801948
    [136]       1.3292656      1.5644633      2.3888652      4.2526984
    [140]       7.8088717      11.400255      14.069032      15.620424
    [144]       15.981020      14.974904      12.094318      5.4207087
    [148]      -7.7294788      6.9815798      10.417685      11.000298
    [152]       9.7704887      7.0308614      3.2053900   0.0060134097
    [156]     -0.76156348     0.35019115      3.0869808      6.0551038
    [160]       8.2427855      9.4421120      9.6033077      8.5518656
    [164]       5.7781563     0.50238788      1.5844967      7.2859473
    [168]       10.362273      11.621978      11.503342      10.276878
    [172]       8.5689154      7.7939410      8.3316755      8.8711786
    [176]       8.7805681      8.2198734      7.6118717      7.2728748
    [180]       7.3706288      8.0056200      8.9376593      9.6973257
    [184]       10.030438      9.9771605      9.6620560      9.0034542
    [188]       7.6017904      4.7634201     -1.0043787     -10.007374
    [192]      -1.0783901      2.7956092      4.0829821      3.5284874
    [196]      0.38307032     -9.7903576    -0.88262242      5.5980582
    [200]       8.2823830      8.7442036      7.1471772      2.7359829
    [204]      -6.8449965    -0.97956800      3.2523060      3.8685074
    [208]       1.7627572     -4.1014376     -4.0426211      3.2622995
    [212]       7.1930628      9.3820591      10.416416      10.484484
    [216]       9.6381416      7.9529924      5.8639708      4.6253929
    [220]       4.9768348      5.9252992      6.8962502      7.9999700
    [224]       9.2751741      10.538686      11.616581      12.438271
    [228]       12.992163      13.275396      13.266150      12.911017
    [232]       12.129957      10.848556      9.0745707      7.0401521
    [236]       5.2639279      4.0763159      3.2639873      2.9210465
    [240]       3.6614456      5.2415733      6.7944036      7.8780546
    [244]       8.3464069      8.0572243      6.7380009      3.8551836
    [248]      -1.1463215    -0.63814819      4.5523372      7.5160074
    [252]       8.8074245      8.8073368      7.5588884      4.7665195
    [256]     -0.34159109     -3.4777529      1.7267898      4.7176938
    [260]       5.7536645      6.0642142      7.4170017      10.160364
    [264]       13.106493      15.792274      18.181532      20.182243
    [268]       21.646606      22.459688      22.558090      21.912682
    [272]       20.518019      18.414570      15.792974      13.210689
    [276]       11.430281      10.355524      9.1838675      7.5565000
    [280]       5.8197169      4.7617259      5.0948000      6.9624038
    [284]       9.3110485      11.062923      11.843445      11.687629
    [288]       10.958645      10.407737      10.522627      10.774130
    [292]       10.399075      8.8790092      5.4770145     -3.0269251
    [296]      -4.1298790      5.9374366      10.210359      12.552663
    [300]       13.685981      13.833918      13.109520      11.715521
    [304]       10.167763      9.1286554      8.4281397      7.0318165
    [308]       3.4652596     -8.2248535      2.1846147      9.7933512
    [312]       13.978991      16.606266      18.157461      18.781952
    [316]       18.493813      17.230120      14.920953      11.882528
    [320]       10.008533      10.423199      10.669531      9.3270807
    [324]       5.6854506      2.3222468      7.8639731      12.371598
    [328]       15.037023      16.468399      16.944891      16.610117
    [332]       15.568226      13.910499      11.666295      8.6528196
    [336]       4.3552475     0.98378950      5.7294469      10.439176
    [340]       13.723836      16.022511      17.530411      18.323662
    [344]       18.455023      17.997967      17.055344      15.716955
    [348]       13.975575      11.749707      9.4243641      8.9463301
    [352]       10.812694      12.828800      14.197106      14.956711
    [356]       15.294241      15.432468      15.542885      15.577283
    [360]       15.249845      14.239152      12.484845      10.911393
    [364]       11.293872      12.667717      13.290429      12.637130
    [368]       10.520651      6.8851604      4.0372186      6.0207772
    [372]       8.2584753      9.1173277      8.7754974      7.4625468
    [376]       5.6091418      4.3201966      4.3984108      4.7632656
    [380]       4.2716918      2.6869955      2.0922422      5.4150314
    [384]       9.1878510      11.839926      13.419505      14.072918
    [388]       13.874993      12.808872      10.709288      7.1211905
    [392]       1.6874030      2.4313366      7.2560415      10.051892
    [396]       11.408443      11.760444      11.283259      9.9574928
    [400]       7.5329289      3.3124382     -5.1729507     -8.8227539
    [404]     -0.49870753      3.3801520      6.5801725      9.4410467
    [408]       11.607898      12.923434      13.407906      13.167772
    [412]       12.399269      11.423336      10.600120      10.058273
    [416]       9.6327152      9.1678114      8.7274675      8.5421391
    [420]       8.7959538      9.4621334      10.350479      11.236996
    [424]       11.940441      12.350961      12.433370      12.214270
    [428]       11.753179      11.099466      10.262221      9.2354403
    [432]       8.0830345      7.0267224      6.4190564      6.5232177
    [436]       7.3025336      8.4475365      9.5659122      10.365064
    [440]       10.727378      10.732841      10.672880      10.898998
    [444]       11.441248      11.965415      12.153708      11.901180
    [448]       11.300609      10.573139      9.9339991      9.4666157
    [452]       9.1729794      9.0696173      9.1346188      9.2690096
    [456]       9.3918753      9.4860926      9.5212412      9.4126377
    [460]       9.1034145      8.6510258      8.1788712      7.7086859
    [464]       7.1135893      6.3173962      5.5347877      5.2354145
    [468]       5.5943594      6.2612548      6.8902550      7.3749623
    [472]       7.7139907      7.8899431      7.8484545      7.5242572
    [476]       6.8606424      5.8131166      4.3530202      2.4953218
    [480]      0.41359684     -1.2178509     -1.1259165     0.81915045
    [484]       3.3747573      5.7437038      7.6300311      8.9090452
    [488]       9.5149288      9.4129772      8.6010876      7.1398063
    [492]       5.2428856      3.5170000      3.1509581      4.6041756
    [496]       6.6963291      8.4617386      9.6316442      10.252425
    [500]       10.475381      10.424306      10.101562      9.4213037
    [504]       8.3553429      7.0378180      5.6168828      3.8695033
    [508]       1.3210834    -0.71708679      1.3332083      3.9230952
    [512]       4.8346362
  [Tag]         6881
  [frame_len]          320
[Record 44]
  [tot_power]       268663.28
  [re_spec_val]
    [0]       14.019565      13.585678      12.305009      10.262564
    [4]       7.6656966      4.9560261      3.2044401      3.7028089
    [8]       5.4806151      7.4482694      9.9284296      12.867945
    [12]       15.452022      17.128162      17.691269      17.038702
    [16]       15.055882      11.593667      6.4360423     -1.3507758
    [20]      -2.3800159      4.0171380      5.4624357      5.7812166
    [24]       13.325902      19.551369      23.463322      25.713223
    [28]       26.632805      26.363909      24.925560      22.212677
    [32]       17.921835      11.392583      3.1463165    -0.65531528
    [36]      -5.3474789      11.737178      18.907604      23.300234
    [40]       26.043634      27.524460      27.905315      27.261700
    [44]       25.649782      23.188740      20.187361      17.096264
    [48]       13.780020      8.4891977     -5.6309214      10.278899
    [52]       17.504625      22.669500      26.818411      30.057230
    [56]       32.391819      33.844070      34.447964      34.250557
    [60]       33.340626      31.906746      30.250473      28.550587
    [64]       26.506571      23.544830      20.851912      23.245481
    [68]       26.884291      29.335878      30.763308      31.369768
    [72]       31.215858      30.271158      28.453735      25.640858
    [76]       21.678637      16.663383      12.915504      13.026067
    [80]       13.271492      12.092855      9.8851681      9.2432423
    [84]       10.994930      12.234839      12.094256      10.645162
    [88]       8.1697206      5.2611828      2.8474662      2.1485090
    [92]       4.3151360      7.6908140      10.583249      12.663049
    [96]       14.002211      14.739661      15.024246      14.999138
    [100]       14.784466      14.464806      14.099566      13.748120
    [104]       13.461854      13.233478      12.993984      12.694090
    [108]       12.348264      11.972445      11.573787      11.341722
    [112]       11.698404      12.694684      13.765162      14.380153
    [116]       14.289464      13.376409      11.546705      8.7708759
    [120]       5.5676117      3.7452588      3.5387030      3.1982336
    [124]       2.9914639      4.2192564      6.1929078      7.8360581
    [128]       8.9516420      9.5871210      9.7554407      9.4565487
    [132]       8.7013903      7.4956889      6.1117721      5.9857988
    [136]       8.1102133      10.673626      12.527878      13.521668
    [140]       13.749026      13.440248      13.132339      13.581161
    [144]       14.847092      16.229782      17.203844      17.558065
    [148]       17.190535      16.042456      14.312209      13.195026
    [152]       14.084239      15.664683      16.520311      16.260057
    [156]       14.713249      11.525156      5.6588025     -3.7692013
    [160]       1.7649781      4.4411592      4.4301162      5.0003319
    [164]       8.0279455      11.043005      12.980861      13.859484
    [168]       13.818097      13.008496      11.681977      10.319668
    [172]       9.4679146      9.1105137      8.7410784      8.0629005
    [176]       7.1292148      5.9606342      4.0793014     0.34512571
    [180]      -7.5230641     -6.0917006     -1.3781571    -0.84391338
    [184]      -1.6648492      1.1614519      5.4411268      8.7094059
    [188]       11.145067      13.050323      14.580273      15.800699
    [192]       16.696817      17.159712      17.012226      16.057156
    [196]       14.166721      11.792492      11.182581      12.875711
    [200]       14.345347      14.687024      13.773712      11.452177
    [204]       7.3240042      1.2669255    0.011896472      1.8957134
    [208]      0.55507338     -6.5367751     -5.7285933      2.3471096
    [212]       5.3653498      5.9997215      4.8049922      1.9400394
    [216]     -0.55928427      1.8335291      5.0767684      7.3280063
    [220]       8.8398314      9.7670012      10.032576      9.4482517
    [224]       7.8058658      4.9890604      1.6456339     0.43321249
    [228]       1.5901704      3.3300507      5.4735880      7.4858880
    [232]       8.7703171      9.0990267      8.4268160      6.7597136
    [236]       4.3017712      2.5360196      3.9670913      6.8077641
    [240]       9.2251606      10.992672      12.174326      12.824901
    [244]       12.975009      12.645205      11.840094      10.520113
    [248]       8.6120644      6.2912836      4.8982043      5.7693748
    [252]       7.2097492      7.9213710      7.8460855      7.4604807
    [256]       7.4941373      8.2290831      9.2264671      9.9991941
    [260]       10.253977      9.7338314      8.0748234      4.7313561
    [264]      0.81199813      3.7213962      7.2910438      8.8013144
    [268]       8.6655216      7.4291782      6.4949923      7.3480830
    [272]       8.7556276      9.3994131      9.0132389      7.8390832
    [276]       6.9692030      7.8186069      9.4717798      10.528678
    [280]       10.547012      9.4272413      7.2005401      4.5877934
    [284]       3.9589012      5.2876067      6.2696300      6.2460113
    [288]       5.1572018      2.8439429     -1.3142362     -9.1753397
    [292]      -9.4262991     -4.1564684     -3.0518239     -4.4543061
    [296]      -4.5947137    -0.72762346      2.4063339      3.9614069
    [300]       4.2371392      3.4389021      1.5153185     -2.1085417
    [304]      -8.0644627     -4.4132209      1.0003140      3.6666436
    [308]       4.3466406      3.1146028    -0.15929975     -1.4409300
    [312]       2.7553804      5.6205115      6.5460377      5.7986507
    [316]       3.8534448      3.8930004      7.5661998      10.940898
    [320]       13.124330      14.245008      14.427558      13.731460
    [324]       12.183268      9.8399611      6.9155440      3.8050659
    [328]      0.34521225     -4.6023383     -2.7610524      3.2594743
    [332]       6.7109437      8.4316006      8.9751558      8.6216373
    [336]       7.3604765      4.6837254    -0.90489888     -3.9187701
    [340]       3.1570385      6.3884268      7.2313862      6.4839888
    [344]       5.1446037      5.0658736      6.3122783      7.3385086
    [348]       7.6595025      7.3619976      6.4634857      4.6628876
    [352]       1.3461647     -2.6740365     0.21551073      4.2957087
    [356]       6.6263185      7.7566309      8.1060724      7.9035578
    [360]       7.2281833      6.0785246      4.5498338      3.1185131
    [364]       2.4375448      2.1935737      1.3896003    -0.35405818
    [368]      -1.3019142     0.86943728      3.4780679      5.0856543
    [372]       5.7919230      5.9284759      5.8118424      5.6248484
    [376]       5.3540645      4.8502274      3.8993597      2.1884563
    [380]     -0.84213310     -5.8453994     -6.2289205     -1.5287139
    [384]      0.65346944     0.34783319     -3.0222759     -14.725770
    [388]      -7.4157019     -1.5079937   -0.014778599    -0.55829883
    [392]     -0.98883182     0.70135629      2.8881059      4.4279675
    [396]       5.4643292      6.2708163      6.8404737      6.9576764
    [400]       6.3911910      4.9271736      2.2488153     -2.4065254
    [404]      -10.866425     -8.3073044     -3.3851588     -1.6260662
    [408]     -0.93804902     0.58025038      3.0231450      5.0719614
    [412]       6.1709814      6.2691169      5.3937426      3.4933574
    [416]      0.29610172     -5.1106844     -17.744837     -15.304331
    [420]      -10.926842     -14.800833     -10.203746     -1.0960990
    [424]       3.8231709      6.6326995      7.9827428      8.1140156
    [428]       7.0737586      4.7477388     0.97889847     -2.3063376
    [432]     -0.30301958      2.1937535      3.0321765      2.0359609
    [436]      -1.6747175     -10.959014     -2.0371187      3.8001859
    [440]       6.5152941      7.4685926      7.0357175      5.2887077
    [444]       2.3319840    -0.36115149     0.23533703      1.9699780
    [448]       2.9716222      3.4787517      4.1569982      5.3603005
    [452]       6.8250093      8.1113253      8.9475660      9.2052422
    [456]       8.8031168      7.6430511      5.5723891      2.3646593
    [460]      -2.1982882     -7.3910728     -10.246803     -13.253736
    [464]      -18.157948     -8.1470022     -2.0786762      1.6490170
    [468]       4.1113067      5.7219977      6.6698089      7.0323038
    [472]       6.8037319      5.9015222      4.1689420      1.3632636
    [476]      -2.9077177     -9.4237614     -18.356979     -13.971635
    [480]      -8.8158073     -5.5260696     -3.4384933     -2.0323420
    [484]     -0.76215684     0.60917288      1.8658786      2.6822395
    [488]       2.8988359      2.5978703      2.1580069      2.1217031
    [492]       2.6525550      3.3773320      3.8408554      3.6866267
    [496]       2.6024542     0.33003172     -2.7803118     -3.8091354
    [500]      -2.1824534     -1.1566336     -1.2942004     -1.9305876
    [504]      -1.8737013    -0.67419767     0.93470234      2.4029291
    [508]       3.5726337      4.4029274      4.8995423      5.1280622
    [512]       5.1875653
  [Tag]         7041
  [frame_len]          320
[Record 45]
  [tot_power]       256725.78
  [re_spec_val]
    [0]       15.530967      15.070472      13.681755      11.375631
    [4]       8.3637629      5.6431241      4.9301343      6.0998530
    [8]       8.1984758      10.874356      13.693141      16.182608
    [12]       18.046274      19.141209      19.402180      18.799129
    [16]       17.329357      15.037995      12.072292      8.7960873
    [20]       5.5477533    -0.49763778    -0.15572917      12.922864
    [24]       19.442848      23.550068      26.067020      27.280691
    [28]       27.277290      26.005186      23.233561      18.317987
    [32]       9.0359812      5.3993373      10.842223      11.833892
    [36]       12.617426      16.187138      20.573629      23.986038
    [40]       26.165865      27.128523      26.861048      25.256876
    [44]       22.061609      16.854895      10.427313      8.3191566
    [48]       5.7698550     -3.5012054     -6.9552178      4.1481652
    [52]       13.994271      20.031015      23.651850      25.565056
    [56]       26.081789      25.296638      23.157717      19.763409
    [60]       17.579926      19.582516      21.736217      22.624231
    [64]       22.746344      24.152554      27.784616      31.410650
    [68]       34.017941      35.529270      36.004444      35.487076
    [72]       33.998699      31.583525      28.460102      25.335821
    [76]       23.137772      21.617062      19.923136      17.803226
    [80]       15.358089      12.476130      8.6094666      3.9735105
    [84]       4.5525575      7.5915380      8.8508911      8.3183804
    [88]       5.9431605      1.6986843      1.5002483      6.1259308
    [92]       9.1706896      10.729490      11.190166      10.771031
    [96]       9.6599302      8.1307421      6.5361238      4.9726734
    [100]       2.8694866     -1.3702673     -18.372637     -1.6987140
    [104]       4.9170384      7.8661299      8.5588903      6.8866820
    [108]       2.9198065      6.4334183      11.984558      15.091353
    [112]       16.491310      16.582584      15.537805      13.474451
    [116]       10.859772      9.5021458      10.552461      12.055214
    [120]       12.926803      13.082791      12.637056      11.705925
    [124]       10.348311      8.5246544      6.0811982      2.7394640
    [128]      -2.0359180     -9.9979334     -23.699093     -9.9303885
    [132]      -5.9974217     -3.2605743     0.84447473      5.4048014
    [136]       9.0531445      11.518014      12.837509      13.064492
    [140]       12.232409      10.390460      7.6643224      4.2976785
    [144]       1.5415746      3.2142427      6.4109149      7.8570080
    [148]       6.8198018      2.6623549      4.8698568      11.119882
    [152]       14.510648      15.954409      15.852025      14.154534
    [156]       10.227163      3.5833371      8.0809412      12.943624
    [160]       15.179203      15.849242      15.554120      15.027613
    [164]       15.082405      15.641135      15.900418      15.268871
    [168]       13.343662      9.4084435     0.26710942     -1.5349401
    [172]       7.6921964      11.319308      13.321566      14.560443
    [176]       15.324512      15.675421      15.575432      14.971522
    [180]       13.896346      12.730856      12.549891      13.953034
    [184]       15.858577      17.314547      18.036257      18.010820
    [188]       17.344221      16.268364      15.172827      14.525698
    [192]       14.586172      15.136182      15.644533      15.634650
    [196]       14.823356      13.195381      11.508313      11.482807
    [200]       12.702792      13.379327      12.794244      10.686419
    [204]       7.5591497      8.0205679      11.578209      14.157730
    [208]       15.566379      16.072882      15.851393      15.020895
    [212]       13.725961      12.211697      10.800156      9.6726799
    [216]       8.7332659      7.8299494      6.9474697      6.0875421
    [220]       5.0637703      3.4983525     0.87566656     -3.7864394
    [224]      -15.107862     -11.581294     -4.7623911     -2.8948860
    [228]      -3.9616356     -7.1688008     -2.8293691      2.8850186
    [232]       6.2288585      7.9159184      8.4104738      8.0779772
    [236]       7.2968149      6.3049226      4.9240370      2.5887816
    [240]      -1.6326733     -10.577079     -13.307128     -5.2767162
    [244]      -2.4680955     -1.3744915     -1.0745564     -1.1446370
    [248]      -1.6646719     -3.4299254     -8.5465136     -25.654453
    [252]      -5.8704538     -1.1052723     0.76558483      1.1986940
    [256]      0.90276915     0.14463948     -1.5023946     -5.3145328
    [260]      -14.557581     -8.1530685     -2.7198174     -1.0644279
    [264]      -1.9230680     -5.3174901     -7.9398899     -3.0389304
    [268]      0.99685442      3.5800860      5.2611699      6.1565070
    [272]       6.1935825      5.3647590      4.0650120      3.3736827
    [276]       3.7371097      4.1804466      4.2776365      4.5929327
    [280]       5.5025887      6.4037066      6.7069044      6.3917108
    [284]       5.9459300      5.9993834      6.5866404      7.3363438
    [288]       8.1198092      8.9462395      9.6629934      9.9828014
    [292]       9.6247702      8.3076935      5.5870209     0.48502535
    [296]      -4.1087918      2.1357005      6.1527925      8.2793932
    [300]       9.3680038      9.8830500      10.110382      10.126068
    [304]       9.7647018      8.6991072      6.5606112      3.6137357
    [308]       3.7822030      7.2232533      9.8255625      11.158216
    [312]       11.447316      10.881599      9.6309242      7.9513054
    [316]       6.3243628      5.4200640      5.7050204      7.1569376
    [320]       9.2250271      11.209802      12.701236      13.567750
    [324]       13.820657      13.549454      12.913983      12.140209
    [328]       11.447109      10.906704      10.429361      9.9869556
    [332]       9.8704901      10.505930      11.734177      12.916565
    [336]       13.604712      13.633676      12.983968      11.698177
    [340]       9.8218460      7.2906237      3.7052147     -2.1136410
    [344]      -7.1658344    -0.31176212      3.9652381      6.5907369
    [348]       8.3703423      9.5218811      10.064540      10.014205
    [352]       9.4648628      8.5935726      7.5888734      6.5767183
    [356]       5.7234879      5.3646016      5.6326170      6.1080527
    [360]       6.2946119      5.9894342      5.2526302      4.3250380
    [364]       3.5123799      2.9808865      2.6715200      2.4499002
    [368]       2.2372587      2.0101941      1.7622224      1.4822265
    [372]       1.1510961     0.75003994     0.27129740    -0.27408224
    [376]     -0.84299868     -1.3628261     -1.8275800     -2.4563274
    [380]      -3.6890655     -5.8619175     -7.5397391     -5.3880491
    [384]      -2.5711510     -1.3117698     -2.0142787     -5.7154212
    [388]      -22.226128     -6.2620420     0.30247331      3.4965904
    [392]       5.1187882      5.7027493      5.4574337      4.4255085
    [396]       2.4791582    -0.80266595     -6.4387417     -10.658724
    [400]      -5.0364509     -1.9671990    -0.93726873    -0.82504374
    [404]     -0.16050190      1.8068751      4.1037045      5.9745746
    [408]       7.2828507      8.0652704      8.3485231      8.1194286
    [412]       7.3455043      6.0167575      4.2269287      2.3617215
    [416]       1.3319967      1.9674013      3.7773855      5.7622571
    [420]       7.3725243      8.4231234      8.9088058      8.9239635
    [424]       8.6155062      8.1129990      7.4623885      6.6742392
    [428]       5.9170628      5.6156268      5.9874201      6.5883741
    [432]       6.8219051      6.3891397      5.3760939      4.4551377
    [436]       4.4931111      5.0738668      5.1630220      4.3262773
    [440]       2.8880205      2.2880955      3.3270950      4.5468473
    [444]       4.9695387      4.3684201      2.6012530    -0.73070759
    [448]      -6.4389877     -7.8837342     -2.5115955     0.44434524
    [452]       1.6298780      1.5679067     0.57564330    -0.89842302
    [456]      -2.2478347     -3.5562665     -5.9289227     -7.6174660
    [460]      -2.1176119      2.8968456      6.0111713      7.6716766
    [464]       8.0882597      7.2732415      5.0521407     0.95643914
    [468]      -5.9932799     -12.655282     -13.760812     -18.840282
    [472]      -3.9368315      2.2285192      5.5700984      7.3114152
    [476]       7.9412551      7.7319450      6.8736672      5.5177922
    [480]       3.7957039      1.8538438   -0.079670109     -1.6707236
    [484]      -2.5857351     -2.5649662     -1.5055454     0.25108537
    [488]       2.1295514      3.7482328      4.9426074      5.6418180
    [492]       5.7908545      5.3155856      4.1031680      1.9862267
    [496]      -1.2284644     -5.2532601     -7.3059740     -6.5843968
    [500]      -6.7128663     -9.0852833     -15.650500     -26.584944
    [504]      -13.129656     -9.5264130     -8.3876667     -8.4769821
    [508]      -9.2565575     -10.462337     -11.997165     -13.620182
    [512]      -14.429657
  [Tag]         7201
  [frame_len]          320
[Record 46]
  [tot_power]       217245.03
  [re_spec_val]
    [0]       7.7737479      9.0895796      10.824452      11.328078
    [4]       10.418159      8.2111464      5.1423860      2.6899064
    [8]       3.2527337      6.1711359      9.1563387      11.427980
    [12]       12.901453      13.521003      13.101295      11.368367
    [16]       8.3436670      6.5929341      8.4256582      9.9410124
    [20]       9.7809076      8.4089489      11.957636      18.469391
    [24]       23.276939      26.492701      28.439075      29.312780
    [28]       29.240028      28.308931      26.565804      23.968845
    [32]       20.366430      16.215696      15.501444      18.240364
    [36]       21.079620      23.820036      26.235983      27.976576
    [40]       28.886757      28.944225      28.151655      26.455660
    [44]       23.629990      18.921913      8.7667379      10.561322
    [48]       18.047634      21.270277      22.847223      23.353601
    [52]       22.975256      21.945322      20.976051      21.123718
    [56]       22.173561      23.044931      23.199545      22.568352
    [60]       21.614941      21.991020      24.558769      27.594105
    [64]       30.077726      31.845434      32.916924      33.322815
    [68]       33.076664      32.168938      30.558598      28.152657
    [72]       24.751869      19.876930      11.980620      1.5049208
    [76]       10.398827      13.264978      13.999260      13.769090
    [80]       13.084622      12.207735      11.167172      9.7624969
    [84]       7.6390867      4.3516135    -0.53461194     -5.9509015
    [88]      -7.0722833     -6.0919890     -3.5822992    -0.15780854
    [92]       3.0587831      5.9917188      8.4238806      10.055627
    [96]       10.744001      10.474056      9.3156624      7.5273151
    [100]       6.0774641      6.8221183      9.4790926      12.265721
    [104]       14.463964      15.926268      16.648073      16.678480
    [108]       16.120161      15.137312      13.902869      12.460005
    [112]       10.673048      8.5139847      6.7614365      6.7071595
    [116]       7.6105161      8.1406994      7.9012179      6.7635579
    [120]       4.2981725     -1.0849665     -15.769313    -0.33835992
    [124]       4.2852464      5.6965599      5.0251970      2.6908336
    [128]       1.1156986      3.7820644      6.9737539      9.2982683
    [132]       11.030258      12.404342      13.434247      13.951247
    [136]       13.657419      12.067360      8.0082722     -6.0432835
    [140]       5.6897087      12.506185      15.889473      17.893766
    [144]       19.155266      19.928612      20.279547      20.173306
    [148]       19.528646      18.241846      16.212494      13.472117
    [152]       10.656518      9.1776581      9.0168200      9.4935322
    [156]       11.205346      13.669565      15.691902      16.834177
    [160]       17.090359      16.575726      15.441984      13.820754
    [164]       11.757351      9.3605328      7.6102972      8.0156851
    [168]       9.3660088      10.101445      9.8565054      8.6117105
    [172]       6.3451977      3.3558655      2.5446956      5.3751168
    [176]       7.9229746      9.1177464      8.8929234      7.0938435
    [180]       3.7648556      3.4311528      7.7909727      11.164296
    [184]       13.229901      14.358727      14.785713      14.647480
    [188]       14.029284      13.001173      11.652989      10.123095
    [192]       8.5917768      7.1949186      5.8784771      4.3477907
    [196]       2.2836893     0.38771200      1.5576746      4.6349525
    [200]       7.0731349      8.5628424      9.2920732      9.4526873
    [204]       9.1786680      8.5673733      7.7452188      6.8769259
    [208]       5.9835687      4.7304654      2.4302292     -2.2773333
    [212]      -17.732218     -5.9590178    0.011041596      2.3062623
    [216]       2.8964052      2.2913599     0.57706136     -2.4881306
    [220]      -7.3221378     -9.3071785     -4.9297147     -2.0139458
    [224]     -0.69503999    -0.24141245     0.34358442      1.7830929
    [228]       3.5124736      4.6578937      4.7399130      3.3336442
    [232]     -0.65522254     -14.852136     -2.5428772      4.2526174
    [236]       7.5831819      9.3531313      10.099501      10.043939
    [240]       9.3125334      8.0353727      6.4172373      4.7181554
    [244]       3.0323586      1.0993961     -1.3722403     -3.3218429
    [248]      -1.9113240     0.99004173      3.2686079      4.7601094
    [252]       5.6196694      5.9835153      5.9598093      5.6461949
    [256]       5.1246662      4.4372458      3.5820715      2.5593941
    [260]       1.4310837     0.31713176    -0.66979975     -1.3928211
    [264]      -1.5860415     -1.1133370    -0.28181666     0.54582459
    [268]       1.3098648      2.1252718      3.0161326      3.8665805
    [272]       4.5745358      5.1394835      5.6164026      6.0317359
    [276]       6.3545961      6.5350261      6.5496306      6.4162889
    [280]       6.1836720      5.9055147      5.6005917      5.2142034
    [284]       4.6135869      3.6197960      2.0465436    -0.21483810
    [288]      -2.6810980     -3.1305594     -1.0766560      1.0743746
    [292]       2.5215797      3.2793074      3.4412403      3.0407150
    [296]       2.0137761     0.17700823     -2.6310132     -4.6103024
    [300]      -1.6354756      2.1615901      4.7059464      6.0694852
    [304]       6.4798150      6.3198161      6.3300033      7.1240115
    [308]       8.3046598      9.1467628      9.3035231      8.6981688
    [312]       7.4106770      5.8128309      4.7592821      4.7174788
    [316]       4.8326497      4.1686921      2.6408219      2.4638922
    [320]       5.3779597      8.2917061      9.9886017      10.468482
    [324]       9.9087076      8.7931128      8.2998800      9.1593781
    [328]       10.392675      11.161045      11.307913      10.918541
    [332]       10.102510      8.9166861      7.3452272      5.3106599
    [336]       2.6803670    -0.75148928     -5.1213078     -8.3386497
    [340]      -6.2170439     -3.1693647    -0.91620559     0.75950634
    [344]       2.0310991      2.9181385      3.3750274      3.3652213
    [348]       2.8919919      2.0052602     0.80782706    -0.51423055
    [352]      -1.6060823     -1.9053622     -1.0794468     0.45974597
    [356]       2.0503953      3.2883611      3.9920950      4.0786209
    [360]       3.5031602      2.2439871     0.32121152     -2.1317401
    [364]      -4.7099180     -6.6135783     -7.1288104     -6.4789014
    [368]      -5.4660530     -4.6715837     -4.3076172     -4.3693066
    [372]      -4.8114181     -5.6961970     -7.2309546     -9.5952339
    [376]      -12.023549     -11.490933     -8.6103020     -5.8705106
    [380]      -3.6822622     -2.1048784     -1.2807246     -1.4156809
    [384]      -2.8445754     -6.3706932     -14.658177     -11.221429
    [388]      -4.5839686     -1.7257645    -0.93157768     -1.9582607
    [392]      -5.3269610     -10.720864     -5.9279866     -1.2276758
    [396]      0.90869457      1.1924207    -0.37722856     -4.8053389
    [400]      -18.247236     -6.2150178    -0.52008915      1.9160709
    [404]       2.6627645      2.1554532     0.57504183     -1.7821983
    [408]      -4.0202847     -5.3175945     -7.0200601     -12.353901
    [412]      -15.240182     -4.2875957     0.85496402      3.8230796
    [416]       5.5138850      6.2696371      6.2485285      5.5238748
    [420]       4.1143317      1.9780415     -1.0501028     -5.4915910
    [424]      -13.138213     -15.779204     -8.4137793     -5.0972815
    [428]      -3.7662308     -3.8327305     -4.9503822     -5.7112675
    [432]      -3.7196882    -0.57006592      1.8882883      3.3758304
    [436]       3.9199893      3.5141318      2.0549278    -0.71460372
    [440]      -5.2240167     -9.7726994     -7.5444508     -5.0884686
    [444]      -4.5146294     -5.4460721     -7.2961617     -7.8759127
    [448]      -5.5056105     -2.7128510    -0.71760911     0.41777730
    [452]      0.75952876     0.32732022    -0.92105275     -3.0713065
    [456]      -6.1156378     -9.3280392     -11.037983     -11.964779
    [460]      -12.220995     -7.7589545     -2.6326122      1.0483057
    [464]       3.4973938      4.9904799      5.7083869      5.7670250
    [468]       5.2374287      4.1542010      2.5269060     0.38095233
    [472]      -2.1276557     -4.5604382     -6.4933376     -8.3570604
    [476]      -11.271195     -16.329363     -19.080681     -15.297143
    [480]      -13.686994     -13.403024     -11.412228     -8.0968380
    [484]      -5.6648312     -4.6248312     -5.0749497     -7.3152761
    [488]      -11.937241     -13.853382     -9.0559597     -6.5698347
    [492]      -6.5891438     -9.6971273     -21.745890     -10.071418
    [496]      -3.2401342     0.16945095      1.9066306      2.4714980
    [500]       2.0386930     0.63646030     -1.7996453     -5.2930794
    [504]      -8.7930765     -8.9393053     -7.0471258     -5.4927168
    [508]      -4.2881336     -3.1729512     -2.1698761     -1.4668281
    [512]      -1.2154404
  [Tag]         7361
  [frame_len]          320
[Record 47]
  [tot_power]       82451.492
  [re_spec_val]
    [0]       12.074031      11.539587      9.8773375      6.8858943
    [4]       2.1012187     -5.7727270     -16.501959     -7.8247247
    [8]      -3.2616971    -0.73491997     0.27623871     0.16895086
    [12]     -0.41990530    -0.78724259    -0.47640163      1.0829290
    [16]       3.7433960      5.7384534      4.7646227     -7.4698520
    [20]       11.508068      19.873711      24.949888      28.236694
    [24]       30.216177      31.101637      31.004848      30.002151
    [28]       28.187361      25.740097      22.953127      19.944130
    [32]       15.939990      10.526864      16.123064      21.774029
    [36]       24.894848      26.304909      26.297222      24.918825
    [40]       22.067245      17.638374      12.822486      11.250893
    [44]       10.454384      8.8778486      10.486437      13.978647
    [48]       16.478292      17.900681      18.499233      18.464502
    [52]       17.933304      16.986168      15.636782      13.917859
    [56]       12.151570      11.043376      10.734011      10.643488
    [60]       11.003399      12.601690      14.835414      16.661764
    [64]       17.671782      17.758818      16.929882      15.556959
    [68]       14.936783      15.813964      16.768227      16.723095
    [72]       15.349288      12.469618      7.8823981      1.7966866
    [76]      -3.4981437     -7.3406916     -5.3685722    -0.54340267
    [80]       1.7490833      2.1650169      1.4272410     0.27754587
    [84]     -0.54194224    -0.76816046    -0.69117242    -0.63975781
    [88]     -0.71150303    -0.76127541    -0.54335505   0.0041838042
    [92]      0.64586663      1.0118446     0.72625506    -0.61224604
    [96]      -3.5831194     -9.0666828     -10.195630     -4.4806495
    [100]     -0.82076818      1.7006702      3.6884084      5.3208084
    [104]       6.6093597      7.5045762      7.9257622      7.7807174
    [108]       6.9778204      5.4144320      2.9362013    -0.65686911
    [112]      -4.4612770     -3.4868917    -0.21236470      2.0337150
    [116]       3.2750888      3.8357642      4.0228114      4.0459871
    [120]       3.8420291      3.0396483      1.0731500     -2.8500397
    [124]      -7.9358563     -4.3584423    -0.31581455      1.9801445
    [128]       3.3486307      4.0129099      3.8913245      3.1733053
    [132]       2.9687958      4.1048908      5.2836289      5.3207211
    [136]       4.0702224      3.8685367      7.4394207      11.196881
    [140]       13.749765      15.152374      15.497125      14.772867
    [144]       12.859571      9.5389261      4.9313335      2.3601546
    [148]       3.4485874      3.9554467      3.9108062      4.9467750
    [152]       7.0201497      8.9496918      10.272674      10.895376
    [156]       10.734836      9.6348743      7.3095016      3.1503408
    [160]      -4.1350913     -5.0482788    0.074764110      2.3840325
    [164]       3.4329410      4.0311160      4.4315848      4.5327287
    [168]       4.1516848      3.1960094      1.7360928    0.064320475
    [172]      -1.3287593     -2.0183132     -2.0380142     -1.9529144
    [176]      -2.3946609     -3.5228732     -4.5011334     -4.2180696
    [180]      -3.6258454     -4.0137820     -5.6709170     -8.0377111
    [184]      -10.042999     -12.440095     -18.805933     -23.943085
    [188]      -13.847778     -11.227917     -11.938366     -15.282866
    [192]      -15.478263     -10.553296     -7.1273103     -5.0504508
    [196]      -3.8421483     -3.3233924     -3.5075958     -4.5149760
    [200]      -6.5368714     -9.8557930     -14.940923     -22.751284
    [204]      -37.044987     -27.688274     -18.731632     -12.945741
    [208]      -8.9307308     -6.2220635     -4.6740079     -4.2982583
    [212]      -5.2462516     -7.9052067     -12.831511     -14.192536
    [216]      -9.5432367     -7.0660758     -6.6275473     -8.1190424
    [220]      -12.257399     -17.493847     -11.248040     -7.2011709
    [224]      -5.7753553     -6.4175329     -9.4935322     -16.015957
    [228]      -12.559695     -7.1069651     -4.6927214     -4.2567844
    [232]      -5.6549854     -9.5560980     -19.188223     -16.038023
    [236]      -10.534781     -9.7175264     -12.537057     -21.216997
    [240]      -12.795235     -6.8859940     -4.1994405     -3.3623483
    [244]      -4.0830455     -6.5936260     -12.104489     -28.470152
    [248]      -15.394320     -11.526212     -11.506830     -13.924700
    [252]      -15.322748     -11.788065     -8.7860556     -7.3948951
    [256]      -7.3586988     -8.6042929     -11.395183     -16.876026
    [260]      -34.677647     -20.061472     -14.250575     -11.017071
    [264]      -8.5859413     -6.7972469     -5.8605561     -6.0041051
    [268]      -7.5206652     -11.062070     -18.792746     -19.995268
    [272]      -13.048850     -10.464984     -9.8774796     -10.469912
    [276]      -11.601074     -12.407519     -12.358740     -11.947303
    [280]      -11.893288     -12.614683     -14.391556     -17.332685
    [284]      -19.445024     -17.121826     -14.315134     -12.822373
    [288]      -12.472093     -12.694892     -12.490544     -11.343551
    [292]      -9.9526796     -8.9626608     -8.5025434     -8.4819145
    [296]      -8.7970152     -9.3715792     -10.017463     -10.284652
    [300]      -9.8682861     -9.1798983     -8.8067913     -8.9351559
    [304]      -9.4328680     -10.348798     -12.574818     -18.584604
    [308]      -15.861349     -8.0500135     -4.1694508     -2.5050476
    [312]      -2.6461008     -4.7618141     -9.2499876     -9.3917389
    [316]      -4.0063705    -0.60799187      1.3641373      2.5351467
    [320]       3.3464582      4.1937504      5.2908087      6.4637551
    [324]       7.3223472      7.5434403      6.9237370      5.3211255
    [328]       2.6313214     -1.0210266     -4.3857512     -5.5976620
    [332]      -6.2079000     -8.0122786     -11.663277     -18.007971
    [336]      -29.480801     -25.827372     -17.921141     -12.696724
    [340]      -9.6128874     -8.2849445     -8.4053297     -9.6330509
    [344]      -11.381222     -12.929843     -14.045803     -14.676097
    [348]      -14.815210     -15.491908     -18.489450     -29.685051
    [352]      -22.754843     -15.986284     -14.032366     -14.858694
    [356]      -18.976606     -35.659615     -21.103062     -14.822042
    [360]      -11.651059     -9.6711178     -8.4056301     -7.7444577
    [364]      -7.6567187     -8.0871754     -8.9229288     -9.9824972
    [368]      -11.026633     -11.816327     -12.217525     -12.282548
    [372]      -12.236128     -12.402479     -13.175129     -15.128614
    [376]      -19.651928     -37.638191     -20.069592     -13.829339
    [380]      -10.849562     -9.5742311     -9.6856070     -11.326385
    [384]      -15.275579     -25.186193     -22.746662     -16.435394
    [388]      -15.007606     -16.249285     -18.393494     -16.069139
    [392]      -12.381909     -10.219393     -9.5019674     -10.094236
    [396]      -12.116876     -15.903507     -19.046656     -15.538460
    [400]      -12.455258     -11.433931     -12.508017     -16.790945
    [404]      -31.222221     -16.395849     -11.067274     -9.0652361
    [408]      -9.1198301     -11.179890     -16.129421     -23.272970
    [412]      -16.259659     -12.157661     -10.396718     -10.076007
    [416]      -11.176723     -14.369366     -20.482628     -16.832918
    [420]      -11.875276     -10.054708     -10.655319     -14.144371
    [424]      -23.026764     -17.431499     -12.114171     -10.384343
    [428]      -10.827323     -13.375800     -19.450304     -30.621952
    [432]      -17.683641     -13.390632     -11.796615     -11.982586
    [436]      -13.911633     -17.591024     -18.856962     -15.285998
    [440]      -12.888901     -12.230430     -13.102145     -15.559553
    [444]      -20.040773     -27.544088     -33.205418     -32.598293
    [448]      -34.243343     -28.448114     -24.610142     -24.040791
    [452]      -26.471769     -30.116846     -28.066521     -27.735149
    [456]      -36.507130     -24.479191     -16.534094     -12.342949
    [460]      -10.098335     -9.2885160     -9.7981424     -11.797237
    [464]      -15.944238     -23.897408     -22.834627     -18.322430
    [468]      -17.639679     -19.801359     -24.439787     -24.124807
    [472]      -20.493219     -19.139421     -19.294966     -19.471645
    [476]      -18.552322     -17.298367     -16.540812     -16.331242
    [480]      -16.455635     -16.867107     -17.730169     -18.817923
    [484]      -18.777277     -17.332363     -16.313511     -16.866196
    [488]      -19.594318     -22.619362     -18.723249     -15.151519
    [492]      -13.800152     -14.381008     -16.959034     -21.058802
    [496]      -20.378532     -16.976284     -15.348264     -15.223147
    [500]      -15.952341     -16.701563     -16.958202     -17.108866
    [504]      -17.668461     -18.617310     -19.189255     -18.183455
    [508]      -15.814895     -13.339166     -11.420155     -10.245206
    [512]      -9.8521070
  [Tag]         7521
  [frame_len]          320
[Record 48]
  [tot_power]       60116.789
  [re_spec_val]
    [0]       12.424376      11.898238      10.285900      7.4695921
    [4]       3.1675963     -3.4428363     -17.383423     -14.192266
    [8]      -8.1389093     -5.4435258     -3.3526735     -1.3618839
    [12]      0.51060563      1.8618450      2.2089562      2.0180602
    [16]       3.1625764      4.1130857     0.29629228      7.7316761
    [20]       17.535791      23.426832      27.264849      29.669250
    [24]       30.902746      31.082880      30.249416      28.397274
    [28]       25.531103      21.859480      18.199085      15.247269
    [32]       11.779090      9.9251328      14.961123      18.877302
    [36]       20.867956      21.370499      20.584507      18.592621
    [40]       15.617218      12.709065      11.414165      10.796529
    [44]       9.4361200      7.4918175      6.6458888      7.6058979
    [48]       8.8917427      9.8259659      10.420579      10.758632
    [52]       10.913494      10.979120      10.957298      10.588602
    [56]       9.3586874      6.5412555      1.5815847      1.6404147
    [60]       5.7923555      7.5009460      7.4662590      7.0857782
    [64]       7.5744162      8.1658173      8.0989065      8.5149574
    [68]       10.603865      12.801641      13.930717      13.777493
    [72]       12.335932      9.6179180      5.7841997      1.6672992
    [76]      -1.4530183     -4.3096466     -7.9569755     -9.9401255
    [80]      -9.1071234     -8.7311344     -9.2698107     -9.9847412
    [84]      -10.138360     -9.7976379     -9.5925188     -9.8312683
    [88]      -10.294870     -10.476416     -10.193443     -9.9708405
    [92]      -10.629607     -12.964837     -16.365152     -13.454376
    [96]      -9.1505489     -6.7813969     -5.8670135     -6.0026741
    [100]      -6.9235873     -8.3845234     -9.9804831     -11.105480
    [104]      -11.593020     -12.114909     -13.401353     -14.887424
    [108]      -12.855660     -8.9317141     -6.2656317     -5.2544837
    [112]      -6.0366068     -9.1911259     -16.232740     -15.118207
    [116]      -10.316497     -9.6471653     -12.817248     -22.817291
    [120]      -12.496351     -6.7646923     -3.9750857     -2.5705175
    [124]      -1.9765707     -1.8968105     -2.1133721     -2.4375763
    [128]      -2.8035882     -3.3536491     -4.2707825     -5.1397758
    [132]      -4.2024674     -1.3965466      1.2078863      2.7624009
    [136]       3.1066902      2.2217023     0.45979863    -0.34782040
    [140]       1.1314248      2.7213576      3.2229698      2.6032624
    [144]       1.4777508      1.4193391      2.8778868      4.3099384
    [148]       4.8637323      4.3956904      3.0511920      1.4133023
    [152]      0.46021292     0.13137271    -0.77111501     -3.3480899
    [156]      -9.6596928     -19.146353     -5.7407489    -0.97090143
    [160]       1.4879246      2.5756168      2.5123453      1.3328545
    [164]     -0.87576556     -3.4103553     -4.4614944     -4.0548630
    [168]      -3.9429884     -4.6264315     -5.6185904     -5.8625398
    [172]      -5.0007448     -3.8279450     -2.9223580     -2.4076343
    [176]      -2.2892992     -2.6342909     -3.6095598     -5.4839258
    [180]      -8.7241802     -14.469297     -22.571518     -15.351432
    [184]      -11.098864     -9.0114908     -8.0027399     -7.6353884
    [188]      -7.6563377     -7.8969121     -8.3023272     -8.9343443
    [192]      -9.8584957     -10.981187     -11.975799     -12.501081
    [196]      -12.557353     -12.393257     -12.264931     -12.433570
    [200]      -13.147161     -14.513424     -16.269323     -17.578684
    [204]      -17.828159     -17.393486     -16.497572     -15.170197
    [208]      -13.826870     -12.904266     -12.583735     -12.907331
    [212]      -13.937176     -15.877271     -19.233120     -25.455885
    [216]      -49.921871     -30.201126     -27.560926     -29.727924
    [220]      -28.388731     -22.022646     -18.162258     -16.308563
    [224]      -16.054615     -17.382355     -20.677170     -27.367350
    [228]      -42.499634     -31.923679     -28.926888     -25.111622
    [232]      -20.999779     -18.396990     -17.266840     -17.207779
    [236]      -17.707806     -18.427998     -19.734367     -22.781187
    [240]      -29.668089     -27.313292     -21.471050     -19.302620
    [244]      -19.340050     -20.878225     -22.514048     -22.141356
    [248]      -20.666544     -19.591961     -19.316057     -20.211277
    [252]      -23.133204     -30.708292     -30.936354     -23.936281
    [256]      -22.069889     -23.349243     -28.244488     -30.170511
    [260]      -23.585051     -20.116461     -18.449141     -17.832050
    [264]      -17.895054     -18.055023     -17.160864     -14.970731
    [268]      -12.654754     -10.986321     -10.222936     -10.519162
    [272]      -12.128164     -15.597945     -21.867603     -23.019461
    [276]      -18.711845     -17.449474     -18.400402     -20.519413
    [280]      -21.466030     -20.603523     -20.064310     -20.603474
    [284]      -22.238987     -24.040169     -22.335938     -18.739941
    [288]      -16.331020     -15.438622     -15.994611     -17.963129
    [292]      -20.930939     -22.340141     -20.971491     -20.201916
    [296]      -21.705780     -27.958593     -30.191147     -20.194559
    [300]      -16.173048     -14.417601     -13.981230     -14.370420
    [304]      -15.209507     -16.259346     -17.624567     -19.959106
    [308]      -23.295837     -19.500303     -13.559287     -9.6529560
    [312]      -7.2766228     -6.0966549     -5.9827104     -6.9259348
    [316]      -8.9804258     -12.058766     -15.009331     -15.162664
    [320]      -12.521842     -8.7435627     -5.2138710     -2.5981793
    [324]      -1.0308526    -0.50710648     -1.0405699     -2.7344258
    [328]      -5.8989134     -11.499605     -25.054531     -19.591234
    [332]      -14.943309     -14.926647     -17.347956     -17.518557
    [336]      -13.490567     -10.536103     -9.0553341     -8.6589260
    [340]      -9.0747490     -10.150611     -11.833368     -14.147254
    [344]      -17.203306     -21.310307     -25.986799     -23.653662
    [348]      -18.912050     -15.909889     -14.334877     -13.953241
    [352]      -14.746840     -16.943312     -21.261892     -27.978180
    [356]      -23.627810     -18.951576     -16.589256     -15.452094
    [360]      -15.031839     -15.092257     -15.562242     -16.467955
    [364]      -17.872505     -19.833870     -22.365026     -25.352468
    [368]      -28.410856     -31.045305     -33.381409     -33.719662
    [372]      -29.293242     -25.040686     -22.422829     -21.250948
    [376]      -21.261211     -22.164028     -23.631945     -25.322792
    [380]      -26.265310     -24.900272     -22.517933     -20.803724
    [384]      -20.021952     -19.975222     -20.533998     -21.969614
    [388]      -25.194214     -32.123562     -29.708162     -23.906609
    [392]      -21.672926     -21.588078     -22.945730     -24.379370
    [396]      -24.079029     -23.110609     -22.985655     -24.073671
    [400]      -26.561571     -30.680420     -30.887207     -25.416620
    [404]      -21.668255     -19.673170     -19.116781     -19.955965
    [408]      -22.419149     -27.140533     -32.839561     -29.635559
    [412]      -26.968628     -26.396255     -26.669912     -26.724014
    [416]      -26.217684     -25.120245     -23.523178     -22.051182
    [420]      -21.172258     -20.683826     -19.927608     -18.812260
    [424]      -18.082056     -18.424429     -20.335003     -24.581076
    [428]      -33.004524     -32.799374     -28.830502     -28.650930
    [432]      -29.311930     -27.945787     -26.047009     -25.203329
    [436]      -25.480684     -26.784348     -29.565443     -36.129284
    [440]      -37.280495     -28.241022     -24.200260     -22.490126
    [444]      -22.503002     -24.102972     -26.544725     -25.971069
    [448]      -22.736803     -20.202124     -18.633411     -17.732252
    [452]      -17.282145     -17.229116     -17.715702     -19.134212
    [456]      -22.410091     -31.512463     -29.973600     -21.123816
    [460]      -17.730621     -16.625040     -17.275650     -19.632908
    [464]      -22.334394     -20.360849     -17.106266     -15.363709
    [468]      -15.113573     -16.213629     -18.370716     -19.921907
    [472]      -18.694191     -16.713413     -15.503380     -15.140281
    [476]      -15.447511     -16.266672     -17.515652     -19.238176
    [480]      -21.688541     -25.572258     -33.014320     -33.357262
    [484]      -26.012115     -22.599335     -21.100836     -20.903728
    [488]      -21.798769     -23.792847     -27.282297     -33.806664
    [492]      -35.117355     -27.747793     -24.138725     -22.655449
    [496]      -22.781857     -24.487143     -28.160128     -35.412281
    [500]      -50.977737     -37.636551     -35.163757     -35.182186
    [504]      -35.639030     -35.555279     -35.342827     -35.479595
    [508]      -35.272175     -33.543953     -31.172853     -29.482384
    [512]      -28.897383
  [Tag]         7681
  [frame_len]          320
[Record 49]
  [tot_power]       36069.844
  [re_spec_val]
    [0]       12.391072      11.875755      10.279979      7.4249535
    [4]       2.8634956     -4.7823348     -27.510832     -11.673609
    [8]      -8.9215889     -7.7594299     -5.7364755     -3.0796971
    [12]     -0.99446541    -0.56199723     -2.7302957     -6.1214399
    [16]      -3.3293271     -4.1571598      4.1267719      14.191756
    [20]       20.511778      24.719540      27.431572      28.911762
    [24]       29.266258      28.501560      26.534168      23.188505
    [28]       18.389326      14.028261      13.614388      13.661178
    [32]       12.962255      12.678208      12.975579      12.931024
    [36]       12.157885      10.888317      9.6616526      8.8076916
    [40]       8.0276709      6.7350245      4.3806734     0.59704566
    [44]      -1.7651217      1.4720969      4.3617783      5.8122954
    [48]       6.2659369      6.1057987      5.5285559      4.4250712
    [52]       2.3298163     -1.5538619     -4.6997089     0.49759606
    [56]       4.6761155      6.9598594      7.8885283      7.6488824
    [60]       6.1384120      3.0749991      1.1005876      5.7805643
    [64]       10.276841      13.267757      15.129814      16.085693
    [68]       16.231421      15.590412      14.136935      11.802206
    [72]       8.4709663      3.9859128     -1.7081110     -7.4815354
    [76]      -10.214670     -11.374813     -13.294621     -16.364958
    [80]      -17.630985     -14.038144     -10.978338     -9.4090424
    [84]      -8.9346189     -9.1848240     -9.8970203     -10.974460
    [88]      -12.535874     -14.878706     -18.086872     -19.531658
    [92]      -16.748899     -14.039078     -12.600184     -12.310001
    [96]      -13.032636     -14.672486     -17.018431     -19.412949
    [100]      -21.019041     -22.294870     -23.992760     -24.117855
    [104]      -21.533504     -19.462500     -18.881163     -19.102051
    [108]      -17.840694     -14.788863     -12.087882     -10.436010
    [112]      -9.8082418     -10.036989     -10.804354     -11.528820
    [116]      -11.681735     -11.461835     -11.477600     -12.126110
    [120]      -13.568425     -15.817375     -18.636667     -21.154448
    [124]      -21.331913     -18.262968     -14.521819     -11.650314
    [128]      -9.9078312     -9.2371750     -9.4039984     -9.6876173
    [132]      -8.8439980     -6.8192072     -4.7405744     -3.2293758
    [136]      -2.4556210     -2.4680109     -3.2555346     -4.6221776
    [140]      -5.9414482     -6.5445142     -6.9464803     -8.3529272
    [144]      -11.762585     -14.525377     -9.7350035     -5.9412632
    [148]      -3.9466128     -2.9516580     -2.2829685     -1.5858483
    [152]      -1.0320070     -1.0174927     -1.8229102     -3.5313148
    [156]      -5.9213524     -8.3832397     -10.887548     -15.436958
    [160]      -21.172985     -11.912687     -7.2110310     -5.1297083
    [164]      -4.7218504     -5.6797576     -7.9651036     -11.794755
    [168]      -17.895399     -25.566860     -21.541626     -18.348948
    [172]      -17.293867     -17.418203     -17.566622     -16.265062
    [176]      -14.148903     -12.638820     -12.247920     -13.109396
    [180]      -15.288581     -18.617809     -21.795805     -23.303879
    [184]      -24.754688     -25.286913     -22.011473     -18.749899
    [188]      -16.809126     -15.874411     -15.599006     -15.822330
    [192]      -16.603579     -18.162891     -20.838530     -25.202875
    [196]      -32.315739     -34.873219     -30.003157     -27.484007
    [200]      -26.060169     -24.839708     -23.490816     -22.324940
    [204]      -21.885557     -22.606113     -24.916641     -29.708050
    [208]      -41.413918     -40.002338     -33.797169     -32.134670
    [212]      -31.216246     -29.889076     -28.382536     -27.288401
    [216]      -27.091343     -28.270592     -31.516193     -36.252567
    [220]      -32.844692     -28.902256     -27.432058     -28.001163
    [224]      -30.958982     -39.633347     -38.835613     -29.481165
    [228]      -25.347963     -23.031437     -21.811172     -21.460148
    [232]      -21.940557     -23.368189     -26.156319     -31.787678
    [236]      -43.341396     -30.296711     -25.244160     -22.939268
    [240]      -22.337145     -23.305214     -26.248663     -33.005585
    [244]      -39.768764     -29.781252     -26.000856     -24.120808
    [248]      -22.894466     -21.719725     -20.411428     -19.157890
    [252]      -18.311691     -18.210407     -19.181757     -21.722422
    [256]      -27.165678     -40.416496     -28.831772     -24.374870
    [260]      -22.793837     -22.442019     -22.533936     -22.717487
    [264]      -23.114983     -24.100372     -26.165884     -30.187973
    [268]      -36.934738     -33.788830     -30.440035     -32.161655
    [272]      -44.555729     -26.307325     -19.508999     -15.771715
    [276]      -13.731142     -12.930426     -13.152648     -14.244737
    [280]      -16.012285     -18.114889     -20.037481     -21.361813
    [284]      -22.187428     -23.022465     -24.142969     -24.759401
    [288]      -23.735432     -22.227608     -21.579796     -22.040060
    [292]      -23.113256     -23.684345     -23.479286     -23.410900
    [296]      -23.650227     -23.485634     -22.925461     -22.990442
    [300]      -24.481384     -27.594872     -29.156141     -26.060369
    [304]      -23.286491     -21.594320     -20.488279     -19.566677
    [308]      -18.549379     -17.357664     -16.246300     -15.663518
    [312]      -16.070635     -18.028322     -22.524748     -26.583092
    [316]      -21.199743     -18.592211     -19.307814     -22.099031
    [320]      -17.197447     -11.586999     -8.3305511     -6.7687640
    [324]      -6.5803456     -7.6858201     -10.188168     -14.436662
    [328]      -21.289957     -30.522608     -29.037964     -26.344667
    [332]      -22.561481     -19.231892     -17.182632     -16.178425
    [336]      -15.918262     -16.224556     -17.010145     -18.100748
    [340]      -19.047016     -19.402647     -19.310246     -19.115107
    [344]      -18.844624     -18.526957     -18.517078     -19.298862
    [348]      -21.327415     -25.238600     -32.783154     -37.588455
    [352]      -29.964466     -26.619564     -25.041182     -24.643013
    [356]      -24.940311     -24.673824     -23.225782     -21.904139
    [360]      -21.701607     -22.970142     -25.877172     -29.488260
    [364]      -29.410475     -27.605324     -27.284698     -28.407333
    [368]      -29.031399     -26.590702     -23.466909     -21.252016
    [372]      -19.992138     -19.522585     -19.699520     -20.421820
    [376]      -21.647087     -23.419518     -25.850794     -28.662128
    [380]      -29.328672     -26.672234     -23.903162     -21.967228
    [384]      -20.757687     -20.111933     -19.970417     -20.403158
    [388]      -21.605019     -23.946508     -28.295015     -36.876717
    [392]      -32.463257     -26.710238     -24.114313     -23.214846
    [396]      -23.560722     -24.995726     -27.494139     -31.208870
    [400]      -37.048477     -46.753315     -36.248901     -30.245800
    [404]      -26.938097     -25.369286     -25.335358     -26.817085
    [408]      -29.379862     -30.475410     -29.180582     -28.465837
    [412]      -28.958281     -29.425838     -28.481606     -27.184362
    [416]      -26.725990     -27.313023     -28.636181     -29.604286
    [420]      -28.789248     -26.963779     -25.597509     -25.208658
    [424]      -25.630499     -25.624990     -23.855659     -21.560148
    [428]      -20.010529     -19.482321     -19.959963     -21.390486
    [432]      -23.689476     -26.568041     -29.132732     -30.366732
    [436]      -30.792994     -31.186131     -31.441401     -31.536030
    [440]      -31.977266     -32.852650     -33.146133     -32.494438
    [444]      -32.243980     -32.763142     -32.199589     -29.895676
    [448]      -28.040983     -27.484449     -28.153244     -29.607733
    [452]      -30.874268     -30.648289     -28.814871     -26.601122
    [456]      -24.943283     -24.187527     -24.447063     -25.837688
    [460]      -28.529575     -31.520483     -30.008036     -26.834953
    [464]      -25.305902     -25.826584     -29.353981     -44.936115
    [468]      -30.761398     -24.286648     -21.526377     -20.575102
    [472]      -20.749807     -21.275965     -21.116840     -20.216839
    [476]      -19.551453     -19.792032     -21.199324     -23.629700
    [480]      -25.356153     -24.294701     -22.755003     -22.194012
    [484]      -22.551638     -23.335291     -23.930574     -24.122704
    [488]      -24.177862     -24.267950     -24.309048     -24.231710
    [492]      -24.149136     -24.253633     -24.727230     -25.791475
    [496]      -27.815269     -31.544676     -38.932747     -40.107708
    [500]      -33.755981     -31.500435     -31.554790     -33.497501
    [504]      -37.452591     -43.672264     -49.660473     -45.769009
    [508]      -38.177624     -32.846058     -29.484867     -27.625097
    [512]      -27.028727
  [Tag]         7841
  [frame_len]          320
[Record 50]
  [tot_power]       13590.680
  [re_spec_val]
    [0]       12.249087      11.773859      10.313100      7.7480755
    [4]       3.8157308     -2.1133428     -11.961663     -16.132004
    [8]      -11.392740     -9.5678015     -6.9320698     -3.2682939
    [12]     -0.17638223      1.4932034      1.4864445      1.2699971
    [16]       5.0295544      9.8475275      13.533597      16.286963
    [20]       18.378456      19.864153      20.716719      21.036669
    [24]       21.193783      21.592632      22.074179      22.018753
    [28]       20.860975      18.097231      13.137640      8.8312798
    [32]       11.604987      13.275675      13.154693      12.280139
    [36]       11.453592      10.738856      9.9389772      9.1829252
    [40]       8.5689697      7.8400888      6.5680904      4.0135183
    [44]      -1.6966795     -3.2637370      4.5255384      8.1124144
    [48]       9.4085798      9.3076210      8.7711735      8.8698263
    [52]       9.3575325      9.1579256      7.6489515      4.6675091
    [56]       1.2207447     0.36302426      1.1355186      1.6997123
    [60]       1.9459666      1.7851605      2.7768631      5.8564548
    [64]       8.3879032      9.0657282      7.2541180      1.2447760
    [68]       1.0421886      8.0092955      10.724836      11.020809
    [72]       9.4158096      5.9348311     0.43563852     -5.8389611
    [76]      -8.0780602     -7.8230581     -5.9598341     -3.7960167
    [80]      -2.1205108    -0.98827457    -0.74771518     -1.7824588
    [84]      -4.1459808     -6.8955469     -8.4490480     -10.301560
    [88]      -14.012276     -11.807760     -7.3202186     -5.2227092
    [92]      -4.7717485     -5.1188722     -5.4105792     -5.3685770
    [96]      -5.4705153     -6.1497483     -7.3993382     -8.6995173
    [100]      -9.0832815     -7.9400296     -5.8496699     -3.8114798
    [104]      -2.3606772     -1.5584960     -1.1415871    -0.69313312
    [108]    -0.039243955     0.56517243     0.78957170     0.49790731
    [112]     -0.23885979     -1.1895933     -2.0725925     -2.7563598
    [116]      -3.3208020     -3.8713918     -4.3878932     -4.7344923
    [120]      -4.7245636     -4.2282939     -3.3737736     -2.5438125
    [124]      -2.0883415     -2.1284227     -2.5000153     -2.8182185
    [128]      -2.8727756     -2.9558301     -3.5100732     -4.7464514
    [132]      -6.5449700     -8.3662252     -9.3433933     -9.0896435
    [136]      -8.3099213     -8.0236197     -8.8991261     -11.059465
    [140]      -12.633741     -11.137451     -9.4917498     -8.8617849
    [144]      -8.1267853     -6.3576393     -4.4520988     -3.2678533
    [148]      -2.9349382     -3.1302464     -3.0430667     -2.0502012
    [152]     -0.78536648    -0.17062502    -0.68354040     -2.6034813
    [156]      -6.2273602     -10.969018     -9.9004793     -5.3813763
    [160]      -1.9683162     0.22908580      1.3188063      1.5240051
    [164]       1.3195506      1.3137797      1.6267174      1.8209090
    [168]       1.5776457     0.93976188     0.19144469    -0.36076990
    [172]     -0.58314151    -0.49360269    -0.12622043     0.50740951
    [176]       1.3376781      2.1741791      2.7840424      3.0038922
    [180]       2.7716544      2.1089571      1.1072130   -0.067714162
    [184]      -1.1846472     -2.0406013     -2.6019108     -2.9974148
    [188]      -3.3779502     -3.8298955     -4.3374820     -4.7489853
    [192]      -4.8810802     -4.7914658     -4.8015308     -5.2179027
    [196]      -6.1776772     -7.6490011     -9.4488478     -11.276043
    [200]      -12.823940     -13.900907     -14.420161     -14.385860
    [204]      -13.929117     -13.249783     -12.544222     -11.990911
    [208]      -11.724236     -11.788296     -12.116762     -12.579793
    [212]      -13.094217     -13.673413     -14.310771     -14.816159
    [216]      -14.822720     -14.082644     -12.762963     -11.300965
    [220]      -10.066195     -9.2173519     -8.7192860     -8.4245901
    [224]      -8.2160416     -8.1252556     -8.2813883     -8.7558546
    [228]      -9.4655924     -10.195008     -10.745402     -11.074799
    [232]      -11.259174     -11.399545     -11.549903     -11.560687
    [236]      -11.063503     -10.009666     -8.9299545     -8.3642578
    [240]      -8.5757341     -9.6059484     -11.234126     -12.805849
    [244]      -13.641206     -14.035608     -14.638672     -15.524859
    [248]      -16.228920     -16.123608     -15.065379     -13.683902
    [252]      -12.715614     -12.498591     -12.897254     -13.214787
    [256]      -12.765132     -11.968497     -11.562125     -11.710709
    [260]      -12.092429     -12.241059     -11.999106     -11.496548
    [264]      -10.850644     -10.226495     -9.8810282     -9.9702559
    [268]      -10.364017     -10.640035     -10.510761     -10.241592
    [272]      -10.248104     -10.658571     -11.268020     -11.549714
    [276]      -10.864357     -9.2359924     -7.4052997     -5.9573174
    [280]      -5.0970984     -4.8155022     -5.0097485     -5.5565076
    [284]      -6.3677835     -7.3908510     -8.5186701     -9.4821320
    [288]      -9.9141512     -9.6681652     -8.9876690     -8.2868004
    [292]      -7.9166036     -8.0949564     -8.8987150     -10.177927
    [296]      -11.270230     -11.133088     -9.8842239     -8.5778971
    [300]      -7.7940001     -7.6843476     -8.2359238     -9.3196669
    [304]      -10.632939     -11.701399     -12.191599     -12.220419
    [308]      -12.032698     -11.618346     -10.897814     -10.151389
    [312]      -9.9220724     -10.610345     -12.020783     -12.422993
    [316]      -10.909174     -9.7122469     -10.112534     -12.506123
    [320]      -15.641012     -13.958949     -11.411511     -10.870423
    [324]      -12.154850     -14.684317     -17.225332     -17.970192
    [328]      -14.965979     -10.774493     -7.6834965     -5.7568078
    [332]      -4.5766010     -3.6905797     -2.8472514     -2.0756388
    [336]      -1.4856467     -1.1079309    -0.92380863    -0.94412386
    [340]      -1.2180333     -1.7808650     -2.6046700     -3.5780394
    [344]      -4.5149426     -5.2005906     -5.4776182     -5.3348351
    [348]      -4.9217443     -4.4597211     -4.1315427     -4.0317020
    [352]      -4.1752973     -4.5327697     -5.0673633     -5.7566209
    [356]      -6.5855365     -7.5155878     -8.4434242     -9.1736584
    [360]      -9.4812813     -9.3082180     -8.8604746     -8.4293890
    [364]      -8.2019930     -8.2161884     -8.3871593     -8.5781364
    [368]      -8.7241077     -8.9117737     -9.3146811     -10.072281
    [372]      -11.217795     -12.634770     -14.021041     -14.992982
    [376]      -15.450951     -15.724874     -16.183640     -16.779221
    [380]      -16.754066     -15.523047     -13.898993     -12.790030
    [384]      -12.488204     -12.908012     -13.617140     -13.900637
    [388]      -13.518486     -13.005044     -12.804608     -12.927266
    [392]      -13.101069     -13.034678     -12.704577     -12.350908
    [396]      -12.223077     -12.407734     -12.760365     -12.950915
    [400]      -12.792583     -12.501653     -12.371237     -12.383335
    [404]      -12.197563     -11.570098     -10.727019     -10.056263
    [408]      -9.7645168     -9.8870287     -10.389180     -11.224342
    [412]      -12.316920     -13.439246     -14.054705     -13.651812
    [416]      -12.506757     -11.305939     -10.458172     -10.097610
    [420]      -10.231986     -10.804282     -11.696965     -12.728436
    [424]      -13.703246     -14.489759     -14.929920     -14.718523
    [428]      -13.836646     -12.843400     -12.296810     -12.426961
    [432]      -13.197251     -14.364374     -15.575346     -16.615471
    [436]      -17.495314     -18.229778     -18.828382     -19.391356
    [440]      -19.750229     -19.214743     -17.643188     -15.851891
    [444]      -14.438727     -13.584960     -13.323520     -13.646411
    [448]      -14.497629     -15.718680     -16.989792     -17.895006
    [452]      -18.209808     -18.032194     -17.558556     -16.987926
    [456]      -16.575310     -16.571980     -17.114519     -18.171726
    [460]      -19.569099     -21.091005     -22.404034     -22.755308
    [464]      -21.994991     -21.259180     -21.270210     -21.606323
    [468]      -20.908852     -19.168869     -17.736078     -17.236139
    [472]      -17.749506     -19.160160     -20.995691     -21.808165
    [476]      -20.372845     -18.034775     -16.086344     -14.904565
    [480]      -14.537560     -14.852684     -15.415851     -15.490844
    [484]      -14.808574     -13.934076     -13.387014     -13.296874
    [488]      -13.551963     -13.935719     -14.264406     -14.511247
    [492]      -14.776137     -15.141588     -15.591402     -16.036507
    [496]      -16.396688     -16.672356     -16.964573     -17.441355
    [500]      -18.260015     -19.449547     -20.768740     -21.777122
    [504]      -22.458748     -23.476854     -25.635771     -29.890648
    [508]      -39.004200     -44.853497     -38.193375     -39.778881
    [512]      -44.798187
  [Tag]         8001
  [frame_len]          320
[Record 51]
  [tot_power]       127035.77
  [re_spec_val]
    [0]       14.862083      15.119395      15.485164      15.306783
    [4]       14.168430      11.773421      7.6969118      1.4869318
    [8]       1.4547263      7.0531321      10.828979      13.224888
    [12]       14.570848      15.164308      15.433889      15.817544
    [16]       16.376564      16.786222      16.732769      16.088360
    [20]       14.924122      13.679996      13.478085      15.179358
    [24]       17.996794      20.965485      23.666067      25.914366
    [28]       27.601082      28.648457      28.990442      28.555944
    [32]       27.250713      24.935062      21.407904      16.557112
    [36]       11.781330      10.210666      8.6823053      3.8106163
    [40]      -1.7068244      6.2059941      10.742922      14.022785
    [44]       16.872517      19.165421      20.694555      21.366673
    [48]       21.137594      19.966461      17.863783      15.258284
    [52]       13.765710      14.168941      14.646454      14.072799
    [56]       12.047338      8.4006252      7.4078765      12.455217
    [60]       16.789743      19.940399      22.238592      23.837624
    [64]       24.805567      25.186029      25.019283      24.344284
    [68]       23.197273      21.660984      20.150808      19.893496
    [72]       21.528488      23.762739      25.639715      26.944267
    [76]       27.677746      27.855965      27.457697      26.412182
    [80]       24.595207      21.835119      18.061018      14.472892
    [84]       14.184964      15.212417      15.204796      13.884399
    [88]       11.394796      8.6734438      8.0566721      8.9589930
    [92]       9.2300596      8.3713198      6.5529523      4.3574796
    [96]       2.9291627      3.2846057      4.9996810      6.9394298
    [100]       8.5202971      9.6983700      10.617548      11.376967
    [104]       11.975242      12.369683      12.499066      12.248656
    [108]       11.445434      9.9119205      7.5665441      4.6575489
    [112]       2.1909130      1.6604724      3.4066088      6.0541263
    [116]       8.2782087      9.6716223      10.305755      10.433179
    [120]       10.321835      10.039267      9.3405123      7.7458072
    [124]       4.4599748     -2.3735116     -3.1443386      3.5304737
    [128]       6.2907100      6.8726315      5.8926353      4.0794220
    [132]       3.6795764      5.7215815      8.0338488      9.7538433
    [136]       10.840191      11.281469      11.005210      9.9064217
    [140]       7.8524747      4.6807084     0.52738643     -1.7755942
    [144]     0.034028221      1.6899772      1.8827546     0.99563313
    [148]       2.0571933      6.1816740      9.8677397      12.302732
    [152]       13.613951      13.969111      13.543577      12.632570
    [156]       11.792353      11.659070      12.290965      13.186113
    [160]       13.854875      13.923673      12.995785      10.439763
    [164]       5.3980565      6.5384417      12.605603      16.170601
    [168]       18.139887      19.085587      19.360731      19.269186
    [172]       19.101587      19.082211      19.283083      19.585070
    [176]       19.736477      19.475693      18.648340      17.362080
    [180]       16.234211      16.024492      16.374218      16.366968
    [184]       15.554985      13.870057      11.442698      8.5262375
    [188]       5.3976736      2.8085132      2.4772639      3.3986580
    [192]       3.3473084      1.4658015     -2.9961538     -11.265062
    [196]      -9.7601271     -6.0974798     -4.6345091     -3.2725258
    [200]      -1.9132400     -1.1376971     -1.0390190     -1.3681818
    [204]      -1.8228312     -2.2429628     -2.6721613     -3.2285244
    [208]      -3.8048401     -3.8923779     -3.1173713     -1.6271429
    [212]      0.46090487      2.9104533      5.2362905      7.1223807
    [216]       8.5271740      9.5393381      10.228666      10.564504
    [220]       10.435824      9.7326899      8.4418211      6.7921033
    [224]       5.4005179      4.8508654      4.9139657      5.0408583
    [228]       4.9638515      4.5936351      3.9398963      3.1919999
    [232]       2.6613486      2.5449903      3.1028121      4.6562886
    [236]       6.7098961      8.3869486      9.2257347      9.0836201
    [240]       7.9751711      6.1905046      4.6927552      4.4598856
    [244]       4.7490520      4.4968591      3.3528936      1.3221236
    [248]      -1.2852372     -3.1672049     -2.5171547    -0.52728295
    [252]       1.1993874      2.2775154      2.7044518      2.5829046
    [256]       2.1445065      1.7832400      1.8309722      2.2235789
    [260]       2.6838548      3.0891025      3.5094161      4.0810018
    [264]       4.8944964      5.9172783      6.9790945      7.8651147
    [268]       8.4372435      8.7063723      8.8548422      9.1442833
    [272]       9.6625175      10.223042      10.600475      10.730637
    [276]       10.689416      10.534460      10.172800      9.4206848
    [280]       8.2085371      6.8192573      5.9084740      5.7474990
    [284]       5.9147062      6.2113395      6.7586255      7.4151959
    [288]       7.8034182      7.7135019      7.1867704      6.3166766
    [292]       4.9160833      2.2774160     -2.8433685     -3.3575997
    [296]       2.8396983      6.2445021      7.7840681      8.1218586
    [300]       7.7515416      7.2290940      6.9889951      6.9729733
    [304]       6.8501720      6.4663649      5.9532413      5.6910229
    [308]       6.1628447      7.4997907      9.2561407      10.889541
    [312]       12.095243      12.779132      13.005327      13.021972
    [316]       13.247932      13.963541      14.979288      15.892874
    [320]       16.437437      16.515785      16.151867      15.508581
    [324]       14.948490      14.909158      15.451410      16.170124
    [328]       16.617748      16.475609      15.462532      13.233556
    [332]       9.6903391      8.5555019      12.017086      14.629869
    [336]       15.699437      15.479362      14.153077      11.907674
    [340]       9.1370926      6.5797129      4.8507824      4.0710659
    [344]       4.2210431      4.8563976      5.5552378      6.4291606
    [348]       7.5420580      8.4825344      8.7833061      8.1974478
    [352]       6.6524377      4.2397718      1.3563558     -1.2355938
    [356]      -2.8888133     -3.2602162     -2.6127133     -1.9102948
    [360]      -1.4564344    -0.81380028    0.057566874     0.50079674
    [364]    -0.027713625     -1.6835659     -4.1041045     -6.0304894
    [368]      -6.3190994     -4.9648733     -2.4486642    0.033418011
    [372]       1.8283453      2.9600370      3.7009017      4.2800503
    [376]       4.7059245      4.8269105      4.5230656      3.8364463
    [380]       3.0356977      2.5254250      2.4409864      2.4487646
    [384]       2.1072943      1.1064833    -0.77224672     -3.6403978
    [388]      -6.7638230     -7.3723392     -6.1436429     -5.7731328
    [392]      -6.8076539     -8.9208403     -10.926495     -12.283927
    [396]      -15.478466     -31.505743     -15.646519     -9.3905592
    [400]      -6.9968381     -6.5309682     -6.9673576     -7.1396809
    [404]      -6.7557349     -6.6007957     -6.8488607     -6.5329504
    [408]      -5.1217284     -3.6456656     -2.8844490     -2.9240198
    [412]      -3.4337823     -3.8283980     -3.9042892     -4.1747322
    [416]      -4.7880392     -4.1287951     -1.3296025      1.5197220
    [420]       3.4898250      4.6416383      5.2226291      5.4281864
    [424]       5.3067436      4.8145924      3.9810832      2.9975860
    [428]       2.0592566      1.2189305     0.91469055      2.0880351
    [432]       4.2653275      6.2339296      7.5789380      8.3558826
    [436]       8.7146940      8.7470112      8.4638367      7.8776040
    [440]       7.0910273      6.2452111      5.2878327      3.8354106
    [444]       1.2494121     -3.4198911     -8.3041744     -3.4730110
    [448]      0.23172143      2.0307066      2.7332120      2.7361314
    [452]       2.2045307      1.1743124    -0.35704872     -2.3292835
    [456]      -4.4461927     -5.9251232     -5.8849764     -4.4924030
    [460]      -2.4824958    -0.33949617      1.6723901      3.4157810
    [464]       4.8234806      5.8463535      6.4320860      6.5388603
    [468]       6.1742682      5.4589972      4.6897817      4.2374072
    [472]       4.1864510      4.2550759      4.1638999      3.8354700
    [476]       3.3294876      2.7230802      2.0821474      1.5667195
    [480]       1.4305973      1.6724730      1.9156358      1.8616461
    [484]       1.6465563      1.7416397      2.2451820      2.6287282
    [488]       2.4764512      2.0016716      2.1170619      3.2310872
    [492]       4.4814696      5.1644521      5.1262841      4.4660473
    [496]       3.4009073      2.2647061      1.5483757      1.6733477
    [500]       2.4591708      3.3377135      3.9732130      4.3610921
    [504]       4.6633024      5.0084214      5.3707433      5.6307611
    [508]       5.7011638      5.5805149      5.3453479      5.1203694
    [512]       5.0278702
  [Tag]         8161
  [frame_len]          320
[Record 52]
  [tot_power]       253444.84
  [re_spec_val]
    [0]       20.346487      19.928495      18.675314      16.585951
    [4]       13.643090      9.7724562      4.7284737     -1.1358956
    [8]       3.3467684      10.740907      16.269709      20.409109
    [12]       23.419775      25.434319      26.520861      26.703308
    [16]       25.962532      24.220108      21.289627      16.728025
    [20]       9.1640129     -18.199188      2.5483549      5.0397649
    [24]       5.2526770      10.137330      16.619528      21.401539
    [28]       24.585014      26.417965      27.027618      26.435053
    [32]       24.546156      21.082260      15.418129      8.3004990
    [36]       9.4113178      10.194832      7.2949944      4.8658514
    [40]       12.005839      17.018826      20.110136      21.936869
    [44]       22.730486      22.540443      21.313501      18.888903
    [48]       14.888373      8.1911840     -7.3201084      1.6078217
    [52]       5.5507460      6.7063670      7.1405458      7.7774739
    [56]       9.0038700      10.449763      11.402187      11.326879
    [60]       10.082044      9.1048689      11.177657      13.970615
    [64]       15.498078      15.485249      13.702712      9.2936077
    [68]      -1.9306810     -3.1876469     -2.8965433      7.2705498
    [72]       16.985224      22.599796      26.114252      28.221436
    [76]       29.251049      29.395094      28.772814      27.435753
    [80]       25.344368      22.343163      18.176643      13.092978
    [84]       12.439907      17.079912      21.378134      24.741245
    [88]       27.265308      29.081070      30.295107      30.972065
    [92]       31.140318      30.804947      29.952433      28.539629
    [96]       26.468224      23.547798      19.444025      13.707552
    [100]       7.9284186      8.0146885      8.3170385      6.6437616
    [104]       3.5987644      2.6901352      7.2000904      11.491581
    [108]       14.244604      15.628470      15.811892      14.879117
    [112]       12.887270      10.310613      9.5508509      11.935357
    [116]       14.794217      17.081964      18.679104      19.524942
    [120]       19.557205      18.766665      17.311100      15.722196
    [124]       14.725492      14.185760      13.179816      10.875653
    [128]       6.5440907      4.8891444      10.678696      14.854554
    [132]       17.383242      18.670832      18.810429      17.703028
    [136]       15.014975      9.7927151    -0.88021952      3.8783407
    [140]       7.6135492      7.4251471      3.9892583     -5.3873186
    [144]       1.4832097      7.8492913      11.135387      13.034675
    [148]       14.049346      14.330248      13.893224      12.710532
    [152]       10.738693      7.8517675      3.5244365     -4.1684499
    [156]      -2.5146337      4.8828063      9.0618677      11.697909
    [160]       13.334816      14.283088      14.859610      15.290779
    [164]       15.458435      14.900920      12.938268      8.1939192
    [168]      -6.1626105      5.9579854      10.884012      12.330129
    [172]       12.014307      10.943542      10.684754      12.480492
    [176]       15.578545      18.769648      21.449131      23.430267
    [180]       24.701014      25.303635      25.285992      24.680782
    [184]       23.493771      21.694691      19.204483      15.854598
    [188]       11.213179      3.5675013     -11.766160      5.2974982
    [192]       10.812234      14.510176      17.375345      19.618059
    [196]       21.299309      22.463108      23.160961      23.450409
    [200]       23.386024      23.004158      22.303244      21.227524
    [204]       19.658606      17.398401      14.084711      8.8125353
    [208]      -2.0022004      1.9893737      7.5717387      9.0663004
    [212]       7.7457123      1.8392147     -4.8850203      6.9001102
    [216]       10.182816      9.8488779      4.7299829     -3.8833373
    [220]       10.348296      14.865762      16.656836      16.778912
    [224]       15.613347      13.415310      10.537263      7.4357152
    [228]       4.1932573     0.27649659     -4.2248044     -3.7414501
    [232]       1.5862541      6.2224774      9.7133713      12.326268
    [236]       14.347575      15.953615      17.164175      17.894672
    [240]       18.041113      17.524456      16.296249      14.335384
    [244]       11.657067      8.3588600      4.7818532      1.9213150
    [248]       1.2164322      2.4392686      4.3312888      6.2544894
    [252]       7.9369392      9.2090521      10.016385      10.547190
    [256]       11.306898      12.667130      14.288372      15.604012
    [260]       16.334435      16.444326      16.007113      15.100027
    [264]       13.692649      11.549658      8.1454210      2.3242545
    [268]      -9.3279095     -7.6734033     -6.4735770   -0.073557317
    [272]       7.1746383      11.524807      13.923299      14.839148
    [276]       14.470325      12.958209      10.858716      10.035182
    [280]       11.334228      12.905447      13.833140      13.966432
    [284]       13.166705      11.097692      7.1609416      3.1009493
    [288]       6.6246157      9.7489786      10.558616      9.1303701
    [292]       4.2567053     -5.5158215      7.1292992      12.504250
    [296]       15.487415      17.277613      18.277508      18.630407
    [300]       18.359346      17.439384      15.879946      13.882523
    [304]       12.052625      11.054440      10.663224      10.243778
    [308]       9.5703964      8.8408136      8.7929487      10.238497
    [312]       12.485368      14.326092      15.156384      14.595096
    [316]       11.951772      5.3594213      7.2614093      14.150177
    [320]       17.497532      19.043972      19.506458      19.411856
    [324]       19.385368      20.005238      21.303911      22.811676
    [328]       24.052830      24.707775      24.538071      23.273438
    [332]       20.425581      14.712591      7.4177098      14.856123
    [336]       18.218077      18.972458      18.003819      15.606534
    [340]       12.182247      9.5154696      9.5566950      10.303621
    [344]       10.209087      8.6331034      4.1923485     -5.2250571
    [348]       5.7356377      10.844997      13.042864      13.484437
    [352]       12.497986      10.158502      6.5848241      3.0212646
    [356]       2.2369304      2.5881162      1.5433263     -2.1362605
    [360]      -2.7111599      4.6314502      9.3701181      12.238459
    [364]       13.895155      14.681236      14.817243      14.466652
    [368]       13.743413      12.703530      11.354526      9.6987877
    [372]       7.8549457      6.4878345      6.9909925      9.0809422
    [376]       11.089788      12.269127      12.451497      11.621842
    [380]       9.8805008      7.6860113      6.1022592      5.6224251
    [384]       5.3497281      4.5977707      3.2135909      1.0871550
    [388]      -2.1177218     -6.5822835     -8.2106342     -5.1609373
    [392]      -3.0700417     -2.3750513     -2.7483015     -3.9318249
    [396]      -5.0415325     -3.7610300    -0.45637155      2.7262018
    [400]       5.2818437      7.2994604      8.9106522      10.189192
    [404]       11.141631      11.726798      11.887744      11.587090
    [408]       10.847190      9.7969465      8.6814985      7.7229772
    [412]       6.8953314      5.9572520      4.6893983      3.0122430
    [416]       1.0235448    -0.81533051     -1.4941871    -0.60764164
    [420]      0.91154850      2.5254230      4.5424833      7.1817923
    [424]       9.9599743      12.329782      14.073919      15.194077
    [428]       15.797302      16.053576      16.169292      16.329212
    [432]       16.596638      16.843328      16.787651      16.071789
    [436]       14.236102      10.457989      3.7797968      7.4492698
    [440]       12.698947      15.267177      16.274374      16.192860
    [444]       15.278793      13.827408      12.467087      12.094372
    [448]       12.732867      13.543141      14.007840      14.056705
    [452]       13.832931      13.509422      13.107460      12.450956
    [456]       11.299610      9.4572744      6.7326474      2.6762619
    [460]      -4.1531253     -6.3590078     0.16261226      2.7456558
    [464]       2.4334884     -1.0844384     -1.9979631      4.7325625
    [468]       8.6698675      10.450961      10.622243      9.3206320
    [472]       6.4518080      2.2002645     0.60226440      3.2965212
    [476]       5.4240284      6.5989099      7.2432499      7.6523867
    [480]       7.9909787      8.2955418      8.4406309      8.1394739
    [484]       6.9429083      4.0344381     -2.6046319    -0.88860744
    [488]       6.4845762      10.389041      12.657549      13.990621
    [492]       14.728602      15.035740      14.957991      14.483954
    [496]       13.599470      12.290014      10.473095      7.8913298
    [500]       3.9773569     -2.5014462     -9.6337070     -4.5523596
    [504]      -1.6015707     0.90315050      3.7395332      6.0942850
    [508]       7.6039348      8.3355742      8.4995642      8.3837395
    [512]       8.2961807
  [Tag]         8321
  [frame_len]          320
[Record 53]
  [tot_power]       250234.50
  [re_spec_val]
    [0]       21.050648      20.623718      19.327026      17.140886
    [4]       14.184374      11.117468      9.1439600      8.2367449
    [8]       7.1672096      4.0755124    -0.28994754      11.139792
    [12]       17.902542      22.043388      24.537909      25.735075
    [16]       25.759695      24.606853      22.144783      18.046597
    [20]       11.646629      4.2654915      5.7260027      7.4117465
    [24]       7.7416286      8.4407816      13.418590      19.089060
    [28]       23.184340      25.808067      27.186251      27.442938
    [32]       26.609716      24.629745      21.335728      16.391577
    [36]       9.2212124    -0.39416778     -2.9444809      4.1652274
    [40]       8.4431906      10.178723      10.683802      12.070607
    [44]       14.646977      16.773581      17.815348      17.765295
    [48]       16.744070      14.933246      12.664078      10.548601
    [52]       9.2644396      8.7948341      8.4672518      7.6738882
    [56]       5.9833312      2.8403780     -2.6620038     -2.4580188
    [60]       3.8809845      7.7385869      9.8784313      10.649341
    [64]       10.095750      8.4096451      7.4292216      9.4076986
    [68]       11.739381      12.868344      12.666134      11.092332
    [72]       8.0673475      6.2196259      10.186066      14.100563
    [76]       16.476870      17.584490      17.667501      16.924305
    [80]       15.528429      13.612673      11.359360      9.2935944
    [84]       8.3234472      9.0808630      10.811333      12.618680
    [88]       16.406218      22.052570      26.921776      30.420919
    [92]       32.641449      33.694309      33.623707      32.394405
    [96]       29.863104      25.693356      19.210361      12.271099
    [100]       13.584907      13.721183      12.045655      13.316334
    [104]       17.556301      21.248030      24.054834      26.111406
    [108]       27.466623      28.102564      27.974762      27.034504
    [112]       25.242079      22.579878      19.045334      14.557261
    [116]       9.5126381      9.6333513      13.269768      15.851594
    [120]       17.945753      20.134932      22.156475      23.542282
    [124]       24.065990      23.679403      22.435534      20.524700
    [128]       18.335615      16.179695      13.731746      10.701230
    [132]       10.167163      13.085197      15.264840      16.232044
    [136]       16.851606      18.146236      19.967161      21.465923
    [140]       22.219696      22.169811      21.416613      20.169239
    [144]       18.694891      17.132019      15.344207      13.145243
    [148]       10.835075      9.4804592      9.3169384      9.1926775
    [152]       8.4005289      6.7303276      3.9076762    -0.86505836
    [156]      -7.0613804     -2.1134646      2.2337132      4.4752641
    [160]       5.5734653      6.0054822      6.0269537      5.7219048
    [164]       4.9326673      3.0610054     -1.9016923     -15.221517
    [168]       3.4536638      9.5655308      12.989435      14.818166
    [172]       15.317801      14.449475      11.882667      6.7866950
    [176]       1.7353889      6.2261972      8.5061092      8.0171452
    [180]       4.7410951     -3.5098891     -1.6160318      4.6622744
    [184]       6.9371338      7.2652187      7.0090756      8.0477533
    [188]       10.058905      11.473337      11.917814      11.753829
    [192]       11.510164      11.158410      10.129161      8.6582565
    [196]       9.6138802      12.863416      15.602862      17.449503
    [200]       18.652243      19.339626      19.414356      18.606312
    [204]       16.454220      11.866808   -0.099956386      7.9999356
    [208]       13.772457      16.085297      16.809807      16.588608
    [212]       15.915219      15.568005      16.490643      18.600410
    [216]       20.983997      23.052340      24.578300      25.467005
    [220]       25.657503      25.093847      23.729218      21.593639
    [224]       19.060730      17.230768      16.771179      16.666574
    [228]       16.091185      14.992424      13.719722      12.773664
    [232]       12.432562      12.533156      12.769359      12.991067
    [236]       13.202415      13.435289      13.651545      13.712078
    [240]       13.382800      12.343130      10.129545      5.7906446
    [244]      -3.7539117     0.61486930      6.6945701      9.4343081
    [248]       10.797196      11.548779      12.142224      12.713153
    [252]       13.006716      12.572448      10.919645      7.4173541
    [256]       2.1402419      3.9887130      8.2820835      10.804782
    [260]       12.226407      12.721044      12.020485      9.4447470
    [264]       2.6926095     -6.2975402      6.6059031      10.170402
    [268]       10.997656      9.9212217      6.8520761      1.6127748
    [272]       2.7660580      8.0082016      11.268434      13.157234
    [276]       13.992922      13.786009      12.315887      8.9433975
    [280]       1.2520206     -3.1357415      5.8940911      8.5891542
    [284]       8.5546904      5.9947786     -1.2188879     -3.7813952
    [288]       5.2693048      8.9855118      11.042304      12.586757
    [292]       13.981460      15.068118      15.597333      15.513769
    [296]       15.077797      14.833858      15.002335      15.012662
    [300]       14.062440      11.298578      4.9396091      2.9799798
    [304]       10.235881      13.419951      14.544765      14.340287
    [308]       13.100008      10.991662      8.5277891      7.6821055
    [312]       9.2822924      10.903280      11.287601      9.8936920
    [316]       5.4460793     -8.2815371      5.5374513      10.985360
    [320]       13.422252      14.376359      14.388983      13.688681
    [324]       12.231886      9.5749273      4.6660252      1.4499954
    [328]       7.1109076      9.9844246      10.183231      9.2767477
    [332]       12.129966      16.648468      19.778479      21.522482
    [336]       22.151041      21.871731      20.873806      19.396235
    [340]       17.770750      16.330244      15.148765      13.954828
    [344]       12.388511      10.420384      9.2971325      10.711616
    [348]       13.031463      14.741201      15.612201      15.741356
    [352]       15.297943      14.535626      13.861317      13.783348
    [356]       14.518040      15.736163      16.935387      17.756323
    [360]       17.997118      17.600630      16.760138      16.068691
    [364]       16.031055      16.172691      15.633537      13.833755
    [368]       10.420020      6.7967787      8.4370527      11.377895
    [372]       13.265573      14.515075      15.398596      15.827179
    [376]       15.508053      14.013873      10.513489      1.7496642
    [380]      0.86633909      9.3452024      12.274358      13.190463
    [384]       13.073825      12.528859      11.914824      11.246350
    [388]       10.377038      9.2648468      8.0461664      6.9968548
    [392]       6.3510933      5.9659524      5.4541392      4.9579549
    [396]       5.5312552      7.2391248      8.7464104      9.3505325
    [400]       9.0310755      8.2176285      7.7634759      8.1913862
    [404]       9.1135597      10.027094      10.578130      10.399321
    [408]       9.1681824      7.0333266      6.1492772      7.9715815
    [412]       9.6433754      9.9973383      8.9867668      6.6736207
    [416]       3.1741118    -0.70231783     -2.0346756    -0.41294912
    [420]       1.5445629      3.0473754      3.9489670      4.3714108
    [424]       4.9240799      6.2218270      7.8266411      8.9522238
    [428]       9.2610931      8.6948996      7.2049809      4.5801826
    [432]      0.62807602     -2.4923940     -2.3616674     -4.5363641
    [436]      -3.6319451      4.6359587      9.2556906      11.399453
    [440]       11.608457      9.8523655      5.4426069     -2.4041829
    [444]       1.3387430      4.6423573      4.8164558      3.8601799
    [448]       4.4387565      5.7036099      4.9185128     -1.5615896
    [452]      -1.4516184      9.3152704      13.765926      15.808473
    [456]       16.198130      15.115320      12.434132      7.5320306
    [460]      -2.5489860     -5.7623434      1.9981105      4.7167573
    [464]       6.1242008      6.5138221      5.2806611     0.55864596
    [468]      -15.267263      4.4775052      9.9798622      12.682294
    [472]       13.860518      13.999133      13.424082      12.442911
    [476]       11.307023      10.100216      8.7780666      7.4009061
    [480]       6.3208599      5.9238367      5.9855280      5.9442072
    [484]       6.0116220      7.5577240      10.418544      12.995320
    [488]       14.676649      15.467669      15.547814      15.145653
    [492]       14.416183      13.297570      11.500459      8.5687847
    [496]       3.7740664     -1.4048384      3.3959560      7.9094348
    [500]       10.567970      11.927519      12.200053      11.478835
    [504]       9.8499060      7.4790545      4.6501331      1.4486934
    [508]      -3.0325015     -10.882949     -6.8094893     -1.8969204
    [512]     -0.53750336
  [Tag]         8481
  [frame_len]          320
[Record 54]
  [tot_power]       254143.38
  [re_spec_val]
    [0]       24.353626      23.780609      22.021038      18.937969
    [4]       14.234315      7.2339964     -4.2056608     -10.758683
    [8]      -7.0346184     -13.921395   -0.055210266      10.036822
    [12]       16.229259      20.419300      23.186874      24.775656
    [16]       25.296974      24.792898      23.256805      20.632132
    [20]       16.782518      11.392265      3.7925618     -3.3235834
    [24]      -1.9666096      2.4194162      10.405843      16.916098
    [28]       21.702452      25.118244      27.374710      28.585243
    [32]       28.803797      28.040564      26.264740      23.395361
    [36]       19.265537      13.488789      4.9962897     -1.1944355
    [40]       3.2674587      4.2324820      1.7554675     -9.4955282
    [44]      0.38795209      8.1092911      12.025968      14.171169
    [48]       15.086485      15.018616      14.168780      12.769271
    [52]       11.018312      8.8790045      5.9646153      1.5249362
    [56]      -6.1418676     -12.242264     -5.5994196     -2.2454112
    [60]       1.6163536      5.8935547      9.2606382      11.366066
    [64]       12.210892      11.809900      10.118239      7.0067201
    [68]       2.2315395     -4.3219485     -6.0831795    -0.98570895
    [72]       2.6646702      5.0468912      7.4557047      10.863189
    [76]       14.519815      17.520348      19.575230      20.636894
    [80]       20.698101      19.752254      17.817526      14.999591
    [84]       11.461522      6.7660918     -1.9759620      3.6736748
    [88]       10.621165      14.135460      15.980761      18.041990
    [92]       22.135204      26.614744      30.105965      32.432270
    [96]       33.663536      33.859512      33.032021      31.140581
    [100]       28.106091      23.942709      19.426222      16.388378
    [104]       13.773131      8.8232851      6.0487638      11.919289
    [108]       16.921324      21.376102      24.936182      27.360600
    [112]       28.659569      28.895683      28.117483      26.360737
    [116]       23.678930      20.178175      15.971855      11.230703
    [120]       8.3957205      9.4862995      9.7759199      8.3520985
    [124]       10.712951      16.000935      19.786837      22.080824
    [128]       23.175037      23.204071      22.189550      20.054291
    [132]       16.548754      10.872463    -0.77883512      2.0219555
    [136]       6.7176447      6.1245956      1.7210674      8.3781157
    [140]       14.953918      18.823898      21.147135      22.403795
    [144]       22.798126      22.399759      21.200171      19.134911
    [148]       16.072147      11.734118      5.4879394     -1.5531543
    [152]       1.2108078      3.8156998      4.3779745      3.5835865
    [156]       2.0255318      1.4182081      3.3726912      5.8871970
    [160]       7.5795712      8.3979034      8.6593275      8.6329651
    [164]       8.1818924      6.7517171      3.6287096    -0.13297588
    [168]       2.6138294      6.0542784      7.5356107      7.6329317
    [172]       7.3987746      8.6754837      11.496013      14.183884
    [176]       16.021910      16.892410      16.822292      15.930601
    [180]       14.538641      13.198341      12.119706      10.641951
    [184]       7.6528411      1.0184011     -7.6251926      3.1679516
    [188]       6.8207150      8.5524349      9.7367525      10.662803
    [192]       11.058358      10.590522      9.0246468      6.3772845
    [196]       4.1805563      5.2214451      7.3225527      8.8240623
    [200]       9.8341236      10.507829      10.709890      10.213530
    [204]       8.9644470      7.4842124      7.1345234      8.0553093
    [208]       8.7248545      8.1943645      6.0753636      3.7178760
    [212]       6.0722837      9.3336039      10.825927      10.463308
    [216]       7.9034896      1.0333495    -0.34309858      9.1750927
    [220]       13.918995      16.874311      18.806673      20.061752
    [224]       20.839428      21.194941      21.040422      20.220545
    [228]       18.609072      16.226488      13.507812      11.499048
    [232]       10.688856      10.316037      9.7654285      8.8085232
    [236]       7.5128069      6.7026491      7.5730910      9.7778482
    [240]       12.322089      14.601710      16.210981      16.861561
    [244]       16.297731      14.178679      10.393978      9.5093384
    [248]       13.162683      15.392925      15.800582      14.600864
    [252]       11.928463      8.9677963      9.3210592      11.432300
    [256]       12.807613      13.414052      13.618231      13.659448
    [260]       13.467012      12.663539      10.627604      6.1116066
    [264]      -4.6947141      3.7176974      8.9001579      10.827929
    [268]       11.064312      10.160283      8.3952541      5.9552093
    [272]       3.2223313      1.4223186      2.2904508      5.4341393
    [276]       8.8138075      11.273246      12.456133      12.170444
    [280]       10.010722      4.5774279     -7.8190727      4.4429951
    [284]       8.5883188      9.8984528      9.8909473      9.5894918
    [288]       9.9392614      11.049820      12.301915      13.158689
    [292]       13.259092      12.264131      9.8609486      7.1377931
    [296]       8.7427511      11.545258      12.553506      11.492307
    [300]       8.1931953      5.8046885      9.5445633      12.408134
    [304]       13.444600      13.140922      11.856215      9.9723549
    [308]       8.2738867      7.7037387      7.5902262      6.2239552
    [312]       1.6005666     -2.7116120      6.1967387      10.511544
    [316]       12.427112      12.860740      12.258186      11.089489
    [320]       10.114249      10.013082      10.638451      11.555767
    [324]       12.566845      13.424841      13.709590      12.910815
    [328]       10.244344      3.2973781     0.37958694      9.5482073
    [332]       12.995598      14.097325      13.699735      12.438703
    [336]       11.592487      12.218460      13.323309      13.841554
    [340]       13.489953      12.336505      10.853168      10.168498
    [344]       10.728848      11.342842      10.994246      9.2047319
    [348]       6.2843752      6.3294649      9.3476152      11.094236
    [352]       11.022009      9.0657578      5.1619582      2.3869371
    [356]       4.1013551      3.9274893     -2.5465529    -0.71684414
    [360]       9.5159826      14.098333      16.489918      17.539719
    [364]       17.751038      17.697090      17.904829      18.342813
    [368]       18.533588      18.101467      16.916531      15.160450
    [372]       13.779830      14.121692      15.440700      16.263786
    [376]       15.941292      14.000492      9.2144403     -9.8665133
    [380]       7.0497108      12.699979      15.063240      15.969228
    [384]       16.005514      15.425912      14.365838      13.062878
    [388]       12.054531      11.748255      11.698570      11.208171
    [392]       10.177085      9.7191896      11.161224      13.274372
    [396]       14.760752      15.346235      15.095600      14.194347
    [400]       12.959989      11.802193      10.987342      10.491303
    [404]       10.141648      9.6493187      8.5039253      5.8488264
    [408]      0.35939050      2.1439743      8.7048626      12.361377
    [412]       14.278137      14.996478      14.791557      13.890785
    [416]       12.602255      11.354527      10.477536      9.8949203
    [420]       9.2623100      8.2608442      6.6082401      3.8621666
    [424]      -1.1991736     -14.307124     -2.0318058      4.3717284
    [428]       8.1018553      10.704031      12.644210      14.109035
    [432]       15.185163      15.914148      16.304270      16.324640
    [436]       15.894272      14.870348      13.038758      10.209480
    [440]       7.4536977      8.8155222      12.032038      14.366773
    [444]       15.771753      16.512203      16.819839      16.876280
    [448]       16.797161      16.609024      16.238705      15.516228
    [452]       14.165188      11.719796      7.2027240     0.46264565
    [456]       6.1649451      10.840267      13.042045      13.773070
    [460]       13.489322      12.558281      11.513227      11.123240
    [464]       11.859980      13.301201      14.687777      15.510018
    [468]       15.482502      14.382889      11.955078      8.2578716
    [472]       6.6990061      9.2176847      11.065219      11.454432
    [476]       10.679821      9.1597118      7.5184059      6.4907932
    [480]       6.6153321      7.8492713      9.3505554      10.280948
    [484]       10.191208      8.7266531      5.1452761     -2.2471809
    [488]       2.0246153      8.2853069      11.689996      13.677707
    [492]       14.769520      15.195032      15.093037      14.614248
    [496]       13.998524      13.583699      13.643578      14.153468
    [500]       14.802794      15.201295      14.996367      13.850353
    [504]       11.321362      6.8317285      4.2840543      8.8910103
    [508]       12.234690      14.045543      14.948080      15.333693
    [512]       15.435246
  [Tag]         8641
  [frame_len]          320
[Record 55]
  [tot_power]       275380.69
  [re_spec_val]
    [0]       21.860909      21.353899      19.830647      17.357100
    [4]       14.424214      12.370349      11.553774      10.518761
    [8]       8.7608261      7.7560291      8.3420353      8.2239456
    [12]       6.7489691      9.9614983      15.680907      19.620949
    [16]       21.975786      23.068312      23.057940      22.000351
    [20]       19.890842      16.726652      12.738382      9.1094151
    [24]       7.6817956      7.6716661      7.0991235      6.3598018
    [28]       11.622849      17.846338      22.244034      25.153296
    [32]       26.864746      27.522430      27.175735      25.802263
    [36]       23.311279      19.561794      14.648022      10.547250
    [40]       9.6580343      9.1625805      8.0612764      6.9449501
    [44]       5.8822656      5.7360611      8.9287748      13.064608
    [48]       16.188553      18.163120      19.092783      19.035727
    [52]       17.988626      15.904679      12.751478      8.6969414
    [56]       4.2162609     -1.7676874     -19.382595     0.31946746
    [60]       5.0816212      6.3413181      5.2015457      3.3572209
    [64]       5.9081764      9.6533728      11.959065      12.995910
    [68]       13.033695      12.133381      10.065140      6.1883216
    [72]      0.33029392      1.6713823      4.5874095      4.0258241
    [76]      -1.4455652     -3.9279313      5.7012663      10.088310
    [80]       12.651508      14.353537      15.441093      15.856244
    [84]       15.442246      13.985847      11.140554      6.5116439
    [88]       3.5047536      6.1554160      7.0522065      5.2447295
    [92]       7.3105512      13.255603      17.445759      20.849771
    [96]       24.529728      28.251764      31.342052      33.503700
    [100]       34.684666      34.900928      34.181080      32.569782
    [104]       30.160452      27.128128      23.717739      20.388975
    [108]       18.319515      17.698917      16.800781      15.955368
    [112]       18.220142      21.745279      24.489029      26.420063
    [116]       27.671850      28.227480      27.995174      26.882000
    [120]       24.831396      21.915379      18.615852      15.812901
    [124]       13.133014      8.3246212      3.2917082      10.888875
    [128]       15.042481      17.085432      18.309776      19.542322
    [132]       20.954683      22.161369      22.784994      22.629257
    [136]       21.597055      19.664581      17.083654      14.893490
    [140]       13.990002      13.047967      10.245034      2.6577375
    [144]      0.14057307      8.6013374      11.259179      11.716936
    [148]       11.368393      11.425595      11.941637      12.010234
    [152]       11.146071      9.6845407      9.0569897      9.7914371
    [156]       10.326789      9.7406073      8.1563425      7.1693292
    [160]       8.3417063      9.9883013      11.117217      12.157784
    [164]       13.656826      15.406047      16.856575      17.700512
    [168]       17.857912      17.377312      16.438404      15.363689
    [172]       14.385324      13.230867      11.123685      6.7423105
    [176]      -2.6158249      3.9187095      9.0238266      11.281789
    [180]       12.712892      14.294648      15.956093      17.198437
    [184]       17.767855      17.660027      17.003569      15.988002
    [188]       14.768804      13.379564      11.802363      10.183270
    [192]       8.8754292      8.0262566      7.3502092      6.4870377
    [196]       5.0410991      2.3282456    -0.91311824      3.0164566
    [200]       7.8991108      10.834421      12.295501      12.601364
    [204]       11.950050      10.615549      9.2504835      8.7292175
    [208]       8.8763056      8.6934404      7.5100842      4.9064174
    [212]      0.36838880     -4.6539631     -1.0664700      3.4859838
    [216]       6.8978357      9.5970097      11.716825      13.298265
    [220]       14.361431      14.939883      15.113739      14.980696
    [224]       14.514767      13.406050      10.954984      5.6755800
    [228]       2.8545454      10.529706      14.908941      17.587408
    [232]       19.411127      20.691616      21.498999      21.821520
    [236]       21.645885      20.981089      19.896261      18.646807
    [240]       17.757168      17.504477      17.373299      16.717955
    [244]       15.429899      14.313558      14.542298      15.564204
    [248]       16.355820      16.782614      17.060122      17.219461
    [252]       17.044418      16.350105      15.252666      14.337822
    [256]       14.156191      14.242129      13.683145      11.768620
    [260]       7.5083389     -1.6705496      3.7423983      9.4682522
    [264]       12.336878      14.069221      15.241130      16.024878
    [268]       16.467915      16.642271      16.670042      16.645164
    [272]       16.528114      16.122141      15.112123      13.014023
    [276]       8.7359028     -3.1806471      4.5836248      11.275575
    [280]       14.168028      15.367661      15.530038      15.075051
    [284]       14.416941      13.891274      13.546627      13.191454
    [288]       12.710468      12.340921      12.577546      13.379508
    [292]       14.012348      13.817121      12.440884      10.193861
    [296]       10.023512      12.875961      15.367473      16.751184
    [300]       17.187145      16.855381      15.880123      14.384205
    [304]       12.623947      11.035513      9.7205839      8.0010977
    [308]       5.4030066      4.9805117      8.3535118      10.999533
    [312]       12.179550      12.274588      11.863711      11.590959
    [316]       11.644374      11.665543      11.346631      10.687982
    [320]       9.9670582      9.7338896      10.564986      12.292898
    [324]       14.083954      15.278563      15.554834      14.831853
    [328]       13.561998      13.421517      15.066490      16.732117
    [332]       17.534061      17.431644      16.638731      15.552945
    [336]       14.688151      14.307812      14.346918      14.911044
    [340]       16.134287      17.576811      18.586786      18.774652
    [344]       18.013084      16.573431      15.755281      16.753666
    [348]       18.236090      19.012058      18.861723      17.885769
    [352]       16.315992      14.472795      12.662451      11.353141
    [356]       11.497603      12.921992      14.187090      14.496881
    [360]       13.615146      11.628215      9.8749533      10.895070
    [364]       13.007727      14.296962      14.553178      13.959795
    [368]       12.838546      11.677626      11.074070      11.455300
    [372]       12.548562      13.484023      13.491886      11.934341
    [376]       7.5833244     -6.9611382      5.0780497      10.715935
    [380]       12.863227      13.416506      13.141754      12.660533
    [384]       12.506878      12.855764      13.435492      13.816628
    [388]       13.663250      12.816225      11.441870      10.397404
    [392]       10.605644      11.309726      11.351408      10.224514
    [396]       7.7444448      4.3509207      3.0077114      4.4467812
    [400]       5.4678435      5.4584970      4.7658548      3.8306124
    [404]       2.8631456      2.0423982      2.7255661      5.4467721
    [408]       8.0768814      9.4906263      9.3878164      7.3916016
    [412]       2.2137325     -8.7906475      2.1032634      6.4452615
    [416]       7.9984059      8.1011925      7.3297911      6.1142721
    [420]       4.8480268      3.9059904      3.8296144      4.9596596
    [424]       6.6065297      7.9471097      8.7964649      9.4197607
    [428]       10.074780      10.601511      10.605823      9.8936014
    [432]       8.7907429      8.2921133      8.8834019      9.8079958
    [436]       10.525709      10.905323      10.778687      10.054648
    [440]       9.4275284      10.302877      12.001842      12.950325
    [444]       12.537243      10.479948      6.3334007     0.11966644
    [448]      0.81612444      4.8654470      7.4704103      8.9945803
    [452]       9.3977518      8.6093645      6.8129501      4.8747063
    [456]       4.6498528      7.0014672      10.346652      13.237842
    [460]       15.210145      16.198294      16.201302      15.159893
    [464]       12.875893      8.8533163      1.7690574     -5.9194961
    [468]     -0.58816916      1.7524124      4.0885463      6.5062103
    [472]       7.5632010      6.4760489      1.6300771     -16.863281
    [476]       4.2262406      9.3054533      11.563327      12.318692
    [480]       12.010934      10.854145      9.0475645      6.9268026
    [484]       4.9135175      3.1182768      1.4894855     0.71446234
    [488]       1.3021393      2.2179780      2.7149451      2.8098259
    [492]       2.6524537      2.2345271      1.5743846     0.97363389
    [496]      0.93720156      1.7329639      2.9392929      3.6310024
    [500]       2.8807464    -0.11684362     -1.1540540      4.3924952
    [504]       7.9872217      9.3503494      8.7994852      6.1974816
    [508]      0.80809188     -5.9875822     -2.8148503     -1.1763705
    [512]      -1.1104966
  [Tag]         8801
  [frame_len]          320
[Record 56]
  [tot_power]       273877.94
  [re_spec_val]
    [0]       20.539751      19.959187      18.143854      14.808332
    [4]       9.1094580     -1.5366613      1.4156716      5.2591853
    [8]       5.7591872      4.5942292      1.5572295     -11.591652
    [12]       3.8374100      12.545941      17.577065      20.735222
    [16]       22.532265      23.172546      22.737270      21.242535
    [20]       18.672972      15.031134      10.413751      4.9029980
    [24]      -2.2683761     -7.7055650     -2.0761788      1.7280911
    [28]       3.9295347      3.5224860     -3.5698371      6.3409047
    [32]       14.893419      19.702662      22.564589      24.032621
    [36]       24.329721      23.544470      21.695923      18.775127
    [40]       14.836572      10.327853      6.7219791      5.2656794
    [44]       5.0309858      5.1200361      5.3048391      5.8045983
    [48]       7.4376597      10.342332      13.289355      15.447266
    [52]       16.599537      16.722719      15.809013      13.803823
    [56]       10.546314      5.6786971    0.049746282      2.2329443
    [60]       6.3873901      9.1225538      10.791589      11.522101
    [64]       11.305923      10.369173      10.184567      12.328489
    [68]       15.005965      16.796230      17.447376      16.919735
    [72]       15.108274      11.757038      6.5591011      1.9514869
    [76]       2.6679583      2.6318042     0.22034861     -4.0353708
    [80]      -8.0716238     -11.584042     -19.905731     -7.7898774
    [84]      0.90899730      6.5201335      10.261518      12.579035
    [88]       13.749156      14.006033      13.547371      12.374868
    [92]       9.9666595      4.4800615     -6.2800798      6.7935553
    [96]       11.905930      15.222596      17.863314      19.816326
    [100]       21.638672      24.691460      28.590038      31.954082
    [104]       34.295815      35.579609      35.846447      35.124626
    [108]       33.423462      30.763092      27.251747      23.138191
    [112]       18.317963      10.268956      2.0369489      13.586020
    [116]       16.328394      16.321613      15.828444      17.923340
    [120]       21.132349      23.518345      24.883123      25.316244
    [124]       24.868660      23.559462      21.436567      18.659874
    [128]       15.549706      12.487808      9.9276180      8.5074253
    [132]       8.3977213      9.7477398      12.146049      14.359591
    [136]       16.041821      17.635796      19.460228      21.188181
    [140]       22.346764      22.691488      22.141453      20.683067
    [144]       18.360531      15.381182      12.345098      10.052394
    [148]       8.3321075      6.0989661      2.5309923     0.90257895
    [152]       4.9238968      8.0513763      9.7018471      10.723545
    [156]       11.867363      13.144938      14.045691      14.191315
    [160]       13.397870      11.495042      8.1734819      3.4682803
    [164]       2.8759336      6.2399626      7.9899821      7.9910197
    [168]       6.4785194      4.1138983      4.5799437      8.7065973
    [172]       12.564864      15.387183      17.230488      18.188435
    [176]       18.343529      17.762199      16.465023      14.353481
    [180]       11.061111      5.4941549     -7.6848049     -1.7410092
    [184]       2.3423183      1.1319199     -8.1741314     -2.4939418
    [188]       6.4251170      10.937471      13.881202      15.899545
    [192]       17.206554      17.933947      18.230223      18.230675
    [196]       17.953016      17.245777      15.856991      13.532460
    [200]       10.140753      6.2069073      3.6982014      2.9069233
    [204]       2.4102137      2.3082099      2.5651197      3.8924057
    [208]       7.1066389      10.392406      12.650803      13.844769
    [212]       14.198969      13.941339      13.102884      11.319089
    [216]       7.6136537    -0.82323682     0.43499511      6.1367626
    [220]       6.8468094      3.1940203     -4.9400835      6.9782491
    [224]       12.612977      15.991024      18.305304      19.874966
    [228]       20.795111      21.185490      21.235441      21.058548
    [232]       20.496925      19.122776      16.284302      10.630822
    [236]      -2.7508557      5.6829801      8.4617434      8.0202131
    [240]       10.714789      15.366922      18.603571      20.491743
    [244]       21.388220      21.559839      21.225716      20.577204
    [248]       19.722971      18.600496      16.968878      14.478838
    [252]       10.703507      5.2506924  -0.0091065951    -0.46231958
    [256]     -0.50379509     0.61504567      3.6571109      6.3908505
    [260]       8.6008444      10.627215      12.455427      13.938457
    [264]       15.056451      15.844460      16.224602      15.959410
    [268]       14.700812      11.962557      6.9408684     0.75025976
    [272]       2.9025190      3.6006234     0.91988599      3.5225267
    [276]       8.9139385      11.949111      13.345510      13.760768
    [280]       13.727559      13.628837      13.557751      13.379898
    [284]       12.893790      11.834324      9.8105936      6.5496578
    [288]       4.7729721      7.7995715      10.398168      11.352901
    [292]       11.031216      10.338958      10.741778      12.198392
    [296]       13.472377      14.080811      14.072989      13.678252
    [300]       13.280422      13.362876      14.000089      14.616929
    [304]       14.556315      13.329432      10.366059      4.4064655
    [308]      -1.0806959      5.2358580      8.1080046      9.1347790
    [312]       9.7908344      10.858977      12.151028      13.205498
    [316]       13.823887      13.996038      13.782157      13.276483
    [320]       12.593382      11.833264      11.076422      10.524201
    [324]       10.630476      11.596946      12.886713      13.878568
    [328]       14.306452      14.173177      13.687748      13.302582
    [332]       13.561058      14.558347      15.866798      17.048664
    [336]       17.827274      17.986403      17.271679      15.277274
    [340]       11.096112      1.5340128      4.1878252      9.7921801
    [344]       11.028440      10.130705      9.9138155      12.801765
    [348]       15.836229      17.841455      18.996792      19.595592
    [352]       19.861238      19.901777      19.686981      19.058689
    [356]       17.752350      15.360454      11.066186      1.9975770
    [360]      0.32036853      7.5321512      9.8386745      10.785304
    [364]       11.931965      13.609660      15.260739      16.560772
    [368]       17.525368      18.250982      18.759529      18.958553
    [372]       18.671900      17.673870      15.685098      12.351958
    [376]       7.7148871      5.7591224      7.5217600      8.0482502
    [380]       6.9265065      5.3582420      5.6267524      7.2976050
    [384]       8.6770687      9.3611641      9.2602625      8.1486502
    [388]       5.5691690     0.52771205     -8.0506754     -4.1008220
    [392]      -1.3517302     -1.7883178     -1.8853761     0.94642699
    [396]       3.4947624      4.7116227      5.0119781      5.1447792
    [400]       5.7346697      6.7635579      7.9164715      9.0339975
    [404]       10.050848      10.880526      11.401802      11.459596
    [408]       10.843912      9.2393570      6.0631838    -0.26180631
    [412]      -9.7196617    -0.75353843      1.8583910      1.1918834
    [416]      -1.5202830     -1.8186826      1.5332111      4.0985832
    [420]       5.7530117      7.0763626      8.4224510      9.8963156
    [424]       11.313766      12.246872      12.206409      10.617487
    [428]       6.2399321     -8.2285109      3.2231143      8.4244528
    [432]       9.7156239      8.7698164      6.1717730      3.7675917
    [436]       4.9172716      7.6555085      10.221968      12.443475
    [440]       14.292533      15.727754      16.617683      16.710218
    [444]       15.623232      12.652705      5.7695727      3.1374221
    [448]       10.652611      13.240684      13.171488      10.574009
    [452]       3.0492761    -0.84841752      9.9722109      14.233871
    [456]       16.646254      18.121002      18.954052      19.212391
    [460]       18.822889      17.579693      15.075769      10.389438
    [464]       1.7953676      5.7332039      10.048327      11.091977
    [468]       9.9614506      6.4645433     -1.9788113   -0.046094660
    [472]       7.6061382      11.215383      13.108768      14.030959
    [476]       14.442993      14.616532      14.471171      13.611678
    [480]       11.470462      7.1470675     0.52205235      4.1609316
    [484]       7.7135124      8.3503494      6.5010381     0.56718940
    [488]      -9.7279863      5.4080396      10.497466      13.198743
    [492]       14.551474      14.891913      14.366335      13.032367
    [496]       10.836539      7.5107055      2.8519878      2.0225518
    [500]       6.3732047      9.3727694      10.884407      11.253859
    [504]       10.681861      9.3605700      7.6630893      6.2151470
    [508]       5.2979712      4.3189325      2.4530582    -0.86107987
    [512]      -3.7587466
  [Tag]         8961
  [frame_len]          320
[Record 57]
  [tot_power]       290931.56
  [re_spec_val]
    [0]       24.393864      23.879946      22.296444      19.503380
    [4]       15.210778      8.9063635     0.71457386     -3.9240882
    [8]      -9.9354448     -10.699780     -3.8700082     0.25955847
    [12]       6.8239622      12.696295      17.061050      20.177460
    [16]       22.240931      23.340872      23.500490      22.698961
    [20]       20.882750      17.991205      14.088698      9.9029455
    [24]       7.2406325      6.2893386      5.7486496      5.5158954
    [28]       6.2237501      7.2489223      6.5691843     0.89286757
    [32]       5.6694751      14.452127      19.082518      21.614752
    [36]       22.647903      22.373289      20.776934      17.632107
    [40]       12.291695      3.5529575      3.1915057      6.0053391
    [44]       5.7225285      4.2093310      3.8366497      5.2399936
    [48]       6.4171672      6.1354666      3.8401103      2.2466147
    [52]       6.7779422      10.615274      12.563671      13.048245
    [56]       12.362198      10.728824      8.3562822      5.2949190
    [60]      0.99993438     -6.6794982     -12.335997     -4.8520350
    [64]      -2.7915750     -2.1283970     0.12372318      4.2268867
    [68]       8.5351419      12.242253      15.084101      16.996552
    [72]       17.983416      18.060064      17.235001      15.511511
    [76]       12.906014      9.4891996      5.4578085      1.2327826
    [80]      -2.5831351     -5.9113317     -7.3745470     -3.0267842
    [84]       1.2717819      3.6198459      3.9706962      1.6105722
    [88]      -7.1094513      1.4788145      8.8599815      12.712685
    [92]       14.728987      15.420828      15.060911      13.996442
    [96]       12.904976      12.654484      13.291039      13.898307
    [100]       13.579157      11.794811      9.5225906      13.060036
    [104]       19.658932      25.374153      29.858995      33.151279
    [108]       35.339893      36.502514      36.687271      35.909740
    [112]       34.153221      31.369286      27.482086      22.406378
    [116]       16.027208      7.1650000     -6.2656088      9.2099695
    [120]       13.715464      15.439833      15.422585      14.873966
    [124]       16.238222      19.014858      21.182611      22.287016
    [128]       22.371979      21.497875      19.680819      16.917673
    [132]       13.219769      8.4804726      1.8386940     -1.3500414
    [136]       4.1830850      6.2248278      4.7925749     -3.1915507
    [140]     -0.20556346      8.8172207      13.218828      16.144156
    [144]       18.329130      19.881021      20.713394      20.727831
    [148]       19.847254      17.999231      15.091137      10.950690
    [152]       5.0303974     -5.0053177     -3.3293664      2.3158636
    [156]       4.1850047      3.8801124      2.1590817      2.8931112
    [160]       7.8603930      12.354624      15.567151      17.643330
    [164]       18.718325      18.903645      18.336132      17.216763
    [168]       15.757345      13.955386      11.391837      7.1880846
    [172]     -0.31037661     -2.7709622      1.9725062      3.3241212
    [176]       2.8671489     0.60465026     -1.4866766      5.5546632
    [180]       11.174003      14.455308      16.078243      16.399511
    [184]       15.697049      14.365417      12.894428      11.296368
    [188]       8.7247972      3.6730690     -3.4143057      1.2118340
    [192]       2.4414415     -2.8035626     -4.8164196      6.5017238
    [196]       11.321298      14.239039      16.301510      17.787287
    [200]       18.670073      18.885405      18.450491      17.488760
    [204]       16.178762      14.593952      12.550517      9.6335039
    [208]       5.2052860     -2.1208136     -9.8557472     -2.9360487
    [212]       1.9926387      7.5950980      12.907332      17.110193
    [216]       20.158442      22.150560      23.168428      23.265203
    [220]       22.485193      20.899696      18.636845      15.791869
    [224]       12.075325      6.7053909      4.4452028      7.9754515
    [228]       8.6307096      5.7686124      7.7060957      14.502006
    [232]       18.706453      21.140814      22.360855      22.618587
    [236]       22.008408      20.515306      18.025990      14.389935
    [240]       10.127376      8.3874197      8.8079548      7.7597699
    [244]       3.7337234     -1.4250735      4.4613242      7.8626261
    [248]       8.5843258      7.5050740      6.0010920      6.7641492
    [252]       8.8049936      10.010342      10.034294      9.0574389
    [256]       7.4786325      5.7416081      3.5599682    -0.84311455
    [260]      -17.640308     -2.2921329      2.8545511      3.6287699
    [264]      0.19357759     -12.424209      4.0272217      9.9422464
    [268]       13.025204      14.629516      15.236209      15.079035
    [272]       14.284040      12.918096      11.018539      8.6168747
    [276]       5.7434611      2.3736041     -1.8092171     -8.3516150
    [280]      -13.511186     -4.0530076     0.44901603      2.3642488
    [284]       2.1517429    -0.51759481     -2.3538666      3.9040434
    [288]       8.8561010      11.999291      13.926641      14.900859
    [292]       15.008791      14.248576      12.590827      10.081248
    [296]       7.0278311      3.8080490    -0.56043935     -4.7943969
    [300]       2.6510243      7.3747401      9.5585585      9.9516525
    [304]       8.7040005      5.3941021     -1.9414287    -0.53968549
    [308]       7.0480204      11.099225      13.531979      14.929722
    [312]       15.497682      15.286517      14.274796      12.486123
    [316]       10.299793      8.7360306      8.0830717      6.9986811
    [320]       4.1093659     -2.8143537     -15.111962     -1.2488365
    [324]       2.2480679      3.8617527      5.1978688      6.5545702
    [328]       7.6093159      8.0737963      7.8282332      6.9330444
    [332]       5.9790101      6.4151349      8.3632135      10.247575
    [336]       11.248760      11.182457      10.122573      8.6913404
    [340]       8.5489998      10.248472      12.473738      14.602137
    [344]       16.461494      17.855076      18.593328      18.551414
    [348]       17.676147      16.021194      13.843223      11.561411
    [352]       9.3155069      7.5714068      8.6963854      11.395745
    [356]       13.068819      13.197862      11.661978      8.4045601
    [360]       6.1391797      9.1772966      12.124015      13.636083
    [364]       13.986611      13.372494      11.971155      10.294823
    [368]       9.4332008      9.5972853      9.5263834      8.2005091
    [372]       4.8145242     -1.5652220     0.45864403      5.9098911
    [376]       8.8200979      10.286230      10.715250      10.233191
    [380]       8.9972382      7.5707483      7.0059834      7.3844819
    [384]       7.5610685      6.6646128      4.1160507   -0.059488460
    [388]      0.30078542      3.9331172      5.5172539      4.9967461
    [392]       2.2673593     -2.9847946     -3.0916266      1.7137815
    [396]       4.4632926      5.8841691      6.5637007      6.8012743
    [400]       6.6997700      6.2048941      5.2310801      3.8852139
    [404]       2.5578628      1.3109462    -0.79919839     -4.5941162
    [408]      -2.8497055      2.3536460      5.1848683      5.9833245
    [412]       4.8684406      1.2751729     -6.4027929     -2.5092556
    [416]       2.9776788      5.4877439      6.5650444      6.8834863
    [420]       6.8064280      6.4946623      5.9256539      4.9382615
    [424]       3.5453722      3.2173910      5.7115278      8.6597939
    [428]       10.392539      10.471951      8.2764692      2.0027196
    [432]       4.9197354      12.108747      15.924318      18.077095
    [436]       19.227613      19.710793      19.748676      19.516499
    [440]       19.111256      18.438885      17.137472      14.525785
    [444]       9.1023302      1.5941986      9.8246136      13.285872
    [448]       13.609222      11.152511      6.6647320      11.027256
    [452]       15.933597      18.550722      19.720245      19.915220
    [456]       19.484800      18.834002      18.389679      18.211143
    [460]       17.822124      16.574278      13.751091      8.0486889
    [464]       1.7534834      7.7162342      9.8353167      8.6845303
    [468]       5.3631077      7.0501227      11.451584      13.993752
    [472]       15.085653      15.206178      14.683057      13.736150
    [476]       12.434842      10.605423      7.7442536      3.3302355
    [480]       2.7501142      7.3517246      10.013858      10.541782
    [484]       8.8528204      4.6392140      5.7433643      11.332803
    [488]       14.582934      16.136639      16.495943      15.938153
    [492]       14.664085      12.873116      10.824978      8.8731565
    [496]       7.2111816      5.3290925      1.8704220     -6.0132394
    [500]      -2.7529926      3.4373295      5.7040687      5.6231337
    [504]       3.3279817     -2.3058290     -13.713520     -3.2362504
    [508]      0.59119993      1.6512132      1.2923912     0.29144907
    [512]     -0.28889441
  [Tag]         9121
  [frame_len]          320
[Record 58]
  [tot_power]       285551.75
  [re_spec_val]
    [0]       16.987181      16.184431      13.874270      11.434604
    [4]       12.158968      13.959579      14.562115      13.783881
    [8]       11.700972      8.2235193      2.6100650     -10.491796
    [12]      -5.8146677    -0.58349800      2.3349917      8.8010044
    [16]       14.674646      18.776373      21.408625      22.818075
    [20]       23.142189      22.457483      20.827913      18.370001
    [24]       15.328889      12.013496      8.3346624      2.9067469
    [28]      -10.740145      3.3859308      8.9973068      10.677970
    [32]       8.2974167     -5.8875232      12.660097      19.216871
    [36]       22.549654      24.045099      24.099939      22.801191
    [40]       20.039602      15.478809      8.6216545      2.4010117
    [44]       1.6298093     0.69931078      3.1294365      5.1388259
    [48]       3.9902687     -3.5138907     -2.8202417      6.7870665
    [52]       10.695852      12.694268      13.821992      14.616996
    [56]       15.275094      15.700838      15.696980      15.110125
    [60]       13.866972      11.992130      9.6753664      7.3211565
    [64]       5.2501884      3.1848607     0.40854192     -4.0984368
    [68]      -14.775023     -10.324542    -0.89630640      4.4009404
    [72]       8.1172409      10.737295      12.430285      13.291323
    [76]       13.404904      12.882678      11.897264      10.673799
    [80]       9.3610964      7.8497739      5.7728209      2.6150663
    [84]      -2.3542559     -8.1048098     -4.1913886    0.068726040
    [88]       2.4103160      3.3788371      3.4433413      3.3375430
    [92]       3.5736902      3.7589800      3.4173129      2.7415657
    [96]       2.4631000      2.8543391      2.9971502      1.6158426
    [100]      -1.0217273      1.3752007      4.0731053      2.1091080
    [104]      -6.0895658      7.2170749      13.197029      18.528709
    [108]       24.369909      29.324007      32.959667      35.356804
    [112]       36.635883      36.871777      36.087086      34.250683
    [116]       31.266462      26.949232      21.065918      14.591176
    [120]       12.633635      12.514503      10.860818      6.8776088
    [124]      -3.4001105     -1.3644872      5.7330570      7.7152238
    [128]       8.4106655      11.029352      14.794600      17.598228
    [132]       19.081120      19.311146      18.354528      16.286997
    [136]       13.494543      11.340668      10.835452      10.589430
    [140]       9.5409060      7.6052008      5.1849856      3.4731958
    [144]       4.9464440      9.2488403      13.656487      17.203087
    [148]       19.737494      21.258144      21.767822      21.237434
    [152]       19.594902      16.758852      12.941259      9.7007265
    [156]       8.3688946      6.6405029      3.1294291      1.5724837
    [160]       4.2804174      5.8084621      5.7056952      4.6332936
    [164]       5.4374094      10.260644      14.961838      18.293240
    [168]       20.344156      21.259632      21.128220      19.998425
    [172]       17.914360      14.975850      11.396192      7.3663197
    [176]       2.6361618     -2.7910581     -2.1040237      3.0540376
    [180]       6.8846145      8.9348431      9.1626606      8.7512550
    [184]       11.833800      16.377060      19.622810      21.477854
    [188]       22.132883      21.708298      20.274149      17.934103
    [192]       15.020627      12.275298      10.117447      7.7773867
    [196]       4.3697996     0.71352321      2.2243669      7.3162766
    [200]       12.167241      16.047602      18.851749      20.626154
    [204]       21.433666      21.314369      20.277393      18.302202
    [208]       15.355166      11.461951      6.9406834      3.0083632
    [212]       2.4831989      5.1065364      7.8034282      10.246707
    [216]       13.115175      16.267715      19.037216      21.072662
    [220]       22.299070      22.728458      22.379742      21.250061
    [224]       19.289993      16.342798      11.938506      4.2396145
    [228]      -6.8973203      5.4172058      9.1682310      10.548061
    [232]       10.479893      9.1436853      6.5209041      3.1672904
    [236]       2.4502945      4.3331146      5.0699768      3.5587299
    [240]      0.89489019      5.2791748      10.299460      13.215732
    [244]       14.558178      14.654202      13.661715      11.674341
    [248]       8.9138327      6.3455706      5.6574807      6.2669072
    [252]       6.6251478      6.2781777      5.1080313      2.5852757
    [256]      -3.4124899     -3.8479533      5.2999663      10.006368
    [260]       12.634261      13.860061      13.901052      12.786192
    [264]       10.415084      6.5582404     0.95350522     -4.9537582
    [268]      -4.7863588     -1.1717101      2.1546512      4.2278824
    [272]       5.0823789      5.2201762      5.4291992      6.1386757
    [276]       7.0083022      7.6756110      8.1562548      8.6062536
    [280]       8.9812851      8.9531021      8.0605869      5.7398691
    [284]       1.1906220     -3.0598135     0.68630618      2.6600962
    [288]       1.6457098     -1.7331190    -0.35919452      4.1660581
    [292]       6.6060929      7.1557198      5.7024932     0.44903705
    [296]      -5.8466353      6.8858523      12.190395      15.046325
    [300]       16.408396      16.592089      15.730223      13.926850
    [304]       11.413469      8.7247572      6.4951386      5.0787115
    [308]       4.9977632      5.8056679      5.9793262      4.8051496
    [312]       3.8784299      6.6236234      9.9889965      12.099584
    [316]       13.065206      13.220480      12.923244      12.484926
    [320]       12.024333      11.446158      10.608627      9.4443064
    [324]       7.9344606      6.0331407      3.7317674      1.5800823
    [328]       1.0903685      2.2094429      3.4675393      4.5891881
    [332]       6.0260973      8.0392132      10.374755      12.611689
    [336]       14.440628      15.699666      16.352068      16.470932
    [340]       16.206821      15.670213      14.756501      13.108851
    [344]       10.331155      7.3767042      8.5970802      11.416379
    [348]       13.023124      13.530966      13.482738      13.514599
    [352]       13.967919      14.615393      15.052488      15.009497
    [356]       14.305728      12.721781      9.8350849      4.5094543
    [360]      -9.2214060    -0.79183537      3.9048910      4.4420562
    [364]       1.8967166     -6.9538631     -5.4662266      3.3359408
    [368]       6.9869123      8.8677092      9.8699627      10.421520
    [372]       10.726748      10.873576      10.979878      11.201273
    [376]       11.507930      11.587364      11.041700      9.5244284
    [380]       6.7936234      3.7327733      4.4591994      7.1999698
    [384]       8.8710527      9.2650051      8.4880819      6.5682845
    [388]       3.8786314      3.2789159      6.2805142      9.2694321
    [392]       11.231261      12.210774      12.306819      11.608440
    [396]       10.247522      8.4418793      6.3845310      3.8937390
    [400]      0.12886897     -7.1234779     -17.273230     -6.2908235
    [404]      -2.1542785      1.3693349      4.5376844      6.7477102
    [408]       7.9758739      8.6560078      9.4790583      10.727439
    [412]       11.955875      12.695292      12.818635      12.486944
    [416]       12.060092      11.849530      11.800693      11.611806
    [420]       11.068496      10.156424      9.0601254      8.1502924
    [424]       7.8544030      8.4676876      10.109475      12.498243
    [428]       14.964769      16.944263      18.129818      18.348118
    [432]       17.453718      15.323770      12.249836      10.327530
    [436]       10.628565      10.300704      8.2699261      7.5484376
    [440]       11.183475      14.491207      16.638239      18.098654
    [444]       19.242163      20.203903      20.946291      21.372984
    [448]       21.382936      20.862988      19.662493      17.574823
    [452]       14.393098      10.603271      9.1619167      9.6649895
    [456]       8.4215775      2.6622126     -1.2401991      9.2803097
    [460]       13.520408      15.522051      16.281446      16.242207
    [464]       15.656154      14.663949      13.361196      11.921369
    [468]       10.676174      9.8435698      9.0953503      7.7528415
    [472]       5.1177130     0.27765727     -7.8287730     -8.5335855
    [476]      -8.9654799     -16.523506     -2.4741390      3.6613343
    [480]       7.0826354      9.2871304      10.911897      12.178904
    [484]       13.058645      13.463859      13.356442      12.741331
    [488]       11.603433      9.8663549      7.5470219      5.4722719
    [492]       5.2900839      6.1534314      6.4673324      6.2364717
    [496]       6.4850364      7.7168813      9.1536169      10.194385
    [500]       10.697920      10.586906      9.6716127      7.5992994
    [504]       3.6780710     -3.5592258     -3.9306090      1.2575541
    [508]       3.0906820      2.8338215     0.74090505     -3.8396382
    [512]      -10.215447
  [Tag]         9281
  [frame_len]          320
[Record 59]
  [tot_power]       262627.69
  [re_spec_val]
    [0]       20.711201      20.175777      18.496960      15.398919
    [4]       10.079432     -1.1317726     -1.5763525      4.1796174
    [8]       4.9632177      4.3106298      4.1440129      4.6036549
    [12]       3.8234968     -1.2612791     0.59599131      10.304873
    [16]       15.326365      18.106422      19.309731      19.141954
    [20]       17.627535      14.809493      11.635373      10.808439
    [24]       11.343550      10.843352      8.9293661      6.0622292
    [28]       3.6291249      3.2183719      3.9391842      4.1167655
    [32]       7.6580200      14.805865      20.474575      24.482965
    [36]       27.182066      28.788467      29.415915      29.110815
    [40]       27.867533      25.629684      22.280943      17.637983
    [44]       11.569877      5.1004391      1.8281056      2.2705953
    [48]       5.4983335      8.9867096      11.801239      13.978759
    [52]       15.584765      16.631054      17.100096      16.937401
    [56]       16.028290      14.166003      10.972180      5.6355686
    [60]      -2.6861498    -0.41364694      2.8480334      3.5231407
    [64]       3.0415745      2.3796070      2.2140687      2.7960808
    [68]       4.1235356      6.1081867      8.5056906      10.937731
    [72]       13.046964      14.580316      15.379823      15.350914
    [76]       14.451890      12.741048      10.520296      8.3663521
    [80]       6.3961706      3.6976926    -0.60086691     -2.3892200
    [84]      0.51780701      1.4182910    -0.78282326     -8.4847097
    [88]      -4.1704183      3.6762056      8.1432934      11.117601
    [92]       12.991570      13.858058      13.800847      12.980564
    [96]       11.634401      9.9802256      8.2682352      7.2242441
    [100]       7.4527202      8.1875000      8.7516165      9.3852282
    [104]       10.615365      11.839803      10.969350      4.2105489
    [108]       16.401762      24.690739      29.702196      32.878063
    [112]       34.695507      35.348885      34.904167      33.339352
    [116]       30.540682      26.262718      20.074080      12.037127
    [120]       6.9553013      1.5810399     -5.5974407      5.9465461
    [124]       8.7603579      8.8329840      8.6131811      10.992108
    [128]       14.648138      17.739645      19.934824      21.201788
    [132]       21.512051      20.815256      19.039520      16.116131
    [136]       12.129765      7.7412558      3.5989974     -3.0532374
    [140]      -5.0717688      4.3987617      8.9462547      11.707516
    [144]       13.477213      14.631183      15.913826      18.208883
    [148]       21.077032      23.516954      25.085041      25.677135
    [152]       25.269136      23.830753      21.304459      17.609169
    [156]       12.659511      6.3295827     -1.7216133     -8.3590565
    [160]      -10.951315     -1.2905194      6.6726208      11.112863
    [164]       13.681532      15.637641      17.982962      20.529066
    [168]       22.534334      23.621683      23.681957      22.666588
    [172]       20.507221      17.135717      12.833755      9.4417934
    [176]       8.5058489      8.5745697      9.9041758      12.222606
    [180]       14.522992      16.821932      19.363626      21.895508
    [184]       23.992533      25.411949      26.067652      25.939993
    [188]       25.033918      23.373159      21.015299      18.075705
    [192]       14.733753      11.211263      7.8431444      5.1942029
    [196]       3.7186382      4.4928036      8.2224226      12.535119
    [200]       16.181700      19.025846      21.099327      22.414951
    [204]       22.956129      22.684044      21.539034      19.436832
    [208]       16.271097      11.984184      7.0160427      3.2581623
    [212]       1.4819885     0.29194400     0.61841810      3.1973007
    [216]       6.4482098      9.2351427      11.164478      12.122520
    [220]       12.099446      11.143607      9.3665133      6.9231453
    [224]       3.9390934      1.1295218      1.3394531      3.5870538
    [228]       4.8856435      4.6478639      2.9172451     0.62234467
    [232]      0.88351852      2.9609382      4.0609961      3.6181107
    [236]       1.8506240     0.72380656      2.2342050      3.3710790
    [240]       1.8711821     -5.7228470     0.17135374      8.0519934
    [244]       11.875776      13.681427      14.033692      13.140941
    [248]       11.150926      8.4642582      6.1037426      4.8451943
    [252]       4.2237487      3.9367881      3.5935903      2.3264201
    [256]      0.48894742      1.9006530      4.9015684      6.3372421
    [260]       5.9440212      4.2228847      3.6115129      5.8227525
    [264]       8.1482477      9.6474018      10.535715      11.089134
    [268]       11.449841      11.632342      11.580488      11.212553
    [272]       10.433916      9.1244841      7.1650014      4.7919712
    [276]       3.6717563      4.8579674      6.0886617      5.9785137
    [280]       3.8720441     -2.0846336     -11.796683      1.6319841
    [284]       6.2314677      8.5478172      9.7879324      10.424051
    [288]       10.634905      10.421996      9.7472067      8.7607002
    [292]       8.0919495      8.4441280      9.3663597      9.8601494
    [296]       9.2703075      7.0770521      3.8159573      6.5704279
    [300]       11.457668      14.605315      16.366148      17.082747
    [304]       16.961287      16.156935      14.830217      13.185453
    [308]       11.481905      9.9815664      8.8294258      7.9884892
    [312]       7.3616476      7.0078669      7.1657596      7.8774142
    [316]       8.7690067      9.4152203      9.6012640      9.2949324
    [320]       8.5890636      7.7095103      7.0095763      6.7101727
    [324]       6.5650525      6.1172199      5.2486482      4.5667391
    [328]       4.8422070      5.5119376      5.7472024      5.9567757
    [332]       7.3535767      9.4641857      10.984349      11.569128
    [336]       11.882986      13.358683      15.890052      18.111591
    [340]       19.425398      19.728485      19.017427      17.292727
    [344]       14.581621      11.043604      7.0188417      2.3883939
    [348]      -3.7165303     -2.4535463      1.6213864      2.4919538
    [352]      0.11656142     -5.6146350     0.29011634      5.5560913
    [356]       7.8348165      8.0560350      6.4834404      3.9789953
    [360]       4.3967118      7.0536346      8.7579679      9.3443251
    [364]       9.2411022      8.8334913      8.3286047      7.7811298
    [368]       7.1210818      6.1238041      4.6350174      3.2686877
    [372]       3.7926610      6.4979987      9.9156685      13.046737
    [376]       15.430660      16.912207      17.473038      17.136648
    [380]       15.928629      13.859310      10.917692      7.1201258
    [384]       2.8476210   -0.036245808      1.1245284      4.6790938
    [388]       7.9596062      10.123993      11.082612      11.019577
    [392]       10.592760      11.013516      12.412836      13.678888
    [396]       14.199462      13.894805      12.888718      11.418636
    [400]       9.7924614      8.2450037      6.8130393      5.5266786
    [404]       4.8099275      5.3348680      6.9879603      9.0774670
    [408]       11.211577      13.218161      14.912123      16.083082
    [412]       16.545450      16.146011      14.745089      12.227795
    [416]       8.7179003      5.3590236      3.4892614      1.2260273
    [420]      -3.4672656     -2.7531717      2.3024685      4.7153921
    [424]       5.1047645      3.5153646     -1.3720914     -2.9452813
    [428]       6.3447442      11.651357      14.956166      16.954214
    [432]       17.891741      17.869392      16.944199      15.201225
    [436]       12.851103      10.291560      7.8316917      5.2185450
    [440]       1.8646675     -2.4131076     -5.5120735     -4.4032378
    [444]      -2.1122692    -0.19908717     0.94960529     0.74980617
    [448]      -1.9653118     -10.758419     -2.4946551      4.1589770
    [452]       7.3618550      8.8575697      9.4201927      9.6937065
    [456]       10.084058      10.440807      10.303254      9.2801886
    [460]       7.1246114      4.0339370      2.1643908      3.0411532
    [464]       3.8034344      3.4045184      2.5057495      2.6072772
    [468]       3.8243270      4.8858252      5.2434044      4.9693384
    [472]       4.4678774      4.3389583      4.8004637      5.3671498
    [476]       5.4405684      4.6203976      2.5467205     -1.3119959
    [480]      -5.2346368    -0.66619194      4.1098003      7.3080974
    [484]       9.4790707      10.935623      11.898099      12.579928
    [488]       13.177464      13.780422      14.304483      14.556478
    [492]       14.357449      13.607018      12.285952      10.418496
    [496]       7.9835768      4.7828341     0.24527928     -7.7785993
    [500]      -12.019746    -0.71906477      4.8130560      8.2773705
    [504]       10.369434      11.383007      11.521182      10.970668
    [508]       9.9202785      8.5407753      6.9824023      5.5363846
    [512]       4.8840957
  [Tag]         9441
  [frame_len]          320
[Record 60]
  [tot_power]       239200.16
  [re_spec_val]
    [0]       23.764580      23.212185      21.500797      18.432264
    [4]       13.490486      4.9993010     -6.1156969      1.4790471
    [8]       2.2859228     0.63154137     -1.6662984     -1.8681585
    [12]       1.7654828      6.5470285      11.000460      14.740780
    [16]       17.615870      19.583866      20.654970      20.852699
    [20]       20.198235      18.712797      16.444006      13.554302
    [24]       10.553969      8.3764486      7.0586925      4.9489431
    [28]     -0.14783674     0.87899059      7.8776832      12.322538
    [32]       16.445847      20.628429      24.170582      26.702681
    [36]       28.166782      28.576828      27.926741      26.156351
    [40]       23.118904      18.522968      11.927660      4.8819156
    [44]       3.7989218      3.3501523      3.3278744      4.7967286
    [48]       6.1017013      7.1744313      9.3390579      12.692183
    [52]       15.925877      18.382088      19.946850      20.643026
    [56]       20.506231      19.556519      17.786930      15.147296
    [60]       11.521662      6.7465596      1.0768406     -2.8245194
    [64]      -3.7546270     -4.6968064     -4.7121000     -2.3164783
    [68]       1.0341487      5.4259763      10.359373      14.584415
    [72]       17.651693      19.530399      20.249638      19.791763
    [76]       18.035351      14.626353      8.4100733     -10.339673
    [80]       2.4894965      6.6294556      7.1241045      5.2690578
    [84]     -0.88415736     -5.6957474      7.6778831      13.562036
    [88]       17.330204      19.815771      21.259823      21.743019
    [92]       21.284256      19.862434      17.413488      13.866948
    [96]       9.7874079      8.6262007      10.473680      11.601774
    [100]       10.901302      6.9416947     -6.8725023      8.8320637
    [104]       14.441469      17.783697      21.436707      25.500175
    [108]       28.954313      31.396278      32.803383      33.223732
    [112]       32.691139      31.212778      28.784388      25.452850
    [116]       21.485844      17.491751      13.656414      8.9048052
    [120]       1.6993300     -6.0441175     0.52814132      7.7136617
    [124]       12.645195      16.004139      18.315559      19.801504
    [128]       20.504032      20.428278      19.609869      18.065104
    [132]       15.576137      11.167198    -0.66559023      4.7703705
    [136]       11.758884      14.280356      15.396222      16.908014
    [140]       19.382998      21.776449      23.436985      24.403263
    [144]       25.088757      25.932890      26.886566      27.501106
    [148]       27.413761      26.485312      24.788717      22.676910
    [152]       20.632711      18.436426      14.624824      4.4732614
    [156]       10.036790      17.263149      20.715178      22.842955
    [160]       24.446032      25.776640      26.786306      27.349413
    [164]       27.389357      26.902786      25.947828      24.611223
    [168]       22.934292      20.816267      17.963564      13.900175
    [172]       8.4722347      6.4570637      8.5407333      8.8460894
    [176]       6.6362762      4.4982910      10.049693      14.995440
    [180]       18.046736      19.743156      20.400690      20.251835
    [184]       19.554296      18.579311      17.415918      15.794079
    [188]       13.158015      8.6281109    -0.24886921     -8.2624063
    [192]     -0.44717816     0.91897619      2.9188614      5.7161360
    [196]       7.2876091      7.2828779      5.9269624      4.1829844
    [200]       4.2984591      6.3135667      8.5062170      10.372111
    [204]       11.792064      12.615952      12.707213      12.016208
    [208]       10.705737      9.3777018      8.7716179      8.6742344
    [212]       8.5353594      8.7370768      9.9333515      11.554901
    [216]       12.742282      13.199414      12.960000      12.206994
    [220]       11.228677      10.312597      9.4980297      8.4508314
    [224]       6.5502024      2.6601987     -6.1426525    0.099514715
    [228]       6.3026972      9.2169733      10.468167      10.781000
    [232]       10.843007      11.174994      11.590618      11.478987
    [236]       10.336590      7.7551870      3.5632160      1.4600614
    [240]       4.2957110      6.2056575      6.5207763      5.7437959
    [244]       4.7033987      4.3803520      4.5703793      4.1559467
    [248]       2.2021418     -2.1140573     -2.0184147      4.4002013
    [252]       8.6775484      11.445330      13.225272      14.233756
    [256]       14.548022      14.175920      13.087982      11.245629
    [260]       8.6732750      5.6976476      3.3565030      2.6059785
    [264]       2.8029170      3.0406408      2.8305829      1.8547211
    [268]      0.21124235    -0.62979275     0.88551748      3.2032175
    [272]       5.2345223      6.8805594      8.0607443      8.6007538
    [276]       8.3345232      7.1152592      4.7657318      1.1607293
    [280]      -2.2832837     -1.6985965    -0.26919261    -0.43557063
    [284]      -1.6356796    -0.84537286      2.3940942      5.4724731
    [288]       7.8907938      9.6868792      10.784281      11.060450
    [292]       10.436137      8.9432192      6.9244208      5.3889537
    [296]       5.3697991      6.4413075      7.6709752      8.4087334
    [300]       8.1364861      6.2658243      1.5941169     -5.1073589
    [304]       2.4503016      6.6211720      8.2748756      8.4548712
    [308]       7.6705332      6.4397769      5.5613427      5.6890931
    [312]       6.4585476      7.0560489      6.9319468      5.7236629
    [316]       3.2637041      1.1799765      3.0486519      5.5924010
    [320]       6.7986302      6.8481297      6.5372739      7.2457232
    [324]       9.3218145      11.602353      13.287376      14.095734
    [328]       13.901049      12.582276      9.9332428      5.5551500
    [332]       1.3220530      5.7992740      10.464107      13.333507
    [336]       14.740471      14.752442      13.165275      9.1768436
    [340]      -1.6886433      1.5500259      8.5817471      10.810032
    [344]       11.049766      10.171974      9.0264559      8.5970335
    [348]       9.0102615      9.5152073      9.4544048      8.3479614
    [352]       5.9371634      4.7472997      8.3902311      11.881714
    [356]       13.845895      14.463899      13.843709      11.882735
    [360]       8.0513945   -0.065153070     -6.5703454      4.2541370
    [364]       7.9085522      9.6524878      10.433826      10.499163
    [368]       9.8929310      8.9343767      8.9110594      10.617973
    [372]       12.556390      13.573914      13.264613      11.235012
    [376]       6.6399026      2.8927395      8.7390795      12.423821
    [380]       14.161400      14.765407      14.755323      14.592365
    [384]       14.595773      14.709352      14.576813      13.839965
    [388]       12.350775      10.655571      10.526048      11.968051
    [392]       13.042044      12.917236      11.288071      7.5750012
    [396]     -0.50860864     -3.6570170      4.2495317      7.0461287
    [400]       7.9343095      7.7554164      6.8636155      5.7163997
    [404]       5.1586885      5.4572787      6.2020311      7.9336405
    [408]       10.697109      13.186954      14.624243      14.773794
    [412]       13.441981      10.123310      3.4239788      2.6478007
    [416]       8.9220247      12.017253      13.526596      14.123491
    [420]       14.081807      13.510029      12.470166      11.112732
    [424]       9.8696795      9.4151106      9.8687000      10.530833
    [428]       10.712733      9.9850016      7.9724035      4.3060908
    [432]       1.3223342      4.5265093      7.7197857      9.4117117
    [436]       10.043154      9.9678965      9.4535713      8.7353230
    [440]       8.0217180      7.4536314      7.0525880      6.7164555
    [444]       6.2644310      5.4755287      4.0795979      1.6719416
    [448]      -2.5951910     -11.286882     -9.4409008     -3.2501471
    [452]     -0.81363505    -0.16286270    -0.51435751     -1.1505697
    [456]      -1.4763571     -1.6730090     -1.9828008    -0.73119789
    [460]       2.9590247      6.6194425      9.2202597      10.701234
    [464]       11.102201      10.395582      8.4338102      4.8708897
    [468]     -0.60688901     -2.8956807     0.10340685      1.3925632
    [472]      0.79603940     -1.4443173     -4.8938656     -6.0567174
    [476]      -3.5447776     -1.3059087     0.51977986      2.6005797
    [480]       4.7305646      6.3104959      6.9936066      6.6348176
    [484]       5.1770992      2.7997935     0.57775867    -0.12789477
    [488]     -0.47081760     -1.1652468     0.24716836      3.5736849
    [492]       6.1593947      7.4932995      7.7365885      7.1340675
    [496]       5.9116287      4.0854392      1.3826077    -0.90894026
    [500]       1.7026992      5.1680193      7.0367241      7.3434052
    [504]       6.1575971      3.3020184     -2.0025980     -14.494580
    [508]      -11.476890     -4.9193635     -2.3664005     -1.1043179
    [512]     -0.69801044
  [Tag]         9601
  [frame_len]          320
[Record 61]
  [tot_power]       272468.69
  [re_spec_val]
    [0]       22.220697      21.754751      20.339615      17.928703
    [4]       14.486101      10.197854      6.1190848      3.6528797
    [8]       1.8125244    -0.66245466     -2.6879697     0.10945070
    [12]       5.3504128      9.9940872      13.672402      16.379015
    [16]       18.134924      18.956747      18.840967      17.742613
    [20]       15.533765      11.901706      6.0218143     -5.3675947
    [24]      -13.572238     -14.750951     -6.9543753      1.2938545
    [28]       2.2470996     -9.6124678      8.9618530      17.290379
    [32]       22.126497      25.093664      26.699860      27.149710
    [36]       26.517492      24.805389      21.992908      18.198465
    [40]       14.181064      11.173697      8.2906218      2.9681246
    [44]      -12.907336     -2.7689338     0.95333499      1.7359844
    [48]       4.9342055      9.4859886      12.935243      15.072160
    [52]       15.986940      15.681087      14.040596      10.836967
    [56]       6.0037808      1.7937350     0.34405345     -3.4055169
    [60]      -5.0127592     0.60487056      2.1162317     0.20395531
    [64]       2.1174114      8.5946388      13.165667      16.296967
    [68]       18.452812      19.779118      20.265848      19.834044
    [72]       18.373446      15.850986      12.977063      12.034494
    [76]       12.556807      11.967498      8.9512787      2.8402851
    [80]       6.9371533      12.086826      14.803233      16.633511
    [84]       18.438725      20.249754      21.653904      22.357908
    [88]       22.275084      21.471045      20.173193      18.730984
    [92]       17.277254      15.370504      12.048182      4.9384871
    [96]      -4.8313541      8.1020775      12.404858      15.420030
    [100]       18.602806      21.762051      24.345732      26.105228
    [104]       26.994093      27.042654      26.326025      24.969763
    [108]       23.131132      20.920340      18.471592      16.654024
    [112]       16.766575      17.581598      17.377567      15.313604
    [116]       10.361826      7.2440028      13.352480      16.783655
    [120]       18.476540      19.332411      19.635372      19.227903
    [124]       17.977709      16.804354      17.689953      19.404762
    [128]       19.998962      19.019064      17.490253      19.275246
    [132]       23.009796      26.036283      28.362055      30.307985
    [136]       31.971813      33.265350      34.070351      34.322460
    [140]       34.014938      33.170879      31.803841      29.886509
    [144]       27.392963      24.559557      22.289230      21.107904
    [148]       19.827299      17.555361      16.327553      18.942497
    [152]       21.879486      23.854944      25.037365      25.566862
    [156]       25.453838      24.671608      23.241600      21.284815
    [160]       18.978371      16.295527      12.676103      6.8785090
    [164]      0.70078570      4.4733267      5.5693083      2.6860178
    [168]      -8.4584608     -4.0757504      2.7376964      5.6945100
    [172]       8.0794716      10.174493      11.575837      12.113619
    [176]       11.789094      10.647764      8.8832493      7.3199816
    [180]       7.2323756      8.1182060      8.6878214      8.5462952
    [184]       7.8786149      7.2587209      7.4423099      8.5690746
    [188]       10.038592      11.319200      12.179111      12.534772
    [192]       12.328844      11.464952      9.7652121      6.9151459
    [196]       2.4024549     -2.8782246     -1.1269617      2.0849977
    [200]       4.0383649      5.4872065      6.7406974      7.7297392
    [204]       8.3920736      8.8057871      9.1171751      9.4247122
    [208]       9.7085705      9.8256531      9.5477552      8.6359558
    [212]       7.0215030      5.4100361      5.4774928      6.7018538
    [216]       7.2506166      6.3633313      3.5643058     -1.7245711
    [220]      -2.2641139      3.1850436      6.8156157      9.3351364
    [224]       11.116858      12.154072      12.364443      11.759773
    [228]       10.700971      10.169938      10.659792      11.131736
    [232]       10.557208      8.2876596      3.3483357     -2.9862456
    [236]       2.1476197      5.0557661      5.2771559      3.5400867
    [240]    -0.059648838     -6.0052547     -16.997581     -15.751159
    [244]      -8.4232101     -4.4752808     -2.2778642     -1.7412492
    [248]      -2.9315670     -4.0549254    -0.78226715      2.9447129
    [252]       5.0173531      5.5158629      4.6019125      2.6322877
    [256]       1.4245255      3.0171473      5.1880875      6.4234023
    [260]       6.4939218      5.2827578      2.5082154     -1.8121457
    [264]      -2.1499858      1.7745869      4.2501392      5.1562548
    [268]       4.6195612      2.4874711    -0.48386988      1.2334872
    [272]       5.0923405      7.4130535      8.2622509      7.9298158
    [276]       6.6889300      4.9500780      3.3715005      2.8053885
    [280]       3.8197317      5.6236048      6.8868432      6.7828526
    [284]       4.4803700     -2.5595765     -2.3600538      5.6387968
    [288]       8.7318382      9.3986902      8.1523294      4.9785357
    [292]      0.28428000     -1.5355093    -0.76665741     -1.9727396
    [296]      -4.7894497     -2.8791490      1.7581180      5.0003405
    [300]       6.7223773      6.8321991      4.8445244    -0.51544815
    [304]     -0.45785201      6.3714585      9.9435482      11.676545
    [308]       12.244774      12.030163      11.425369      10.887213
    [312]       10.595354      10.234418      9.5205564      8.9969120
    [316]       10.008286      12.194422      14.108599      15.154171
    [320]       15.167671      13.999214      11.323497      6.5058703
    [324]       2.7994840      7.5909395      11.211674      13.292282
    [328]       14.444823      14.918277      14.812530      14.195178
    [332]       13.103838      11.463443      9.1053457      6.7085748
    [336]       7.4868388      10.281873      12.143875      12.657578
    [340]       11.960789      10.474499      9.3146639      9.4139185
    [344]       9.9198551      10.051249      10.139095      10.996062
    [348]       12.608056      14.212371      15.276702      15.531601
    [352]       14.727344      12.414212      7.3275442     -5.8284984
    [356]       5.4935961      10.290736      11.894999      11.801724
    [360]       10.602420      8.9547167      8.1513062      9.4705887
    [364]       12.108363      14.663013      16.556309      17.647154
    [368]       17.908056      17.302111      15.716050      12.919414
    [372]       9.0304403      8.1586647      11.434043      13.905576
    [376]       15.127200      15.433853      15.100176      14.326863
    [380]       13.348963      12.743831      13.272597      14.606456
    [384]       15.714412      15.997946      15.177134      12.985181
    [388]       9.2687483      7.1956668      10.419812      13.175245
    [392]       14.448318      14.530482      13.639821      11.997914
    [396]       10.085812      8.9166098      9.4057636      11.152320
    [400]       13.155225      14.774064      15.754128      16.051147
    [404]       15.727446      14.911159      13.757574      12.326121
    [408]       10.341314      6.8688173    -0.40442383      2.4729276
    [412]       9.0215578      11.932791      12.780951      12.125942
    [416]       10.551885      9.3238344      9.1053858      8.4718285
    [420]       5.8313279     -1.5631907     -4.6678691      4.3926349
    [424]       7.6704760      9.1575565      10.028092      10.678679
    [428]       11.053250      11.048602      10.700889      10.107009
    [432]       9.3283310      8.4882383      7.9154429      7.8161039
    [436]       7.8346481      7.4651480      6.5371852      5.3229480
    [440]       4.5030975      4.6290393      5.4463906      6.2974024
    [444]       6.6804781      6.3173966      5.1123919      3.2256861
    [448]       1.2642809    -0.13422631     -1.4181900     -3.2529912
    [452]      -3.9529138     -1.2459064      1.9452800      4.2452116
    [456]       5.6469293      6.1902976      5.8031287      4.3188572
    [460]       1.4919561     -2.9198563     -8.8102074     -19.528542
    [464]      -11.056517     -1.4029059      3.5499532      6.2602377
    [468]       7.3794150      7.1370335      5.5719934      2.6317496
    [472]      -1.4063963     -4.1661949     -4.1145563     -4.5227203
    [476]      -6.8817086     -12.316149     -26.721962     -19.238420
    [480]      -19.508379     -22.922508     -7.4711990    -0.97379446
    [484]       2.7794509      4.8162761      5.4488015      4.7128267
    [488]       2.4332078     -1.7371142     -6.5154753     -5.8905840
    [492]      -4.7630467     -4.2380586    -0.91095161      2.9538031
    [496]       5.4160352      6.3634133      5.7735400      3.2769372
    [500]      -2.6082420     -9.5897894    -0.55562484      2.9463518
    [504]       3.7883570      2.7102389    -0.47091827     -7.4411592
    [508]      -24.284397     -7.9352322     -5.0831800     -4.8713803
    [512]      -5.1661334
  [Tag]         9761
  [frame_len]          320
[Record 62]
  [tot_power]       268545.44
  [re_spec_val]
    [0]       19.040941      18.457195      16.668507      13.565021
    [4]       9.0738382      4.3042536      3.0985548      3.7203434
    [8]       3.5020099      1.9693781     -2.0328252     -2.3430777
    [12]       6.7396770      12.422004      15.964439      17.988968
    [16]       18.726538      18.245766      16.516588      13.432677
    [20]       8.8862362      3.4254990      1.2998434      4.4864483
    [24]       7.9967861      10.256937      11.299588      12.542524
    [28]       16.076500      20.333462      23.673296      25.847609
    [32]       26.905813      26.887487      25.772440      23.451546
    [36]       19.643099      13.566322      2.0914509      2.3390279
    [40]       6.7173748      6.8940406      5.1059904      4.0516996
    [44]       7.4607000      11.497956      14.411371      16.189058
    [48]       16.861671      16.367491      14.540313      11.093088
    [52]       6.3718252      5.7491879      8.2731581      9.4557657
    [56]       9.3114948      8.0922928      5.6843052      1.8052877
    [60]       1.6376336      7.3178091      11.527970      14.194451
    [64]       15.764386      16.548029      16.746731      16.359982
    [68]       15.083648      12.238154      6.7776093      6.1155338
    [72]       11.380173      13.928898      14.951349      15.982465
    [76]       18.036398      20.458336      22.392384      23.535412
    [80]       23.802732      23.122877      21.353693      18.174952
    [84]       12.890802      7.5625734      11.524681      14.355108
    [88]       15.070124      14.659598      14.738746      16.478624
    [92]       18.783924      20.796082      22.407345      23.593544
    [96]       24.267109      24.349352      23.813354      22.671785
    [100]       20.950323      18.683617      15.926715      12.604559
    [104]       7.9572096      2.9931095      8.6856918      13.181545
    [108]       15.412039      16.310141      16.555805      16.748325
    [112]       17.218500      17.816833      17.991037      16.933311
    [116]       13.315891      8.5288553      16.318445      21.197348
    [120]       23.648388      24.825783      25.682425      27.025690
    [124]       28.838800      30.610878      32.048962      33.074291
    [128]       33.661491      33.798187      33.518394      32.938545
    [132]       32.223953      31.434698      30.380232      28.658937
    [136]       25.729561      20.896561      16.410015      19.478104
    [140]       21.780960      22.164402      21.677896      21.734430
    [144]       22.778244      23.854853      24.355875      24.222364
    [148]       23.600790      22.701666      21.700567      20.588717
    [152]       19.079929      16.630423      12.368385      6.9295702
    [156]       10.941084      15.071503      17.122917      17.916151
    [160]       17.899635      17.338905      16.396626      15.108940
    [164]       13.313343      10.664820      7.1302485      5.3942108
    [168]       7.0713778      8.1438942      7.4302559      4.6658006
    [172]      -1.0964304     -14.806117     -7.7989292     -4.7724552
    [176]      -5.8704376     -6.4702654     -1.4514499      3.1280560
    [180]       6.0248661      7.4541516      7.4476166      5.7834272
    [184]       1.8297935     -4.0579557    -0.95932525      2.3773024
    [188]       3.0601666      1.8172240    -0.85511380     -3.5551693
    [192]      -3.7546163     -2.8480005     -3.1412930     -5.0371385
    [196]      -3.9648495     0.92505229      4.2445488      5.5870104
    [200]       5.0021029      2.0597627     -3.7445910     -1.0570043
    [204]       3.9230466      6.3099055      7.2130661      7.3066287
    [208]       7.1101284      7.0084214      7.0270157      6.7503786
    [212]       5.4757791      1.9884280     -6.3358479      1.2512782
    [216]       7.4502273      10.524428      11.879196      11.954200
    [220]       10.901591      8.7895622      5.9330177      3.8824346
    [224]       4.2720361      5.4086957      6.0789752      6.4673047
    [228]       7.1367965      8.2189579      9.2447224      9.7185631
    [232]       9.3203669      7.7390366      4.3719106     -2.3799274
    [236]      -3.6189544      3.1333561      6.4645200      8.2272015
    [240]       9.2302494      9.8603191      10.294997      10.582616
    [244]       10.672089      10.413392      9.5648489      7.7841773
    [248]       4.5025339     -1.5238223     -6.2786136    -0.13063781
    [252]       2.8413174      3.7493927      3.4030378      2.1440971
    [256]      0.17391177     -1.9961666     -3.1336222     -2.9945543
    [260]      -2.5262871     -1.1703044      1.5462794      4.3066211
    [264]       6.2567592      7.2383971      7.2266421      6.0794296
    [268]       3.2917964     -3.0337508     -14.444485    -0.86480522
    [272]       2.7158139      3.0049860     0.46201730     -2.5528047
    [276]       3.0716906      7.9740820      11.046745      12.996753
    [280]       14.136569      14.557117      14.247381      13.167007
    [284]       11.344719      9.2672377      8.6239614      10.182480
    [288]       12.186080      13.671810      14.506667      14.736905
    [292]       14.430999      13.657440      12.486218      11.017625
    [296]       9.5054808      8.5959234      8.9881258      10.265218
    [300]       11.445866      11.988789      11.715629      10.637159
    [304]       8.9893875      7.3660474      6.5610890      7.1285925
    [308]       9.0305662      11.386458      13.379847      14.718253
    [312]       15.372172      15.360970      14.649233      13.073123
    [316]       10.227366      5.1907158    -0.87435627      3.8267200
    [320]       6.8763833      7.1751814      5.3764863      3.4318266
    [324]       5.8644280      9.2716045      11.625311      13.256970
    [328]       14.517336      15.468107      15.962643      15.799263
    [332]       14.779654      12.688748      9.3190165      5.2162733
    [336]       4.0109439      5.5269408      6.9110861      8.5973816
    [340]       10.764539      12.739468      14.107972      14.805679
    [344]       14.877192      14.359881      13.243680      11.475813
    [348]       9.0661669      6.4709120      4.7743206      3.6718693
    [352]       1.2894355     0.14949544      5.8688488      10.380933
    [356]       12.991001      14.252487      14.515720      14.035911
    [360]       13.035231      11.668137      9.8740540      7.1505184
    [364]       1.8936334     -29.844797      1.9212087      7.5978680
    [368]       10.264807      11.479165      11.769178      11.418224
    [372]       10.654375      9.7347126      8.8773441      8.0679493
    [376]       7.1328959      6.0451546      4.7722859      2.5077679
    [380]      -3.7309411     -8.2726088      3.3496912      7.2870679
    [384]       8.1189413      5.8840504     -3.8175159      1.8270779
    [388]       9.8511391      13.281311      14.691192      14.679341
    [392]       13.388374      10.765634      7.0702219      5.5311961
    [396]       7.8696680      10.003916      11.141970      11.475908
    [400]       11.186296      10.557018      10.209819      10.744726
    [404]       11.903520      13.078694      14.029345      14.784360
    [408]       15.397852      15.810633      15.836680      15.211633
    [412]       13.592006      10.401437      4.2510762    -0.94548535
    [416]       5.8558183      8.7631292      9.3052588      8.3342247
    [420]       6.8291807      6.8571568      8.5659819      10.033171
    [424]       10.519882      9.8951941      8.0386963      4.6200614
    [428]      -1.1768910     -6.2454629    -0.90196294      2.8605576
    [432]       5.1715884      6.6311049      7.3427653      7.2626152
    [436]       6.3122315      4.3995337      1.5253718     -1.4389049
    [440]      -1.8683394    -0.47307238     0.29689240    -0.26241133
    [444]      -2.7227876     -9.5361614     -14.364930     -2.5492170
    [448]       2.0251956      4.3591180      5.3371339      5.2479758
    [452]       4.1886082      2.1510291    -0.98660338     -5.4192953
    [456]      -9.1044016     -6.2009726     -2.5713856    -0.24083723
    [460]       1.0710808      1.6533487      1.8158952      1.9351920
    [464]       2.2777703      2.7485039      3.0011232      2.7101536
    [468]       1.6269126    -0.51675874     -4.1063285     -8.4889145
    [472]      -6.9740648     -3.2462480     -1.0419344   -0.042250168
    [476]      0.16110411   -0.038023997    -0.14121459     0.31178364
    [480]       1.2982664      2.3449481      3.0060434      3.0053692
    [484]       2.1062741    -0.11061175     -4.8227291     -13.329622
    [488]      -4.2087235      1.1180464      3.8585684      5.1812758
    [492]       5.4965177      5.0034981      3.8891737      2.5639100
    [496]       1.8724658      2.3539760      3.3507404      4.0347791
    [500]       3.9805164      2.8948364     0.32942519     -4.6041784
    [504]      -8.3451376     -2.8703442     0.47276351      1.7864723
    [508]       1.7280520     0.58883262     -1.4664211     -4.0726309
    [512]      -5.5875592
  [Tag]         9921
  [frame_len]          320
[Record 63]
  [tot_power]       223610.58
  [re_spec_val]
    [0]       20.363123      19.804369      18.086945      15.075208
    [4]       10.493981      3.8335121     -4.8035893     -5.8595924
    [8]      -3.9451940     -1.4154829      5.3872380      11.429006
    [12]       15.623026      18.316666      19.777563      20.147049
    [16]       19.467140      17.677618      14.564189      9.5716295
    [20]      0.91682047     -7.6325612    -0.50783819     0.47973734
    [24]       1.9340410      11.010830      18.208855      23.182440
    [28]       26.551558      28.629635      29.564106      29.401066
    [32]       28.100006      25.509308      21.264303      14.368331
    [36]     -0.55028760      1.7584965      5.1325541      5.3537273
    [40]       5.7456369      7.8206110      11.796210      15.315234
    [44]       17.514746      18.405876      18.070734      16.503262
    [48]       13.566117      9.0344725      3.9801898      3.3866103
    [52]       3.8871865      2.0837834     -2.9247077     -9.6369457
    [56]      -6.0470300     -3.5367846     0.50180906      4.9862823
    [60]       7.8641548      9.0481291      8.6938677      6.9346371
    [64]       4.0320578     0.37732613     -4.2335382     -3.6405506
    [68]       2.9234896      8.5760002      14.031383      18.851301
    [72]       22.598743      25.209232      26.730396      27.200682
    [76]       26.617214      24.925718      22.016171      17.761053
    [80]       12.576397      10.589808      13.311534      15.976799
    [84]       17.661844      18.799166      20.321568      22.459335
    [88]       24.425106      25.623234      25.858194      25.073479
    [92]       23.220438      20.233318      16.163847      11.945125
    [96]       9.7630644      8.7952938      7.3105578      6.4383659
    [100]       8.2383747      10.999023      13.173016      14.477469
    [104]       14.850756      14.190181      12.268190      8.5829401
    [108]       1.8962562     -9.7503777    -0.58015066      8.6379099
    [112]       15.238717      19.855474      23.210888      25.915947
    [116]       28.368242      30.594482      32.372414      33.486122
    [120]       33.813545      33.301731      31.944197      29.807594
    [124]       27.158422      24.679823      23.134539      22.195616
    [128]       20.760462      17.792122      13.038834      14.932962
    [132]       19.587513      22.173704      23.362993      23.606281
    [136]       23.068501      21.745335      19.629681      17.111504
    [140]       15.576853      15.774261      16.297117      16.174459
    [144]       15.180989      13.470177      12.163770      12.891871
    [148]       14.528195      15.577364      15.725090      15.028372
    [152]       13.594509      11.503606      8.6892023      4.5757418
    [156]      -2.9415522     -3.1279914      3.8606246      7.1698790
    [160]       9.2759056      11.361487      13.441339      14.958063
    [164]       15.561533      15.130370      13.631054      11.086162
    [168]       7.6605916      3.6837275     -1.3764877     -12.372587
    [172]      -2.3525207      4.2215757      7.5740371      9.3917828
    [176]       10.357347      10.947553      11.453113      11.847256
    [180]       11.883985      11.319549      9.9968538      7.8387251
    [184]       4.8989716      1.6894472    -0.29989603    -0.24251689
    [188]      0.64154673      1.4952105      2.1448431      2.6875410
    [192]       3.3052769      4.0055203      4.5285621      4.5728340
    [196]       4.0187616      3.0502281      2.0566070     0.87085873
    [200]      -2.0461347     -13.073976     -2.8792922      4.7625828
    [204]       8.5180607      10.406645      11.052567      10.855407
    [208]       10.281572      9.8229198      9.5923290      9.2836256
    [212]       8.7172337      8.1543446      7.9718528      7.9356408
    [216]       7.3468575      5.6292729      2.5338826    -0.66225260
    [220]     -0.73998976    -0.31201550     -1.6649112     -3.0596128
    [224]     -0.63433486      2.1992948      3.7485733      4.4462380
    [228]       4.9022722      5.3097353      5.2536912      4.0891900
    [232]       1.5994754      1.6713251      6.0083246      9.3150673
    [236]       11.051232      11.552714      11.143554      10.188684
    [240]       9.0657749      7.9804945      6.9711289      6.0919466
    [244]       5.1339927      3.2245154     -1.4170367     -7.3681054
    [248]       1.4014770      5.7279778      7.4232240      7.4209480
    [252]       6.0796952      3.6602068     0.65046448     -1.8041972
    [256]      -2.2592182     -1.2526562    -0.62178713     -1.3395108
    [260]      -2.2959032     0.87975365      5.2589040      8.3076811
    [264]       10.113182      10.986560      11.226079      11.129223
    [268]       10.921880      10.642531      10.176617      9.4475937
    [272]       8.5707293      7.8024120      7.2249312      6.6586671
    [276]       6.1670847      6.3013148      7.0872078      7.6281862
    [280]       7.1577034      5.2502108      1.7088724     -2.0763521
    [284]      -2.6212981     -3.2948935     -6.6993475     -6.8992372
    [288]      -3.0927351     -2.4654610     -6.0788593     -9.6054640
    [292]      -1.4373686      2.4680719      3.8088713      3.5322030
    [296]       2.3754954      1.4704615      1.6142190      2.2872005
    [300]       2.9037762      3.2885735      3.2632563      2.5191479
    [304]      0.77141649     -1.0297407      1.1128566      5.0216174
    [308]       7.8083792      9.3245277      9.7557449      9.2973804
    [312]       8.2446976      7.1522408      6.7429132      7.1765151
    [316]       7.8250299      8.0191584      7.4453382      6.5343132
    [320]       7.0829134      9.3624926      11.400740      12.351081
    [324]       12.042413      10.333681      6.9579630      2.3370636
    [328]       2.1166236      4.8378611      6.1440158      6.0584288
    [332]       4.6860991      2.1286769      1.8203566      5.9704790
    [336]       9.4686832      11.504382      12.326231      12.132688
    [340]       11.077806      9.3824587      7.4969668      6.0481467
    [344]       5.2080402      4.5836439      3.9867129      3.5827980
    [348]       3.4014955      3.2151372      3.0973899      3.6941381
    [352]       5.1667314      6.6441836      7.3736143      7.0010171
    [356]       5.2740011      1.8000522     -4.3527198     -17.036623
    [360]      -16.573336     -11.191250     -9.0099201     -10.338256
    [364]      -9.8860998    -0.61136615      5.0116305      8.2755060
    [368]       10.002178      10.622644      10.469731      9.8867054
    [372]       9.2041636      8.6140862      8.1356010      7.7386894
    [376]       7.4004831      7.0418053      6.5636883      6.1599674
    [380]       6.6398897      8.3897085      10.428681      11.871808
    [384]       12.381276      11.798711      9.9100142      6.2136135
    [388]      -1.0036719     -21.514729     -2.8697281     0.19213372
    [392]       1.1294956      1.8443867      2.7467716      3.8590827
    [396]       5.4578295      7.3773398      9.0057850      9.9277525
    [400]       9.9813480      9.0936384      7.1899500      4.2029214
    [404]      0.40510559     -2.3003995     -1.9892387    -0.46113092
    [408]       1.2623332      2.7655416      3.6760550      3.9563348
    [412]       3.9255514      3.9481790      3.8857985      3.1293449
    [416]      0.97979480     -3.4279485     -9.0414228     -6.0764894
    [420]      -4.2071939     -6.2208314     -13.156857     -6.4990005
    [424]      -1.0115272      1.0777127     0.95277172     -1.0513674
    [428]      -3.8382490     -3.7677402     -2.4908402     -3.2585840
    [432]      -7.5618281     -15.353122     -7.3116107     -4.1688995
    [436]      -4.8160501     -9.6578808     -14.168911     -6.1942205
    [440]      -3.0615499     -2.7030053     -4.4607816     -8.3392544
    [444]      -14.622426     -20.577662     -13.627347     -7.4200325
    [448]      -3.8153651     -2.3369815     -2.9358602     -6.2470255
    [452]      -14.360649     -9.5421362     -3.9925606     -1.6783885
    [456]     -0.91918713     -1.0183359     -1.6686348     -2.7711842
    [460]      -3.9782133     -4.2643342     -3.3874097     -2.6255136
    [464]      -2.9134004     -4.7308755     -8.7712927     -17.092083
    [468]      -19.979084     -15.268319     -15.547796     -15.459975
    [472]      -12.048113     -10.123419     -10.916132     -14.084277
    [476]      -11.940088     -7.2809601     -5.1442184     -5.3687887
    [480]      -8.3475628     -17.479761     -17.824121     -10.052102
    [484]      -7.9758492     -7.0445609     -5.1795807     -3.1943653
    [488]      -2.3761911     -3.1162674     -5.3056374     -7.4002562
    [492]      -7.1406727     -6.8220582     -8.4238396     -11.786501
    [496]      -12.373653     -10.660587     -10.518898     -9.1048164
    [500]      -5.2953930     -2.5826347     -1.8283026     -3.3512161
    [504]      -8.6778698     -18.141607     -6.0837140     -2.0421648
    [508]     -0.81233960     -1.2908037     -2.9798024     -5.1784530
    [512]      -6.3346515
  [Tag]        10081
  [frame_len]          320
[Record 64]
  [tot_power]       187719.20
  [re_spec_val]
    [0]       18.365562      17.818331      16.145342      13.256788
    [4]       9.0568123      3.8734276    0.081846908    -0.99450356
    [8]      -3.8810401     -16.890030      3.1570950      10.257415
    [12]       14.293601      16.552134      17.466166      17.221764
    [16]       15.877406      13.344002      9.1648350      1.3105291
    [20]      -9.6986609      1.3430264      1.4584684      4.2838707
    [24]       14.014448      20.334473      24.503094      27.185980
    [28]       28.658949      29.029209      28.303324      26.398127
    [32]       23.120420      18.169416      11.873840      8.2689972
    [36]       6.3532729      4.9243274      10.108917      14.635787
    [40]       17.645704      19.671478      20.862810      21.188229
    [44]       20.572355      18.920349      16.093138      11.872533
    [48]       6.0796642     0.42507759    -0.51645881     0.58237129
    [52]       3.3064413      6.8174367      9.8361568      12.101875
    [56]       13.610172      14.303651      14.030797      12.530788
    [60]       9.3574085      3.8031294     -1.7504292     -1.1058120
    [64]      -5.1873674     -2.9136007      8.2304401      14.791667
    [68]       19.602152      23.175682      25.627932      26.994139
    [72]       27.265289      26.372808      24.155693      20.304876
    [76]       14.355494      6.7974982      1.2583938      6.5166378
    [80]       14.239209      18.951355      22.216669      24.771124
    [84]       26.742315      27.995613      28.384689      27.798569
    [88]       26.116758      23.139427      18.484915      11.772649
    [92]       7.9697700      9.4268827      8.9366713      7.0382609
    [96]       7.2079191      9.4841976      10.824205      10.545769
    [100]       8.5486708      4.6793823     -1.0653703     -5.6681342
    [104]      -3.9979324     -2.7057424    -0.38303068      7.4520183
    [108]       13.868385      18.620731      22.491451      25.823107
    [112]       28.571640      30.578459      31.732540      31.983072
    [116]       31.319952      29.784071      27.527632      24.881916
    [120]       22.233788      19.866838      18.554621      18.852749
    [124]       19.566423      20.142712      21.240561      22.951181
    [128]       24.445017      25.188978      25.064959      24.106510
    [132]       22.378695      19.908676      16.541290      11.532263
    [136]       1.9815043      4.1934843      10.203262      12.270227
    [140]       12.240524      10.541560      7.4805593      4.8082662
    [144]       4.7578831      4.9167681      4.0646882      3.4074032
    [148]       3.5739217      2.7776754    -0.17369314      1.0400856
    [152]       6.6906929      10.389097      12.650774      14.140596
    [156]       15.189194      15.811144      15.846669      15.118450
    [160]       13.489811      10.867923      7.1872878      2.1200511
    [164]      -6.8681884     -3.5489991      4.1947107      8.1609573
    [168]       10.404544      11.629321      12.205356      12.312667
    [172]       11.960362      11.034105      9.3535671      6.7237582
    [176]       3.3187120      1.5124816      2.8480999      3.9091029
    [180]       3.3064322     0.51868743     -5.8697152     -11.590296
    [184]      -5.0487866     -3.3367863     -4.3346038     -6.4374685
    [188]      -7.7927504     -9.2712374     -12.926542     -13.222315
    [192]      -9.2285900     -8.5819616     -12.957901     -14.200178
    [196]      -4.0505300      1.1368712      4.4109259      6.6493607
    [200]       8.1313248      8.9063025      8.9388523      8.1964436
    [204]       6.7947059      5.3346891      4.7903862      4.8818932
    [208]       4.3491654      2.5785263      1.0563146      3.2474658
    [212]       6.2058845      7.9066410      8.3514376      7.6967554
    [216]       5.9762673      3.0501041     -1.2457250     -5.3075056
    [220]      -6.2136979     -9.3060122     -7.6391969      1.7288966
    [224]       7.0193925      10.233035      12.205660      13.368349
    [228]       13.969573      14.104325      13.740556      12.809348
    [232]       11.355806      9.7295179      8.4679708      7.4333820
    [236]       5.6025057      1.5807903     -4.0321689      1.9297363
    [240]       6.4119234      8.5683851      9.3837748      9.3346291
    [244]       8.6533823      7.3603067      5.3042364      2.4327936
    [248]     -0.25877571     -1.0864390     -2.1233885     -7.6494122
    [252]      -9.5913754      1.7087071      6.6624136      9.4392071
    [256]       11.022987      11.847303      12.126409      11.934027
    [260]       11.290481      10.300043      9.2386837      8.3053942
    [264]       7.1255884      4.7428217    -0.17902127     -1.1616538
    [268]       5.0817027      8.5373402      10.081924      10.357538
    [272]       9.7286091      8.4880390      6.8734536      4.9614654
    [276]       2.6499679   -0.074941337     -2.7775321     -5.2107191
    [280]      -9.1730833     -19.671598     -7.0631437    -0.65091622
    [284]       2.8034673      4.6883855      5.4247937      5.1318603
    [288]       3.7899926      1.4140919     -1.1939002     -1.7382368
    [292]     -0.94838732     -1.3449802     -4.2727413     -13.567887
    [296]      -11.157500     -3.5305936    -0.82595259   -0.086668432
    [300]     -0.42051828     -1.3634073     -2.6252582     -3.5003424
    [304]      -3.0559716     -2.3777890     -3.4704807     -9.5326490
    [308]      -12.061781    -0.57742828      3.9198246      6.0078220
    [312]       6.6258225      6.2304473      5.2442508      4.1598959
    [316]       3.4309673      3.3405313      3.8126032      4.2490592
    [320]       3.9359424      2.5547538      1.5419484      3.9445796
    [324]       7.1730938      9.2376919      10.051010      9.7560205
    [328]       8.4989405      6.5091953      4.2436061      2.3931038
    [332]       1.5984406      1.9998941      2.7758446      2.8275430
    [336]       1.4374211     -1.3048234    -0.93401104      2.8593471
    [340]       5.3435693      6.1549277      5.4638491      3.2783957
    [344]     -0.48136926     -5.0441117     -6.5703230     -5.9458022
    [348]      -6.0782924     -7.1840153     -10.174620     -12.298914
    [352]      -4.1610384      1.4208857      4.7891831      6.7498479
    [356]       7.7119284      7.9419537      7.6529422      7.0256548
    [360]       6.1900940      5.1807055      3.9168046      2.3498936
    [364]       1.0403366      1.4625558      3.4090362      5.3154345
    [368]       6.6293745      7.3673711      7.6219239      7.4205189
    [372]       6.7233286      5.4910965      3.7984011      1.9653822
    [376]      0.43022010    -0.90679055     -2.8293183     -6.1784663
    [380]      -9.8870592     -7.3748136     -3.5422745    -0.86410761
    [384]       1.0961388      2.4301286      2.9517105      2.4237957
    [388]      0.59252518     -2.7806959     -6.5308022     -5.5573397
    [392]      -2.8272173     -1.0531332    -0.10972825   -0.019456333
    [396]      -1.1821735     -4.5130262     -13.372042     -11.202419
    [400]      -4.0816674     -1.6030105     -1.3266453     -2.5056751
    [404]      -4.1979227     -4.7865491     -4.3348842     -4.3795052
    [408]      -5.6689773     -8.6494617     -14.362501     -16.056089
    [412]      -8.7835255     -4.4327545     -1.8738757    -0.51759958
    [416]    -0.056157511    -0.12445815    -0.11052649     0.51937312
    [420]       1.5163674      2.2030401      2.0866764     0.78740460
    [424]      -2.3234422     -8.7112474     -8.5179033     -1.9822906
    [428]       1.3573900      3.0057547      3.6280766      3.6052358
    [432]       3.2729943      2.9235771      2.6195447      2.0868635
    [436]      0.84221464     -1.7923142     -7.1744242     -11.182800
    [440]      -3.7627609     0.31990677      2.4322400      3.4188654
    [444]       3.6740501      3.4307990      2.8500934      2.0714190
    [448]       1.2342525     0.39560273    -0.62570214     -2.2478139
    [452]      -4.7636256     -6.3648043     -3.7698014    -0.63661087
    [456]       1.2754916      2.0459449      1.8834355     0.99103636
    [460]     -0.33883584     -1.6080909     -2.3046424     -2.5258641
    [464]      -2.9434445     -4.2509270     -7.1540618     -11.834805
    [468]      -9.9020386     -4.8862920     -1.8861159    -0.26960778
    [472]      0.44287440     0.56667614     0.37426698     0.11688057
    [476]    -0.046997041    -0.11944759    -0.18783545    -0.25552908
    [480]     -0.15675709     0.29286468      1.0107008      1.6724931
    [484]       1.9884261      1.8337123      1.2570639     0.48116350
    [488]     -0.18731113    -0.64657289     -1.1513859     -2.0733020
    [492]      -3.6660156     -5.7975912     -6.8126006     -4.7795248
    [496]      -1.9102675     0.25767955      1.5355847      1.9692960
    [500]       1.6295587     0.63652992    -0.77390629     -2.2953618
    [504]      -3.8788788     -5.8444467     -7.6149306     -6.2077122
    [508]      -2.9529636    -0.44375333      1.0797563      1.8515106
    [512]       2.0814421
  [Tag]        10241
  [frame_len]          320
[Record 65]
  [tot_power]       189012.78
  [re_spec_val]
    [0]       16.092178      15.683184      14.471541      12.515238
    [4]       9.9458208      6.9786167      3.8460457      1.2354933
    [8]       2.1215951      6.1401587      9.9472656      12.825178
    [12]       14.752335      15.735353      15.760161      14.821286
    [16]       12.979453      10.401764      7.1405587      2.5324452
    [20]      -5.3636479     -6.3717828      6.5628858      14.731850
    [24]       20.267990      23.979233      26.258167      27.297068
    [28]       27.163403      25.813730      23.047909      18.323542
    [32]       10.132146      4.8813858      8.5849123      6.5439839
    [36]     0.035231978      10.975156      17.046959      20.595345
    [40]       22.733011      23.806011      23.918486      23.069481
    [44]       21.185867      18.105154      13.512145      6.9848027
    [48]       1.0306370     0.63220948     0.26499838      4.7761388
    [52]       10.274619      13.906733      15.954925      16.637863
    [56]       15.954514      13.650812      8.8974838     -2.3802800
    [60]      -2.5369070      2.8489723      3.8357031      9.3183765
    [64]       15.856874      20.892950      24.629583      27.263412
    [68]       28.883505      29.521284      29.172272      27.815289
    [72]       25.478119      22.473377      19.761715      18.081814
    [76]       17.107620      18.031065      21.281752      24.667572
    [80]       27.293234      29.052330      29.940125      29.949282
    [84]       29.071020      27.307032      24.679266      21.189400
    [88]       16.576571      9.7239943      4.8838105      9.9520559
    [92]       11.650146      10.907916      10.111204      12.075588
    [96]       14.479706      15.767776      15.970759      15.313575
    [100]       13.988776      12.523129      12.752505      15.270614
    [104]       18.087847      20.630941      23.176140      25.677120
    [108]       27.737007      29.035860      29.433926      28.924667
    [112]       27.681658      26.221132      25.180872      24.347057
    [116]       22.744547      19.298479      11.524129      5.4821329
    [120]       15.966695      20.045324      22.562523      24.254353
    [124]       25.182249      25.330009      24.721741      23.411091
    [128]       21.452915      18.884956      15.786303      12.626643
    [132]       10.713839      10.421041      10.305094      9.5679684
    [136]       8.3052998      7.1075644      6.5841236      7.0054479
    [140]       8.3884172      10.087309      11.238989      11.352445
    [144]       10.141662      7.1942654      1.6238940    -0.83781600
    [148]       5.3229270      9.1489468      11.377394      12.560721
    [152]       12.930892      12.650974      11.867933      10.634253
    [156]       8.7614613      5.6576424    -0.27580419     -8.0368109
    [160]       1.3213904      5.5208473      7.4197092      8.0871382
    [164]       7.9334908      7.1122608      5.6122003      3.3162966
    [168]     0.038272075     -4.4886870     -8.3052168     -4.3681450
    [172]     -0.13140756      2.2759767      3.2716455      3.4551322
    [176]       3.7971134      4.9050946      6.2062297      7.0553107
    [180]       7.3269072      7.1937485      6.8873940      6.4867301
    [184]       5.8490720      4.7461696      3.0342133     0.88225216
    [188]     -0.71864086    -0.54238814     0.62770313      1.6331158
    [192]       2.2344534      2.6419628      3.1683605      3.9186511
    [196]       4.6857839      5.1942515      5.2881265      4.9268579
    [200]       4.1516337      3.1622815      2.5117745      2.8076553
    [204]       3.7296119      4.4499950      4.6010752      4.5644636
    [208]       5.4804339      7.5644064      9.6073570      10.829308
    [212]       10.973387      9.9035912      7.5635033      4.9797211
    [216]       5.6555724      8.1273890      9.7564068      10.351727
    [220]       10.157105      9.5622883      9.3440819      10.224975
    [224]       11.689078      12.772407      12.972344      12.048987
    [228]       9.8000298      6.3524671      4.6798534      6.8565683
    [232]       8.6847591      9.1650486      8.4280081      6.5858116
    [236]       3.9185028      2.2299378      3.6277113      5.6092682
    [240]       6.5584960      6.2589803      4.7316961      2.5593994
    [244]       2.2684028      4.3817410      6.2227249      7.0035481
    [248]       6.7850947      5.9140429      5.4333959      6.5663919
    [252]       8.4913177      9.8819704      10.226407      9.3435850
    [256]       7.2798123      5.4526443      6.6416311      8.8089428
    [260]       10.021330      10.212596      9.7442999      9.2132235
    [264]       9.2715044      9.9551973      10.638248      10.722566
    [268]       9.8488646      7.8734255      5.4522252      5.1333885
    [272]       6.7289953      7.7724233      7.7559338      6.9583540
    [276]       5.9306746      5.2312999      4.9317341      4.6729755
    [280]       4.1239309      3.0995684      1.5777093    0.027508421
    [284]     -0.23360726      1.0482814      2.3636262      2.7569399
    [288]       1.8315796    -0.56244373     -2.1277289      1.2198030
    [292]       4.7610555      6.8634934      7.6931839      7.4171729
    [296]       6.2384944      4.8686199      4.7274394      5.7549200
    [300]       6.5287805      6.4329834      5.5727844      4.8358102
    [304]       5.6882701      7.7632565      9.6493979      10.752190
    [308]       10.903081      9.9968529      7.9065742      4.6396298
    [312]       1.5940537      1.7932504      3.1724420      3.8768885
    [316]       4.1587906      4.5731874      5.3175688      6.1910639
    [320]       6.9057722      7.2430792      7.0528078      6.2106833
    [324]       4.5444093      1.6890461     -3.3626211     -16.111322
    [328]      -10.713867     -4.7624431     -2.8833983     -1.8868477
    [332]     -0.14746949      2.1793914      4.1887121      5.4807606
    [336]       5.9319115      5.4307928      3.7769918     0.56694299
    [340]      -5.1897378     -16.579596     -15.409121     -16.253681
    [344]      -20.788883     -6.1086512    -0.16220491      3.2782812
    [348]       5.3360100      6.4090343      6.6354570      5.9916539
    [352]       4.2772684     0.94980156     -5.7270393     -13.503059
    [356]      -4.0167980    -0.51365912      1.0007354      2.0310314
    [360]       3.2005303      4.3050771      4.9221168      4.8276143
    [364]       3.9684813      2.4081101     0.35913280     -1.8300524
    [368]      -3.9989083     -6.4550433     -9.4657755     -12.292646
    [372]      -13.110441     -11.080359     -7.7910271     -5.2031174
    [376]      -3.9264624     -3.9811141     -5.1620393     -6.7706108
    [380]      -7.4449396     -6.8771753     -5.8985229     -4.5740123
    [384]      -2.6206331    -0.16662556      2.4056759      4.7609167
    [388]       6.6693234      7.9882393      8.6291542      8.5246935
    [392]       7.6051049      5.7919550      3.0460649    -0.36312318
    [396]      -3.1732512     -3.8958480     -2.7162707    -0.15352954
    [400]       2.6511183      4.8573761      6.2729487      6.9391599
    [404]       6.9285703      6.2907696      5.0526953      3.2718983
    [408]       1.1978600    -0.49488297     -1.0669854    -0.61448902
    [412]      0.46055663      1.9302516      3.4486585      4.6500092
    [416]       5.3222189      5.3671207      4.7080112      3.2295568
    [420]      0.76719451     -2.7277951     -6.1837330     -7.1039252
    [424]      -6.5368538     -4.8390217     -1.5085846      1.7288138
    [428]       4.0172968      5.3477097      5.8771086      5.7676916
    [432]       5.1458993      4.0569091      2.4274387     0.10652046
    [436]      -2.8794436     -5.4656339     -5.5441451     -3.5117643
    [440]     -0.69200492      2.0331182      4.0582304      5.1663785
    [444]       5.3603778      4.7573657      3.5894785      2.1880713
    [448]      0.79839176    -0.60500926     -2.0875373     -3.2809260
    [452]      -3.2516062     -1.6295574     0.63820243      2.6278644
    [456]       3.9585223      4.5284719      4.3328128      3.3983021
    [460]       1.7725830    -0.44139588     -2.9712493     -5.2509995
    [464]      -6.8785133     -8.4765663     -11.136355     -13.398221
    [468]      -9.4565353     -5.1897879     -2.5614171     -1.1898452
    [472]     -0.75783515     -1.0323708     -1.7959702     -2.8326387
    [476]      -3.9785933     -5.1459723     -6.1864357     -6.7472081
    [480]      -6.5204701     -5.5550327     -4.0444632     -2.2505205
    [484]     -0.54155064     0.77987266      1.5654024      1.7704090
    [488]       1.3853709     0.39914292     -1.1641712     -3.0157726
    [492]      -4.2305021     -4.1675158     -3.7950916     -4.0079327
    [496]      -4.5371146     -4.0093079     -2.2040920    -0.52462268
    [500]      0.32431260     0.25415093    -0.66730553     -2.3350921
    [504]      -4.4953799     -6.1172814     -5.5478840     -3.7591064
    [508]      -2.5072393     -2.3897491     -3.6305869     -6.2916765
    [512]      -8.4510288
  [Tag]        10401
  [frame_len]          320
[Record 66]
  [tot_power]       216592.33
  [re_spec_val]
    [0]       16.564405      16.252823      15.337512      13.875470
    [4]       11.954056      9.6765957      7.1744790      4.7748532
    [8]       3.4777956      4.6279526      7.5938077      10.734680
    [12]       13.214672      14.741024      15.207971      14.568481
    [16]       12.811381      9.9972992      6.2690334      1.2784852
    [20]      -6.6585774      5.1807852      13.604443      19.289660
    [24]       23.298250      26.002754      27.583567      28.132532
    [28]       27.680567      26.199423      23.583767      19.614990
    [32]       14.039147      8.3661737      7.4395700      9.1850863
    [36]       13.860603      18.635786      22.091534      24.276262
    [40]       25.326405      25.286793      24.098183      21.551302
    [44]       17.088423      8.7978668      1.3688591      9.0400772
    [48]       11.177292      12.456712      14.768010      17.518505
    [52]       19.724680      21.069233      21.494221      20.963570
    [56]       19.373407      16.509661      12.508558      11.143210
    [60]       13.328508      14.130633      13.823898      17.381536
    [64]       22.676474      26.504509      28.857361      29.962528
    [68]       29.944271      28.863689      26.837292      24.410645
    [72]       22.940819      22.766552      22.488468      21.718338
    [76]       22.496548      25.807316      29.073473      31.293095
    [80]       32.424957      32.529968      31.635429      29.727068
    [84]       26.755148      22.640100      17.249105      10.085213
    [88]      -1.4141976      6.0126534      13.058741      17.391693
    [92]       20.099735      21.452814      21.565464      20.523897
    [96]       18.511137      16.107967      14.489731      14.188921
    [100]       14.277067      13.601192      11.724126      13.404143
    [104]       18.958607      23.035685      25.482401      26.657816
    [108]       26.836620      26.321789      25.556795      24.995466
    [112]       24.665279      24.145462      22.957611      20.577095
    [116]       15.790427    -0.73279774      12.873238      19.050785
    [120]       21.642139      22.514448      22.165155      20.768637
    [124]       18.371603      14.985530      10.791184      6.7695398
    [128]       5.2022772      6.7236557      9.0519638      10.702333
    [132]       11.415611      11.440892      11.242221      11.182944
    [136]       11.264228      11.347986      11.400838      11.380101
    [140]       11.089159      10.218543      8.3902807      4.9939408
    [144]      -1.7280114     -11.267014    -0.23498997      3.8525870
    [148]       5.9144173      7.0726838      7.6501665      7.7468934
    [152]       7.4587579      6.9388204      6.3591003      5.8039341
    [156]       5.1636753      4.1862855      2.7787585      1.5571727
    [160]       1.5816365      2.2341654      2.1618958     0.84371835
    [164]      -1.3517985     -2.6302071     -2.4586606     -2.9336536
    [168]      -4.5644574     -4.5383410     -1.3139470      2.2606423
    [172]       5.4441547      8.0260363      9.7618256      10.513893
    [176]       10.228230      8.8930273      6.6196203      4.1517987
    [180]       3.4338970      4.6547990      6.0266814      6.8378038
    [184]       6.9936666      6.5758138      5.9120312      5.6502028
    [188]       6.1246834      6.7726264      6.8723993      5.9701228
    [192]       3.6222391     -1.2046269     -11.168663     -3.6560776
    [196]       1.5344758      3.9366338      5.0501690      5.4554672
    [200]       5.4535546      5.1715932      4.5975108      3.7265828
    [204]       2.9815316      3.5410109      5.6239977      7.9103618
    [208]       9.6032276      10.491415      10.492699      9.4819345
    [212]       7.2919202      4.4452624      4.5761542      7.3565855
    [216]       9.2067289      9.6433029      8.9313259      7.9670000
    [220]       8.4584026      10.220981      11.667027      12.162093
    [224]       11.547383      9.7010870      6.6573849      4.2373838
    [228]       5.4025722      7.0534635      7.4374833      6.7936883
    [232]       6.1622887      6.6225710      7.5620332      7.9222898
    [236]       7.3025866      5.5912499      2.6755679     -1.6281754
    [240]      -6.4942546     -7.0313382     -6.0697742     -7.1489000
    [244]      -4.4269776      2.1255534      6.8533635      9.9156456
    [248]       11.700801      12.386245      12.018862      10.607548
    [252]       8.4564905      7.1383042      8.0409107      9.4114256
    [256]       10.247156      10.948983      12.088846      13.478009
    [260]       14.540688      14.945760      14.577839      13.360841
    [264]       11.137868      7.6341586      3.3919730      3.4837689
    [268]       6.1847167      7.6068273      7.8802080      7.7026663
    [272]       7.7424111      8.0479336      8.1525183      7.6953883
    [276]       6.5365987      4.6036811      1.7229731     -2.6658869
    [280]      -10.814620     -18.529596     -7.7874508     -3.9175954
    [284]      -1.0503314      2.0522425      5.0240393      7.3131647
    [288]       8.6823874      9.0174150      8.1445370      5.6263533
    [292]     0.052339207     -9.1736670      1.1385341      5.6501861
    [296]       7.9153385      9.3149595      10.446772      11.450658
    [300]       12.191014      12.495652      12.245149      11.337367
    [304]       9.6125927      6.7298346      1.8070718     -7.1294847
    [308]      -2.4968913      2.6382759      4.9167309      5.7731624
    [312]       5.7659945      5.2344704      4.4665847      3.6949241
    [316]       3.0289657      2.4495051      1.8795019      1.2403464
    [320]      0.47144684    -0.45578176     -1.5069867     -2.5298777
    [324]      -3.2582800     -3.5104525     -3.3257916     -2.7450986
    [328]      -1.7484149    -0.51740801     0.57245976      1.1811043
    [332]       1.0417269    -0.17802387     -3.2225127     -11.236098
    [336]      -12.852429     -2.7169421      1.2685190      3.0765932
    [340]       3.4351645      2.4983380     0.17376670     -3.4492965
    [344]      -5.1725874     -2.7282662    -0.95015496    -0.96993309
    [348]      -2.9776344     -7.4884853     -12.201754     -10.213510
    [352]      -11.343026     -13.371259     -3.4447334      2.1831458
    [356]       5.2458262      6.6454282      6.7121172      5.5574880
    [360]       3.2583716     0.38192347     -1.1520925     -1.1419120
    [364]      -2.0874681     -5.8268614     -11.012750     -3.9745276
    [368]      0.34642053      2.1204631      2.1966147     0.78940517
    [372]      -2.3318026     -8.2142887     -14.492398     -8.1516161
    [376]      -5.0988560     -4.4718184     -5.5136056     -8.0818558
    [380]      -12.421099     -17.176710     -13.900164     -9.6710558
    [384]      -6.9592385     -5.0843563     -3.3900390     -1.4887106
    [388]      0.38480610      1.6823144      1.9448638     0.73085284
    [392]      -2.7299154     -8.0104008     -3.0377882      1.6826304
    [396]       4.0330191      4.8643274      4.5278502      3.1530135
    [400]      0.85433596     -1.7622689     -3.0046110     -2.7113063
    [404]      -2.8463292     -4.5377073     -7.8941555     -7.1620684
    [408]      -2.4236403     0.71246040      2.2917726      2.6495273
    [412]       1.9183735     0.11610144     -2.4401593     -3.6258409
    [416]      -2.0644374    -0.64697254    -0.80252510     -3.1771784
    [420]      -9.3225222     -9.5334139     -2.7577386     0.24005337
    [424]       1.0767546     0.19892654     -2.6075263     -8.5835714
    [428]      -13.614620     -6.4345174     -3.2957373     -2.5841539
    [432]      -3.6800883     -6.0513358     -6.0453353     -2.4250348
    [436]      0.56069130      2.2451789      2.8099022      2.3734484
    [440]       1.0029784    -0.97393435     -2.2352080     -1.7786424
    [444]      -1.2583258     -2.2282929     -5.9821458     -14.998879
    [448]      -6.5906434     -1.1545275      1.2570509      2.0062146
    [452]       1.5071959    -0.14293285     -2.8860099     -5.6033525
    [456]      -5.2467027     -3.4971583     -2.9635141     -4.3493562
    [460]      -8.1295252     -8.4728508     -2.8404455     0.68305820
    [464]       2.3360245      2.5403435      1.3939643     -1.2724950
    [468]      -5.9875727     -12.186888     -10.452512     -8.0243406
    [472]      -8.1814537     -10.266272     -11.468484     -8.5363388
    [476]      -5.5200591     -3.7573769     -3.0914602     -3.3694627
    [480]      -4.5060606     -6.2673483     -7.8057408     -8.1663656
    [484]      -8.2053041     -9.3788462     -12.288175     -12.735392
    [488]      -8.0558786     -4.5625024     -2.6647582     -1.9927701
    [492]      -2.3572485     -3.6782143     -5.7739987     -7.7237720
    [496]      -7.9836531     -7.3894105     -7.7027569     -9.5238981
    [500]      -11.049079     -8.2463541     -4.9978790     -3.2988486
    [504]      -3.1324713     -4.5159588     -7.8430586     -14.595437
    [508]      -21.643736     -14.367337     -12.252605     -12.545945
    [512]      -13.144368
  [Tag]        10561
  [frame_len]          320
[Record 67]
  [tot_power]       219426.50
  [re_spec_val]
    [0]       17.175692      16.775185      15.586604      13.664132
    [4]       11.152158      8.3426952      5.6122622      3.4205277
    [8]       3.5462565      6.9631295      10.810958      13.764960
    [12]       15.661686      16.499378      16.261610      14.903861
    [16]       12.378417      8.7033796      4.0209646     -2.2040923
    [20]      -12.727168      4.7154145      13.213588      18.931425
    [24]       22.895420      25.475393      26.845692      27.076691
    [28]       26.155361      23.971680      20.259968      14.459181
    [32]       6.2163157      3.8052690      5.7554021      9.9863310
    [36]       15.081482      19.073818      21.911110      23.692059
    [40]       24.427956      24.058260      22.432819      19.211237
    [44]       13.477580      3.1055565      7.6870155      11.722041
    [48]       13.481766      15.036812      17.175615      19.510948
    [52]       21.366327      22.368639      22.326469      21.007605
    [56]       17.855375      11.071153      6.8665195      14.378998
    [60]       16.868546      17.666815      20.354284      24.640192
    [64]       28.095095      30.291843      31.330177      31.312927
    [68]       30.322615      28.554399      26.708878      26.007935
    [72]       26.268597      26.083368      24.626358      22.416697
    [76]       23.967274      27.983646      30.830740      32.337341
    [80]       32.710789      32.065304      30.423801      27.725271
    [84]       23.795599      18.246473      10.675507      8.7031059
    [88]       13.135695      16.791634      19.770491      21.941528
    [92]       23.190374      23.503698      22.940691      21.663954
    [96]       20.044874      18.724684      18.245684      18.444637
    [100]       18.646503      18.238419      17.047935      16.352386
    [104]       18.284054      21.027491      22.891106      23.689907
    [108]       23.565296      22.744741      21.600719      20.628946
    [112]       20.018614      19.318195      17.791285      14.530023
    [116]       7.1216021     -1.8838114      9.6970587      12.176767
    [120]       11.478969      8.0355387      2.7804732      5.1668162
    [124]       8.3143911      9.1243677      8.2635689      6.6427927
    [128]       7.0331583      10.111073      13.057793      15.063375
    [132]       16.160969      16.445013      15.975090      14.782349
    [136]       12.893390      10.389757      7.6053653      5.4945741
    [140]       4.9387064      5.1789584      5.1964989      4.7220407
    [144]       3.9254906      3.1292782      2.5674474      2.2914364
    [148]       2.2658377      2.4162936      2.6341677      2.8070674
    [152]       2.8023946      2.4163582      1.3875754    -0.34444913
    [156]      -1.5337391    -0.14442378      1.9204930      2.9112840
    [160]       2.7577302      2.4050324      3.4403603      5.4761958
    [164]       7.1396260      7.9601121      7.8603206      6.8091912
    [168]       5.0615082      4.4862986      6.8337808      9.6387672
    [172]       11.519932      12.339555      12.119576      10.872730
    [176]       8.7592392      6.7819018      6.7708840      7.9507098
    [180]       8.6479998      8.4106474      7.2096286      5.1065822
    [184]       2.6299236      1.8834826      3.4682693      4.8109226
    [188]       4.6371408      2.2323375     -2.1168277      2.0743525
    [192]       7.1783600      9.9148216      11.054602      10.986197
    [196]       9.9205399      8.1539488      6.4959574      5.9716511
    [200]       5.9945025      5.0607262      1.6057466     -9.1984835
    [204]       1.0546771      7.5920558      10.810819      12.366205
    [208]       12.799066      12.428337      11.606201      10.779395
    [212]       10.223584      9.7709713      9.1990557      8.9003267
    [216]       9.7592649      11.541308      13.188751      14.158338
    [220]       14.304074      13.574472      11.897699      9.1813126
    [224]       5.7741466      4.4632339      6.4021039      8.1272516
    [228]       8.5912228      7.6012249      4.6689720     -1.8522375
    [232]      -3.4958456      3.7818749      7.1763415      8.6598682
    [236]       8.9220810      8.2108965      6.6426630      4.5160489
    [240]       3.1574092      4.5438461      7.6046748      10.633619
    [244]       13.056024      14.684652      15.430650      15.222200
    [248]       13.957725      11.467676      7.5788336      3.5042508
    [252]       4.0405536      6.4768333      8.3028822      9.8109627
    [256]       11.208864      12.392718      13.186072      13.448242
    [260]       13.059894      11.883149      9.7014132      6.0646548
    [264]     -0.11432045     -4.1102667      1.9940447      5.2955451
    [268]       6.6378660      6.5854888      5.2307353      2.3362193
    [272]      -3.0375335     -12.411002     -5.5018120     -1.0379975
    [276]      0.61335677     0.56414199    -0.69966781     -2.1800885
    [280]      -2.2938802     -1.3086239     0.23303522      2.8213365
    [284]       5.7741222      8.0810108      9.3868876      9.6329336
    [288]       8.7970095      6.8060384      3.4827235     -1.4293028
    [292]      -6.1615791     -4.2708616     -1.2103540     0.80472267
    [296]       2.0679760      2.7882054      3.0883660      3.0539925
    [300]       2.7335470      2.1121767      1.0773185    -0.60058343
    [304]      -3.3053703     -7.7498279     -14.473368     -12.808426
    [308]      -9.0549231     -8.3885956     -10.886220     -21.149689
    [312]      -15.584522     -7.8555398     -4.7284865     -3.4450397
    [316]      -3.1398010     -3.2723978     -3.4898956     -3.7019100
    [320]      -4.0095501     -4.5172648     -5.2161045     -5.8697624
    [324]      -5.8689060     -4.8025823     -3.3364353     -2.3821642
    [328]      -2.4418266     -3.7942352     -6.4133554     -7.9005456
    [332]      -5.4781528     -3.1063006     -2.3239796     -3.3607254
    [336]      -6.5595403     -8.6430521     -3.9533155    -0.47239757
    [340]      0.91378134     0.45083269     -2.1787252     -8.6664524
    [344]      -10.745432     -3.0554106     0.27725345      1.4588848
    [348]       1.1531936   -0.096753418    -0.23546322      2.3739455
    [352]       5.2474146      7.0966277      7.7984872      7.3523698
    [356]       5.6671247      2.4746475     -2.7001915     -7.5777864
    [360]      -5.4084053     -3.7489579     -3.1847944     -1.0803338
    [364]       2.4276037      5.4211140      7.4077034      8.4314632
    [368]       8.5919962      7.9920378      6.8004866      5.3935833
    [372]       4.3896661      4.0934119      4.0703945      3.7963200
    [376]       3.1057763      2.1657953      1.3287759     0.75503612
    [380]      0.13610254     -1.0490030     -3.3322060     -7.4113851
    [384]      -11.755555     -7.2775278     -2.9955456    -0.64791727
    [388]      0.34153333     0.33454862   -0.055171177     0.45221600
    [392]       2.3016233      4.2802377      5.5559282      5.9044714
    [396]       5.2677693      3.5905406     0.81350881     -2.8597445
    [400]      -5.8536754     -6.3603997     -6.2620029     -6.3711715
    [404]      -5.4158611     -3.2693660     -1.3509090    -0.39133766
    [408]     -0.63684660     -2.3591349     -5.9607434     -8.6252813
    [412]      -4.4232545    -0.86593419     0.92650598      1.3355899
    [416]      0.45366728     -1.9935864     -7.1991529     -25.217596
    [420]      -9.8911524     -4.7865014     -3.1736956     -3.3065684
    [424]      -4.0171208     -3.4541416     -1.5731753    0.030059054
    [428]      0.76468158     0.72916615     0.41436139     0.59440821
    [432]       1.5029383      2.5028136      2.9895322      2.6849835
    [436]       1.4445692    -0.89516979     -4.6152582     -9.9960814
    [440]      -13.995601     -12.258761     -11.058636     -10.802162
    [444]      -9.2887602     -6.0929112     -3.0148320    -0.79647434
    [448]      0.46222359     0.72970897    -0.10530818     -2.3411326
    [452]      -6.7646942     -14.595056     -11.002543     -6.6216326
    [456]      -5.2837882     -5.5632281     -5.4813848     -3.1338313
    [460]     -0.30450919      1.5767195      2.2747567      1.7378819
    [464]     -0.19748859     -3.9495437     -9.8664551     -11.105479
    [468]      -8.1939983     -8.0047827     -11.188961     -20.991451
    [472]      -11.591969     -5.4744539     -2.5990169     -1.5165905
    [476]      -1.8811738     -3.7608898     -7.7274804     -16.171829
    [480]      -18.491796     -11.311135     -9.1725273     -9.3258562
    [484]      -10.878729     -11.302114     -8.1536665     -4.7519798
    [488]      -2.4794683     -1.3409483     -1.2609842     -2.2221422
    [492]      -4.2110176     -6.9444895     -9.1537218     -9.6764574
    [496]      -10.119024     -12.474967     -20.722757     -17.848442
    [500]      -8.4154978     -3.8880634     -1.2690507     0.10115378
    [504]      0.42371523    -0.27361247     -2.0783999     -5.2207866
    [508]      -10.117643     -15.621470     -14.222561     -11.727107
    [512]      -10.956765
  [Tag]        10721
  [frame_len]          320
[Record 68]
  [tot_power]       218758.16
  [re_spec_val]
    [0]       11.121522      10.618565      9.0965996      6.4996204
    [4]       2.6262867     -3.3308575     -15.981033     -16.393940
    [8]      -14.714684     -5.3214626      3.7810144      9.2637167
    [12]       12.648169      14.505780      15.072484      14.443195
    [16]       12.659118      9.7763309      5.8483119     0.41786551
    [20]      -6.8723655      1.2084625      9.3674965      15.642847
    [24]       20.423679      23.872988      26.133062      27.301575
    [28]       27.424082      26.494070      24.449808      21.164188
    [32]       16.423159      9.8580465     0.35322821     -17.606804
    [36]       2.7380483      11.114831      16.933542      20.950623
    [40]       23.502195      24.786963      24.921038      23.971804
    [44]       21.994125      19.085384      15.453191      11.331223
    [48]       6.2521830      2.9364274      11.737927      18.155609
    [52]       22.422295      25.207956      26.784380      27.249599
    [56]       26.578215      24.599619      20.915899      15.036867
    [60]       10.679536      10.275237      12.726911      21.521238
    [64]       27.444185      31.245863      33.612617      34.865952
    [68]       35.155285      34.525124      32.922371      30.154482
    [72]       25.751057      18.679811      14.106855      18.387951
    [76]       20.427961      21.484303      22.211882      22.265678
    [80]       21.203375      18.911242      16.289297      15.671032
    [84]       16.273098      16.078650      14.914216      13.652652
    [88]       13.570279      14.735933      16.296799      17.682678
    [92]       18.602898      18.915646      18.567801      17.536253
    [96]       15.758794      13.027923      8.7579432      1.1667418
    [100]      -2.8358960      4.5820017      8.8252592      12.590504
    [104]       16.048038      18.808390      20.738747      21.867718
    [108]       22.265673      22.006725      21.159954      19.780785
    [112]       17.888798      15.428117      12.211782      7.8464222
    [116]       2.1587851      1.4562143      5.7240119      8.7104111
    [120]       10.490545      11.296969      11.187358      10.159120
    [124]       8.2347860      5.6727715      3.4539633      2.7575135
    [128]       3.0467489      3.6346841      4.7233810      6.2915354
    [132]       7.8546538      9.0888977      9.9554472      10.513627
    [136]       10.763470      10.608657      9.9295034      8.6855392
    [140]       7.0103068      5.2665539      3.9185114      3.2619174
    [144]       3.3159857      3.8193815      4.5371900      5.5482769
    [148]       6.8436041      8.0009375      8.5637426      8.3163557
    [152]       7.3024325      5.9285703      4.9735537      4.7054930
    [156]       4.3867660      3.2124579     0.60256344     -2.3082948
    [160]       1.4167478      6.3996458      9.7768011      11.853806
    [164]       12.842099      12.802423      11.708576      9.5009270
    [168]       6.2951889      3.3397989      2.8821120      3.4282391
    [172]       2.8033342    -0.59951699     -14.384680      1.1141326
    [176]       7.8298416      11.305620      13.096850      13.700885
    [180]       13.364263      12.274786      10.654492      8.7923145
    [184]       6.8934937      4.6825666     0.85865092     -9.6491432
    [188]      0.29716650      7.5871549      11.456555      13.569854
    [192]       14.398095      14.124689      12.863491      10.835438
    [196]       8.6464911      7.1652169      6.4891367      6.5222449
    [200]       7.9484572      10.373367      12.609710      14.138102
    [204]       14.850201      14.716147      13.685747      11.674685
    [208]       8.6514177      5.2808089      4.1422615      5.2896919
    [212]       6.2083893      6.2136664      5.2183585      3.3471692
    [216]       2.3423638      4.6194258      7.4975119      9.2935028
    [220]       9.8898029      9.3638716      7.7981896      5.3911476
    [224]       2.8009324      1.4475758      2.3163497      4.6063809
    [228]       7.0341568      8.9314756      10.107381      10.538370
    [232]       10.225180      9.1556673      7.3515768      5.1549706
    [236]       3.9350469      4.8670821      6.5932188      7.9980588
    [240]       8.9396811      9.5754824      10.088718      10.532909
    [244]       10.763501      10.513428      9.4795923      7.2856154
    [248]       3.2046063     -5.5083165     -10.712530     -1.2392309
    [252]       1.4775298      2.1283054      1.6874182     0.49378136
    [256]      -1.4998176     -4.7186089     -8.3285275     -5.2500653
    [260]     -0.81858462      1.8123319      3.0174572      3.1672800
    [264]       2.6542380      2.0547733      1.9241104      2.2078676
    [268]       2.3828228      2.0736270      1.2786520     0.46290222
    [272]      0.23325267     0.34575513   -0.063738160     -1.6854845
    [276]      -5.2043562     -10.780709     -7.9983621     -2.8763978
    [280]      0.26346073      2.2948697      3.6075563      4.2423658
    [284]       4.0395889      2.7020738    -0.29691458     -6.0608983
    [288]      -10.377449     -5.0228543     -2.6838648     -2.7259707
    [292]      -4.6210618     -8.3864183     -13.242101     -11.638692
    [296]      -6.9417424     -3.2114971    -0.35446310      1.7043924
    [300]       3.0272799      3.7086020      3.8418384      3.4803631
    [304]       2.6344242      1.3284065    -0.30070591     -1.9740710
    [308]      -3.5376227     -5.3896275     -8.4259892     -10.862671
    [312]      -5.5758781    -0.63038999      2.4105980      4.0097475
    [316]       4.4287372      3.8338299      2.4516447     0.76951599
    [320]     -0.49214324     -1.0678140     -1.2053920    -0.83730525
    [324]      0.20838527      1.6407580      3.0256007      4.0943170
    [328]       4.6841116      4.6742258      3.9959018      2.7031155
    [332]       1.1535416     0.12404221    0.028140953     0.23847875
    [336]     0.099656470    -0.42574137    -0.54089636     0.79407299
    [340]       2.9609404      4.7973084      5.8447084      5.9964471
    [344]       5.2332897      3.6227825      1.6155179     0.53213388
    [348]       1.1205875      2.1892273      2.9157543      3.2560110
    [352]       3.4406729      3.7382541      4.2346663      4.7269149
    [356]       4.9007149      4.5355077      3.5961826      2.3711760
    [360]       1.6326898      1.9751835      2.8849907      3.6339741
    [364]       3.9303048      3.7331536      3.0964067      2.1352477
    [368]      0.99923289    -0.24377593     -1.7671354     -4.0311475
    [372]      -7.8056922     -13.614843     -12.303854     -7.9212742
    [376]      -5.9561825     -5.5412693     -5.4874668     -4.1978073
    [380]      -1.8311406     0.30683872      1.7100589      2.3349583
    [384]       2.2150924      1.3583335    -0.21158537     -2.0706723
    [388]      -2.5759342     -1.0010496     0.73709929      1.5508472
    [392]       1.1625404    -0.64552164     -4.2481990     -8.7305822
    [396]      -7.1087151     -4.1912241     -3.2596517     -4.0996184
    [400]      -6.7004933     -11.385668     -15.646428     -12.572906
    [404]      -10.008389     -9.1233797     -8.9458942     -8.1114073
    [408]      -6.1513829     -4.1405244     -2.8942056     -2.6987090
    [412]      -3.7125430     -6.1274533     -9.6932068     -10.482560
    [416]      -7.4613385     -5.1319351     -4.0509610     -4.0906949
    [420]      -5.3284717     -8.1606159     -13.058614     -13.481524
    [424]      -8.8166447     -6.3454833     -5.8168406     -7.0115371
    [428]      -10.266220     -17.433926     -22.425228     -13.463596
    [432]      -10.166626     -9.4438066     -11.143863     -16.491190
    [436]      -15.535328     -8.6710472     -5.2707300     -3.8581936
    [440]      -3.7629285     -4.5310512     -5.5470495     -5.9732499
    [444]      -5.4655170     -4.5313544     -3.7703016     -3.5790665
    [448]      -4.3113618     -6.4770064     -11.100389     -16.623795
    [452]      -10.981229     -7.7035942     -7.3552818     -9.8721962
    [456]      -17.792652     -15.588342     -8.3038664     -5.4030933
    [460]      -4.6959662     -5.8395314     -9.3304062     -14.692709
    [464]      -9.5955257     -4.7779160     -2.3314943     -1.3810030
    [468]      -1.5160947     -2.4562206     -3.8066733     -4.8641543
    [472]      -4.9777627     -4.3691916     -3.6949553     -3.2854950
    [476]      -3.0882676     -2.8107905     -2.2506757     -1.6229877
    [480]      -1.3711704     -1.8535663     -3.2863338     -5.6300063
    [484]      -7.6874509     -7.1223288     -5.2815013     -3.9667928
    [488]      -3.3679771     -3.2802358     -3.4283743     -3.4566734
    [492]      -3.0555425     -2.3076775     -1.6492143     -1.4814136
    [496]      -2.0297379     -3.3637764     -5.2533221     -6.6373687
    [500]      -6.1861153     -4.6378069     -3.0996318     -1.8059640
    [504]     -0.73532635    0.085041299     0.57659340     0.66682827
    [508]      0.31780824    -0.46009207     -1.5624367     -2.6682096
    [512]      -3.1682408
  [Tag]        10881
  [frame_len]          320
[Record 69]
  [tot_power]       151767.58
  [re_spec_val]
    [0]      -14.624944     -10.356292     -8.3765383     -11.713687
    [4]      -15.026467     -4.4499078     0.71782678      4.1748705
    [8]       7.2288799      9.9928818      12.148210      13.510100
    [12]       14.048001      13.759757      12.562917      10.199301
    [16]       6.1058760    -0.57375646     -2.6370544      2.0349689
    [20]       5.0627513      7.1459289      10.129598      15.147119
    [24]       19.957195      23.500679      25.748741      26.809633
    [28]       26.758562      25.623379      23.380678      19.901449
    [32]       14.670827      6.2499423      9.1933718      15.522851
    [36]       19.695179      22.970339      25.498577      27.175678
    [40]       27.920105      27.682152      26.395296      23.904354
    [44]       19.780857      12.511930      4.8286805      14.187188
    [48]       18.829741      22.067253      24.570518      26.339058
    [52]       27.306057      27.451551      26.807230      25.478754
    [56]       23.698643      21.793247      19.846289      17.358179
    [60]       13.774704      13.627789      19.092966      23.629395
    [64]       26.957500      29.379850      31.013323      31.885075
    [68]       31.987461      31.292873      29.750223      27.270929
    [72]       23.708857      18.909746      13.656848      12.060325
    [76]       12.946120      13.196209      12.806603      12.017405
    [80]       10.630812      8.3653021      6.3338103      7.3400502
    [84]       9.4004068      10.572144      10.972413      11.139758
    [88]       11.451329      11.859072      12.043623      11.691514
    [92]       10.689908      9.4498215      9.0284147      9.5034342
    [96]       9.5913086      8.3129997      4.6976357     -5.1687346
    [100]      -1.9080652      5.4902353      8.4911423      9.6758194
    [104]       9.6215601      8.3974400      5.9689488      3.7489216
    [108]       5.4552116      8.2778149      9.8963537      10.262252
    [112]       9.5378704      7.8171439      5.1348100      1.5847347
    [116]      -2.2312756     -4.8578725     -6.0851293     -6.8613539
    [120]      -6.7629237     -5.0015354     -2.2809787    0.091651849
    [124]       1.4535524      1.6110501     0.54607594     -1.6323246
    [128]      -4.4805398     -6.6280470     -6.2361774     -4.2192154
    [132]      -2.3710387     -1.1195546    -0.20777448     0.58768517
    [136]       1.0781872     0.84858251    -0.52561152     -3.6109476
    [140]      -8.4383764     -5.5783257    0.058005054      3.9143100
    [144]       6.7041521      8.7748194      10.209598      10.991127
    [148]       11.077011      10.417996      8.9504309      6.6271834
    [152]       3.8390875      2.8179822      4.5831575      6.4244967
    [156]       7.3475933      7.5436053      7.7223992      8.6525440
    [160]       10.115300      11.341955      11.903914      11.652201
    [164]       10.495317      8.2885733      4.9111085      1.7773336
    [168]       3.0639396      5.7011857      7.3929048      8.4557285
    [172]       9.4650326      10.623025      11.660769      12.234818
    [176]       12.140950      11.266774      9.5258684      6.9465318
    [180]       4.4178267      4.2486739      5.6937056      6.7002344
    [184]       7.1138048      7.6879606      8.9737806      10.491747
    [188]       11.569114      11.911628      11.437096      10.123347
    [192]       8.0374899      5.7717662      5.0524864      6.1557965
    [196]       7.2299557      7.3931065      6.4297547      4.2701206
    [200]       1.4781386      1.0065166      3.1397016      4.8130817
    [204]       5.3407598      4.7552500      3.0785322     0.41229257
    [208]      -2.0002403     -1.5051908     0.26863983      1.3466612
    [212]       1.7854656      2.2495041      3.1169429      4.0185971
    [216]       4.4396095      4.1258163      3.0065587      1.1431420
    [220]      -1.0098259     -2.0728786     -1.3188926    -0.19959827
    [224]      0.21372572    -0.43001211     -2.3530324     -5.7085366
    [228]      -8.7963820     -7.4287214     -5.5108509     -5.3116307
    [232]      -7.0778394     -11.554815     -18.441580     -11.968511
    [236]      -7.6009116     -5.8802795     -6.0537071     -8.3251047
    [240]      -14.568117     -21.866159     -10.204109     -6.0249295
    [244]      -4.2618775     -3.9577556     -4.7971601     -6.5472956
    [248]      -8.4434013     -8.6018353     -6.8746438     -5.1145296
    [252]      -4.0954504     -3.8735554     -4.2049360     -4.6238470
    [256]      -4.8766503     -5.4016542     -6.9943633     -10.465034
    [260]      -14.325363     -10.606276     -6.8633718     -5.0358486
    [264]      -4.5481539     -5.0071759     -5.9440179     -6.4713798
    [268]      -5.9331923     -5.0142450     -4.6513462     -5.3019314
    [272]      -7.1602058     -9.7523804     -9.8583965     -6.9791603
    [276]      -4.4655447     -2.9007545     -2.0824027     -1.7761998
    [280]      -1.7537241     -1.8230108     -1.9569610     -2.3639731
    [284]      -3.3590684     -5.1037741     -6.8833256     -6.5012512
    [288]      -4.4249229     -2.7554655     -2.0361187     -2.2770922
    [292]      -3.4470406     -5.3018432     -6.3071041     -4.5930910
    [296]      -2.0997858    -0.37369618     0.39306590     0.33887881
    [300]     -0.18805467    -0.50388128   -0.011603797     0.98255914
    [304]       1.7882593      2.0196714      1.5486456     0.41648006
    [308]      -1.0140524     -1.8846089     -1.7517862     -1.3806248
    [312]      -1.4414949     -1.8397985     -1.8409935    -0.93361193
    [316]      0.36277929      1.3952981      1.9116813      1.8631091
    [320]       1.2458035    0.075656973     -1.5418888     -3.2739987
    [324]      -4.6183968     -5.5269508     -6.6054087     -8.3107080
    [328]      -9.8427162     -8.8841925     -6.4776111     -4.6784482
    [332]      -3.9030263     -4.1476007     -5.3516364     -7.1250362
    [336]      -7.9997730     -7.0007091     -5.7386723     -5.2847276
    [340]      -5.6033325     -5.9272885     -5.2771597     -3.9361329
    [344]      -2.8242354     -2.3417115     -2.5378985     -3.3676181
    [348]      -4.7173729     -6.1642885     -6.7244449     -6.0680008
    [352]      -5.3163333     -5.4175897     -6.8442655     -10.060764
    [356]      -15.559279     -18.408354     -16.084850     -16.667503
    [360]      -21.875105     -26.191624     -18.789917     -17.011631
    [364]      -18.975777     -21.787184     -17.330854     -13.910837
    [368]      -13.052390     -14.609276     -19.839529     -31.310129
    [372]      -17.901760     -13.418962     -11.765541     -11.685552
    [376]      -12.180356     -11.695518     -10.123745     -8.8790960
    [380]      -8.6521368     -9.5180120     -11.126611     -12.330581
    [384]      -12.137053     -11.513432     -11.514817     -12.547087
    [388]      -15.181659     -21.905823     -24.818096     -13.986777
    [392]      -9.3746052     -7.0474153     -6.2203860     -6.6585574
    [396]      -8.2988329     -10.999187     -13.757852     -14.575827
    [400]      -14.435719     -15.418637     -18.574020     -26.017593
    [404]      -30.448320     -23.088572     -21.907179     -24.200922
    [408]      -23.427416     -17.416586     -13.377548     -11.024601
    [412]      -9.7929325     -9.3440943     -9.4662199     -10.023651
    [416]      -10.851890     -11.531333     -11.415068     -10.497881
    [420]      -9.5521078     -9.2024603     -9.7341261     -11.212014
    [424]      -13.161639     -13.807043     -12.559140     -11.321131
    [428]      -10.940844     -11.359223     -12.145183     -12.560452
    [432]      -11.969719     -10.513609     -8.8468628     -7.4963031
    [436]      -6.7054830     -6.4957047     -6.7130775     -7.1001496
    [440]      -7.5002499     -8.0278177     -8.9081726     -10.165603
    [444]      -11.436498     -12.219599     -12.537909     -12.659295
    [448]      -12.343796     -11.263350     -9.7926836     -8.5038872
    [452]      -7.6579199     -7.3200965     -7.5288973     -8.3749666
    [456]      -10.039554     -12.847362     -17.271830     -21.433157
    [460]      -18.709661     -15.843912     -14.628209     -14.376682
    [464]      -14.110026     -13.006630     -11.454069     -10.293923
    [468]      -9.9469452     -10.550364     -12.122398     -14.468456
    [472]      -16.736761     -17.642696     -17.549639     -17.470840
    [476]      -17.409725     -16.780378     -15.263746     -13.270692
    [480]      -11.432336     -10.162531     -9.6818085     -10.138175
    [484]      -11.698015     -14.640121     -19.556431     -28.067364
    [488]      -38.366714     -36.614609     -36.455872     -25.406401
    [492]      -19.583786     -16.178226     -14.307442     -13.729730
    [496]      -14.493849     -16.953495     -22.202539     -29.274004
    [500]      -22.317942     -18.653585     -17.509537     -17.970648
    [504]      -19.791235     -22.993845     -26.734592     -26.084841
    [508]      -23.080095     -21.365496     -21.019337     -21.550278
    [512]      -21.973385
  [Tag]        11041
  [frame_len]          320
[Record 70]
  [tot_power]       50458.789
  [re_spec_val]
    [0]       10.938101      10.648075      9.6834345      7.7850332
    [4]       4.5300493    -0.89706033     -10.989382     -9.8639956
    [8]      -3.0830429     0.82579839      3.1543615      4.0831366
    [12]       3.7703867      2.4036534   -0.011985688     -4.4758663
    [16]      -17.734047     -8.7323980     -5.8345847    -0.52919453
    [20]       10.347148      17.501186      22.396620      25.735268
    [24]       27.823206      28.796028      28.691372      27.464529
    [28]       24.961561      20.802660      13.936864      5.8064151
    [32]       12.245852      16.464273      19.444494      21.785480
    [36]       23.445774      24.301590      24.229923      23.100142
    [40]       20.780699      17.336206      14.054277      13.064566
    [44]       12.568903      11.019383      10.248427      12.498891
    [48]       15.143938      17.001390      18.245497      19.111523
    [52]       19.640871      19.703762      19.106016      17.653267
    [56]       15.157338      11.460599      6.7191491      2.5646348
    [60]       2.0150092      4.5155792      6.9460382      7.6033154
    [64]       5.3151321     -6.4809699      3.6349268      11.313031
    [68]       14.837366      16.448952      16.743799      15.956576
    [72]       14.196738      11.556439      8.3759375      6.1732254
    [76]       6.7607083      8.4129524      9.5000925      9.6736383
    [80]       8.9060783      7.2510672      4.9637117      2.9979625
    [84]       2.8720899      4.3325100      6.2308445      8.1434889
    [88]       9.9009609      11.337323      12.317124      12.750307
    [92]       12.572768      11.733064      10.232680      8.3417501
    [96]       7.0265436      7.1451821      7.7787776      7.8333340
    [100]       6.9567580      5.2302217      3.2601454      2.1910353
    [104]       2.2212923      2.5160353      2.7653890      3.0363634
    [108]       3.2719171      3.3060257      3.0329018      2.4414845
    [112]       1.6593513      1.1028178      1.2899486      2.0650544
    [116]       2.7538927      2.9216723      2.4492662      1.3756992
    [120]     -0.17356557     -1.9688307     -3.5774174     -4.3608646
    [124]      -4.0478640     -3.1680179     -2.3790531     -2.0149832
    [128]      -2.1639349     -2.7687533     -3.5693011     -3.8815105
    [132]      -3.0326219     -1.5635010    -0.46678090    -0.23474509
    [136]      -1.0287439     -2.8856878     -5.6817675     -8.4810972
    [140]      -8.5592213     -6.1619792     -3.9145935     -2.5529623
    [144]      -2.0370958     -2.0911305     -2.3736482     -2.7852349
    [148]      -3.6262882     -5.3730092     -8.4875908     -12.691076
    [152]      -12.526972     -8.6616573     -5.6537132     -3.5362327
    [156]      -2.0784290     -1.1598320    -0.67519438    -0.53049827
    [160]     -0.71117526     -1.3459383     -2.7237320     -5.3575335
    [164]      -10.423161     -19.329540     -11.661021     -6.9069738
    [168]      -4.6590061     -3.5566807     -2.9745824     -2.5912054
    [172]      -2.3782933     -2.5444434     -3.4086313     -5.3783774
    [176]      -9.1683445     -16.938431     -22.385000     -14.379873
    [180]      -11.667353     -9.5776005     -6.7637844     -4.1835904
    [184]      -2.5492251     -1.9834864     -2.4508772     -3.8844960
    [188]      -6.1459002     -8.9108057     -11.789074     -15.176301
    [192]      -20.906734     -20.322306     -13.078390     -8.9269161
    [196]      -6.5269542     -5.2900028     -4.9531446     -5.3475552
    [200]      -6.3135972     -7.7080207     -9.5133486     -11.961717
    [204]      -15.541336     -20.838669     -25.956163     -23.298994
    [208]      -18.227793     -13.672587     -10.344916     -8.3109484
    [212]      -7.4599214     -7.6788397     -8.8261938     -10.572154
    [216]      -12.248129     -13.467047     -15.011583     -18.236431
    [220]      -23.324980     -19.663919     -14.984179     -12.556580
    [224]      -11.365894     -10.705896     -10.206443     -9.9132700
    [228]      -10.071607     -10.853506     -12.304973     -14.464213
    [232]      -17.616718     -22.387531     -25.031204     -21.213678
    [236]      -19.479013     -20.971563     -24.981380     -19.316071
    [240]      -13.829557     -10.940392     -9.7659407     -9.9177618
    [244]      -11.209264     -13.473673     -16.380980     -19.353588
    [248]      -21.837305     -22.782602     -21.141920     -18.594248
    [252]      -16.206440     -14.009716     -12.134519     -10.855774
    [256]      -10.365438     -10.733301     -11.946205     -13.964309
    [260]      -16.897467     -21.538227     -32.183712     -31.429884
    [264]      -25.210367     -26.745726     -39.027122     -21.273922
    [268]      -15.261406     -12.498851     -11.707759     -12.488451
    [272]      -14.480359     -16.598816     -17.553576     -18.532089
    [276]      -20.891798     -21.925179     -19.438959     -18.432619
    [280]      -20.456636     -22.719400     -17.252134     -13.312544
    [284]      -11.774362     -12.025817     -13.507360     -15.056245
    [288]      -15.649777     -16.329138     -17.970848     -18.755972
    [292]      -17.220552     -16.388329     -17.900341     -22.438980
    [296]      -22.395643     -17.574362     -15.685081     -16.065550
    [300]      -17.766140     -18.916897     -19.213161     -21.127314
    [304]      -23.918816     -18.530153     -14.063732     -12.163555
    [308]      -12.314311     -14.428362     -18.314865     -20.584164
    [312]      -19.311012     -19.086140     -19.425665     -17.945137
    [316]      -16.143744     -15.660178     -16.091209     -15.494284
    [320]      -13.553936     -12.137777     -12.006792     -13.188424
    [324]      -15.298325     -17.205441     -18.182167     -19.496517
    [328]      -22.117903     -23.904629     -22.453348     -22.011152
    [332]      -25.062656     -42.674011     -25.564939     -19.391933
    [336]      -16.708094     -15.484388     -14.996840     -15.083181
    [340]      -16.016340     -18.303589     -22.518612     -26.961948
    [344]      -25.692879     -24.684109     -24.560476     -22.611584
    [348]      -20.763493     -21.366484     -27.215240     -29.538675
    [352]      -18.343538     -13.825382     -11.538109     -10.463105
    [356]      -10.148211     -10.415434     -11.329544     -13.167889
    [360]      -16.346397     -19.907898     -17.687277     -13.878882
    [364]      -11.634852     -10.701439     -10.653313     -10.857934
    [368]      -10.546657     -9.6606731     -8.8542604     -8.6095695
    [372]      -9.1011066     -10.396697     -12.597433     -15.931276
    [376]      -20.463772     -21.955956     -18.204023     -15.214493
    [380]      -13.524389     -12.867817     -13.085650     -14.066448
    [384]      -15.670485     -17.667269     -19.731356     -21.619274
    [388]      -23.520014     -26.292654     -31.232227     -29.953690
    [392]      -23.711994     -20.308710     -18.953196     -19.272356
    [396]      -21.122286     -23.599436     -23.508184     -21.574606
    [400]      -20.582956     -20.943424     -22.414167     -24.390308
    [404]      -26.074965     -27.776527     -30.674288     -31.416611
    [408]      -26.608335     -23.034397     -21.207809     -20.640469
    [412]      -20.947096     -21.812532     -23.033207     -24.557795
    [416]      -26.438332     -29.006369     -33.764530     -42.135395
    [420]      -31.279707     -26.142265     -23.974195     -23.653204
    [424]      -24.509863     -25.359041     -25.211563     -24.975637
    [428]      -25.455547     -25.400249     -22.893908     -19.617065
    [432]      -16.938910     -14.961247     -13.575517     -12.707044
    [436]      -12.315289     -12.373633     -12.872175     -13.844234
    [440]      -15.403813     -17.767586     -21.088079     -23.832682
    [444]      -22.505692     -20.333841     -19.499266     -20.117586
    [448]      -22.126644     -25.347448     -28.815763     -30.694529
    [452]      -31.166458     -30.963116     -30.450726     -30.266470
    [456]      -29.645056     -27.502476     -25.296951     -24.298372
    [460]      -24.807386     -26.612770     -27.890522     -26.490662
    [464]      -24.797396     -24.277510     -24.901356     -26.216305
    [468]      -27.492327     -28.116707     -27.961588     -27.233103
    [472]      -26.487913     -26.313250     -26.981382     -28.399633
    [476]      -29.974167     -30.436972     -28.995132     -26.751896
    [480]      -24.990753     -24.226368     -24.472664     -25.107967
    [484]      -24.762396     -23.374039     -22.316128     -22.298725
    [488]      -23.492514     -25.882324     -29.020420     -31.178080
    [492]      -31.036261     -29.779810     -28.141621     -26.526434
    [496]      -25.258307     -24.377474     -23.776377     -23.417978
    [500]      -23.411346     -23.930059     -25.119108     -27.048470
    [504]      -29.610859     -32.075806     -32.576519     -30.617363
    [508]      -27.917131     -25.490015     -23.664186     -22.547298
    [512]      -22.172670
  [Tag]        11201
  [frame_len]          320
[Record 71]
  [tot_power]       25583.340
  [re_spec_val]
    [0]       12.477176      11.931509      10.251174      7.2855935
    [4]       2.6799986     -4.5656095     -20.841240     -14.307708
    [8]      -9.2446470     -6.3932886     -3.9261980     -2.2028818
    [12]      -2.0414867     -4.7449999     -12.683241     -3.6602354
    [16]       1.9200881      4.2539635      6.2782230      10.847523
    [20]       15.983148      20.098120      23.118876      25.187157
    [24]       26.409725      26.845064      26.512939      25.400995
    [28]       23.468403      20.653723      16.913273      12.389580
    [32]       7.9870753      6.0519814      7.6439881      10.441901
    [36]       12.855433      14.561043      15.569135      15.897230
    [40]       15.513512      14.345502      12.295392      9.2742338
    [44]       5.4044418      1.8530627     0.65623283      1.1119372
    [48]       2.3906486      4.5034509      6.8732123      8.9455967
    [52]       10.484403      11.382204      11.549804      10.884714
    [56]       9.2608223      6.5439482      2.7518110     -1.4101361
    [60]      -5.0797014     -5.9988050     0.64444894      5.9020505
    [64]       9.0275583      10.507244      10.525276      9.0381126
    [68]       5.8678942      1.8500987      1.9155535      3.7683103
    [72]       3.9018869      2.1107645     -1.7474988     -7.9842677
    [76]      -10.077287     -6.1514530     -4.0013676     -3.3306322
    [80]      -3.7730544     -5.1443133     -7.2737045     -9.7157621
    [84]      -10.872452     -9.7079411     -8.2082605     -7.5367765
    [88]      -7.5526319     -7.3770781     -6.4490938     -5.6326857
    [92]      -5.8935485     -7.1127973     -6.5126171     -3.3875942
    [96]     -0.90982836     0.16181923   -0.032977499     -1.1727967
    [100]      -2.6694605     -3.9153094     -5.1774721     -7.4884591
    [104]      -12.102691     -18.011915     -13.609777     -10.616952
    [108]      -10.103735     -10.836493     -11.166435     -10.055475
    [112]      -8.4570522     -7.1087155     -6.1289058     -5.6115551
    [116]      -5.7673469     -6.8872499     -9.4104729     -14.266916
    [120]      -21.702087     -17.025549     -13.474756     -12.610052
    [124]      -12.739329     -11.740195     -9.4570246     -7.5270057
    [128]      -6.5839009     -6.6772747     -7.7099414     -9.3138428
    [132]      -10.390391     -9.9541473     -8.9186993     -8.3242579
    [136]      -8.4186563     -9.0934277     -10.098043     -11.143808
    [140]      -12.067059     -12.962152     -14.149099     -16.039343
    [144]      -18.810966     -20.783848     -19.297211     -17.364765
    [148]      -16.729406     -17.451145     -19.349474     -21.874485
    [152]      -23.368441     -22.721241     -21.391109     -20.311562
    [156]      -19.600332     -19.351997     -19.906803     -21.942345
    [160]      -26.852917     -30.309763     -23.237770     -19.775366
    [164]      -18.788126     -19.582262     -21.748035     -23.914476
    [168]      -22.796385     -19.580416     -16.903639     -15.310335
    [172]      -14.686976     -14.403949     -13.441999     -11.827011
    [176]      -10.586724     -10.386510     -11.558623     -14.451740
    [180]      -19.085278     -20.462177     -18.010874     -17.464401
    [184]      -19.213202     -22.778275     -24.814224     -24.041805
    [188]      -25.030218     -30.153284     -53.196178     -30.746353
    [192]      -27.508295     -27.708456     -29.506805     -30.632265
    [196]      -28.703880     -25.027210     -21.689674     -19.370544
    [200]      -18.111752     -17.803368     -18.332935     -19.660934
    [204]      -21.896713     -25.336113     -29.960094     -31.486320
    [208]      -28.293114     -25.214218     -22.747276     -21.091110
    [212]      -20.527906     -21.263592     -23.498964     -27.394457
    [216]      -30.539192     -26.667913     -21.866537     -18.240536
    [220]      -15.742924     -14.272259     -13.718717     -13.931707
    [224]      -14.642118     -15.395620     -15.775548     -15.844545
    [228]      -15.964988     -16.278845     -16.562498     -16.409735
    [232]      -15.640376     -14.501251     -13.416309     -12.740026
    [236]      -12.715294     -13.529915     -15.416862     -18.870583
    [240]      -25.463055     -31.846142     -23.036886     -19.210360
    [244]      -17.553093     -17.169909     -17.653521     -18.540180
    [248]      -19.085165     -18.736914     -17.756657     -16.579193
    [252]      -15.352525     -14.149702     -13.095985     -12.302097
    [256]      -11.808868     -11.602885     -11.655479     -11.954676
    [260]      -12.541608     -13.570907     -15.392256     -18.732243
    [264]      -25.603918     -30.219995     -21.944569     -18.929174
    [268]      -18.250998     -18.947968     -20.352282     -21.887810
    [272]      -23.560356     -25.450260     -24.889143     -21.117857
    [276]      -17.678125     -15.298354     -13.809045     -13.025617
    [280]      -12.818184     -13.093640     -13.772503     -14.786205
    [284]      -16.137318     -18.018816     -20.764275     -22.786303
    [288]      -19.285248     -14.958844     -12.058466     -10.493484
    [292]      -10.183550     -11.240185     -14.107363     -20.305502
    [296]      -28.831860     -19.637714     -16.592194     -16.642809
    [300]      -19.742868     -29.621124     -21.664764     -15.290030
    [304]      -12.704367     -12.406805     -14.405736     -19.169489
    [308]      -17.988585     -12.398403     -9.3753595     -8.1186972
    [312]      -8.2081013     -9.6432543     -12.981488     -20.798403
    [316]      -22.284208     -13.735469     -10.440294     -9.3744497
    [320]      -9.8670874     -11.620704     -13.789262     -14.181792
    [324]      -12.888692     -11.961984     -12.022013     -13.106051
    [328]      -15.272845     -18.793640     -24.383120     -34.186459
    [332]      -48.253235     -31.678551     -23.448116     -18.153139
    [336]      -14.708527     -12.488673     -11.137319     -10.486063
    [340]      -10.532549     -11.426105     -13.461078     -16.940096
    [344]      -19.749043     -17.078867     -14.244157     -13.020152
    [348]      -13.204113     -14.727585     -17.959379     -24.731592
    [352]      -29.396257     -20.028250     -16.047203     -14.116814
    [356]      -13.236075     -13.021171     -13.592864     -15.656691
    [360]      -21.365639     -32.135284     -17.416700     -12.959001
    [364]      -11.300084     -11.409406     -12.927859     -15.052541
    [368]      -15.409077     -13.942014     -13.005418     -13.246163
    [372]      -14.344944     -15.274699     -15.206825     -14.917127
    [376]      -15.307969     -16.508261     -18.006409     -18.954926
    [380]      -19.306065     -19.898729     -21.459103     -24.535688
    [384]      -27.981388     -24.884586     -20.607113     -17.845781
    [388]      -16.147268     -15.210028     -14.983484     -15.544194
    [392]      -16.864454     -18.305433     -18.465343     -17.435217
    [396]      -16.512384     -16.070547     -15.901336     -15.830598
    [400]      -15.915629     -16.231632     -16.623199     -16.678850
    [404]      -16.037069     -14.829028     -13.579035     -12.770597
    [408]      -12.706011     -13.574296     -15.507212     -18.455883
    [412]      -21.427887     -22.436682     -22.605562     -24.087580
    [416]      -28.287268     -36.198792     -27.713858     -22.250753
    [420]      -19.450630     -18.246265     -18.290699     -19.333294
    [424]      -20.729002     -20.976538     -19.558569     -17.909004
    [428]      -16.969595     -17.038189     -18.257994     -20.819305
    [432]      -25.030836     -28.107338     -23.578735     -19.544319
    [436]      -17.309772     -16.439173     -16.477383     -16.829844
    [440]      -17.110022     -17.660191     -19.176920     -22.267530
    [444]      -27.376532     -32.284489     -31.095751     -28.116022
    [448]      -24.795053     -22.204178     -20.772266     -20.391630
    [452]      -20.865458     -22.092655     -24.204153     -27.709707
    [456]      -33.332405     -34.381344     -30.411825     -29.584410
    [460]      -33.145741     -41.817028     -27.631771     -22.011511
    [464]      -19.105501     -17.713507     -17.343473     -17.672731
    [468]      -18.451731     -19.545469     -20.945404     -22.613340
    [472]      -24.283674     -25.684113     -27.168623     -29.602663
    [476]      -32.980751     -31.372475     -26.697552     -23.506943
    [480]      -21.758320     -21.267069     -22.020439     -24.057386
    [484]      -26.949978     -28.446493     -27.869732     -27.978716
    [488]      -29.643736     -30.780878     -28.220430     -25.327686
    [492]      -23.569433     -22.689381     -22.297682     -22.110954
    [496]      -22.009714     -21.969557     -21.945766     -21.874029
    [500]      -21.776304     -21.789869     -22.055574     -22.593889
    [504]      -23.251703     -23.774237     -24.038122     -24.185207
    [508]      -24.444689     -24.934618     -25.607216     -26.242941
    [512]      -26.513830
  [Tag]        11361
  [frame_len]          320
[Record 72]
  [tot_power]       3932.1841
  [re_spec_val]
    [0]       12.543070      12.012912      10.376838      7.4761810
    [4]       2.9411759     -4.2101216     -19.112684     -17.878798
    [8]      -14.074406     -12.139032     -8.0399866     -3.1283066
    [12]      0.93637192      3.7502670      5.3542275      5.8562818
    [16]       5.3416700      3.8073640      1.2789938     0.72413504
    [20]       5.4602671      9.8573847      12.661661      14.020473
    [24]       14.006248      12.554199      9.6059284      6.6305337
    [28]       7.7375531      9.9613733      10.962971      10.780890
    [32]       9.5948029      7.4671497      4.4703832      1.0834628
    [36]      -1.8592576     -5.2790842     -11.583081     -7.5050106
    [40]      -2.2218440    -0.20975919    -0.30099863     -2.0898786
    [44]      -5.5043783     -10.893818     -20.584063     -15.764060
    [48]      -8.4768248     -4.4531169     -1.9509280    -0.23030199
    [52]       1.1794312      2.4202642      3.3166544      3.6120076
    [56]       3.1170394      1.6919767    -0.86575663     -5.1498632
    [60]      -12.782707     -7.9095888    -0.30766612      4.8331351
    [64]       8.6977568      11.579700      13.561088      14.670551
    [68]       14.912936      14.270030      12.693343      10.091077
    [72]       6.3070731      1.0991248     -5.7567210     -13.327790
    [76]      -18.708958     -21.647337     -19.142635     -17.701889
    [80]      -18.576359     -18.989471     -16.302807     -13.668777
    [84]      -12.242700     -11.743778     -11.655755     -11.359588
    [88]      -10.338933     -8.5628500     -6.4953308     -4.6254187
    [92]      -3.2160301     -2.3523667     -2.0253808     -2.1692288
    [96]      -2.6728945     -3.4094226     -4.3183155     -5.5090775
    [100]      -7.3246026     -10.493044     -17.108891     -20.058235
    [104]      -11.022888     -6.8727112     -4.8499894     -4.2233253
    [108]      -4.7641392     -6.4351993     -9.3483448     -13.873509
    [112]      -20.535835     -20.974100     -15.886272     -12.751464
    [116]      -11.034422     -10.499388     -11.048407     -12.069623
    [120]      -11.739209     -9.8936872     -8.5191240     -8.5707359
    [124]      -10.629473     -16.448288     -22.162760     -11.940709
    [128]      -7.7280536     -5.8527527     -5.3744421     -5.8750792
    [132]      -6.8959985     -7.7068481     -7.8374114     -7.7652011
    [136]      -8.2064066     -9.5723915     -12.114944     -15.856671
    [140]      -18.031475     -15.052896     -11.759296     -9.4498615
    [144]      -7.8932757     -6.8330164     -6.0668311     -5.4897738
    [148]      -5.1248188     -5.0667682     -5.3864751     -6.0723839
    [152]      -7.0321569     -8.1711559     -9.5253639     -11.315714
    [156]      -13.826929     -16.861420     -17.793278     -15.176720
    [160]      -12.211824     -9.8627644     -8.1386843     -7.0286002
    [164]      -6.5301189     -6.6004620     -7.1421084     -8.0552511
    [168]      -9.3706293     -11.335422     -14.168380     -16.694918
    [172]      -16.425734     -15.961542     -17.260540     -15.224956
    [176]      -9.4403515     -5.2959275     -2.8204508     -1.6478895
    [180]      -1.5917281     -2.6025903     -4.7659373     -8.3806343
    [184]      -13.939735     -16.731558     -12.389923     -9.4046717
    [188]      -7.7946472     -7.0360537     -6.8529534     -7.0748558
    [192]      -7.5760021     -8.2684946     -9.1194639     -10.148235
    [196]      -11.323093     -12.291804     -12.343703     -11.448256
    [200]      -10.492236     -10.137414     -10.622446     -11.986349
    [204]      -14.111880     -16.551432     -18.351128     -18.719427
    [208]      -17.814184     -16.134190     -14.057245     -11.823299
    [212]      -9.6613760     -7.8055692     -6.4046073     -5.4893222
    [216]      -5.0061765     -4.8855624     -5.1329422     -5.9046764
    [220]      -7.5554671     -10.819194     -18.131479     -24.035723
    [224]      -13.226020     -9.4812078     -7.9866004     -7.7669530
    [228]      -8.3881407     -9.5335197     -10.912694     -12.288289
    [232]      -13.560479     -14.804751     -16.131325     -17.386343
    [236]      -17.999918     -17.443186     -15.788028     -13.621405
    [240]      -11.612048     -10.117470     -9.1506042     -8.5006609
    [244]      -7.9136133     -7.3235521     -6.8966627     -6.8493018
    [248]      -7.3161044     -8.3243580     -9.7537203     -11.245205
    [252]      -12.348232     -13.154173     -14.378535     -16.692942
    [256]      -19.295485     -17.434769     -13.690961     -11.059474
    [260]      -9.3023987     -7.7822852     -6.0496039     -4.2035937
    [264]      -2.6345220     -1.6116767     -1.2265481     -1.4604732
    [268]      -2.2101734     -3.2502680     -4.1635337     -4.4487429
    [272]      -4.0029345     -3.2559233     -2.6650152     -2.4546781
    [276]      -2.6677508     -3.2372251     -4.0103636     -4.7397680
    [280]      -5.1196318     -4.9979887     -4.5647569     -4.1624141
    [284]      -4.0309987     -4.2895179     -5.0358276     -6.4306788
    [288]      -8.6852713     -11.654404     -13.252161     -12.152493
    [292]      -11.481479     -12.994680     -18.902199     -23.225153
    [296]      -12.545445     -8.3804836     -6.6801434     -6.6941609
    [300]      -8.4224195     -11.865773     -11.606158     -6.6137676
    [304]      -3.1119163     -1.1861682    -0.52600694     -1.0310059
    [308]      -2.7385375     -5.6121473     -8.2237158     -7.4854002
    [312]      -5.7249880     -5.1193480     -5.9032202     -7.8915668
    [316]      -9.4567327     -7.6325202     -4.7153716     -2.6482623
    [320]      -1.5746981     -1.4308294     -2.2419114     -4.1853757
    [324]      -7.7532768     -14.611565     -31.969339     -15.945943
    [328]      -12.815243     -12.760160     -14.204606     -14.540384
    [332]      -11.754493     -8.3712444     -5.5584555     -3.4147909
    [336]      -1.9748137     -1.3035163     -1.4864242     -2.6481664
    [340]      -5.0088353     -9.0179682     -15.422340     -18.121696
    [344]      -13.809286     -11.388084     -10.188063     -9.7111406
    [348]      -9.9095411     -10.789497     -12.075492     -12.885524
    [352]      -12.065300     -9.6852865     -6.8606982     -4.4200454
    [356]      -2.7168458     -1.8713078     -1.9161060     -2.8067400
    [360]      -4.2339015     -5.2270141     -4.8753572     -3.9618211
    [364]      -3.5492737     -4.0752149     -5.8099513     -9.2501135
    [368]      -14.384317     -11.981771     -7.1056962     -4.2874827
    [372]      -2.8735759     -2.4673257     -2.8456316     -3.8117681
    [376]      -5.0841041     -6.2168159     -6.7434349     -6.6251087
    [380]      -6.3109593     -6.2845550     -6.8312416     -8.0264359
    [384]      -9.6701593     -11.253042     -12.601647     -14.763788
    [388]      -20.580379     -23.295166     -12.483666     -7.4154191
    [392]      -4.4685826     -2.7647316     -1.9499611     -1.8174841
    [396]      -2.2013569     -2.9584024     -4.0069733     -5.3741503
    [400]      -7.1970291     -9.7272587     -13.527517     -20.522614
    [404]      -26.408770     -16.712343     -12.786056     -10.970794
    [408]      -10.046247     -9.2471876     -8.3919077     -7.8872800
    [412]      -8.2037201     -9.7112188     -12.903212     -18.594929
    [416]      -20.021973     -14.610806     -11.452029     -9.7319784
    [420]      -8.7967434     -8.3749857     -8.4937744     -9.4282684
    [424]      -11.660216     -15.697394     -17.636814     -13.472063
    [428]      -10.608256     -9.4982204     -9.6099024     -10.414983
    [432]      -11.126458     -10.814139     -9.4111156     -7.7821541
    [436]      -6.6734653     -6.4993043     -7.5947909     -10.563987
    [440]      -17.571520     -25.346296     -13.743683     -9.9459362
    [444]      -8.3843622     -8.0152445     -8.4925499     -9.7559872
    [448]      -11.886627     -14.771987     -16.806032     -15.809889
    [452]      -13.915231     -12.548645     -11.629059     -10.913687
    [456]      -10.360323     -10.089466     -10.218186     -10.746553
    [460]      -11.507374     -12.244020     -12.957339     -14.173847
    [464]      -16.743082     -20.077271     -16.730064     -12.133058
    [468]      -9.4919205     -8.3919592     -8.5435152     -9.8329363
    [472]      -12.278114     -16.047697     -21.040039     -22.009027
    [476]      -17.986162     -14.835827     -12.784940     -11.570911
    [480]      -11.012159     -10.877370     -10.825769     -10.580350
    [484]      -10.200866     -9.9787741     -10.137114     -10.741681
    [488]      -11.740083     -12.975893     -14.127429     -14.663035
    [492]      -14.203686     -13.079560     -11.971840     -11.340498
    [496]      -11.374946     -12.077717     -13.275101     -14.593781
    [500]      -15.452424     -15.081075     -13.289388     -11.028658
    [504]      -9.1285944     -7.8366528     -7.1063471     -6.7698517
    [508]      -6.6106339     -6.4476109     -6.2269106     -6.0227637
    [512]      -5.9397879
  [Tag]        11521
  [frame_len]          320
[Record 73]
  [tot_power]       1670.1254
  [re_spec_val]
    [0]       12.528063      11.983104      10.309256      7.3696961
    [4]       2.8402307     -4.1487474     -17.648130     -19.108477
    [8]      -16.330111     -19.777662     -26.491337     -22.272659
    [12]      -17.838245     -14.838677     -12.667901     -11.332257
    [16]      -10.463576     -9.5318604     -8.5263090     -7.0938587
    [20]      -3.8047750     0.61227840      4.4832258      7.3411722
    [24]       9.1804800      10.048809      9.9704704      8.9412231
    [28]       6.9433093      4.0039115     0.39918315     -3.0162027
    [32]      -5.5695143     -7.5915451     -6.5835958     -2.4412973
    [36]      0.97967160      3.0257614      3.8109183      3.4265060
    [40]       1.8949538    -0.79706126     -4.5298877     -8.2512903
    [44]      -9.6866112     -9.6488647     -9.9304552     -10.549777
    [48]      -10.663079     -9.5911026     -7.6800170     -5.6919317
    [52]      -4.2042718     -3.5729802     -4.0324798     -5.8186345
    [56]      -9.3306875     -15.570898     -30.039530     -25.224953
    [60]      -18.489756     -14.680992     -12.843548     -10.984278
    [64]      -5.7894330    -0.42068976      3.4915318      6.0477133
    [68]       7.4502206      7.8234777      7.2216763      5.6350064
    [72]       2.9728553    -0.99933165     -6.8446436     -15.414916
    [76]      -16.552805     -12.937056     -11.019547     -9.8669415
    [80]      -9.5204287     -10.193375     -11.925638     -14.524093
    [84]      -17.479095     -19.946161     -20.872986     -20.117649
    [88]      -18.796309     -17.567617     -16.737270     -16.711397
    [92]      -17.847404     -19.897392     -20.125259     -17.229410
    [96]      -14.364753     -12.358681     -11.139941     -10.706294
    [100]      -11.169957     -12.533186     -13.685688     -12.125578
    [104]      -9.1758928     -6.7765980     -5.1217146     -4.0557261
    [108]      -3.5169189     -3.5715168     -4.3324847     -5.8463135
    [112]      -7.8980813     -9.7582855     -10.800159     -11.634339
    [116]      -12.925582     -13.784670     -12.530887     -10.354527
    [120]      -8.6692495     -7.7057214     -7.4461594     -7.9776120
    [124]      -9.5269880     -12.122920     -13.246615     -10.316358
    [128]      -7.5177164     -6.2221432     -6.5268493     -8.8443871
    [132]      -15.309066     -23.751884     -10.242802     -5.7391858
    [136]      -3.5968726     -2.8164303     -3.1073375     -4.4443045
    [140]      -7.0213265     -11.439206     -19.512728     -21.009851
    [144]      -14.817382     -11.936593     -10.245749     -9.0816860
    [148]      -8.3615694     -8.1239185     -8.3434820     -8.9481096
    [152]      -9.9045458     -11.254190     -13.040988     -15.123261
    [156]      -16.695024     -16.308249     -14.509654     -12.995777
    [160]      -12.406120     -12.657197     -13.063034     -12.587950
    [164]      -11.132947     -9.2973680     -7.3979025     -5.6761494
    [168]      -4.4000301     -3.7427583     -3.7681179     -4.4884143
    [172]      -5.9222236     -8.1238194     -11.129122     -14.677437
    [176]      -17.813936     -19.242649     -16.836420     -12.352812
    [180]      -8.7148371     -6.2961888     -4.9576116     -4.6216178
    [184]      -5.3643479     -7.5092845     -11.976202     -20.739147
    [188]      -15.767018     -11.223369     -9.9709225     -10.488273
    [192]      -11.285028     -10.624017     -9.3376799     -8.9065666
    [196]      -9.7995071     -12.208044     -16.527912     -23.900642
    [200]      -28.045019     -21.904341     -18.366753     -16.009840
    [204]      -14.225321     -12.785561     -11.627177     -10.849004
    [208]      -10.711235     -11.660624     -14.598115     -23.081524
    [212]      -23.033628     -14.084421     -10.973065     -10.179746
    [216]      -10.702858     -11.429925     -11.438021     -11.485441
    [220]      -12.911844     -16.833796     -20.880297     -16.255400
    [224]      -13.649363     -14.243258     -19.372356     -30.114353
    [228]      -14.592899     -9.7845974     -7.5002837     -6.5092230
    [232]      -6.3015771     -6.5932775     -7.2368484     -8.1752615
    [236]      -9.3560505     -10.661986     -12.039239     -13.845943
    [240]      -17.071344     -22.843075     -20.223864     -14.872900
    [244]      -12.328446     -11.552868     -12.005975     -13.349826
    [248]      -15.121560     -16.070168     -15.210215     -14.060255
    [252]      -13.965576     -15.144980     -16.761810     -17.198492
    [256]      -17.217543     -18.587801     -20.640028     -17.944338
    [260]      -13.172924     -9.3367348     -6.5094557     -4.7105899
    [264]      -4.0256214     -4.5921173     -6.7151289     -11.277046
    [268]      -20.337513     -14.290366     -9.0263262     -6.4785361
    [272]      -5.1896229     -4.6678791     -4.7646432     -5.4922357
    [276]      -6.8975320     -8.8063965     -10.170869     -9.5307055
    [280]      -7.7616301     -6.2136626     -5.2574239     -4.9482532
    [284]      -5.3676944     -6.7559257     -9.6934128     -15.095850
    [288]      -14.246912     -8.4073925     -5.1997833     -3.7695155
    [292]      -3.7017465     -4.9398189     -7.4922681     -9.6031961
    [296]      -7.4263568     -4.6444421     -3.4342284     -3.9611495
    [300]      -6.4965091     -11.812723     -15.334629     -10.650106
    [304]      -8.3653603     -7.6946149     -7.1415191     -6.0274897
    [308]      -4.9078951     -4.3347549     -4.4250708     -5.1337366
    [312]      -6.4900169     -8.7543888     -12.581108     -19.663181
    [316]      -26.506536     -19.572701     -16.956570     -15.296303
    [320]      -13.746326     -13.282639     -15.009068     -20.447416
    [324]      -18.923407     -12.289568     -9.1601887     -8.2385511
    [328]      -9.2951450     -12.803790     -14.683532     -8.3908119
    [332]      -4.0034556     -1.5909917    -0.63192022    -0.95957464
    [336]      -2.5776153     -5.3058810     -7.1151624     -5.6257615
    [340]      -3.8343413     -3.2724116     -4.0220404     -6.0286756
    [344]      -9.0806532     -11.735634     -11.359882     -9.4830046
    [348]      -8.0020638     -7.3380837     -7.7076168     -9.2979603
    [352]      -11.344837     -10.132809     -6.7940121     -4.4234400
    [356]      -3.3138280     -3.2818699     -4.1358676     -5.6666889
    [360]      -7.7053013     -10.498049     -15.715985     -25.801796
    [364]      -12.298218     -6.6091743     -3.5443923     -1.9615440
    [368]      -1.4939059     -2.0250297     -3.5820200     -6.2692318
    [372]      -9.8036623     -11.674506     -10.616176     -9.6983643
    [376]      -9.4984913     -9.2222052     -8.3417597     -6.9731236
    [380]      -5.3276711     -3.8233192     -3.0467665     -3.5082145
    [384]      -5.7553620     -10.663572     -14.347346     -9.9252148
    [388]      -8.1064930     -8.5544662     -8.5876131     -6.3658810
    [392]      -4.5251226     -4.3647184     -6.2074761     -10.744957
    [396]      -20.323454     -19.810778     -16.183678     -15.309650
    [400]      -12.682484     -9.5293741     -7.3827844     -6.0865784
    [404]      -5.2749648     -4.7505999     -4.4313841     -4.2046771
    [408]      -3.9240456     -3.5391343     -3.1469314     -2.8877761
    [412]      -2.8328373     -2.9613218     -3.2338891     -3.7057452
    [416]      -4.5429220     -5.8991685     -7.7539520     -9.8456430
    [420]      -11.998738     -14.562140     -16.903597     -15.164391
    [424]      -11.865096     -9.6851730     -8.4838104     -7.7649384
    [428]      -7.1715527     -6.6686087     -6.4408703     -6.6719146
    [432]      -7.4524722     -8.6775961     -9.6022005     -8.8839083
    [436]      -6.9740925     -5.3851981     -4.7911754     -5.4731989
    [440]      -7.8192453     -12.712461     -17.496605     -12.092589
    [444]      -8.8848314     -7.9103251     -8.3499374     -9.5074100
    [448]      -10.278923     -9.9497299     -9.2847452     -9.1507454
    [452]      -9.8291826     -11.082623     -11.675678     -10.349794
    [456]      -8.3171082     -6.8196135     -6.1394043     -6.2629676
    [460]      -7.1515989     -8.8541555     -11.674667     -16.381540
    [464]      -19.701300     -14.341724     -10.744660     -9.2641401
    [468]      -9.3297882     -10.350814     -10.882069     -9.7615585
    [472]      -8.2346554     -7.2930884     -6.9662228     -7.0358567
    [476]      -7.4098639     -8.1793194     -9.3607397     -10.458471
    [480]      -10.494259     -9.4906788     -8.4219131     -7.7985535
    [484]      -7.6305194     -7.6478581     -7.4490361     -6.8518648
    [488]      -6.0598297     -5.3266559     -4.7365174     -4.2886944
    [492]      -4.0149970     -3.9906216     -4.2837806     -4.9259782
    [496]      -5.9180346     -7.2533560     -8.9458733     -11.035477
    [500]      -13.489478     -15.949673     -17.887623     -19.570518
    [504]      -20.349091     -17.333622     -13.533421     -11.066890
    [508]      -9.9635277     -10.037228     -11.089969     -12.676401
    [512]      -13.567325
  [Tag]        11681
  [frame_len]          320
[Record 74]
  [tot_power]       1162.9980
  [re_spec_val]
    [0]       12.424382      11.869165      10.158451      7.1336417
    [4]       2.4168489     -5.0264282     -20.926989     -19.330250
    [8]      -18.338228     -24.069229     -33.225002     -32.539749
    [12]      -24.488579     -18.732649     -15.997589     -15.460283
    [16]      -16.585426     -17.035110     -14.043284     -11.205044
    [20]      -10.391731     -12.432119     -16.564196     -9.4163456
    [24]      -3.8221695    -0.88799727     0.24134298    -0.17839020
    [28]      -2.2471745     -6.6007867     -16.294403     -20.233244
    [32]      -12.803610     -11.747862     -10.963488     -7.6203489
    [36]      -4.2065721     -1.8647203    -0.48621541     0.10771629
    [40]    -0.033871178     -1.0186952     -3.1347663     -7.0030627
    [44]      -14.135691     -16.817663     -11.111589     -8.9908438
    [48]      -8.8119965     -9.5720739     -9.7988377     -8.3878651
    [52]      -6.6097736     -5.6816730     -5.9838676     -7.7051344
    [56]      -11.184476     -17.332035     -29.833361     -29.930595
    [60]      -24.182178     -18.731644     -14.647750     -12.211102
    [64]      -10.485140     -8.5015669     -6.3782887     -4.8633528
    [68]      -4.3820233     -5.0700846     -6.9609580     -10.050172
    [72]      -14.426803     -20.916250     -24.514341     -18.205357
    [76]      -15.178776     -14.276335     -14.009302     -13.041469
    [80]      -11.744308     -11.126427     -11.523103     -12.831003
    [84]      -14.554698     -15.488755     -14.795636     -13.638683
    [88]      -13.267413     -14.239680     -16.556776     -17.487902
    [92]      -14.666531     -12.248281     -11.322829     -11.399287
    [96]      -11.316552     -10.308724     -9.2755613     -9.1694250
    [100]      -10.349516     -12.966990     -17.102528     -21.868303
    [104]      -21.975357     -18.547867     -15.604312     -13.316777
    [108]      -11.395148     -9.6842480     -8.1062326     -6.5834856
    [112]      -5.1813126     -4.1553912     -3.7724569     -4.1723113
    [116]      -5.3192334     -6.9496827     -8.6548967     -10.347735
    [120]      -12.449698     -15.249995     -18.211515     -20.124262
    [124]      -19.464659     -16.270020     -13.524778     -12.413184
    [128]      -13.178429     -16.179411     -21.743889     -22.782631
    [132]      -19.325657     -16.942362     -14.249267     -11.872940
    [136]      -10.742634     -10.977300     -11.580037     -10.211541
    [140]      -7.5347142     -5.4997063     -4.5159941     -4.5396705
    [144]      -5.5575581     -7.7037416     -11.367528     -17.539944
    [148]      -27.830048     -25.350185     -23.925785     -24.085249
    [152]      -20.898710     -17.607969     -15.539278     -13.916256
    [156]      -11.970529     -9.8255129     -8.0618410     -6.9974103
    [160]      -6.6672406     -6.9562964     -7.6864796     -8.7358036
    [164]      -10.212768     -12.599152     -16.606695     -17.773041
    [168]      -12.493129     -8.9695177     -7.4415841     -7.6080289
    [172]      -9.5146322     -13.339916     -15.835840     -12.232031
    [176]      -9.1812687     -7.5476151     -6.8387446     -6.6981163
    [180]      -6.8414025     -6.9874959     -6.9138603     -6.6611018
    [184]      -6.5981727     -7.1948400     -8.7958794     -11.275135
    [188]      -13.101767     -13.414983     -14.973220     -20.626730
    [192]      -17.063162     -10.600330     -7.8670950     -7.5300221
    [196]      -9.3981390     -13.944839     -16.905392     -11.709141
    [200]      -8.3663416     -6.7252312     -6.1198974     -6.2393432
    [204]      -6.9065642     -7.9769392     -9.3704081     -11.178419
    [208]      -13.709083     -17.481228     -21.290932     -16.761744
    [212]      -11.312915     -7.6008158     -5.2074871     -3.8741779
    [216]      -3.4636278     -3.9125993     -5.2361403     -7.5679431
    [220]      -11.197371     -15.917199     -16.998640     -15.012750
    [224]      -15.132690     -19.308809     -29.775673     -14.405152
    [228]      -8.7716417     -5.7736197     -4.2391281     -3.7743943
    [232]      -4.1784554     -5.2375975     -6.5655808     -7.6150684
    [236]      -8.1321106     -8.3976240     -8.7519903     -9.2772284
    [240]      -9.7206535     -9.5677900     -8.7232094     -7.7815332
    [244]      -7.2627239     -7.3051581     -7.7943411     -8.4869490
    [248]      -9.1210089     -9.5515966     -9.8891926     -10.539449
    [252]      -12.123148     -15.426636     -18.691074     -13.940288
    [256]      -9.3765163     -6.4955826     -4.6044841     -3.3052158
    [260]      -2.4810801     -2.2349238     -2.8027468     -4.5262213
    [264]      -7.8912659     -12.308839     -10.785258     -7.5108080
    [268]      -6.2563419     -6.8115573     -9.0679550     -13.143439
    [272]      -18.599411     -19.243629     -14.678105     -10.701789
    [276]      -8.1546736     -7.1857576     -7.9946952     -11.287917
    [280]      -20.302536     -17.901274     -11.056041     -8.5328341
    [284]      -7.5709138     -6.8622980     -5.8133521     -4.7499018
    [288]      -4.1032205     -3.9400167     -4.0741329     -4.2864175
    [292]      -4.5219369     -4.8855453     -5.4665704     -6.2264633
    [296]      -7.0036922     -7.5569334     -7.6168041     -7.0679879
    [300]      -6.1550169     -5.3115401     -4.8786292     -5.0688934
    [304]      -6.0653920     -8.1613255     -12.008701     -17.739273
    [308]      -13.739792     -8.2427835     -4.7539935     -2.3432229
    [312]     -0.57485044     0.72942466      1.6183547      2.0809410
    [316]       2.0903847      1.6235213     0.65712392    -0.85814518
    [320]      -3.0526693     -6.2569256     -11.389831     -22.343832
    [324]      -18.718325     -12.855629     -11.066330     -11.018350
    [328]      -11.145208     -10.018019     -8.3940220     -7.3243098
    [332]      -6.6974802     -5.8468065     -4.6654248     -3.8302424
    [336]      -3.9663956     -5.5013084     -8.9615097     -14.292935
    [340]      -13.267187     -9.7365313     -8.3600693     -8.2313480
    [344]      -7.9675474     -6.6221495     -4.8549628     -3.4520676
    [348]      -2.6062999     -2.2633262     -2.3426607     -2.8473074
    [352]      -3.9602778     -6.1597557     -10.504640     -15.998214
    [356]      -9.5086355     -4.7634192     -2.1714756    -0.77925277
    [360]     -0.20222257    -0.36047402     -1.3663216     -3.4002798
    [364]      -6.3358126     -8.3478327     -7.6260648     -6.6952224
    [368]      -6.8856740     -8.0008488     -8.8796625     -8.0587168
    [372]      -6.3611202     -5.2096262     -5.1517448     -6.4990578
    [376]      -9.8118191     -14.344505     -9.9003420     -4.8644023
    [380]      -1.8608444    -0.18122326     0.58015168     0.72367734
    [384]      0.53087372     0.18619540    -0.33799818     -1.1831812
    [388]      -2.2416260     -2.7235882     -1.8681607    -0.39621353
    [392]      0.77078795      1.3865782      1.5559922      1.4832971
    [396]       1.3223394      1.0814656     0.63845545    -0.17805481
    [400]      -1.5128744     -3.3550837     -5.1816177     -5.8492332
    [404]      -5.2922311     -4.6332526     -4.3945060     -4.5063629
    [408]      -4.6903315     -4.6832895     -4.4313364     -4.1167631
    [412]      -3.9852617     -4.2223744     -4.9549909     -6.2406425
    [416]      -7.8808970     -9.1356449     -9.5154266     -10.000960
    [420]      -11.987762     -17.484364     -37.477230     -16.344122
    [424]      -11.917450     -10.275563     -9.8949928     -10.024235
    [428]      -10.151148     -10.090687     -10.043730     -10.422255
    [432]      -11.680017     -14.346997     -19.098799     -21.585621
    [436]      -16.218939     -11.989705     -8.9231291     -6.6535077
    [440]      -5.1750264     -4.5615158     -4.8897939     -6.2479386
    [444]      -8.7056084     -11.885340     -13.518855     -12.556922
    [448]      -11.805873     -12.429275     -14.579284     -17.369383
    [452]      -17.253468     -15.200767     -13.930326     -13.368683
    [456]      -13.031879     -13.042054     -14.070226     -17.102274
    [460]      -23.711620     -21.139793     -15.382494     -12.948947
    [464]      -12.689769     -14.620382     -20.555845     -29.543451
    [468]      -15.768051     -10.975346     -8.5702753     -7.4828410
    [472]      -7.2884955     -7.6647120     -8.2819662     -8.9801197
    [476]      -10.001463     -11.877222     -15.090227     -18.250772
    [480]      -16.456251     -13.748088     -12.516263     -12.613751
    [484]      -13.776303     -15.097598     -14.153131     -11.499864
    [488]      -9.5175209     -8.8575783     -9.6572590     -12.143359
    [492]      -16.920341     -25.787600     -31.106077     -24.127298
    [496]      -18.808025     -14.914534     -12.876574     -12.680325
    [500]      -14.554873     -19.842007     -37.275776     -19.574141
    [504]      -14.745934     -12.680805     -11.901766     -11.846463
    [508]      -12.132081     -12.351401     -12.213830     -11.863830
    [512]      -11.687379
  [Tag]        11841
  [frame_len]          320
[Record 75]
  [tot_power]       3324.9934
  [re_spec_val]
    [0]       12.552988      12.009967      10.339625      7.3987923
    [4]       2.8587880     -4.1043973     -16.774626     -23.556047
    [8]      -21.541040     -23.641935     -18.206345     -14.823555
    [12]      -12.700513     -10.740750     -8.8752356     -7.4139752
    [16]      -6.5969057     -6.5406394     -7.2362189     -8.3898611
    [20]      -9.0239506     -7.9271660     -5.4439807     -2.6031210
    [24]     0.024608383      2.1675382      3.7096963      4.6309671
    [28]       4.9735193      4.8397403      4.4168153      3.9795556
    [32]       3.7683568      3.7900660      3.8415620      3.7330103
    [36]       3.4146209      2.9776545      2.6105967      2.5219214
    [40]       2.8336599      3.5116704      4.3971181      5.2995448
    [44]       6.0665321      6.6043701      6.8717685      6.8678069
    [48]       6.6218009      6.1864281      5.6349344      5.0602646
    [52]       4.5613098      4.1977749      3.9408548      3.6912434
    [56]       3.3703091      3.0129676      2.7984238      2.9514036
    [60]       3.5367520      4.4019613      5.3330283      6.1681871
    [64]       6.7975721      7.1360173      7.1102099      6.6559215
    [68]       5.7157087      4.2332253      2.1465085    -0.59273207
    [72]      -3.7955313     -6.0623355     -5.4957743     -3.8030775
    [76]      -2.6084166     -2.1956716     -2.5532742     -3.6544259
    [80]      -5.4863806     -8.0312405     -11.225608     -14.946219
    [84]      -19.128393     -22.771347     -20.722424     -16.577065
    [88]      -13.666022     -11.906977     -10.958974     -10.267300
    [92]      -8.9365902     -6.6828098     -4.2832184     -2.3652353
    [96]      -1.0652590    -0.26047447     0.27661201     0.74150687
    [100]       1.1774844      1.4979438      1.6028218      1.4286611
    [104]      0.91928989  -0.0062850481     -1.4436071     -3.4384363
    [108]      -5.7889233     -7.5590396     -7.4683318     -6.1323953
    [112]      -4.8578577     -4.1593518     -4.1182761     -4.5538149
    [116]      -4.9459748     -4.7277493     -4.0551457     -3.5498912
    [120]      -3.5880387     -4.2634101     -5.5436668     -7.3197932
    [124]      -9.2663479     -10.596087     -10.756268     -10.469289
    [128]      -10.569677     -11.219060     -12.046030     -12.416066
    [132]      -12.002526     -11.057212     -10.108331     -9.7145090
    [136]      -10.399197     -12.811316     -18.064812     -19.435514
    [140]      -13.204679     -9.6451988     -7.5439148     -6.0548825
    [144]      -4.8046923     -3.6256425     -2.3654711    -0.99493128
    [148]      0.24457817     0.98769671     0.90785807    -0.27492529
    [152]      -2.4374921     -2.4168756      1.5291661      5.1238632
    [156]       7.4863062      8.7847576      9.1854620      8.8079662
    [160]       7.7500277      6.0757251      3.7216594     0.26958019
    [164]      -5.7211308     -15.619669     -5.8694057     -1.6588091
    [168]     -0.10547548   -0.076543353     -1.1886944     -3.3257446
    [172]      -6.6480393     -11.972748     -21.417805     -17.240654
    [176]      -13.053676     -12.259469     -12.887148     -12.416373
    [180]      -10.699997     -9.9696026     -11.181207     -14.554931
    [184]      -16.162094     -12.782036     -10.692871     -10.233917
    [188]      -10.181937     -9.2446814     -7.8188071     -6.9687181
    [192]      -6.8819394     -6.3407741     -3.7704706    -0.53549361
    [196]       1.9573213      3.4440837      3.9683990      3.6135328
    [200]       2.4863443     0.77301806     -1.1973184     -3.0480874
    [204]      -4.6731253     -6.2197285     -7.5504336     -8.0319824
    [208]      -7.4804707     -6.6721020     -6.3521972     -6.8689790
    [212]      -8.1838865     -9.3460188     -8.7334070     -7.0864444
    [216]      -5.7666235     -4.8552094     -3.9216862     -2.7596114
    [220]      -1.6063027    -0.77929592    -0.44607401    -0.65904886
    [224]      -1.4168274     -2.6678755     -4.2440910     -5.7175870
    [228]      -6.3109326     -5.4066195     -3.3923330     -1.1449282
    [232]      0.78994513      2.2139852      3.0952518      3.4664350
    [236]       3.3795037      2.8801835      1.9871737     0.67429835
    [240]      -1.1405518     -3.5863862     -6.7106571     -9.6795626
    [244]      -9.9423494     -8.1798105     -6.6251106     -5.6396508
    [248]      -5.0895648     -4.9028740     -5.1058726     -5.7203708
    [252]      -6.6557298     -7.6207552     -8.0350752     -7.2368207
    [256]      -5.3372288     -3.1384275     -1.1883514     0.33378559
    [260]       1.3775012      1.8792694      1.7210588     0.73115426
    [264]      -1.3090825     -4.5769639     -8.3310776     -9.4567995
    [268]      -9.1769276     -10.514589     -11.570381     -7.2512536
    [272]      -2.8863893   -0.022686765      1.7183104      2.6350560
    [276]       2.9074318      2.6556454      1.9781241     0.96248853
    [280]     -0.33303243     -1.9015546     -3.7241404     -5.4580374
    [284]      -6.0524611     -5.0194016     -3.4856198     -2.3216479
    [288]      -1.7456405     -1.7498472     -2.2818277     -3.3008864
    [292]      -4.8208704     -6.9824452     -10.204318     -15.628304
    [296]      -22.138096     -14.630070     -9.6949606     -6.6563554
    [300]      -4.5977759     -3.2695303     -2.6680112     -2.8750298
    [304]      -4.0048509     -6.2014260     -9.6182861     -13.938278
    [308]      -15.606823     -12.846650     -9.8744297     -7.6870589
    [312]      -6.2938170     -5.5231013     -5.0962095     -4.8440776
    [316]      -4.9280801     -5.7354350     -7.6610260     -11.030237
    [320]      -15.961536     -22.207373     -25.527267     -17.380859
    [324]      -12.598267     -10.928975     -12.354545     -18.905504
    [328]      -14.097489     -6.6344886     -2.7082052    -0.47881559
    [332]      0.69800359      1.1489941      1.1583896      1.1172925
    [336]       1.4491835      2.2209537      3.0729060      3.6251218
    [340]       3.6689115      3.1142695      1.9270161     0.11850815
    [344]      -2.2021527     -4.7025633     -6.7328153     -7.5945106
    [348]      -7.1394925     -5.9872446     -4.9330239     -4.3595181
    [352]      -4.1587553     -3.8419895     -3.0379279     -2.0162547
    [356]      -1.2547276    -0.94182891    -0.94815969    -0.94273674
    [360]     -0.68709219    -0.33661848    -0.27399418    -0.77219909
    [364]      -1.8180469     -2.8907156     -3.0828593     -2.4012420
    [368]      -1.6565195     -1.0851182    -0.33603007     0.77766061
    [372]       1.8570619      2.3661804      1.9182944     0.11499879
    [376]      -3.9171731     -13.687080     -9.7651386     -3.2764812
    [380]     -0.67467421     0.22994830     0.17888246    -0.34876657
    [384]     -0.93296599     -1.2827739     -1.3872014     -1.5097117
    [388]      -2.0161002     -3.2410858     -5.4580259     -8.7797289
    [392]      -12.252899     -12.949809     -11.895771     -11.213110
    [396]      -10.827748     -10.276308     -9.3378010     -8.0379438
    [400]      -6.5888014     -5.2628827     -4.2408376     -3.5850351
    [404]      -3.2771518     -3.2348304     -3.3039534     -3.2750330
    [408]      -2.9770448     -2.4102390     -1.7738925     -1.3601010
    [412]      -1.4527816     -2.3189528     -4.2984881     -8.1028490
    [416]      -16.587067     -20.698067     -10.855087     -7.7046189
    [420]      -6.8835444     -7.7551618     -10.467234     -15.871801
    [424]      -19.646744     -13.892997     -10.544149     -8.9130945
    [428]      -8.2405071     -8.2717218     -9.0167856     -10.564466
    [432]      -12.776998     -14.435442     -13.696455     -11.731835
    [436]      -9.9846830     -8.6471062     -7.6374903     -6.9608483
    [440]      -6.7139010     -6.9768615     -7.6802177     -8.4805889
    [444]      -8.9110031     -9.0013523     -9.3416500     -10.510275
    [448]      -12.954695     -17.027319     -20.331345     -17.676180
    [452]      -15.075139     -14.015320     -14.107830     -15.007859
    [456]      -16.348097     -17.596138     -18.333241     -18.925161
    [460]      -20.112703     -21.322502     -19.647366     -16.623440
    [464]      -14.630747     -13.444074     -11.723682     -8.9281902
    [468]      -6.1031771     -3.9309933     -2.4936910     -1.6846796
    [472]      -1.3675429     -1.4239711     -1.7823687     -2.4489675
    [476]      -3.5398111     -5.3174968     -8.2980871     -13.708289
    [480]      -20.914793     -13.485868     -9.2343473     -7.3505425
    [484]      -6.8903103     -7.5770216     -9.4541998     -12.956812
    [488]      -19.481750     -21.782230     -14.430696     -10.248641
    [492]      -7.5138597     -5.5671082     -4.2241421     -3.4715323
    [496]      -3.3613806     -3.9846270     -5.4817123     -8.0795612
    [500]      -12.154035     -18.027300     -22.117338     -21.298777
    [504]      -22.028421     -24.626633     -26.720308     -26.822937
    [508]      -22.876894     -17.398638     -13.548863     -11.388644
    [512]      -10.695072
  [Tag]        12001
  [frame_len]          320
[Record 76]
  [tot_power]       1642.3623
  [re_spec_val]
    [0]       12.399995      11.847844      10.146623      7.1375332
    [4]       2.4348259     -5.0633135     -22.422571     -16.956106
    [8]      -15.273584     -18.317186     -24.005651     -25.429049
    [12]      -19.032585     -14.792952     -12.469472     -11.473207
    [16]      -11.428356     -12.115767     -13.548385     -16.202560
    [20]      -21.645142     -21.952896     -13.442170     -8.3788452
    [24]      -5.1532388     -3.1500833     -2.1370482     -1.9903123
    [28]      -2.5090878     -3.1351216     -2.9948170     -2.0468605
    [32]      -1.1428875    -0.85119909     -1.3616338     -2.7640548
    [36]      -5.2028456     -8.9465628     -14.232781     -19.605522
    [40]      -21.414251     -17.256586     -11.198168     -7.3325191
    [44]      -5.5809150     -5.8180022     -8.3954515     -14.980587
    [48]      -23.930843     -15.477621     -14.285870     -13.458762
    [52]      -9.3795280     -6.2274127     -5.0136471     -5.5952868
    [56]      -7.7873058     -9.7931166     -7.7414799     -4.8028178
    [60]      -3.1277936     -2.7696483     -3.4675715     -3.9000206
    [64]      -1.8548568      1.1893063      3.4162917      4.5055552
    [68]       4.4654236      3.2804413     0.82485360     -3.2906475
    [72]      -10.499604     -24.922924     -11.603032     -7.2206244
    [76]      -5.0892587     -4.1871443     -4.3621883     -5.7565408
    [80]      -8.9035320     -15.747756     -19.493277     -10.538134
    [84]      -6.5436649     -4.4412527     -3.3368928     -2.8409717
    [88]      -2.7425976     -2.9426260     -3.4395874     -4.3089428
    [92]      -5.6641822     -7.5988660     -10.055039     -12.444053
    [96]      -13.390789     -12.540050     -11.049897     -9.5509844
    [100]      -8.0907812     -6.6364088     -5.3443961     -4.5268407
    [104]      -4.5001602     -5.5561209     -7.9979491     -11.487192
    [108]      -11.447468     -8.1471195     -5.9239478     -5.0132422
    [112]      -5.1577282     -6.2234821     -8.2173433     -11.284460
    [116]      -15.446312     -18.350939     -17.174549     -16.284859
    [120]      -17.456545     -20.400707     -19.252844     -14.912627
    [124]      -12.291177     -11.381084     -11.925828     -13.535343
    [128]      -14.238885     -12.125717     -9.7771931     -8.6717911
    [132]      -9.0621729     -11.212949     -15.754399     -19.916552
    [136]      -15.296693     -11.970107     -10.374666     -9.6805725
    [140]      -9.4132967     -9.2645960     -8.9862776     -8.4686346
    [144]      -7.7656422     -6.8664579     -5.6714087     -4.3236046
    [148]      -3.2462637     -2.8495133     -3.3841307     -4.6055336
    [152]      -4.3029833     -1.0018311      2.5381572      5.2221956
    [156]       7.0703807      8.2036667      8.6874056      8.5146475
    [160]       7.5937400      5.7038479      2.3435774     -3.7357645
    [164]      -7.8738184     -1.4061658      1.8276440      3.0157313
    [168]       2.8828690      1.7479204    -0.14140387     -2.4206553
    [172]      -4.6115832     -6.6030588     -8.9915142     -12.389231
    [176]      -13.411473     -8.7802248     -4.6472964     -1.7823274
    [180]      0.13455598      1.3108293      1.8800108      1.9596113
    [184]       1.6810491      1.1913680     0.62424970    0.062374804
    [188]     -0.46600604    -0.95175248     -1.3697603     -1.6671282
    [192]      -1.7825049     -1.6995165     -1.4802604     -1.2226945
    [196]      -1.0019107    -0.87246859    -0.90498173     -1.1909869
    [200]      -1.8067788     -2.7689011     -3.9949067     -5.2685437
    [204]      -6.2603793     -6.7157679     -6.6964612     -6.5209937
    [208]      -6.5267596     -6.9790945     -8.1131144     -10.234440
    [212]      -13.972331     -21.580589     -27.725834     -17.108892
    [216]      -13.055410     -10.940441     -9.8477221     -9.4783077
    [220]      -9.7263966     -10.558620     -11.953013     -13.777769
    [224]      -15.396806     -15.428000     -13.698701     -11.504855
    [228]      -9.5022078     -7.7961102     -6.3695679     -5.2124639
    [232]      -4.3530598     -3.8636169     -3.8534052     -4.4648633
    [236]      -5.8920588     -8.4264565     -12.316904     -14.910528
    [240]      -11.962770     -9.1999474     -8.0303221     -8.3136454
    [244]      -10.098082     -13.719480     -18.371113     -16.400019
    [248]      -12.805807     -10.876844     -10.034617     -9.7733183
    [252]      -9.7547531     -9.8035440     -9.8997049     -10.077403
    [256]      -10.247516     -10.130144     -9.5910568     -9.0088387
    [260]      -8.9953270     -10.103362     -12.789277     -14.842881
    [264]      -10.574965     -6.2393889     -3.4622190     -1.8843206
    [268]      -1.2745783     -1.5336639     -2.6260078     -4.4861007
    [272]      -6.7493525     -8.3112640     -8.3674965     -7.9186001
    [276]      -7.8926864     -8.4114513     -9.1652527     -9.6784792
    [280]      -9.7095566     -9.3889923     -8.8695288     -8.2204866
    [284]      -7.5983262     -7.2559314     -7.4288259     -8.3103857
    [288]      -10.115028     -13.114677     -16.919727     -17.277235
    [292]      -14.741601     -13.412841     -13.506885     -14.047767
    [296]      -13.238912     -11.208941     -9.4688711     -8.5065689
    [300]      -8.2425547     -8.4597540     -8.9422808     -9.5939417
    [304]      -10.511177     -11.923578     -14.076585     -17.119915
    [308]      -20.820892     -23.966707     -25.411663     -25.538774
    [312]      -24.383709     -22.534582     -20.546465     -18.283384
    [316]      -15.762101     -13.269961     -10.957924     -8.8181992
    [320]      -6.8415380     -5.0769653     -3.5944786     -2.4517205
    [324]      -1.7068596     -1.4500567     -1.8117608     -2.9003079
    [328]      -4.4733758     -5.0657649     -3.4710889     -1.3997114
    [332]    -0.054674663     0.37580636    -0.10079103     -1.5581863
    [336]      -4.3377519     -9.5391836     -16.306381     -8.7155619
    [340]      -4.1933522     -2.0241475     -1.2860178     -1.6580694
    [344]      -3.0119321     -5.2343445     -7.8770704     -9.4191980
    [348]      -8.7109900     -7.2121425     -6.0535455     -5.4917769
    [352]      -5.5673213     -6.2818990     -7.5837426     -9.2070217
    [356]      -10.274735     -9.6700974     -7.8907042     -6.0786777
    [360]      -4.6741672     -3.7263308     -3.1990602     -3.0852242
    [364]      -3.4504340     -4.4455118     -6.3111897     -9.2864809
    [368]      -12.072993     -9.9536715     -6.2964630     -3.7324488
    [372]      -2.2093396     -1.5547208     -1.7120780     -2.7341993
    [376]      -4.8207593     -8.5315218     -16.050049     -23.167391
    [380]      -11.963337     -7.9179745     -5.9294968     -4.9766788
    [384]      -4.5774488     -4.3947592     -4.2596254     -4.2229776
    [388]      -4.4570951     -5.1350279     -6.4240799     -8.5760822
    [392]      -12.148143     -19.019646     -34.417198     -17.666740
    [396]      -13.317735     -11.331067     -10.416507     -10.033663
    [400]      -9.8355389     -9.6037655     -9.2838593     -8.9531145
    [404]      -8.7052202     -8.5531378     -8.3996801     -8.0873289
    [408]      -7.5282865     -6.8013101     -6.0903072     -5.5608258
    [412]      -5.3058634     -5.3537350     -5.6948543     -6.3122282
    [416]      -7.2117372     -8.4435949     -10.103548     -12.289549
    [420]      -14.851252     -16.437860     -15.209596     -12.761446
    [424]      -10.653865     -9.1600122     -8.2685785     -7.9589357
    [428]      -8.2245178     -9.0575609     -10.438034     -12.349267
    [432]      -14.826287     -17.861895     -20.259924     -19.330664
    [436]      -17.132353     -15.826885     -15.604633     -16.172043
    [440]      -16.923319     -17.116116     -16.673100     -16.156879
    [444]      -15.962648     -16.184513     -16.775900     -17.623316
    [448]      -18.550501     -19.367010     -20.038782     -20.778503
    [452]      -21.835857     -23.157299     -24.200949     -24.595411
    [456]      -24.948961     -25.929596     -27.359148     -28.490633
    [460]      -29.560486     -27.734192     -21.004335     -15.316523
    [464]      -11.221942     -8.3402014     -6.4209862     -5.3223467
    [468]      -4.9639158     -5.2893143     -6.2051616     -7.4335113
    [472]      -8.3079185     -8.1678200     -7.3372912     -6.5943975
    [476]      -6.3633990     -6.7956157     -7.9543228     -9.8679714
    [480]      -12.471148     -15.418331     -18.050619     -20.176365
    [484]      -21.913939     -21.787512     -19.777637     -18.099062
    [488]      -17.435640     -17.615053     -18.152992     -18.355042
    [492]      -17.760469     -16.641911     -15.636452     -15.228886
    [496]      -15.662271     -16.848780     -17.814384     -16.994659
    [500]      -15.128400     -13.607767     -12.741899     -12.410328
    [504]      -12.428741     -12.659831     -13.061666     -13.699194
    [508]      -14.724471     -16.352354     -18.860971     -22.476967
    [512]      -25.251160
  [Tag]        12161
  [frame_len]          320
[Record 77]
  [tot_power]       894.49939
  [re_spec_val]
    [0]       12.608738      12.069526      10.409555      7.4825468
    [4]       2.9562421     -3.9822254     -16.411196     -26.045532
    [8]      -23.888838     -22.157593     -14.561710     -8.7160101
    [12]      -4.0536027    -0.62179840      1.7382804      3.3104398
    [16]       4.3808846      5.1307182      5.5609975      5.5447502
    [20]       4.9558358      3.7783041      2.2087772     0.68657595
    [24]     -0.49043784     -1.6422876     -3.2668314     -4.9391947
    [28]      -4.2702317     -1.4680179      1.0077846      2.5212784
    [32]       3.1042280      2.9010537      2.1491995      1.2065432
    [36]      0.39433333    -0.27233028    -0.96801192     -1.6849853
    [40]      -2.1896491     -2.4030914     -2.6285372     -3.2811747
    [44]      -4.6943474     -7.2239456     -11.605667     -19.898344
    [48]      -17.363649     -10.827877     -7.1729832     -4.7077007
    [52]      -2.9300795     -1.7207711     -1.1088141     -1.1908602
    [56]      -2.0970516     -3.9416492     -6.5908003     -8.8879786
    [60]      -9.1571188     -8.0795116     -6.2102208     -3.8092077
    [64]      -1.7708448    -0.67192364    -0.70419931     -1.9564801
    [68]      -4.5235834     -8.3022699     -11.511971     -11.427576
    [72]      -10.600616     -10.479423     -10.715245     -10.903716
    [76]      -11.172579     -12.018175     -13.983365     -17.678831
    [80]      -22.838345     -21.294703     -17.315424     -15.043075
    [84]      -14.026640     -14.074496     -15.159870     -16.936499
    [88]      -17.812550     -16.628361     -15.223079     -14.912431
    [92]      -16.094578     -18.321558     -17.594675     -13.990863
    [96]      -11.334107     -9.8835917     -9.2120581     -8.9143209
    [100]      -8.7784834     -8.8837223     -9.5425234     -11.164389
    [104]      -13.508564     -12.724236     -9.0095406     -6.4298530
    [108]      -5.5230908     -6.3160682     -9.1632376     -15.578727
    [112]      -40.157394     -18.490252     -16.193054     -16.531551
    [116]      -14.270372     -10.541813     -8.0223856     -6.7777019
    [120]      -6.5401964     -7.1258578     -8.4530792     -10.526702
    [124]      -13.302468     -15.888979     -15.899760     -14.180129
    [128]      -13.002715     -12.958425     -14.258676     -17.485064
    [132]      -24.889999     -24.327328     -16.452736     -12.600335
    [136]      -10.487193     -9.3949194     -8.9727383     -8.9891806
    [140]      -9.2886038     -9.7953558     -10.514171     -11.535841
    [144]      -13.088120     -15.697065     -20.826927     -30.078070
    [148]      -19.332689     -14.183030     -11.721010     -10.830241
    [152]      -11.174754     -12.723149     -15.737654     -20.550192
    [156]      -22.298258     -18.958378     -17.966417     -20.783901
    [160]      -37.492950     -19.040020     -12.538510     -9.3925066
    [164]      -8.1215954     -8.5618105     -11.375454     -20.057102
    [168]      -16.067438     -8.4291563     -5.0581160     -3.5566876
    [172]      -3.1912858     -3.5720844     -4.4017096     -5.3058658
    [176]      -5.7314095     -5.5044012     -5.3236694     -6.0707135
    [180]      -8.5601873     -14.482791     -21.374947     -12.014797
    [184]      -8.1664000     -6.4859738     -5.8504720     -5.8420253
    [188]      -6.3845534     -7.5582685     -9.4344015     -11.959113
    [192]      -14.884251     -17.909601     -21.213554     -25.887657
    [196]      -33.629257     -29.939980     -24.993456     -23.125027
    [200]      -23.145973     -24.374247     -25.780285     -26.363434
    [204]      -26.198771     -25.249176     -23.871506     -23.375597
    [208]      -25.019714     -31.479811     -36.287361     -25.291849
    [212]      -21.939692     -21.380177     -22.754154     -25.625225
    [216]      -29.218029     -32.981339     -39.351040     -51.561100
    [220]      -38.489033     -34.156834     -29.829821     -25.981794
    [224]      -23.627182     -22.816626     -23.384377     -24.949291
    [228]      -26.339695     -26.197723     -25.484793     -25.658548
    [232]      -27.595589     -33.204674     -48.032341     -30.672462
    [236]      -26.692379     -26.197426     -28.500227     -30.812815
    [240]      -26.408449     -22.844690     -21.418289     -21.628965
    [244]      -23.109457     -25.460484     -28.171476     -30.443592
    [248]      -30.328516     -28.096941     -26.112362     -24.792366
    [252]      -23.681768     -22.527578     -21.605837     -21.358522
    [256]      -22.124146     -23.869881     -24.541609     -21.923466
    [260]      -19.202898     -17.917532     -18.330727     -21.013279
    [264]      -28.774195     -30.547504     -21.480732     -18.504221
    [268]      -18.182743     -20.150394     -24.720428     -26.187523
    [272]      -21.685341     -19.537382     -19.683723     -22.132355
    [276]      -28.556149     -40.520382     -26.113777     -22.133778
    [280]      -20.770290     -21.008215     -22.629681     -25.576189
    [284]      -28.883129     -29.386984     -28.369883     -28.659874
    [288]      -30.490192     -30.782923     -27.531507     -24.888935
    [292]      -23.690001     -23.320734     -22.705664     -21.394581
    [296]      -20.128851     -19.546968     -19.800222     -20.758995
    [300]      -21.997490     -22.694637     -22.242025     -21.041388
    [304]      -19.775692     -18.827301     -18.404480     -18.679487
    [308]      -19.856483     -22.272161     -26.674574     -32.321960
    [312]      -26.247402     -20.592329     -16.886763     -14.417368
    [316]      -12.888349     -12.046919     -11.557408     -11.084190
    [320]      -10.500071     -9.8468504     -9.1112232     -8.2950287
    [324]      -7.6257324     -7.4712677     -8.1561871     -9.9567051
    [328]      -13.252417     -18.997913     -29.389406     -22.922159
    [332]      -18.396412     -16.755594     -16.853401     -18.162386
    [336]      -19.607361     -20.448259     -22.647760     -31.823818
    [340]      -24.782322     -17.471373     -14.696461     -14.457161
    [344]      -16.591007     -22.311827     -47.816532     -24.461699
    [348]      -20.849619     -20.577173     -22.419725     -26.961193
    [352]      -37.783527     -29.118799     -23.726633     -21.001776
    [356]      -18.993790     -17.406439     -16.748011     -17.624865
    [360]      -20.795561     -25.494566     -21.204033     -17.028378
    [364]      -15.263092     -15.174407     -16.325216     -18.052427
    [368]      -18.987158     -18.639723     -18.272366     -18.651825
    [372]      -19.730494     -20.998077     -21.989143     -22.942150
    [376]      -24.264868     -25.497169     -25.490166     -24.323055
    [380]      -22.668262     -20.822144     -19.203777     -18.164492
    [384]      -17.774200     -17.905441     -18.396364     -19.182238
    [388]      -20.242468     -21.382526     -22.241642     -22.786793
    [392]      -23.425056     -24.471790     -25.948582     -27.678802
    [396]      -29.105303     -29.082542     -27.677389     -26.362356
    [400]      -26.036190     -27.208494     -30.761778     -40.375103
    [404]      -38.979042     -32.681194     -32.172440     -36.015995
    [408]      -43.067017     -34.845852     -31.530313     -31.690256
    [412]      -34.896263     -38.256878     -33.508183     -30.115700
    [416]      -29.001755     -29.673723     -32.001835     -35.591919
    [420]      -37.553570     -36.783798     -37.179577     -40.471191
    [424]      -45.220634     -38.665398     -33.912441     -31.438114
    [428]      -30.413307     -30.617825     -32.225044     -35.976189
    [432]      -42.057846     -36.603710     -31.325422     -28.459929
    [436]      -26.993380     -26.440060     -26.434301     -26.639364
    [440]      -26.919764     -27.477228     -28.597340     -30.076778
    [444]      -30.561014     -29.404026     -28.207905     -27.979923
    [448]      -28.951414     -31.211996     -35.027603     -41.893528
    [452]      -49.212498     -37.026955     -31.610125     -28.559702
    [456]      -27.021931     -26.670433     -27.249844     -28.468248
    [460]      -30.270903     -33.669945     -44.334137     -36.557213
    [464]      -29.007013     -25.840773     -24.974649     -26.095802
    [468]      -29.575869     -35.558498     -33.686832     -30.103556
    [472]      -29.464279     -31.420208     -36.973412     -43.802666
    [476]      -35.827351     -33.057827     -33.713306     -38.804661
    [480]      -49.323303     -34.585896     -30.192678     -28.740332
    [484]      -29.211340     -31.013016     -31.951658     -29.917940
    [488]      -27.423426     -25.609341     -24.378443     -23.687212
    [492]      -23.711842     -24.741755     -27.111959     -30.800076
    [496]      -32.228569     -29.498554     -27.351677     -26.299910
    [500]      -25.843214     -25.631285     -25.565834     -25.650833
    [504]      -25.866106     -26.224600     -26.850128     -27.925846
    [508]      -29.600864     -31.950634     -34.947758     -38.221519
    [512]      -40.005241
  [Tag]        12321
  [frame_len]          320
[Record 78]
  [tot_power]       711.23157
  [re_spec_val]
    [0]       12.694467      12.148249      10.468575      7.5113783
    [4]       2.9337864     -4.2044249     -18.950230     -18.317646
    [8]      -15.827917     -20.090952     -21.306055     -12.499690
    [12]      -6.8912139     -2.6034079     0.86173826      3.5281746
    [16]       5.3809857      6.4376054      6.7210507      6.2257605
    [20]       4.8829565      2.5063019     -1.3467700     -7.9208732
    [24]      -21.133089     -14.230729     -13.188215     -21.022564
    [28]      -16.802334     -7.9978299     -4.5823817     -3.6239843
    [32]      -4.6486454     -7.8649344     -12.373427     -9.6688309
    [36]      -5.8362446     -3.9365115     -3.3270259     -3.5381260
    [40]      -4.2505078     -5.2404499     -6.3853140     -7.6630960
    [44]      -9.0956049     -10.633410     -12.047068     -13.011921
    [48]      -13.468653     -13.743317     -14.269012     -15.385040
    [52]      -16.967588     -17.195122     -14.722554     -11.821719
    [56]      -9.5098333     -7.6927752     -6.2089291     -5.0439343
    [60]      -4.2702498     -3.9558771     -4.1386585     -4.8506722
    [64]      -6.1645350     -8.2622366     -11.576223     -17.203346
    [68]      -24.178328     -18.058344     -14.558567     -13.617015
    [72]      -14.476282     -16.986261     -20.767435     -22.458775
    [76]      -20.789101     -19.885073     -20.573132     -22.537861
    [80]      -24.005095     -22.447062     -19.845955     -17.644655
    [84]      -15.742179     -13.938023     -12.254410     -10.846266
    [88]      -9.8541565     -9.3255377     -9.1618843     -9.0658894
    [92]      -8.6337814     -7.7241945     -6.6003165     -5.5964060
    [96]      -4.9153376     -4.6615696     -4.8842869     -5.5590301
    [100]      -6.5262370     -7.4801869     -8.1788797     -8.6701250
    [104]      -9.0210819     -8.9570866     -8.2158566     -7.1063023
    [108]      -6.1148043     -5.4677911     -5.2029643     -5.3307118
    [112]      -5.9146090     -7.0717797     -8.9028769     -11.234374
    [116]      -12.947293     -12.802177     -12.050538     -12.086649
    [120]      -13.335514     -15.647844     -17.111490     -15.519277
    [124]      -13.497161     -12.521675     -12.646956     -13.741509
    [128]      -15.654522     -18.136862     -20.615446     -21.924784
    [132]      -21.271326     -19.613810     -18.091343     -17.178755
    [136]      -17.057152     -17.872087     -19.864544     -23.569216
    [140]      -30.475029     -35.544693     -29.166079     -27.156900
    [144]      -27.647125     -27.563269     -23.590916     -19.670256
    [148]      -17.260029     -16.267624     -16.561041     -18.051876
    [152]      -20.561537     -23.616957     -26.801321     -30.394878
    [156]      -30.155926     -25.645508     -22.658083     -21.234800
    [160]      -20.840715     -21.130337     -21.863985     -22.155777
    [164]      -20.506153     -17.894753     -15.940705     -15.086706
    [168]      -15.336657     -16.515404     -17.983248     -18.355219
    [172]      -17.157532     -15.331039     -13.276812     -11.042511
    [176]      -8.8638153     -7.0545845     -5.8317356     -5.3145857
    [180]      -5.5682931     -6.5962653     -8.1730824     -9.3905420
    [184]      -9.0909634     -7.8918052     -6.9676385     -6.7308536
    [188]      -7.2410698     -8.5030355     -10.538299     -13.317202
    [192]      -16.333090     -17.971060     -17.872589     -17.868958
    [196]      -18.913803     -21.243633     -24.808130     -28.443743
    [200]      -29.488041     -29.106567     -28.933281     -28.404907
    [204]      -26.831972     -24.611139     -22.446152     -20.684877
    [208]      -19.392164     -18.469994     -17.731359     -17.017025
    [212]      -16.329288     -15.827126     -15.696369     -16.060997
    [216]      -16.973389     -18.432650     -20.402632     -22.822744
    [220]      -25.599468     -28.598318     -31.798435     -35.269993
    [224]      -35.590275     -31.262554     -27.789524     -25.896032
    [228]      -25.366350     -26.046881     -27.802309     -30.263355
    [232]      -32.210629     -31.931349     -29.917543     -27.659092
    [236]      -25.893002     -24.874073     -24.655836     -25.199306
    [240]      -26.380177     -27.913448     -29.283306     -30.008907
    [244]      -30.128780     -29.975908     -29.720167     -29.382088
    [248]      -28.990812     -28.648407     -28.511387     -28.700474
    [252]      -29.125463     -29.370501     -29.173891     -29.096392
    [256]      -30.085602     -33.157040     -38.784161     -35.955093
    [260]      -31.944368     -31.299673     -34.008228     -38.936817
    [264]      -32.685631     -28.124844     -26.252346     -26.188538
    [268]      -27.501154     -29.426725     -30.258772     -29.834955
    [272]      -30.031437     -32.084400     -37.724464     -53.521210
    [276]      -37.437500     -33.742443     -33.252285     -34.619740
    [280]      -36.717045     -37.477253     -35.747726     -32.473602
    [284]      -29.170681     -26.657490     -25.053530     -24.181639
    [288]      -23.709301     -23.251904     -22.639059     -22.074696
    [292]      -21.927412     -22.508316     -23.949047     -25.659777
    [296]      -25.612480     -23.935423     -22.806391     -22.910664
    [300]      -23.970577     -24.764297     -24.326077     -23.856663
    [304]      -24.398699     -25.616804     -25.767263     -24.616005
    [308]      -23.952494     -24.493664     -26.092846     -27.654940
    [312]      -26.749914     -23.619213     -20.546314     -18.374559
    [316]      -17.268238     -17.253572     -18.304388     -20.100590
    [320]      -21.129509     -19.773401     -17.605190     -15.959867
    [324]      -15.064263     -14.936010     -15.647206     -17.396648
    [328]      -20.649708     -26.865753     -52.381081     -27.736303
    [332]      -22.092339     -18.647272     -16.240198     -14.707239
    [336]      -13.912286     -13.530675     -13.115664     -12.513409
    [340]      -12.066118     -12.232459     -13.354757     -15.756730
    [344]      -19.956465     -26.327923     -26.931820     -23.625904
    [348]      -22.441154     -22.450539     -22.617897     -22.316216
    [352]      -21.544752     -20.507898     -19.471954     -18.807718
    [356]      -18.866331     -19.946646     -22.410690     -26.714848
    [360]      -29.831181     -26.128557     -23.305344     -22.421610
    [364]      -23.282907     -26.227161     -32.921711     -37.703453
    [368]      -30.007463     -27.361610     -26.951311     -27.423834
    [372]      -27.713427     -27.899164     -29.155193     -33.130219
    [376]      -41.490101     -32.112606     -26.829090     -24.315922
    [380]      -23.324997     -23.394733     -24.289885     -25.838840
    [384]      -27.828241     -29.881523     -31.462498     -32.299973
    [388]      -32.649960     -32.809807     -32.848183     -32.812420
    [392]      -32.883488     -33.272900     -34.077213     -35.212914
    [396]      -36.386616     -37.107243     -36.850658     -35.463318
    [400]      -33.378647     -31.198174     -29.329044     -28.001766
    [404]      -27.373142     -27.593155     -28.851217     -31.417290
    [408]      -35.522388     -39.483063     -39.410046     -39.854694
    [412]      -44.731262     -48.277153     -38.831844     -35.157951
    [416]      -34.240833     -35.548717     -39.907982     -53.203949
    [420]      -40.411415     -34.418095     -31.436434     -30.011839
    [424]      -29.767271     -30.534037     -31.994946     -33.382507
    [428]      -34.085884     -34.728054     -35.900375     -36.421913
    [432]      -34.867184     -33.030125     -32.229675     -32.664242
    [436]      -34.360378     -37.555836     -43.380630     -52.648399
    [440]      -42.530170     -37.223888     -34.205170     -32.519409
    [444]      -31.993093     -32.723370     -35.023346     -39.507065
    [448]      -44.668442     -42.034100     -40.106079     -40.994884
    [452]      -44.083130     -44.809135     -41.785542     -40.323933
    [456]      -41.110924     -44.396042     -46.878071     -41.332935
    [460]      -36.951557     -34.426186     -33.337612     -33.646893
    [464]      -35.565426     -39.066936     -40.070896     -37.092709
    [468]      -35.567909     -36.347130     -40.184528     -53.649246
    [472]      -44.256763     -38.195076     -36.104713     -35.843285
    [476]      -36.625721     -37.276318     -36.085934     -33.577351
    [480]      -31.259314     -29.632746     -28.777687     -28.746117
    [484]      -29.675646     -31.845736     -35.373138     -36.321693
    [488]      -32.204002     -28.804108     -26.635447     -25.292421
    [492]      -24.516148     -24.207125     -24.378464     -25.090408
    [496]      -26.393856     -28.294455     -30.726070     -33.532177
    [500]      -36.469940     -39.057777     -39.813221     -37.826843
    [504]      -35.169392     -33.196404     -32.185417     -32.137211
    [508]      -32.908714     -34.016132     -34.567989     -34.331867
    [512]      -34.105511
  [Tag]        12481
  [frame_len]          320
[Record 79]
  [tot_power]       337.23038
  [re_spec_val]
    [0]       12.253691      11.694962      9.9703884      6.9095879
    [4]       2.1066856     -5.5414009     -21.061821     -18.829832
    [8]      -19.849480     -30.518055     -31.741903     -37.427620
    [12]      -23.587334     -16.652803     -13.916293     -13.675711
    [16]      -15.751764     -20.521660     -19.859520     -14.261450
    [20]      -11.167810     -9.8709469     -9.9324827     -11.191685
    [24]      -13.329398     -14.376596     -12.265860     -9.5885887
    [28]      -7.7413855     -6.7500143     -6.4896712     -6.9219184
    [32]      -8.1399860     -10.393927     -14.194091     -20.819466
    [36]      -31.584574     -25.476738     -23.833075     -25.369068
    [40]      -26.392780     -24.193285     -22.156681     -21.134274
    [44]      -20.567327     -20.036497     -19.677872     -19.912430
    [48]      -21.133448     -23.766479     -28.448481     -32.016209
    [52]      -26.984612     -22.848728     -20.050163     -17.998503
    [56]      -16.491415     -15.501977     -15.041326     -15.072422
    [60]      -15.449485     -15.922840     -16.253325     -16.248169
    [64]      -15.657328     -14.498218     -13.342583     -12.818573
    [68]      -13.327511     -15.198896     -18.977774     -26.060701
    [72]      -32.235119     -27.183561     -26.791479     -29.990883
    [76]      -32.590488     -28.344101     -25.676702     -25.184473
    [80]      -26.397459     -28.824741     -30.782675     -30.675745
    [84]      -30.546064     -32.164803     -37.490562     -50.604206
    [88]      -33.305038     -28.183056     -25.904894     -25.407965
    [92]      -26.379314     -28.626423     -31.653608     -34.021008
    [96]      -34.247444     -32.403889     -28.865179     -24.796339
    [100]      -21.258383     -18.619072     -16.926142     -16.144211
    [104]      -16.228992     -17.140738     -18.818966     -21.074753
    [108]      -23.322460     -24.590673     -24.805908     -25.005329
    [112]      -26.142166     -29.298901     -36.037701     -30.233601
    [116]      -24.124905     -21.051500     -19.835472     -20.150427
    [120]      -21.999207     -25.361324     -28.195488     -27.102184
    [124]      -25.925032     -26.463892     -28.388134     -29.682671
    [128]      -28.506271     -27.113470     -26.750420     -27.386894
    [132]      -28.660801     -29.856483     -30.091759     -29.421848
    [136]      -28.705322     -28.532091     -29.138416     -30.558384
    [140]      -32.540585     -34.341286     -35.118717     -34.413326
    [144]      -31.989702     -28.881071     -26.186338     -24.242172
    [148]      -23.083092     -22.725079     -23.271357     -25.016945
    [152]      -28.754667     -36.559444     -32.980827     -26.885160
    [156]      -24.039465     -22.845665     -22.667671     -23.132490
    [160]      -24.037600     -25.398087     -27.302240     -29.422247
    [164]      -30.871284     -32.123508     -35.693111     -44.939503
    [168]      -34.169125     -29.064074     -27.400461     -28.159527
    [172]      -31.544071     -39.433918     -53.646458     -41.613083
    [176]      -34.081257     -27.533192     -23.286674     -20.839275
    [180]      -19.839190     -20.163797     -21.894218     -25.408190
    [184]      -31.853170     -42.063553     -36.301666     -33.507931
    [188]      -31.514360     -29.358528     -28.296339     -29.049034
    [192]      -31.486700     -31.053730     -26.818718     -23.801111
    [196]      -22.301107     -21.979786     -22.580395     -23.874063
    [200]      -25.620537     -27.658466     -30.084635     -33.164108
    [204]      -36.133480     -35.673359     -33.253296     -31.557274
    [208]      -30.812775     -30.832874     -31.468431     -32.677177
    [212]      -34.532330     -36.586750     -35.820927     -32.243240
    [216]      -29.184046     -27.283630     -26.446518     -26.561600
    [220]      -27.569714     -29.472963     -32.366905     -36.501076
    [224]      -41.975971     -44.697041     -42.431698     -40.647869
    [228]      -38.792522     -35.994976     -33.085625     -30.802507
    [232]      -29.300447     -28.533806     -28.429844     -28.935698
    [236]      -30.019871     -31.610167     -33.412441     -34.821770
    [240]      -35.703293     -37.057713     -40.474804     -49.341820
    [244]      -43.669064     -37.345657     -34.408554     -32.833202
    [248]      -31.849770     -31.359430     -31.742603     -33.591805
    [252]      -37.351490     -38.099445     -33.562191     -30.661894
    [256]      -29.432566     -29.215704     -29.295282     -29.099979
    [260]      -28.744642     -28.770987     -29.589838     -31.451080
    [264]      -34.543774     -38.375999     -39.141289     -37.014320
    [268]      -35.908649     -36.627274     -39.947456     -49.801815
    [272]      -44.358253     -37.978432     -36.020203     -36.921253
    [276]      -41.960903     -50.622341     -36.974422     -31.771484
    [280]      -28.916588     -27.306665     -26.583752     -26.605068
    [284]      -27.256433     -28.328054     -29.508362     -30.717175
    [288]      -32.555248     -36.670380     -52.435562     -36.425514
    [292]      -29.758533     -26.288544     -24.331972     -23.350258
    [296]      -23.073946     -23.324596     -23.959848     -24.837400
    [300]      -25.743715     -26.321657     -26.262907     -25.727964
    [304]      -25.210985     -25.096493     -25.574478     -26.734459
    [308]      -28.602398     -30.904728     -32.181118     -30.949045
    [312]      -28.883619     -27.332335     -26.495842     -26.294323
    [316]      -26.612848     -27.354416     -28.454287     -29.765352
    [320]      -30.642830     -30.084953     -28.580370     -27.478054
    [324]      -27.540859     -29.382280     -34.369587     -37.020092
    [328]      -28.991625     -24.598026     -22.170975     -20.892714
    [332]      -20.367882     -20.319960     -20.499735     -20.693802
    [336]      -20.795547     -20.842621     -20.957006     -21.247763
    [340]      -21.725372     -22.225698     -22.468027     -22.414621
    [344]      -22.469667     -23.160889     -24.916162     -28.061499
    [348]      -31.988163     -32.228989     -29.932051     -28.614168
    [352]      -28.268679     -28.415216     -28.645412     -28.798651
    [356]      -29.105234     -30.046326     -32.073246     -35.073429
    [360]      -36.529678     -35.467693     -35.550610     -38.925255
    [364]      -51.222588     -38.271748     -32.354187     -29.614809
    [368]      -28.513828     -28.578951     -29.670536     -31.895769
    [372]      -35.824970     -43.653866     -43.741436     -36.058735
    [376]      -32.320805     -30.364393     -29.654257     -30.105860
    [380]      -31.843071     -35.093632     -38.941528     -38.190342
    [384]      -35.510403     -34.137856     -33.907772     -34.376202
    [388]      -35.180668     -36.253288     -38.020893     -41.577751
    [392]      -51.405403     -48.280392     -39.672245     -35.917339
    [396]      -34.006096     -33.254559     -33.369034     -34.064236
    [400]      -34.905621     -35.519581     -36.083954     -37.179916
    [404]      -39.100849     -40.183857     -37.530388     -34.126339
    [408]      -31.792150     -30.630241     -30.634621     -31.976133
    [412]      -35.249966     -42.931217     -50.294331     -39.218487
    [416]      -36.644058     -37.190762     -40.553307     -45.908302
    [420]      -43.564037     -40.692886     -39.231041     -36.494823
    [424]      -33.077873     -30.520571     -29.064072     -28.550556
    [428]      -28.779324     -29.571035     -30.808512     -32.473270
    [432]      -34.597710     -36.993473     -38.722919     -38.880512
    [436]      -38.433884     -38.461437     -39.120586     -39.973446
    [440]      -40.310253     -39.868008     -39.062557     -38.445049
    [444]      -38.501080     -39.740784     -42.960499     -49.549335
    [448]      -47.775826     -42.348206     -40.207169     -40.229721
    [452]      -42.152931     -45.228058     -44.015465     -40.122959
    [456]      -37.690903     -36.832047     -37.488400     -40.017769
    [460]      -46.133114     -56.648804     -43.692627     -39.599197
    [464]      -38.318966     -39.045635     -41.686779     -43.121681
    [468]      -39.101307     -35.736465     -34.148197     -34.037304
    [472]      -35.173523     -37.302574     -40.048550     -43.123894
    [476]      -45.193634     -42.707222     -39.409031     -37.591030
    [480]      -36.970184     -36.654621     -35.768021     -34.561016
    [484]      -33.807156     -33.881493     -34.858788     -36.706852
    [488]      -39.338070     -42.557056     -45.695530     -46.719334
    [492]      -44.685139     -41.689491     -38.891850     -36.627029
    [496]      -35.034092     -34.145630     -33.892944     -34.099571
    [500]      -34.509930     -34.939064     -35.448814     -36.285179
    [504]      -37.666592     -39.673653     -42.184803     -44.100060
    [508]      -42.417927     -38.719666     -35.764828     -34.010471
    [512]      -33.433926
  [Tag]        12641
  [frame_len]          320
[Record 80]
  [tot_power]       379.82736
  [re_spec_val]
    [0]       12.673645      12.141861      10.509532      7.6507230
    [4]       3.2890711     -3.1992817     -13.583186     -25.542347
    [8]      -24.667248     -28.367090     -21.674852     -19.331299
    [12]      -19.696751     -20.840750     -19.660082     -16.592833
    [16]      -14.189861     -12.978151     -12.853107     -13.616196
    [20]      -14.970163     -16.407072     -17.211699     -16.684813
    [24]      -14.821925     -12.615840     -10.885717     -9.8507547
    [28]      -9.4061518     -9.3586960     -9.6235790     -10.324503
    [32]      -11.707076     -13.968667     -16.890995     -18.773087
    [36]      -18.104105     -16.821135     -16.078295     -15.945216
    [40]      -16.382452     -17.454596     -19.328127     -22.212677
    [44]      -25.835613     -27.207539     -25.448458     -24.312712
    [48]      -24.837406     -27.302633     -30.855536     -28.858644
    [52]      -25.106520     -23.105728     -22.462116     -22.613934
    [56]      -22.966635     -23.060009     -22.833685     -22.430733
    [60]      -21.890371     -21.161856     -20.225864     -19.129538
    [64]      -17.966717     -16.877789     -16.047300     -15.666130
    [68]      -15.890531     -16.828037     -18.542259     -21.064476
    [72]      -24.411304     -28.461721     -31.494829     -30.446024
    [76]      -28.468519     -27.638079     -28.075264     -29.622877
    [80]      -31.957279     -34.424530     -36.386303     -38.002209
    [84]      -39.615917     -40.795662     -40.543900     -38.705235
    [88]      -36.290436     -34.061409     -32.236778     -30.870478
    [92]      -30.026508     -29.725580     -29.844648     -30.161386
    [96]      -30.655163     -31.715746     -33.971825     -38.233063
    [100]      -46.064293     -62.512104     -52.296547     -42.764896
    [104]      -37.228714     -34.390110     -33.453453     -33.961029
    [108]      -35.494846     -37.425247     -38.858818     -39.251686
    [112]      -39.025345     -38.927700     -39.411625     -41.049541
    [116]      -46.353188     -51.767284     -37.394482     -31.499006
    [120]      -28.078981     -26.111959     -25.163765     -24.932615
    [124]      -25.143677     -25.580919     -26.187874     -27.075184
    [128]      -28.367771     -29.993664     -31.540142     -32.556362
    [132]      -33.124088     -33.377930     -33.071198     -32.441387
    [136]      -32.288284     -33.082214     -34.273560     -33.750381
    [140]      -31.614937     -29.936626     -29.301720     -29.611195
    [144]      -30.545414     -31.517456     -31.846342     -31.536476
    [148]      -31.303917     -31.799875     -33.370811     -35.692562
    [152]      -36.461044     -35.058239     -34.263943     -34.847881
    [156]      -35.314972     -33.049919     -30.020889     -28.004984
    [160]      -27.164093     -27.431141     -28.822653     -31.503084
    [164]      -35.560051     -37.558945     -34.038910     -30.877230
    [168]      -28.971994     -28.062090     -28.026211     -28.886677
    [172]      -30.784582     -33.865623     -36.978195     -36.130604
    [176]      -33.860737     -32.961483     -33.744968     -36.517326
    [180]      -42.528301     -55.396233     -45.679249     -41.489468
    [184]      -37.430592     -33.040291     -29.568781     -27.224924
    [188]      -25.894693     -25.473494     -25.904316     -27.136574
    [192]      -28.943935     -30.379240     -29.999277     -28.391148
    [196]      -26.940563     -26.114471     -25.928850     -26.189653
    [200]      -26.404486     -25.884125     -24.500660     -22.821201
    [204]      -21.335209     -20.245872     -19.607931     -19.407789
    [208]      -19.582890     -20.033636     -20.660275     -21.418468
    [212]      -22.337765     -23.465721     -24.770636     -26.054571
    [216]      -26.972229     -27.299381     -27.188251     -26.980885
    [220]      -26.946253     -27.248732     -27.993818     -29.231318
    [224]      -30.873283     -32.484085     -33.274628     -33.117870
    [228]      -32.899326     -33.432632     -35.241951     -38.695309
    [232]      -41.837513     -39.723549     -37.349712     -35.970486
    [236]      -34.231434     -31.956867     -30.172623     -29.483765
    [240]      -30.108809     -32.074268     -34.023418     -32.306034
    [244]      -29.250605     -27.246767     -26.425480     -26.692141
    [248]      -28.054256     -30.616648     -34.280598     -36.948292
    [252]      -36.081490     -34.734009     -33.914486     -32.997276
    [256]      -31.850477     -30.992172     -30.860582     -31.708282
    [260]      -33.855042     -38.093231     -46.235092     -42.978695
    [264]      -37.911903     -35.979382     -35.423237     -34.952019
    [268]      -33.823997     -32.492165     -31.582325     -31.295834
    [272]      -31.641182     -32.693546     -34.791531     -38.664642
    [276]      -42.393402     -37.647049     -33.615715     -31.541561
    [280]      -30.681063     -30.426714     -30.260368     -29.978544
    [284]      -29.698725     -29.453264     -28.976088     -28.016695
    [288]      -26.768661     -25.670589     -25.038692     -25.019266
    [292]      -25.644089     -26.821360     -28.225742     -29.236578
    [296]      -29.448673     -29.237099     -29.158979     -29.380596
    [300]      -29.663633     -29.670382     -29.527191     -29.822626
    [304]      -31.177107     -34.299557     -40.874489     -47.540302
    [308]      -39.531818     -36.928669     -36.988510     -38.870358
    [312]      -41.638813     -42.140583     -40.250214     -38.938007
    [316]      -38.624817     -38.742649     -38.703930     -38.653267
    [320]      -38.889072     -38.453110     -36.195915     -33.426716
    [324]      -31.257784     -29.805834     -28.927504     -28.471264
    [328]      -28.263643     -28.011854     -27.361450     -26.237457
    [332]      -24.929266     -23.738420     -22.790813     -22.079660
    [336]      -21.534983     -21.066374     -20.590271     -20.045189
    [340]      -19.395660     -18.639194     -17.821245     -17.034834
    [344]      -16.392229     -15.989955     -15.886069     -16.083807
    [348]      -16.507160     -16.974073     -17.230497     -17.114822
    [352]      -16.694885     -16.158487     -15.641398     -15.200637
    [356]      -14.874771     -14.728878     -14.848999     -15.304270
    [360]      -16.099104     -17.117485     -18.090826     -18.726439
    [364]      -19.001337     -19.184738     -19.546972     -20.196266
    [368]      -21.067572     -21.932001     -22.494812     -22.665436
    [372]      -22.662376     -22.750101     -23.018515     -23.364767
    [376]      -23.575983     -23.482157     -23.097696     -22.604668
    [380]      -22.216402     -22.073170     -22.203463     -22.511856
    [384]      -22.788696     -22.795259     -22.434027     -21.830839
    [388]      -21.221821     -20.811241     -20.709410     -20.901112
    [392]      -21.197018     -21.243883     -20.793127     -20.004652
    [396]      -19.248878     -18.784193     -18.705826     -18.997101
    [400]      -19.549183     -20.153589     -20.549702     -20.602560
    [404]      -20.436995     -20.309441     -20.412107     -20.794542
    [408]      -21.337505     -21.753132     -21.751902     -21.346691
    [412]      -20.830276     -20.477312     -20.426529     -20.728977
    [416]      -21.408979     -22.483311     -23.898766     -25.301985
    [420]      -25.827263     -25.046858     -23.793995     -22.855827
    [424]      -22.492834     -22.721737     -23.466169     -24.580860
    [428]      -25.847832     -27.026438     -27.985916     -28.782143
    [432]      -29.563835     -30.434862     -31.358953     -32.072044
    [436]      -32.164646     -31.556108     -30.646811     -29.822607
    [440]      -29.210480     -28.762951     -28.385098     -28.025232
    [444]      -27.701208     -27.466034     -27.362978     -27.399492
    [448]      -27.521681     -27.570339     -27.278791     -26.462629
    [452]      -25.262926     -24.027367     -23.036079     -22.426191
    [456]      -22.232985     -22.425917     -22.915840     -23.545200
    [460]      -24.095896     -24.373360     -24.349087     -24.192112
    [464]      -24.142778     -24.395334     -25.050215     -26.050568
    [468]      -27.015278     -27.209835     -26.356279     -25.062532
    [472]      -23.896631     -23.053362     -22.555260     -22.392241
    [476]      -22.563532     -23.068041     -23.860497     -24.778536
    [480]      -25.498543     -25.704000     -25.417496     -24.950546
    [484]      -24.572237     -24.392893     -24.402395     -24.514950
    [488]      -24.618294     -24.636982     -24.555300     -24.375828
    [492]      -24.095076     -23.744028     -23.417072     -23.227333
    [496]      -23.235697     -23.405447     -23.594995     -23.622406
    [500]      -23.411823     -23.069311     -22.775190     -22.648680
    [504]      -22.706940     -22.883654     -23.066406     -23.146963
    [508]      -23.073641     -22.874214     -22.632366     -22.441906
    [512]      -22.370403
  [Tag]        12801
  [frame_len]          320
[Record 81]
  [tot_power]       329.32010
  [re_spec_val]
    [0]       12.416071      11.853357      10.114730      7.0197387
    [4]       2.1216006     -5.9149942     -25.886370     -15.589622
    [8]      -15.631291     -20.617037     -25.434145     -22.613199
    [12]      -19.513573     -17.441942     -17.060934     -18.739326
    [16]      -22.999853     -29.664640     -27.945740     -25.166140
    [20]      -23.928080     -21.659193     -18.405355     -15.714314
    [24]      -14.213410     -14.213039     -16.321402     -22.597801
    [28]      -24.191544     -15.861686     -12.402625     -11.219398
    [32]      -11.542409     -12.999834     -15.218460     -17.660696
    [36]      -19.789270     -21.327126     -22.138451     -22.552422
    [40]      -23.420015     -25.517483     -29.591103     -36.567890
    [44]      -38.719646     -36.256996     -38.234814     -44.171303
    [48]      -35.543911     -29.791225     -26.526337     -24.577105
    [52]      -23.554789     -23.354965     -23.984463     -25.484140
    [56]      -27.861273     -30.894156     -33.665928     -34.927727
    [60]      -34.805958     -33.765923     -32.297112     -31.246632
    [64]      -31.182299     -32.303356     -34.233284     -34.960152
    [68]      -33.443096     -31.962002     -31.518135     -32.119751
    [72]      -33.552448     -35.299660     -36.140018     -35.150711
    [76]      -33.347176     -31.830359     -30.980539     -30.894854
    [80]      -31.602827     -33.119244     -35.434635     -38.359413
    [84]      -40.803471     -40.711205     -38.891022     -37.109333
    [88]      -35.758839     -34.750938     -33.965614     -33.444984
    [92]      -33.442055     -34.230457     -35.379795     -34.442257
    [96]      -31.310242     -28.600262     -26.994999     -26.446413
    [100]      -26.854013     -28.156544     -30.312754     -33.123470
    [104]      -35.550064     -35.940079     -35.253471     -35.110573
    [108]      -35.879570     -37.194527     -38.032845     -37.767010
    [112]      -37.152386     -36.790516     -36.483727     -35.692459
    [116]      -34.292606     -32.713528     -31.371820     -30.474081
    [120]      -30.117371     -30.377455     -31.361769     -33.292191
    [124]      -36.777882     -44.157627     -45.681679     -36.739082
    [128]      -32.683018     -30.719273     -30.215137     -31.059580
    [132]      -33.439312     -37.589249     -38.934475     -34.458565
    [136]      -31.266747     -29.691139     -29.380749     -30.144995
    [140]      -31.730618     -33.343357     -33.660301     -32.845264
    [144]      -32.014935     -31.403584     -30.705040     -29.805408
    [148]      -28.994453     -28.595043     -28.738749     -29.409771
    [152]      -30.560604     -32.228657     -34.536217     -37.217979
    [156]      -38.455505     -37.560184     -36.902893     -37.266491
    [160]      -37.184120     -34.859795     -32.117146     -30.360670
    [164]      -29.742010     -30.084017     -30.888960     -31.169544
    [168]      -30.465265     -29.635746     -29.517750     -30.521461
    [172]      -33.001743     -37.374054     -40.695671     -37.651260
    [176]      -35.575947     -35.705944     -38.075314     -42.759056
    [180]      -41.468365     -36.209587     -33.047867     -31.386026
    [184]      -30.817986     -31.137733     -32.135399     -33.464916
    [188]      -34.781387     -36.272938     -38.779850     -42.300774
    [192]      -40.185055     -35.970695     -34.037937     -34.380421
    [196]      -36.306061     -34.879887     -30.835363     -28.528645
    [200]      -28.369598     -30.673635     -35.829216     -33.902683
    [204]      -29.234331     -27.553707     -28.202505     -30.814516
    [208]      -33.014671     -31.176189     -29.509684     -29.793770
    [212]      -32.249989     -37.659061     -50.279762     -49.237877
    [216]      -47.840431     -60.244263     -47.260391     -41.013966
    [220]      -38.023129     -35.876514     -33.901550     -32.278439
    [224]      -31.361254     -31.456015     -32.961708     -36.751759
    [228]      -44.542358     -39.928295     -34.682125     -32.499584
    [232]      -31.919722     -32.180992     -32.545544     -32.416069
    [236]      -31.905792     -31.649324     -32.252506     -34.335148
    [240]      -39.220272     -51.715336     -40.870060     -36.231670
    [244]      -34.997612     -35.960201     -39.279297     -47.188652
    [248]      -55.420536     -44.588482     -42.324829     -42.384342
    [252]      -41.935932     -39.153721     -35.928158     -33.291916
    [256]      -31.294130     -29.913847     -29.174128     -29.071100
    [260]      -29.493946     -30.175516     -30.803848     -31.325745
    [264]      -31.926928     -32.522652     -32.530243     -31.758165
    [268]      -30.902586     -30.540276     -30.750877     -31.288445
    [272]      -31.823856     -32.288795     -32.955029     -34.177113
    [276]      -36.291836     -39.810131     -46.076088     -53.044514
    [280]      -44.806065     -40.373611     -37.726040     -35.902115
    [284]      -34.381477     -32.796772     -31.239191     -30.156036
    [288]      -29.913462     -30.593908     -31.705605     -31.934483
    [292]      -31.058329     -30.497377     -31.060474     -32.654579
    [296]      -33.755543     -32.856579     -31.927633     -32.662975
    [300]      -36.069923     -40.202190     -34.089684     -29.743511
    [304]      -27.694492     -27.164715     -27.820299     -29.512650
    [308]      -32.136253     -35.282166     -37.290821     -36.938107
    [312]      -36.300129     -36.991753     -40.169662     -50.319374
    [316]      -44.554840     -37.784126     -35.522537     -35.806381
    [320]      -38.633217     -44.706627     -43.800156     -38.820469
    [324]      -36.422382     -35.090828     -33.897900     -32.666355
    [328]      -31.698648     -31.354176     -31.952291     -33.788696
    [332]      -36.872913     -39.510330     -39.850067     -39.866337
    [336]      -37.267372     -32.999996     -30.325686     -29.686243
    [340]      -31.286963     -36.268826     -57.846500     -38.759346
    [344]      -33.545185     -30.761053     -28.919350     -28.335180
    [348]      -29.776735     -35.260326     -43.400009     -30.883062
    [352]      -26.694599     -25.195553     -25.377260     -27.006279
    [356]      -30.220049     -33.889088     -31.279678     -27.308084
    [360]      -25.124815     -24.520615     -25.349707     -27.641140
    [364]      -31.517956     -36.989735     -44.448334     -50.631958
    [368]      -38.596096     -33.617786     -31.684301     -32.041794
    [372]      -34.910286     -42.460094     -51.006397     -39.664459
    [376]      -36.778004     -35.696827     -34.850853     -33.928101
    [380]      -33.372749     -33.723351     -35.529026     -39.497192
    [384]      -44.245964     -42.291702     -40.690163     -38.284653
    [388]      -33.347050     -29.517067     -27.444668     -26.935553
    [392]      -27.883080     -30.374899     -34.880981     -42.295654
    [396]      -41.462368     -36.895645     -35.119595     -34.990204
    [400]      -35.562107     -35.824600     -35.845516     -36.778351
    [404]      -39.911255     -45.938698     -39.925415     -34.084400
    [408]      -30.879108     -29.320026     -29.101154     -30.187853
    [412]      -32.727795     -36.999199     -41.480949     -40.276455
    [416]      -38.854252     -40.554199     -47.477776     -40.778004
    [420]      -34.290234     -31.381346     -30.695456     -32.062923
    [424]      -36.199097     -46.207306     -40.833931     -35.899334
    [428]      -34.607025     -35.208683     -36.949074     -39.009468
    [432]      -40.338581     -40.685047     -40.993172     -41.698410
    [436]      -41.383400     -39.426327     -37.902840     -37.756496
    [440]      -38.684624     -39.386269     -39.041122     -38.500359
    [444]      -37.786907     -36.497669     -35.394161     -35.167210
    [448]      -35.401356     -34.761719     -33.323208     -32.492142
    [452]      -33.042225     -35.510326     -41.425179     -59.296192
    [456]      -42.345730     -39.088459     -39.759991     -44.556854
    [460]      -63.130253     -46.781639     -44.733891     -48.006493
    [464]      -43.663364     -37.463226     -34.365314     -33.226490
    [468]      -33.491726     -34.905605     -37.432049     -41.197170
    [472]      -45.710159     -48.702122     -51.305664     -46.493324
    [476]      -39.674026     -35.753902     -33.871292     -33.539955
    [480]      -34.523476     -36.699608     -39.832268     -42.205624
    [484]      -41.216393     -39.640465     -39.179184     -38.590633
    [488]      -36.181023     -33.598587     -32.349480     -32.902191
    [492]      -35.909161     -44.229088     -46.265549     -38.649788
    [496]      -37.493210     -40.262047     -46.001965     -40.192677
    [500]      -36.164516     -35.239017     -36.664345     -39.740715
    [504]      -39.968430     -37.235374     -36.049934     -37.040070
    [508]      -40.561451     -44.296776     -39.933666     -36.583706
    [512]      -35.568417
  [Tag]        12961
  [frame_len]          320
aArDvArK

## RUN PROGRAM (1)

echo 'Running command (1):'
echo '    ./mbs_dist -A tstA.spec tstB.spec out1.fea >log1.txt'
./mbs_dist -A tstA.spec tstB.spec out1.fea >log1.txt


## CHECK OUTPUT (1)

## --- STDOUT OUTPUT (1)

echo '... checking stdout output'

x=`cat log1.txt`
pat="10.111600"

case "$x" in
'') echo "* * * ERROR: no output to stdout";;
*)
    case `echo	"scale=20;" \
		"if (($x) < 0.99 * ($pat)) \"NOT\";" \
		"if (($pat) < 0.99 * ($x)) \"NOT\";" \
		"\"OK\"" | bc`
    in
    OK) : ;;
    *)  echo "* * * ERROR: output distortion is $x; should be $pat" ;;
    esac
;;
esac

## --- FEA OUTPUT (1)

## --- Make FEA comparison file (1)

echo '... making comparison file ref1.fea'

esig2fea - ref1.fea <<aArDvArK
Esignal
   0.0B
  ASCII
     48
    665
     -1
Tag: LONG <r>
MBSD: FLOAT <r>
MBSD_included: SHORT <r>
MBSD_included.enumStrings: CHAR 2 4 <g> 
  [0][0]  "NO\0\0"
  [1][0]  "YES\0"
nan: LONG 1 <g> [0]            0
src_sf: DOUBLE 1 <g> [0]        8000.000000000000
distortion_type: SHORT 1 <g> [0]       2
distortion_type.enumStrings: CHAR 3 5 <g> 
  [0][0]  "NONE\0"
  [1][0]  "BSD\0\0"
  [2][0]  "MBSD\0"
start: LONG 2 <g> 
  [0]            1           1
record_freq: DOUBLE 1 <g> [0]        50.00000000000000
start_time: DOUBLE 1 <g> [0]      0.02000000000000000
recordFreq: DOUBLE <g>       50.00000000000000
startTime: DOUBLE 1 <g> [0]      0.02000000000000000
[Record 0]
  [MBSD]       1.533429
  [Tag]            1
  [MBSD_included]       0
[Record 1]
  [MBSD]       1.970142
  [Tag]          161
  [MBSD_included]       0
[Record 2]
  [MBSD]       1.744389
  [Tag]          321
  [MBSD_included]       0
[Record 3]
  [MBSD]       0.572297
  [Tag]          481
  [MBSD_included]       0
[Record 4]
  [MBSD]       2.988862
  [Tag]          641
  [MBSD_included]       1
[Record 5]
  [MBSD]       2.000809
  [Tag]          801
  [MBSD_included]       1
[Record 6]
  [MBSD]       2.105886
  [Tag]          961
  [MBSD_included]       1
[Record 7]
  [MBSD]       0.454416
  [Tag]         1121
  [MBSD_included]       1
[Record 8]
  [MBSD]       3.554819
  [Tag]         1281
  [MBSD_included]       1
[Record 9]
  [MBSD]       9.841910
  [Tag]         1441
  [MBSD_included]       1
[Record 10]
  [MBSD]       7.422391
  [Tag]         1601
  [MBSD_included]       1
[Record 11]
  [MBSD]       6.866177
  [Tag]         1761
  [MBSD_included]       1
[Record 12]
  [MBSD]       6.214296
  [Tag]         1921
  [MBSD_included]       0
[Record 13]
  [MBSD]       14.758785
  [Tag]         2081
  [MBSD_included]       1
[Record 14]
  [MBSD]       13.266623
  [Tag]         2241
  [MBSD_included]       0
[Record 15]
  [MBSD]       10.410454
  [Tag]         2401
  [MBSD_included]       1
[Record 16]
  [MBSD]       10.908244
  [Tag]         2561
  [MBSD_included]       1
[Record 17]
  [MBSD]       18.978099
  [Tag]         2721
  [MBSD_included]       1
[Record 18]
  [MBSD]       22.142016
  [Tag]         2881
  [MBSD_included]       1
[Record 19]
  [MBSD]       24.189187
  [Tag]         3041
  [MBSD_included]       1
[Record 20]
  [MBSD]       19.735913
  [Tag]         3201
  [MBSD_included]       1
[Record 21]
  [MBSD]       16.663894
  [Tag]         3361
  [MBSD_included]       1
[Record 22]
  [MBSD]       12.047734
  [Tag]         3521
  [MBSD_included]       1
[Record 23]
  [MBSD]       9.912277
  [Tag]         3681
  [MBSD_included]       1
[Record 24]
  [MBSD]       7.995951
  [Tag]         3841
  [MBSD_included]       0
[Record 25]
  [MBSD]       12.351762
  [Tag]         4001
  [MBSD_included]       1
[Record 26]
  [MBSD]       12.984885
  [Tag]         4161
  [MBSD_included]       1
[Record 27]
  [MBSD]       7.114380
  [Tag]         4321
  [MBSD_included]       0
[Record 28]
  [MBSD]       8.249673
  [Tag]         4481
  [MBSD_included]       1
[Record 29]
  [MBSD]       8.261422
  [Tag]         4641
  [MBSD_included]       1
[Record 30]
  [MBSD]       9.321382
  [Tag]         4801
  [MBSD_included]       1
[Record 31]
  [MBSD]       11.530859
  [Tag]         4961
  [MBSD_included]       1
[Record 32]
  [MBSD]       9.377032
  [Tag]         5121
  [MBSD_included]       1
[Record 33]
  [MBSD]       8.965472
  [Tag]         5281
  [MBSD_included]       1
[Record 34]
  [MBSD]       11.588917
  [Tag]         5441
  [MBSD_included]       1
[Record 35]
  [MBSD]       13.482445
  [Tag]         5601
  [MBSD_included]       1
[Record 36]
  [MBSD]       6.095615
  [Tag]         5761
  [MBSD_included]       1
[Record 37]
  [MBSD]       1.655609
  [Tag]         5921
  [MBSD_included]       1
[Record 38]
  [MBSD]       0.627573
  [Tag]         6081
  [MBSD_included]       1
[Record 39]
  [MBSD]       6.170237
  [Tag]         6241
  [MBSD_included]       1
[Record 40]
  [MBSD]       21.033547
  [Tag]         6401
  [MBSD_included]       1
[Record 41]
  [MBSD]       22.784993
  [Tag]         6561
  [MBSD_included]       1
[Record 42]
  [MBSD]       11.965449
  [Tag]         6721
  [MBSD_included]       1
[Record 43]
  [MBSD]       5.937145
  [Tag]         6881
  [MBSD_included]       1
[Record 44]
  [MBSD]       3.781105
  [Tag]         7041
  [MBSD_included]       1
[Record 45]
  [MBSD]       0.843292
  [Tag]         7201
  [MBSD_included]       1
[Record 46]
  [MBSD]       3.431955
  [Tag]         7361
  [MBSD_included]       1
[Record 47]
  [MBSD]       5.772848
  [Tag]         7521
  [MBSD_included]       1
[Record 48]
  [MBSD]       5.863767
  [Tag]         7681
  [MBSD_included]       0
[Record 49]
  [MBSD]       5.274406
  [Tag]         7841
  [MBSD_included]       0
[Record 50]
  [MBSD]       2.056852
  [Tag]         8001
  [MBSD_included]       0
[Record 51]
  [MBSD]       0.710832
  [Tag]         8161
  [MBSD_included]       1
[Record 52]
  [MBSD]       0.652456
  [Tag]         8321
  [MBSD_included]       1
[Record 53]
  [MBSD]       0.000000
  [Tag]         8481
  [MBSD_included]       1
[Record 54]
  [MBSD]       0.000000
  [Tag]         8641
  [MBSD_included]       1
[Record 55]
  [MBSD]       0.000000
  [Tag]         8801
  [MBSD_included]       1
[Record 56]
  [MBSD]       0.000000
  [Tag]         8961
  [MBSD_included]       1
[Record 57]
  [MBSD]       0.000000
  [Tag]         9121
  [MBSD_included]       1
[Record 58]
  [MBSD]       1.159059
  [Tag]         9281
  [MBSD_included]       1
[Record 59]
  [MBSD]       4.549081
  [Tag]         9441
  [MBSD_included]       1
[Record 60]
  [MBSD]       6.004533
  [Tag]         9601
  [MBSD_included]       1
[Record 61]
  [MBSD]       16.653211
  [Tag]         9761
  [MBSD_included]       1
[Record 62]
  [MBSD]       26.629300
  [Tag]         9921
  [MBSD_included]       1
[Record 63]
  [MBSD]       23.031817
  [Tag]        10081
  [MBSD_included]       1
[Record 64]
  [MBSD]       22.095737
  [Tag]        10241
  [MBSD_included]       1
[Record 65]
  [MBSD]       20.616730
  [Tag]        10401
  [MBSD_included]       1
[Record 66]
  [MBSD]       19.199220
  [Tag]        10561
  [MBSD_included]       1
[Record 67]
  [MBSD]       21.309008
  [Tag]        10721
  [MBSD_included]       1
[Record 68]
  [MBSD]       25.486066
  [Tag]        10881
  [MBSD_included]       1
[Record 69]
  [MBSD]       17.292253
  [Tag]        11041
  [MBSD_included]       1
[Record 70]
  [MBSD]       7.923211
  [Tag]        11201
  [MBSD_included]       0
[Record 71]
  [MBSD]       4.063605
  [Tag]        11361
  [MBSD_included]       0
[Record 72]
  [MBSD]       1.071496
  [Tag]        11521
  [MBSD_included]       0
[Record 73]
  [MBSD]       0.398032
  [Tag]        11681
  [MBSD_included]       0
[Record 74]
  [MBSD]       0.329111
  [Tag]        11841
  [MBSD_included]       0
[Record 75]
  [MBSD]       0.547637
  [Tag]        12001
  [MBSD_included]       0
[Record 76]
  [MBSD]       0.426258
  [Tag]        12161
  [MBSD_included]       0
[Record 77]
  [MBSD]       1.013371
  [Tag]        12321
  [MBSD_included]       0
[Record 78]
  [MBSD]       1.405937
  [Tag]        12481
  [MBSD_included]       0
[Record 79]
  [MBSD]       2.267651
  [Tag]        12641
  [MBSD_included]       0
[Record 80]
  [MBSD]       1.589485
  [Tag]        12801
  [MBSD_included]       0
[Record 81]
  [MBSD]       1.805778
  [Tag]        12961
  [MBSD_included]       0
[Record 0]
  [MBSD]       1.5323697
  [Tag]            1
  [MBSD_included]       0
[Record 1]
  [MBSD]       1.9548637
  [Tag]          161
  [MBSD_included]       0
[Record 2]
  [MBSD]       1.7977037
  [Tag]          321
  [MBSD_included]       0
[Record 3]
  [MBSD]      0.58205801
  [Tag]          481
  [MBSD_included]       0
[Record 4]
  [MBSD]       2.9750350
  [Tag]          641
  [MBSD_included]       1
[Record 5]
  [MBSD]       1.9781948
  [Tag]          801
  [MBSD_included]       1
[Record 6]
  [MBSD]       2.0862339
  [Tag]          961
  [MBSD_included]       1
[Record 7]
  [MBSD]      0.44647551
  [Tag]         1121
  [MBSD_included]       1
[Record 8]
  [MBSD]       3.5242560
  [Tag]         1281
  [MBSD_included]       1
[Record 9]
  [MBSD]       9.7837725
  [Tag]         1441
  [MBSD_included]       1
[Record 10]
  [MBSD]       7.3641872
  [Tag]         1601
  [MBSD_included]       1
[Record 11]
  [MBSD]       6.8171792
  [Tag]         1761
  [MBSD_included]       1
[Record 12]
  [MBSD]       6.1503477
  [Tag]         1921
  [MBSD_included]       0
[Record 13]
  [MBSD]       14.679045
  [Tag]         2081
  [MBSD_included]       1
[Record 14]
  [MBSD]       13.181120
  [Tag]         2241
  [MBSD_included]       0
[Record 15]
  [MBSD]       10.363204
  [Tag]         2401
  [MBSD_included]       1
[Record 16]
  [MBSD]       10.842793
  [Tag]         2561
  [MBSD_included]       1
[Record 17]
  [MBSD]       18.834749
  [Tag]         2721
  [MBSD_included]       1
[Record 18]
  [MBSD]       21.933619
  [Tag]         2881
  [MBSD_included]       1
[Record 19]
  [MBSD]       24.015261
  [Tag]         3041
  [MBSD_included]       1
[Record 20]
  [MBSD]       19.613338
  [Tag]         3201
  [MBSD_included]       1
[Record 21]
  [MBSD]       16.540194
  [Tag]         3361
  [MBSD_included]       1
[Record 22]
  [MBSD]       11.956120
  [Tag]         3521
  [MBSD_included]       1
[Record 23]
  [MBSD]       9.8343611
  [Tag]         3681
  [MBSD_included]       1
[Record 24]
  [MBSD]       7.9360003
  [Tag]         3841
  [MBSD_included]       0
[Record 25]
  [MBSD]       12.256979
  [Tag]         4001
  [MBSD_included]       1
[Record 26]
  [MBSD]       12.913343
  [Tag]         4161
  [MBSD_included]       1
[Record 27]
  [MBSD]       7.0531359
  [Tag]         4321
  [MBSD_included]       0
[Record 28]
  [MBSD]       8.2029867
  [Tag]         4481
  [MBSD_included]       1
[Record 29]
  [MBSD]       8.2272701
  [Tag]         4641
  [MBSD_included]       1
[Record 30]
  [MBSD]       9.2852545
  [Tag]         4801
  [MBSD_included]       1
[Record 31]
  [MBSD]       11.433966
  [Tag]         4961
  [MBSD_included]       1
[Record 32]
  [MBSD]       9.3142214
  [Tag]         5121
  [MBSD_included]       1
[Record 33]
  [MBSD]       8.8889809
  [Tag]         5281
  [MBSD_included]       1
[Record 34]
  [MBSD]       11.504143
  [Tag]         5441
  [MBSD_included]       1
[Record 35]
  [MBSD]       13.340736
  [Tag]         5601
  [MBSD_included]       1
[Record 36]
  [MBSD]       6.0446267
  [Tag]         5761
  [MBSD_included]       1
[Record 37]
  [MBSD]       1.6383861
  [Tag]         5921
  [MBSD_included]       1
[Record 38]
  [MBSD]      0.62643266
  [Tag]         6081
  [MBSD_included]       1
[Record 39]
  [MBSD]       6.1035967
  [Tag]         6241
  [MBSD_included]       1
[Record 40]
  [MBSD]       20.896553
  [Tag]         6401
  [MBSD_included]       1
[Record 41]
  [MBSD]       22.616098
  [Tag]         6561
  [MBSD_included]       1
[Record 42]
  [MBSD]       11.847965
  [Tag]         6721
  [MBSD_included]       1
[Record 43]
  [MBSD]       5.8726153
  [Tag]         6881
  [MBSD_included]       1
[Record 44]
  [MBSD]       3.7513366
  [Tag]         7041
  [MBSD_included]       1
[Record 45]
  [MBSD]      0.79743332
  [Tag]         7201
  [MBSD_included]       1
[Record 46]
  [MBSD]       3.4208064
  [Tag]         7361
  [MBSD_included]       1
[Record 47]
  [MBSD]       5.8018456
  [Tag]         7521
  [MBSD_included]       1
[Record 48]
  [MBSD]       5.8322916
  [Tag]         7681
  [MBSD_included]       0
[Record 49]
  [MBSD]       5.2404442
  [Tag]         7841
  [MBSD_included]       0
[Record 50]
  [MBSD]       2.0663366
  [Tag]         8001
  [MBSD_included]       0
[Record 51]
  [MBSD]      0.73004436
  [Tag]         8161
  [MBSD_included]       1
[Record 52]
  [MBSD]      0.66684961
  [Tag]         8321
  [MBSD_included]       1
[Record 53]
  [MBSD]       0.0000000
  [Tag]         8481
  [MBSD_included]       1
[Record 54]
  [MBSD]       0.0000000
  [Tag]         8641
  [MBSD_included]       1
[Record 55]
  [MBSD]       0.0000000
  [Tag]         8801
  [MBSD_included]       1
[Record 56]
  [MBSD]       0.0000000
  [Tag]         8961
  [MBSD_included]       1
[Record 57]
  [MBSD]       0.0000000
  [Tag]         9121
  [MBSD_included]       1
[Record 58]
  [MBSD]       1.1476036
  [Tag]         9281
  [MBSD_included]       1
[Record 59]
  [MBSD]       4.5224733
  [Tag]         9441
  [MBSD_included]       1
[Record 60]
  [MBSD]       5.9367385
  [Tag]         9601
  [MBSD_included]       1
[Record 61]
  [MBSD]       16.501492
  [Tag]         9761
  [MBSD_included]       1
[Record 62]
  [MBSD]       26.377462
  [Tag]         9921
  [MBSD_included]       1
[Record 63]
  [MBSD]       22.804737
  [Tag]        10081
  [MBSD_included]       1
[Record 64]
  [MBSD]       21.920359
  [Tag]        10241
  [MBSD_included]       1
[Record 65]
  [MBSD]       20.422823
  [Tag]        10401
  [MBSD_included]       1
[Record 66]
  [MBSD]       18.990095
  [Tag]        10561
  [MBSD_included]       1
[Record 67]
  [MBSD]       21.083725
  [Tag]        10721
  [MBSD_included]       1
[Record 68]
  [MBSD]       25.283913
  [Tag]        10881
  [MBSD_included]       1
[Record 69]
  [MBSD]       17.147987
  [Tag]        11041
  [MBSD_included]       1
[Record 70]
  [MBSD]       7.8984466
  [Tag]        11201
  [MBSD_included]       0
[Record 71]
  [MBSD]       4.0402203
  [Tag]        11361
  [MBSD_included]       0
[Record 72]
  [MBSD]       1.0578126
  [Tag]        11521
  [MBSD_included]       0
[Record 73]
  [MBSD]      0.39063111
  [Tag]        11681
  [MBSD_included]       0
[Record 74]
  [MBSD]      0.33510333
  [Tag]        11841
  [MBSD_included]       0
[Record 75]
  [MBSD]      0.55006415
  [Tag]        12001
  [MBSD_included]       0
[Record 76]
  [MBSD]      0.42629448
  [Tag]        12161
  [MBSD_included]       0
[Record 77]
  [MBSD]       1.0226117
  [Tag]        12321
  [MBSD_included]       0
[Record 78]
  [MBSD]       1.4210931
  [Tag]        12481
  [MBSD_included]       0
[Record 79]
  [MBSD]       2.2720127
  [Tag]        12641
  [MBSD_included]       0
[Record 80]
  [MBSD]       1.5849563
  [Tag]        12801
  [MBSD_included]       0
[Record 81]
  [MBSD]       1.7956722
  [Tag]        12961
  [MBSD_included]       0
aArDvArK

## --- Check FEA output (1)

echo '... checking output'

## --- Header (1)

# tagged?

if psps -D out1.fea | grep ' not  *tagged' >/dev/null
then echo "* * * ERROR: file is not tagged; should be tagged"
fi

# generic string values

gv_distortion_type="MBSD"

for i in \
    distortion_type
do
    x=`hditem -i $i out1.fea`
    eval "pat=\$gv_$i"

    case "$x" in
    "$pat") : ;;
    '') echo "* * * ERROR: header item $i is missing" ;;
    *)  echo "* * * ERROR: header item $i is \"$x\"; should be \"$pat\"" ;;
    esac
done

# generic integer values

    gv_nan="0"
    gv_ndrec="82"

    for i in \
	nan	ndrec
    do
	x=`hditem -i $i out1.fea`
	eval "pat=\$gv_$i"

	case "$x" in
	'') echo "* * * ERROR: header item $i is missing" ;;
	*)
	    case `echo "if ($x == $pat) \"OK\"" | bc` in
	    OK) : ;;
	    *)  echo "* * * ERROR: header item $i is $x; should be $pat" ;;
	    esac
	;;
	esac
    done

    x=`hditem -i start out1.fea`
    start_0=1
    start_1=1
    case "$x" in
    '') echo "* * * ERROR: header item start is missing" ;;
    *)
	n=0
	for i in $x
	do
	    n=`expr $n + 1`
	done
	if test $n -ne 2
	then
	    echo "* * * ERROR: header item start has wrong length"
	else
	    n=0
	    for i in $x
	    do
		eval "y=\$start_$n"
		if test $i -ne $y
		then
		    echo "* * * ERROR: header item start[$n] is $i;" \
			 "should be $y"
		fi
		n=`expr $n + 1`
	    done
	fi
	;;
    esac

    # generic floating-point values

    gv_record_freq="50"
    gv_src_sf="8000"
    gv_start_time="0.02"

    for i in \
	record_freq   src_sf        start_time
    do
	x=`hditem -i $i out1.fea`
	eval "pat=\$gv_$i"

	case "$x" in
	'') echo "* * * ERROR: header item $i is missing" ;;
	*)
	    case `echo	"scale=20;" \
			"if (($pat) >= 0) {" \
			"    if (($x) < 0.9999 * ($pat)) \"NOT\";" \
			"    if (($pat) < 0.9999 * ($x)) \"NOT\"};" \
			"if (($pat) < 0) {" \
			"    if (($x) > 0.9999 * ($pat)) \"NOT\";" \
			"    if (($pat) > 0.9999 * ($x)) \"NOT\"};" \
			"\"OK\"" | bc`
	    in
	    OK) : ;;
	    *)  echo "* * * ERROR: header item $i is $x; should be $pat" ;;
	    esac
	;;
	esac
    done

## --- Data (1)

if feaop -f MBSD -f MBSD \
	 -f MBSD_dif -O SUB out1.fea ref1.fea - \
   | feafunc -fMBSD_dif -f- -FABS - dif1.fea
then
    rm -f tmp.fea
    `get_esps_base`/bin/select -o tmp.fea \
	    -q'MBSD_dif/(1+MBSD) > 3.0e-2' dif1.fea 2>/dev/null 1>&2
    n=`hditem -i ndrec tmp.fea`

    if test "$n" -ne 0
    then
	echo "* * * ERROR: MBSD disagrees with ref in $n records"
    fi
else
    echo "* * * ERROR: couldn't form MBSD difference " \
	 "between out1.fea and ref1.fea"
fi

## RUN PROGRAM (2)
